/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/base/common/errorMessage","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],S=0,L=K.length;S<L;S++)e[S]=Z[K[S]];return e};define(Z[88],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=S}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function L(n){const y=[];for(let m in n)S.call(n,m)&&y.push(n[m]);return y}e.values=L;function R(n,y){for(let m in n)if(S.call(n,m)&&y({key:m,value:n[m]},function(){delete n[m]})===!1)return}e.forEach=R;function k(n,y){const m=Object.create(null);for(const v of n){const h=y(v);let I=m[h];I||(I=m[h]=[]),I.push(v)}return m}e.groupBy=k;function A(n){const y=Object.create(null);return n&&n.forEach((m,v)=>{y[v]=m}),y}e.fromMap=A;function P(n,y){const m=[],v=[];for(let h of n)y.has(h)||m.push(h);for(let h of y)n.has(h)||v.push(h);return{removed:m,added:v}}e.diffSets=P;function p(n,y){const m=[],v=[];for(let[h,I]of n)y.has(h)||m.push(I);for(let[h,I]of y)n.has(h)||v.push(I);return{removed:m,added:v}}e.diffMaps=p;class w{constructor(){this.map=new Map}add(y,m){let v=this.map.get(y);v||(v=new Set,this.map.set(y,v)),v.add(m)}delete(y,m){const v=this.map.get(y);!v||(v.delete(m),v.size===0&&this.map.delete(y))}forEach(y,m){const v=this.map.get(y);!v||v.forEach(m)}}e.SetMap=w}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(A){return(P,p,w)=>{let n=null,y=null;if(typeof w.value=="function"?(n="value",y=w.value):typeof w.get=="function"&&(n="get",y=w.get),!y)throw new Error("not supported");w[n]=A(y,p)}}e.createDecorator=S;function L(A,P,p){let w=null,n=null;if(typeof p.value=="function"?(w="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(w="get",n=p.get),!n)throw new Error("not supported");const y=`$memoize$${P}`;p[w]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,m)}),this[y]}}e.memoize=L;function R(A,P,p){return S((w,n)=>{const y=`$debounce$${n}`,m=`$debounce$result$${n}`;return function(...v){this[m]||(this[m]=p?p():void 0),clearTimeout(this[y]),P&&(this[m]=P(this[m],...v),v=[this[m]]),this[y]=setTimeout(()=>{w.apply(this,v),this[m]=p?p():void 0},A)}})}e.debounce=R;function k(A,P,p){return S((w,n)=>{const y=`$throttle$timer$${n}`,m=`$throttle$result$${n}`,v=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...I){if(this[m]||(this[m]=p?p():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...I)),this[h])return;const D=this[v]+A;D<=Date.now()?(this[v]=Date.now(),w.apply(this,[this[m]]),this[m]=p?p():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),w.apply(this,[this[m]]),this[m]=p?p():void 0},D-Date.now()))}})}e.throttle=k}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function L(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=L;function R(o){p(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=R;function k(o){p(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=k;function A(o){if(o instanceof Error){let{name:t,message:r}=o;const i=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:i}}return o}e.transformErrorForSerialization=A;const P="Canceled";function p(o){return o instanceof Error&&o.name===P&&o.message===P}e.isPromiseCanceledError=p;class w extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=w;function n(){const o=new Error(P);return o.name=o.message,o}e.canceled=n;function y(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=y;function m(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=m;function v(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function I(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=I;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function f(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function a(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(Z[23],ee([0,1,11]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(z,V=0){return z[z.length-(1+V)]}e.tail=L;function R(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=R;function k(z,V,H=(X,Q)=>X===Q){if(z===V)return!0;if(!z||!V||z.length!==V.length)return!1;for(let X=0,Q=z.length;X<Q;X++)if(!H(z[X],V[X]))return!1;return!0}e.equals=k;function A(z,V,H){let X=0,Q=z.length-1;for(;X<=Q;){const ie=(X+Q)/2|0,ne=H(z[ie],V);if(ne<0)X=ie+1;else if(ne>0)Q=ie-1;else return ie}return-(X+1)}e.binarySearch=A;function P(z,V){let H=0,X=z.length;if(X===0)return 0;for(;H<X;){const Q=Math.floor((H+X)/2);V(z[Q])?X=Q:H=Q+1}return H}e.findFirstInSorted=P;function p(z,V,H){if(z=z|0,z>=V.length)throw new TypeError("invalid index");let X=V[Math.floor(V.length*Math.random())],Q=[],ie=[],ne=[];for(let le of V){const de=H(le,X);de<0?Q.push(le):de>0?ie.push(le):ne.push(le)}return z<Q.length?p(z,Q,H):z<Q.length+ne.length?ne[0]:p(z-(Q.length+ne.length),ie,H)}e.quickSelect=p;function w(z,V){const H=[];let X;for(const Q of z.slice(0).sort(V))!X||V(X[0],Q)!==0?(X=[Q],H.push(X)):X.push(Q);return H}e.groupBy=w;function n(z,V,H){const X=[];function Q(le,de,ye){if(de===0&&ye.length===0)return;const pe=X[X.length-1];pe&&pe.start+pe.deleteCount===le?(pe.deleteCount+=de,pe.toInsert.push(...ye)):X.push({start:le,deleteCount:de,toInsert:ye})}let ie=0,ne=0;for(;;){if(ie===z.length){Q(ie,0,V.slice(ne));break}if(ne===V.length){Q(ie,z.length-ie,[]);break}const le=z[ie],de=V[ne],ye=H(le,de);ye===0?(ie+=1,ne+=1):ye<0?(Q(ie,1,[]),ie+=1):ye>0&&(Q(ie,0,[de]),ne+=1)}return X}e.sortedDiff=n;function y(z,V,H){const X=n(z,V,H),Q=[],ie=[];for(const ne of X)Q.push(...z.slice(ne.start,ne.start+ne.deleteCount)),ie.push(...ne.toInsert);return{removed:Q,added:ie}}e.delta=y;function m(z,V,H){if(H===0)return[];const X=z.slice(0,H).sort(V);return h(z,V,X,H,z.length),X}e.top=m;function v(z,V,H,X,Q){return H===0?Promise.resolve([]):new Promise((ie,ne)=>{(async()=>{const le=z.length,de=z.slice(0,H).sort(V);for(let ye=H,pe=Math.min(H+X,le);ye<le;ye=pe,pe=Math.min(pe+X,le)){if(ye>H&&await new Promise(Pe=>setTimeout(Pe)),Q&&Q.isCancellationRequested)throw(0,S.canceled)();h(z,V,de,ye,pe)}return de})().then(ie,ne)})}e.topAsync=v;function h(z,V,H,X,Q){for(const ie=H.length;X<Q;X++){const ne=z[X];if(V(ne,H[ie-1])<0){H.pop();const le=P(H,de=>V(ne,de)<0);H.splice(le,0,ne)}}}function I(z){return z.filter(V=>!!V)}e.coalesce=I;function D(z){let V=0;for(let H=0;H<z.length;H++)z[H]&&(z[V]=z[H],V+=1);z.length=V}e.coalesceInPlace=D;function b(z,V,H){z.splice(H,0,z.splice(V,1)[0])}e.move=b;function C(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=C;function f(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=f;function a(z,V){if(!V)return z.filter((X,Q)=>z.indexOf(X)===Q);const H=Object.create(null);return z.filter(X=>{const Q=V(X);return H[Q]?!1:(H[Q]=!0,!0)})}e.distinct=a;function o(z){const V=new Set;return z.filter(H=>V.has(H)?!1:(V.add(H),!0))}e.distinctES6=o;function t(z){const V=Object.create(null);return H=>{const X=z(H);return V[X]?!1:(V[X]=!0,!0)}}e.uniqueFilter=t;function r(z,V){for(let H=z.length-1;H>=0;H--){const X=z[H];if(V(X))return H}return-1}e.lastIndex=r;function i(z,V){return z.length>0?z[0]:V}e.firstOrDefault=i;function s(z,V,H=(X,Q)=>X===Q){let X=0;for(let Q=0,ie=Math.min(z.length,V.length);Q<ie&&H(z[Q],V[Q]);Q++)X++;return X}e.commonPrefixLength=s;function u(z){return[].concat(...z)}e.flatten=u;function c(z,V){let H=typeof V=="number"?z:0;typeof V=="number"?H=z:(H=0,V=z);const X=[];if(H<=V)for(let Q=H;Q<V;Q++)X.push(Q);else for(let Q=H;Q>V;Q--)X.push(Q);return X}e.range=c;function l(z,V,H){return z.reduce((X,Q)=>(X[V(Q)]=H?H(Q):Q,X),Object.create(null))}e.index=l;function d(z,V){return z.push(V),()=>E(z,V)}e.insert=d;function E(z,V){const H=z.indexOf(V);if(H>-1)return z.splice(H,1),V}e.remove=E;function g(z,V,H){const X=z.slice(0,V),Q=z.slice(V);return X.concat(H,Q)}e.arrayInsert=g;function T(z,V){let H;if(typeof V=="number"){let X=V;H=()=>{const Q=Math.sin(X++)*179426549;return Q-Math.floor(Q)}}else H=Math.random;for(let X=z.length-1;X>0;X-=1){const Q=Math.floor(H()*(X+1)),ie=z[X];z[X]=z[Q],z[Q]=ie}}e.shuffle=T;function O(z,V){const H=z.indexOf(V);H>-1&&(z.splice(H,1),z.unshift(V))}e.pushToStart=O;function $(z,V){const H=z.indexOf(V);H>-1&&(z.splice(H,1),z.push(V))}e.pushToEnd=$;function x(z,V){return Array.isArray(z)?z.map(V):V(z)}e.mapArrayOrNot=x;function G(z){return Array.isArray(z)?z:[z]}e.asArray=G;function B(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=B;function U(z,V){for(const H of z){const X=V(H);if(X!==void 0)return X}}e.mapFind=U;function M(z,V,H){const X=j(z,V),Q=z.length,ie=H.length;z.length=Q+ie;for(let ne=Q-1;ne>=X;ne--)z[ne+ie]=z[ne];for(let ne=0;ne<ie;ne++)z[ne+X]=H[ne]}e.insertInto=M;function F(z,V,H,X){const Q=j(z,V),ie=z.splice(Q,H);return M(z,Q,X),ie}e.splice=F;function j(z,V){return V<0?Math.max(V+z.length,0):Math.min(V,z.length)}function _(z,V){let H=Number.MAX_SAFE_INTEGER,X=0;return z.forEach((Q,ie)=>{const ne=V(Q);ne<H&&(H=ne,X=ie)}),X}e.minIndex=_;function N(z,V){let H=Number.MIN_SAFE_INTEGER,X=0;return z.forEach((Q,ie)=>{const ne=V(Q);ne>H&&(H=ne,X=ie)}),X}e.maxIndex=N;class W{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let H=this.firstIdx;for(;H<this.items.length&&V(this.items[H]);)H++;const X=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,X}takeFromEndWhile(V){let H=this.lastIdx;for(;H>=0&&V(this.items[H]);)H--;const X=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,X}}e.ArrayQueue=W}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(L){const R=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(R,arguments)),A}}e.once=S}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(L){function R(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}L.is=R;const k=Object.freeze([]);function A(){return k}L.empty=A;function*P(o){yield o}L.single=P;function p(o){return o||k}L.from=p;function w(o){return!o||o[Symbol.iterator]().next().done===!0}L.isEmpty=w;function n(o){return o[Symbol.iterator]().next().value}L.first=n;function y(o,t){for(const r of o)if(t(r))return!0;return!1}L.some=y;function m(o,t){for(const r of o)if(t(r))return r}L.find=m;function*v(o,t){for(const r of o)t(r)&&(yield r)}L.filter=v;function*h(o,t){let r=0;for(const i of o)yield t(i,r++)}L.map=h;function*I(...o){for(const t of o)for(const r of t)yield r}L.concat=I;function*D(o){for(const t of o)for(const r of t)yield r}L.concatNested=D;function b(o,t,r){let i=r;for(const s of o)i=t(i,s);return i}L.reduce=b;function*C(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}L.slice=C;function f(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const i=o[Symbol.iterator]();for(let s=0;s<t;s++){const u=i.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=f;function a(o,t,r=(i,s)=>i===s){const i=o[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=i.next(),c=s.next();if(u.done!==c.done)return!1;if(u.done)return!0;if(!r(u.value,c.value))return!1}}L.equals=a})(S=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,s=t.length,u="",c=0,l=16,d=0;function E(B){let U=0,M=0;for(;U<B;){const F=t.charCodeAt(i);if(F>=48&&F<=57)M=M*16+F-48;else if(F>=65&&F<=70)M=M*16+F-65+10;else if(F>=97&&F<=102)M=M*16+F-97+10;else break;i++,U++}return U<B&&(M=-1),M}function g(B){i=B,u="",c=0,l=16,d=0}function T(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return d=3,t.substring(B,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;U=i}else d=3;return t.substring(B,U)}function O(){let B="",U=i;for(;;){if(i>=s){B+=t.substring(U,i),d=2;break}const M=t.charCodeAt(i);if(M===34){B+=t.substring(U,i),i++;break}if(M===92){if(B+=t.substring(U,i),i++,i>=s){d=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const j=E(4);j>=0?B+=String.fromCharCode(j):d=4;break;default:d=5}U=i;continue}if(M>=0&&M<=31)if(p(M)){B+=t.substring(U,i),d=2;break}else d=6;i++}return B}function $(){if(u="",d=0,c=i,i>=s)return c=s,l=17;let B=t.charCodeAt(i);if(P(B)){do i++,u+=String.fromCharCode(B),B=t.charCodeAt(i);while(P(B));return l=15}if(p(B))return i++,u+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(B){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=O(),l=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!p(t.charCodeAt(i));)i++;return u=t.substring(U,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const M=s-1;let F=!1;for(;i<M;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,F=!0;break}i++}return F||(i++,d=1),u=t.substring(U,i),l=13}return u+=String.fromCharCode(B),i++,l=16;case 45:if(u+=String.fromCharCode(B),i++,i===s||!w(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=T(),l=11;default:for(;i<s&&x(B);)i++,B=t.charCodeAt(i);if(c!==i){switch(u=t.substring(c,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(B),i++,l=16}}function x(B){if(P(B)||p(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let B;do B=$();while(B>=12&&B<=15);return B}return{setPosition:g,getPosition:()=>i,scan:r?G:$,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>d}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function y(t,r){const i=[],s=new Object;let u;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(E,g,T,O){c.value=E,c.offset=g,c.length=T,c.type=O,c.colonOffset=void 0,u=c}try{f(t,{onObjectBegin:(E,g)=>{if(r<=E)throw s;u=void 0,l=r>E,i.push("")},onObjectProperty:(E,g,T)=>{if(r<g||(d(E,g,T,"property"),i[i.length-1]=E,r<=g+T))throw s},onObjectEnd:(E,g)=>{if(r<=E)throw s;u=void 0,i.pop()},onArrayBegin:(E,g)=>{if(r<=E)throw s;u=void 0,i.push(0)},onArrayEnd:(E,g)=>{if(r<=E)throw s;u=void 0,i.pop()},onLiteralValue:(E,g,T)=>{if(r<g||(d(E,g,T,o(E)),r<=g+T))throw s},onSeparator:(E,g,T)=>{if(r<=g)throw s;if(E===":"&&u&&u.type==="property")u.colonOffset=g,l=!1,u=void 0;else if(E===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(E){if(E!==s)throw E}return{path:i,previousNode:u,isAtPropertyKey:l,matches:E=>{let g=0;for(let T=0;g<E.length&&T<i.length;T++)if(E[g]===i[T]||E[g]==="*")g++;else if(E[g]!=="**")return!1;return g===E.length}}}e.getLocation=y;function m(t,r=[],i=k.DEFAULT){let s=null,u=[];const c=[];function l(E){Array.isArray(u)?u.push(E):s!==null&&(u[s]=E)}return f(t,{onObjectBegin:()=>{const E={};l(E),c.push(u),u=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{const E=[];l(E),c.push(u),u=E,s=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:l,onError:(E,g,T)=>{r.push({error:E,offset:g,length:T})}},i),u[0]}e.parse=m;function v(t,r=[],i=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function c(E){return s.children.push(E),E}f(t,{onObjectBegin:E=>{s=c({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,g,T)=>{s=c({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:g,length:T,parent:s})},onObjectEnd:(E,g)=>{s.length=E+g-s.offset,s=s.parent,u(E+g)},onArrayBegin:(E,g)=>{s=c({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,g)=>{s.length=E+g-s.offset,s=s.parent,u(E+g)},onLiteralValue:(E,g,T)=>{c({type:o(E),offset:g,length:T,parent:s,value:E}),u(g+T)},onSeparator:(E,g,T)=>{s.type==="property"&&(E===":"?s.colonOffset=g:E===","&&u(g))},onError:(E,g,T)=>{r.push({error:E,offset:g,length:T})}},i);const d=s.children[0];return d&&delete d.parent,d}e.parseTree=v;function h(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===s){i=c.children[1],u=!0;break}if(!u)return}else{const u=s;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=h;function I(t){if(!t.parent||!t.parent.children)return[];const r=I(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=I;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=D(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function C(t,r,i=!1){if(b(t,r,i)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=r;u++){const c=C(s[u],r,i);if(c)return c}return t}}e.findNodeAtOffset=C;function f(t,r,i=k.DEFAULT){const s=A(t,!1);function u(H){return H?()=>H(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(H){return H?X=>H(X,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),d=c(r.onObjectProperty),E=u(r.onObjectEnd),g=u(r.onArrayBegin),T=u(r.onArrayEnd),O=c(r.onLiteralValue),$=c(r.onSeparator),x=u(r.onComment),G=c(r.onError),B=i&&i.disallowComments,U=i&&i.allowTrailingComma;function M(){for(;;){const H=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:B||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(H){case 12:case 13:B?F(10):x();break;case 16:F(1);break;case 15:case 14:break;default:return H}}}function F(H,X=[],Q=[]){if(G(H),X.length+Q.length>0){let ie=s.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){M();break}else if(Q.indexOf(ie)!==-1)break;ie=M()}}}function j(H){const X=s.getTokenValue();return H?O(X):d(X),M(),!0}function _(){switch(s.getToken()){case 11:let H=0;try{H=JSON.parse(s.getTokenValue()),typeof H!="number"&&(F(2),H=0)}catch(X){F(2)}O(H);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function N(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(j(!1),s.getToken()===6?($(":"),M(),V()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function W(){l(),M();let H=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(H||F(4,[],[]),$(","),M(),s.getToken()===2&&U)break}else H&&F(6,[],[]);N()||F(4,[],[2,5]),H=!0}return E(),s.getToken()!==2?F(7,[2],[]):M(),!0}function z(){g(),M();let H=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(H||F(4,[],[]),$(","),M(),s.getToken()===4&&U)break}else H&&F(6,[],[]);V()||F(4,[],[4,5]),H=!0}return T(),s.getToken()!==4?F(8,[4],[]):M(),!0}function V(){switch(s.getToken()){case 3:return z();case 1:return W();case 10:return j(!0);default:return _()}}return M(),s.getToken()===17?i.allowEmptyContent?!0:(F(4,[],[]),!1):V()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=f;function a(t,r){let i=A(t),s=[],u,c=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:c!==l&&s.push(t.substring(c,l)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(u!==17);return s.join("")}e.stripComments=a;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(Z[47],ee([0,1,33]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(p,w,n){let y,m,v,h,I;if(w){for(h=w.offset,I=h+w.length,v=h;v>0&&!P(p,v-1);)v--;let c=I;for(;c<p.length&&!P(p,c);)c++;m=p.substring(v,c),y=k(m,n)}else m=p,y=0,v=0,h=0,I=p.length;const D=A(n,p);let b=!1,C=0,f;n.insertSpaces?f=R(" ",n.tabSize||4):f="	";const a=(0,S.createScanner)(m,!1);let o=!1;function t(){return D+R(f,y+C)}function r(){let c=a.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=a.scan();return o=c===16||a.getTokenError()!==0,c}const i=[];function s(c,l,d){!o&&l<I&&d>h&&p.substring(l,d)!==c&&i.push({offset:l,length:d-l,content:c})}let u=r();if(u!==17){const c=a.getTokenOffset()+v,l=R(f,y);s(l,v,c)}for(;u!==17;){let c=a.getTokenOffset()+a.getTokenLength()+v,l=r(),d="";for(;!b&&(l===12||l===13);){const g=a.getTokenOffset()+v;s(" ",c,g),c=a.getTokenOffset()+a.getTokenLength()+v,d=l===12?t():"",l=r()}if(l===2)u!==1&&(C--,d=t());else if(l===4)u!==3&&(C--,d=t());else{switch(u){case 3:case 1:C++,d=t();break;case 5:case 12:d=t();break;case 13:b?d=t():d=" ";break;case 6:d=" ";break;case 10:if(l===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?d=" ":l!==5&&l!==17&&(o=!0);break;case 16:o=!0;break}b&&(l===12||l===13)&&(d=t())}const E=a.getTokenOffset()+v;s(d,c,E),u=l}return i}e.format=L;function R(p,w){let n="";for(let y=0;y<w;y++)n+=p;return n}function k(p,w){let n=0,y=0;const m=w.tabSize||4;for(;n<p.length;){const v=p.charAt(n);if(v===" ")y++;else if(v==="	")y+=m;else break;n++}return Math.floor(y/m)}function A(p,w){for(let n=0;n<w.length;n++){const y=w.charAt(n);if(y==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=A;function P(p,w){return`\r
`.indexOf(p.charAt(w))!==-1}e.isEOL=P}),define(Z[41],ee([0,1,33,47]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(w,n,y){return k(w,n,void 0,y)}e.removeProperty=R;function k(w,n,y,m,v){const h=n.slice(),I=[],D=(0,S.parseTree)(w,I);let b,C;for(;h.length>0&&(C=h.pop(),b=(0,S.findNodeAtLocation)(D,h),b===void 0&&y!==void 0);)typeof C=="string"?y={[C]:y}:y=[y];if(b)if(b.type==="object"&&typeof C=="string"&&Array.isArray(b.children)){const f=(0,S.findNodeAtLocation)(b,[C]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const a=b.children.indexOf(f.parent);let o,t=f.parent.offset+f.parent.length;if(a>0){const r=b.children[a-1];o=r.offset+r.length}else o=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(w,{offset:o,length:t-o,content:""},m)}else return A(w,{offset:f.offset,length:f.length,content:JSON.stringify(y)},m);else{if(y===void 0)return[];const a=`${JSON.stringify(C)}: ${JSON.stringify(y)}`,o=v?v(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(o>0){const r=b.children[o-1];t={offset:r.offset+r.length,length:0,content:","+a}}else b.children.length===0?t={offset:b.offset+1,length:0,content:a}:t={offset:b.offset+1,length:0,content:a+","};return A(w,t,m)}}else if(b.type==="array"&&typeof C=="number"&&Array.isArray(b.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let a;if(b.children.length===0||C===0)a={offset:b.offset+1,length:0,content:b.children.length===0?f:f+","};else{const o=C===-1||C>b.children.length?b.children.length:C,t=b.children[o-1];a={offset:t.offset+t.length,length:0,content:","+f}}return A(w,a,m)}else{const f=C,a=b.children[f];let o;if(b.children.length===1)o={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===f){const t=b.children[f-1],r=t.offset+t.length,i=b.offset+b.length;o={offset:r,length:i-2-r,content:""}}else o={offset:a.offset,length:b.children[f+1].offset-a.offset,content:""};return A(w,o,m)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${b.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(y)},m)}}e.setProperty=k;function A(w,n,y){let m=P(w,n),v=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;v>0&&!(0,L.isEOL)(m,v-1);)v--;for(;h<m.length&&!(0,L.isEOL)(m,h);)h++}const I=(0,L.format)(m,{offset:v,length:h-v},y);for(let b=I.length-1;b>=0;b--){const C=I[b];m=P(m,C),v=Math.min(v,C.offset),h=Math.max(h,C.offset+C.length),h+=C.content.length-C.length}const D=w.length-(m.length-h)-v;return[{offset:v,length:D,content:m.substring(v,h)}]}e.withFormatting=A;function P(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=P;function p(w,n){let y=n.slice(0).sort((v,h)=>{const I=v.offset-h.offset;return I===0?v.length-h.length:I}),m=w.length;for(let v=y.length-1;v>=0;v--){let h=y[v];if(h.offset+h.length<=m)w=P(w,h);else throw new Error("Overlapping edit");m=h.offset}return w}e.applyEdits=p}),define(Z[2],ee([0,1,65,55]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function A(i){k=i}if(e.setDisposableTracker=A,R){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==C.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==C.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function P(i){return k?.trackDisposable(i),i}function p(i){k?.markAsDisposed(i)}function w(i,s){k?.setParent(i,s)}function n(i,s){if(!!k)for(const u of i)k.setParent(u,s)}function y(i){return k?.markAsSingleton(i),i}e.markAsSingleton=y;class m extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=m;function v(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=v;function h(i){if(L.Iterable.is(i)){let s=[];for(const u of i)if(u)try{u.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new m(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=h;function I(...i){const s=D(()=>h(i));return n(i,s),s}e.combinedDisposable=I;function D(i){const s=P({dispose:(0,S.once)(()=>{p(s),i()})});return s}e.toDisposable=D;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new b,P(this),w(this._store,this)}dispose(){p(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=f;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class o{constructor(){this.references=new Map}acquire(s,...u){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,c));const{object:l}=c,d=(0,S.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:l,dispose:d}}}e.ReferenceCollection=o;class t{constructor(s){this.referenceCollection=s}async acquire(s,...u){const c=this.referenceCollection.acquire(s,...u);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(l){throw c.dispose(),l}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[89],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(k){this.element=k,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class L{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let k=this._first;for(;k!==S.Undefined;){const A=k.next;k.prev=S.Undefined,k.next=S.Undefined,k=A}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const P=new S(k);if(this._first===S.Undefined)this._first=P,this._last=P;else if(A){const w=this._last;this._last=P,P.prev=w,w.next=P}else{const w=this._first;this._first=P,P.next=w,w.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==S.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==S.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==S.Undefined&&k.next!==S.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===S.Undefined&&k.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):k.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):k.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==S.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function K(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function A(p){k.push(p,Date.now())}function P(){const p=[];for(let w=0;w<k.length;w+=2)p.push({name:k[w],startTime:k[w+1]});return p}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(R+A.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=S(L))}(),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const S="en";let L=!1,R=!1,k=!1,A=!1,P=!1,p=!1,w=!1,n,y=S,m,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const I=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=I&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!I)v=navigator.userAgent,L=v.indexOf("Windows")>=0,R=v.indexOf("Macintosh")>=0,w=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,p=!0,n=navigator.language,y=n;else if(typeof h=="object"){L=h.platform==="win32",R=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=S,y=S;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),u=s.availableLanguages["*"];n=s.locale,y=u||S,m=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let C=0;R?C=1:L?C=3:k&&(C=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=A,e.isNative=P,e.isWeb=p,e.isIOS=w,e.platform=C,e.userAgent=v,e.language=y;var f;(function(i){function s(){return e.language}i.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function c(){return e.language==="en"}i.isDefault=c})(f=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let d=0,E=u.length;d<E;d++){const g=u[d];if(g.id===l.data.vscodeSetImmediateId){u.splice(d,1),g.callback();return}}});let c=0;return l=>{const d=++c;u.push({id:d,callback:l}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const s=Promise.resolve();return u=>s.then(u)}();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||w?2:L?1:3;let o=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,o=new Uint16Array(i.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=r}),define(Z[34],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const R=S.globals.vscode.process;L={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(k){return(0,S.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(R){return(0,S.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],ee([0,1,34]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,k=90,A=122,P=46,p=47,w=92,n=58,y=63;class m extends Error{constructor(a,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const i=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${i} ${r} of type ${o}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function v(f,a){if(typeof f!="string")throw new m(a,"string",f)}function h(f){return f===p||f===w}function I(f){return f===p}function D(f){return f>=L&&f<=k||f>=R&&f<=A}function b(f,a,o,t){let r="",i=0,s=-1,u=0,c=0;for(let l=0;l<=f.length;++l){if(l<f.length)c=f.charCodeAt(l);else{if(t(c))break;c=p}if(t(c)){if(!(s===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const d=r.lastIndexOf(o);d===-1?(r="",i=0):(r=r.slice(0,d),i=r.length-1-r.lastIndexOf(o)),s=l,u=0;continue}else if(r.length!==0){r="",i=0,s=l,u=0;continue}}a&&(r+=r.length>0?`${o}..`:"..",i=2)}else r.length>0?r+=`${o}${f.slice(s+1,l)}`:r=f.slice(s+1,l),i=l-s-1;s=l,u=0}else c===P&&u!==-1?++u:u=-1}return r}function C(f,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const o=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${t}`:`${o}${f}${t}`:t}e.win32={resolve(...f){let a="",o="",t=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],v(i,"path"),i.length===0)continue}else a.length===0?i=S.cwd():(i=S.env[`=${a}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${a}\\`));const s=i.length;let u=0,c="",l=!1;const d=i.charCodeAt(0);if(s===1)h(d)&&(u=1,l=!0);else if(h(d))if(l=!0,h(i.charCodeAt(1))){let E=2,g=E;for(;E<s&&!h(i.charCodeAt(E));)E++;if(E<s&&E!==g){const T=i.slice(g,E);for(g=E;E<s&&h(i.charCodeAt(E));)E++;if(E<s&&E!==g){for(g=E;E<s&&!h(i.charCodeAt(E));)E++;(E===s||E!==g)&&(c=`\\\\${T}\\${i.slice(g,E)}`,u=E)}}}else u=1;else D(d)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),u=2,s>2&&h(i.charCodeAt(2))&&(l=!0,u=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(t){if(a.length>0)break}else if(o=`${i.slice(u)}\\${o}`,t=l,l&&a.length>0)break}return o=b(o,!t,"\\",h),t?`${a}\\${o}`:`${a}${o}`||"."},normalize(f){v(f,"path");const a=f.length;if(a===0)return".";let o=0,t,r=!1;const i=f.charCodeAt(0);if(a===1)return I(i)?"\\":f;if(h(i))if(r=!0,h(f.charCodeAt(1))){let u=2,c=u;for(;u<a&&!h(f.charCodeAt(u));)u++;if(u<a&&u!==c){const l=f.slice(c,u);for(c=u;u<a&&h(f.charCodeAt(u));)u++;if(u<a&&u!==c){for(c=u;u<a&&!h(f.charCodeAt(u));)u++;if(u===a)return`\\\\${l}\\${f.slice(c)}\\`;u!==c&&(t=`\\\\${l}\\${f.slice(c,u)}`,o=u)}}}else o=1;else D(i)&&f.charCodeAt(1)===n&&(t=f.slice(0,2),o=2,a>2&&h(f.charCodeAt(2))&&(r=!0,o=3));let s=o<a?b(f.slice(o),!r,"\\",h):"";return s.length===0&&!r&&(s="."),s.length>0&&h(f.charCodeAt(a-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(f){v(f,"path");const a=f.length;if(a===0)return!1;const o=f.charCodeAt(0);return h(o)||a>2&&D(o)&&f.charCodeAt(1)===n&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,o;for(let i=0;i<f.length;++i){const s=f[i];v(s,"path"),s.length>0&&(a===void 0?a=o=s:a+=`\\${s}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&h(o.charCodeAt(0))){++r;const i=o.length;i>1&&h(o.charCodeAt(1))&&(++r,i>2&&(h(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&h(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(f,a){if(v(f,"from"),v(a,"to"),f===a)return"";const o=e.win32.resolve(f),t=e.win32.resolve(a);if(o===t||(f=o.toLowerCase(),a=t.toLowerCase(),f===a))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===w;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===w;)i--;const s=i-r;let u=0;for(;u<a.length&&a.charCodeAt(u)===w;)u++;let c=a.length;for(;c-1>u&&a.charCodeAt(c-1)===w;)c--;const l=c-u,d=s<l?s:l;let E=-1,g=0;for(;g<d;g++){const O=f.charCodeAt(r+g);if(O!==a.charCodeAt(u+g))break;O===w&&(E=g)}if(g!==d){if(E===-1)return t}else{if(l>d){if(a.charCodeAt(u+g)===w)return t.slice(u+g+1);if(g===2)return t.slice(u+g)}s>d&&(f.charCodeAt(r+g)===w?E=g:g===2&&(E=3)),E===-1&&(E=0)}let T="";for(g=r+E+1;g<=i;++g)(g===i||f.charCodeAt(g)===w)&&(T+=T.length===0?"..":"\\..");return u+=E,T.length>0?`${T}${t.slice(u,c)}`:(t.charCodeAt(u)===w&&++u,t.slice(u,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===w){if(a.charCodeAt(1)===w){const o=a.charCodeAt(2);if(o!==y&&o!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===w)return`\\\\?\\${a}`;return f},dirname(f){v(f,"path");const a=f.length;if(a===0)return".";let o=-1,t=0;const r=f.charCodeAt(0);if(a===1)return h(r)?f:".";if(h(r)){if(o=t=1,h(f.charCodeAt(1))){let u=2,c=u;for(;u<a&&!h(f.charCodeAt(u));)u++;if(u<a&&u!==c){for(c=u;u<a&&h(f.charCodeAt(u));)u++;if(u<a&&u!==c){for(c=u;u<a&&!h(f.charCodeAt(u));)u++;if(u===a)return f;u!==c&&(o=t=u+1)}}}}else D(r)&&f.charCodeAt(1)===n&&(o=a>2&&h(f.charCodeAt(2))?3:2,t=o);let i=-1,s=!0;for(let u=a-1;u>=t;--u)if(h(f.charCodeAt(u))){if(!s){i=u;break}}else s=!1;if(i===-1){if(o===-1)return".";i=o}return f.slice(0,i)},basename(f,a){a!==void 0&&v(a,"ext"),v(f,"path");let o=0,t=-1,r=!0,i;if(f.length>=2&&D(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(o=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,u=-1;for(i=f.length-1;i>=o;--i){const c=f.charCodeAt(i);if(h(c)){if(!r){o=i+1;break}}else u===-1&&(r=!1,u=i+1),s>=0&&(c===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=u))}return o===t?t=u:t===-1&&(t=f.length),f.slice(o,t)}for(i=f.length-1;i>=o;--i)if(h(f.charCodeAt(i))){if(!r){o=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(o,t)},extname(f){v(f,"path");let a=0,o=-1,t=0,r=-1,i=!0,s=0;f.length>=2&&f.charCodeAt(1)===n&&D(f.charCodeAt(0))&&(a=t=2);for(let u=f.length-1;u>=a;--u){const c=f.charCodeAt(u);if(h(c)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),c===P?o===-1?o=u:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||r===-1||s===0||s===1&&o===r-1&&o===t+1?"":f.slice(o,r)},format:C.bind(null,"\\"),parse(f){v(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const o=f.length;let t=0,r=f.charCodeAt(0);if(o===1)return h(r)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(h(r)){if(t=1,h(f.charCodeAt(1))){let E=2,g=E;for(;E<o&&!h(f.charCodeAt(E));)E++;if(E<o&&E!==g){for(g=E;E<o&&h(f.charCodeAt(E));)E++;if(E<o&&E!==g){for(g=E;E<o&&!h(f.charCodeAt(E));)E++;E===o?t=E:E!==g&&(t=E+1)}}}}else if(D(r)&&f.charCodeAt(1)===n){if(o<=2)return a.root=a.dir=f,a;if(t=2,h(f.charCodeAt(2))){if(o===3)return a.root=a.dir=f,a;t=3}}t>0&&(a.root=f.slice(0,t));let i=-1,s=t,u=-1,c=!0,l=f.length-1,d=0;for(;l>=t;--l){if(r=f.charCodeAt(l),h(r)){if(!c){s=l+1;break}continue}u===-1&&(c=!1,u=l+1),r===P?i===-1?i=l:d!==1&&(d=1):i!==-1&&(d=-1)}return u!==-1&&(i===-1||d===0||d===1&&i===u-1&&i===s+1?a.base=a.name=f.slice(s,u):(a.name=f.slice(s,i),a.base=f.slice(s,u),a.ext=f.slice(i,u))),s>0&&s!==t?a.dir=f.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",o=!1;for(let t=f.length-1;t>=-1&&!o;t--){const r=t>=0?f[t]:S.cwd();v(r,"path"),r.length!==0&&(a=`${r}/${a}`,o=r.charCodeAt(0)===p)}return a=b(a,!o,"/",I),o?`/${a}`:a.length>0?a:"."},normalize(f){if(v(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===p,o=f.charCodeAt(f.length-1)===p;return f=b(f,!a,"/",I),f.length===0?a?"/":o?"./":".":(o&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return v(f,"path"),f.length>0&&f.charCodeAt(0)===p},join(...f){if(f.length===0)return".";let a;for(let o=0;o<f.length;++o){const t=f[o];v(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(v(f,"from"),v(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const o=1,t=f.length,r=t-o,i=1,s=a.length-i,u=r<s?r:s;let c=-1,l=0;for(;l<u;l++){const E=f.charCodeAt(o+l);if(E!==a.charCodeAt(i+l))break;E===p&&(c=l)}if(l===u)if(s>u){if(a.charCodeAt(i+l)===p)return a.slice(i+l+1);if(l===0)return a.slice(i+l)}else r>u&&(f.charCodeAt(o+l)===p?c=l:l===0&&(c=0));let d="";for(l=o+c+1;l<=t;++l)(l===t||f.charCodeAt(l)===p)&&(d+=d.length===0?"..":"/..");return`${d}${a.slice(i+c)}`},toNamespacedPath(f){return f},dirname(f){if(v(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===p;let o=-1,t=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===p){if(!t){o=r;break}}else t=!1;return o===-1?a?"/":".":a&&o===1?"//":f.slice(0,o)},basename(f,a){a!==void 0&&v(a,"ext"),v(f,"path");let o=0,t=-1,r=!0,i;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,u=-1;for(i=f.length-1;i>=0;--i){const c=f.charCodeAt(i);if(c===p){if(!r){o=i+1;break}}else u===-1&&(r=!1,u=i+1),s>=0&&(c===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=u))}return o===t?t=u:t===-1&&(t=f.length),f.slice(o,t)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===p){if(!r){o=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(o,t)},extname(f){v(f,"path");let a=-1,o=0,t=-1,r=!0,i=0;for(let s=f.length-1;s>=0;--s){const u=f.charCodeAt(s);if(u===p){if(!r){o=s+1;break}continue}t===-1&&(r=!1,t=s+1),u===P?a===-1?a=s:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||t===-1||i===0||i===1&&a===t-1&&a===o+1?"":f.slice(a,t)},format:C.bind(null,"/"),parse(f){v(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const o=f.charCodeAt(0)===p;let t;o?(a.root="/",t=1):t=0;let r=-1,i=0,s=-1,u=!0,c=f.length-1,l=0;for(;c>=t;--c){const d=f.charCodeAt(c);if(d===p){if(!u){i=c+1;break}continue}s===-1&&(u=!1,s=c+1),d===P?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}if(s!==-1){const d=i===0&&o?1:i;r===-1||l===0||l===1&&r===s-1&&r===i+1?a.base=a.name=f.slice(d,s):(a.name=f.slice(d,r),a.base=f.slice(d,s),a.ext=f.slice(r,s))}return i>0?a.dir=f.slice(0,i-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var L in S)(typeof exports=="object"?exports:K)[L]=S[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function S(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return K[L].call(R.exports,R,R.exports,S),R.l=!0,R.exports}return S.m=K,S.c=e,S.d=function(L,R,k){S.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:k})},S.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},S.t=function(L,R){if(1&R&&(L=S(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var A in L)S.d(k,A,function(P){return L[P]}.bind(null,A));return k},S.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return S.d(R,"a",R),R},S.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},S.p="",S(S.s=0)}([function(K,e,S){(function(L){var R;e=K.exports=Q,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],w=0,n=w++;p[n]="0|[1-9]\\d*";var y=w++;p[y]="[0-9]+";var m=w++;p[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=w++;p[v]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var h=w++;p[h]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var I=w++;p[I]="(?:"+p[n]+"|"+p[m]+")";var D=w++;p[D]="(?:"+p[y]+"|"+p[m]+")";var b=w++;p[b]="(?:-("+p[I]+"(?:\\."+p[I]+")*))";var C=w++;p[C]="(?:-?("+p[D]+"(?:\\."+p[D]+")*))";var f=w++;p[f]="[0-9A-Za-z-]+";var a=w++;p[a]="(?:\\+("+p[f]+"(?:\\."+p[f]+")*))";var o=w++,t="v?"+p[v]+p[b]+"?"+p[a]+"?";p[o]="^"+t+"$";var r="[v=\\s]*"+p[h]+p[C]+"?"+p[a]+"?",i=w++;p[i]="^"+r+"$";var s=w++;p[s]="((?:<|>)?=?)";var u=w++;p[u]=p[y]+"|x|X|\\*";var c=w++;p[c]=p[n]+"|x|X|\\*";var l=w++;p[l]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[b]+")?"+p[a]+"?)?)?";var d=w++;p[d]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[C]+")?"+p[a]+"?)?)?";var E=w++;p[E]="^"+p[s]+"\\s*"+p[l]+"$";var g=w++;p[g]="^"+p[s]+"\\s*"+p[d]+"$";var T=w++;p[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;p[O]="(?:~>?)";var $=w++;p[$]="(\\s*)"+p[O]+"\\s+",P[$]=new RegExp(p[$],"g");var x=w++;p[x]="^"+p[O]+p[l]+"$";var G=w++;p[G]="^"+p[O]+p[d]+"$";var B=w++;p[B]="(?:\\^)";var U=w++;p[U]="(\\s*)"+p[B]+"\\s+",P[U]=new RegExp(p[U],"g");var M=w++;p[M]="^"+p[B]+p[l]+"$";var F=w++;p[F]="^"+p[B]+p[d]+"$";var j=w++;p[j]="^"+p[s]+"\\s*("+r+")$|^$";var _=w++;p[_]="^"+p[s]+"\\s*("+t+")$|^$";var N=w++;p[N]="(\\s*)"+p[s]+"\\s*("+r+"|"+p[l]+")",P[N]=new RegExp(p[N],"g");var W=w++;p[W]="^\\s*("+p[l]+")\\s+-\\s+("+p[l]+")\\s*$";var z=w++;p[z]="^\\s*("+p[d]+")\\s+-\\s+("+p[d]+")\\s*$";var V=w++;p[V]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)R(H,p[H]),P[H]||(P[H]=new RegExp(p[H]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>k||!(re?P[i]:P[o]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Q))return new Q(J,re);R("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[i]:P[o]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ve=+me;if(ve>=0&&ve<A)return ve}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return R("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=J.prerelease[re];if(R("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ne(se,me)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(J,se).inc(re,me).version}catch(ve){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=X(J),me=X(re);if(se.prerelease.length||me.prerelease.length){for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==me[ve])return"pre"+ve;return"prerelease"}for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==me[ve])return ve},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),me=ie.test(re);return se&&me&&(J=+J,re=+re),se&&!me?-1:me&&!se?1:J<re?-1:J>re?1:0}function le(J,re,se){return new Q(J,se).compare(new Q(re,se))}function de(J,re,se){return le(J,re,se)>0}function ye(J,re,se){return le(J,re,se)<0}function pe(J,re,se){return le(J,re,se)===0}function Pe(J,re,se){return le(J,re,se)!==0}function Te(J,re,se){return le(J,re,se)>=0}function Ne(J,re,se){return le(J,re,se)<=0}function Oe(J,re,se,me){var ve;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),ve=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),ve=J!==se;break;case"":case"=":case"==":ve=pe(J,se,me);break;case"!=":ve=Pe(J,se,me);break;case">":ve=de(J,se,me);break;case">=":ve=Te(J,se,me);break;case"<":ve=ye(J,se,me);break;case"<=":ve=Ne(J,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return ve}function Le(J,re){if(J instanceof Le){if(J.loose===re)return J;J=J.value}if(!(this instanceof Le))return new Le(J,re);R("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=le,e.compareLoose=function(J,re){return le(J,re,!0)},e.rcompare=function(J,re,se){return le(re,J,se)},e.sort=function(J,re){return J.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(J,re){return J.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=de,e.lt=ye,e.eq=pe,e.neq=Pe,e.gte=Te,e.lte=Ne,e.cmp=Oe,e.Comparator=Le;var _e={};function be(J,re){if(J instanceof be)return J.loose===re?J:new be(J.raw,re);if(J instanceof Le)return new be(J.value,re);if(!(this instanceof be))return new be(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ke(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ye(J,re,se,me,ve,De,we,Ae,Ie,Re,Ue,q,te){return((re=ke(se)?"":ke(me)?">="+se+".0.0":ke(ve)?">="+se+"."+me+".0":">="+re)+" "+(Ae=ke(Ie)?"":ke(Re)?"<"+(+Ie+1)+".0.0":ke(Ue)?"<"+Ie+"."+(+Re+1)+".0":q?"<="+Ie+"."+Re+"."+Ue+"-"+q:"<="+Ae)).trim()}function Je(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(R(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var me=J[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function ze(J,re,se){try{re=new be(re,se)}catch(me){return!1}return re.test(J)}function je(J,re,se,me){var ve,De,we,Ae,Ie;switch(J=new Q(J,me),re=new be(re,me),se){case">":ve=de,De=Ne,we=ye,Ae=">",Ie=">=";break;case"<":ve=ye,De=Te,we=de,Ae="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(J,re,me))return!1;for(var Re=0;Re<re.set.length;++Re){var Ue=re.set[Re],q=null,te=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Le(">=0.0.0")),q=q||ae,te=te||ae,ve(ae.semver,q.semver,me)?q=ae:we(ae.semver,te.semver,me)&&(te=ae)}),q.operator===Ae||q.operator===Ie||(!te.operator||te.operator===Ae)&&De(J,te.semver)||te.operator===Ie&&we(J,te.semver))return!1}return!0}Le.prototype.parse=function(J){var re=this.loose?P[j]:P[_],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},Le.prototype.toString=function(){return this.value},Le.prototype.test=function(J){return R("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new Q(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Le.prototype.intersects=function(J,re){if(!(J instanceof Le))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new be(J.value,re),ze(this.value,se,re);if(J.operator==="")return se=new be(this.value,re),ze(J.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),De=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ae=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ie=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||ve||De&&we||Ae||Ie},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),R("range",J,re);var se=re?P[z]:P[W];J=J.replace(se,Ye),R("hyphen replace",J),J=J.replace(P[N],"$1$2$3"),R("comparator trim",J,P[N]),J=(J=(J=J.replace(P[$],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var me=re?P[j]:P[_],ve=J.split(" ").map(function(De){return function(we,Ae){return R("comp",we),we=function(Ie,Re){return Ie.trim().split(/\s+/).map(function(Ue){return function(q,te){R("caret",q,te);var ae=te?P[F]:P[M];return q.replace(ae,function(ce,oe,he,ge,Se){var ue;return R("caret",q,ce,oe,he,ge,Se),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=oe==="0"?">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+".0 <"+(+oe+1)+".0.0":Se?(R("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+Se+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+Se+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+Se+" <"+(+oe+1)+".0.0"):(R("no pr"),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+" <"+(+oe+1)+".0.0"),R("caret return",ue),ue})}(Ue,Re)}).join(" ")}(we,Ae),R("caret",we),we=function(Ie,Re){return Ie.trim().split(/\s+/).map(function(Ue){return function(q,te){var ae=te?P[G]:P[x];return q.replace(ae,function(ce,oe,he,ge,Se){var ue;return R("tilde",q,ce,oe,he,ge,Se),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":Se?(R("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),ue=">="+oe+"."+he+"."+ge+Se+" <"+oe+"."+(+he+1)+".0"):ue=">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0",R("tilde return",ue),ue})}(Ue,Re)}).join(" ")}(we,Ae),R("tildes",we),we=function(Ie,Re){return R("replaceXRanges",Ie,Re),Ie.split(/\s+/).map(function(Ue){return function(q,te){q=q.trim();var ae=te?P[g]:P[E];return q.replace(ae,function(ce,oe,he,ge,Se,ue){R("xRange",q,ce,oe,he,ge,Se,ue);var Ee=ke(he),Ce=Ee||ke(ge),Fe=Ce||ke(Se);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ce&&(ge=0),Fe&&(Se=0),oe===">"?(oe=">=",Ce?(he=+he+1,ge=0,Se=0):Fe&&(ge=+ge+1,Se=0)):oe==="<="&&(oe="<",Ce?he=+he+1:ge=+ge+1),ce=oe+he+"."+ge+"."+Se):Ce?ce=">="+he+".0.0 <"+(+he+1)+".0.0":Fe&&(ce=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),R("xRange return",ce),ce})}(Ue,Re)}).join(" ")}(we,Ae),R("xrange",we),we=function(Ie,Re){return R("replaceStars",Ie,Re),Ie.trim().replace(P[V],"")}(we,Ae),R("stars",we),we}(De,re)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(me)})),ve=ve.map(function(De){return new Le(De,re)})},be.prototype.intersects=function(J,re){if(!(J instanceof be))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return J.set.some(function(ve){return ve.every(function(De){return me.intersects(De,re)})})})})},e.toComparators=function(J,re){return new be(J,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},be.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],J))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(J,re,se){var me=null,ve=null;try{var De=new be(re,se)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(me&&ve.compare(we)!==-1||(ve=new Q(me=we,se)))}),me},e.minSatisfying=function(J,re,se){var me=null,ve=null;try{var De=new be(re,se)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(me&&ve.compare(we)!==1||(ve=new Q(me=we,se)))}),me},e.validRange=function(J,re){try{return new be(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return je(J,re,"<",se)},e.gtr=function(J,re,se){return je(J,re,">",se)},e.outside=je,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new be(J,se),re=new be(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(P[T]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,S(1))},function(K,e){var S,L,R=K.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(D){if(S===setTimeout)return setTimeout(D,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(D,0);try{return S(D,0)}catch(b){try{return S.call(null,D,0)}catch(C){return S.call(this,D,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch(D){S=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(D){L=A}})();var p,w=[],n=!1,y=-1;function m(){n&&p&&(n=!1,p.length?w=p.concat(w):y=-1,w.length&&v())}function v(){if(!n){var D=P(m);n=!0;for(var b=w.length;b;){for(p=w,w=[];++y<b;)p&&p[y].run();y=-1,b=w.length}p=null,n=!1,function(C){if(L===clearTimeout)return clearTimeout(C);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(C);try{L(C)}catch(f){try{return L.call(null,C)}catch(a){return L.call(this,C)}}}(D)}}function h(D,b){this.fun=D,this.array=b}function I(){}R.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)b[C-1]=arguments[C];w.push(new h(D,b)),w.length!==1||n||P(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=I,R.addListener=I,R.once=I,R.off=I,R.removeListener=I,R.removeAllListeners=I,R.emit=I,R.prependListener=I,R.prependOnceListener=I,R.listeners=function(D){return[]},R.binding=function(D){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(D){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[90],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=S.globals.performance&&typeof S.globals.performance.now=="function";class R{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new R(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],ee([0,1,11,65,2,89,90]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(f){f.None=()=>R.Disposable.None;function a(B){return(U,M=null,F)=>{let j=!1,_;return _=B(N=>{if(!j)return _?_.dispose():j=!0,U.call(M,N)},null,F),j&&_.dispose(),_}}f.once=a;function o(B,U){return c((M,F=null,j)=>B(_=>M.call(F,U(_)),null,j))}f.map=o;function t(B,U){return c((M,F=null,j)=>B(_=>{U(_),M.call(F,_)},null,j))}f.forEach=t;function r(B,U){return c((M,F=null,j)=>B(_=>U(_)&&M.call(F,_),null,j))}f.filter=r;function i(B){return B}f.signal=i;function s(...B){return(U,M=null,F)=>(0,R.combinedDisposable)(...B.map(j=>j(_=>U.call(M,_),null,F)))}f.any=s;function u(B,U,M){let F=M;return o(B,j=>(F=U(F,j),F))}f.reduce=u;function c(B){let U;const M=new m({onFirstListenerAdd(){U=B(M.fire,M)},onLastListenerRemove(){U.dispose()}});return M.event}function l(B,U,M=100,F=!1,j){let _,N,W,z=0;const V=new m({leakWarningThreshold:j,onFirstListenerAdd(){_=B(H=>{z++,N=U(N,H),F&&!W&&(V.fire(N),N=void 0),clearTimeout(W),W=setTimeout(()=>{const X=N;N=void 0,W=void 0,(!F||z>1)&&V.fire(X),z=0},M)})},onLastListenerRemove(){_.dispose()}});return V.event}f.debounce=l;function d(B,U=(M,F)=>M===F){let M=!0,F;return r(B,j=>{const _=M||!U(j,F);return M=!1,F=j,_})}f.latch=d;function E(B,U){return[f.filter(B,U),f.filter(B,M=>!U(M))]}f.split=E;function g(B,U=!1,M=[]){let F=M.slice(),j=B(W=>{F?F.push(W):N.fire(W)});const _=()=>{F&&F.forEach(W=>N.fire(W)),F=null},N=new m({onFirstListenerAdd(){j||(j=B(W=>N.fire(W)))},onFirstListenerDidAdd(){F&&(U?setTimeout(_):_())},onLastListenerRemove(){j&&j.dispose(),j=null}});return N.event}f.buffer=g;class T{constructor(U){this.event=U}map(U){return new T(o(this.event,U))}forEach(U){return new T(t(this.event,U))}filter(U){return new T(r(this.event,U))}reduce(U,M){return new T(u(this.event,U,M))}latch(){return new T(d(this.event))}debounce(U,M=100,F=!1,j){return new T(l(this.event,U,M,F,j))}on(U,M,F){return this.event(U,M,F)}once(U,M,F){return a(this.event)(U,M,F)}}function O(B){return new T(B)}f.chain=O;function $(B,U,M=F=>F){const F=(...W)=>N.fire(M(...W)),j=()=>B.on(U,F),_=()=>B.removeListener(U,F),N=new m({onFirstListenerAdd:j,onLastListenerRemove:_});return N.event}f.fromNodeEventEmitter=$;function x(B,U,M=F=>F){const F=(...W)=>N.fire(M(...W)),j=()=>B.addEventListener(U,F),_=()=>B.removeEventListener(U,F),N=new m({onFirstListenerAdd:j,onLastListenerRemove:_});return N.event}f.fromDOMEventEmitter=x;function G(B){return new Promise(U=>a(B)(U))}f.toPromise=G})(P=e.Event||(e.Event={}));class p{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${p._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let w=-1;function n(f){const a=w;return w=f,{dispose(){w=a}}}e.setGlobalLeakWarningThreshold=n;class y{constructor(a,o=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let o=w;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||a<o)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,s=0;for(const[u,c]of this._stacks)(!i||s<c)&&(i=u,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class m{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=w>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(a,o,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[a,o]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,o);const s=this._leakageMon?.check(this._listeners.size),u=(0,R.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){(0,S.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class v extends m{async fireAsync(a,o,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],u={...i,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),s.push(c)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(c){(0,S.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const l of c)l.status==="rejected"&&(0,S.onUnexpectedError)(l.reason)})}}}}e.AsyncEmitter=v;class h extends m{constructor(a){super(a);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class I extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=I;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const o={event:a,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const t=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(o=>this.emitter.fire(o))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class b{constructor(){this.buffers=[]}wrapEvent(a){return(o,t,r)=>a(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(t,i)):o.call(t,i)},void 0,r)}bufferEvents(a){const o=[];this.buffers.push(o);const t=a();return this.buffers.pop(),o.forEach(r=>r()),t}}e.EventBufferer=b;class C{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(Z[29],ee([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,p){const w=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(w)}}});var R;(function(P){function p(w){return w===P.None||w===P.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=R.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=A}),define(Z[48],ee([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(y){const m=this._icons.get(y.id);m?y.description?m.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function k(n,y){return new P(n,y)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(y,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(y,m,v){this.id=y,this.definition=m,this.description=v,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function p(n,y){const m=["codicon","codicon-"+n];return y&&m.push("codicon-modifier-"+y),m}e.getClassNamesArray=p;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function m(I){if(I instanceof P)return["codicon","codicon-"+I.id];const D=y.exec(I.id);if(!D)return m(P.error);let[,b,C]=D;const f=["codicon","codicon-"+b];return C&&f.push("codicon-modifier-"+C.substr(1)),f}n.asClassNameArray=m;function v(I){return m(I).join(" ")}n.asClassName=v;function h(I){return"."+m(I).join(".")}n.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[49],ee([0,1,11,2]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(f){const a=f;return a?[a.on,a.pause,a.resume,a.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=R;function k(f){const a=f;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(f,a){return new P(f,a)}e.newWriteableStream=A;class P{constructor(a,o){this.reducer=a,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(o=>o(a))}emitError(a){this.listeners.error.length===0?(0,S.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(o=>o(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,o){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(a,o){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(f,a){const o=[];let t;for(;(t=f.read())!==null;)o.push(t);return a(o)}e.consumeReadable=p;function w(f,a,o){const t=[];let r;for(;(r=f.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return f.read()}}}e.peekReadable=w;function n(f,a){return new Promise((o,t)=>{const r=[];y(f,{onData:i=>{a&&r.push(i)},onError:i=>{a?t(i):o(void 0)},onEnd:()=>{o(a?a(r):void 0)}})})}e.consumeStream=n;function y(f,a){f.on("error",o=>a.onError(o)),f.on("end",()=>a.onEnd()),f.on("data",o=>a.onData(o))}e.listenStream=y;function m(f,a){return new Promise((o,t)=>{const r=new L.DisposableStore,i=[],s=l=>{if(i.push(l),i.length>a)return r.dispose(),f.pause(),o({stream:f,buffer:i,ended:!1})},u=l=>t(l),c=()=>o({stream:f,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),r.add((0,L.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),r.add((0,L.toDisposable)(()=>f.removeListener("data",s))),f.on("data",s)})}e.peekStream=m;function v(f,a){const o=A(a);return o.end(f),o}e.toStream=v;function h(){const f=A(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function I(f){let a=!1;return{read:()=>a?null:(a=!0,f)}}e.toReadable=I;function D(f,a,o){const t=A(o);return y(f,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(f,a,o){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?o([f,r]):f)}}}e.prefixedReadable=b;function C(f,a,o){let t=!1;const r=A(o);return y(a,{onData:i=>t?r.write(i):(t=!0,r.write(o([f,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}e.prefixedStream=C}),define(Z[19],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=S;const L=/{(\d+)}/g;function R(q,...te){return te.length===0?q:q.replace(L,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=te.length?ae:te[oe]})}e.format=R;const k=/{([^}]+)}/g;function A(q,te){return q.replace(k,(ae,ce)=>te[ce]??ae)}e.format2=A;function P(q){return q.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function p(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function w(q,te){let ae=0;const ce=te.charCodeAt(0);for(let oe=q.length-1;oe>=0;oe--)q.charCodeAt(oe)===ce&&ae++;return ae}e.count=w;function n(q,te,ae="\u2026"){return q.length<=te?q:`${q.substr(0,te)}${ae}`}e.truncate=n;function y(q,te=" "){const ae=m(q,te);return v(ae,te)}e.trim=y;function m(q,te){if(!q||!te)return q;const ae=te.length;if(ae===0||q.length===0)return q;let ce=0;for(;q.indexOf(te,ce)===ce;)ce=ce+ae;return q.substring(ce)}e.ltrim=m;function v(q,te){if(!q||!te)return q;const ae=te.length,ce=q.length;if(ae===0||ce===0)return q;let oe=ce,he=-1;for(;he=q.lastIndexOf(te,oe-1),!(he===-1||he+ae!==oe);){if(he===0)return"";oe=he}return q.substring(0,oe)}e.rtrim=v;function h(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function I(q){return q.replace(/\*/g,"")}e.stripWildcards=I;function D(q,te,ae={}){if(!q)throw new Error("Cannot create regex from empty string");te||(q=p(q)),ae.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(q,ce)}e.createRegExp=D;function b(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function C(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function f(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=f;function a(q){return q.split(/\r\n|\r|\n/)}e.splitLines=a;function o(q){for(let te=0,ae=q.length;te<ae;te++){const ce=q.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=o;function t(q,te=0,ae=q.length){for(let ce=te;ce<ae;ce++){const oe=q.charCodeAt(ce);if(oe!==32&&oe!==9)return q.substring(te,ce)}return q.substring(te,ae)}e.getLeadingWhitespace=t;function r(q,te=q.length-1){for(let ae=te;ae>=0;ae--){const ce=q.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(q,te){return q<te?-1:q>te?1:0}e.compare=i;function s(q,te,ae=0,ce=q.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=q.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue<Ee)return-1;if(ue>Ee)return 1}const ge=ce-ae,Se=he-oe;return ge<Se?-1:ge>Se?1:0}e.compareSubstring=s;function u(q,te){return c(q,te,0,q.length,0,te.length)}e.compareIgnoreCase=u;function c(q,te,ae=0,ce=q.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=q.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue===Ee)continue;const Ce=ue-Ee;if(!(Ce===32&&d(Ee))&&!(Ce===-32&&d(ue)))return l(ue)&&l(Ee)?Ce:s(q.toLowerCase(),te.toLowerCase(),ae,ce,oe,he)}const ge=ce-ae,Se=he-oe;return ge<Se?-1:ge>Se?1:0}e.compareSubstringIgnoreCase=c;function l(q){return q>=97&&q<=122}e.isLowerAsciiLetter=l;function d(q){return q>=65&&q<=90}e.isUpperAsciiLetter=d;function E(q){return l(q)||d(q)}function g(q,te){return q.length===te.length&&T(q,te)}e.equalsIgnoreCase=g;function T(q,te,ae=q.length){for(let ce=0;ce<ae;ce++){const oe=q.charCodeAt(ce),he=te.charCodeAt(ce);if(oe!==he){if(E(oe)&&E(he)){const ge=Math.abs(oe-he);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(he).toLowerCase())return!1}}return!0}function O(q,te){const ae=te.length;return te.length>q.length?!1:T(q,te,ae)}e.startsWithIgnoreCase=O;function $(q,te){let ae,ce=Math.min(q.length,te.length);for(ae=0;ae<ce;ae++)if(q.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=$;function x(q,te){let ae,ce=Math.min(q.length,te.length);const oe=q.length-1,he=te.length-1;for(ae=0;ae<ce;ae++)if(q.charCodeAt(oe-ae)!==te.charCodeAt(he-ae))return ae;return ce}e.commonSuffixLength=x;function G(q){return 55296<=q&&q<=56319}e.isHighSurrogate=G;function B(q){return 56320<=q&&q<=57343}e.isLowSurrogate=B;function U(q,te){return(q-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function M(q,te,ae){const ce=q.charCodeAt(ae);if(G(ce)&&ae+1<te){const oe=q.charCodeAt(ae+1);if(B(oe))return U(ce,oe)}return ce}e.getNextCodePoint=M;function F(q,te){const ae=q.charCodeAt(te-1);if(B(ae)&&te>1){const ce=q.charCodeAt(te-2);if(G(ce))return U(ce,ae)}return ae}function j(q,te){const ae=ve.getInstance(),ce=te,oe=q.length,he=M(q,oe,te);te+=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te<oe;){const Se=M(q,oe,te),ue=ae.getGraphemeBreakType(Se);if(se(ge,ue))break;te+=Se>=65536?2:1,ge=ue}return te-ce}e.nextCharLength=j;function _(q,te){const ae=ve.getInstance(),ce=te,oe=F(q,te);te-=oe>=65536?2:1;let he=ae.getGraphemeBreakType(oe);for(;te>0;){const ge=F(q,te),Se=ae.getGraphemeBreakType(ge);if(se(Se,he))break;te-=ge>=65536?2:1,he=Se}return ce-te}e.prevCharLength=_;function N(q,te){const ae=ve.getInstance(),ce=q.length,oe=te,he=M(q,ce,te),ge=ae.getGraphemeBreakType(he);te+=he>=65536?2:1;let Se=ge;for(;te<ce;){const Ee=M(q,ce,te),Ce=ae.getGraphemeBreakType(Ee);if(se(Se,Ce))break;te+=Ee>=65536?2:1,Se=Ce}const ue=te;for(te=oe,Se=ge;te>0;){const Ee=F(q,te),Ce=ae.getGraphemeBreakType(Ee);if(se(Ce,Se))break;te-=Ee>=65536?2:1,Se=Ce}return[te,ue]}function W(q,te){return te>0&&B(q.charCodeAt(te))?N(q,te-1):N(q,te)}e.getCharContainingOffset=W;function z(q){const te=q.length;let ae=0,ce=0;for(;ce<te;){const ge=M(q,te,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let he=0;for(;ce<te;){const ge=M(q,te,ce);ce+=ge>=65536?2:1,ge<128?oe[he++]=ge:ge<2048?(oe[he++]=192|(ge&1984)>>>6,oe[he++]=128|(ge&63)>>>0):ge<65536?(oe[he++]=224|(ge&61440)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0):(oe[he++]=240|(ge&1835008)>>>18,oe[he++]=128|(ge&258048)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=z;function V(q){const te=q.byteLength,ae=[];let ce=0;for(;ce<te;){const oe=q[ce];let he;if(oe>=240&&ce+3<te?he=(q[ce++]&7)<<18>>>0|(q[ce++]&63)<<12>>>0|(q[ce++]&63)<<6>>>0|(q[ce++]&63)<<0>>>0:oe>=224&&ce+2<te?he=(q[ce++]&15)<<12>>>0|(q[ce++]&63)<<6>>>0|(q[ce++]&63)<<0>>>0:oe>=192&&ce+1<te?he=(q[ce++]&31)<<6>>>0|(q[ce++]&63)<<0>>>0:he=q[ce++],he>=0&&he<=55295||he>=57344&&he<=65535)ae.push(String.fromCharCode(he));else if(he>=65536&&he<=1114111){const ge=he-65536,Se=55296+((ge&1047552)>>>10),ue=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(Se)),ae.push(String.fromCharCode(ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=V;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(q){return H.test(q)}e.containsRTL=X;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(q){return Q.test(q)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function le(q){return ne.test(q)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=de;function ye(q){for(let te=0,ae=q.length;te<ae;te++)if(pe(q.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ye;function pe(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=pe;function Pe(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=Pe;function Te(q,te){if(q.length<te)return q;const ae=/\b/g;let ce=0;for(;ae.test(q)&&!(q.length-ae.lastIndex<te);)ce=ae.lastIndex,ae.lastIndex+=1;return q.substring(ce).replace(/^\s/,"")}e.lcut=Te;const Ne=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function _e(q){return q&&(q=q.replace(Ne,""),q=q.replace(Oe,""),q=q.replace(Le,"")),q}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function ke(q){return be(q)?q.substr(1):q}e.stripUTF8BOM=ke;function Ye(q,te){if(!q||!te||q.length<te.length)return!1;const ae=te.length,ce=q.toLowerCase();let oe=0,he=-1;for(;oe<ae;){const ge=ce.indexOf(te[oe],he+1);if(ge<0)return!1;he=ge,oe++}return!0}e.fuzzyContains=Ye;function Je(q,te=!1){return q?(te&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Je;function ze(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=ze;function je(q,te=1){if(te===0)return"";let ae=-1;do ae=q.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?q:(q[ae-1]==="\r"&&ae--,q.substr(0,ae))}e.getNLines=je;function J(q){const te=90-65+1;return q=q%(2*te),q<te?String.fromCharCode(97+q):String.fromCharCode(65+q-te)}e.singleLetterHash=J;function re(q){return ve.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=re;function se(q,te){return q===0?te!==5&&te!==7:q===2&&te===3?!1:q===4||q===2||q===3||te===4||te===2||te===3?!0:!(q===8&&(te===8||te===9||te===11||te===12)||(q===11||q===9)&&(te===9||te===10)||(q===12||q===10)&&te===10||te===5||te===13||te===7||q===1||q===13&&te===14||q===6&&te===6)}e.breakBetweenGraphemeBreakType=se;var me;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=De()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(te<ae[3*oe])oe=2*oe;else if(te>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}ve._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(q,te){if(q===0)return 0;const ae=Ae(q,te);if(ae!==void 0)return ae;const ce=F(te,q);return q-=Ie(ce),q}e.getLeftDeleteOffset=we;function Ae(q,te){let ae=F(te,q);for(q-=Ie(ae);Re(ae)||ae===65039||ae===8419;){if(q===0)return;ae=F(te,q),q-=Ie(ae)}if(!!Pe(ae)){if(q>=0){const ce=F(te,q);ce===8205&&(q-=Ie(ce))}return q}}function Ie(q){return q>=65536?2:1}function Re(q){return 127995<=q&&q<=127999}var Ue;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(Z[25],ee([0,1,19,49]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,p;class w{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return R?new w(Buffer.allocUnsafe(l)):new w(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new w(l)}static fromString(l,d){return!(d?.dontUseNodeBuffer||!1)&&R?new w(Buffer.from(l)):k?(P||(P=new TextEncoder),new w(P.encode(l))):new w(S.encodeUTF8(l))}static concat(l,d){if(typeof d=="undefined"){d=0;for(let T=0,O=l.length;T<O;T++)d+=l[T].byteLength}const E=w.alloc(d);let g=0;for(let T=0,O=l.length;T<O;T++){const $=l[T];E.set($,g),g+=$.byteLength}return E}toString(){return R?this.buffer.toString():A?(p||(p=new TextDecoder),p.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(l,d){return new w(this.buffer.subarray(l,d))}set(l,d){l instanceof w?this.buffer.set(l.buffer,d):this.buffer.set(l,d)}readUInt32BE(l){return m(this.buffer,l)}writeUInt32BE(l,d){v(this.buffer,l,d)}readUInt32LE(l){return h(this.buffer,l)}writeUInt32LE(l,d){I(this.buffer,l,d)}readUInt8(l){return D(this.buffer,l)}writeUInt8(l,d){b(this.buffer,l,d)}}e.VSBuffer=w;function n(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=n;function y(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255}e.writeUInt16LE=y;function m(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=m;function v(c,l,d){c[d+3]=l,l=l>>>8,c[d+2]=l,l=l>>>8,c[d+1]=l,l=l>>>8,c[d]=l}e.writeUInt32BE=v;function h(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=h;function I(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255,l=l>>>8,c[d+2]=l&255,l=l>>>8,c[d+3]=l&255}e.writeUInt32LE=I;function D(c,l){return c[l]}e.readUInt8=D;function b(c,l,d){c[d]=l}e.writeUInt8=b;function C(c){return L.consumeReadable(c,l=>w.concat(l))}e.readableToBuffer=C;function f(c){return L.toReadable(c)}e.bufferToReadable=f;function a(c){return L.consumeStream(c,l=>w.concat(l))}e.streamToBuffer=a;async function o(c){return c.ended?w.concat(c.buffer):w.concat([...c.buffer,await a(c.stream)])}e.bufferedStreamToBuffer=o;function t(c){return L.toStream(c,l=>w.concat(l))}e.bufferToStream=t;function r(c){return L.transform(c,{data:l=>typeof l=="string"?w.fromString(l):w.wrap(l)},l=>w.concat(l))}e.streamToBufferReadableStream=r;function i(c){return L.newWriteableStream(l=>w.concat(l),c)}e.newWriteableBufferStream=i;function s(c,l){return L.prefixedReadable(c,l,d=>w.concat(d))}e.prefixedBufferReadable=s;function u(c,l){return L.prefixedStream(c,l,d=>w.concat(d))}e.prefixedBufferStream=u}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(l){return Array.isArray(l)}e.isArray=S;function L(l){return typeof l=="string"}e.isString=L;function R(l){return Array.isArray(l)&&l.every(d=>L(d))}e.isStringArray=R;function k(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=k;function A(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=A;function P(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=P;function p(l){return l===!0||l===!1}e.isBoolean=p;function w(l){return typeof l=="undefined"}e.isUndefined=w;function n(l){return!y(l)}e.isDefined=n;function y(l){return w(l)||l===null}e.isUndefinedOrNull=y;function m(l,d){if(!l)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=m;function v(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=v;function h(...l){const d=[];for(let E=0;E<l.length;E++){const g=l[E];if(y(g))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);d.push(g)}return d}e.assertAllDefined=h;const I=Object.prototype.hasOwnProperty;function D(l){if(!k(l))return!1;for(let d in l)if(I.call(l,d))return!1;return!0}e.isEmptyObject=D;function b(l){return typeof l=="function"}e.isFunction=b;function C(...l){return l.length>0&&l.every(b)}e.areFunctions=C;function f(l,d){const E=Math.min(l.length,d.length);for(let g=0;g<E;g++)a(l[g],d[g])}e.validateConstraints=f;function a(l,d){if(L(d)){if(typeof l!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(b(d)){try{if(l instanceof d)return}catch{}if(!y(l)&&l.constructor===d||d.length===1&&d.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function o(l){let d=[],E=Object.getPrototypeOf(l);for(;Object.prototype!==E;)d=d.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return d}e.getAllPropertyNames=o;function t(l){const d=[];for(const E of o(l))typeof l[E]=="function"&&d.push(E);return d}e.getAllMethodNames=t;function r(l,d){const E=T=>function(){const O=Array.prototype.slice.call(arguments,0);return d(T,O)};let g={};for(const T of l)g[T]=E(T);return g}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function s(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=s;function u(l){return class{constructor(){return new Proxy({},{get(d,E){if(d[E])return d[E];throw new Error(`Not Implemented: ${l}->${String(E)}`)}})}}}e.NotImplementedProxy=u;function c(l,d="Unreachable"){throw new Error(d)}e.assertNever=c}),define(Z[42],ee([0,1,7,19,8,16]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function P(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function p(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function w(i,s=R.posix.sep){if(!i)return"";const u=i.length,c=i.charCodeAt(0);if(A(c)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let d=3;const E=d;for(;d<u&&!A(i.charCodeAt(d));d++);if(E!==d&&!A(i.charCodeAt(d+1))){for(d+=1;d<u;d++)if(A(i.charCodeAt(d)))return i.slice(0,d+1).replace(/[\\/]/g,s)}}return s}else if(b(c)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(A(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=w;function n(i){if(!S.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let u=2;const c=u;for(;u<i.length&&(s=i.charCodeAt(u),s!==92);u++);return!(c===u||(s=i.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=n;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,s=S.isWindows){const u=s?y:m;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||s&&v.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function I(i,s,u){const c=i===s;return!u||c?c:!i||!s?!1:(0,L.equalsIgnoreCase)(i,s)}e.isEqual=I;function D(i,s,u,c=R.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(u){if(!(0,L.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let d=s.length;return s.charAt(s.length-1)===c&&d--,i.charAt(d)===c}return s.charAt(s.length-1)!==c&&(s+=c),i.indexOf(s)===0}e.isEqualOrParent=D;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function C(i,s){return S.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(s,i)),i=(0,R.normalize)(i),S.isWindows?(i=(0,L.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,L.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=C;function f(i){const s=(0,R.normalize)(i);return S.isWindows?i.length>3?!1:a(s)&&(i.length===2||s.charCodeAt(2)===92):s===R.posix.sep}e.isRootOrDriveLetter=f;function a(i){return S.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function o(i){return a(i)?i[0]:void 0}e.getDriveLetter=o;function t(i,s,u){return s.length>i.length?-1:i===s?0:(u&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let u,c,l;if(s.forEach(d=>{const E=Number(d);(0,k.isNumber)(E)?c===void 0?c=E:l===void 0&&(l=E):u=u?[u,d].join(":"):d}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(I){if(!I||typeof I!="object"||I instanceof RegExp)return I;const D=Array.isArray(I)?[]:{};return Object.keys(I).forEach(b=>{I[b]&&typeof I[b]=="object"?D[b]=L(I[b]):D[b]=I[b]}),D}e.deepClone=L;function R(I){if(!I||typeof I!="object")return I;const D=[I];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const C in b)if(k.call(b,C)){const f=b[C];typeof f=="object"&&!Object.isFrozen(f)&&D.push(f)}}return I}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function A(I,D){return P(I,D,new Set)}e.cloneAndChange=A;function P(I,D,b){if((0,S.isUndefinedOrNull)(I))return I;const C=D(I);if(typeof C!="undefined")return C;if((0,S.isArray)(I)){const f=[];for(const a of I)f.push(P(a,D,b));return f}if((0,S.isObject)(I)){if(b.has(I))throw new Error("Cannot clone recursive data-structure");b.add(I);const f={};for(let a in I)k.call(I,a)&&(f[a]=P(I[a],D,b));return b.delete(I),f}return I}function p(I,D,b=!0){return(0,S.isObject)(I)?((0,S.isObject)(D)&&Object.keys(D).forEach(C=>{C in I?b&&((0,S.isObject)(I[C])&&(0,S.isObject)(D[C])?p(I[C],D[C],b):I[C]=D[C]):I[C]=D[C]}),I):D}e.mixin=p;function w(I,D){if(I===D)return!0;if(I==null||D===null||D===void 0||typeof I!=typeof D||typeof I!="object"||Array.isArray(I)!==Array.isArray(D))return!1;let b,C;if(Array.isArray(I)){if(I.length!==D.length)return!1;for(b=0;b<I.length;b++)if(!w(I[b],D[b]))return!1}else{const f=[];for(C in I)f.push(C);f.sort();const a=[];for(C in D)a.push(C);if(a.sort(),!w(f,a))return!1;for(b=0;b<f.length;b++)if(!w(I[f[b]],D[f[b]]))return!1}return!0}e.equals=w;function n(I){const D=new Set;return JSON.stringify(I,(b,C)=>{if((0,S.isObject)(C)||Array.isArray(C)){if(D.has(C))return"[Circular]";D.add(C)}return C})}e.safeStringify=n;function y(I,D,b){const C=D(I);return typeof C=="undefined"?b:C}e.getOrDefault=y;function m(I,D){const b=Object.create(null);return!I||!D||Object.keys(D).forEach(f=>{const a=I[f],o=D[f];w(a,o)||(b[f]=o)}),b}e.distinct=m;function v(I,D){const b=D.toLowerCase(),C=Object.keys(I).find(f=>f.toLowerCase()===b);return C?I[C]:I[D]}e.getCaseInsensitive=v;function h(I,D){const b=Object.create(null);for(const C of Object.keys(I))D(C,I[C])&&(b[C]=I[C]);return b}e.filter=h}),define(Z[4],ee([0,1,7,8]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!R.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,s){return!i&&!s?"file":i}function w(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const n="",y="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(s,u,c,l,d,E=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=p(s,E),this.authority=u||n,this.path=w(this.scheme,c||n),this.query=l||n,this.fragment=d||n,P(this,E))}static isUri(s){return s instanceof v?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:c,path:l,query:d,fragment:E}=s;return u===void 0?u=this.scheme:u===null&&(u=n),c===void 0?c=this.authority:c===null&&(c=n),l===void 0?l=this.path:l===null&&(l=n),d===void 0?d=this.query:d===null&&(d=n),E===void 0?E=this.fragment:E===null&&(E=n),u===this.scheme&&c===this.authority&&l===this.path&&d===this.query&&E===this.fragment?this:new I(u,c,l,d,E)}static parse(s,u=!1){const c=m.exec(s);return c?new I(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),u):new I(n,n,n,n,n)}static file(s){let u=n;if(S.isWindows&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const c=s.indexOf(y,2);c===-1?(u=s.substring(2),s=y):(u=s.substring(2,c),s=s.substring(c)||y)}return new I("file",u,s,n,n)}static from(s){const u=new I(s.scheme,s.authority,s.path,s.query,s.fragment);return P(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return S.isWindows&&s.scheme==="file"?c=v.file(L.win32.join(f(s,!0),...u)).path:c=L.posix.join(s.path,...u),s.with({path:c})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof v)return s;{const u=new I(s);return u._formatted=s.external,u._fsPath=s._sep===h?s.fsPath:null,u}}else return s}}e.URI=v;const h=S.isWindows?1:void 0;class I extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,s){let u,c=-1;for(let l=0;l<i.length;l++){const d=i.charCodeAt(l);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||s&&d===47)c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const E=D[d];E!==void 0?(c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u+=E):c===-1&&(c=l)}}return c!==-1&&(u+=encodeURIComponent(i.substring(c))),u!==void 0?u:i}function C(i){let s;for(let u=0;u<i.length;u++){const c=i.charCodeAt(u);c===35||c===63?(s===void 0&&(s=i.substr(0,u)),s+=D[c]):s!==void 0&&(s+=i[u])}return s!==void 0?s:i}function f(i,s){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,S.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=f;function a(i,s){const u=s?C:b;let c="",{scheme:l,authority:d,path:E,query:g,fragment:T}=i;if(l&&(c+=l,c+=":"),(d||l==="file")&&(c+=y,c+=y),d){let O=d.indexOf("@");if(O!==-1){const $=d.substr(0,O);d=d.substr(O+1),O=$.indexOf(":"),O===-1?c+=u($,!1):(c+=u($.substr(0,O),!1),c+=":",c+=u($.substr(O+1),!1)),c+="@"}d=d.toLowerCase(),O=d.indexOf(":"),O===-1?c+=u(d,!1):(c+=u(d.substr(0,O),!1),c+=d.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}c+=u(E,!0)}return g&&(c+="?",c+=u(g,!1)),T&&(c+="#",c+=s?T:b(T,!1)),c}function o(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+o(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>o(s)):i}}),define(Z[91],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function R(w){const n=[];let y;try{const m=JSON.parse(w.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),y=v.__$stack),n.push(...m)}catch(m){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:y}}e.parse=R;function k(w){if(typeof w!="string")return k(R(w).stack);const n=w;if(n){const y=A(n),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(m&&m.length===4)return{uri:S.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function A(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function P(w,n){const{args:y,stack:m}=R(w),v=typeof y[0]=="string"&&y.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let I=[];if(typeof y[0]=="string"?h&&v?I=[`%c[${n}] %c${y[0]} %c${h}`,p("blue"),p(""),p("grey")]:I=[`%c[${n}] %c${y[0]}`,p("blue"),p(""),...y.slice(1)]:I=[`%c[${n}]%`,p("blue"),...y],h&&!v&&I.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,I)}e.log=P;function p(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,S,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(K,S):R?R.value=S:e.set(K,S),S},$e=this&&this.__classPrivateFieldGet||function(K,e,S,L){if(S==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?L:S==="a"?L.call(K):L?L.value:e.get(K)};define(Z[38],ee([0,1,4,19]),function(K,e,S,L){"use strict";var R,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=P;function p(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new h(r))}static forPaths(){return new D(new m)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new y)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let u;for(this._root||(this._root=new I,this._root.segment=s.value()),u=this._root;;){const l=s.cmp(u.segment);if(l>0)u.left||(u.left=new I,u.left.segment=s.value()),u=u.left;else if(l<0)u.right||(u.right=new I,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new I,u.mid.segment=s.value()),u=u.mid;else break}const c=u.value;return u.value=i,u.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const u=i.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),u=[];let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)u.push([1,c]),c=c.left;else if(l<0)u.push([-1,c]),c=c.right;else if(s.hasNext())s.next(),u.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;u.length>0&&c.isEmpty();){let[d,E]=u.pop();switch(d){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}c=E}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,u;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const u=i.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=D;class b{constructor(r,i){this[R]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,u]of this.map)r(u,S.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield S.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[S.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[S.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var C;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let u=this._map.get(r);if(u)u.value=i,s!==0&&this.touch(u,s);else{switch(u={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.key,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.value,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:[s.key,s.value],done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,u=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=f;class a extends f{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class o{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return $e(this,A,"f").size}forEach(r,i){$e(this,A,"f").forEach(r,i)}get(r){return $e(this,A,"f").get(r)}has(r){return $e(this,A,"f").has(r)}entries(){return $e(this,A,"f").entries()}keys(){return $e(this,A,"f").keys()}values(){return $e(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return $e(this,A,"f").entries()}}e.ReadonlyMapView=o}),define(Z[92],ee([0,1,25,19,4]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,p)}e.stringify=k;function A(n){let y=JSON.parse(n);return y=w(y),y}e.parse=A;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function p(n,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,L.regExpFlags)(y)}:y}function w(n,y=0){if(!n||y>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof S.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let m=0;m<n.length;++m)n[m]=w(n[m],y+1);else for(const m in n)Object.hasOwnProperty.call(n,m)&&(n[m]=w(n[m],y+1))}return n}e.revive=w}),define(Z[17],ee([0,1,4,7]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,w,n){this._hosts[p]=w,this._ports[p]=n}setConnectionToken(p,w){this._connectionTokens[p]=w}rewrite(p){if(this._delegate)return this._delegate(p);const w=p.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const y=this._ports[w],m=this._connectionTokens[w];let v=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(v+=`&tkn=${encodeURIComponent(m)}`),S.URI.from({scheme:L.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${n}:${y}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,w,n){const y=this.toUri(p,w);if(y.scheme===R.vscodeRemote)return e.RemoteAuthorities.rewrite(y);let m=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&y.scheme===R.file&&(m=!0),y.scheme===R.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(m=!0),m?y.with({scheme:R.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(p,w){const n=this.toUri(p,w);return n.scheme===R.vscodeFileResource?n.with({scheme:R.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,w){return S.URI.isUri(p)?p:S.URI.parse(w.toUrl(p))}}e.FileAccess=new A}),define(Z[66],ee([0,1,38]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new S.LRUCache(1e4);function R(w){return p(w,"NFC",L)}e.normalizeNFC=R;const k=new S.LRUCache(1e4);function A(w){return p(w,"NFD",k)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function p(w,n,y){if(!w)return w;const m=y.get(w);if(m)return m;let v;return P.test(w)?v=w.normalize(n):v=w,y.set(w,v),v}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(n){return A(n).replace(w,"")}}()}),define(Z[15],ee([0,1,42,8,4,19,17,7]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=p;class w{constructor(h){this._ignorePathCasing=h}compare(h,I,D=!1){return h===I?0:(0,k.compare)(this.getComparisonKey(h,D),this.getComparisonKey(I,D))}isEqual(h,I,D=!1){return h===I?!0:!h||!I?!1:this.getComparisonKey(h,D)===this.getComparisonKey(I,D)}getComparisonKey(h,I=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,I,D=!1){if(h.scheme===I.scheme){if(h.scheme===A.Schemas.file)return S.isEqualOrParent(p(h),p(I),this._ignorePathCasing(h))&&h.query===I.query&&(D||h.fragment===I.fragment);if((0,e.isEqualAuthority)(h.authority,I.authority))return S.isEqualOrParent(h.path,I.path,this._ignorePathCasing(h),"/")&&h.query===I.query&&(D||h.fragment===I.fragment)}return!1}joinPath(h,...I){return R.URI.joinPath(h,...I)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let I;return h.scheme===A.Schemas.file?I=R.URI.file(L.dirname(p(h))).path:(I=L.posix.dirname(h.path),h.authority&&I.length&&I.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),I="/")),h.with({path:I})}normalizePath(h){if(!h.path.length)return h;let I;return h.scheme===A.Schemas.file?I=R.URI.file(L.normalize(p(h))).path:I=L.posix.normalize(h.path),h.with({path:I})}relativePath(h,I){if(h.scheme!==I.scheme||!(0,e.isEqualAuthority)(h.authority,I.authority))return;if(h.scheme===A.Schemas.file){const C=L.relative(p(h),p(I));return P.isWindows?S.toSlashes(C):C}let D=h.path||"/",b=I.path||"/";if(this._ignorePathCasing(h)){let C=0;for(const f=Math.min(D.length,b.length);C<f&&!(D.charCodeAt(C)!==b.charCodeAt(C)&&D.charAt(C).toLowerCase()!==b.charAt(C).toLowerCase());C++);D=b.substr(0,C)+D.substr(C)}return L.posix.relative(D,b)}resolvePath(h,I){if(h.scheme===A.Schemas.file){const D=R.URI.file(L.resolve(p(h),I));return h.with({authority:D.authority,path:D.path})}return I=S.toPosixPath(I),h.with({path:L.posix.resolve(h.path,I)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,I){return h===I||(0,k.equalsIgnoreCase)(h,I)}hasTrailingPathSeparator(h,I=L.sep){if(h.scheme===A.Schemas.file){const D=p(h);return D.length>S.getRoot(D).length&&D[D.length-1]===I}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,I=L.sep){return(0,e.hasTrailingPathSeparator)(h,I)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,I=L.sep){let D=!1;if(h.scheme===A.Schemas.file){const b=p(h);D=b!==void 0&&b.length===S.getRoot(b).length&&b[b.length-1]===I}else{I="/";const b=h.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,I)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(v=>v.scheme===A.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new w(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(v,h){const I=[];for(let D=0;D<v.length;D++){const b=h(v[D]);v.some((C,f)=>f===D?!1:(0,e.isEqualOrParent)(b,h(C)))||I.push(v[D])}return I}e.distinctParents=n;var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(I){const D=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,o]=f.split(":");a&&o&&D.set(a,o)});const C=I.path.substring(0,I.path.indexOf(";"));return C&&D.set(v.META_DATA_MIME,C),D}v.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function m(v,h,I){if(h){let D=v.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),v.with({scheme:I,authority:h,path:D})}return v.with({scheme:I})}e.toLocalResource=m}),define(Z[5],ee([0,1,29,11,3,2,15]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(M){return!!M&&typeof M.then=="function"}e.isThenable=P;function p(M){const F=new S.CancellationTokenSource,j=M(F.token),_=new Promise((N,W)=>{const z=F.token.onCancellationRequested(()=>{z.dispose(),F.dispose(),W((0,L.canceled)())});Promise.resolve(j).then(V=>{z.dispose(),F.dispose(),N(V)},V=>{z.dispose(),F.dispose(),W(V)})});return new class{cancel(){F.cancel()}then(N,W){return _.then(N,W)}catch(N){return this.then(void 0,N)}finally(N){return _.finally(N)}}}e.createCancelablePromise=p;function w(M,F,j){return Promise.race([M,new Promise(_=>F.onCancellationRequested(()=>_(j)))])}e.raceCancellation=w;async function n(M){let F=-1;const j=M.map((N,W)=>N.then(z=>(F=W,z))),_=await Promise.race(j);return M.forEach((N,W)=>{W!==F&&N.cancel()}),_}e.raceCancellablePromises=n;function y(M,F,j){let _;const N=setTimeout(()=>{_?.(void 0),j?.()},F);return Promise.race([M.finally(()=>clearTimeout(N)),new Promise(W=>_=W)])}e.raceTimeout=y;function m(M){return new Promise((F,j)=>{const _=M();P(_)?_.then(F,j):F(_)})}e.asPromise=m;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(j,j).then(_)})}return new Promise((j,_)=>{this.queuedPromise.then(j,_)})}return this.activePromise=F(),new Promise((j,_)=>{this.activePromise.then(N=>{this.activePromise=null,j(N)},N=>{this.activePromise=null,_(N)})})}}e.Throttler=v;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class I{constructor(){this.promiseMap=new Map}queue(F,j){const N=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(F)===N&&this.promiseMap.delete(F)});return this.promiseMap.set(F,N),N}}e.SequencerByKey=I;class D{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,j=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,N)=>{this.doResolve=_,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class b{constructor(F){this.delayer=new D(F),this.throttler=new v}trigger(F,j){return this.delayer.trigger(()=>this.throttler.queue(F),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class C{constructor(){this._isOpen=!1,this._promise=new Promise((F,j)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=C;class f extends C{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function a(M,F){return F?new Promise((j,_)=>{const N=setTimeout(()=>{W.dispose(),j()},M),W=F.onCancellationRequested(()=>{clearTimeout(N),W.dispose(),_((0,L.canceled)())})}):p(j=>a(M,j))}e.timeout=a;function o(M,F=0){const j=setTimeout(M,F);return(0,k.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=o;function t(M){const F=[];let j=0;const _=M.length;function N(){return j<_?M[j++]():null}function W(z){z!=null&&F.push(z);const V=N();return V?V.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=t;function r(M,F=_=>!!_,j=null){let _=0;const N=M.length,W=()=>{if(_>=N)return Promise.resolve(j);const z=M[_++];return Promise.resolve(z()).then(H=>F(H)?Promise.resolve(H):W())};return W()}e.first=r;function i(M,F=_=>!!_,j=null){if(M.length===0)return Promise.resolve(j);let _=M.length;const N=()=>{_=-1;for(const W of M)W.cancel?.()};return new Promise((W,z)=>{for(const V of M)V.then(H=>{--_>=0&&F(H)?(N(),W(H)):_===0&&W(j)}).catch(H=>{--_>=0&&(N(),z(H))})})}e.firstParallel=i;class s{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((j,_)=>{this.outstandingPromises.push({factory:F,c:j,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const j=F.factory();j.then(F.c,F.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class c{constructor(){this.queues=new Map}queueFor(F,j=A.extUri){const _=j.getComparisonKey(F);let N=this.queues.get(_);return N||(N=new u,R.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(_)}),this.queues.set(_,N)),N}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=c;class l{constructor(F,j){this._token=-1,typeof F=="function"&&typeof j=="number"&&this.setIfNotSet(F,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},j)}setIfNotSet(F,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},j))}}e.TimeoutTimer=l;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setInterval(()=>{F()},j)}}e.IntervalTimer=d;class E{constructor(F,j){this.timeoutToken=-1,this.runner=F,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class g extends E{constructor(F,j){super(F,j);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=g;class T extends k.Disposable{constructor(F,j,_,N){super();this.maxWorkChunkSize=F,this.maxPendingWork=j,this.throttleDelay=_,this.handler=N,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const j=setTimeout(()=>F(M));let _=!1;return{dispose(){_||(_=!0,clearTimeout(j))}}}}else e.runWhenIdle=(M,F)=>{const j=requestIdleCallback(M,typeof F=="number"?{timeout:F}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(j))}}}}();class O{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function $(M,F,j){let _;for(let N=0;N<j;N++)try{return await M()}catch(W){_=W,await a(F)}throw _}e.retry=$;class x{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,j,_){return this._pending={taskId:F,cancel:()=>_?.(),promise:j},j.then(()=>this.donePending(F),()=>this.donePending(F)),j}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let j,_;const N=new Promise((W,z)=>{j=W,_=z});this._next={run:F,promise:N,promiseResolve:j,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=x;class G{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,j)=>{this.completeCallback=F,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(j=>{this.completeCallback(F),this.resolved=!0,j()})}error(F){return new Promise(j=>{this.errorCallback(F),this.rejected=!0,j()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=B;var U;(function(M){async function F(j){let _;const N=await Promise.all(j.map(W=>W.then(z=>z,z=>{_||(_=z)})));if(typeof _!="undefined")throw _;return N}M.settled=F})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,19,42,8,38,5]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const p="**",w="/",n="[/\\\\]",y="[^/\\\\]",m=/\//g;function v(N){switch(N){case 0:return"";case 1:return`${y}*?`;default:return`(?:${n}|${y}+${n}|${n}${y}+)*?`}}function h(N,W){if(!N)return[];const z=[];let V=!1,H=!1,X="";for(const Q of N){switch(Q){case W:if(!V&&!H){z.push(X),X="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":H=!0;break;case"]":H=!1;break}X+=Q}return X&&z.push(X),z}e.splitGlobAware=h;function I(N){if(!N)return"";let W="";const z=h(N,w);if(z.every(V=>V===p))W=".*";else{let V=!1;z.forEach((H,X)=>{if(H===p){V||(W+=v(2),V=!0);return}let Q=!1,ie="",ne=!1,le="";for(const de of H){if(de!=="}"&&Q){ie+=de;continue}if(ne&&(de!=="]"||!le)){let ye;de==="-"?ye=de:(de==="^"||de==="!")&&!le?ye="^":de===w?ye="":ye=S.escapeRegExpCharacters(de),le+=ye;continue}switch(de){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":W+=`(?:${h(ie,",").map(Pe=>I(Pe)).join("|")})`,Q=!1,ie="";break;case"]":W+="["+le+"]",ne=!1,le="";break;case"?":W+=y;continue;case"*":W+=v(1);continue;default:W+=S.escapeRegExpCharacters(de)}}X<z.length-1&&(z[X+1]!==p||X+2<z.length)&&(W+=n),V=!1})}return W}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(N,W){if(!N)return i;let z;typeof N!="string"?z=N.pattern:z=N,z=z.trim();const V=`${z}_${!!W.trimForExclusions}`;let H=t.get(V);if(H)return u(H,N);let X;if(D.test(z)){const Q=z.substr(4);H=function(ie,ne){return typeof ie=="string"&&ie.endsWith(Q)?z:null}}else(X=b.exec(c(z,W)))?H=l(X[1],z):(W.trimForExclusions?f:C).test(z)?H=d(z,W):(X=a.exec(c(z,W)))?H=E(X[1].substr(1),z,!0):(X=o.exec(c(z,W)))?H=E(X[1],z,!1):H=g(z);return t.set(V,H),u(H,N)}function u(N,W){return typeof W=="string"?N:function(z,V){return L.isEqualOrParent(z,W.base)?N(R.relative(W.base,z),V):null}}function c(N,W){return W.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function l(N,W){const z=`/${N}`,V=`\\${N}`,H=function(Q,ie){return typeof Q!="string"?null:ie?ie===N?W:null:Q===N||Q.endsWith(z)||Q.endsWith(V)?W:null},X=[N];return H.basenames=X,H.patterns=[W],H.allBasenames=X,H}function d(N,W){const z=_(N.slice(1,-1).split(",").map(ie=>s(ie,W)).filter(ie=>ie!==i),N),V=z.length;if(!V)return i;if(V===1)return z[0];const H=function(ie,ne){for(let le=0,de=z.length;le<de;le++)if(z[le](ie,ne))return N;return null},X=z.find(ie=>!!ie.allBasenames);X&&(H.allBasenames=X.allBasenames);const Q=z.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(H.allPaths=Q),H}function E(N,W,z){const V=R.sep===R.posix.sep,H=V?N:N.replace(m,R.sep),X=R.sep+H,Q=R.posix.sep+N,ie=z?function(ne,le){return typeof ne=="string"&&(ne===H||ne.endsWith(X)||!V&&(ne===N||ne.endsWith(Q)))?W:null}:function(ne,le){return typeof ne=="string"&&(ne===H||!V&&ne===N)?W:null};return ie.allPaths=[(z?"*/":"./")+N],ie}function g(N){try{const W=new RegExp(`^${I(N)}$`);return function(z){return W.lastIndex=0,typeof z=="string"&&W.test(z)?N:null}}catch(W){return i}}function T(N,W,z){return!N||typeof W!="string"?!1:O(N)(W,void 0,z)}e.match=T;function O(N,W={}){if(!N)return r;if(typeof N=="string"||B(N)){const z=s(N,W);if(z===i)return r;const V=function(H,X){return!!z(H,X)};return z.allBasenames&&(V.allBasenames=z.allBasenames),z.allPaths&&(V.allPaths=z.allPaths),V}return F(N,W)}e.parse=O;function $(N){if(!N)return;let W;return z=>(W||(W=(N()||Promise.resolve([])).then(V=>V?G(V):{})),W.then(V=>!!V[z]))}e.hasSiblingPromiseFn=$;function x(N){if(!N)return;let W;return z=>{if(!W){const V=N();W=V?G(V):{}}return!!W[z]}}e.hasSiblingFn=x;function G(N){const W={};for(const z of N)W[z]=!0;return W}function B(N){const W=N;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=B;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function M(N){return N.allPaths||[]}e.getPathTerms=M;function F(N,W){const z=_(Object.getOwnPropertyNames(N).map(ie=>j(ie,N[ie],W)).filter(ie=>ie!==i)),V=z.length;if(!V)return i;if(!z.some(ie=>!!ie.requiresSiblings)){if(V===1)return z[0];const ie=function(de,ye){for(let pe=0,Pe=z.length;pe<Pe;pe++){const Te=z[pe](de,ye);if(Te)return Te}return null},ne=z.find(de=>!!de.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const le=z.reduce((de,ye)=>ye.allPaths?de.concat(ye.allPaths):de,[]);return le.length&&(ie.allPaths=le),ie}const H=function(ie,ne,le){let de;for(let ye=0,pe=z.length;ye<pe;ye++){const Pe=z[ye];Pe.requiresSiblings&&le&&(ne||(ne=R.basename(ie)),de||(de=ne.substr(0,ne.length-R.extname(ie).length)));const Te=Pe(ie,ne,de,le);if(Te)return Te}return null},X=z.find(ie=>!!ie.allBasenames);X&&(H.allBasenames=X.allBasenames);const Q=z.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(H.allPaths=Q),H}function j(N,W,z){if(W===!1)return i;const V=s(N,z);if(V===i)return i;if(typeof W=="boolean")return V;if(W){const H=W.when;if(typeof H=="string"){const X=(Q,ie,ne,le)=>{if(!le||!V(Q,ie))return null;const de=H.replace("$(basename)",ne),ye=le(de);return(0,A.isThenable)(ye)?ye.then(pe=>pe?N:null):ye?N:null};return X.requiresSiblings=!0,X}}return V}function _(N,W){const z=N.filter(ie=>!!ie.basenames);if(z.length<2)return N;const V=z.reduce((ie,ne)=>{const le=ne.basenames;return le?ie.concat(le):ie},[]);let H;if(W){H=[];for(let ie=0,ne=V.length;ie<ne;ie++)H.push(W)}else H=z.reduce((ie,ne)=>{const le=ne.patterns;return le?ie.concat(le):ie},[]);const X=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let de;for(de=ie.length;de>0;de--){const ye=ie.charCodeAt(de-1);if(ye===47||ye===92)break}ne=ie.substr(de)}const le=V.indexOf(ne);return le!==-1?H[le]:null};X.basenames=V,X.patterns=H,X.allBasenames=V;const Q=N.filter(ie=>!ie.basenames);return Q.push(X),Q}}),define(Z[93],ee([0,1,8,19,67,17,15]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let p=[],w=[],n=[];function y(r,i=!1){const s=m(r);p.push(s),s.userConfigured?n.push(s):w.push(s),i&&!s.userConfigured&&p.forEach(u=>{u.mime===s.mime||u.userConfigured||(s.extension&&u.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&u.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&u.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&u.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=y;function m(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(S.posix.sep)>=0:!1}}function v(r){r?(p=p.filter(i=>!i.userConfigured),n=[]):(p=[],w=[],n=[])}e.clearTextMimes=v;function h(r,i){let s;if(r)switch(r.scheme){case k.Schemas.file:s=r.fsPath;break;case k.Schemas.data:s=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:s=r.path}if(!s)return[P.unknown];s=s.toLowerCase();const u=(0,S.basename)(s),c=I(s,u,n);if(c)return[c,P.text];const l=I(s,u,w);if(l)return[l,P.text];if(i){const d=D(i);if(d)return[d,P.text]}return[P.unknown]}e.guessMimeTypes=h;function I(r,i,s){let u=null,c=null,l=null;for(let d=s.length-1;d>=0;d--){const E=s[d];if(i===E.filenameLowercase){u=E;break}if(E.filepattern&&(!c||E.filepattern.length>c.filepattern.length)){const g=E.filepatternOnPath?r:i;(0,R.match)(E.filepatternLowercase,g)&&(c=E)}E.extension&&(!l||E.extension.length>l.extension.length)&&i.endsWith(E.extensionLowercase)&&(l=E)}return u?u.mime:c?c.mime:l?l.mime:null}function D(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=p.length-1;i>=0;i--){const s=p[i];if(!s.firstline)continue;const u=r.match(s.firstline);if(u&&u.length>0)return s.mime}return null}function b(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const i=(0,S.extname)(r);return C[i.toLowerCase()]}e.getMediaMime=f;function a(r){for(const i in C)if(C[i]===r)return i}e.getExtensionForMimeType=a;const o=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const s=o.exec(r);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[94],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class R{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:L(S.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:L(S.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:S.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,y,m){if(!n||m>200)return null;if(typeof n=="object"){if(n instanceof S.URI)return y.transformOutgoing(n);for(let v in n)if(Object.hasOwnProperty.call(n,v)){const h=k(n[v],y,m+1);h!==null&&(n[v]=h)}}return null}function A(n,y){const m=k(n,y,0);return m===null?n:m}e.transformOutgoingURIs=A;function P(n,y,m,v){if(!n||v>200)return null;if(typeof n=="object"){if(n.$mid===1)return m?S.URI.revive(y.transformIncoming(n)):y.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const I=P(n[h],y,m,v+1);I!==null&&(n[h]=I)}}return null}function p(n,y){const m=P(n,y,!1,0);return m===null?n:m}e.transformIncomingURIs=p;function w(n,y){const m=P(n,y,!0,0);return m===null?n:m}e.transformAndReviveIncomingURIs=w}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(p){return S.test(p)}e.isUUID=L;const R=new Uint8Array(16),k=[];for(let p=0;p<256;p++)k.push(p.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let w=0;w<p.length;w++)p[w]=Math.floor(Math.random()*256);return p};function P(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,w="";return w+=k[R[p++]],w+=k[R[p++]],w+=k[R[p++]],w+=k[R[p++]],w+="-",w+=k[R[p++]],w+=k[R[p++]],w+="-",w+=k[R[p++]],w+=k[R[p++]],w+="-",w+=k[R[p++]],w+=k[R[p++]],w+="-",w+=k[R[p++]],w+=k[R[p++]],w+=k[R[p++]],w+=k[R[p++]],w+=k[R[p++]],w+=k[R[p++]],w}e.generateUuid=P}),define(Z[68],ee([0,1,211]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new S.StringDecoder(k),this.remaining=null}write(k){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return A;let p=0,w,n=p;for(;n<P.length;)if(w=P.charCodeAt(n),w===13||w===10){if(A.push(P.substring(p,n)),n++,n<P.length){const y=w;w=P.charCodeAt(n),(y===13&&w===10||y===10&&w===13)&&n++}p=n}else n++;return this.remaining=p<P.length?P.substr(p):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(Z[95],ee([0,1,35]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const p=P.replace(/\-/g,":").toLowerCase();return!L.has(p)}function k(){return new Promise(async(P,p)=>{const w=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(n){p(n)}finally{clearTimeout(w)}})}e.getMac=k;function A(){return new Promise((P,p)=>{try{const w=(0,S.networkInterfaces)();for(let n in w){const y=w[n];if(y){for(const{mac:m}of y)if(R(m))return P(m)}}p("Unable to retrieve mac address (unexpected format)")}catch(w){p(w)}})}}),define(Z[96],ee([0,1,11,30,35,38,95]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,y=0;const m=(0,R.networkInterfaces)();for(let v in m){const h=m[v];if(h)for(const{mac:I,internal:D}of h)D||(y+=1,this._isVirtualMachineMacAdress(I.toUpperCase())&&(n+=1))}this._value=y>0?n/y:0}return this._value}};let P;async function p(){return P||(P=(async()=>await w()||L.generateUuid())()),P}e.getMachineId=p;async function w(){try{const n=await new Promise((m,v)=>{K(["crypto"],m,v)}),y=await(0,A.getMac)();return n.createHash("sha256").update(y,"utf8").digest("hex")}catch(n){S.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,50,35,212,8,5,7,42,30,66,15,4]),function(K,e,S,L,R,k,A,P,p,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(U,M=v.UNLINK){if((0,p.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return M===v.UNLINK?D(U):I(U)}async function I(U){try{const M=(0,k.join)((0,L.tmpdir)(),(0,w.generateUuid)());try{await e.Promises.rename(U,M)}catch(F){return D(U)}D(M).catch(F=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function D(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,p.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function C(U,M){return o(await(M?f(U):(0,R.promisify)(S.readdir)(U)))}async function f(U){try{return await(0,R.promisify)(S.readdir)(U,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const M=[],F=await C(U);for(const j of F){let _=!1,N=!1,W=!1;try{const z=await e.Promises.lstat((0,k.join)(U,j));_=z.isFile(),N=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}M.push({name:j,isFile:()=>_,isDirectory:()=>N,isSymbolicLink:()=>W})}return M}function a(U){return o(S.readdirSync(U))}e.readdirSync=a;function o(U){return U.map(M=>typeof M=="string"?P.isMacintosh?(0,n.normalizeNFC)(M):M:(M.name=P.isMacintosh?(0,n.normalizeNFC)(M.name):M.name,M))}async function t(U){const M=await C(U),F=[];for(const j of M)await i.existsDirectory((0,k.join)(U,j))&&F.push(j);return F}function r(U,M=1e3){return new Promise(F=>{let j=!1;const _=setInterval(()=>{j||(j=!0,S.access(U,N=>{j=!1,N&&(clearInterval(_),F(void 0))}))},M)})}e.whenDeleted=r;var i;(function(U){async function M(_){let N;try{if(N=await e.Promises.lstat(_),!N.isSymbolicLink())return{stat:N}}catch(W){}try{return{stat:await e.Promises.stat(_),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(P.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw z}throw W}}U.stat=M;async function F(_){try{const{stat:N,symbolicLink:W}=await U.stat(_);return N.isFile()&&W?.dangling!==!0}catch(N){}return!1}U.existsFile=F;async function j(_){try{const{stat:N,symbolicLink:W}=await U.stat(_);return N.isDirectory()&&W?.dangling!==!0}catch(N){}return!1}U.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function u(U,M,F){return s.queueFor(m.URI.file(U),y.extUriBiasedIgnorePathCase).queue(()=>{const j=E(F);return new Promise((_,N)=>l(U,M,j,W=>W?N(W):_()))})}let c=!0;function l(U,M,F,j){if(!c)return S.writeFile(U,M,{mode:F.mode,flag:F.flag},j);S.open(U,F.flag,F.mode,(_,N)=>{if(_)return j(_);S.writeFile(N,M,W=>{if(W)return S.close(N,()=>j(W));S.fdatasync(N,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c=!1),S.close(N,V=>j(V))))})})}function d(U,M,F){const j=E(F);if(!c)return S.writeFileSync(U,M,{mode:j.mode,flag:j.flag});const _=S.openSync(U,j.flag,j.mode);try{S.writeFileSync(_,M);try{S.fdatasyncSync(_)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c=!1}}finally{S.closeSync(_)}}e.writeFileSync=d;function E(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function g(U,M){if(U===M)return;async function F(j){try{const _=await e.Promises.lstat(j);if(_.isDirectory()||_.isSymbolicLink())return;await e.Promises.utimes(j,_.atime,new Date)}catch(_){}}try{await e.Promises.rename(U,M),await F(M)}catch(j){if(U.toLowerCase()!==M.toLowerCase()&&j.code==="EXDEV"||U.endsWith("."))await T(U,M,{preserveSymlinks:!1}),await h(U,v.MOVE),await F(M);else throw j}}async function T(U,M,F){return $(U,M,{root:{source:U,target:M},options:F,handledSourcePaths:new Set})}const O=511;async function $(U,M,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:j,symbolicLink:_}=await i.stat(U);if(_){if(F.options.preserveSymlinks)try{return await B(U,M,F)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(_.dangling)return}return j.isDirectory()?x(U,M,j.mode&O,F):G(U,M,j.mode&O)}async function x(U,M,F,j){await e.Promises.mkdir(M,{recursive:!0,mode:F});const _=await C(U);for(const N of _)await $((0,k.join)(U,N),(0,k.join)(M,N),j)}async function G(U,M,F){await e.Promises.copyFile(U,M),await e.Promises.chmod(M,F)}async function B(U,M,F){let j=await e.Promises.readlink(U);(0,p.isEqualOrParent)(j,F.root.source,!P.isLinux)&&(j=(0,k.join)(F.root.target,j.substr(F.root.source.length+1))),await e.Promises.symlink(j,M)}e.Promises=new class{get access(){return(0,R.promisify)(S.access)}get stat(){return(0,R.promisify)(S.stat)}get lstat(){return(0,R.promisify)(S.lstat)}get utimes(){return(0,R.promisify)(S.utimes)}get read(){return(0,R.promisify)(S.read)}get readFile(){return(0,R.promisify)(S.readFile)}get write(){return(0,R.promisify)(S.write)}get appendFile(){return(0,R.promisify)(S.appendFile)}get fdatasync(){return(0,R.promisify)(S.fdatasync)}get truncate(){return(0,R.promisify)(S.truncate)}get rename(){return(0,R.promisify)(S.rename)}get copyFile(){return(0,R.promisify)(S.copyFile)}get open(){return(0,R.promisify)(S.open)}get close(){return(0,R.promisify)(S.close)}get symlink(){return(0,R.promisify)(S.symlink)}get readlink(){return(0,R.promisify)(S.readlink)}get chmod(){return(0,R.promisify)(S.chmod)}get mkdir(){return(0,R.promisify)(S.mkdir)}get unlink(){return(0,R.promisify)(S.unlink)}get rmdir(){return(0,R.promisify)(S.rmdir)}get realpath(){return(0,R.promisify)(S.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return h}get move(){return g}get copy(){return T}}}),define(Z[97],ee([0,1,50,19,8,18]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const y=(0,R.dirname)(n);if(n===y)return n;const m=((0,R.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(y).filter(I=>I.toLowerCase()===m);if(h.length===1){const I=A(y);if(I)return(0,R.join)(I,h[0])}else if(h.length>1){const I=h.indexOf(m);if(I>=0){const D=A(y);if(D)return(0,R.join)(D,h[I])}}}catch(v){}return null}e.realcaseSync=A;async function P(n){try{return await k.Promises.realpath(n)}catch(y){const m=w(n);return await k.Promises.access(m,S.constants.R_OK),m}}e.realpath=P;function p(n){try{return S.realpathSync(n)}catch(y){const m=w(n);return S.accessSync(m,S.constants.R_OK),m}}e.realpathSync=p;function w(n){return(0,L.rtrim)((0,R.normalize)(n),R.sep)}}),define(Z[98],ee([0,1,18,35,8]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(p||(p={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class y{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:o=!1}={}){const t=m({useAlternateBitness:a});if(!t)return null;const r=R.join(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const l of await S.Promises.readdir(r)){let d=-1;if(o){const g=l.indexOf("-");if(g<0)continue;const T=l.substring(0,g);if(!k.test(T)||l.substring(g+1)!=="preview")continue;d=parseInt(T,10)}else{if(!k.test(l))continue;d=parseInt(l,10)}if(d<=i)continue;const E=R.join(r,l,"pwsh.exe");!await S.SymlinkSupport.existsFile(E)||(s=E,i=d)}if(!s)return null;const u=t.includes("x86")?" (x86)":"",c=o?" Preview":"";return new y(s,`PowerShell${c}${u}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const o=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(o))if(t.test(i)){const s=R.join(o,i,"pwsh.exe");return new y(s,r)}return null}function I(){const a=R.join(L.homedir(),".dotnet","tools","pwsh.exe");return new y(a,".NET Core PowerShell Global Tool")}function D(){const a=R.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(a,"Windows PowerShell",!0)}async function*b(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=I(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=D(),a&&(yield a)}async function*C(){for await(const a of b())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=C;async function f(){for await(const a of C())return a;return null}e.getFirstAvailablePowerShellInstallation=f}),define(Z[99],ee([0,1,43,17]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(A){return new Promise((P,p)=>{let w;const n=new Map;function y(v,h,I,D,b){const C=n.get(h);if(v===A||C){const f={name:m(I),cmd:I,pid:v,ppid:h,load:D,mem:b};n.set(v,f),v===A&&(w=f),C&&(C.children||(C.children=[]),C.children.push(f),C.children.length>1&&(C.children=C.children.sort((a,o)=>a.pid-o.pid)))}}function m(v){const h=/--disable-blink-features=Auxclick/,I=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,C=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(I.exec(v))return"watcherService ";if(D.exec(v))return"electron-crash-reporter";if(b.exec(v))return"winpty-process";if(C.exec(v))return"console-window-host (Windows internal process)";let a=f.exec(v);if(a&&a.length===2)return a[1]==="renderer"?h.exec(v)?"shared-process":"window":a[1];const o=/[a-zA-Z-]+\.js/g;let t="";do a=o.exec(v),a&&(t+=a+" ");while(a);return t&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${t}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,I)=>{K(["windows-process-tree"],h,I)}).then(h=>{h.getProcessList(A,I=>{h.getProcessCpuUsage(I,D=>{const b=new Map;D.forEach(C=>{const f=v(C.commandLine||"");b.set(C.pid,{name:m(f),cmd:f,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),w=b.get(A),w?(b.forEach(C=>{const f=b.get(C.ppid);f&&(f.children||(f.children=[]),f.children.push(C))}),b.forEach(C=>{C.children&&(C.children=C.children.sort((f,a)=>f.pid-a.pid))}),P(w)):p(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[w];const I=[];for(;h.length;){const b=h.shift();b&&(I.push(b.pid),b.children&&(h=h.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);D+=" "+I.join(" "),(0,S.exec)(D,{},(b,C,f)=>{if(b||f)p(b||new Error(f.toString()));else{const a=C.toString().split(`
`);for(let o=0;o<I.length;o++){const t=n.get(I[o]);t.load=parseFloat(a[o])}if(!w){p(new Error(`Root process ${A} not found`));return}P(w)}})};(0,S.exec)("which ps",{},(h,I,D)=>{if(h||D)if(process.platform!=="linux")p(h||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,S.exec)(b,{},(C,f,a)=>{C||a?p(C||new Error(a.toString())):(k(f,y),v())})}else{const b=I.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${b} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,a,o)=>{f||o&&!o.includes("screen size is bogus")?p(f||new Error(o.toString())):(k(a,y),process.platform==="linux"?v():w?P(w):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=R;function k(A,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const n of w){const y=p.exec(n.trim());y&&y.length===6&&P(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Z[100],ee([0,1,8,50,7,66,2,18]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(y,m,v){return n({path:y,isDirectory:!1},m,v)}e.watchFile=p;function w(y,m,v){return n({path:y,isDirectory:!0},m,v)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(y,m,v){const h=(0,S.basename)(y.path),I=new Map;let D=!1,b=[(0,A.toDisposable)(()=>{I.forEach(C=>(0,A.dispose)(C)),I.clear()})];try{const C=(0,L.watch)(y.path);b.push((0,A.toDisposable)(()=>{C.removeAllListeners(),C.close()}));const f=new Set;y.isDirectory&&P.Promises.readdir(y.path).then(a=>a.forEach(o=>f.add(o))),C.on("error",(a,o)=>{D||v(`Failed to watch ${y.path} for changes using fs.watch() (${a}, ${o})`)}),C.on("change",(a,o)=>{if(D)return;let t="";if(o&&(t=o.toString(),R.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const r=y.isDirectory?(0,S.join)(y.path,t):y.path;if(y.isDirectory)if(a==="rename"){const i=I.get(r);i&&(0,A.dispose)(i);const s=setTimeout(async()=>{I.delete(r);const u=await P.Promises.exists(r);if(D)return;let c;u?f.has(t)?c="changed":(c="added",f.add(t)):(f.delete(t),c="deleted"),m(c,r)},e.CHANGE_BUFFER_DELAY);I.set(r,(0,A.toDisposable)(()=>clearTimeout(s)))}else{let i;f.has(t)?i="changed":(i="added",f.add(t)),m(i,r)}else if(a==="rename"||t!==h){const i=setTimeout(async()=>{const s=await P.Promises.exists(r);D||(s?(m("changed",r),b=[n(y,m,v)]):m("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else m("changed",r)})}catch(C){P.Promises.exists(y.path).then(f=>{f&&!D&&v(`Failed to watch ${y.path} for changes using fs.watch() (${C.toString()})`)})}return(0,A.toDisposable)(()=>{D=!0,b=(0,A.dispose)(b)})}});var fe=this&&this.__decorate||function(K,e,S,L){var R=arguments.length,k=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,S):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(K,e,S,L);else for(var P=K.length-1;P>=0;P--)(A=K[P])&&(k=(R<3?A(k):R>3?A(e,S,k):A(e,S))||k);return R>3&&k&&Object.defineProperty(e,S,k),k};define(Z[36],ee([0,1,3,2,5,29,11,25,23,16,92,19,64]),function(K,e,S,L,R,k,A,P,p,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(I=e.ResponseType||(e.ResponseType={}));function D(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(b||(b={}));class C{constructor(N){this.buffer=N,this.pos=0}read(N){const W=this.buffer.slice(this.pos,this.pos+N);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var a;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(a||(a={}));function o(_){const N=P.VSBuffer.alloc(4);return N.writeUInt32BE(_,0),N}function t(_){return _.read(4).readUInt32BE(0)}function r(_){const N=P.VSBuffer.alloc(1);return N.writeUInt8(_,0),N}const i={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},s=typeof Buffer!="undefined";function u(_,N){if(typeof N=="undefined")_.write(i.Undefined);else if(typeof N=="string"){const W=P.VSBuffer.fromString(N);_.write(i.String),_.write(o(W.byteLength)),_.write(W)}else if(s&&Buffer.isBuffer(N)){const W=P.VSBuffer.wrap(N);_.write(i.Buffer),_.write(o(W.byteLength)),_.write(W)}else if(N instanceof P.VSBuffer)_.write(i.VSBuffer),_.write(o(N.byteLength)),_.write(N);else if(Array.isArray(N)){_.write(i.Array),_.write(o(N.length));for(const W of N)u(_,W)}else{const W=P.VSBuffer.fromString(JSON.stringify(N));_.write(i.Object),_.write(o(W.byteLength)),_.write(W)}}function c(_){switch(_.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return _.read(t(_)).toString();case a.Buffer:return _.read(t(_)).buffer;case a.VSBuffer:return _.read(t(_));case a.Array:{const W=t(_),z=[];for(let V=0;V<W;V++)z.push(c(_));return z}case a.Object:return JSON.parse(_.read(t(_)).toString())}}class l{constructor(N,W,z=null,V=1e3){this.protocol=N,this.ctx=W,this.logger=z,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(N,W){this.channels.set(N,W),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const W=this.send([N.type]);this.logger&&this.logger.logOutgoing(W,0,1,D(N.type));return}case 201:case 202:case 204:case 203:{const W=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(W,N.id,1,D(N.type),N.data);return}}}send(N,W=void 0){const z=new f;return u(z,N),u(z,W),this.sendBuffer(z.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onRawMessage(N){const W=new C(N),z=c(W),V=c(W),H=z[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,z[1],1,`${h(H)}: ${z[2]}.${z[3]}`,V),this.onPromise({type:H,id:z[1],channelName:z[2],name:z[3],arg:V});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,z[1],1,`${h(H)}: ${z[2]}.${z[3]}`,V),this.onEventListen({type:H,id:z[1],channelName:z[2],name:z[3],arg:V});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,z[1],1,`${h(H)}`),this.disposeActiveRequest({type:H,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,z[1],1,`${h(H)}`),this.disposeActiveRequest({type:H,id:z[1]})}}onPromise(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const z=new k.CancellationTokenSource;let V;try{V=W.call(this.ctx,N.name,N.arg,z.token)}catch(Q){V=Promise.reject(Q)}const H=N.id;V.then(Q=>{this.sendResponse({id:H,data:Q,type:201}),this.activeRequests.delete(N.id)},Q=>{Q instanceof Error?this.sendResponse({id:H,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:H,data:Q,type:203}),this.activeRequests.delete(N.id)});const X=(0,L.toDisposable)(()=>z.cancel());this.activeRequests.set(N.id,X)}onEventListen(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const z=N.id,H=W.listen(this.ctx,N.name,N.arg)(X=>this.sendResponse({id:z,data:X,type:204}));this.activeRequests.set(N.id,H)}disposeActiveRequest(N){const W=this.activeRequests.get(N.id);W&&(W.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let W=this.pendingRequests.get(N.channelName);W||(W=[],this.pendingRequests.set(N.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:N,timeoutTimer:z})}flushPendingRequests(N){const W=this.pendingRequests.get(N);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var d;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,W=null){this.protocol=N,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(N){const W=this;return{call(z,V,H){return W.isDisposed?Promise.reject(A.canceled()):W.requestPromise(N,z,V,H)},listen(z,V){return W.isDisposed?Promise.reject(A.canceled()):W.requestEvent(N,z,V)}}}requestPromise(N,W,z,V=k.CancellationToken.None){const H=this.lastRequestId++,Q={id:H,type:100,channelName:N,name:W,arg:z};if(V.isCancellationRequested)return Promise.reject(A.canceled());let ie;return new Promise((le,de)=>{if(V.isCancellationRequested)return de(A.canceled());const ye=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(H),le(Oe.data);break;case 202:this.handlers.delete(H);const Le=new Error(Oe.data.message);Le.stack=Oe.data.stack,Le.name=Oe.data.name,de(Le);break;case 203:this.handlers.delete(H),de(Oe.data);break}};this.handlers.set(H,Ne),this.sendRequest(Q)};let pe=null;this.state===b.Idle?ye():(pe=(0,R.createCancelablePromise)(Ne=>this.whenInitialized()),pe.then(()=>{pe=null,ye()}));const Pe=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:H,type:101}),de(A.canceled())},Te=V.onCancellationRequested(Pe);ie=(0,L.combinedDisposable)((0,L.toDisposable)(Pe),Te),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(N,W,z){const V=this.lastRequestId++,X={id:V,type:102,channelName:N,name:W,arg:z};let Q=null;const ie=new S.Emitter({onFirstListenerAdd:()=>{Q=(0,R.createCancelablePromise)(le=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:V,type:103}))}}),ne=le=>ie.fire(le.data);return this.handlers.set(V,ne),ie.event}sendRequest(N){switch(N.type){case 100:case 102:{const W=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(W,N.id,0,`${h(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const W=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(W,N.id,0,h(N.type));return}}}send(N,W=void 0){const z=new f;return u(z,N),u(z,W),this.sendBuffer(z.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onBuffer(N){const W=new C(N),z=c(W),V=c(W),H=z[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,D(H)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,z[1],0,D(H),V),this.onResponse({type:z[0],id:z[1],data:V})}}onResponse(N){if(N.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(N.id);W&&W(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}fe([m.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class g{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:W,onDidClientDisconnect:z})=>{S.Event.once(W.onMessage)(H=>{const X=new C(H),Q=c(X),ie=new l(W,Q),ne=new E(W);this.channels.forEach((de,ye)=>ie.registerChannel(ye,de));const le={channelServer:ie,channelClient:ne,ctx:Q};this._connections.add(le),this._onDidAddConnection.fire(le),z(()=>{ie.dispose(),ne.dispose(),this._connections.delete(le),this._onDidRemoveConnection.fire(le)})})})}get connections(){const N=[];return this._connections.forEach(W=>N.push(W)),N}getChannel(N,W){const z=this;return{call(V,H,X){let Q;if((0,w.isFunction)(W)){let ne=(0,p.getRandomElement)(z.connections.filter(W));Q=ne?Promise.resolve(ne):S.Event.toPromise(S.Event.filter(z.onDidAddConnection,W))}else Q=W.routeCall(z,V,H);const ie=Q.then(ne=>ne.channelClient.getChannel(N));return O(ie).call(V,H,X)},listen(V,H){if((0,w.isFunction)(W))return z.getMulticastEvent(N,W,V,H);const X=W.routeEvent(z,V,H).then(Q=>Q.channelClient.getChannel(N));return O(X).listen(V,H)}}}getMulticastEvent(N,W,z,V){const H=this;let X=new L.DisposableStore;const Q=new S.Emitter({onFirstListenerAdd:()=>{X=new L.DisposableStore;const ie=new S.EventMultiplexer,ne=new Map,le=ye=>{const Pe=ye.channelClient.getChannel(N).listen(z,V),Te=ie.add(Pe);ne.set(ye,Te)},de=ye=>{const pe=ne.get(ye);!pe||(pe.dispose(),ne.delete(ye))};H.connections.filter(W).forEach(le),S.Event.filter(H.onDidAddConnection,W)(le,void 0,X),H.onDidRemoveConnection(de,void 0,X),ie.event(Q.fire,Q,X),X.add(ie)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(N,W){this.channels.set(N,W),this._connections.forEach(z=>{z.channelServer.registerChannel(N,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class T{constructor(N,W,z=null){const V=new f;u(V,W),N.send(V.buffer),this.channelClient=new E(N,z),this.channelServer=new l(N,W,z)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,W){this.channelServer.registerChannel(N,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(_){return{call(N,W,z){return _.then(V=>V.call(N,W,z))},listen(N,W){const z=new S.Relay;return _.then(V=>z.input=V.listen(N,W)),z.event}}}e.getDelayedChannel=O;function $(_){let N=!1;return{call(W,z,V){return N?_.call(W,z,V):(0,R.timeout)(0).then(()=>N=!0).then(()=>_.call(W,z,V))},listen(W,z){if(N)return _.listen(W,z);const V=new S.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>V.input=_.listen(W,z)),V.event}}}e.getNextTickChannel=$;class x{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const W of N.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=x;var G;(function(_){function N(V,H){const X=V,Q=H&&H.disableMarshalling,ie=new Map;for(const ne in X)z(ne)&&ie.set(ne,S.Event.buffer(X[ne],!0));return new class{listen(ne,le){const de=ie.get(le);if(de)return de;throw new Error(`Event not found: ${le}`)}call(ne,le,de){const ye=X[le];if(typeof ye=="function"){if(!Q&&Array.isArray(de))for(let pe=0;pe<de.length;pe++)de[pe]=(0,n.revive)(de[pe]);return ye.apply(X,de)}throw new Error(`Method not found: ${le}`)}}}_.fromService=N;function W(V,H){const X=H&&H.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return H?.properties?.has(ie)?H.properties.get(ie):z(ie)?V.listen(ie):async function(...ne){let le;H&&!(0,w.isUndefinedOrNull)(H.context)?le=[H.context,...ne]:le=ne;const de=await V.call(ie,le);return X?de:(0,n.revive)(de)};throw new Error(`Property not found: ${String(ie)}`)}})}_.toService=W;function z(V){return V[0]==="o"&&V[1]==="n"&&y.isUpperAsciiLetter(V.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let N=_.toString();if(N!=="[object Object]")return N}return _}function M(_){return Array.isArray(_)?_.map(U):U(_)}function F(_,N,W,z,V,H,X){X=M(X);const Q=B[V],ie=Q[z%Q.length];let ne=[`%c[${_}]%c[${String(N).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(H)?(ne=ne.concat(X),ne.push(")")):ne.push(X),console.log.apply(console,ne)}e.logWithColors=F;class j{constructor(N,W){this._outgoingPrefix=N,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,W,z,V,H){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,W,z,V,H)}logIncoming(N,W,z,V,H){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,W,z,V,H)}}e.IPCLogger=j}),define(Z[101],ee([0,1,3,36,25]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(p){this.port=p,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",w=>R.VSBuffer.wrap(w.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends L.IPCClient{constructor(p,w){const n=new k(p);super(n,w);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[102],ee([0,1,103,3,36,101]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends R.IPCServer{static getOnDidClientConnect(){const p=L.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(w,n)=>n);return L.Event.map(p,w=>{const{port1:n,port2:y}=new MessageChannel,v={protocol:new k.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[y]),v})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[104],ee([0,1,11,25]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,p){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((n,y)=>{w.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(w,P),w.responseType="arraybuffer",w.onerror=m=>y(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=m=>{n({res:{statusCode:w.status,headers:A(w)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=m=>y(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(w.timeout=P.timeout),w.send(P.data),p.onCancellationRequested(()=>{w.abort(),y((0,S.canceled)())})})}e.request=R;function k(P,p){if(p.headers){e:for(let w in p.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(w,p.headers[w])}}}function A(P){const p=Object.create(null);for(const w of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const n=w.indexOf(":");p[w.substr(0,n).trim().toLowerCase()]=w.substr(n+1).trim()}return p}}),define(Z[69],ee([0,1,2,3,5,16]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class p extends S.Disposable{constructor(y,m=Object.create(null)){super();this.database=y,this.options=m,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((m,v)=>this.accept(v,m)),y.deleted?.forEach(m=>this.accept(m,void 0))}accept(y,m){if(this.state===P.Closed)return;let v=!1;(0,k.isUndefinedOrNull)(m)?v=this.cache.delete(y):this.cache.get(y)!==m&&(this.cache.set(y,m),v=!0),v&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,m){const v=this.cache.get(y);return(0,k.isUndefinedOrNull)(v)?m:v}getBoolean(y,m){const v=this.get(y);return(0,k.isUndefinedOrNull)(v)?m:v==="true"}getNumber(y,m){const v=this.get(y);return(0,k.isUndefinedOrNull)(v)?m:parseInt(v,10)}async set(y,m){if(this.state===P.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(y);const v=String(m);if(this.cache.get(y)!==v)return this.cache.set(y,v),this.pendingInserts.set(y,v),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===P.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((m,v)=>this.items.set(v,m)),y.delete&&y.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=w}),define(Z[105],ee([12,13]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,105]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,k=R*24,A=k*7,P=k*30,p=k*365;function w(y,m){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,S.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(v<30)return(0,S.localize)(1,null);let h;return v<L?(h=v,m?h===1?(0,S.localize)(2,null,h):(0,S.localize)(3,null,h):h===1?(0,S.localize)(4,null,h):(0,S.localize)(5,null,h)):v<R?(h=Math.floor(v/L),m?h===1?(0,S.localize)(6,null,h):(0,S.localize)(7,null,h):h===1?(0,S.localize)(8,null,h):(0,S.localize)(9,null,h)):v<k?(h=Math.floor(v/R),m?h===1?(0,S.localize)(10,null,h):(0,S.localize)(11,null,h):h===1?(0,S.localize)(12,null,h):(0,S.localize)(13,null,h)):v<A?(h=Math.floor(v/k),m?h===1?(0,S.localize)(14,null,h):(0,S.localize)(15,null,h):h===1?(0,S.localize)(16,null,h):(0,S.localize)(17,null,h)):v<P?(h=Math.floor(v/A),m?h===1?(0,S.localize)(18,null,h):(0,S.localize)(19,null,h):h===1?(0,S.localize)(20,null,h):(0,S.localize)(21,null,h)):v<p?(h=Math.floor(v/P),m?h===1?(0,S.localize)(22,null,h):(0,S.localize)(23,null,h):h===1?(0,S.localize)(24,null,h):(0,S.localize)(25,null,h)):(h=Math.floor(v/p),m?h===1?(0,S.localize)(26,null,h):(0,S.localize)(27,null,h):h===1?(0,S.localize)(28,null,h):(0,S.localize)(29,null,h))}e.fromNow=w;function n(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[106],ee([12,13]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[39],ee([0,1,106,16,23]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(w,n){return n&&(w.stack||w.stacktrace)?S.localize(0,null,P(w),A(w.stack)||A(w.stacktrace)):P(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function p(w=null,n=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const y=R.coalesce(w),m=p(y[0],n);return y.length>1?S.localize(4,null,m,y.length):m}if(L.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return k(y.error,n);if(y.exception)return k(y.exception,n)}return w.stack?k(w,n):w.message?w.message:S.localize(5,null)}e.toErrorMessage=p}),define(Z[107],ee([12,13]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[108],ee([0,1,8,18,43,107,34,16,26,42,7,68,17]),function(K,e,S,L,R,k,A,P,p,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,o){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};o&&(t.cwd=o);const r=R.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,u)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?v(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{R.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,s,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function I(a=A.env){return a.comspec||"cmd.exe"}e.getWindowsShell=I;class D{constructor(o,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=o,this.args=t,this.shell=r,this.options=i;else{const s=o;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(A.env).forEach(u=>{s[u]=A.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const t=o.lastIndexOf(S.sep);return t!==-1&&(o=o.substring(t+1)),D.WellKnowCommands[o]?o:"other"}start(o){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((u,c)=>{r=u,i=c});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=R.exec(u,this.options,(c,l,d)=>{this.childProcess=null;const E=c;E&&E.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:d.toString()}):this.handleExec(r,o,c,l,d)})}else{let u=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,o,i);const d={terminated:this.terminateRequested};P.isNumber(l)&&(d.cmdCode=l),r(d)};if(this.shell&&n.isWindows){const l=p.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let d=!1,E=!1;const g=[];let T=this.ensureQuotes(this.cmd);g.push(T.value),d=T.quoted,this.args&&this.args.forEach($=>{T=this.ensureQuotes($),g.push(T.value),E=E&&T.quoted});const O=["/s","/c"];d?E?O.push('"'+g.join(" ")+'"'):g.length>1?O.push('"'+g[0]+'" '+g.slice(1).join(" ")):O.push('"'+g[0]+'"'):O.push(g.join(" ")),u=R.spawn(I(),O,l)}else this.cmd&&(u=R.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(P.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",c),this.handleSpawn(u,r,o,i,!0)))}return s})}handleClose(o,t,r,i){}ensureQuotes(o){return D.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,h(o,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!n.isWindows)return o(!1);const t=R.spawn(I(),["/s","/c"]);t.on("error",r=>o(!0)),t.on("exit",r=>o(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(o,t,r,i){super(o,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,t,r,i,s){[i,s].forEach((u,c)=>{const l=new y.LineDecoder;l.write(u).forEach(g=>{t({line:g,source:c===0?0:1})});const E=l.end();E&&t({line:E,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,t,r,i,s){const u=new y.LineDecoder,c=new y.LineDecoder;o.stdout.on("data",l=>{u.write(l).forEach(E=>r({line:E,source:0}))}),o.stderr.on("data",l=>{c.write(l).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=c}handleClose(o,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=b;function C(a){let o=[],t=!1;const r=function(i){if(t){o.push(i);return}(!a.send(i,u=>{if(u&&console.error(u),t=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=C;var f;(function(a){async function o(t,r,i){if(S.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),S.dirname(t)!=="."||(i===void 0&&P.isString(A.env.PATH)&&(i=A.env.PATH.split(S.delimiter)),i===void 0||i.length===0))return S.join(r,t);async function u(c){return await L.Promises.exists(c)?!(await L.Promises.stat(c)).isDirectory():!1}for(let c of i){let l;if(S.isAbsolute(c)?l=S.join(c,t):l=S.join(r,c,t),await u(l))return l;let d=l+".com";if(await u(d)||(d=l+".exe",await u(d)))return d}return S.join(r,t)}a.findExecutable=o})(f=e.win32||(e.win32={}))}),define(Z[51],ee([0,1,43,2,5,26,3,108,36,91,29,11,25,7]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends p.ChannelServer{constructor(b){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(f){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",C=>m.VSBuffer.wrap(Buffer.from(C,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class I{constructor(b,C){this.modulePath=b,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new R.Delayer(f),this.child=null,this._client=null}getChannel(b){const C=this;return{call(f,a,o){return C.requestPromise(b,f,a,o)},listen(f,a){return C.requestEvent(b,f,a)}}}requestPromise(b,C,f,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(b),t=(0,R.createCancelablePromise)(s=>o.call(C,f,s)),r=a.onCancellationRequested(()=>t.cancel()),i=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,C,f){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let a;const o=new A.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(b).listen(C,f)(o.fire,o),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),v.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,b,C);const f=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,w.isRemoteConsoleLog)(u)){(0,w.log)(u,`IPC Library: ${this.options.serverName}`);return}f.fire(m.VSBuffer.wrap(Buffer.from(u,"base64")))});const o=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&o.send(u.buffer.toString("base64")),r=f.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,c)=>{process.removeListener("exit",s),this.activeRequests.forEach(l=>(0,L.dispose)(l)),this.activeRequests.clear(),u!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:c})})}return this._client}getCachedChannel(b){let C=this.channels.get(b);return C||(C=this.client.getChannel(b),this.channels.set(b,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(Z[109],ee([12,13]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[110],ee([12,13]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[111],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[112],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[113],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[114],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[115],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[116],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[117],ee([12,13]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[118],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[119],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[120],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[121],ee([12,13]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[122],ee([12,13]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[123],ee([12,13]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[124],ee([12,13]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[125],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[126],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[127],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[128],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[129],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[130],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[131],ee([0,1,8,15,64,56,17,4,34]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,I,D){this._args=h,this.paths=I,this.productService=D}get appRoot(){return(0,S.dirname)(A.FileAccess.asFileUri("",K).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(P.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=p.env.VSCODE_PORTABLE;return h?P.URI.file((0,S.join)(h,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,S.resolve)(h):(0,S.normalize)((0,S.join)(A.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,S.resolve)(h):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,S.resolve)(h);const I=p.env.VSCODE_EXTENSIONS;if(I)return I;const D=p.env.VSCODE_PORTABLE;return D?(0,S.join)(D,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(I=>/^[^:/?#]+?:\/\//.test(I)?P.URI.parse(I):P.URI.file((0,S.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,S.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return P.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([R.memoize],w.prototype,"appRoot",null),fe([R.memoize],w.prototype,"userHome",null),fe([R.memoize],w.prototype,"userDataPath",null),fe([R.memoize],w.prototype,"appSettingsHome",null),fe([R.memoize],w.prototype,"tmpDir",null),fe([R.memoize],w.prototype,"userRoamingDataHome",null),fe([R.memoize],w.prototype,"settingsResource",null),fe([R.memoize],w.prototype,"userDataSyncHome",null),fe([R.memoize],w.prototype,"userDataSyncLogResource",null),fe([R.memoize],w.prototype,"sync",null),fe([R.memoize],w.prototype,"machineSettingsResource",null),fe([R.memoize],w.prototype,"globalStorageHome",null),fe([R.memoize],w.prototype,"workspaceStorageHome",null),fe([R.memoize],w.prototype,"keybindingsResource",null),fe([R.memoize],w.prototype,"keyboardLayoutResource",null),fe([R.memoize],w.prototype,"argvResource",null),fe([R.memoize],w.prototype,"snippetsHome",null),fe([R.memoize],w.prototype,"isExtensionDevelopment",null),fe([R.memoize],w.prototype,"untitledWorkspacesHome",null),fe([R.memoize],w.prototype,"installSourcePath",null),fe([R.memoize],w.prototype,"builtinExtensionsPath",null),fe([R.memoize],w.prototype,"extensionsPath",null),fe([R.memoize],w.prototype,"extensionDevelopmentLocationURI",null),fe([R.memoize],w.prototype,"extensionDevelopmentKind",null),fe([R.memoize],w.prototype,"extensionTestsLocationURI",null),fe([R.memoize],w.prototype,"debugExtensionHost",null),fe([R.memoize],w.prototype,"serviceMachineIdResource",null),fe([R.memoize],w.prototype,"telemetryLogResource",null),fe([R.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(v,h){return m(v["inspect-extensions"],v["inspect-brk-extensions"],5870,h,v.debugId)}e.parseExtensionHostPort=n;function y(v,h){return m(v["inspect-search"],v["inspect-brk-search"],5876,h)}e.parseSearchPort=y;function m(v,h,I,D,b){const f=Number(h||v)||(D?null:I),a=f?Boolean(!!h):!1;return{port:f,break:a,debugId:b}}}),function(){"use strict";function K(e,S,L,R){function k(P){const p=A(P),w=[p];return e.isAbsolute(p)||w.unshift(R),e.resolve(...w)}function A(P){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const n=P["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(y,"AppData","Roaming")}break;case"darwin":w=e.join(S.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[132],ee([0,213,35,17,15,34]),function(e,S,L,R,k,A){const P=k.dirname(R.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return K(S,L,p.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),L=require("os");module.exports=K(S,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[133],ee([0,1,35,132,131]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,L.getUserDataPath)(P)},p)}}e.NativeEnvironmentService=k}),define(Z[134],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(D){const b=D.match(A);return b?b[1]:null}function n(D){if(D.indexOf("://")===-1){const b=D.match(L);return b?w(b[2]):null}try{const b=S.URI.parse(D);if(b.authority)return w(b.authority)}catch(b){}return null}function y(D,b){const C=new Set;let f;for(;f=P.exec(D);){const o=n(f[1]);o&&C.add(o)}const a=new Set(b);return Array.from(C).map(o=>a.has(o)?o:o.replace(p,"a"))}e.getDomainsOfRemotes=y;function m(D){const b=D.match(k);return b?b[2]:null}function v(D,b,C){return D&&b?(C&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${D}${b}`:`${D}/${b}`):null}function h(D,b){if(D.indexOf("://")===-1){const C=D.match(R);if(C)return v(C[2],C[3],b)}try{const C=S.URI.parse(D);if(C.authority)return v(m(C.authority),C.path,b)}catch(C){}return null}function I(D,b=!1){const C=[];let f;for(;f=P.exec(D);){const a=h(f[1],b);a&&C.push(a)}return C}e.getRemotes=I}),define(Z[135],ee([0,1,3,4,94,26,2]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(h,I){return L.URI.revive(I?I.transformIncoming(h):h)}function p(h,I){return I?I.transformOutgoingURI(h):h}function w(h,I){I=I||R.DefaultURITransformer;const D=h.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...h,manifest:void 0},I),manifest:D}}function n(h,I){return I?(0,k.cloneAndChange)(h,D=>D instanceof L.URI?I.transformOutgoingURI(D):void 0):h}class y{constructor(I,D){this.service=I,this.getUriTransformer=D,this.onInstallExtension=S.Event.buffer(I.onInstallExtension,!0),this.onDidInstallExtensions=S.Event.buffer(I.onDidInstallExtensions,!0),this.onUninstallExtension=S.Event.buffer(I.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(I.onDidUninstallExtension,!0)}listen(I,D){const b=this.getUriTransformer(I);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return S.Event.map(this.onDidInstallExtensions,C=>C.map(f=>({...f,local:f.local?n(f.local,b):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(I,D,b){const C=this.getUriTransformer(I);switch(D){case"zip":return this.service.zip(w(b[0],C)).then(f=>p(f,C));case"unzip":return this.service.unzip(P(b[0],C));case"install":return this.service.install(P(b[0],C),b[1]);case"getManifest":return this.service.getManifest(P(b[0],C));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(w(b[0],C),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(b[0],C));case"getInstalled":return this.service.getInstalled(b[0]).then(f=>f.map(a=>n(a,C)));case"updateMetadata":return this.service.updateMetadata(w(b[0],C),b[1]).then(f=>n(f,C));case"updateExtensionScope":return this.service.updateExtensionScope(w(b[0],C),b[1]).then(f=>n(f,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class m extends A.Disposable{constructor(I){super();this.channel=I,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new S.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire({identifier:D.identifier,source:this.isUriComponents(D.source)?L.URI.revive(D.source):D.source}))),this._register(this.channel.listen("onDidInstallExtensions")(D=>this._onDidInstallExtensions.fire(D.map(b=>({...b,local:b.local?w(b.local,null):b.local,source:this.isUriComponents(b.source)?L.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}isUriComponents(I){return I?typeof I.path=="string"&&typeof I.scheme=="string":!1}zip(I){return Promise.resolve(this.channel.call("zip",[I]).then(D=>L.URI.revive(D)))}unzip(I){return Promise.resolve(this.channel.call("unzip",[I]))}install(I,D){return Promise.resolve(this.channel.call("install",[I,D])).then(b=>w(b,null))}getManifest(I){return Promise.resolve(this.channel.call("getManifest",[I]))}async canInstall(I){return!0}installFromGallery(I,D){return Promise.resolve(this.channel.call("installFromGallery",[I,D])).then(b=>w(b,null))}uninstall(I,D){return Promise.resolve(this.channel.call("uninstall",[I,D]))}reinstallFromGallery(I){return Promise.resolve(this.channel.call("reinstallFromGallery",[I]))}getInstalled(I=null){return Promise.resolve(this.channel.call("getInstalled",[I])).then(D=>D.map(b=>w(b,null)))}updateMetadata(I,D){return Promise.resolve(this.channel.call("updateMetadata",[I,D])).then(b=>w(b,null))}updateExtensionScope(I,D){return Promise.resolve(this.channel.call("updateExtensionScope",[I,D])).then(b=>w(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class v{constructor(I){this.service=I}listen(I,D){throw new Error("Invalid listen")}call(I,D,b){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(Z[136],ee([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(k,A){const P=p=>{if(typeof p!="string")return;const w=L.exec(p);if(!w)return;const n=A[w[1]]??p;return typeof n=="string"?n:typeof n.message=="string"?n.message:p};return(0,S.cloneAndChange)(k,P)}e.localizeManifest=R}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,P,p){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,P,p])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[70],ee([0,1,117]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=k;function A(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=m.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=A;function P(m){if(!m)return null;let v=m.majorBase,h=m.majorMustEqual,I=m.minorBase,D=m.minorMustEqual,b=m.patchBase,C=m.patchMustEqual;m.hasCaret&&(v===0||(D=!1),C=!1);let f=0;if(m.preRelease){const a=R.exec(m.preRelease);if(a){const[,o,t,r]=a;f=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:v,majorMustEqual:h,minorBase:I,minorMustEqual:D,patchBase:b,patchMustEqual:C,isMinimum:m.hasGreaterEquals,notBefore:f}}e.normalizeVersion=P;function p(m,v,h){let I;typeof m=="string"?I=P(A(m)):I=m;let D;v instanceof Date?D=v.getTime():typeof v=="string"&&(D=new Date(v).getTime());let b;if(typeof h=="string"?b=P(A(h)):b=h,!I||!b)return!1;let C=I.majorBase,f=I.minorBase,a=I.patchBase,o=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,s=b.majorMustEqual,u=b.minorMustEqual,c=b.patchMustEqual;return b.isMinimum?C>o?!0:C<o?!1:f>t?!0:f<t||D&&D<i?!1:a>=r:(C===1&&o===0&&(!s||!u||!c)&&(o=1,t=0,r=0,s=!0,u=!1,c=!1),C<o?!1:C>o?!s:f<t?!1:f>t?!u:a<r?!1:a>r?!c:!(D&&D<i))}e.isValidVersion=p;function w(m,v,h,I){return h.isBuiltin||typeof h.main=="undefined"?!0:y(m,v,h.engines.vscode,I)}e.isValidExtensionVersion=w;function n(m,v,h){return m==="*"||y(v,h,m)}e.isEngineValid=n;function y(m,v,h,I=[]){let D=P(A(h));if(!D)return I.push(S.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return I.push(S.localize(1,null,h)),!1}else if(!D.majorMustEqual)return I.push(S.localize(2,null,h)),!1;return p(m,v,D)?!0:(I.push(S.localize(3,null,m,h)),!1)}}),define(Z[138],ee([0,1,36,51,2,17]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends R.Disposable{constructor(p,w,n,y){super();this.folders=p,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[139],ee([0,1,36,51,2,17]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends R.Disposable{constructor(p,w,n,y,m={}){super();this.folders=p,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=y,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[140],ee([0,1,43,68,67,17]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(p,w,n,y,m){this.watchedFolder=p,this.eventCallback=n,this.logCallback=y,this.verboseLogging=m,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(v=>(0,R.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,S.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,p);const w=new L.LineDecoder;this.handle.stdout.on("data",n=>{const y=[];for(const m of w.write(n)){const v=m.split("|");if(v.length===2){const h=Number(v[0]),I=v[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(D=>D(I))){this.verboseLogging&&this.log(I);continue}y.push({type:A.changeTypeMap[h],path:I})}else this.log(v[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,y)=>this.onExit(n,y))}onError(p){this.error("process error: "+p.toString())}onExit(p,w){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${w})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[141],ee([0,1,140,8,19]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(P,p,w,n){this.onDidFilesChange=p,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,R.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(R,k=[],A=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=S}),define(Z[142],ee([0,1,52]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(A,P,p){P instanceof S.SyncDescriptor||(P=new S.SyncDescriptor(P,[],p)),L.push([A,P])}e.registerSingleton=R;function k(){return L}e.getSingletonServiceDescriptors=k}),define(Z[143],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=S;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const P=this.lookupOrInsertNode(k),p=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),p),p.incoming.set(this._hashFn(k),P)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let P=this._nodes.get(A);return P||(P=new S(k),this._nodes.set(A,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,P]of this._nodes)k.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const P=new Set([k]),p=this._findCycle(A,P);if(p)return p}}_findCycle(k,A){for(let[P,p]of k.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const w=this._findCycle(p,A);if(w)return w;A.delete(P)}}}e.Graph=L}),define(Z[6],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function p(w){return w[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=p})(S=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,p,w,n){p[S.DI_TARGET]===p?p[S.DI_DEPENDENCIES].push({id:P,index:w,optional:n}):(p[S.DI_DEPENDENCIES]=[{id:P,index:w,optional:n}],p[S.DI_TARGET]=p)}function R(P){if(S.serviceIds.has(P))return S.serviceIds.get(P);const p=function(w,n,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(p,w,y,!1)};return p.toString=()=>P,S.serviceIds.set(P,p),p}e.createDecorator=R;function k(P){return P}e.refineServiceDecorator=k;function A(P){return function(p,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,p,n,!0)}}e.optional=A}),define(Z[144],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(Z[145],ee([0,1,19,6,7]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=R.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",R.isMacintosh),A.set("isLinux",R.isLinux),A.set("isWindows",R.isWindows),A.set("isWeb",R.isWeb),A.set("isMacNative",R.isMacintosh&&!R.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var p;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(g){return v.create(g)}static equals(g,T){return h.create(g,T)}static notEquals(g,T){return b.create(g,T)}static regex(g,T){return r.create(g,T)}static in(g,T){return I.create(g,T)}static not(g){return C.create(g)}static and(...g){return s.create(g)}static or(...g){return u.create(g)}static greater(g,T){return f.create(g,T)}static less(g,T){return o.create(g,T)}static deserialize(g,T=!1){if(!!g)return this._deserializeOrExpression(g,T)}static _deserializeOrExpression(g,T){let O=g.split("||");return u.create(O.map($=>this._deserializeAndExpression($,T)))}static _deserializeAndExpression(g,T){let O=g.split("&&");return s.create(O.map($=>this._deserializeOne($,T)))}static _deserializeOne(g,T){if(g=g.trim(),g.indexOf("!=")>=0){let O=g.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(g.indexOf("==")>=0){let O=g.split("==");return h.create(O[0].trim(),this._deserializeValue(O[1],T))}if(g.indexOf("=~")>=0){let O=g.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(g.indexOf(" in ")>=0){let O=g.split(" in ");return I.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const O=g.split(">=");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const O=g.split(">");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const O=g.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const O=g.split("<");return o.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(g)?C.create(g.substr(1).trim()):v.create(g)}static _deserializeValue(g,T){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let O=/^'([^']*)'$/.exec(g);return O?O[1].trim():g}static _deserializeRegexValue(g,T){if((0,S.isFalsyOrWhitespace)(g)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=g.indexOf("/"),$=g.lastIndexOf("/");if(O===$||O<0){if(T)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let x=g.slice(O+1,$),G=g[$+1]==="i"?"i":"";try{return new RegExp(x,G)}catch(B){if(T)throw new Error(`bad regexp-value '${g}', parse error: ${B}`);return console.warn(`bad regexp-value '${g}', parse error: ${B}`),null}}}e.ContextKeyExpr=w;function n(E,g){return E.cmp(g)}class y{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{constructor(g){this.key=g,this.type=2}static create(g){const T=A.get(g);return typeof T=="boolean"?T?m.INSTANCE:y.INSTANCE:new v(g)}cmp(g){return g.type!==this.type?this.type-g.type:l(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return C.create(this.key)}}e.ContextKeyDefinedExpr=v;class h{constructor(g,T){this.key=g,this.value=T,this.type=4}static create(g,T){if(typeof T=="boolean")return T?v.create(g):C.create(g);const O=A.get(g);return typeof O=="boolean"?T===(O?"true":"false")?m.INSTANCE:y.INSTANCE:new h(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class I{constructor(g,T){this.key=g,this.valueKey=T,this.type=10}static create(g,T){return new I(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const T=g.getValue(this.valueKey),O=g.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?P.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=I;class D{constructor(g){this._actual=g,this.type=11}static create(g){return new D(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new D(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class b{constructor(g,T){this.key=g,this.value=T,this.type=5}static create(g,T){if(typeof T=="boolean")return T?C.create(g):v.create(g);const O=A.get(g);return typeof O=="boolean"?T===(O?"true":"false")?y.INSTANCE:m.INSTANCE:new b(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class C{constructor(g){this.key=g,this.type=3}static create(g){const T=A.get(g);return typeof T=="boolean"?T?y.INSTANCE:m.INSTANCE:new C(g)}cmp(g){return g.type!==this.type?this.type-g.type:l(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return v.create(this.key)}}e.ContextKeyNotExpr=C;class f{constructor(g,T){this.key=g,this.value=T,this.type=12}static create(g,T){return new f(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class a{constructor(g,T){this.key=g,this.value=T,this.type=13}static create(g,T){return new a(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class o{constructor(g,T){this.key=g,this.value=T,this.type=14}static create(g,T){return new o(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(g,T){this.key=g,this.value=T,this.type=15}static create(g,T){return new t(g,T)}cmp(g){return g.type!==this.type?this.type-g.type:d(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(g,T){this.key=g,this.regexp=T,this.type=7}static create(g,T){return new r(g,T)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const T=this.regexp?this.regexp.source:"",O=g.regexp?g.regexp.source:"";return T<O?-1:T>O?1:0}equals(g){if(g.type===this.type){const T=this.regexp?this.regexp.source:"",O=g.regexp?g.regexp.source:"";return this.key===g.key&&T===O}return!1}evaluate(g){let T=g.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(g){this._actual=g,this.type=8}static create(g){return new i(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new i(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(g){this.expr=g,this.type=6}static create(g){return s._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],g.expr[T]);if($!==0)return $}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(g.expr[T]))return!1;return!0}return!1}evaluate(g){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(g))return!1;return!0}static _normalizeArr(g){const T=[];let O=!1;for(const $ of g)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return y.INSTANCE;if($.type===6){T.push(...$.expr);continue}T.push($)}if(T.length===0&&O)return m.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const $=T[T.length-1];if($.type!==9)break;T.pop();const x=T.pop(),G=u.create($.expr.map(B=>s.create([B,x])));G&&(T.push(G),T.sort(n))}return T.length===1?T[0]:new s(T)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let T of this.expr)g.push(...T.keys());return g}map(g){return new s(this.expr.map(T=>T.map(g)))}negate(){let g=[];for(let T of this.expr)g.push(T.negate());return u.create(g)}}e.ContextKeyAndExpr=s;class u{constructor(g){this.expr=g,this.type=9}static create(g){const T=u._normalizeArr(g);if(T.length!==0)return T.length===1?T[0]:new u(T)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],g.expr[T]);if($!==0)return $}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(g.expr[T]))return!1;return!0}return!1}evaluate(g){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(g))return!0;return!1}static _normalizeArr(g){let T=[],O=!1;if(g){for(let $=0,x=g.length;$<x;$++){const G=g[$];if(!!G){if(G.type===0){O=!0;continue}if(G.type===1)return[m.INSTANCE];if(G.type===9){T=T.concat(G.expr);continue}T.push(G)}}if(T.length===0&&O)return[y.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let T of this.expr)g.push(...T.keys());return g}map(g){return new u(this.expr.map(T=>T.map(g)))}negate(){let g=[];for(let O of this.expr)g.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;g.length>1;){const O=g.shift(),$=g.shift(),x=[];for(const G of T(O))for(const B of T($))x.push(w.and(G,B));g.unshift(w.or(...x))}return g[0]}}e.ContextKeyOrExpr=u;class c extends v{constructor(g,T,O){super(g);this._defaultValue=T,typeof O=="object"?c._info.push({...O,key:g}):O!==!0&&c._info.push({key:g,description:O,type:T!=null?typeof T:void 0})}static all(){return c._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(g){return w.equals(this.key,g)}notEqualsTo(g){return w.notEquals(this.key,g)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(E,g){return E<g?-1:E>g?1:0}function d(E,g,T,O){return E<T?-1:E>T?1:g<O?-1:g>O?1:0}}),define(Z[71],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[72],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(Z[9],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,112,6,17]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var p;(function(y){y.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var w;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(m,v){super(m);this.code=v,this.name=v}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(S,L){e(S,L,K)}};define(Z[146],ee([0,1,2,27]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends S.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=fe([Y(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[73],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[74],ee([0,1,19,6]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=R;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,m){if(typeof y=="undefined"||y===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof y=="string"||typeof m=="string"){let v=typeof y=="string"?y:y.value,h=typeof m=="string"?m:m.value;return S.equalsIgnoreCase(v,h)}return y._lower===m._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=P;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,19,74]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(h,I){return h.uuid&&I.uuid?h.uuid===I.uuid:h.id===I.id?!0:(0,S.compareIgnoreCase)(h.id,I.id)===0}e.areSameExtensions=R;class k{constructor(I,D){this.version=D,this.id=I.id,this.uuid=I.uuid}key(){return`${this.id}-${this.version}`}equals(I){return I instanceof k?R(this,I)&&this.version===I.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,I){return`${h}.${I}`}e.getExtensionId=A;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function p(h,I){return P(A(h,I))}e.getGalleryExtensionId=p;function w(h,I){const D=[],b=C=>{for(const f of D)if(f.some(a=>R(I(a),I(C))))return f;return null};for(const C of h){const f=b(C);f?f.push(C):D.push([C])}return D}e.groupByExtension=w;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function y(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function m(h){const I=new Set;for(const D of h)D.malicious&&I.add(D.id.id);return I}e.getMaliciousExtensionsSet=m;function v(h,I){const D=[],b=I.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const C=b.shift();if(C&&D.every(f=>!R(f.identifier,{id:C}))){const f=h.filter(a=>R(a.identifier,{id:C}));f.length===1&&(D.push(f[0]),b.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=v}),define(Z[147],ee([0,1,2,8,74,18]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends S.Disposable{constructor(p,w){super();this.environmentService=p,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(p){p.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[14],ee([0,1,119,8,4,6,19,16,38]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function w(U){return U.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var y;(function(U){U[U.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=v;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function I(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=I;function D(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(M,F){super(M);this.code=F}}e.FileSystemProviderError=C;function f(U,M){const F=new C(U.toString(),M);return o(F,M),F}e.createFileSystemProviderError=f;function a(U){return U||f((0,S.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=a;function o(U,M){return U.name=M?`${M} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=o;function t(U){if(!U)return b.Unknown;if(U instanceof C)return U.code;const M=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!M)return b.Unknown;switch(M[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof d)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(M,F,j){this.resource=M,this.operation=F,this.target=j}isOperation(M){return this.operation===M}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(M,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of M)switch(j.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>F)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>F)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>F)),this.deleted.set(j.resource,j);break}}contains(M,...F){return this.doContains(M,{includeChildren:!1},...F)}affects(M,...F){return this.doContains(M,{includeChildren:!0},...F)}doContains(M,F,...j){if(!M)return!1;const _=j.length>0;return!!((!_||j.includes(1))&&(this.added?.get(M)||F.includeChildren&&this.added?.findSuperstr(M))||(!_||j.includes(0))&&(this.updated?.get(M)||F.includeChildren&&this.updated?.findSuperstr(M))||(!_||j.includes(2))&&(this.deleted?.findSubstr(M)||F.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(U,M,F){return!U||!M||U===M||M.length>U.length?!1:(M.charAt(M.length-1)!==L.sep&&(M+=L.sep),F?(0,A.startsWithIgnoreCase)(U,M):U.indexOf(M)===0)}e.isParent=l;class d extends Error{constructor(M,F,j){super(M);this.fileOperationResult=F,this.options=j}}e.FileOperationError=d;class E extends d{constructor(M,F,j){super(M,2,j);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function $(U,M){if(!M.canHandleResource(R.URI.from({scheme:U.scheme})))return new Promise(F=>{const j=M.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===U.scheme&&_.added&&(j.dispose(),F())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(M){return(0,P.isNumber)(M)||(M=0),M<x.KB?(0,S.localize)(1,null,M.toFixed(0)):M<x.MB?(0,S.localize)(2,null,(M/x.KB).toFixed(2)):M<x.GB?(0,S.localize)(3,null,(M/x.MB).toFixed(2)):M<x.TB?(0,S.localize)(4,null,(M/x.GB).toFixed(2)):(0,S.localize)(5,null,(M/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function B(U){return{maxFileSize:U===0?300*x.MB:16*x.GB,maxHeapSize:U===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=B}),define(Z[148],ee([0,1,149,49,14]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(p,w)=>{const n=(0,S.createHash)("md5"),y=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(y,{onData:m=>n.update(m.buffer),onError:m=>w(m),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};k=fe([Y(0,R.IFileService)],k),e.ChecksumService=k}),define(Z[75],ee([0,1,4,14,7]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(p){return p.map(w=>({type:w.type,resource:S.URI.file(w.path)}))}e.toFileChanges=k;function A(p){const w=new P;for(const n of p)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const y=n.type,m=w.type;y===1&&m===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):y===2&&m===1?n.type=0:y===1&&m===0||(n.type=m)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(y=>y.type!==2?(w.push(y),!1):!0).sort((y,m)=>y.path.length-m.path.length).filter(y=>n.some(m=>(0,L.isParent)(y.path,m,!R.isLinux))?!1:(n.push(y.path),!0)).concat(w)}}}),define(Z[150],ee([0,1,75,2,18,97,100,5,8]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(y,m,v,h){super();this.path=y,this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=h,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:m}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(m)try{v=await(0,k.realpath)(v)}catch(h){if(this.onError(h),m.dangling)return}y.isDirectory()?this._register((0,A.watchFolder)(v,(h,I)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(I))})},h=>this.onError(h))):this._register((0,A.watchFile)(v,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,S.normalizeFileChanges)(m);if(this.verboseLogging)for(const h of v)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[76],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...R){this._entries=new Map;for(let[k,A]of R)this.set(k,A)}set(R,k){const A=this._entries.get(R);return this._entries.set(R,k),A}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=S}),define(Z[151],ee([0,1,11,143,52,6,76,5]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new A.ServiceCollection,I=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=I,this._parent=D,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...I){let D=m.traceInvocation(h),b=!1;try{return h({get:(f,a)=>{if(b)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(f,D);if(!o&&a!==k.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return o}},...I)}finally{b=!0,D.stop()}}createInstance(h,...I){let D,b;return h instanceof R.SyncDescriptor?(D=m.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(I),D)):(D=m.traceCreation(h),b=this._createInstance(h,I,D)),D.stop(),b}_createInstance(h,I=[],D){let b=k._util.getServiceDependencies(h).sort((a,o)=>a.index-o.index),C=[];for(const a of b){let o=this._getOrCreateServiceInstance(a.id,D);if(!o&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);C.push(o)}let f=b.length>0?b[0].index:I.length;if(I.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${I.length} static arguments`);let a=f-I.length;a>0?I=I.concat(new Array(a)):I=I.slice(0,f)}return new h(...[...I,...C])}_setServiceInstance(h,I){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,I);else if(this._parent)this._parent._setServiceInstance(h,I);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let I=this._services.get(h);return!I&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):I}_getOrCreateServiceInstance(h,I){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,I.branch(h,!0)):(I.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,I,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,I,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,I,D){const b=new L.Graph(a=>a.id.toString());let C=0;const f=[{id:h,desc:I,_trace:D}];for(;f.length;){const a=f.pop();if(b.lookupOrInsertNode(a),C++>1e3)throw new w(b);for(let o of k._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:o.id,desc:t,_trace:a._trace.branch(o.id,!0)};b.insertEdge(a,r),f.push(r)}}}for(;;){const a=b.roots();if(a.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:o}of a){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}b.removeNode(o)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,I,D=[],b,C){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(I,D,b,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,I,D,b,C);throw new Error(`illegalState - creating UNKNOWN service instance ${I.name}`)}_createServiceInstance(h,I=[],D,b){if(D){const C=new P.IdleValue(()=>this._createInstance(h,I,b));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];let o=C.value,t=o[a];return typeof t!="function"||(t=t.bind(o),f[a]=t),t},set(f,a,o){return C.value[a]=o,!0}})}else return this._createInstance(h,I,b)}}e.InstantiationService=n;var y;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(y||(y={}));class m{constructor(h,I){this.type=h,this.name=I,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return p?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return p?new m(0,h.name):m._None}branch(h,I){let D=new m(2,h.toString());return this._dep.push([h,I,D]),D}stop(){let h=Date.now()-this._start;m._totals+=h;let I=!1;function D(C,f){let a=[],o=new Array(C+1).join("	");for(const[t,r,i]of f._dep)if(r&&i){I=!0,a.push(`${o}CREATES -> ${t}`);let s=D(C+1,i);s&&a.push(s)}else a.push(`${o}uses -> ${t}`);return a.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||I)&&console.log(b.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[152],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(R,k){this.server=R,this.router=k}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,k){this.server.registerChannel(R,k)}}e.MessagePortMainProcessService=S}),define(Z[153],ee([0,1,36,52,142,6]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(v,h,I){const D=I.getChannel(v);return P(h)?new h.channelClientCtor(D):S.ProxyChannel.toService(D,h?.proxyOptions)}}function P(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let p=class extends A{constructor(v,h,I){super(v,h,I)}};p=fe([Y(2,e.IMainProcessService)],p);function w(m,v,h){(0,R.registerSingleton)(m,new L.SyncDescriptor(p,[v,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(v,h,I){super(v,h,I)}};n=fe([Y(2,e.ISharedProcessService)],n);function y(m,v,h){(0,R.registerSingleton)(m,new L.SyncDescriptor(n,[v,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=y}),define(Z[57],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const k of R.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[154],ee([0,1,2,57]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends S.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=fe([Y(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[10],ee([0,1,6,2,7,3,39]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function P(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class w extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class y extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class m extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class v extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class h extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class I extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=I;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function C(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const t=f(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function f(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function a(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=a}),define(Z[155],ee([0,1,9,8,18,11,2,5,10]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends A.Disposable{constructor(y,m){super();this.environmentService=y,this.logService=m,this._register(new P.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,L.basename)(this.environmentService.logsPath),m=(0,L.dirname)(this.environmentService.logsPath),I=(await R.Promises.readdir(m)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==y),D=I.slice(0,Math.max(0,I.length-9));D.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${D.join(", ")}'`),await Promise.all(D.map(b=>R.Promises.rm((0,L.join)(m,b)))))}catch(y){(0,k.onUnexpectedError)(y)}}};w=fe([Y(0,S.IEnvironmentService),Y(1,p.ILogService)],w),e.LogsDataCleaner=w}),define(Z[156],ee([0,1,9,8,18,11,2,5,10]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends A.Disposable{constructor(y,m,v){super();this.backupWorkspacesPath=y,this.environmentService=m,this.logService=v,this._register(new P.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const y=await R.Promises.readFile(this.backupWorkspacesPath,"utf8"),v=JSON.parse(y).emptyWorkspaceInfos.map(I=>I.backupFolder),h=await R.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async I=>{I.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&v.indexOf(I)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${I}.`),await R.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,I)))}))}catch(y){(0,k.onUnexpectedError)(y)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=fe([Y(1,S.INativeEnvironmentService),Y(2,p.ILogService)],w),e.StorageDataCleaner=w}),define(Z[157],ee([0,1,18,2,14,27,9,4,15,31,10,30,58,7,5,11]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends L.Disposable{constructor(f,a,o,t){super();this.fileService=a,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=P.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,a){await this.cleanUpPromise;const o=this.getName(f),t=(0,p.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const r=(0,p.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,a);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(f){}async rename(f,a,o){try{await S.Promises.rename(f.fsPath,a.fsPath)}catch(t){if(v.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${f} to ${a} with 'EPERM' error. Trying again...`),this.rename(f,a,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const a=[],o=[];for(const i of f.children){const s=this.parse(i.name);s&&o.push([s,i])}const t=(0,w.groupByExtension)(o,([i])=>i),r=[];for(const i of t)i.sort((s,u)=>m.rcompare(s[0].version,u[0].version)),a.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(a.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new w.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,y.generateUuid)()}parse(f){const a=D.exec(f);return a&&a[1]&&a[2]?new w.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};b=fe([Y(0,A.INativeEnvironmentService),Y(1,R.IFileService),Y(2,k.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[158],ee([0,1,2,10,43,39,8,5,3,17,18,9]),function(K,e,S,L,R,k,A,P,p,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends S.Disposable{constructor(h,I){super();this.environmentService=h,this.logService=I,this.processesLimiter=new P.Limiter(5)}async postUninstall(h){const I=this.parseScript(h,"uninstall");return I&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(I.script,"uninstall",I.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${D}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(h,I){const D=`vscode:${I}`;if(h.location.scheme===w.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[D]=="string"){const b=h.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${D} should be a node script`),null):{script:(0,A.join)(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,I,D,b,C){return new Promise((f,a)=>{const o=this.start(h,I,D,C);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?a(i):f(void 0)};o.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,s)=>{r(i?`post-${I} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,o.kill(),a("timed out")},5e3))})}start(h,I,D,b){const C={silent:!0,execArgv:void 0},f=(0,R.fork)(h,[`--type=extension-post-${I}`,...D],C);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const a=p.Event.fromNodeEventEmitter(f.stdout,"data"),o=p.Event.fromNodeEventEmitter(f.stderr,"data");a(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${I}`,i)),o(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${I}`,i));const t=p.Event.any(p.Event.map(a,i=>({data:`%c${i}`,format:[""]})),p.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=fe([Y(0,y.IEnvironmentService),Y(1,L.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[159],ee([0,1,2,9,3,14,4,31,15,10]),function(K,e,S,L,R,k,A,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends S.Disposable{constructor(m,v,h,I){super();this.extensionsManagementService=m,this.logService=I,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(C=>this.onInstallExtension(C))),this._register(m.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(m.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const D=A.URI.file(h.extensionsPath),b=new p.ExtUri(C=>!v.hasCapability(C,1024));this._register(v.watch(D)),this._register(R.Event.filter(v.onDidChangeFilesRaw,C=>C.changes.some(f=>this.doesChangeAffects(f,D,b)))(()=>this.onDidChange()))}doesChangeAffects(m,v,h){return h.isEqual(h.dirname(m.resource),v)?h.isEqual(m.resource,h.joinPath(v,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const v of m)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(v=>!(0,P.areSameExtensions)(v,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,P.areSameExtensions)(v,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),v=m.filter(I=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,P.areSameExtensions)(D,I.identifier))?!1:I.installedTimestamp&&I.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",I.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",I.identifier.id),!1)),h=this.installedExtensions.filter(I=>this.installingExtensions.some(D=>(0,P.areSameExtensions)(D,I))?!1:m.every(D=>!(0,P.areSameExtensions)(D.identifier,I))?(this.logService.info("Detected extension removed from another source",I.id),!0):!1);this.installedExtensions=m.map(I=>I.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};n=fe([Y(1,k.IFileService),Y(2,L.INativeEnvironmentService),Y(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[160],ee([0,1,18,149,27,2,9,5,31,10,57,23,17,8]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(b,C,f){super();this.extensionManagementService=b,this.logService=f,this.cache=this._register(new I(C,f)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),C=["en",...Object.keys(b)];return(0,y.distinct)(C)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const C=await this.cache.getLanguagePacks();Object.keys(C).some(f=>C[f]&&C[f].extensions.some(a=>(0,p.areSameExtensions)(a.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,C]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(C);return!(0,y.equals)(Object.keys(b),Object.keys(f))}};h=fe([Y(0,R.IExtensionManagementService),Y(1,A.INativeEnvironmentService),Y(2,w.ILogService)],h),e.LocalizationsService=h;let I=class extends k.Disposable{constructor(b,C){super();this.logService=C,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(C=>{Object.keys(C).forEach(f=>delete C[f]),this.createLanguagePacksFromExtensions(C,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...C){for(const f of C)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,f);Object.keys(b).forEach(f=>this.updateHash(b[f]))}createLanguagePacksFromExtension(b,C){const f=C.identifier,a=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const o of a)if(C.location.scheme===m.Schemas.file&&(0,n.isValidLocalization)(o)){let t=b[o.languageId];t||(t={hash:"",extensions:[],translations:{}},b[o.languageId]=t);let r=t.extensions.filter(i=>(0,p.areSameExtensions)(i.extensionIdentifier,f))[0];r?r.version=C.manifest.version:t.extensions.push({extensionIdentifier:f,version:C.manifest.version});for(const i of o.translations)t.translations[i.id]=(0,v.join)(C.location.fsPath,i.path)}}updateHash(b){if(b){const C=(0,L.createHash)("md5");for(const f of b.extensions)C.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);b.hash=C.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let C=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(a){return{}}}).then(f=>(C=b(f),f)).then(f=>{for(const o of Object.keys(f))f[o]||delete f[o];this.languagePacks=f,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),S.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>C,f=>this.logService.error(f))})}};I=fe([Y(0,A.INativeEnvironmentService),Y(1,w.ILogService)],I)}),define(Z[77],ee([0,1,10,3,4]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=L.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=k;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,v){return m.call("setLevel",v)}}e.LogLevelChannelClient=A;class P{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,v){throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"createLogger":this.createLogger(R.URI.revive(h[0]),h[1]);return;case"log":return this.log(R.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(m,v){this.loggers.set(m.toString(),this.loggerService.createLogger(m,v))}consoleLog(m,v){let h=console.log;switch(m){case S.LogLevel.Error:h=console.error;break;case S.LogLevel.Warning:h=console.warn;break;case S.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(m,v){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[I,D]of v)switch(I){case S.LogLevel.Trace:h.trace(D);break;case S.LogLevel.Debug:h.debug(D);break;case S.LogLevel.Info:h.info(D);break;case S.LogLevel.Warning:h.warn(D);break;case S.LogLevel.Error:h.error(D);break;case S.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class p extends S.AbstractLoggerService{constructor(m,v,h){super(m,v);this.channel=h}createConsoleMainLogger(){return new S.AdapterLogger({log:(m,v)=>{this.channel.call("consoleLog",[m,v])}})}doCreateLogger(m,v,h){return new w(this.channel,m,v,h)}}e.LoggerChannelClient=p;class w extends S.AbstractMessageLogger{constructor(m,v,h,I){super(I?.always);this.channel=m,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,I]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,v){const h=[[m,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class n extends S.LogService{constructor(m,v){super(v);this.parent=m,this._register(m.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=n}),define(Z[59],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,7,34,15]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,k.dirname)(S.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const p=K.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:p.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[78],ee([0,1,120,25,14,11,44]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(y,m,v,h,I,D){let b;try{await p(y,m,v,h,I,D)}catch(C){b=C}finally{b&&I.errorTransformer&&(b=I.errorTransformer(b)),typeof b!="undefined"&&v.error(b),v.end()}}e.readFileIntoStream=P;async function p(y,m,v,h,I,D){w(D);const b=await y.open(m,{create:!1});try{w(D);let C=0,f=0,a=I&&typeof I.length=="number"?I.length:void 0,o=L.VSBuffer.alloc(Math.min(I.bufferSize,typeof a=="number"?a:I.bufferSize)),t=I&&typeof I.position=="number"?I.position:0,r=0;do f=await y.read(b,t,o.buffer,r,o.byteLength-r),t+=f,r+=f,C+=f,typeof a=="number"&&(a-=f),r===o.byteLength&&(await v.write(h(o)),o=L.VSBuffer.alloc(Math.min(I.bufferSize,typeof a=="number"?a:I.bufferSize)),r=0);while(f>0&&(typeof a!="number"||a>0)&&w(D)&&n(C,I));if(r>0){let i=r;typeof a=="number"&&(i=Math.min(r,a)),v.write(h(o.slice(0,i)))}}catch(C){throw(0,R.ensureFileSystemProviderError)(C)}finally{await y.close(b)}}function w(y){if(y.isCancellationRequested)throw(0,k.canceled)();return!0}function n(y,m){if(m?.limits){if(typeof m.limits.memory=="number"&&y>m.limits.memory)throw(0,R.createFileSystemProviderError)((0,S.localize)(0,null,A.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&y>m.limits.size)throw(0,R.createFileSystemProviderError)((0,S.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[161],ee([0,1,118,162,2,14,3,15,38,23,10,25,49,5,29,17,78,55]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class xe extends R.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new v.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new k.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new v.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new k.FileChangesEvent(o,!0)))),this.watchedResources=p.TernarySearchTree.forUris(o=>{const t=this.getProvider(o.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new v.ResourceQueue)}registerProvider(a,o){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:o});const t=new R.DisposableStore;return t.add(o.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(o)))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:a}))),typeof o.onDidErrorOccur=="function"&&t.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,R.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:o}),this.provider.delete(a),(0,R.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){o.push(t)}}),!this.provider.has(a)&&await v.Promises.settled(o)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,o){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return b.Iterable.map(this.provider,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async withProvider(a){if(!(0,P.isAbsolutePath)(a))throw new k.FileOperationError((0,S.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const o=this.provider.get(a.scheme);if(!o){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,a.toString()),t}return o}async withReadProvider(a){const o=await this.withProvider(a);if((0,k.hasOpenReadWriteCloseCapability)(o)||(0,k.hasReadWriteCapability)(o)||(0,k.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const o=await this.withProvider(a);if((0,k.hasOpenReadWriteCloseCapability)(o)||(0,k.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.doResolveFile(a,o)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,S.localize)(2,null,this.resourceForError(a)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(a,o){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),i=o?.resolveTo,s=o?.resolveSingleChildDescendants,u=o?.resolveMetadata,c=await t.stat(a);let l;return this.toFileStat(t,a,c,void 0,!!u,(d,E)=>(l||(l=p.TernarySearchTree.forUris(()=>!r),l.set(a,!0),(0,w.isNonEmptyArray)(i)&&i.forEach(g=>l.set(g,!0))),Boolean(l.findSuperstr(d.resource)||l.get(d.resource))?!0:d.isDirectory&&s?E===1:!1))}async toFileStat(a,o,t,r,i,s){const{providerExtUri:u}=this.getExtUri(a),c={resource:o,name:u.basename(o),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&s(c,r)){try{const l=await a.readdir(o),d=await v.Promises.settled(l.map(async([E,g])=>{try{const T=u.joinPath(o,E),O=i?await a.stat(T):{type:g};return await this.toFileStat(a,T,O,l.length,i,s)}catch(T){return this.logService.trace(T),null}}));c.children=(0,w.coalesce)(d)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(a){return v.Promises.settled(a.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const o=await this.withProvider(a);try{return!!await o.stat(a)}catch(t){return!1}}async canCreateFile(a,o){try{await this.doValidateCreateFile(a,o)}catch(t){return t}return!0}async doValidateCreateFile(a,o){if(!o?.overwrite&&await this.exists(a))throw new k.FileOperationError((0,S.localize)(3,null,this.resourceForError(a)),3,o)}async createFile(a,o=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,o);return this._onDidRunOperation.fire(new k.FileOperationEvent(a,0,r)),r}async writeFile(a,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,i.dirname(a));let u;if((0,k.hasReadWriteCapability)(r)&&!(o instanceof y.VSBuffer))if((0,m.isReadableStream)(o)){const c=await(0,m.peekStream)(o,3);c.ended?u=y.VSBuffer.concat(c.buffer):u=c}else u=(0,m.peekReadable)(o,c=>y.VSBuffer.concat(c),3);else u=o;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&u instanceof y.VSBuffer?await this.doWriteUnbuffered(r,a,t,u):await this.doWriteBuffered(r,a,t,u instanceof y.VSBuffer?(0,y.bufferToReadable)(u):u)}catch(s){throw new k.FileOperationError((0,S.localize)(4,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,o,t){if(!!t?.unlock&&!(a.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(o)));let i;try{i=await a.stat(o)}catch(s){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,S.localize)(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,S.localize)(7,null),3,t);return i}async readFile(a,o){const t=await this.withReadProvider(a);return o?.atomic?this.doReadFileAtomic(t,a,o):this.doReadFile(t,a,o)}async doReadFileAtomic(a,o,t){return new Promise((r,i)=>{this.writeQueue.queueFor(o,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,o,t);r(s)}catch(s){i(s)}})})}async doReadFile(a,o,t){const r=await this.doReadFileStream(a,o,{...t,preferUnbuffered:!0});return{...r,value:await(0,y.streamToBuffer)(r.value)}}async readFileStream(a,o){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,o)}async doReadFileStream(a,o,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(o,t).then(u=>u,u=>{throw r.cancel(),u});let s;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasFileReadStreamCapability)(a))||(0,k.hasReadWriteCapability)(a)&&t?.preferUnbuffered?s=this.readFileUnbuffered(a,o,t):(0,k.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,o,r.token,t):s=this.readFileBuffered(a,o,r.token,t),{...await i,value:s}}catch(u){s&&await(0,m.consumeStream)(s);const c=(0,S.localize)(8,null,this.resourceForError(o),(0,k.ensureFileSystemProviderError)(u).toString());throw u instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(c,u.stat,t):new k.FileOperationError(c,(0,k.toFileOperationResult)(u),t)}}readFileStreamed(a,o,t,r=Object.create(null)){const i=a.readFileStream(o,r,t);return(0,m.transform)(i,{data:s=>s instanceof y.VSBuffer?s:y.VSBuffer.wrap(s),error:s=>new k.FileOperationError((0,S.localize)(9,null,this.resourceForError(o),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},s=>y.VSBuffer.concat(s))}readFileBuffered(a,o,t,r=Object.create(null)){const i=(0,y.newWriteableBufferStream)();return(0,D.readFileIntoStream)(a,o,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new k.FileOperationError((0,S.localize)(10,null,this.resourceForError(o),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},t),i}readFileUnbuffered(a,o,t){const r=(0,m.newWriteableStream)(i=>y.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(o);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(o,i.byteLength,t),r.end(y.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(a,o){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,S.localize)(11,null,this.resourceForError(a)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==k.ETAG_DISABLED&&o.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,S.localize)(12,null),t,o);return this.validateReadFileLimits(a,t.size,o),t}validateReadFileLimits(a,o,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&o>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,S.localize)(13,null,this.resourceForError(a)),r)}}async canMove(a,o,t){return this.doCanMoveCopy(a,o,"move",t)}async canCopy(a,o,t){return this.doCanMoveCopy(a,o,"copy",t)}async doCanMoveCopy(a,o,t,r){if(a.toString()!==o.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,a,s,o,t,r)}catch(i){return i}return!0}async move(a,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,a,i,o,"move",!!t),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,s==="move"?2:3,u)),u}async copy(a,o,t){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,a,i,o,"copy",!!t),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,s==="copy"?3:2,u)),u}async doMoveCopy(a,o,t,r,i,s){if(o.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(a,o,t,r,i,s);if(u&&!c&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(a===t&&(0,k.hasFileFolderCopyCapability)(a))await a.copy(o,r,{overwrite:s});else{const l=await this.resolve(o);l.isDirectory?await this.doCopyFolder(a,l,t,r):await this.doCopyFile(a,o,t,r)}return i}else return a===t?(await a.rename(o,r,{overwrite:s}),i):(await this.doMoveCopy(a,o,t,r,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(a,o,t,r){if((0,k.hasOpenReadWriteCloseCapability)(a)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,o,t,r);if((0,k.hasOpenReadWriteCloseCapability)(a)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,o,t,r);if((0,k.hasReadWriteCapability)(a)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,o,t,r);if((0,k.hasReadWriteCapability)(a)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,o,t,r)}async doCopyFolder(a,o,t,r){await t.mkdir(r),Array.isArray(o.children)&&await v.Promises.settled(o.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),t,s):this.doCopyFile(a,i.resource,t,s)}))}async doValidateMoveCopy(a,o,t,r,i,s){let u=!1;if(a===t){const{providerExtUri:l,isPathCaseSensitive:d}=this.getExtUri(a);if(d||(u=l.isEqual(o,r)),u&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,o))throw new Error((0,S.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!u){if(!s)throw new k.FileOperationError((0,S.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(a===t){const{providerExtUri:l}=this.getExtUri(a);if(l.isEqualOrParent(o,r))throw new Error((0,S.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:u}}getExtUri(a){const o=this.isPathCaseSensitive(a);return{providerExtUri:o?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(o,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,0,t)),t}async mkdirp(a,o){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(o,r.dirname(o));)try{if(((await a.stat(o)).type&k.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(o)),o=r.dirname(o)}for(let i=t.length-1;i>=0;i--){o=r.joinPath(o,t[i]);try{await a.mkdir(o)}catch(s){if((0,k.toFileSystemProviderErrorCode)(s)!==k.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,o){try{await this.doValidateDelete(a,o)}catch(t){return t}return!0}async doValidateDelete(a,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(a)));let i;try{i=await t.stat(a)}catch(u){}if(i)this.throwIfFileIsReadonly(a,i);else throw new k.FileOperationError((0,S.localize)(20,null,this.resourceForError(a)),1);if(!!!o?.recursive){const u=await this.resolve(a);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(a)))}return t}async del(a,o){const t=await this.doValidateDelete(a,o),r=!!o?.useTrash,i=!!o?.recursive;await t.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(a,1))}onDidChangeFile(a,o){this._onDidChangeFilesRaw.fire({changes:a});let t,r;{for(const i of a)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!o))}if(r){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,o={recursive:!1,excludes:[]}){const t=new R.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,R.toDisposable)(()=>i())),this.doWatch(a,o).then(s=>{r?(0,R.dispose)(s):i=()=>(0,R.dispose)(s)},s=>this.logService.error(s))}return o.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),t.add((0,R.toDisposable)(()=>{const r=this.watchedResources.get(a);typeof r=="number"&&(r<=1?this.watchedResources.delete(a):this.watchedResources.set(a,r-1))}))),t}async doWatch(a,o){const t=await this.withProvider(a),r=this.toWatchKey(t,a,o),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,o)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,R.toDisposable)(()=>{i.count--,i.count===0&&((0,R.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,o,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(o),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,R.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(a,i,r):await this.doWriteReadableBufferedQueued(a,i,r)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,o,t){let r=0,i;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,o,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,u)=>{(0,m.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(a,o,c,c.byteLength,r,0)}catch(l){return u(l)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>u(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,o,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(a,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,o,t,r,i,s){let u=0;for(;u<r;)u+=await a.write(o,i+u,t.buffer,s+u,r-u)}async doWriteUnbuffered(a,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,o,t,r))}async doWriteUnbufferedQueued(a,o,t,r){let i;r instanceof y.VSBuffer?i=r:(0,m.isReadableStream)(r)?i=await(0,y.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?i=await(0,y.bufferedStreamToBuffer)(r):i=(0,y.readableToBuffer)(r),await a.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(a,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,o,t,r))}async doPipeBufferedQueued(a,o,t,r){let i,s;try{i=await a.open(o,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const u=y.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,d=0;do d=await a.read(i,c,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,s,u,d,c,l),c+=d,l+=d,l===u.byteLength&&(l=0);while(d>0)}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await v.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,o,t,r))}async doPipeUnbufferedQueued(a,o,t,r){return t.writeFile(r,await a.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,o,t,r))}async doPipeUnbufferedToBufferedQueued(a,o,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await a.readFile(o);await this.doWriteBuffer(t,i,y.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(a,o,t,r){const i=await(0,y.streamToBuffer)(this.readFileBuffered(a,o,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(a,o){if(a.capabilities&2048)throw new k.FileOperationError((0,S.localize)(22,null,this.resourceForError(o)),6);return a}throwIfFileIsReadonly(a,o){if((o.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,S.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===I.Schemas.file?a.fsPath:a.toString(!0)}};C.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},C=fe([Y(0,n.ILogService)],C),e.FileService=C}),define(Z[163],ee([0,1,2,14,3,7,18,8,15,42,5,10,121,75,139,141,138,150,49,78,23,25]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends S.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:u}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(i,c.name))).type:l=this.toType(c),u.push([c.name,l])}catch(l){this.logService.trace(l)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let u;return s?.dangling?u=L.FileType.Unknown:i.isFile()?u=L.FileType.File:i.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,s&&(u|=L.FileType.SymbolicLink),u}async readFile(i){try{const s=this.toFilePath(i);return await A.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,u){const c=(0,C.newWriteableStream)(l=>o.VSBuffer.concat(l.map(d=>o.VSBuffer.wrap(d))).buffer);return(0,f.readFileIntoStream)(this,i,c,l=>l.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),c}async writeFile(i,s,u){let c;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await A.Promises.exists(l)){if(!u.overwrite)throw(0,L.createFileSystemProviderError)((0,m.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,L.createFileSystemProviderError)((0,m.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof c=="number"&&await this.close(c)}}async open(i,s){try{const u=this.toFilePath(i);if((0,L.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:d}=await A.SymlinkSupport.stat(u);d.mode&128||await A.Promises.chmod(u,d.mode|128)}catch(d){this.logService.trace(d)}let c;if((0,L.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await A.Promises.truncate(u,0),c="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}c||(c="w")}else c="r";const l=await A.Promises.open(u,c);return this.mapHandleToPos.set(l,0),(0,L.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(l,i),l}catch(u){throw(0,L.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await A.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,u,c,l){const d=this.normalizePos(i,s);let E=null;try{const g=await A.Promises.read(i,u,c,l,d);return typeof g=="number"?E=g:E=g.bytesRead,E}catch(g){throw this.toFileSystemProviderError(g)}finally{this.updatePos(i,d,E)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,u){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,c+u):this.mapHandleToPos.delete(i)))}async write(i,s,u,c,l){return(0,n.retry)(()=>this.doWrite(i,s,u,c,l),100,3)}async doWrite(i,s,u,c,l){const d=this.normalizePos(i,s);let E=null;try{const g=await A.Promises.write(i,u,c,l,d);return typeof g=="number"?E=g:E=g.bytesWritten,E}catch(g){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),g)}finally{this.updatePos(i,d,E)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const u=this.toFilePath(i);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,s){s.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,s,u){const c=this.toFilePath(i),l=this.toFilePath(s);if(c!==l)try{await this.validateTargetDeleted(i,s,"move",u.overwrite),await A.Promises.move(c,l)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,m.localize)(2,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(i,s,u){const c=this.toFilePath(i),l=this.toFilePath(s);if(c!==l)try{await this.validateTargetDeleted(i,s,"copy",u.overwrite),await A.Promises.copy(c,l,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,m.localize)(3,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(i,s,u,c){const l=this.toFilePath(i),d=this.toFilePath(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,w.isEqual)(l,d,!0)),E&&u==="copy")throw(0,L.createFileSystemProviderError)((0,m.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!E&&await A.Promises.exists(d)){if(!c)throw(0,L.createFileSystemProviderError)((0,m.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const u={path:this.toFilePath(i),excludes:s},c=(0,a.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,S.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,S.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=h.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=I.FileWatcher:i=h.FileWatcher:i=D.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,v.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===y.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new b.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire((0,v.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===y.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,S.combinedDisposable)(s,u)}toFilePath(i){return(0,P.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=L.FileSystemProviderErrorCode.NoPermissions;break;default:s=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let u=this.toFileSystemProviderError(s);if(i&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await A.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(u=(0,L.createFileSystemProviderError)(s,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return u}dispose(){super.dispose(),(0,S.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,S.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(Z[164],ee([0,1,8,11,2,18,28,5,10]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends R.Disposable{constructor(y,m,v){super();this.productService=m,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new P.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},30*1e3)).schedule()}async cleanUpCodeCaches(y){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),v=(0,S.dirname)(y),h=(0,S.basename)(y),I=await k.Promises.readdir(v);await Promise.all(I.map(async D=>{if(D===h)return;const b=(0,S.join)(v,D),C=await k.Promises.stat(b);if(C.isDirectory()&&m-C.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${D}.`),k.Promises.rm(b)}))}catch(m){(0,L.onUnexpectedError)(m)}}};w=fe([Y(1,A.IProductService),Y(2,p.ILogService)],w),e.CodeCacheCleaner=w}),define(Z[165],ee([0,1,8,18,28,2,11,10,9,5]),function(K,e,S,L,R,k,A,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(m,v,h){super();this.environmentService=m,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new w.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),v=JSON.parse(await L.Promises.readFile((0,S.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let C of Object.keys(v)){const f=v[C];m[`${f.hash}.${C}`]=!0}const h=(0,S.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const D=await L.Promises.readdir(h);for(const C of D){if(m[C]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await L.Promises.rm((0,S.join)(h,C))}const b=Date.now();for(const C of Object.keys(m)){const f=(0,S.join)(h,C),a=await L.Promises.readdir(f);for(const o of a){if(o==="tcf.json")continue;const t=(0,S.join)(f,o),r=await L.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,S.join)(C,o)}`),await L.Promises.rm(t))}}}catch(m){(0,A.onUnexpectedError)(m)}}};n=fe([Y(0,p.INativeEnvironmentService),Y(1,P.ILogService),Y(2,R.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[32],ee([0,1,16,88]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(A,P){L.ok(S.isString(A)),L.ok(S.isObject(P)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new R}),define(Z[79],ee([0,1,32,3]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,w){this.schemasById[R(p)]=w,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;S.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[37],ee([0,1,110,3,32,16,79]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=R.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,f=!0){this.registerConfigurations([C],f)}registerConfigurations(C,f=!0){const a=[];C.forEach(o=>{a.push(...this.validateAndRegisterProperties(o,f,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(C){const f=[],a=o=>{if(o.properties)for(const t in o.properties)f.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,o.properties[t]);o.allOf&&o.allOf.forEach(t=>a(t))};for(const o of C){a(o);const t=this.configurationContributors.indexOf(o);t!==-1&&this.configurationContributors.splice(t,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(C){const f=[],a=[];for(const o of C)for(const t in o)if(f.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...o[t]};const r={type:"object",default:this.defaultValues[t],description:S.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(m(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=o[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(C){const f=[];for(const a of C)for(const o in a)if(f.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const f of C)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,f=!0,a,o=3){o=k.isUndefinedOrNull(C.scope)?o:C.scope;let t=[],r=C.properties;if(r)for(let s in r){if(f&&I(s)){delete r[s];continue}const u=r[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=k.isUndefinedOrNull(u.scope)?o:u.scope,u.restricted=k.isUndefinedOrNull(u.restricted)?!!a?.restrictedConfigurations?.includes(s):u.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=C.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,f,a,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const f=a=>{let o=a.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let t=a.allOf;t&&t.forEach(f)};f(C)}updateSchema(C,f){switch(e.allSettings.properties[C]=f,f.scope){case 1:e.applicationSettings.properties[C]=f;break;case 2:e.machineSettings.properties[C]=f;break;case 6:e.machineOverridableSettings.properties[C]=f;break;case 3:e.windowSettings.properties[C]=f;break;case 4:e.resourceSettings.properties[C]=f;break;case 5:e.resourceSettings.properties[C]=f,this.resourceLanguageSettingsSchema.properties[C]=f;break}}removeFromSchema(C,f){switch(delete e.allSettings.properties[C],f.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const f=`[${C}]`,a={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,a),e.allSettings.properties[f]=a,e.applicationSettings.properties[f]=a,e.machineSettings.properties[f]=a,e.machineOverridableSettings.properties[f]=a,e.windowSettings.properties[f]=a,e.resourceSettings.properties[f]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,f){let a=this.defaultValues[C];k.isUndefined(a)&&(a=f.default),k.isUndefined(a)&&(a=v(f.type)),f.default=a}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function m(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=m;function v(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const h=new n;R.Registry.add(e.Extensions.Configuration,h);function I(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=I;function D(){const b=[],C=h.getConfigurationProperties();for(const f of Object.keys(C))b.push([f,C[f].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=D}),define(Z[24],ee([0,1,26,16,4,32,6,37]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=p;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function y(r,i){const s=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],u=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],c=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),$=b(i.contents,T);S.equals(O,$)||c.push(T)}}const l=[],d=T=>{const O={};for(const $ of T)for(const x of $.identifiers)O[o(x)]=$;return O},E=i?d(i.overrides):{},g=r?d(r.overrides):{};if(Object.keys(E).length)for(const T of s){const O=E[T];O&&l.push([(0,P.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(g).length)for(const T of u){const O=g[T];O&&l.push([(0,P.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(E).length&&Object.keys(g).length)for(const T of c){const O=g[T],$=E[T];if(O&&$){const x=y({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});l.push([(0,P.overrideIdentifierFromKey)(T),[...x.added,...x.removed,...x.updated]])}}return{added:s,removed:u,updated:c,overrides:l}}e.compare=y;function m(r,i){const s=[];for(const u of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(u)){const c={};for(const l in r[u])c[l]=r[u][l];s.push({identifiers:[(0,P.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(c),contents:v(c,i)})}return s}e.toOverrides=m;function v(r,i){const s=Object.create(null);for(let u in r)h(s,u,r[u],i);return s}e.toValuesTree=v;function h(r,i,s,u){const c=i.split("."),l=c.pop();let d=r;for(let E=0;E<c.length;E++){let g=c[E],T=d[g];switch(typeof T){case"undefined":T=d[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(T)}`);return}d=T}if(typeof d=="object"&&d!==null)try{d[l]=s}catch(E){u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(d)}`)}else u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=h;function I(r,i){const s=i.split(".");D(r,s)}e.removeFromValueTree=I;function D(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const u=r[s];typeof u=="object"&&!Array.isArray(u)&&(D(u,i),Object.keys(u).length===0&&delete r[s])}}function b(r,i,s){function u(d,E){let g=d;for(const T of E){if(typeof g!="object"||g===null)return;g=g[T]}return g}const c=i.split("."),l=u(r,c);return typeof l=="undefined"?s:l}e.getConfigurationValue=b;function C(r,i,s){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(i[u])?C(r[u],i[u],s):s&&(r[u]=i[u]):r[u]=i[u])})}e.merge=C;function f(){const r=k.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=f;function a(){const r=Object.create(null),i=k.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let s in i){let u=i[s].default;h(r,s,u,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=a;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,i,s){const u=r.inspect(i),c=r.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[166],ee([0,1,33,38,23,16,26,4,37,24,32,2,3]),function(K,e,S,L,R,k,A,P,p,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,w.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,w.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[s],c=r[s];c&&(typeof u=="object"&&typeof c=="object"?(u=A.deepClone(u),this.mergeContents(u,c)):u=c),i[s]=u}return new v(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const c of u.overrides){const[l]=i.filter(d=>R.equals(d.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):i.push(A.deepClone(c))}for(const c of u.keys)s.indexOf(c)===-1&&s.push(c)}return new v(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,w.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,w.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(){const t=(0,w.getDefaultValues)(),r=(0,w.getConfigurationKeys)(),i=[];for(const s of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,p.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,w.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class I{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:u,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new v(i,s,u),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,s=[],u=[],c=[];function l(E){Array.isArray(s)?s.push(E):i!==null&&(s[i]=E)}let d={onObjectBegin:()=>{let E={};l(E),u.push(s),s=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let E=[];l(E),u.push(s),s=E,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:l,onError:(E,g,T)=>{c.push({error:E,offset:g,length:T})}};if(t)try{S.visit(t,d),r=s[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const u=(0,w.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),c=Object.keys(t),l=(0,w.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:u,keys:c,overrides:l,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const u={},c=[];for(let l in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const d=this.filter(t[l],r,!1,s);u[l]=d.raw,c.push(...d.restricted)}else{const d=r[l],E=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&c.push(l),(E===void 0||s.scopes===void 0||s.scopes.includes(E))&&(s.skipRestricted&&d?.restricted||(u[l]=t[l]))}return{raw:u,restricted:c}}}e.ConfigurationModelParser=I;class D extends y.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,i=new v,s=new v,u=new L.ResourceMap,c=new v,l=new L.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new v,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,$=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),x=s.getValue(t),G=R.distinct(R.flatten(s.overrides.map(B=>B.identifiers))).filter(B=>s.getOverrideValue(t,B)!==void 0);return{defaultValue:l,userValue:d,userLocalValue:E,userRemoteValue:g,workspaceValue:T,workspaceFolderValue:O,memoryValue:$,value:x,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>p.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,p.overrideIdentifierFromKey)(s),c=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),d=[...l.filter(E=>c.indexOf(E)===-1),...c.filter(E=>l.indexOf(E)===-1),...c.filter(E=>!A.equals(this._defaultConfiguration.override(u).getValue(E),t.override(u).getValue(E)))];return[u,d]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,w.compare)(this.localUserConfiguration,t),c=[...r,...i,...s];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,w.compare)(this.remoteUserConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,w.compare)(this.workspaceConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:u,removed:c,overrides:l}=(0,w.compare)(i,r);let d=[...s,...u,...c];return(d.length||!i)&&this.updateFolderConfiguration(t,r),{keys:d,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:u,overrides:c}=(0,w.compare)(r,void 0);return{keys:[...i,...s,...u],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((c,l)=>(c.set(P.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new L.ResourceMap);return new b(r,i,new v,s,u,new v,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function C(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const s of o)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,c])=>{const l=(0,L.getOrSet)(r,u,new Set);c.forEach(d=>l.add(d))});const i=[];return r.forEach((s,u)=>i.push([u,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=C;class f{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(d=>u.add(d))),this.affectedKeys=[...u.values()];const c=new v;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,w.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=f;class a extends f{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=a}),define(Z[167],ee([0,1,32,37,2,24,166,3,5,15]),function(K,e,S,L,R,k,A,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends R.Disposable{constructor(m,v){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,v)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const h=typeof m=="string"?m:void 0,I=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,I,void 0)}updateValue(m,v,h,I){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,v,1)}onDidDefaultConfigurationChange(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,m);this.trigger(h,v,6)}trigger(m,v,h){const I=new A.ConfigurationChangeEvent(m,{data:v},this.configuration);I.source=h,I.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(I)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[168],ee([0,1,24,10,104]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,p){this.configurationService=P,this.logService=p}request(P,p){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,p)}async resolveProxy(P){}};k=fe([Y(0,S.IConfigurationService),Y(1,L.ILogService)],k),e.RequestService=k}),define(Z[40],ee([0,1,122,6,37,32,25]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function p(h){return h.res.statusCode===204}async function w(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return p(h)?null:(await(0,A.streamToBuffer)(h.stream)).toString()}e.asText=w;async function n(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const D=(await(0,A.streamToBuffer)(h.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=n;function y(h){v(h)}e.updateProxyConfigurationsScope=y;let m;function v(h){const I=k.Registry.as(R.Extensions.Configuration);m&&I.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),restricted:!0}}},I.registerConfiguration(m)}v(2)}),define(Z[169],ee([0,1,40,29,14,17]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(p,w){this.requestService=p,this.fileService=w}async download(p,w,n=L.CancellationToken.None){if(p.scheme===k.Schemas.file||p.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(p,w);return}const y={type:"GET",url:p.toString()},m=await this.requestService.request(y,n);if(m.res.statusCode===200)await this.fileService.writeFile(w,m.stream);else{const v=await(0,S.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};A=fe([Y(0,S.IRequestService),Y(1,R.IFileService)],A),e.DownloadService=A}),define(Z[170],ee([0,1,28,14,23,63,40,29,10,15,134,2]),function(K,e,S,L,R,k,A,P,p,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends y.Disposable{constructor(h,I,D,b){super();this.fileService=h,this.productService=I,this.requestService=D,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:C})=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const I=[];for(const[D,b]of this.allConfigBasedTips)try{const C=await this.fileService.readFile((0,w.joinPath)(h,D)),f=new Map;(0,k.forEach)(b.recommendations,({key:o,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const r of t.remotes)f.set(r,{extensionId:o,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else I.push({extensionId:o,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const a=(0,n.getDomainsOfRemotes)(C.value.toString(),[...f.keys()]);for(const o of a){const t=f.get(o);t&&I.push(t)}}catch(C){}return I}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},P.CancellationToken.None);if(h.res.statusCode!==200)return[];const I=await(0,A.asJson)(h);return I?I.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};m=fe([Y(0,L.IFileService),Y(1,S.IProductService),Y(2,A.IRequestService),Y(3,p.ILogService)],m),e.ExtensionTipsService=m}),define(Z[45],ee([0,1,30,25]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,A,P){let p=P&&P.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();p=(0,S.isUUID)(n)?n:null}catch(w){p=null}if(!p){p=(0,S.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(p))}catch(w){}}return P&&P.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=R}),define(Z[20],ee([0,1,6,3,2,16,69,5]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var w;(function(I){I[I.NONE=0]="NONE",I[I.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(I){I[I.GLOBAL=0]="GLOBAL",I[I.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var y;(function(I){I[I.USER=0]="USER",I[I.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class m extends R.Disposable{constructor(D={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===p?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,C){return this.getStorage(b)?.get(D,C)}getBoolean(D,b,C){return this.getStorage(b)?.getBoolean(D,C)}getNumber(D,b,C){return this.getStorage(b)?.getNumber(D,C)}store(D,b,C,f){if((0,k.isUndefinedOrNull)(b)){this.remove(D,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,C,f),this.getStorage(C)?.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,void 0),this.getStorage(b)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const C=[],f=this.getKeyTargets(D);for(const a of Object.keys(f))f[a]===b&&C.push(a);return C}updateKeyTarget(D,b,C){const f=this.getKeyTargets(b);typeof C=="number"?f[D]!==C&&(f[D]=C,this.getStorage(b)?.set(p,JSON.stringify(f))):typeof f[D]=="number"&&(delete f[D],this.getStorage(b)?.set(p,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(p,D);if(b)try{return JSON.parse(b)}catch(C){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await P.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(D,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends m{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=v;async function h(I,D,b,C){const f=u=>{try{return JSON.parse(u)}catch(c){return u}},a=new Map,o=new Map;I.forEach((u,c)=>{a.set(c,u),o.set(c,f(u))});const t=new Map,r=new Map;D.forEach((u,c)=>{t.set(c,u),r.set(c,f(u))}),console.group(`Storage: Global (path: ${b})`);let i=[];a.forEach((u,c)=>{i.push({key:c,value:u})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${C})`);let s=[];t.forEach((u,c)=>{s.push({key:c,value:u})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=h}),define(Z[171],ee([0,1,3,2,27,31,20,16]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends L.Disposable{constructor(y){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(y)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(y,m){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}async disableExtension(y,m){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){let m=this.getDisabledExtensions();return m.every(v=>!(0,k.areSameExtensions)(v,y))?(m.push(y),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(y){let m=this.getDisabledExtensions();for(let v=0;v<m.length;v++){const h=m[v];if((0,k.areSameExtensions)(h,y))return m.splice(v,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(y){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,m){this.storageManger.set(y,m,0)}};p=fe([Y(0,A.IStorageService)],p),e.GlobalExtensionEnablementService=p;class w extends L.Disposable{constructor(y){super();this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(y,m){let v;return m===0?((0,P.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,m)),v=this.storage[y]):v=this._get(y,m),JSON.parse(v)}set(y,m,v){let h=JSON.stringify(m.map(({id:D,uuid:b})=>({id:D,uuid:b})));this._get(y,v)!==h&&(v===0&&(m.length?this.storage[y]=h:delete this.storage[y]),this._set(y,m.length?h:void 0,v))}onDidStorageChange(y){if(y.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const v=this.get(y.key,y.scope);delete this.storage[y.key];const h=this.get(y.key,y.scope),I=v.filter(b=>!h.some(C=>(0,k.areSameExtensions)(b,C))),D=h.filter(b=>!v.some(C=>(0,k.areSameExtensions)(C,b)));(I.length||D.length)&&this._onDidChange.fire([...I,...D])}}_get(y,m){return this.storageService.get(y,m,"[]")}_set(y,m,v){m?this.storageService.store(y,m,v,1):this.storageService.remove(y,v)}}e.StorageManager=w}),define(Z[172],ee([0,1,3,2]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n}async getItems(){const w={workspace:this.workspace},n=await this.channel.call("getItems",w);return new Map(n)}updateItems(w){const n={workspace:this.workspace};return w.insert&&(n.insert=Array.from(w.insert.entries())),w.delete&&(n.delete=Array.from(w.delete.values())),this.channel.call("updateItems",n)}}class k extends R{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class A extends R{constructor(w,n){super(w,n);this.onDidChangeItemsExternal=S.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class P extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[173],ee([0,1,2,20,69,5,162,172,15]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(y,m,v){super();this.mainProcessService=m,this.environmentService=v,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(y)}createGlobalStorage(){const y=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new R.Storage(y.globalStorage);return this._register(m.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),m}createWorkspaceStorage(y){const m=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),y);if(m.workspaceStorage){const v=new R.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=v.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=y?.id,v}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,p.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(y){const m=this.workspaceStorage,v=m?.items??new Map;m&&(await m.close(),m.dispose()),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init();for(const[h,I]of v)this.workspaceStorage.set(h,I)}}e.NativeStorageService=w}),define(Z[174],ee([0,1,7,34,30,4]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(S.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,n,y,m,v,h,I,D,b,C){const f=Object.create(null);f["common.machineId"]=I,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=v,f.version=h,f["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,S.PlatformToString)(S.platform),f["common.nodePlatform"]=L.platform,f["common.nodeArch"]=m,f["common.product"]=C||"desktop";const a=p(D||[]);a&&(f["common.msftInternal"]=a);let o=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),S.isLinuxSnap&&(f["common.snap"]="true");const r=A(y);r&&(f["common.platformDetail"]=r);try{const i=await w.readFile(k.URI.file(b));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}e.resolveCommonProperties=P;function p(w){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const y=n.toLowerCase();return w.some(m=>y===m)}e.verifyMicrosoftInternalDomain=p}),define(Z[21],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[175],ee([0,1,35,96,71,8,33,99,28,7,4,21,55,17,14,18]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(o,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,u=2e4;function c(E,g,T,O){const $=g.substring(E.length+1);return new Promise(async x=>{let G;try{G=await I.Promises.readdir(g,{withFileTypes:!0})}catch(M){x();return}if(O.count>=u){O.count+=G.length,O.maxReached=!0,x();return}let B=G.length;if(B===0){x();return}let U=G;O.count+G.length>u&&(O.maxReached=!0,B=u-O.count,U=G.slice(0,B)),O.count+=G.length;for(const M of U)if(M.isDirectory()){if(T.includes(M.name)||await c(E,(0,k.join)(g,M.name),T,O),--B==0){x();return}}else{const F=M.name.lastIndexOf(".");if(F>=0){const j=M.name.substring(F+1);j&&i.set(j,(i.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test($)!==!1&&j.filePattern.test(M.name)&&s.set(j.tag,(s.get(j.tag)??0)+1);if(--B==0){x();return}}})}const l={count:0,maxReached:!1};await c(o,o,t,l);const d=await f(o);return{configFiles:b(s),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=D;function b(o){return[...m.Iterable.map(o.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function C(){const o={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=S.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=C;async function f(o){try{const t=new Map,r=(0,k.join)(o,".vscode","launch.json"),i=await I.Promises.readFile(r),s=[],u=(0,A.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(u)==="object"&&u.configurations)for(const c of u.configurations){const l=c.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=f;let a=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${S.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,P.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,u]=i,c=this.formatProcessList(t,s);return r.forEach(l=>{if((0,R.isRemoteDiagnosticError)(l))c+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(c+=`

Remote: ${l.hostName}`,l.processes&&(c+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const d of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[d];let g=`${E.fileCount} files`;E.maxFilesReached&&(g=`more than ${g}`),u+=`|    Folder (${d}): ${g}`,u+=this.formatWorkspaceStats(E)}}}),{processInfo:c,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:u,cpus:c}=C(),l={os:u,memory:i,cpus:c,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(l.load=`${S.loadavg().map(d=>Math.round(d)).join(", ")}`),w.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return(0,P.listProcesses)(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,R.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const c of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[c];let d=`${l.fileCount} files`;l.maxFilesReached&&(d=`more than ${d}`),i.push(`Folder (${c}): ${d}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const u=(E,g)=>{const T=` ${E}(${g})`;s+T.length>i?(r.push(c),c="|                 ",s=c.length):s+=T.length,c+=T};let c="|      File types:";const l=10;let d=t.fileTypes.length>l?l:t.fileTypes.length;for(let E=0;E<d;E++){const g=t.fileTypes[E];u(g.name,g.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",s=0,t.configFiles.forEach(E=>{u(E.name,E.count)}),r.push(c)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(g=>{E+=g.count>1?` ${g.name}(${g.count})`:` ${g.name}`}),r.push(E)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const c=n.URI.revive(u);if(c.scheme===v.Schemas.file){const l=c.fsPath;i.push(D(l,["node_modules",".git"]).then(d=>{let E=`${d.fileCount} files`;d.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,k.basename)(l)}): ${E}`),r.push(this.formatWorkspaceStats(d))}).catch(d=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${d.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,u){const c=u===0;let l;c?l=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(l=`${l} (${r.get(s.pid)})`));const d=process.platform==="win32"?s.mem:S.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(d/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(s.children)&&s.children.forEach(E=>this.formatProcessItem(t,r,i,E,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==v.Schemas.file)continue;const s=i.fsPath;try{const u=await D(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};a=fe([Y(0,y.ITelemetryService),Y(1,p.IProductService)],a),e.DiagnosticsService=a}),define(Z[176],ee([0,1,111,2,27,31,3,44,10,21,29,11,4,5]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let h=class extends L.Disposable{constructor(f,a,o){super();this.galleryService=f,this.telemetryService=a,this.logService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(f,a={}){if(!this.galleryService.isEnabled())throw new Error(S.localize(0,null));try{f=await this.checkAndGetCompatibleVersion(f)}catch(t){throw this.logService.error((0,y.getErrorMessage)(t)),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}if(!await this.canInstall(f)){const t=new R.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",f.identifier.id,t.message),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}const o=await this.galleryService.getManifest(f,n.CancellationToken.None);if(o===null){const t=new R.ExtensionManagementError(`Missing manifest for extension ${f.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",f.identifier.id,t.message),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}return this.installExtension(o,f,a)}async uninstall(f,a={}){return this.logService.trace("ExtensionManagementService#uninstall",f.identifier.id),this.unininstallExtension(f,a)}async reinstallFromGallery(f){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",f.identifier.id),!this.galleryService.isEnabled())throw new Error(S.localize(1,null));const a=await this.findGalleryExtension(f);if(!a)throw new Error(S.localize(2,null));await this.createUninstallExtensionTask(f,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsReport(){const f=new Date().getTime();return(!this.reportedExtensions||f-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=f),this.reportedExtensions}registerParticipant(f){this.participants.push(f)}async installExtension(f,a,o){if(!m.URI.isUri(a)){let u=this.installingExtensions.get(new k.ExtensionIdentifierWithVersion(a.identifier,a.version).key());if(u)return this.logService.info("Extensions is already requested to install",a.identifier.id),u.waitUntilTaskIsFinished();o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],r=[],i=this.createInstallExtensionTask(f,a,o);m.URI.isUri(a)||this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(i.identifier,f.version).key(),i),this._onInstallExtension.fire({identifier:i.identifier,source:a}),this.logService.info("Installing extension:",i.identifier.id),t.push({task:i,manifest:f});let s=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",i.identifier.id);else try{const c=await this.getAllDepsAndPackExtensionsToInstall(i.identifier,f,!!o.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:l,manifest:d}of c)if(s=s||!!d.extensionDependencies?.some(E=>(0,k.areSameExtensions)({id:E},i.identifier)),this.installingExtensions.has(new k.ExtensionIdentifierWithVersion(l.identifier,l.version).key()))this.logService.info("Extension is already requested to install",l.identifier.id);else{const E=this.createInstallExtensionTask(d,l,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(E.identifier,d.version).key(),E),this._onInstallExtension.fire({identifier:E.identifier,source:l}),this.logService.info("Installing extension:",E.identifier.id),t.push({task:E,manifest:d})}}catch(c){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",i.identifier.id),this.logService.error(c),c}const u=t.reduce((c,{task:l,manifest:d})=>(c.set(l.identifier.id.toLowerCase(),{task:l,manifest:d}),c),new Map);for(;u.size;){let c;const l=[...u.values()].filter(({manifest:d})=>!d.extensionDependencies?.some(E=>u.has(E.toLowerCase())));l.length?c=u.size===1?l:l.filter(({task:d})=>!(d===i&&!s)):(this.logService.info("Found extensions with circular dependencies",l.map(({task:d})=>d.identifier.id)),c=[...u.values()]),await this.joinAllSettled(c.map(async({task:d})=>{const E=new Date().getTime();try{const g=await d.run();await this.joinAllSettled(this.participants.map(T=>T.postInstall(g,d.source,o,n.CancellationToken.None))),m.URI.isUri(d.source)||D(this.telemetryService,d.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(d.source),new Date().getTime()-E,void 0),r.push({local:g,identifier:d.identifier,operation:d.operation,source:d.source})}catch(g){throw m.URI.isUri(d.source)||D(this.telemetryService,d.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(d.source),new Date().getTime()-E,g),this.logService.error("Error while installing the extension:",d.identifier.id),this.logService.error(g),g}finally{u.delete(d.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:c})=>this.logService.info("Extension installed successfully:",c.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:c})=>(0,k.areSameExtensions)(c,i.identifier))[0].local}catch(u){if(t.forEach(({task:c})=>c.cancel()),r.length)try{const c=await Promise.allSettled(r.map(({local:l})=>this.createUninstallExtensionTask(l,{versionOnly:!0}).run()));for(let l=0;l<c.length;l++){const d=c[l],{identifier:E}=r[l];d.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",E.id):this.logService.warn("Rollback: Error while uninstalling extension",E.id,(0,y.getErrorMessage)(d.reason))}}catch(c){this.logService.warn("Error while rolling back extensions",(0,y.getErrorMessage)(c),r.map(({identifier:l})=>l.id))}throw this.logService.error("Failed to install extension:",i.identifier.id,(0,y.getErrorMessage)(u)),this._onDidInstallExtensions.fire(t.map(({task:c})=>({identifier:c.identifier,operation:1,source:c.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:c}of t)if(!m.URI.isUri(u.source)){const l=new k.ExtensionIdentifierWithVersion(u.identifier,c.version).key();this.installingExtensions.delete(l)||this.logService.warn("Installation task is not found in the cache",l)}}}async joinAllSettled(f){const a=[],o=[],t=await Promise.allSettled(f);for(const r of t)r.status==="fulfilled"?a.push(r.value):o.push(r.reason);if(o.length)throw I(o);return a}async getAllDepsAndPackExtensionsToInstall(f,a,o){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const r=[f,...t.map(u=>u.identifier)],i=[],s=async(u,c)=>{const l=c.extensionDependencies||[];if(c.extensionPack){const d=o?t.find(E=>(0,k.areSameExtensions)(E.identifier,u)):void 0;for(const E of c.extensionPack)d&&d.manifest.extensionPack&&d.manifest.extensionPack.some(g=>(0,k.areSameExtensions)({id:g},{id:E}))||l.every(g=>!(0,k.areSameExtensions)({id:g},{id:E}))&&l.push(E)}if(l.length){const d=[...r,...i.map(g=>g.gallery.identifier)],E=l.filter(g=>d.every(T=>!(0,k.areSameExtensions)(T,{id:g})));if(E.length){const g=await this.galleryService.query({names:E,pageSize:l.length},n.CancellationToken.None);for(const T of g.firstPage){if(d.find(x=>(0,k.areSameExtensions)(x,T.identifier)))continue;const O=await this.checkAndGetCompatibleVersion(T);if(!await this.canInstall(O)){this.logService.info("Skipping the extension as it cannot be installed",O.identifier.id);continue}const $=await this.galleryService.getManifest(O,n.CancellationToken.None);if($===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${O.identifier.id}`,e.INSTALL_ERROR_VALIDATING);i.push({gallery:O,manifest:$}),await s(O.identifier,$)}}}};return await s(f,a),t=await this.getInstalled(),i.filter(u=>!t.some(c=>(0,k.areSameExtensions)(c.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(f){if(await this.isMalicious(f))throw new R.ExtensionManagementError(S.localize(3,null,f.identifier.id),R.INSTALL_ERROR_MALICIOUS);const a=await this.galleryService.getCompatibleExtension(f);if(!a)throw new R.ExtensionManagementError(S.localize(4,null,f.identifier.id,P.default.version),R.INSTALL_ERROR_INCOMPATIBLE);return a}async isMalicious(f){const a=await this.getExtensionsReport();return(0,k.getMaliciousExtensionsSet)(a).has(f.identifier.id)}async unininstallExtension(f,a){const o=this.uninstallingExtensions.get(f.identifier.id.toLowerCase());if(o)return this.logService.info("Extensions is already requested to uninstall",f.identifier.id),o.waitUntilTaskIsFinished();const t=(u,c)=>{const l=this.createUninstallExtensionTask(u,c);return this.uninstallingExtensions.set(l.extension.identifier.id.toLowerCase(),l),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),l},r=(u,c)=>{c?this.logService.error("Failed to uninstall extension:",u.identifier.id,c.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),D(this.telemetryService,"extensionGallery:uninstall",(0,k.getLocalExtensionTelemetryData)(u),void 0,c),this._onDidUninstallExtension.fire({identifier:u.identifier,error:c?.code})},i=[],s=[];try{i.push(t(f,{}));const u=await this.getInstalled(1);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",f.identifier.id);else{const c=this.getAllPackExtensionsToUninstall(f,u);for(const l of c)this.uninstallingExtensions.has(l.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",l.identifier.id):i.push(t(l,{}))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",f.identifier.id):this.checkForDependents(i.map(c=>c.extension),u,f),await this.joinAllSettled(i.map(async c=>{try{if(await c.run(),await this.joinAllSettled(this.participants.map(l=>l.postUninstall(c.extension,a,n.CancellationToken.None))),c.extension.identifier.uuid)try{await this.galleryService.reportStatistic(c.extension.manifest.publisher,c.extension.manifest.name,c.extension.manifest.version,"uninstall")}catch(l){}r(c.extension)}catch(l){const d=l instanceof R.ExtensionManagementError?l:new R.ExtensionManagementError((0,y.getErrorMessage)(l),e.ERROR_UNKNOWN);throw r(c.extension,d),d}finally{s.push(c)}}))}catch(u){const c=u instanceof R.ExtensionManagementError?u:new R.ExtensionManagementError((0,y.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const l of i){try{l.cancel()}catch(d){}s.includes(l)||r(l.extension,c)}throw c}finally{for(const u of i)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(f,a,o){for(const t of f){const r=this.getDependents(t,a);if(r.length){const i=r.filter(s=>f.indexOf(s)===-1);if(i.length)throw new Error(this.getDependentsErrorMessage(t,i,o))}}}getDependentsErrorMessage(f,a,o){return o===f?a.length===1?S.localize(5,null,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?S.localize(6,null,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):S.localize(7,null,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?S.localize(8,null,o.manifest.displayName||o.manifest.name,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?S.localize(9,null,o.manifest.displayName||o.manifest.name,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):S.localize(10,null,o.manifest.displayName||o.manifest.name,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(f,a,o=[]){if(o.indexOf(f)!==-1)return[];o.push(f);const t=f.manifest.extensionPack?f.manifest.extensionPack:[];if(t.length){const r=a.filter(s=>!s.isBuiltin&&t.some(u=>(0,k.areSameExtensions)({id:u},s.identifier))),i=[];for(const s of r)i.push(...this.getAllPackExtensionsToUninstall(s,a,o));return[...r,...i]}return[]}getDependents(f,a){return a.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(t=>(0,k.areSameExtensions)({id:t},f.identifier)))}async findGalleryExtension(f){if(f.identifier.uuid){const a=await this.findGalleryExtensionById(f.identifier.uuid);return a||this.findGalleryExtensionByName(f.identifier.id)}return this.findGalleryExtensionByName(f.identifier.id)}async findGalleryExtensionById(f){return(await this.galleryService.query({ids:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(f){return(await this.galleryService.query({names:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const f=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${f.length} reported extensions from service`),f}catch(f){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};h=fe([Y(0,R.IExtensionGalleryService),Y(1,w.ITelemetryService),Y(2,p.ILogService)],h),e.AbstractExtensionManagementService=h;function I(C){const f=Array.isArray(C)?C:[C];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((a,o)=>new Error(`${a.message}${a.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=I;function D(C,f,a,o,t){const r=t?t instanceof R.ExtensionManagementError?t.code:e.ERROR_UNKNOWN:void 0;C.publicLogError(f,{...a,success:!t,duration:o,errorcode:r})}e.reportTelemetry=D;class b{constructor(){this.barrier=new v.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,v.createCancelablePromise)(f=>this.doRun(f))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,v.createCancelablePromise)(f=>new Promise((a,o)=>{const t=f.onCancellationRequested(()=>{t.dispose(),o((0,y.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=b}),define(Z[177],ee([0,1,11,27,31,26,21,40,70,9,29,10,14,4,28,20,45,6]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var C;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(C||(C={}));function f(...M){return String(M.reduce((F,j)=>F|j,0))}var a;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:C.None,criteria:[],assetTypes:[]};class s{constructor(F=i){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,j=this.state.pageSize){return new s({...this.state,pageNumber:F,pageSize:j})}withFilter(F,...j){const _=[...this.state.criteria,...j.length?j.map(N=>({filterType:F,value:N})):[{filterType:F}]];return new s({...this.state,criteria:_})}withSortBy(F){return new s({...this.state,sortBy:F})}withSortOrder(F){return new s({...this.state,sortOrder:F})}withFlags(...F){return new s({...this.state,flags:F.reduce((j,_)=>j|_,0)})}withAssetTypes(...F){return new s({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:j,pageSize:_,sortBy:N,sortOrder:W,flags:z,assetTypes:V}=this.state;return{filters:[{criteria:F,pageNumber:j,pageSize:_,sortBy:N,sortOrder:W}],assetTypes:V,flags:z}}get searchText(){const F=this.state.criteria.filter(j=>j.filterType===a.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(M,F){const j=(M||[]).filter(_=>_.statisticName===F)[0];return j?j.value:0}function c(M){const F="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(_=>_.assetType.indexOf(F)===0).reduce((_,N)=>{const W=g(M,N.assetType);return W&&_.push([N.assetType.substring(F.length),W]),_},[])}function l(M){if(M.properties){const F=M.properties.filter(N=>N.key===o.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=F.filter(N=>j.test(N.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return g(M,o.Repository)}function d(M){return{uri:`${M.fallbackAssetUri}/${o.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${o.VSIX}`}}function E(M){const F=g(M,o.Icon);if(F)return F;const j=L.DefaultIconPath;return{uri:j,fallbackUri:j}}function g(M,F){return M.files.filter(_=>_.assetType===F)[0]?{uri:`${M.assetUri}/${F}`,fallbackUri:`${M.fallbackAssetUri}/${F}`}:null}function T(M,F){const j=M.properties?M.properties.filter(N=>N.key===F):[],_=j.length>0&&j[0].value;return _?_.split(",").map(N=>(0,R.adoptToGalleryExtensionId)(N)):[]}function O(M){const F=M.properties?M.properties.filter(j=>j.key===t.Engine):[];return F.length>0&&F[0].value||""}function $(M){const F=M.properties?M.properties.filter(_=>_.key===t.LocalizedLanguages):[],j=F.length>0&&F[0].value||"";return j?j.split(","):[]}function x(M){return M.indexOf("preview")!==-1}function G(M,F,j,_,N){const W={manifest:g(F,o.Manifest),readme:g(F,o.Details),changelog:g(F,o.Changelog),license:g(F,o.License),repository:l(F),download:d(F),icon:E(F),coreTranslations:c(F)};return{identifier:{id:(0,R.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:F.version,date:F.lastUpdated,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:u(M.statistics,"install"),rating:u(M.statistics,"averagerating"),ratingCount:u(M.statistics,"ratingcount"),assetUri:v.URI.parse(F.assetUri),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(L.WEB_EXTENSION_TAG),assetTypes:F.files.map(({assetType:z})=>z),assets:W,properties:{dependencies:T(F,t.Dependency),extensionPack:T(F,t.ExtensionPack),engine:O(F),localizedLanguages:$(F)},telemetryData:{index:(_.pageNumber-1)*_.pageSize+j,querySource:N},preview:x(M.flags)}}let B=class{constructor(F,j,_,N,W,z,V){this.requestService=F,this.logService=j,this.environmentService=_,this.telemetryService=N,this.fileService=W,this.productService=z;const H=z.extensionsGallery;this.extensionsGalleryUrl=H&&H.serviceUrl,this.extensionsControlUrl=H&&H.controlUrl,this.commonHeadersPromise=U(z.version,this.environmentService,this.fileService,V)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,j){const _=[];let{total:N,firstPage:W,getPage:z}=await this.query({names:F,pageSize:F.length},j);_.push(...W);for(let V=1;_.length<N&&(W=await z(V,j),W.length);V++)_.push(...W);return _}async getCompatibleExtension(F,j){return this.getCompatibleExtensionByEngine(F,j)}async getCompatibleExtensionByEngine(F,j){const _=(0,L.isIExtensionIdentifier)(F)?null:F;if(_&&_.properties.engine&&(0,p.isEngineValid)(_.properties.engine,this.productService.version,this.productService.date))return _;const{id:N,uuid:W}=_?_.identifier:F;let z=new s().withFlags(C.IncludeAssetUri,C.IncludeStatistics,C.IncludeCategoryAndTags,C.IncludeFiles,C.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");W?z=z.withFilter(a.ExtensionId,W):z=z.withFilter(a.ExtensionName,N);const{galleryExtensions:V}=await this.queryGallery(z,n.CancellationToken.None),[H]=V;if(!H||!H.versions.length)return null;if(j){const Q=H.versions.filter(ie=>ie.version===j)[0];if(Q){const ie=G(H,Q,0,z);if(ie.properties.engine&&(0,p.isEngineValid)(ie.properties.engine,this.productService.version,this.productService.date))return ie}return null}const X=await this.getLastValidExtensionVersion(H,H.versions);return X?G(H,X,0,z):null}async query(F,j){const _=n.CancellationToken.isCancellationToken(F)?{}:F,N=n.CancellationToken.isCancellationToken(F)?F:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=_.text||"";const z=(0,k.getOrDefault)(_,ne=>ne.pageSize,50);let V=new s().withFlags(C.IncludeLatestVersionOnly,C.IncludeAssetUri,C.IncludeStatistics,C.IncludeCategoryAndTags,C.IncludeFiles,C.IncludeVersionProperties).withPage(1,z).withFilter(a.Target,"Microsoft.VisualStudio.Code");W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,le,de)=>(V=V.withFilter(a.Category,de||le),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,le,de)=>(V=V.withFilter(a.Tag,de||le),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(a.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),V=V.withFilter(a.SearchText,W)),V=V.withSortBy(0)):_.ids?V=V.withFilter(a.ExtensionId,..._.ids):_.names?V=V.withFilter(a.ExtensionName,..._.names):V=V.withSortBy(4),typeof _.sortBy=="number"&&(V=V.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(V=V.withSortOrder(_.sortOrder));const{galleryExtensions:H,total:X}=await this.queryGallery(V,N),Q=H.map((ne,le)=>G(ne,ne.versions[0],le,V,_.source)),ie=async(ne,le)=>{if(le.isCancellationRequested)throw(0,S.canceled)();const de=V.withPage(ne+1),{galleryExtensions:ye}=await this.queryGallery(de,le);return ye.map((pe,Pe)=>G(pe,pe.versions[0],Pe,de,_.source))};return{firstPage:Q,total:X,pageSize:V.pageSize,getPage:ie}}async queryGallery(F,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,C.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,f(C.Unpublished));const _=await this.commonHeadersPromise,N=JSON.stringify(F.raw),W={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)},z=new Date().getTime();let V,H,X=0;try{if(V=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:W},j),V.res.statusCode&&V.res.statusCode>=400&&V.res.statusCode<500)return{galleryExtensions:[],total:X};const Q=await(0,P.asJson)(V);if(Q){const ie=Q.results[0],ne=ie.extensions,le=ie.resultMetadata&&ie.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return X=le&&le.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:X}}return{galleryExtensions:[],total:X}}catch(Q){throw H=Q,Q}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(N.length),duration:new Date().getTime()-z,success:!!V&&(0,P.isSuccess)(V),responseBodySize:V?.res.headers["Content-Length"],statusCode:V?String(V.res.statusCode):void 0,errorCode:H?(0,S.isPromiseCanceledError)(H)?"canceled":(0,S.getErrorMessage)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(F,j,_,N){if(!this.isEnabled())return;const z={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${F}/extensions/${j}/${_}/stats?statType=${N}`),headers:z},n.CancellationToken.None)}catch(V){}}async download(F,j,_){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const N=(0,R.getGalleryExtensionTelemetryData)(F),W=new Date().getTime(),z=Q=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...N,duration:Q}),V=_===1?"install":_===2?"update":"",H=V?{uri:`${F.assets.download.uri}&${V}=true`,fallbackUri:`${F.assets.download.fallbackUri}?${V}=true`}:F.assets.download,X=await this.getAsset(H);await this.fileService.writeFile(j,X.stream),z(new Date().getTime()-W)}async getReadme(F,j){if(F.assets.readme){const _=await this.getAsset(F.assets.readme,{},j);return await(0,P.asText)(_)||""}return""}async getManifest(F,j){if(F.assets.manifest){const _=await this.getAsset(F.assets.manifest,{},j),N=await(0,P.asText)(_);return N?JSON.parse(N):null}return null}async getCoreTranslation(F,j){const _=F.assets.coreTranslations.filter(N=>N[0]===j.toUpperCase())[0];if(_){const N=await this.getAsset(_[1]),W=await(0,P.asText)(N);return W?JSON.parse(W):null}return null}async getChangelog(F,j){if(F.assets.changelog){const _=await this.getAsset(F.assets.changelog,{},j);return await(0,P.asText)(_)||""}return""}async getAllVersions(F,j){let _=new s().withFlags(C.IncludeVersions,C.IncludeCategoryAndTags,C.IncludeFiles,C.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?_=_.withFilter(a.ExtensionId,F.identifier.uuid):_=_.withFilter(a.ExtensionName,F.identifier.id);const N=[],{galleryExtensions:W}=await this.queryGallery(_,n.CancellationToken.None);return W.length&&(j?await Promise.all(W[0].versions.map(async z=>{let V;try{V=await this.getEngine(z)}catch(H){}V&&(0,p.isEngineValid)(V,this.productService.version,this.productService.date)&&N.push({version:z.version,date:z.lastUpdated})})):N.push(...W[0].versions.map(z=>({version:z.version,date:z.lastUpdated})))),N}async getAsset(F,j={},_=n.CancellationToken.None){const N=await this.commonHeadersPromise,W={type:"GET"},z={...N,...j.headers||{}};j={...j,...W,headers:z};const V=F.uri,H=F.fallbackUri,X={...j,url:V};try{const Q=await this.requestService.request(X,_);if(Q.res.statusCode===200)return Q;const ie=await(0,P.asText)(Q);throw new Error(`Expected 200, got back ${Q.res.statusCode} instead.

${ie}`)}catch(Q){if((0,S.isPromiseCanceledError)(Q))throw Q;const ie=(0,S.getErrorMessage)(Q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:V,message:ie});const ne={...j,url:H};return this.requestService.request(ne,_)}}async getLastValidExtensionVersion(F,j){const _=this.getLastValidExtensionVersionFromProperties(F,j);return _||this.getLastValidExtensionVersionRecursively(F,j)}getLastValidExtensionVersionFromProperties(F,j){for(const _ of j){const N=O(_);if(!N)return null;if((0,p.isEngineValid)(N,this.productService.version,this.productService.date))return _}return null}async getEngine(F){const j=O(F);if(j)return j;const _=g(F,o.Manifest);if(!_)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},W=await this.getAsset(_,{headers:N}),z=await(0,P.asJson)(W);if(z)return z.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(F,j){if(!j.length)return null;const _=j[0],N=await this.getEngine(_);return(0,p.isEngineValid)(N,this.productService.version,this.productService.date)?{..._,properties:[..._.properties||[],{key:t.Engine,value:N}]}:this.getLastValidExtensionVersionRecursively(F,j.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,P.asJson)(F),_=new Map;if(j)for(const N of j.malicious){const W=_.get(N)||{id:{id:N},malicious:!0,slow:!1};W.malicious=!0,_.set(N,W)}return[..._.values()]}};B=fe([Y(0,P.IRequestService),Y(1,y.ILogService),Y(2,w.IEnvironmentService),Y(3,A.ITelemetryService),Y(4,m.IFileService),Y(5,h.IProductService),Y(6,(0,b.optional)(I.IStorageService))],B),e.ExtensionGalleryService=B;async function U(M,F,j,_){const N={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},W=await(0,D.getServiceMachineId)(F,j,_);return N["X-Market-User-Id"]=W,N}e.resolveMarketplaceHeaders=U}),define(Z[178],ee([0,1,4,8,28,9,34,14,7,23,27,63,40,10,170,5,21,73,113,20,3,59]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(u,c,l,d,E,g,T,O,$,x){super(T,O,$,x);this.environmentService=u,this.telemetryService=c,this.extensionManagementService=l,this.storageService=d,this.nativeHostService=E,this.extensionRecommendationNotificationService=g,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,y.forEach)(O.exeBasedExtensionTips,({key:G,value:B})=>{const U=[],M=[],F=[];(0,y.forEach)(B.recommendations,({key:j,value:_})=>{_.important?B.important?U.push({extensionId:j,extensionName:_.name,isExtensionPack:!!_.isExtensionPack}):M.push({extensionId:j,extensionName:_.name,isExtensionPack:!!_.isExtensionPack}):F.push({extensionId:j,extensionName:_.name,isExtensionPack:!!_.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(G,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:U}),M.length&&this.mediumImportanceExecutableTips.set(G,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:M}),F.length&&this.allOtherExecutableTips.set(G,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:F})}),(0,I.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(u,c){const l=new Map;u.forEach(O=>l.set(O.extensionId.toLowerCase(),O));const{installed:d,uninstalled:E}=this.groupByInstalled([...l.keys()],c);for(const O of d){const $=l.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:$.exeName})}for(const O of E){const $=l.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:$.exeName})}const g=this.getPromptedExecutableTips(),T=new Map;for(const O of E){const $=l.get(O);if($&&(!g[$.exeName]||!g[$.exeName].includes($.extensionId))){let x=T.get($.exeName);x||(x=[],T.set($.exeName,x)),x.push($)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const d=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register((0,I.disposableTimeout)(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),c=Date.now()-u,l=7*24*60*60*1e3;if(c<l){const g=this._register((0,I.disposableTimeout)(()=>{g.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[d,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(g=>{switch(g){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(E[0].exeName,E);const T=this._register((0,I.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const $=this._register((0,I.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const c=u.map(({extensionId:d})=>d.toLowerCase()),l=(0,C.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,c){const l=this.getPromptedExecutableTips();l[u]=c.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,c){const l=[],d=[],E=c.reduce((g,T)=>(g.add(T.identifier.id.toLowerCase()),g),new Set);return u.forEach(g=>{E.has(g.toLowerCase())?l.push(g):d.push(g)}),{installed:l,uninstalled:d}}async getValidExecutableBasedExtensionTips(u){const c=[],l=new Map;for(const d of u.keys()){const E=u.get(d);if(!E||!(0,w.isNonEmptyArray)(E.recommendations))continue;const g=[];p.isWindows?E.windowsPath&&g.push(E.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(g.push((0,L.join)("/usr/local/bin",d)),g.push((0,L.join)("/usr/bin",d)),g.push((0,L.join)(this.environmentService.userHome.fsPath,d)));for(const T of g){let O=l.get(T);if(O===void 0&&(O=await this.fileService.exists(S.URI.file(T)),l.set(T,O)),O)for(const{extensionId:$,extensionName:x,isExtensionPack:G}of E.recommendations)c.push({extensionId:$,extensionName:x,isExtensionPack:G,exeName:d,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}return c}};i=fe([Y(0,k.INativeEnvironmentService),Y(1,D.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,f.IStorageService),Y(4,o.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,P.IFileService),Y(7,R.IProductService),Y(8,m.IRequestService),Y(9,v.ILogService)],i),e.ExtensionTipsService=i}),define(Z[80],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:P,data:p}){return this.appender.log(P,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[81],ee([0,1,44,123,19,6,24,37,2,26,32]),function(K,e,S,L,R,k,A,P,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(h,I){this._configurationService=I,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,I){this._experimentProperties[h]=I}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(m);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let I=h.sessionID,D=h["common.instanceId"],b=h["common.machineId"],C=h["common.firstSessionDate"],f=h["common.msftInternal"];return{sessionId:I,instanceId:D,machineId:b,firstSessionDate:C,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(h,I,D){return this.isOptedIn?this._commonProperties.then(b=>{I=(0,w.mixin)(I,b),I=(0,w.mixin)(I,this._experimentProperties),I=(0,w.cloneAndChange)(I,C=>{if(typeof C=="string")return this._cleanupInfo(C,D)}),this._appender.log(h,I)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,I,D){return this.publicLog(h,I,D)}publicLogError(h,I){return this.sendErrorTelemetry?this.publicLog(h,I,!0):Promise.resolve(void 0)}publicLogError2(h,I){return this.publicLogError(h,I)}_cleanupInfo(h,I){let D=h;if(I){const b=[];for(let o of this._cleanupPatterns)for(;;){const t=o.exec(h);if(!t)break;b.push([t.index,o.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(D="";;){const o=f.exec(h);if(!o)break;!C.test(o[0])&&b.every(([t,r])=>o.index<t||o.index>=r)&&(D+=h.substring(a,o.index)+"<REDACTED: user-file-path>",a=f.lastIndex)}a<h.length&&(D+=h.substr(a))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([Y(1,(0,k.optional)(A.IConfigurationService))],y),e.TelemetryService=y;const m="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,L.localize)(2,null,S.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[53],ee([0,1,24,26,16,5]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,I){return Promise.resolve(void 0)}publicLog2(h,I){return this.publicLog(h,I)}publicLogError(h,I){return Promise.resolve(void 0)}publicLogError2(h,I){return this.publicLogError(h,I)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(I,D,b){}async publicLogError(I,D,b){}}e.NullEndpointTelemetryService=A;function P(...h){return{log:(I,D)=>h.forEach(b=>b.log(I,D)),flush:()=>k.Promises.settled(h.map(I=>I.flush())),productIdentifier:h.find(I=>I.productIdentifier!==void 0)?.productIdentifier}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(h,I){return I.onDidChangeConfiguration(D=>{D.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(D.source),configurationKeys:m(D.sourceConfig)})})}e.configurationTelemetry=p;function w(h){const I=Object.create(null),D=Object.create(null),b=Object.create(null);y(h,b);for(let C in b){C=C.length>150?C.substr(C.length-149):C;const f=b[C];typeof f=="number"?D[C]=f:typeof f=="boolean"?D[C]=f?1:0:typeof f=="string"?I[C]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(I[C]=f)}return{properties:I,measurements:D}}e.validateTelemetryData=w;function n(h){if(!h)return"none";let I="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(I=b)}),I}e.cleanRemoteAuthority=n;function y(h,I,D=0,b){if(!!h)for(let C of Object.getOwnPropertyNames(h)){const f=h[C],a=b?b+C:C;Array.isArray(f)?I[a]=(0,L.safeStringify)(f):f instanceof Date?I[a]=f.toISOString():(0,R.isObject)(f)?D<2?y(f,I,D+1,a+"."):I[a]=(0,L.safeStringify)(f):I[a]=f}}function m(h){if(!h)return[];const I=[];return v(I,"",h),I}function v(h,I,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>v(h,I?`${I}.${b}`:b,D[b])):h.push(I)}}),define(Z[82],ee([0,1,2,9,10,53]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends S.Disposable{constructor(p,w,n=""){super();this.prefix=n;const y=p.getLogger(w.telemetryLogResource);y?this.logger=this._register(y):(this.logger=this._register(p.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(p,w){this.logger.trace(`${this.prefix}telemetry/${p}`,(0,k.validateTelemetryData)(w))}};A=fe([Y(0,R.ILoggerService),Y(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[179],ee([0,1,11,26,53]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P){const p=await new Promise((n,y)=>{K(["applicationinsights"],n,y)});let w;return p.defaultClient?(w=new p.TelemetryClient(P),w.channel.setUseDiskRetryCaching(!0)):(p.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=p.defaultClient),P.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class A{constructor(p,w,n){this._eventPrefix=p,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(w=>{p(w)},w=>{(0,S.onUnexpectedError)(w),console.error(w)})}}log(p,w){!this._aiClient||(w=(0,L.mixin)(w,this._defaultData),w=(0,R.validateTelemetryData)(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[180],ee([0,1,51,80,17,81,24,21,53,9,10,82]),function(K,e,S,L,R,k,A,P,p,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,I,D,b){this.configurationService=h,this.telemetryService=I,this.loggerService=D,this.environmentService=b,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:I,sessionId:D}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=I,b["common.vscodesessionid"]=D;const C=[h.id,JSON.stringify(b),h.aiKey],a=new S.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:C,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),o=(0,p.combinedAppender)(new L.TelemetryAppenderClient(a),new y.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `));this.customTelemetryServices.set(h.id,new k.TelemetryService({appender:o,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,I,D){await(await this.getCustomTelemetryService(h)).publicLog(I,D)}async publicLogError(h,I,D){await(await this.getCustomTelemetryService(h)).publicLogError(I,D)}};m=fe([Y(0,A.IConfigurationService),Y(1,P.ITelemetryService),Y(2,n.ILoggerService),Y(3,w.IEnvironmentService)],m),e.CustomEndpointTelemetryService=m}),define(Z[181],ee([0,1,5,29,3,2,10]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(w,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((n,y)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,n),this._onCreateRequest.fire({requestId:m,...w});const v=new L.CancellationTokenSource;(0,S.timeout)(this._timeout,v.token).then(()=>y(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,k.toDisposable)(()=>v.cancel())])})}acceptReply(w,n){const y=this._pendingRequests.get(w);y?(this._pendingRequests.delete(w),(0,k.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),y(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};P=fe([Y(1,A.ILogService)],P),e.RequestStore=P}),define(Z[83],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.TitleMode="terminal.integrated.titleMode",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,S.createDecorator)("ptyService");var p;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(v){v.TerminalView="view",v.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(Z[182],ee([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(Z[183],ee([0,1,35,8,34,18,16,26,7]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let m=0;return y&&y.length===4&&(m=parseInt(y[3])),m}e.getWindowsBuildNumber=w;async function n(y,m,v,h=R.env,I=k.Promises.exists){if(L.isAbsolute(y))return await I(y)?y:void 0;if(m===void 0&&(m=R.cwd()),L.dirname(y)!=="."){const f=L.join(m,y);return await I(f)?f:void 0}const b=(0,P.getCaseInsensitive)(h,"PATH");if(v===void 0&&(0,A.isString)(b)&&(v=b.split(L.delimiter)),v===void 0||v.length===0){const f=L.join(m,y);return await I(f)?f:void 0}for(let f of v){let a;if(L.isAbsolute(f)?a=L.join(f,y):a=L.join(m,f,y),await I(a))return a;if(p.isWindows){let o=a+".com";if(await I(o)||(o=a+".exe",await I(o)))return o}}const C=L.join(m,y);return await I(C)?C:void 0}e.findExecutable=n}),define(Z[184],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var S;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(S=e.ColorScheme||(e.ColorScheme={}))}),define(Z[84],ee([0,1,6,2,32,3,184,48]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var p;(function(D){function b(C){return C&&typeof C=="object"&&typeof C.id=="string"}D.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function w(D){return{id:D}}e.themeColorFromId=w;var n;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}D.isThemeIcon=b;const C=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const i=C.exec(r);if(!i)return;let[,s]=i;return{id:s}}D.fromString=f;function a(r,i){let s=r.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),i&&(s=`${s}~${i}`),{id:s}}D.modify=a;function o(r,i){return r.id===i.id&&r.color?.id===i.color?.id}D.isEqual=o;function t(r,i){return{id:r.id,color:i?w(i):void 0}}D.asThemeIcon=t,D.asClassNameArray=P.CSSIcon.asClassNameArray,D.asClassName=P.CSSIcon.asClassName,D.asCSSSelector=P.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function y(D){switch(D){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const C=this.themingParticipants.indexOf(b);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new m;R.Registry.add(e.Extensions.ThemingContribution,v);function h(D){return v.onColorThemeChange(D)}e.registerThemingParticipant=h;class I extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,C){let f=this.theme.getColor(b);return f&&C&&(f=C(f,this.theme)),f?f.toString():null}}e.Themable=I}),define(Z[185],ee([0,1,48,84]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,p){const w=P.map(n=>({name:n.profileName,description:k(n)}));return p&&(console.log(p),w.push(...p.map(n=>({name:n.title,description:A(n)})))),{values:w.map(n=>n.name),markdownDescriptions:w.map(n=>n.description)}}e.createProfileSchemaEnums=R;function k(P){let p=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:S.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?p+=`
- args: "${P.args}"`:p+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(p+=`
- overrideName: ${P.overrideName}`),P.color&&(p+=`
- color: ${P.color}`),P.env&&(p+=`
- env: ${JSON.stringify(P.env)}`),p}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:S.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[186],ee([0,1,48,124,37,32,185]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(S.iconRegistry.all,D=>D.id),markdownEnumDescriptions:Array.from(S.iconRegistry.all,D=>`$(${D.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},w=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(36,null),type:"boolean",default:!0}}};function v(){k.Registry.as(R.Extensions.Configuration).registerConfiguration(m),I()}e.registerTerminalPlatformConfiguration=v;let h;function I(D,b){const C=k.Registry.as(R.Extensions.Configuration);h&&C.deregisterConfigurations([h]);let f;D&&(f=(0,A.createProfileSchemaEnums)(D?.profiles,b)),h={id:"terminal",order:100,title:(0,L.localize)(37,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(38,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:D?.os===3?f?.values:void 0,markdownEnumDescriptions:D?.os===3?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:D?.os===2?f?.values:void 0,markdownEnumDescriptions:D?.os===2?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:D?.os===1?f?.values:void 0,markdownEnumDescriptions:D?.os===1?f?.markdownDescriptions:void 0}}},C.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=I}),define(Z[187],ee([0,1,8,98,183,43,18,48,7,84]),function(K,e,S,L,R,k,A,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function y(t,r,i,s,u,c,l,d){return u=u||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},p.isWindows?m(i,u,c,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),d,l):f(u,c,i,t&&typeof t=="object"?{...t}:s.getValue(p.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(p.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),d,l)}e.detectAvailableProfiles=y;async function m(t,r,i,s,u,c,l,d){const E=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${process.env.windir}\\${E?"Sysnative":"System32"}`;let T=!1;(0,R.getWindowsBuildNumber)()>=16299&&(T=!0),await I(l);const O=new Map;t&&(O.set("PowerShell",{source:"PowerShell",icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Windows PowerShell",{path:`${g}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),O.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),O.set("Command Prompt",{path:`${g}\\cmd.exe`,icon:P.Codicon.terminalCmd,isAutoDetected:!0})),a(u,O);const $=await v(O.entries(),c,r,i,d);if(t||!t&&s)try{const x=await b(`${g}\\${T?"wsl":"bash"}.exe`,c);for(const G of x)(!u||!(G.profileName in u))&&$.push(G)}catch(x){i?.info("WSL is not installed, so could not detect WSL profiles")}return $}async function v(t,r,i,s,u){const c=[];for(const[l,d]of t){if(d===null)continue;let E,g,T;if("source"in d){const x=n?.get(d.source);if(!x)continue;E=x.paths,g=d.args||x.args,d.icon?T=h(d.icon):x.icon&&(T=x.icon)}else E=Array.isArray(d.path)?d.path:[d.path],g=p.isWindows||Array.isArray(d.args)?d.args:void 0,T=h(d.icon)||void 0;const O=await u?.(E)||E.slice(),$=await o(l,r,O,i,g,d.env,d.overrideName,d.isAutoDetected,s);$?($.isAutoDetected=d.isAutoDetected,$.icon=T,$.color=d.color,c.push($)):s?.trace("profile not validated",l,E)}return c}function h(t){return typeof t=="string"?{id:t}:t}async function I(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await D(),icon:w.ThemeIcon.asThemeIcon(P.Codicon.terminalPowershell)}))}async function D(){const t=[];for await(const r of(0,L.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],s=await new Promise((l,d)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(E,g)=>{if(E)return d("Problem occurred when getting wsl distros");l(g)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),c=s.split(u).filter(l=>l.trim().length>0&&l!=="");for(const l of c){if(l===""||l.startsWith("docker-desktop"))continue;const d=`${l} (WSL)`,E={profileName:d,path:t,args:["-d",`${l}`],isDefault:d===r,icon:C(l)};i.push(E)}return i}function C(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(P.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(P.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(P.Codicon.terminalLinux)}async function f(t,r,i,s,u,c,l){const d=new Map;if(i){const E=(await t.readFile("/etc/shells")).toString(),g=c||E.split(`
`).filter(O=>O.trim().indexOf("#")!==0&&O.trim().length>0),T=new Map;for(const O of g){let $=(0,S.basename)(O),x=T.get($)||0;x++,x>1&&($=`${$} (${x})`),T.set($,x),d.set($,{path:O,isAutoDetected:!0})}}return a(s,d),await v(d.entries(),u,t,r,l)}function a(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function o(t,r,i,s,u,c,l,d,E){if(i.length===0)return Promise.resolve(void 0);const g=i.shift();if(g==="")return o(t,r,i,s,u,c,l,d);const T={profileName:t,path:g,args:u,env:c,overrideName:l,isAutoDetected:d,isDefault:t===r};if((0,S.basename)(g)===g){const $=process.env.PATH?process.env.PATH.split(S.delimiter):void 0;return await(0,R.findExecutable)(g,void 0,$,void 0,s.existsFile)?T:o(t,r,i,s,u)}return await s.existsFile((0,S.normalize)(g))?T:o(t,r,i,s,u,c,l,d)}}),define(Z[188],ee([0,1,2,10,83,51,17,36,3,77,21,187,24,186,181]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var I;(function(C){C[C.MaxRestarts=5]="MaxRestarts"})(I||(I={}));let D=0,b=class extends S.Disposable{constructor(f,a,o,t){super();this._reconnectConstants=f,this._configurationService=a,this._logService=o,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new p.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new p.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new p.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new p.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new p.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new p.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new p.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new p.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new p.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new p.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new p.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new p.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new p.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new p.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new p.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new p.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,v.registerTerminalPlatformConfiguration)(),this._register((0,S.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const f=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(f.getChannel(R.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(f.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=I.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const o=f.getChannel(R.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const t=P.ProxyChannel.toService(f.getChannel(R.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(t.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[f,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(f,a,o,t,r,i,s,u,c,l){const d=setTimeout(()=>this._handleUnresponsiveCreateProcess(),R.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(f,a,o,t,r,i,s,u,c,l);return clearTimeout(d),D=Math.max(D,E),E}updateTitle(f,a,o){return this._proxy.updateTitle(f,a,o)}updateIcon(f,a,o){return this._proxy.updateIcon(f,a,o)}attachToProcess(f){return this._proxy.attachToProcess(f)}detachFromProcess(f){return this._proxy.detachFromProcess(f)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(f){return this._proxy.start(f)}shutdown(f,a){return this._proxy.shutdown(f,a)}input(f,a){return this._proxy.input(f,a)}processBinary(f,a){return this._proxy.processBinary(f,a)}resize(f,a,o){return this._proxy.resize(f,a,o)}acknowledgeDataEvent(f,a){return this._proxy.acknowledgeDataEvent(f,a)}getInitialCwd(f){return this._proxy.getInitialCwd(f)}getCwd(f){return this._proxy.getCwd(f)}getLatency(f){return this._proxy.getLatency(f)}orphanQuestionReply(f){return this._proxy.orphanQuestionReply(f)}getDefaultSystemShell(f){return this._proxy.getDefaultSystemShell(f)}async getProfiles(f,a,o,t=!1){return(0,y.detectAvailableProfiles)(a,o,t,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this,f))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(f){return this._proxy.getWslPath(f)}setTerminalLayoutInfo(f){return this._proxy.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return await this._proxy.getTerminalLayoutInfo(f)}async requestDetachInstance(f,a){return this._proxy.requestDetachInstance(f,a)}async acceptDetachInstanceReply(f,a){return this._proxy.acceptDetachInstanceReply(f,a)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier+R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${R.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(f,a){return this._resolveVariablesRequestStore.createRequest({workspaceId:f,originalText:a})}async acceptPtyHostResolvedVariables(f,a){this._resolveVariablesRequestStore.acceptReply(f,a)}};b=fe([Y(1,m.IConfigurationService),Y(2,L.ILogService),Y(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(Z[54],ee([0,1,41]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,p,w){const n=(0,S.setProperty)(A,P,p,w)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function R(A,P,p){let w=p;for(;w>=0;){if(A.charAt(w)===P.charAt(P.length-1)&&P.length===1)return w+1;if(w--,P.length===2&&w>=0&&A.charAt(w)===P.charAt(0))return w+2}return 0}e.getLineStartOffset=R;function k(A,P,p){let w=p;for(;w>=0;)if(A.charAt(w)===P.charAt(P.length-1)&&P.length===1||(w++,P.length===2&&w>=0&&A.charAt(w)===P.charAt(1)))return w;return A.length-1}e.getLineEndOffset=k}),define(Z[189],ee([0,1,26,58]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(y,m,v,h,I){const D=[],b=[],C=[];if(!m){const T=y.filter(({identifier:O})=>I.every($=>$.toLowerCase()!==O.id.toLowerCase()));return{local:{added:D,removed:b,updated:C},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}y=y.map(w),m=m.map(w),v=v?v.map(w):null;const f=new Map,a=T=>{T.uuid&&f.set(T.id.toLowerCase(),T.uuid)};y.forEach(({identifier:T})=>a(T)),m.forEach(({identifier:T})=>a(T)),v&&v.forEach(({identifier:T})=>a(T));const o=T=>{const O=T.identifier.uuid||f.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(o(O),O),T),r=y.reduce(t,new Map),i=m.reduce(t,new Map),s=m.reduce((T,O)=>{const $=o(O);O=(0,S.deepClone)(O);const x=r.get($);return x&&(x.installed&&(O.installed=!0),O.version||(O.version=x.version)),t(T,O)},new Map),u=v?v.reduce(t,new Map):null,c=h.reduce(t,new Map),l=I.reduce((T,O)=>{const $=f.get(O.toLowerCase());return T.add($?`uuid:${$}`:`id:${O.toLowerCase()}`)},new Set),d=k(r,i,l);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const T=k(u,r,l),O=k(u,i,l),$=(x,G)=>{const B=r.get(x);if(B){const U=i.get(x);return{...G?U:B,version:(U.version&&L.gt(U.version,B.version),B.version),state:A(B,U,u?.get(x))}}};for(const x of O.removed.values()){const G=r.get(x);G&&b.push(G.identifier)}for(const x of O.added.values())if(T.added.has(x)){if(d.updated.has(x)){const G=$(x,!0);G&&(C.push(n(G,x)),s.set(x,G))}}else{const G=i.get(x);G.installed&&D.push(n(G,x))}for(const x of O.updated.values()){const G=$(x,!0);G&&(C.push(n(G,x)),s.set(x,G))}for(const x of T.added.values())O.added.has(x)||s.set(x,r.get(x));for(const x of T.updated.values())if(!O.removed.has(x)&&!O.updated.has(x)){const G=$(x,!1);G&&(s.get(x)?.installed&&(G.installed=!0),s.set(x,G))}for(const x of T.removed.values())!c.has(x)&&!O.updated.has(x)&&u?.get(x)?.installed&&s.delete(x)}const E=[],g=k(i,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(g.added.size>0||g.updated.size>0||g.removed.size>0)&&s.forEach((T,O)=>E.push(n(T,O))),{local:{added:D,removed:b,updated:C},remote:E.length?{added:[...g.added].map(T=>s.get(T)),updated:[...g.updated].map(T=>s.get(T)),removed:[...g.removed].map(T=>i.get(T)),all:E}:null}}e.merge=R;function k(y,m,v,{checkInstalledProperty:h,checkVersionProperty:I}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=y?[...y.keys()].filter(o=>!v.has(o)):[],b=[...m.keys()].filter(o=>!v.has(o)),C=b.filter(o=>D.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),f=D.filter(o=>b.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),a=new Set;for(const o of D){if(f.has(o))continue;const t=y.get(o),r=m.get(o);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||I&&t.version!==r.version||h&&t.installed!==r.installed)&&a.add(o)}return{added:C,removed:f,updated:a}}function A(y,m,v){const h=y.state,I=m.state,D=v?.state;if(!m.version||h&&L.gt(y.version,m.version))return h;if(I&&L.gt(m.version,y.version)||!h)return I;if(!I)return h;const b=(0,S.deepClone)(h),C=D?P(D,I):{added:Object.keys(I).reduce((a,o)=>(a.add(o),a),new Set),removed:new Set,updated:new Set},f=D?P(D,h):{added:Object.keys(h).reduce((a,o)=>(a.add(o),a),new Set),removed:new Set,updated:new Set};for(const a of[...C.added.values(),...C.updated.values()])b[a]=I[a];for(const a of C.removed.values())f.updated.has(a)||delete b[a];return b}function P(y,m){const v=Object.keys(y),h=Object.keys(m),I=h.filter(C=>v.indexOf(C)===-1).reduce((C,f)=>(C.add(f),C),new Set),D=v.filter(C=>h.indexOf(C)===-1).reduce((C,f)=>(C.add(f),C),new Set),b=new Set;for(const C of v){if(D.has(C))continue;const f=y[C],a=m[C];(0,S.equals)(f,a)||b.add(C)}return{added:I,removed:D,updated:b}}function p(y={},m={}){const{added:v,removed:h,updated:I}=P(y,m);return v.size===0&&h.size===0&&I.size===0}function w(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function n(y,m){const v={identifier:{id:y.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return y.version&&(v.version=y.version),y.disabled&&(v.disabled=!0),y.installed&&(v.installed=!0),y.state&&(v.state=y.state),v}}),define(Z[85],ee([0,1,23,3,2,31,6,28,20]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends R.Disposable{constructor(m,v){super();this.storageService=m,this.productService=v,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const v=w.exec(m);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const m=this.storageService.keys(0,1);for(const v of m){const h=Ze.fromKey(v);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const v=Ze.fromKey(m.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,v){this.storageService.store(Ze.toKey(m),JSON.stringify(v),0,1)}getKeysForSync(m){const v=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],h=this.storageService.get(Ze.toKey(m),0),I=h?JSON.parse(h):void 0;return I&&v?(0,S.distinct)([...I,...v]):I||v}};n=fe([Y(0,p.IStorageService),Y(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[86],ee([0,1,23,24,6]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,p){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==P&&n!==`-${P}`),p&&w.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(P,p){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==P&&n!==`-${P}`),p&&w.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(P){const p=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),n=[],y=[];if(Array.isArray(w))for(const m of w)m.startsWith("-")?y.push(m.substring(1)):n.push(m);return(0,S.distinct)([...p,...n].filter(m=>y.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};k=fe([Y(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(Z[190],ee([0,1,26,33,23,145,54]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(a){return(0,L.parse)(a)||[]}e.parseKeybindings=P;async function p(a,o,t,r,i){const s=P(a),u=P(o),c=t?P(t):null,l=[...s,...u,...c||[]].map(M=>M.key),d=await i.resolveUserBindings(l);let E=n(s,u,c,d);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const g=m(s),T=m(u),O=c?m(c):null,$=h(g,T,d),x=O?h(O,g,d):{added:[...g.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set},G=O?h(O,T,d):{added:[...T.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set},B=w($,x,G);let U=a;for(const M of B.removed.values())B.conflicts.has(M)||(U=C(U,M,r));for(const M of B.added.values()){if(B.conflicts.has(M))continue;const F=T.get(M);if(F.some(j=>j.command!==`-${M}`&&E.conflicts.has(d[j.key]))){B.conflicts.add(M);continue}U=b(U,F,r)}for(const M of B.updated.values()){if(B.conflicts.has(M))continue;const F=T.get(M);if(F.some(j=>j.command!==`-${M}`&&E.conflicts.has(d[j.key]))){B.conflicts.add(M);continue}U=f(U,M,F,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=p;function w(a,o,t){const r=new Set,i=new Set,s=new Set,u=new Set;for(const c of o.removed.values())t.updated.has(c)&&u.add(c);for(const c of t.removed.values())u.has(c)||(o.updated.has(c)?u.add(c):i.add(c));for(const c of o.added.values())u.has(c)||t.added.has(c)&&a.updated.has(c)&&u.add(c);for(const c of t.added.values())u.has(c)||(o.added.has(c)?a.updated.has(c)&&u.add(c):r.add(c));for(const c of o.updated.values())u.has(c)||t.updated.has(c)&&a.updated.has(c)&&u.add(c);for(const c of t.updated.values())u.has(c)||(o.updated.has(c)?a.updated.has(c)&&u.add(c):s.add(c));return{added:r,removed:i,updated:s,conflicts:u}}function n(a,o,t,r){const i=new Set,s=y(a,r),u=y(o,r),c=t?y(t,r):null,l=v(s,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const d=c?v(c,s):{added:[...s.keys()].reduce((x,G)=>(x.add(G),x),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=c?v(c,u):{added:[...u.keys()].reduce((x,G)=>(x.add(G),x),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:g,removed:T,updated:O,conflicts:$}=w(l,d,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:g,removed:T,updated:O,conflicts:$}}function y(a,o){const t=new Map;for(const r of a){const i=o[r.key];let s=t.get(i);s||(s=[],t.set(i,s)),s.push(r)}return t}function m(a){const o=new Map;for(const t of a){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=o.get(r);i||(i=[],o.set(r,i)),i.push(t)}return o}function v(a,o){const t=[...a.keys()],r=[...o.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),s=t.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),u=new Set;for(const c of t){if(s.has(c))continue;const l=a.get(c).map(E=>({...E,key:c})),d=o.get(c).map(E=>({...E,key:c}));(0,R.equals)(l,d,(E,g)=>D(E,g))||u.add(c)}return{added:i,removed:s,updated:u}}function h(a,o,t){const r=[...a.keys()],i=[...o.keys()],s=i.filter(l=>r.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),c=new Set;for(const l of r){if(u.has(l))continue;const d=a.get(l).map(g=>({...g,key:t[g.key]})),E=o.get(l).map(g=>({...g,key:t[g.key]}));I(d,E)||c.add(l)}return{added:s,removed:u,updated:c}}function I(a,o){return!(!(0,R.equals)(a.filter(({command:t})=>t[0]!=="-"),o.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!(0,R.equals)(a.filter(({command:t})=>t[0]==="-"),o.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(a,o){if(a.command!==o.command||a.key!==o.key)return!1;const t=k.ContextKeyExpr.deserialize(a.when),r=k.ContextKeyExpr.deserialize(o.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!S.equals(a.args,o.args))}function b(a,o,t){for(const r of o)a=A.edit(a,[-1],r,t);return a}function C(a,o,t){const r=P(a);for(let i=r.length-1;i>=0;i--)(r[i].command===o||r[i].command===`-${o}`)&&(a=A.edit(a,[i],void 0,t));return a}function f(a,o,t,r){const i=P(a),s=i.findIndex(u=>u.command===o||u.command===`-${o}`);for(let u=i.length-1;u>=0;u--)(i[u].command===o||i[u].command===`-${o}`)&&(a=A.edit(a,[u],void 0,r));for(let u=t.length-1;u>=0;u--)a=A.edit(a,[s],t[u],r);return a}}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(k,A,P){const p={},w={},n=new Set;if(!A)return{local:{added:p,updated:w,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const y=L(k,A);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:p,updated:w,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(P,k),v=L(P,A),h={},I={},D=new Set,b=new Set;for(const C of m.removed.values())v.updated.has(C)?p[C]=A[C]:D.add(C);for(const C of v.removed.values())b.has(C)||(m.updated.has(C)?b.add(C):n.add(C));for(const C of m.updated.values())b.has(C)||(v.updated.has(C)?y.updated.has(C)&&b.add(C):I[C]=k[C]);for(const C of v.updated.values())b.has(C)||(m.updated.has(C)?y.updated.has(C)&&b.add(C):k[C]!==void 0&&(w[C]=A[C]));for(const C of m.added.values())b.has(C)||(v.added.has(C)?y.updated.has(C)&&b.add(C):h[C]=k[C]);for(const C of v.added.values())b.has(C)||(m.added.has(C)?y.updated.has(C)&&b.add(C):p[C]=A[C]);return{local:{added:p,removed:[...n.values()],updated:w},remote:{added:h,removed:[...D.values()],updated:I},conflicts:[...b.values()]}}e.merge=S;function L(k,A){const P=k?Object.keys(k):[],p=A?Object.keys(A):[],w=p.filter(m=>P.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),n=P.filter(m=>p.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),y=new Set;for(const m of P){if(n.has(m))continue;const v=k[m],h=A[m];v!==h&&y.add(m)}return{added:w,removed:n,updated:y}}function R(k,A){const{added:P,removed:p,updated:w}=L(k,A);return P.size===0&&p.size===0&&w.size===0}e.areSame=R}),define(Z[22],ee([0,1,6,27,32,37,129,79,15,23,16]),function(K,e,S,L,R,k,A,P,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const c=R.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function m(){const c=R.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(g=>!!c[g].ignoreSync),d=Object.keys(c).filter(g=>c[g].scope===2||c[g].scope===6),E=y();return(0,w.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...d,...E])}e.getDefaultIgnoredSettings=m;function v(){const c="vscode://schemas/ignoredSettings",l=R.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=R.Registry.as(P.Extensions.JSONContribution),E=()=>{const g=y(),T=m().filter(G=>G!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(G=>T.indexOf(G)===-1),$=T.filter(G=>g.indexOf(G)===-1),x={items:{type:"string",enum:[...O,...$.map(G=>`-${G}`)]}};d.registerSchema(c,x)};return l.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=v;function h(c){return c&&(0,n.isObject)(c)&&(0,n.isString)(c.id)&&(0,n.isArray)(c.scopes)}e.isAuthenticationProvider=h;var I;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(I=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function D(c,l,d){return d.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=D,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=b;var C;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(l,d,E,g){super(l);this.code=d,this.resource=E,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class a extends f{constructor(l,d,E,g,T){super(l,E,void 0,T);this.url=d,this.serverCode=g}}e.UserDataSyncStoreError=a;class o extends f{constructor(l,d){super(l,d)}}e.UserDataAutoSyncError=o,function(c){function l(d){if(d instanceof c)return d;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(E&&E[1]){const g=E[2]==="unknown"?void 0:E[2],T=E[3]==="unknown"?void 0:E[3];return new c(d.message,E[1],g,T)}return new c(d.message,"Unknown")}c.toUserDataSyncError=l}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(c){return`sync.enable.${c}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,p.isEqualOrParent)(c,(0,p.joinPath)(l.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[46],ee([0,1,2,14,25,4,22,9,15,5,3,21,33,125,24,16,19,23,45,20,29]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=o;let t=class extends S.Disposable{constructor(c,l,d,E,g,T,O,$,x,G){super();this.resource=c,this.fileService=l,this.environmentService=d,this.userDataSyncStoreService=g,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=$,this.logService=x,this.configurationService=G,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new w.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,D.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(c,d,this.extUri),this.currentMachineIdPromise=(0,C.getServiceMachineId)(d,l,E)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,a.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const l=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,l={}){await this._sync(c,!0,l)}async preview(c,l={}){return this._sync(c,!1,l)}async apply(c,l={}){try{this.syncHeaders={...l};const d=await this.doApply(c);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,l,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let E="idle";try{const g=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(c,g);return E=await this.performSync(T,g,l),E==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(E)}}finally{this.syncHeaders={}}}async replace(c){const l=await this.resolveContent(c);if(!l)return!1;const d=this.parseSyncData(l);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(null,E),T=await this.isRemoteDataFromCurrentMachine(g),O=await this.generateSyncPreview({ref:g.ref,syncData:d},E,T,a.CancellationToken.None),$=[];for(const x of O){const G=await this.getAcceptResult(x,x.remoteResource,void 0,a.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(x,x.previewResource,x.remoteContent,a.CancellationToken.None);$.push([x,{...G,remoteChange:B!==0?B:2}])}await this.applyResult(g,E,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const l=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===l}async getLatestRemoteUserData(c,l){if(l){const d=c&&c.latest?c.latest[this.resource]:void 0;if(l.ref===d||d===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(c,l,d){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,l,d)}catch(E){if(E instanceof A.UserDataSyncError)switch(E.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,l,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(c,l,d)}throw E}}async doSync(c,l,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,w.createCancelablePromise)(g=>this.doGenerateSyncResourcePreview(c,l,d,g)));const E=await this.syncPreviewPromise;return this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(E){throw this.syncPreviewPromise=null,E}}async merge(c){return await this.updateSyncResourcePreview(c,async l=>{const d=await this.getMergeResult(l,a.CancellationToken.None);await this.fileService.writeFile(l.previewResource,R.VSBuffer.fromString(d?.content||""));const E=d&&!d.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,a.CancellationToken.None):void 0;return l.acceptResult=E,l.mergeState=d.hasConflicts?"conflict":E?"accepted":"preview",l.localChange=E?E.localChange:d.localChange,l.remoteChange=E?E.remoteChange:d.remoteChange,l}),this.syncPreviewPromise}async accept(c,l){return await this.updateSyncResourcePreview(c,async d=>{const E=await this.getAcceptResult(d,c,l,a.CancellationToken.None);return d.acceptResult=E,d.mergeState="accepted",d.localChange=E.localChange,d.remoteChange=E.remoteChange,d}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async l=>{const d=await this.getMergeResult(l,a.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,R.VSBuffer.fromString(d.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=d.localChange,l.remoteChange=d.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(c,l){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const E=d.resourcePreviews.findIndex(({localResource:g,remoteResource:T,previewResource:O})=>this.extUri.isEqual(g,c)||this.extUri.isEqual(T,c)||this.extUri.isEqual(O,c));E!==-1&&(this.syncPreviewPromise=(0,w.createCancelablePromise)(async g=>{const T=[...d.resourcePreviews];return T[E]=await l(T[E]),{...d,resourcePreviews:T}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:g})=>g==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(d=>[d,d.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const l=c.filter(({mergeState:d})=>d==="conflict");(0,b.equals)(this._conflicts,l,(d,E)=>this.extUri.isEqual(d.previewResource,E.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:d})=>({created:l,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:d})=>({created:l,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(c){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:d}=await this.getUserData(l);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(c){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:d}=await this.getUserData(l);return d}return this.extUri.isEqual(c,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(c){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const d of l.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,c))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,c))return d.remoteContent;if(this.extUri.isEqual(d.localResource,c))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,l,d,E){const g=await this.isRemoteDataFromCurrentMachine(c),T=await this.generateSyncPreview(c,l,g,E),O=[];for(const $ of T){const x=$.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)O.push({...$,acceptedResource:x,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const G=d?await this.getMergeResult($,E):void 0;if(E.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,R.VSBuffer.fromString(G?.content||""));const B=G&&!G.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,E):void 0;O.push({...$,acceptResult:B,mergeState:G?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:G?G.localChange:$.localChange,remoteChange:B?B.remoteChange:G?G.remoteChange:$.remoteChange})}}return{remoteUserData:c,lastSyncUserData:l,resourcePreviews:O,isLastSyncFromCurrentMachine:g}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(c.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&d&&l.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const E=l;if(E.content===null)return{ref:l.ref,syncData:null};const g=JSON.parse(E.content);if(o(g))return{...l,syncData:g,content:void 0}}catch(c){c instanceof L.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),E={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:d,...l};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(c){const{ref:l,content:d}=await this.getUserData(c);let E=null;return d!==null&&(E=this.parseSyncData(d)),{ref:l,syncData:E}}parseSyncData(c){try{const l=JSON.parse(c);if(o(l))return l}catch(l){this.logService.error(l)}throw new A.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,I.isString)(c)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:l}}else{const l=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(c,l){const d=await this.currentMachineIdPromise,E={version:this.version,machineId:d,content:c};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(E),l,this.syncHeaders),{ref:l,syncData:E}}async backupLocal(c){const l={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([Y(1,L.IFileService),Y(2,P.IEnvironmentService),Y(3,f.IStorageService),Y(4,A.IUserDataSyncStoreService),Y(5,A.IUserDataSyncBackupStoreService),Y(6,A.IUserDataSyncResourceEnablementService),Y(7,y.ITelemetryService),Y(8,A.IUserDataSyncLogService),Y(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,l,d,E,g,T,O,$,x,G,B){super(l,d,E,g,T,O,$,x,G,B);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,l,d){try{l?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(c),d?void 0:l):await this.fileService.createFile(this.file,R.VSBuffer.fromString(c),{overwrite:d})}catch(E){throw E instanceof L.FileOperationError&&E.fileOperationResult===1||E instanceof L.FileOperationError&&E.fileOperationResult===3?new A.UserDataSyncError(E.message,"LocalPreconditionFailed"):E}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=fe([Y(2,L.IFileService),Y(3,P.IEnvironmentService),Y(4,f.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,l,d,E,g,T,O,$,x,G,B,U){super(c,l,d,E,g,T,O,$,x,G,U);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(c){const l=[];return(0,m.parse)(c,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=fe([Y(2,L.IFileService),Y(3,P.IEnvironmentService),Y(4,f.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,A.IUserDataSyncUtilService),Y(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let s=class{constructor(c,l,d,E){this.resource=c,this.environmentService=l,this.logService=d,this.fileService=E,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,l,p.extUri)}async initialize({ref:c,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(l);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:d})}catch(g){this.logService.error(g)}}parseSyncData(c){try{const l=JSON.parse(c);if(o(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,l={}){const d={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};s=fe([Y(1,P.IEnvironmentService),Y(2,A.IUserDataSyncLogService),Y(3,L.IFileService)],s),e.AbstractInitializer=s}),define(Z[192],ee([0,1,22,3,9,27,31,14,24,189,46,21,4,47,41,19,20,86,11,85,5]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function o(u,c){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const d=(await c.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of l)u.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),u.version===2&&d.every(g=>!(0,A.areSameExtensions)(g.identifier,E.identifier))&&(E.installed=!0)}return l}function t(u,c,l){const d=l.get((0,A.getExtensionId)(u,c),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function r(u,c,l,d){d.store((0,A.getExtensionId)(u,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(c,l,d,E,g,T,O,$,x,G,B,U,M,F){super("extensions",l,c,d,E,g,U,M,x,B);this.storageService=d,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=G,this.extensionsStorageSyncService=F,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:_})=>!!_)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const d=c.syncData?await o(c.syncData,this.extensionManagementService):null,E=l?.skippedExtensions||[],g=l?.syncData?await o(l.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),$=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:x,remote:G}=(0,w.merge)(O,d,g,E,$),B={local:x,remote:G,content:this.getPreviewContent(O,x.added,x.updated,x.removed),localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:G!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,d,E){const g=[...l,...d],T=new Set,O=$=>{T.add($.id.toLowerCase()),$.uuid&&T.add($.uuid)};g.forEach(({identifier:$})=>O($)),E.forEach(O);for(const $ of c)T.has($.identifier.id.toLowerCase())||$.identifier.uuid&&T.has($.identifier.uuid)||g.push($);return this.format(g)}async getMergeResult(c,l){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,l,d,E){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=(0,w.merge)(c.localExtensions,null,null,c.skippedExtensions,d),{local:g,remote:T}=E;return{content:c.localContent,local:g,remote:T,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=c.remoteContent?JSON.parse(c.remoteContent):null;if(E!==null){const g=(0,w.merge)(c.localExtensions,E,c.localExtensions,[],d),{local:T,remote:O}=g;return{content:c.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,d,E){let{skippedExtensions:g,localExtensions:T}=d[0][0],{local:O,remote:$,localChange:x,remoteChange:G}=d[0][1];if(x===0&&G===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),x!==0&&(await this.backupLocal(JSON.stringify(T)),g=await this.updateLocalExtensions(O.added,O.removed,O.updated,g)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify($.all);c=await this.updateRemoteUserData(B,E?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(U=>U.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(U=>U.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(U=>U.identifier.id))}.`:""}`)}l?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:g}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${g.length?` Skipped: ${JSON.stringify(g.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),g=this.getLocalExtensions(d).filter(T=>!E.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(g)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const d=this.parseSyncData(l);if(d)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(c){c.sort((E,g)=>!E.identifier.uuid&&g.identifier.uuid?-1:E.identifier.uuid&&!g.identifier.uuid?1:(0,I.compare)(E.identifier.id,g.identifier.id));const l=JSON.stringify(c),d=(0,v.format)(l,void 0,{});return(0,h.applyEdits)(l,d)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(d=>d.installed||d.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,d,E){const g=[],T=[],O=await this.extensionManagementService.getInstalled();if(l.length){const x=O.filter(({identifier:G,isBuiltin:B})=>!B&&l.some(U=>(0,A.areSameExtensions)(G,U)));await a.Promises.settled(x.map(async G=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,G.identifier.id),await this.extensionManagementService.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,G.identifier.id),g.push(G.identifier)}))}(c.length||d.length)&&await a.Promises.settled([...c,...d].map(async x=>{const G=O.find(U=>(0,A.areSameExtensions)(U.identifier,x.identifier));if(G&&G.isBuiltin){x.state&&G.manifest.version===x.version&&this.updateExtensionState(x.state,G.manifest.publisher,G.manifest.name,G.manifest.version),x.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,x.identifier.id),await this.extensionEnablementService.disableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,x.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,x.identifier.id),await this.extensionEnablementService.enableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,x.identifier.id)),g.push(x.identifier);return}const B=await this.extensionGalleryService.getCompatibleExtension(x.identifier);if(x.state&&(G?G.manifest.version===x.version:!!B)){const U=G?G.manifest.publisher:B.publisher,M=G?G.manifest.name:B.name;this.updateExtensionState(x.state,U,M,G?.manifest.version)}if(B)try{x.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,x.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,x.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,x.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,x.identifier.id,B.version)),G||(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,x.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,x.identifier.id,B.version),g.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),T.push(x)))}catch(U){T.push(x),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,x.identifier.id),T.push(x)}));const $=[];for(const x of E)g.some(G=>(0,A.areSameExtensions)(G,x.identifier))||$.push(x);for(const x of T)$.some(G=>(0,A.areSameExtensions)(G.identifier,x.identifier))||$.push(x);return $}updateExtensionState(c,l,d,E){const g=t(l,d,this.storageService),T=E?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(l,d),version:E}):void 0;T?T.forEach(O=>{g[O]=c[O]}):Object.keys(c).forEach(O=>g[O]=c[O]),r(l,d,g,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:d,isBuiltin:E,manifest:g})=>{const T={identifier:d,version:g.version};l.some(O=>(0,A.areSameExtensions)(O,d))&&(T.disabled=!0),E||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:g.version});if(O){const $=t(g.publisher,g.name,this.storageService);T.state=Object.keys($).reduce((x,G)=>(O.includes(G)&&(x[G]=$[G]),x),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,C.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=m.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=fe([Y(0,R.IEnvironmentService),Y(1,P.IFileService),Y(2,D.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,k.IExtensionManagementService),Y(6,k.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,S.IUserDataSyncLogService),Y(9,k.IExtensionGalleryService),Y(10,p.IConfigurationService),Y(11,S.IUserDataSyncResourceEnablementService),Y(12,y.ITelemetryService),Y(13,f.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let s=class extends n.AbstractInitializer{constructor(c,l,d,E,g){super("extensions",E,g,d);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await o(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const d=[],E=[],g=[];for(const T of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=l.find($=>(0,A.areSameExtensions)($.identifier,T.identifier));O?(d.push(O),T.disabled&&g.push(T.identifier)):T.installed&&(E.push(T.identifier),T.disabled&&g.push(T.identifier))}return{installedExtensions:d,newExtensions:E,disabledExtensions:g,remoteExtensions:c}}};s=fe([Y(0,k.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,P.IFileService),Y(3,R.IEnvironmentService),Y(4,S.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(Z[193],ee([0,1,26,22]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,p,w,n,y){if(!p)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const m=k(P,p);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=w?k(w,p):{added:Object.keys(p).reduce((C,f)=>(C.add(f),C),new Set),removed:new Set,updated:new Set},h=w?k(w,P):{added:Object.keys(P).reduce((C,f)=>(C.add(f),C),new Set),removed:new Set,updated:new Set},I={added:{},removed:[],updated:{}},D=S.deepClone(p),b=!w;for(const C of h.added.values())C!==L.SYNC_SERVICE_URL_TYPE&&b&&v.added.has(C)||(D[C]=P[C]);for(const C of h.updated.values())D[C]=P[C];for(const C of h.removed.values())n.unregistered.includes(C)||delete D[C];for(const C of v.added.values()){const f=p[C];if(n.machine.includes(C)){y.info(`GlobalState: Skipped adding ${C} in local storage because it is declared as machine scoped.`);continue}if(w&&h.added.has(C))continue;const a=P[C];a&&a.value===f.value||C===L.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(C)||(a?I.updated[C]=f:I.added[C]=f)}for(const C of v.updated.values()){const f=p[C];if(n.machine.includes(C)){y.info(`GlobalState: Skipped updating ${C} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(C)||h.removed.has(C))continue;const a=P[C];a&&a.value===f.value||(I.updated[C]=f)}for(const C of v.removed.values()){if(n.machine.includes(C)){y.trace(`GlobalState: Skipped removing ${C} in local storage because it is declared as machine scoped.`);continue}h.updated.has(C)||h.removed.has(C)||I.removed.push(C)}return{local:I,remote:A(D,p)?null:D}}e.merge=R;function k(P,p){const w=Object.keys(P),n=Object.keys(p),y=n.filter(h=>w.indexOf(h)===-1).reduce((h,I)=>(h.add(I),h),new Set),m=w.filter(h=>n.indexOf(h)===-1).reduce((h,I)=>(h.add(I),h),new Set),v=new Set;for(const h of w){if(m.has(h))continue;const I=P[h],D=p[h];S.equals(I,D)||v.add(h)}return{added:y,removed:m,updated:v}}function A(P,p){const{added:w,removed:n,updated:y}=k(P,p);return w.size===0&&n.size===0&&y.size===0}}),define(Z[194],ee([0,1,22,25,3,9,14,54,193,33,46,21,24,4,47,41,20,7,45,30,10]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",t=["locale"];function r(l){const d=l.storage?Object.keys(l.storage).sort():[],E={};d.forEach(O=>E[O]=l.storage[O]),l.storage=E;const g=JSON.stringify(l),T=(0,h.format)(g,void 0,{});return(0,I.applyEdits)(g,T)}const i=1;let s=class ot extends n.AbstractSynchroniser{constructor(d,E,g,T,O,$,x,G,B){super("globalState",d,O,B,E,g,$,x,T,G);this.storageService=B,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(d.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),R.Event.filter(B.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:B.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,E,g,T){const O=d.syncData?JSON.parse(d.syncData.content):null;E=E===null&&g?d:E;const $=E&&E.syncData?JSON.parse(E.syncData.content):null,x=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=this.getStorageKeys($),{local:B,remote:U}=(0,p.merge)(x.storage,O?O.storage:null,$?$.storage:null,G,this.logService),M={content:null,local:B,remote:U,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(x),localUserData:x,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:G}]}async getMergeResult(d,E){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,E,g,T){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(E,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const E=JSON.parse(d.remoteContent),{local:g,remote:T}=(0,p.merge)(d.localUserData.storage,E.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:g,remote:T,localChange:Object.keys(g.added).length>0||Object.keys(g.updated).length>0||g.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,E,g,T){let{localUserData:O}=g[0][0],{local:$,remote:x,localChange:G,remoteChange:B}=g[0][1];if(G===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),G!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:x});d=await this.updateRemoteUserData(U,T?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}E?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const g=await this.getLocalGlobalState();return r(g)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let E=await super.resolveContent(d);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(d)),E){const g=this.parseSyncData(E);if(g)switch(this.extUri.basename(d)){case"globalState.json":return r(JSON.parse(g.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${o}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},E=await this.getLocalArgvContent(),g=(0,w.parse)(E);for(const T of t)g[T]!==void 0&&(d[`${o}${T}`]={version:1,value:g[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(d[T]={version:1,value:O})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:E,updated:g}){const T={},O={},$=(G,B)=>{for(const U of G){if(U.startsWith(o)){T[U.substring(o.length)]=B?B[U].value:void 0;continue}if(B){const M=B[U];M.value!==String(this.storageService.get(U,0))&&(O[U]=M.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if($(Object.keys(d),d),$(Object.keys(g),g),$(E),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const G of Object.keys(O))this.storageService.store(G,O[G],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(d){const E=await this.getLocalArgvContent();let g=E;for(const T of Object.keys(d))g=(0,P.edit)(g,[T],d[T],{});E!==g&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(g)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const E=this.storageService.keys(0,0),g=this.storageService.keys(0,1),T=[...E,...g],O=d?.storage?Object.keys(d.storage).filter($=>!$.startsWith(o)&&!T.includes($)&&this.storageService.get($,0)!==void 0):[];if(!b.isWeb){const $=[...S.ALL_SYNC_RESOURCES.map(x=>(0,S.getEnablementKey)(x)),S.SYNC_SERVICE_URL_TYPE];O.push(...$),g.push(...$)}return{user:E,machine:g,unregistered:O}}};s.GLOBAL_STATE_DATA_URI=v.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=fe([Y(0,A.IFileService),Y(1,S.IUserDataSyncStoreService),Y(2,S.IUserDataSyncBackupStoreService),Y(3,S.IUserDataSyncLogService),Y(4,k.IEnvironmentService),Y(5,S.IUserDataSyncResourceEnablementService),Y(6,y.ITelemetryService),Y(7,m.IConfigurationService),Y(8,D.IStorageService)],s),e.GlobalStateSynchroniser=s;let u=class extends n.AbstractInitializer{constructor(d,E,g,T){super("globalState",g,T,E);this.storageService=d}async doInitialize(d){const E=d.syncData?JSON.parse(d.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const g={},T={};for(const O of Object.keys(E.storage))O.startsWith(o)?g[O.substring(o.length)]=E.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=E.storage[O].value);if(Object.keys(g).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch($){}for(const $ of Object.keys(g))O=(0,P.edit)(O,[$],g[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};u=fe([Y(0,D.IStorageService),Y(1,A.IFileService),Y(2,k.IEnvironmentService),Y(3,S.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let c=class{constructor(d,E,g,T,O){this.userDataSyncStoreClient=d,this.storageService=E,this.environmentService=g,this.fileService=T,this.logService=O}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const E=(0,S.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(d,E)}catch(g){if(g instanceof S.UserDataSyncError)switch(g.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,E)}throw g}}async doSync(d,E){const g=await this.userDataSyncStoreClient.read("globalState",null,E),T=this.parseGlobalState(g)||{storage:{}};T.storage[S.SYNC_SERVICE_URL_TYPE]={value:d,version:i};const O=await(0,C.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),g.ref,E)}parseGlobalState({content:d}){if(!d)return null;const E=JSON.parse(d);if((0,n.isSyncData)(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};c=fe([Y(1,D.IStorageService),Y(2,k.IEnvironmentService),Y(3,A.IFileService),Y(4,a.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[195],ee([0,1,14,22,190,33,126,9,24,7,16,23,46,21,20,25,3]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(a,o){const t=JSON.parse(a);if(!o)return(0,n.isUndefined)(t.all)?null:t.all;switch(w.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let C=class extends m.AbstractJsonFileSynchroniser{constructor(o,t,r,i,s,u,c,l,d,E){super(c.keybindingsResource,"keybindings",u,c,l,o,t,s,E,r,d,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,g=>g.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,r,i){const s=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;t=t===null&&r?o:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let d=null,E=!1,g=!1,T=!1;if(s){let $=c?c.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new L.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==$||u!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const x=await(0,R.merge)($,s,u,l,this.userDataSyncUtilService);x.hasChanges&&(d=x.mergeContent,T=x.hasConflicts,E=T||x.mergeContent!==$,g=T||x.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=c.value.toString(),g=!0);const O={content:d,localChange:E?c?2:1:0,remoteChange:g?2:0,hasConflicts:T};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,i){const{fileContent:s}=r[0][0];let{content:u,localChange:c,remoteChange:l}=r[0][1];if(c===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new L.UserDataSyncError((0,A.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(u||"[]",s,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(u||"[]",o.syncData?.content);o=await this.updateRemoteUserData(d,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,k.parse)(o.value.toString());if((0,y.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(o)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(o.syncData.content)}getKeybindingsContentFromSyncContent(o){try{return b(o,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(o,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=o,w.OS){case 2:r.mac=o;break;case 3:r.linux=o;break;case 1:r.windows=o;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let o=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return o!==void 0||(o=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,o!==void 0)?o:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};C=fe([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncBackupStoreService),Y(2,L.IUserDataSyncLogService),Y(3,p.IConfigurationService),Y(4,L.IUserDataSyncResourceEnablementService),Y(5,S.IFileService),Y(6,P.IEnvironmentService),Y(7,h.IStorageService),Y(8,L.IUserDataSyncUtilService),Y(9,v.ITelemetryService)],C),e.KeybindingsSynchroniser=C;let f=class extends m.AbstractInitializer{constructor(o,t,r){super("keybindings",t,r,o)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,I.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(o.value.toString());return!(0,y.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return b(o,!0)}catch(t){return this.logService.error(t),null}}};f=fe([Y(0,S.IFileService),Y(1,P.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(Z[196],ee([0,1,26,33,41,47,54,22,23]),function(K,e,S,L,R,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(c,l,d){let E=[];d?E=y(d):E=n(l);const g=[],T=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const O of E)O.startsWith("-")?T.push(O.substring(1)):g.push(O);return(0,p.distinct)([...c,...g].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=w;function n(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function y(c){const l=(0,L.parse)(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function m(c,l,d,E){if(d.length){const g=u(l),T=(0,L.parse)(l),O=(0,L.parse)(c),$=[];for(const x of d){const G=T[x],B=O[x];G===void 0?c=A.edit(c,[x],void 0,E):B!==void 0?c=A.edit(c,[x],G,E):$.push(o(x,g))}$.sort((x,G)=>x.startOffset-G.startOffset),$.forEach(x=>c=b(x.setting.key,l,c,E))}return c}e.updateIgnoredSettings=m;function v(c,l,d,E,g,T){const O=m(c,l,E,T),$=d!==O,x=d!==l;if(!$&&!x)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!x)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(x&&!$)return{conflictsSettings:[],localContent:m(l,c,E,T),remoteContent:null,hasConflicts:!1};if(d===null&&I(c)){const ne=h(c,l,E)?null:m(l,c,E,T);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let G=c,B=l;const U=(0,L.parse)(c),M=(0,L.parse)(l),F=d?(0,L.parse)(d):null,j=E.reduce((ne,le)=>(ne.add(le),ne),new Set),_=D(U,M,j),N=D(F,U,j),W=D(F,M,j),z=new Map,V=new Set,H=ne=>{V.add(ne);const le=g.filter(({key:de})=>de===ne)[0];le?(G=A.edit(G,[ne],le.value,T),B=A.edit(B,[ne],le.value,T)):z.set(ne,{key:ne,localValue:U[ne],remoteValue:M[ne]})};for(const ne of N.removed.values())W.updated.has(ne)?H(ne):B=A.edit(B,[ne],void 0,T);for(const ne of W.removed.values())V.has(ne)||(N.updated.has(ne)?H(ne):G=A.edit(G,[ne],void 0,T));for(const ne of N.updated.values())V.has(ne)||(W.updated.has(ne)?_.updated.has(ne)&&H(ne):B=A.edit(B,[ne],U[ne],T));for(const ne of W.updated.values())V.has(ne)||(N.updated.has(ne)?_.updated.has(ne)&&H(ne):G=A.edit(G,[ne],M[ne],T));for(const ne of N.added.values())V.has(ne)||(W.added.has(ne)?_.updated.has(ne)&&H(ne):B=b(ne,G,B,T));for(const ne of W.added.values())V.has(ne)||(N.added.has(ne)?_.updated.has(ne)&&H(ne):G=b(ne,B,G,T));const X=z.size>0||!h(G,B,E),Q=X||!h(G,c,[]),ie=X||!h(B,l,[]);return{localContent:Q?G:null,remoteContent:ie?B:null,conflictsSettings:[...z.values()],hasConflicts:X}}e.merge=v;function h(c,l,d){if(c===l)return!0;const E=(0,L.parse)(c),g=(0,L.parse)(l),T=d.reduce((x,G)=>(x.add(G),x),new Set),O=u(c).filter(x=>!(x.setting&&T.has(x.setting.key))),$=u(l).filter(x=>!(x.setting&&T.has(x.setting.key)));if(O.length!==$.length)return!1;for(let x=0;x<O.length;x++){const G=O[x],B=$[x];if(G.setting&&B.setting){if(G.setting.key!==B.setting.key||!S.equals(E[G.setting.key],g[G.setting.key]))return!1}else if(!G.setting&&!B.setting){if(G.value!==B.value)return!1}else return!1}return!0}e.areSame=h;function I(c){return c?u(c).length===0:!0}e.isEmpty=I;function D(c,l,d){const E=c?Object.keys(c).filter(x=>!d.has(x)):[],g=Object.keys(l).filter(x=>!d.has(x)),T=g.filter(x=>E.indexOf(x)===-1).reduce((x,G)=>(x.add(G),x),new Set),O=E.filter(x=>g.indexOf(x)===-1).reduce((x,G)=>(x.add(G),x),new Set),$=new Set;if(c)for(const x of E){if(O.has(x))continue;const G=c[x],B=l[x];S.equals(G,B)||$.add(x)}return{added:T,removed:O,updated:$}}function b(c,l,d,E){const g=(0,L.parse)(l),T=u(l),O=u(d),$=C(c,T,O);return f(d,c,g[c],$,O,E)}e.addSetting=b;function C(c,l,d){const E=l.findIndex(T=>T.setting?.key===c),g=l[E-1];if(g){if(g.setting){const O=o(g.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!0}}else{const O=t(E,l);if(O){const $=o(O.setting.key,d);if($){const x=r(d.indexOf($),d),G=i(l,O,l[E]);if(x){const B=i(d,$,x),U=s(G,B);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.indexOf(x),insertAfter:!1}}else{const B=i(d,$,d[d.length-1]),U=s(G,B);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const T=l[E+1];if(T)if(T.setting){const O=o(T.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!1}}else{const O=r(E,l);if(O){const $=o(O.setting.key,d);if($){const x=t(d.indexOf($),d),G=i(l,l[E],O);if(x){const B=i(d,x,$),U=s(G.reverse(),B.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:d.indexOf(x),insertAfter:!0}}else{const B=i(d,d[0],$),U=s(G.reverse(),B.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function f(c,l,d,E,g,T){let O;return E.index===-1?O=(0,R.setProperty)(c,[l],d,T):O=a(c,l,d,E,g,T).map($=>(0,R.withFormatting)(c,$,T)[0]),(0,R.applyEdits)(c,O)}function a(c,l,d,E,g,T){const O=`${JSON.stringify(l)}: ${JSON.stringify(d)}`,$=(0,k.getEOL)(T,c),x=g[E.index];if(E.insertAfter){const G=[];if(x.setting)G.push({offset:x.endOffset,length:0,content:","+O});else{const B=r(E.index,g),U=t(E.index,g),M=U?.setting?.commaOffset;U&&M===void 0&&G.push({offset:U.endOffset,length:0,content:","});const F=M!==void 0&&M>x.endOffset;G.push({offset:F?M+1:x.endOffset,length:0,content:B?$+O+",":$+O})}return G}else{if(x.setting)return[{offset:x.startOffset,length:0,content:O+","}];const G=(g[E.index-1]&&!g[E.index-1].setting?$:"")+O+(r(E.index,g)?",":"")+$;return[{offset:x.startOffset,length:0,content:G}]}}function o(c,l){return l.filter(d=>d.setting?.key===c)[0]}function t(c,l){for(let d=c-1;d>=0;d--)if(l[d].setting)return l[d]}function r(c,l){for(let d=c+1;d<l.length;d++)if(l[d].setting)return l[d]}function i(c,l,d){const E=c.indexOf(l),g=c.indexOf(d);return c.filter((T,O)=>E<O&&O<g)}function s(c,l){if(c.length&&l.length){let d=0;for(;d<l.length&&d<c.length;d++)if(c[d].value!==l[d].value)return l[d-1];return l[d-1]}}function u(c){const l=[];let d=-1,E,g;const T={onObjectBegin:O=>{d++},onObjectProperty:(O,$,x)=>{d===0&&(E=$,g=O)},onObjectEnd:(O,$)=>{d--,d===0&&l.push({startOffset:E,endOffset:O+$,value:c.substring(E,O+$),setting:{key:g,commaOffset:void 0}})},onArrayBegin:(O,$)=>{d++},onArrayEnd:(O,$)=>{d--,d===0&&l.push({startOffset:E,endOffset:O+$,value:c.substring(E,O+$),setting:{key:g,commaOffset:void 0}})},onLiteralValue:(O,$,x)=>{d===0&&l.push({startOffset:E,endOffset:$+x,value:c.substring(E,$+x),setting:{key:g,commaOffset:void 0}})},onSeparator:(O,$,x)=>{if(d===0&&O===","){let G=l.length-1;for(;G>=0&&!l[G].setting;G--);const B=l[G];B&&l.splice(G,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:$}})}},onComment:(O,$)=>{d===0&&l.push({startOffset:O,endOffset:O+$,value:c.substring(O,O+$)})}};return(0,L.visit)(c,T),l}}),define(Z[197],ee([0,1,14,22,25,127,3,9,24,196,54,46,21,27,20,41]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(o){return o&&o.settings&&typeof o.settings=="string"&&Object.keys(o).length===1}function b(o){const t=JSON.parse(o);return D(t)?t:{settings:o}}e.parseSettingsSyncContent=b;let C=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,i,s,u,c,l,d,E,g,T){super(r.settingsResource,"settings",t,r,i,s,u,E,g,c,l,d);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,s){const u=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const d=r?this.getSettingsSyncContent(r):null,E=await this.getIgnoredSettings();let g=null,T=!1,O=!1,$=!1;if(l){let G=u?u.value.toString().trim():"{}";G=G||"{}",this.validateContent(G),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const B=(0,w.merge)(G,l.settings,d?d.settings:null,E,[],c);g=B.localContent||B.remoteContent,T=B.localContent!==null,O=B.remoteContent!==null,$=B.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=u.value.toString(),O=!0);const x={content:g,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:$};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:x.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:x.remoteChange,previewResource:this.previewResource,previewResult:x,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,w.updateIgnoredSettings)(t.previewResult.content,"{}",s,i):null}}async getAcceptResult(t,r,i,s){const u=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,w.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,w.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,s){const{fileContent:u}=i[0][0];let{content:c,localChange:l,remoteChange:d}=i[0][1];if(l===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(c,u,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const E=await this.getFormattingOptions(),g=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(c);c=(0,w.updateIgnoredSettings)(c,g?g.settings:"{}",T,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,w.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const s=this.parseSettingsSyncContent(i.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,w.updateIgnoredSettings)(r,"{}",s,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let s=i.settings;const u=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const l=(0,I.setProperty)(s,[c],r[c],u);l.length&&(s=(0,I.applyEdits)(s,l))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(s))}catch(t){}}};C=fe([Y(0,S.IFileService),Y(1,P.IEnvironmentService),Y(2,h.IStorageService),Y(3,L.IUserDataSyncStoreService),Y(4,L.IUserDataSyncBackupStoreService),Y(5,L.IUserDataSyncLogService),Y(6,L.IUserDataSyncUtilService),Y(7,p.IConfigurationService),Y(8,L.IUserDataSyncResourceEnablementService),Y(9,m.ITelemetryService),Y(10,v.IExtensionManagementService)],C),e.SettingsSynchroniser=C;let f=class extends y.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,w.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};f=fe([Y(0,S.IFileService),Y(1,P.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function a(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&o.machineId!==void 0&&typeof o.machineId=="string")}}),define(Z[198],ee([0,1,22,9,14,24,46,21,25,191,20,26,3]),function(K,e,S,L,R,k,A,P,p,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let v=class extends A.AbstractSynchroniser{constructor(D,b,C,f,a,o,t,r,i){super("snippets",b,D,C,f,a,r,i,o,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(m.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,b,C,f){const a=await this.getSnippetsFileContents(),o=this.toSnippetsContents(a),t=D.syncData?this.parseSnippets(D.syncData):null;b=b===null&&C?D:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,w.merge)(o,t,r);return this.getResourcePreviews(i,a,t||{})}async getMergeResult(D,b){return D.previewResult}async getAcceptResult(D,b,C,f){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return C===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:C,localChange:C===null?D.fileContent!==null?3:0:2,remoteChange:C===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(D,b,C,f){const a=C.map(([o,t])=>({...o,acceptResult:t}));a.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),a.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(a),await this.updateLocalSnippets(a,f)),a.some(({remoteChange:o})=>o!==0)&&(D=await this.updateRemoteSnippets(a,D,f)),b?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of a)try{await this.fileService.del(o)}catch(t){}}getResourcePreviews(D,b,C){const f=new Map;for(const a of Object.keys(D.local.added)){const o={content:D.local.added[a],hasConflicts:!1,localChange:1,remoteChange:0};f.set(a,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.local.updated)){const o={content:D.local.updated[a],hasConflicts:!1,localChange:2,remoteChange:0};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.local.removed){const o={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.remote.added)){const o={content:D.remote.added[a],hasConflicts:!1,localChange:0,remoteChange:1};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.remote.updated)){const o={content:D.remote.updated[a],hasConflicts:!1,localChange:0,remoteChange:2};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.remote.removed){const o={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.conflicts){const o={content:b[a]?b[a].value.toString():null,hasConflicts:!0,localChange:b[a]?2:1,remoteChange:C[a]?2:1};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a]||null,localContent:b[a]?b[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(b))if(!f.has(a)){const o={content:b[a]?b[a].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a]||null,localContent:b[a]?b[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:D}){let b=await super.resolveContent(D);if(b){const C=this.parseSyncData(b);if(C){const f=this.parseSnippets(C),a=[];for(const o of Object.keys(f)){const t=this.extUri.joinPath(D,o),r=this.extUri.joinPath(this.snippetsFolder,o),i=await this.fileService.exists(r);a.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return a}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let b=await super.resolveContent(D);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(D)),b){const C=this.parseSyncData(b);if(C)return this.parseSnippets(C)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const b={};for(const C of D)C.fileContent&&(b[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(D,b){for(const{fileContent:C,acceptResult:f,localResource:a,remoteResource:o,localChange:t}of D)if(t!==0){const r=o?this.extUri.basename(o):this.extUri.basename(a),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(f.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(f.content),b?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,b,C){const f=b.syncData?this.parseSnippets(b.syncData):{},a=(0,y.deepClone)(f);for(const{acceptResult:o,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete a[s]:a[s]=o.content}return(0,w.areSame)(f,a)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(a),C?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const b={};for(const C of Object.keys(D))b[C]=D[C].value.toString();return b}async getSnippetsFileContents(){const D={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof R.FileOperationError&&C.fileOperationResult===1)return D;throw C}for(const C of b.children||[]){const f=C.resource,a=this.extUri.extname(f);if(a===".json"||a===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);D[o]=t}}return D}};v=fe([Y(0,L.IEnvironmentService),Y(1,R.IFileService),Y(2,n.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,k.IConfigurationService),Y(7,S.IUserDataSyncResourceEnablementService),Y(8,P.ITelemetryService)],v),e.SnippetsSynchroniser=v;let h=class extends A.AbstractInitializer{constructor(D,b,C){super("snippets",b,C,D)}async doInitialize(D){const b=D.syncData?JSON.parse(D.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(b)){const a=b[f];if(a){const o=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(o,p.VSBuffer.fromString(a)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(D)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(D){return D.fileOperationResult===1}}};h=fe([Y(0,R.IFileService),Y(1,L.IEnvironmentService),Y(2,S.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(Z[60],ee([0,1,6,3,2,22]),function(K,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let A=class extends R.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};A=fe([Y(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[199],ee([0,1,2,22,15,24,14,9,56,25,5]),function(K,e,S,L,R,k,A,P,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends S.Disposable{constructor(v,h,I,D){super();this.environmentService=v,this.fileService=h,this.configurationService=I,this.logService=D,L.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(v){const h=(0,R.joinPath)(this.environmentService.userDataSyncHome,v),I=await this.fileService.resolve(h);return I.children?I.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(v,h){if(!h){const I=await this.getAllRefs(v);I.length&&(h=I[I.length-1].ref)}if(h){const I=(0,R.joinPath)(this.environmentService.userDataSyncHome,v,h);return(await this.fileService.readFile(I)).value.toString()}return null}async backup(v,h){const I=(0,R.joinPath)(this.environmentService.userDataSyncHome,v),D=(0,R.joinPath)(I,`${(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,w.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(v)}catch(b){}}async cleanUpBackup(v){const h=(0,R.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(h))return}catch(D){return}const I=await this.fileService.resolve(h);if(I.children){const D=I.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let C=D.filter(a=>Date.now()-this.getCreationTime(a)>b);const f=D.length-C.length;f<10&&(C=C.slice(10-f)),await n.Promises.settled(C.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(I){this.logService.error(I)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};y=fe([Y(0,P.IEnvironmentService),Y(1,A.IFileService),Y(2,k.IConfigurationService),Y(3,L.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(Z[200],ee([0,1,4,2]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(m){this.service=m}listen(m,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(m){this.service=m}listen(m,v){throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class p{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class w{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class n extends L.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:S.URI.revive(m.url),type:m.type,defaultUrl:S.URI.revive(m.defaultUrl),insidersUrl:S.URI.revive(m.insidersUrl),stableUrl:S.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[201],ee([0,1,10,9]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends S.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};R=fe([Y(0,S.ILoggerService),Y(1,L.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],ee([0,1,6,2,45,9,14,20,22,130,28,7,19,3]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let I=class Ke extends L.Disposable{constructor(b,C,f,a,o,t){super();this.storageService=f,this.userDataSyncStoreService=a,this.logService=o,this.productService=t,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,R.getServiceMachineId)(b,C,f)}async getMachines(b){const C=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(a=>({...a,isCurrent:a.id===C}))}async addCurrentMachine(b){const C=await this.currentMachineIdPromise,f=await this.readMachinesData(b);f.machines.some(({id:a})=>a===C)||(f.machines.push({id:C,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(b){const C=await this.currentMachineIdPromise,f=await this.readMachinesData(b),a=f.machines.filter(({id:o})=>o!==C);a.length!==f.machines.length&&(f.machines=a,await this.writeMachinesData(f))}async renameMachine(b,C,f){const a=await this.currentMachineIdPromise,o=await this.readMachinesData(f),t=o.machines.find(({id:r})=>r===b);t&&(t.name=C,await this.writeMachinesData(o),o.machines.some(({id:r})=>r===a)&&this.storageService.store(h,C,0,1))}async setEnablement(b,C){const f=await this.readMachinesData(),a=f.machines.find(({id:o})=>o===b);a&&(a.disabled=C?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(b){const C=this.storageService.get(h,0);if(C)return C;const f=`${this.productService.nameLong} (${(0,y.PlatformToString)(y.isWeb?0:y.platform)})`,a=new RegExp(`${(0,m.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let o=0;for(const t of b){const r=a.exec(t.name),i=r?parseInt(r[1]):0;o=i>o?i:o}return`${f} #${o+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const C=this.parse(this.userData);if(C.version!==Ke.VERSION)throw new Error((0,w.localize)(0,null,this.productService.nameLong));return C}async writeMachinesData(b){const C=JSON.stringify(b),f=await this.userDataSyncStoreService.write(Ke.RESOURCE,C,this.userData?.ref||null);this.userData={ref:f,content:C},this._onDidChange.fire()}async readUserData(b){if(this.userData){const C=b&&b.latest?b.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===C)return this.userData;if(C===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(C){this.logService.error(C)}return{version:Ke.VERSION,machines:[]}}};I.VERSION=1,I.RESOURCE="machines",I=fe([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,P.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,n.IProductService)],I),e.UserDataSyncMachinesService=I}),define(Z[87],ee([0,1,5,3,2,22,60,21,11,20,9,61,128,56,4,15,7,28,39]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const f="sync.enable",a="sync.disableMachineEventually",o="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let i=class extends R.Disposable{constructor(l,d,E){super();this.storageService=l,this.environmentService=d,this.userDataSyncStoreManagementService=E,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(g=>this.onDidStorageChange(g)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(f,l,0,1)}onDidStorageChange(l){if(l.scope===0&&f===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=fe([Y(0,w.IStorageService),Y(1,n.IEnvironmentService),Y(2,k.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let s=class extends R.Disposable{constructor(l,d,E,g,T,O,$,x,G,B,U){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=E,this.userDataSyncResourceEnablementService=g,this.userDataSyncService=T,this.logService=O,this.userDataSyncAccountService=$,this.telemetryService=x,this.userDataSyncMachinesService=G,this.storageService=B,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register($.onDidChangeAccount(()=>this.updateAutoSync())),this._register(E.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(T.onDidChangeLocal,(M,F)=>M?[...M,F]:[F],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(t,0);return l?h.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(t,l.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(l){l?this.storageService.store(r,l,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:l,message:d}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new u(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(E=>this.onDidFinishSync(E))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,v.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,d,E){try{this.userDataSyncAccountService.account&&!E&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(g){if(d)this.logService.error(g),this.updateEnablement(!1);else throw g}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(f,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const d=k.UserDataSyncError.toUserDataSyncError(l);d instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?D.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(a,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(a,0,!1)}stopDisableMachineEventually(){this.storageService.remove(a,0)}async triggerSync(l,d,E){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",E)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=fe([Y(0,b.IProductService),Y(1,k.IUserDataSyncStoreManagementService),Y(2,k.IUserDataSyncStoreService),Y(3,k.IUserDataSyncResourceEnablementService),Y(4,k.IUserDataSyncService),Y(5,k.IUserDataSyncLogService),Y(6,A.IUserDataSyncAccountService),Y(7,P.ITelemetryService),Y(8,y.IUserDataSyncMachinesService),Y(9,w.IStorageService),Y(10,k.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class u extends R.Disposable{constructor(l,d,E,g,T,O,$,x){super();this.lastSyncUrl=l,this.interval=d,this.userDataSyncStoreManagementService=E,this.userDataSyncStoreService=g,this.userDataSyncService=T,this.userDataSyncMachinesService=O,this.logService=$,this.storageService=x,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(u.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(u.INTERVAL_SYNCING,!1),this.interval)}sync(l,d){const E=(0,S.createCancelablePromise)(async g=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(T){if((0,p.isPromiseCanceledError)(T))return}return this.doSync(l,d,g)});return this.syncPromise=E,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!l&&(!(0,I.isEqual)(d.defaultUrl,l.defaultUrl)||!(0,I.isEqual)(d.insidersUrl,l.insidersUrl)||!(0,I.isEqual)(d.stableUrl,l.stableUrl))}async doSync(l,d,E){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let g;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),E.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(0,null),"DefaultServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(1,null),"ServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(2,null),"TurnedOff");const T=this.storageService.get(o,0);if(T&&this.manifest&&T!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(3,null),"DefaultServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(4,null),"ServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(E.isCancellationRequested)return;const $=O.find(x=>x.isCurrent);if($?.disabled)throw new k.UserDataAutoSyncError((0,m.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(x){throw new k.UserDataAutoSyncError((0,C.toErrorMessage)(x),x instanceof k.UserDataSyncError?x.code:"Unknown")}if(this.manifest&&this.manifest.session!==T&&this.storageService.store(o,this.manifest.session,0,1),E.isCancellationRequested)return;$||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(T){this.logService.error(T),g=T}this._onDidFinishSync.fire(g)}register(l){return super._register(l)}}u.INTERVAL_SYNCING="Interval"}),define(Z[202],ee([0,1,22,2,3,20,21,7]),function(K,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends L.Disposable{constructor(n,y){super();this.storageService=n,this.telemetryService=y,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(n){return this.storageService.getBoolean((0,S.getEnablementKey)(n),0,!0)}setResourceEnablement(n,y){if(this.isResourceEnabled(n)!==y){const m=(0,S.getEnablementKey)(n);this.telemetryService.publicLog2(m,{enabled:y}),this.storeResourceEnablement(m,y)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,y){this.storageService.store(n,y,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const y=S.ALL_SYNC_RESOURCES.filter(m=>(0,S.getEnablementKey)(m)===n.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}}};p=fe([Y(0,k.IStorageService),Y(1,A.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(Z[203],ee([0,1,22,2,6,3,192,195,194,39,21,23,20,197,15,198,30,5,11]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let a=class extends L.Disposable{constructor(i,s,u,c,l,d){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=s,this.instantiationService=u,this.logService=c,this.telemetryService=l,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(v.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(P.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(I.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,s){await this.checkEnablement();const u=(0,D.generateUuid)();try{const E=(0,S.createSyncHeaders)(u);s&&(E["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,E)}catch(E){const g=S.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(g,u),g}let c=!1;const l=this;let d;return{manifest:i,run(){if(c)throw new Error("Can run a task only once");return d=(0,b.createCancelablePromise)(E=>l.sync(i,u,E)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,D.generateUuid)(),s=(0,S.createSyncHeaders)(i);let u;try{u=await this.userDataSyncStoreService.manifest(null,s)}catch(c){const l=S.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,i),l}return new o(i,u,s,this.synchronisers,this.logService)}async sync(i,s,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,S.createSyncHeaders)(s);for(const d of this.synchronisers){if(u.isCancellationRequested)return;try{await d.sync(i,l)}catch(E){let g=!1;if(E instanceof S.UserDataSyncError)switch(E.code){case"TooLarge":E=new S.UserDataSyncError(E.message,E.code,d.resource),g=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":g=!0;break}const T=S.UserDataSyncError.toUserDataSyncError(E);if(this.reportUserDataSyncError(T,s),g)throw T;this.logService.error(E),this.logService.error(`${d.resource}: ${(0,w.toErrorMessage)(E)}`),this._syncErrors.push([d.resource,T])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const d=S.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(d,s),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(s){this.logService.error(s)}}async replace(i){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(i))return}async accept(i,s,u,c){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(s,u),c&&await l.apply(!1,(0,S.createSyncHeaders)((0,D.generateUuid)()))}async resolveContent(i){for(const s of this.synchronisers){const u=await s.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,s){return this.getSynchroniser(i).getAssociatedResources(s)}getMachineId(i,s){return this.getSynchroniser(i).getMachineId(s)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of i)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(s){this.logService.error(`${i.resource}: ${(0,w.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const s=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,y.equals)(this._conflicts,i,([s,u],[c,l])=>s===s&&(0,y.equals)(u,l,(d,E)=>(0,h.isEqual)(d.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,s){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof S.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof S.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(s=>s.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=fe([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,R.IInstantiationService),Y(3,S.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,m.IStorageService)],a),e.UserDataSyncService=a;class o extends L.Disposable{constructor(i,s,u,c,l){super();this.id=i,this.manifest=s,this.syncHeaders=u,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,s){try{return await this.performAction(i,u=>u.accept(i,s))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,s=>s.merge(i)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(i){try{return await this.performAction(i,s=>s.discard(i))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,s]of this.previews)for(const u of s.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const s of i)await this.discard(s);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(d=>d.resource===s);for(const d of u.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await c.merge(d.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await u.accept(c.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await u.accept(c.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(s){(0,C.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(i,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:x,previewResource:G,remoteResource:B})=>(0,h.isEqual)(i,x)||(0,h.isEqual)(i,G)||(0,h.isEqual)(i,B)));if(u===-1)return this.previews;const[c,l]=this.previews[u],d=l.resourcePreviews.find(({localResource:$,remoteResource:x,previewResource:G})=>(0,h.isEqual)($,i)||(0,h.isEqual)(x,i)||(0,h.isEqual)(G,i));if(!d)return this.previews;let E=this.synchronizingResources.find($=>$[0]===c);E||(E=[c,[]],this.synchronizingResources.push(E)),E[1].some($=>(0,h.isEqual)($,d.localResource))||(E[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const g=this.synchronisers.find($=>$.resource===this.previews[u][0]),T=await s(g);T?this.previews.splice(u,1,this.toSyncResourcePreview(g.resource,T)):this.previews.splice(u,1);const O=this.synchronizingResources.findIndex($=>$[0]===c);return this.synchronizingResources[O][1].splice(E[1].findIndex($=>(0,h.isEqual)($,d.localResource)),1),E[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(d=>d.resource===s);let l=u;for(const d of u.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(l=await c.merge(d.previewResource));l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const s=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const c=await u.preview(this.manifest,this.syncHeaders);c&&s.push(this.toSyncResourcePreview(u.resource,c))}return s}toSyncResourcePreview(i,s){return[i,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[204],ee([0,1,3,22,4,2,16]),function(K,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(y,m){this.service=y,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(y,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(y,m,v){try{return await this._call(y,m,v)}catch(h){throw this.logService.error(h),h}}async _call(y,m,v){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(R.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],R.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(R.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:R.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:R.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),I=v[0],D=this.getManualSyncTask(I);switch(v=v.slice(1),h){case"preview":return D.preview();case"accept":return D.accept(R.URI.revive(v[0]),v[1]);case"merge":return D.merge(R.URI.revive(v[0]));case"discard":return D.discard(R.URI.revive(v[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(y){const m=this.manualSyncTasks.get(this.createKey(y));if(!m)throw new Error(`Manual sync taks not found: ${y}`);return m.manualSyncTask}async createManualSyncTask(){const y=new k.DisposableStore,m=y.add(await this.service.createManualSyncTask());return y.add(m.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:v}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:y}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(y){y.dispose();const m=this.createKey(y.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=P;class p extends k.Disposable{constructor(y){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,v,h){return y.call(m,v,h).then(null,I=>{throw L.UserDataSyncError.toUserDataSyncError(I)})},listen(m,v){return y.listen(m,v)}},this.channel.call("_getInitialData").then(([m,v,h])=>{this.updateStatus(m),this.updateConflicts(v),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(I=>this.updateStatus(I))),this._register(this.channel.listen("onDidChangeLastSyncTime")(I=>this.updateLastSyncTime(I)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([v,h])=>[v,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:y,manifest:m,status:v}=await this.channel.call("createManualSyncTask"),h=this,I=new w(y,m,v,{async call(D,b,C){return h.channel.call(`manualSync/${D}`,[y,...(0,A.isArray)(b)?b:[b]],C)},listen(D,b){return S.Event.map(S.Event.filter(h.channel.listen(`manualSync/${D}`,b),C=>!I.isDiposed()&&C.manualSyncTaskId===y),C=>C.data)}});return I}replace(y){return this.channel.call("replace",[y])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(y,m,v,h){return this.channel.call("accept",[y,m,v,h])}resolveContent(y){return this.channel.call("resolveContent",[y])}async getLocalSyncResourceHandles(y){return(await this.channel.call("getLocalSyncResourceHandles",[y])).map(({created:v,uri:h})=>({created:v,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(y){return(await this.channel.call("getRemoteSyncResourceHandles",[y])).map(({created:v,uri:h})=>({created:v,uri:R.URI.revive(h)}))}async getAssociatedResources(y,m){return(await this.channel.call("getAssociatedResources",[y,m])).map(({resource:h,comparableResource:I})=>({resource:R.URI.revive(h),comparableResource:R.URI.revive(I)}))}async getMachineId(y,m){return this.channel.call("getMachineId",[y,m])}async updateStatus(y){this._status=y,this._onDidChangeStatus.fire(y)}async updateConflicts(y){this._conflicts=y.map(([m,v])=>[m,v.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(y){this._lastSyncTime!==y&&(this._lastSyncTime=y,this._onDidChangeLastSyncTime.fire(y))}}e.UserDataSyncChannelClient=p;class w extends k.Disposable{constructor(y,m,v,h){super();this.id=y,this.manifest=m,this._disposed=!1,this._status=v;const I=this;this.channel={async call(D,b,C){try{const f=await h.call(D,b,C);return I.isDiposed()||(I._status=await h.call("_getStatus")),f}catch(f){throw L.UserDataSyncError.toUserDataSyncError(f)}},listen(D,b){return h.listen(D,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const y=await this.channel.call("preview");return this.deserializePreviews(y)}async accept(y,m){const v=await this.channel.call("accept",[y,m]);return this.deserializePreviews(v)}async merge(y){const m=await this.channel.call("merge",[y]);return this.deserializePreviews(m)}async discard(y){const m=await this.channel.call("discard",[y]);return this.deserializePreviews(m)}async discardConflicts(){const y=await this.channel.call("discardConflicts");return this.deserializePreviews(y)}async apply(){const y=await this.channel.call("apply");return this.deserializePreviews(y)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(y){return y.map(([m,v])=>[m,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource),acceptedResource:R.URI.revive(h.acceptedResource)}))}])}}}),define(Z[205],ee([0,1,2,22,40,15,29,24,28,45,9,14,20,30,7,3,5,16,4,11,93]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",s=100,u=1e3*60*5;let c=class extends S.Disposable{constructor(O,$,x){super();this.productService=O,this.configurationService=$,this.storageService=x,this._onDidChangeUserDataSyncStore=this._register(new I.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(I.Event.filter(x.onDidChangeValue,G=>G.key===L.SYNC_SERVICE_URL_TYPE&&G.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,O,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,$){O=h.isWeb&&O?.web?{...O,...O.web}:O;const x={...O||{},...$||{}};if(x&&(0,b.isString)(x.url)&&(0,b.isObject)(x.authenticationProviders)&&Object.keys(x.authenticationProviders).every(G=>(0,b.isArray)(x.authenticationProviders[G].scopes))){const G=x,B=!!G.canSwitch&&!$?.url,U=G.url===G.insidersUrl?"insiders":"stable",M=(B?this.userDataSyncStoreType:void 0)||U,F=$?.url||(M==="insiders"?G.insidersUrl:M==="stable"?G.stableUrl:G.url);return{url:C.URI.parse(F),type:M,defaultType:U,defaultUrl:C.URI.parse(G.url),stableUrl:C.URI.parse(G.stableUrl),insidersUrl:C.URI.parse(G.insidersUrl),canSwitch:B,authenticationProviders:Object.keys(G.authenticationProviders).reduce((j,_)=>(j.push({id:_,scopes:G.authenticationProviders[_].scopes}),j),[])}}}};c=fe([Y(0,p.IProductService),Y(1,P.IConfigurationService),Y(2,m.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(O,$,x){super(O,$,x);const G=this.storageService.get(o,0);G&&(this.previousConfigurationSyncStore=JSON.parse(G));const B=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];B?this.storageService.store(o,JSON.stringify(B),0,1):this.storageService.remove(o,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=fe([Y(0,p.IProductService),Y(1,P.IConfigurationService),Y(2,m.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let d=class extends S.Disposable{constructor(O,$,x,G,B,U,M){super();this.requestService=x,this.logService=G,this.storageService=M,this._onTokenFailed=this._register(new I.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new I.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new I.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(B,U,M).then(F=>{const j={"X-Client-Name":`${$.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":$.version,"X-Machine-Id":F};return $.commit&&(j["X-Client-Commit"]=$.commit),j}),this.session=new g(s,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,$){this.authToken={token:O,type:$}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)($=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),x={},G=await this.request($.toString(),{type:"GET",headers:x},[],A.CancellationToken.None);return(await(0,R.asJson)(G)||[]).map(({url:U,created:M})=>({ref:(0,k.relativePath)($,$.with({path:U})),created:M*1e3}))}async resolveContent(O,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,$).toString(),G={};G["Cache-Control"]="no-cache";const B=await this.request(x,{type:"GET",headers:G},[],A.CancellationToken.None);return await(0,R.asText)(B)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),x={};await this.request($,{type:"DELETE",headers:x},[],A.CancellationToken.None)}async read(O,$,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const G=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();x={...x},x["Cache-Control"]="no-cache",$&&(x["If-None-Match"]=$.ref);const B=await this.request(G,{type:"GET",headers:x},[304],A.CancellationToken.None);let U=null;if(B.res.statusCode===304&&(U=$),U===null){const M=B.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",G,"NoRef",B.res.statusCode,B.res.headers[L.HEADER_OPERATION_ID]);const F=await(0,R.asText)(B);if(!F&&B.res.statusCode===304)throw new L.UserDataSyncStoreError("Empty response",G,"EmptyResponse",B.res.statusCode,B.res.headers[L.HEADER_OPERATION_ID]);U={ref:M,content:F}}return U}async write(O,$,x,G={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();G={...G},G["Content-Type"]=a.Mimes.text,x&&(G["If-Match"]=x);const U=await this.request(B,{type:"POST",data:$,headers:G},[],A.CancellationToken.None),M=U.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",U.res.statusCode,U.res.headers[L.HEADER_OPERATION_ID]);return M}async manifest(O,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();$={...$},$["Content-Type"]="application/json",O&&($["If-None-Match"]=O.ref);const G=await this.request(x,{type:"GET",headers:$},[304],A.CancellationToken.None);let B=null;if(G.res.statusCode===304&&(B=O),!B){const M=G.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",x,"NoRef",G.res.statusCode,G.res.headers[L.HEADER_OPERATION_ID]);const F=await(0,R.asText)(G);if(!F&&G.res.statusCode===304)throw new L.UserDataSyncStoreError("Empty response",x,"EmptyResponse",G.res.statusCode,G.res.headers[L.HEADER_OPERATION_ID]);F&&(B={...JSON.parse(F),ref:M})}const U=this.storageService.get(r,0);return U&&B&&U!==B.session&&this.clearSession(),B===null&&U&&this.clearSession(),B&&this.storageService.store(r,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),$={"Content-Type":a.Mimes.text};await this.request(O,{type:"DELETE",headers:$},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,$,x,G){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const B=await this.commonHeadersPromise;$.headers={...$.headers||{},...B,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders($.headers),this.logService.trace("Sending request to server",{url:O,type:$.type,headers:{...$.headers,authorization:void 0}});let U;try{U=await this.session.request(O,$,G)}catch(_){if(!(_ instanceof L.UserDataSyncStoreError)){let N="RequestFailed";const W=(0,f.getErrorMessage)(_).toLowerCase();W.includes("xhr timeout")?N="RequestTimeout":W.includes("protocol")&&W.includes("not supported")?N="RequestProtocolNotSupported":W.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":W.includes("headers must be an object")?N="RequestHeadersNotObject":(0,f.isPromiseCanceledError)(_)&&(N="RequestCanceled"),_=new L.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,N,void 0,void 0)}throw this.logService.info("Request failed",O),_}const M=U.res.headers[L.HEADER_OPERATION_ID],F={url:O,status:U.res.statusCode,"execution-id":$.headers[L.HEADER_EXECUTION_ID],"operation-id":M},j=(0,R.isSuccess)(U)||U.res.statusCode&&x.indexOf(U.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",F):this.logService.info("Request failed",F),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,M);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,M);if(U.res.statusCode===410)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,M);if(U.res.statusCode===412)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,M);if(U.res.statusCode===413)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,M);if(U.res.statusCode===426)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,M);if(U.res.statusCode===429){const _=U.res.headers["retry-after"];throw _?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(_)*1e3)),new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,M)):new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,M)}if(!j)throw new L.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,M);return U}addSessionHeaders(O){let $=this.storageService.get(i,0);$===void 0&&($=(0,v.generateUuid)(),this.storageService.store(i,$,0,1)),O["X-Machine-Session-Id"]=$;const x=this.storageService.get(r,0);x!==void 0&&(O["X-User-Session-Id"]=x)}};d=fe([Y(1,p.IProductService),Y(2,R.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,y.IFileService),Y(6,m.IStorageService)],d),e.UserDataSyncStoreClient=d;let E=class extends d{constructor(O,$,x,G,B,U,M){super(O.userDataSyncStore?.url,$,x,G,B,U,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};E=fe([Y(0,L.IUserDataSyncStoreManagementService),Y(1,p.IProductService),Y(2,R.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,y.IFileService),Y(6,m.IStorageService)],E),e.UserDataSyncStoreService=E;class g{constructor(O,$,x,G){this.limit=O,this.interval=$,this.requestService=x,this.logService=G,this.requests=[],this.startTime=void 0}request(O,$,x){if(this.isExpired()&&this.reset(),$.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request($,x)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=g}),define(Z[206],ee([0,1,22,3,59,87,60,21,20,61,28]),function(K,e,S,L,R,k,A,P,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends k.UserDataAutoSyncService{constructor(v,h,I,D,b,C,f,a,o,t,r,i){super(v,h,I,D,b,f,a,o,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(C.onDidFocusWindow,()=>"windowFocus"),L.Event.map(C.onDidOpenWindow,()=>"windowOpen")),(s,u)=>s?[...s,u]:[u],1e3)(s=>this.triggerSync(s,!0,!1)))}};y=fe([Y(0,n.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncResourceEnablementService),Y(4,S.IUserDataSyncService),Y(5,R.INativeHostService),Y(6,S.IUserDataSyncLogService),Y(7,A.IUserDataSyncAccountService),Y(8,P.ITelemetryService),Y(9,w.IUserDataSyncMachinesService),Y(10,p.IStorageService),Y(11,S.IUserDataAutoSyncEnablementService)],y),e.UserDataAutoSyncService=y}),define(Z[207],ee([0,1,3,2,5]),function(K,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends L.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:p,getActiveWindowId:w}){super();this.disposables=this._register(new L.DisposableStore),S.Event.latch(S.Event.any(P,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>w()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[62],ee([0,1,109,8,50,5,18,214,215,16]),function(K,e,S,L,R,k,A,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function y(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function m(o){if(o instanceof n)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new n(t,o)}function v(o,t,r,i,s,u){const c=L.dirname(t),l=L.join(i,c);if(!l.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const d=L.join(i,t);let E;return u.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(A.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((g,T)=>{if(!u.isCancellationRequested)try{E=(0,R.createWriteStream)(d,{mode:r}),E.once("close",()=>g()),E.once("error",T),o.once("error",T),o.pipe(E)}catch(O){T(O)}}))}function h(o,t,r,i){let s=(0,k.createCancelablePromise)(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{s.cancel(),o.close()}),new Promise((c,l)=>{const d=new k.Sequencer,E=g=>{g.isCancellationRequested||(u++,o.readEntry())};o.once("error",l),o.once("close",()=>s.then(()=>{i.isCancellationRequested||o.entryCount===u?c():l(new n("Incomplete",new Error(S.localize(1,null,u,o.entryCount))))},l)),o.readEntry(),o.on("entry",g=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(g.fileName)){E(i);return}const T=g.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const x=L.join(t,T);s=(0,k.createCancelablePromise)(G=>A.Promises.mkdir(x,{recursive:!0}).then(()=>E(G)).then(void 0,l));return}const O=D(o,g),$=y(g);s=(0,k.createCancelablePromise)(x=>d.queue(()=>O.then(G=>v(G,T,$,t,r,x).then(()=>E(x)))).then(null,l))})})}function I(o,t=!1){return new Promise((r,i)=>{(0,P.open)(o,t?{lazyEntries:!0}:void 0,(s,u)=>{s?i(m(s)):r((0,w.assertIsDefined)(u))})})}function D(o,t){return new Promise((r,i)=>{o.openReadStream(t,(s,u)=>{s?i(m(s)):r((0,w.assertIsDefined)(u))})})}function b(o,t){return new Promise((r,i)=>{const s=new p.ZipFile;t.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const u=(0,R.createWriteStream)(o);s.outputStream.pipe(u),s.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(o))})}e.zip=b;function C(o,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=I(o,!0);return r.overwrite&&(u=u.then(c=>A.Promises.rm(t).then(()=>c))),u.then(c=>h(c,t,{sourcePathRegex:s},i))}e.extract=C;function f(o,t){return I(o).then(r=>new Promise((i,s)=>{r.on("entry",u=>{u.fileName===t&&D(r,u).then(c=>i(c),c=>s(c))}),r.once("close",()=>s(new Error(S.localize(2,null,t))))}))}function a(o,t){return f(o,t).then(r=>new Promise((i,s)=>{const u=[];r.once("error",s),r.on("data",c=>u.push(c)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=a}),define(Z[208],ee([0,1,62,115]),function(K,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,S.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(Z[209],ee([0,1,58,2,18,8,10,27,31,5,4,9,136,116,28,62,7,23,17,14,15,30,11]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",u="deleting",c="renaming";let l=class extends L.Disposable{constructor(E,g,T,O,$){super();this.beforeRemovingExtension=E,this.fileService=g,this.logService=T,this.environmentService=O,this.productService=$,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const g=[];(E===null||E===0)&&g.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,r)))),(E===null||E===1)&&g.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(g);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[g,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!g[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),E&&(T=(0,p.groupByExtension)(T,$=>$.identifier).map($=>$.sort((x,G)=>S.rcompare(x.manifest.version,G.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,g,T){const O=E.key(),$=k.join(this.extensionsPath,`.${(0,o.generateUuid)()}`),x=k.join(this.extensionsPath,O);try{await R.Promises.rm(x)}catch(B){try{await R.Promises.rm(x)}catch(U){}throw new P.ExtensionManagementError((0,v.localize)(0,null,x,E.id),u)}await this.extractAtLocation(E,g,$,T);let G=await this.scanExtension(n.URI.file($),1);if(!G)throw new Error((0,v.localize)(1,null,$));await this.storeMetadata(G,{installedTimestamp:Date.now()});try{await this.rename(E,$,x,Date.now()+2*60*1e3),this.logService.info("Renamed to",x)}catch(B){try{await R.Promises.rm($)}catch(U){}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(B)}. Deleted from extracted location`,$),B}try{G=await this.scanExtension(n.URI.file(x),1)}catch(B){}if(G)return G;throw new Error((0,v.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,g){return this.setMetadata(E,g),await this.storeMetadata(E,{...g,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,g){g.isMachineScoped=g.isMachineScoped||void 0,g.isBuiltin=g.isBuiltin||void 0,g.installedTimestamp=g.installedTimestamp||void 0;const T=k.join(E.location.fsPath,"package.json"),O=await R.Promises.readFile(T,"utf8"),{manifest:$}=await this.parseManifest(O);return $.__metadata=g,await R.Promises.writeFile(T,JSON.stringify($,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const g=E.map(T=>new p.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{g.forEach(O=>T[O.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions(O=>delete O[E.key()]);const T=(await this.scanExtensions(1)).find(O=>new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(E))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let g;try{g=await R.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(g)try{T=JSON.parse(g)}catch(O){}return E&&(E(T),Object.keys(T).length?await R.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await R.Promises.rm(this.uninstalledPath)),T})}async removeExtension(E,g){this.logService.trace(`Deleting ${g} extension from disk`,E.identifier.id,E.location.fsPath),await R.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(g=>delete g[new p.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,g,T,O){this.logService.trace(`Started extracting the extension from ${g} to ${T}`);try{await R.Promises.rm(T)}catch($){throw new P.ExtensionManagementError(this.joinErrors($).message,u)}try{await(0,I.extract)(g,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,E.id)}catch($){try{await R.Promises.rm(T)}catch(x){}throw new P.ExtensionManagementError($.message,$ instanceof I.ExtractError&&$.type?$.type:s)}}async rename(E,g,T,O){try{await R.Promises.rename(g,T)}catch($){if(D.isWindows&&$&&$.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${g} to ${T} with 'EPERM' error. Trying again...`,E.id),this.rename(E,g,T,O);throw new P.ExtensionManagementError($.message||(0,v.localize)(3,null,g,T),$.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const g=this.scanDevSystemExtensions(),[T,O]=await Promise.all([E,g]);return[...T,...O]}async scanExtensionsInDir(E,g){const T=new w.Limiter(10),O=await this.fileService.resolve(n.URI.file(E));return O.children?(await Promise.all(O.children.filter(x=>x.isDirectory).map(x=>T.queue(async()=>g===1&&(0,a.basename)(x.resource).indexOf(".")===0?null:this.scanExtension(x.resource,g))))).filter(x=>x&&x.identifier):[]}async scanExtension(E,g){try{const T=await this.fileService.resolve(E);if(T.children){const{manifest:O,metadata:$}=await this.readManifest(E.fsPath),x=T.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,G=T.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource,B={id:(0,p.getGalleryExtensionId)(O.publisher,O.name)},U={type:g,identifier:B,manifest:O,location:E,readmeUrl:x,changelogUrl:G,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:g===0};return $&&(this.setMetadata(U,$),U.installedTimestamp=$.installedTimestamp),U}}catch(T){g!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const g=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",g.length),g.filter(T=>E.some(O=>(0,p.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(E,g){E.publisherDisplayName=g.publisherDisplayName||null,E.publisherId=g.publisherId||null,E.identifier.uuid=g.id,E.isMachineScoped=!!g.isMachineScoped,E.isBuiltin=E.type===0||!!g.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),g=await this.scanAllUserExtensions(),T=new Set;for(const x of g)E[new p.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version).key()]||T.add(x.identifier.id.toLowerCase());const O=(0,p.groupByExtension)(g,x=>x.identifier);await w.Promises.settled(O.map(async x=>{const G=x.sort((B,U)=>S.rcompare(B.manifest.version,U.manifest.version))[0];T.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(G)}));const $=g.filter(x=>E[new p.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version).key()]);await w.Promises.settled($.map(x=>this.removeUninstalledExtension(x)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),g=[],T=(0,p.groupByExtension)(E,O=>O.identifier);g.push(...(0,b.flatten)(T.map(O=>O.sort(($,x)=>S.rcompare($.manifest.version,x.manifest.version)).slice(1)))),await w.Promises.settled(g.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const g=Array.isArray(E)?E:[E];return g.length===1?g[0]instanceof Error?g[0]:new Error(g[0]):g.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(C.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const g=[R.Promises.readFile(k.join(E,"package.json"),"utf8").then(x=>this.parseManifest(x)),R.Promises.readFile(k.join(E,"package.nls.json"),"utf8").then(void 0,x=>x.code!=="ENOENT"?Promise.reject(x):"{}").then(x=>JSON.parse(x))],[{manifest:T,metadata:O},$]=await Promise.all(g);return{manifest:(0,m.localizeManifest)(T,$),metadata:O}}parseManifest(E){return new Promise((g,T)=>{try{const O=JSON.parse(E),$=O.__metadata||null;g({manifest:O,metadata:$})}catch(O){T(new Error((0,v.localize)(4,null)))}})}};l=fe([Y(1,f.IFileService),Y(2,A.ILogService),Y(3,y.INativeEnvironmentService),Y(4,h.IProductService)],l),e.ExtensionsScanner=l}),define(Z[210],ee([0,1,114,8,18,62,27,31,9,58,4,44,7,10,147,39,21,70,15,30,72,6,17,208,157,209,158,159,14,176]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a,o,t,r,i,s,u,c,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const E="unsetUninstalled",g="downloading";let T=class extends d.AbstractExtensionManagementService{constructor(U,M,F,j,_,N,W){super(U,M,F);this.environmentService=j,this.downloadService=_;const z=this._register(N.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(s.ExtensionsScanner,H=>z.postUninstall(H))),this.manifestCache=this._register(new h.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(N.createInstance(i.ExtensionsDownloader));const V=this._register(new c.ExtensionsWatcher(this,W,j,F));this._register(V.onDidChangeExtensionsByAnotherSource(({added:H,removed:X})=>{H.length&&this._onDidInstallExtensions.fire(H.map(Q=>({identifier:Q.identifier,operation:0,local:Q}))),X.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const M=await this.collectFiles(U),F=await(0,k.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,M);return n.URI.file(F)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const M=await this.downloadVsix(U),F=L.resolve(M.fsPath);return(0,r.getManifest)(F)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,M={}){this.logService.trace("ExtensionManagementService#install",U.toString());const F=await this.downloadVsix(U),j=await(0,r.getManifest)(L.resolve(F.fsPath));if(j.engines&&j.engines.vscode&&!(0,b.isEngineValid)(j.engines.vscode,y.default.version,y.default.date))throw new Error(S.localize(0,null,(0,P.getGalleryExtensionId)(j.publisher,j.name),y.default.version));return this.installExtension(j,F,M)}async updateMetadata(U,M){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...M}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,M){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:M}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===t.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const M=(0,C.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(U,M),M}createInstallExtensionTask(U,M,F){return n.URI.isUri(M)?new x(U,M,F,this.galleryService,this.extensionsScanner,this.logService):new $(M,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,M){return new G(U,M,this.extensionsScanner)}async collectFiles(U){const M=async j=>{let _=await R.Promises.readdir(j);_=_.map(z=>L.join(j,z));const N=await Promise.all(_.map(z=>R.Promises.stat(z)));let W=Promise.resolve([]);return N.forEach((z,V)=>{const H=_[V];z.isFile()&&(W=W.then(X=>[...X,H])),z.isDirectory()&&(W=W.then(X=>M(H).then(Q=>[...X,...Q])))}),W};return(await M(U.location.fsPath)).map(j=>({path:`extension/${L.relative(U.location.fsPath,j)}`,localPath:j}))}};T=fe([Y(0,A.IExtensionGalleryService),Y(1,D.ITelemetryService),Y(2,v.ILogService),Y(3,p.INativeEnvironmentService),Y(4,(0,o.optional)(a.IDownloadService)),Y(5,o.IInstantiationService),Y(6,l.IFileService)],T),e.ExtensionManagementService=T;class O extends d.AbstractExtensionTask{constructor(U,M,F,j){super();this.identifier=U,this.source=M,this.extensionsScanner=F,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(U,M){try{const F=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(F)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,U.metadata):F}catch(F){throw m.isMacintosh?new A.ExtensionManagementError(S.localize(1,null),E):new A.ExtensionManagementError(S.localize(2,null),E)}return this.extract(U,M)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const F=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),F}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:M,metadata:F},j){let _=await this.extensionsScanner.extractUserExtension(M,U,j);return this.logService.info("Extracting completed.",M.id),F&&(_=await this.extensionsScanner.saveMetadataForLocalExtension(_,F)),_}}class $ extends O{constructor(U,M,F,j,_){super(U.identifier,U,j,_);this.gallery=U,this.options=M,this.extensionsDownloader=F}async doRun(U){const F=(await this.extensionsScanner.scanExtensions(null)).find(N=>(0,P.areSameExtensions)(N.identifier,this.gallery.identifier));F&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin;const _=await this.installExtension(j,U);F&&w.neq(F.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(F);try{await this.extensionsDownloader.delete(n.URI.file(j.zipPath))}catch(N){}return _}async downloadInstallableExtension(U,M){const F={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",U.identifier.id),j=(await this.extensionsDownloader.downloadExtension(U,M)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,j)}catch(_){throw new A.ExtensionManagementError((0,d.joinErrors)(_).message,g)}try{const _=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new P.ExtensionIdentifierWithVersion(U.identifier,_.version),metadata:F}}catch(_){throw new A.ExtensionManagementError((0,d.joinErrors)(_).message,d.INSTALL_ERROR_VALIDATING)}}}class x extends O{constructor(U,M,F,j,_,N){super({id:(0,P.getGalleryExtensionId)(U.publisher,U.name)},M,_,N);this.manifest=U,this.location=M,this.options=F,this.galleryService=j}async doRun(U){const M=new P.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(N=>(0,P.areSameExtensions)(this.identifier,N.identifier)),_=await this.getMetadata(this.identifier.id,U);if(j)if(_.isMachineScoped=this.options.isMachineScoped||j.isMachineScoped,_.isBuiltin=this.options.isBuiltin||j.isBuiltin,this._operation=2,M.equals(new P.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(N){throw new Error(S.localize(3,null,this.manifest.displayName||this.manifest.name))}else w.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const N=await this.unsetUninstalledAndGetLocal(M);if(N)try{await this.extensionsScanner.removeExtension(N,"existing")}catch(W){throw new Error(S.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:M,metadata:_},U)}async getMetadata(U,M){try{const F=(await this.galleryService.query({names:[U],pageSize:1},M)).firstPage[0];if(F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId}}catch(F){}return{}}}class G extends d.AbstractExtensionTask{constructor(U,M,F){super();this.extension=U,this.options=M,this.extensionsScanner=F}async doRun(U){const M=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new P.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);M.push(...F.filter(_=>j.equals(new P.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version))))}else M.push(...F.filter(j=>(0,P.areSameExtensions)(j.identifier,this.extension.identifier)));if(!M.length)throw new Error(S.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...M),this.options.remove)for(const j of M)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(_){throw new Error(S.localize(6,null,(0,I.toErrorMessage)(_)))}}}}),define(Z[216],ee([0,1,50,35,217,103,44,102,36,76,52,151,9,133,135,27,210,177,24,167,40,168,21,53,174,80,81,179,10,77,160,57,2,169,72,164,165,156,155,153,152,175,71,161,14,163,17,28,22,203,205,200,59,201,206,173,20,171,202,60,199,178,61,73,137,207,82,87,86,85,6,154,146,11,39,83,188,182,204,144,148,180,4,15]),function(K,e,S,L,R,k,A,P,p,w,n,y,m,v,h,I,D,b,C,f,a,o,t,r,i,s,u,c,l,d,E,g,T,O,$,x,G,B,U,M,F,j,_,N,W,z,V,H,X,Q,ie,ne,le,de,ye,pe,Pe,Te,Ne,Oe,Le,_e,be,ke,Ye,Je,ze,je,J,re,se,me,ve,De,we,Ae,Ie,Re,Ue,q,te,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class he extends T.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new P.Server),(0,R.gracefulify)(S),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,X.registerConfiguration)(),ue.invokeFunction(Ee=>{const Ce=Ee.get(l.ILogService);Ce.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ce)}),this._register((0,T.combinedDisposable)(ue.createInstance(x.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(G.LanguagePackCachedDataCleaner),ue.createInstance(B.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(U.LogsDataCleaner),ue.createInstance(me.LocalizationsUpdater),ue.createInstance(ve.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new w.ServiceCollection,Ee={_serviceBrand:void 0,...A.default};ue.set(H.IProductService,Ee);const Ce=new p.StaticRouter(We=>We==="main"),Fe=new F.MessagePortMainProcessService(this.server,Ce);ue.set(M.IMainProcessService,Fe);const Me=new v.NativeEnvironmentService(this.configuration.args,Ee);ue.set(m.INativeEnvironmentService,Me);const et=new d.LogLevelChannelClient(this.server.getChannel("logLevel",Ce)),Be=new d.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));ue.set(l.ILoggerService,Be);const nt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,oe.joinPath)(ce.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new d.FollowerLogService(et,nt));ue.set(l.ILogService,Ve);const He=this._register(new N.FileService(Ve));ue.set(W.IFileService,He);const it=this._register(new z.DiskFileSystemProvider(Ve));He.registerProvider(V.Schemas.file,it);const qe=this._register(new f.ConfigurationService(Me.settingsResource,He));ue.set(C.IConfigurationService,qe),await qe.initialize();const Xe=new pe.NativeStorageService(void 0,Fe,Me);ue.set(Pe.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),ue.set(a.IRequestService,new n.SyncDescriptor(o.RequestService)),ue.set(q.IChecksumService,new n.SyncDescriptor(te.ChecksumService));const tt=p.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(le.INativeHostService,tt),ue.set($.IDownloadService,new n.SyncDescriptor(O.DownloadService));const rt=this._register(new Je.ActiveWindowManager(tt)),ht=new p.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));ue.set(ke.IExtensionRecommendationNotificationService,new Ye.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Ee.enableTelemetry){Ge=new ze.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new c.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ct.flush())),Ge=(0,r.combinedAppender)(ct,Ge)}Qe=new u.TelemetryService({appender:Ge,commonProperties:(0,i.resolveCommonProperties)(He,(0,L.release)(),(0,L.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},qe)}else Qe=r.NullTelemetryService,Ge=r.NullAppender;this.server.registerChannel("telemetryAppender",new s.TelemetryAppenderChannel(Ge)),ue.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(qe,Qe,Be,Me);return ue.set(t.ICustomEndpointTelemetryService,ft),ue.set(I.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),ue.set(I.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),ue.set(I.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),ue.set(g.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),ue.set(_.IDiagnosticsService,new n.SyncDescriptor(j.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(X.IUserDataSyncLogService,new n.SyncDescriptor(de.UserDataSyncLogService)),ue.set(X.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ue.set(I.IGlobalExtensionEnablementService,new n.SyncDescriptor(Te.GlobalExtensionEnablementService)),ue.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(X.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(X.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),ue.set(X.IUserDataSyncBackupStoreService,new n.SyncDescriptor(Le.UserDataSyncBackupStoreService)),ue.set(X.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(je.UserDataAutoSyncEnablementService)),ue.set(X.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Ne.UserDataSyncResourceEnablementService)),ue.set(X.IUserDataSyncService,new n.SyncDescriptor(Q.UserDataSyncService)),ue.set(Re.ILocalPtyService,this._register(new Ie.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,Ve,Qe))),new y.InstantiationService(ue)}initChannels(ue){const Ee=new h.ExtensionManagementChannel(ue.get(I.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ce=p.ProxyChannel.fromService(ue.get(g.ILocalizationsService));this.server.registerChannel("localizations",Ce);const Fe=p.ProxyChannel.fromService(ue.get(_.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new h.ExtensionTipsChannel(ue.get(I.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=p.ProxyChannel.fromService(ue.get(q.IChecksumService));this.server.registerChannel("checksum",et);const Be=new ne.UserDataSyncMachinesServiceChannel(ue.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=p.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new Ue.UserDataSyncChannel(ue.get(X.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(ue.get(se.IInstantiationService).createInstance(ye.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get(Re.ILocalPtyService),rt=p.ProxyChannel.fromService(tt);this.server.registerChannel(Ae.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ee=>{(0,De.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,De.setUnexpectedErrorHandler)(Ee=>{const Ce=(0,we.toErrorMessage)(Ee,!0);!Ce||ue.error(`[uncaught exception in sharedProcess]: ${Ce}`)})}}async function ge(Se){const ue=new he(Se);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/04485223ebc6a075f39966bf9b3e261359ac7818/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
