/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],p=0,R=J.length;p<R;p++)e[p]=me[J[p]];return e};define(me[54],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(me[55],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function R(i){const I=[];for(let u in i)p.call(i,u)&&I.push(i[u]);return I}e.values=R;function D(i,I){for(let u in i)if(p.call(i,u)&&I({key:u,value:i[u]},function(){delete i[u]})===!1)return}e.forEach=D;function S(i,I){const u=Object.create(null);for(const m of i){const c=I(m);let v=u[c];v||(v=u[c]=[]),v.push(m)}return u}e.groupBy=S;function T(i){const I=Object.create(null);return i&&i.forEach((u,m)=>{I[m]=u}),I}e.fromMap=T;function C(i,I){const u=[],m=[];for(let c of i)I.has(c)||u.push(c);for(let c of I)i.has(c)||m.push(c);return{removed:u,added:m}}e.diffSets=C;function y(i,I){const u=[],m=[];for(let[c,v]of i)I.has(c)||u.push(v);for(let[c,v]of I)i.has(c)||m.push(v);return{removed:u,added:m}}e.diffMaps=y;class A{constructor(){this.map=new Map}add(I,u){let m=this.map.get(I);m||(m=new Set,this.map.set(I,m)),m.add(u)}delete(I,u){const m=this.map.get(I);!m||(m.delete(u),m.size===0&&this.map.delete(I))}forEach(I,u){const m=this.map.get(I);!m||m.forEach(u)}}e.SetMap=A}),define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(T){return(C,y,A)=>{let i=null,I=null;if(typeof A.value=="function"?(i="value",I=A.value):typeof A.get=="function"&&(i="get",I=A.get),!I)throw new Error("not supported");A[i]=T(I,y)}}e.createDecorator=p;function R(T,C,y){let A=null,i=null;if(typeof y.value=="function"?(A="value",i=y.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(A="get",i=y.get),!i)throw new Error("not supported");const I=`$memoize$${C}`;y[A]=function(...u){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,u)}),this[I]}}e.memoize=R;function D(T,C,y){return p((A,i)=>{const I=`$debounce$${i}`,u=`$debounce$result$${i}`;return function(...m){this[u]||(this[u]=y?y():void 0),clearTimeout(this[I]),C&&(this[u]=C(this[u],...m),m=[this[u]]),this[I]=setTimeout(()=>{A.apply(this,m),this[u]=y?y():void 0},T)}})}e.debounce=D;function S(T,C,y){return p((A,i)=>{const I=`$throttle$timer$${i}`,u=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...v){if(this[u]||(this[u]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),C&&(this[u]=C(this[u],...v)),this[c])return;const _=this[m]+T;_<=Date.now()?(this[m]=Date.now(),A.apply(this,[this[u]]),this[u]=y?y():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[m]=Date.now(),A.apply(this,[this[u]]),this[u]=y?y():void 0},_-Date.now()))}})}e.throttle=S}),define(me[15],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=R;function D(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=D;function S(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=S;function T(g){if(g instanceof Error){let{name:t,message:r}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:r,stack:s}}return g}e.transformErrorForSerialization=T;const C="Canceled";function y(g){return g instanceof Error&&g.name===C&&g.message===C}e.isPromiseCanceledError=y;class A extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=A;function i(){const g=new Error(C);return g.name=g.message,g}e.canceled=i;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function u(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=u;function m(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function c(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function l(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function d(g,t=Object.create(null)){const r=new Error(g);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=d}),define(me[20],ge([0,1,15]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R($,K=0){return $[$.length-(1+K)]}e.tail=R;function D($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=D;function S($,K,re=(fe,ye)=>fe===ye){if($===K)return!0;if(!$||!K||$.length!==K.length)return!1;for(let fe=0,ye=$.length;fe<ye;fe++)if(!re($[fe],K[fe]))return!1;return!0}e.equals=S;function T($,K,re){let fe=0,ye=$.length-1;for(;fe<=ye;){const Ie=(fe+ye)/2|0,Le=re($[Ie],K);if(Le<0)fe=Ie+1;else if(Le>0)ye=Ie-1;else return Ie}return-(fe+1)}e.binarySearch=T;function C($,K){let re=0,fe=$.length;if(fe===0)return 0;for(;re<fe;){const ye=Math.floor((re+fe)/2);K($[ye])?fe=ye:re=ye+1}return re}e.findFirstInSorted=C;function y($,K,re){if($=$|0,$>=K.length)throw new TypeError("invalid index");let fe=K[Math.floor(K.length*Math.random())],ye=[],Ie=[],Le=[];for(let qe of K){const We=re(qe,fe);We<0?ye.push(qe):We>0?Ie.push(qe):Le.push(qe)}return $<ye.length?y($,ye,re):$<ye.length+Le.length?Le[0]:y($-(ye.length+Le.length),Ie,re)}e.quickSelect=y;function A($,K){const re=[];let fe;for(const ye of $.slice(0).sort(K))!fe||K(fe[0],ye)!==0?(fe=[ye],re.push(fe)):fe.push(ye);return re}e.groupBy=A;function i($,K,re){const fe=[];function ye(qe,We,je){if(We===0&&je.length===0)return;const W=fe[fe.length-1];W&&W.start+W.deleteCount===qe?(W.deleteCount+=We,W.toInsert.push(...je)):fe.push({start:qe,deleteCount:We,toInsert:je})}let Ie=0,Le=0;for(;;){if(Ie===$.length){ye(Ie,0,K.slice(Le));break}if(Le===K.length){ye(Ie,$.length-Ie,[]);break}const qe=$[Ie],We=K[Le],je=re(qe,We);je===0?(Ie+=1,Le+=1):je<0?(ye(Ie,1,[]),Ie+=1):je>0&&(ye(Ie,0,[We]),Le+=1)}return fe}e.sortedDiff=i;function I($,K,re){const fe=i($,K,re),ye=[],Ie=[];for(const Le of fe)ye.push(...$.slice(Le.start,Le.start+Le.deleteCount)),Ie.push(...Le.toInsert);return{removed:ye,added:Ie}}e.delta=I;function u($,K,re){if(re===0)return[];const fe=$.slice(0,re).sort(K);return c($,K,fe,re,$.length),fe}e.top=u;function m($,K,re,fe,ye){return re===0?Promise.resolve([]):new Promise((Ie,Le)=>{(async()=>{const qe=$.length,We=$.slice(0,re).sort(K);for(let je=re,W=Math.min(re+fe,qe);je<qe;je=W,W=Math.min(W+fe,qe)){if(je>re&&await new Promise(Z=>setTimeout(Z)),ye&&ye.isCancellationRequested)throw(0,p.canceled)();c($,K,We,je,W)}return We})().then(Ie,Le)})}e.topAsync=m;function c($,K,re,fe,ye){for(const Ie=re.length;fe<ye;fe++){const Le=$[fe];if(K(Le,re[Ie-1])<0){re.pop();const qe=C(re,We=>K(Le,We)<0);re.splice(qe,0,Le)}}}function v($){return $.filter(K=>!!K)}e.coalesce=v;function _($){let K=0;for(let re=0;re<$.length;re++)$[re]&&($[K]=$[re],K+=1);$.length=K}e.coalesceInPlace=_;function b($,K,re){$.splice(re,0,$.splice(K,1)[0])}e.move=b;function P($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=P;function l($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=l;function d($,K){if(!K)return $.filter((fe,ye)=>$.indexOf(fe)===ye);const re=Object.create(null);return $.filter(fe=>{const ye=K(fe);return re[ye]?!1:(re[ye]=!0,!0)})}e.distinct=d;function g($){const K=new Set;return $.filter(re=>K.has(re)?!1:(K.add(re),!0))}e.distinctES6=g;function t($){const K=Object.create(null);return re=>{const fe=$(re);return K[fe]?!1:(K[fe]=!0,!0)}}e.uniqueFilter=t;function r($,K){for(let re=$.length-1;re>=0;re--){const fe=$[re];if(K(fe))return re}return-1}e.lastIndex=r;function s($,K){return $.length>0?$[0]:K}e.firstOrDefault=s;function n($,K,re=(fe,ye)=>fe===ye){let fe=0;for(let ye=0,Ie=Math.min($.length,K.length);ye<Ie&&re($[ye],K[ye]);ye++)fe++;return fe}e.commonPrefixLength=n;function a($){return[].concat(...$)}e.flatten=a;function h($,K){let re=typeof K=="number"?$:0;typeof K=="number"?re=$:(re=0,K=$);const fe=[];if(re<=K)for(let ye=re;ye<K;ye++)fe.push(ye);else for(let ye=re;ye>K;ye--)fe.push(ye);return fe}e.range=h;function f($,K,re){return $.reduce((fe,ye)=>(fe[K(ye)]=re?re(ye):ye,fe),Object.create(null))}e.index=f;function w($,K){return $.push(K),()=>E($,K)}e.insert=w;function E($,K){const re=$.indexOf(K);if(re>-1)return $.splice(re,1),K}e.remove=E;function o($,K,re){const fe=$.slice(0,K),ye=$.slice(K);return fe.concat(re,ye)}e.arrayInsert=o;function k($,K){let re;if(typeof K=="number"){let fe=K;re=()=>{const ye=Math.sin(fe++)*179426549;return ye-Math.floor(ye)}}else re=Math.random;for(let fe=$.length-1;fe>0;fe-=1){const ye=Math.floor(re()*(fe+1)),Ie=$[fe];$[fe]=$[ye],$[ye]=Ie}}e.shuffle=k;function L($,K){const re=$.indexOf(K);re>-1&&($.splice(re,1),$.unshift(K))}e.pushToStart=L;function N($,K){const re=$.indexOf(K);re>-1&&($.splice(re,1),$.push(K))}e.pushToEnd=N;function V($,K){return Array.isArray($)?$.map(K):K($)}e.mapArrayOrNot=V;function ee($){return Array.isArray($)?$:[$]}e.asArray=ee;function z($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=z;function M($,K){for(const re of $){const fe=K(re);if(fe!==void 0)return fe}}e.mapFind=M;function x($,K,re){const fe=q($,K),ye=$.length,Ie=re.length;$.length=ye+Ie;for(let Le=ye-1;Le>=fe;Le--)$[Le+Ie]=$[Le];for(let Le=0;Le<Ie;Le++)$[Le+fe]=re[Le]}e.insertInto=x;function F($,K,re,fe){const ye=q($,K),Ie=$.splice(ye,re);return x($,ye,fe),Ie}e.splice=F;function q($,K){return K<0?Math.max(K+$.length,0):Math.min(K,$.length)}function U($,K){let re=Number.MAX_SAFE_INTEGER,fe=0;return $.forEach((ye,Ie)=>{const Le=K(ye);Le<re&&(re=Le,fe=Ie)}),fe}e.minIndex=U;function O($,K){let re=Number.MIN_SAFE_INTEGER,fe=0;return $.forEach((ye,Ie)=>{const Le=K(ye);Le>re&&(re=Le,fe=Ie)}),fe}e.maxIndex=O;class G{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let re=this.firstIdx;for(;re<this.items.length&&K(this.items[re]);)re++;const fe=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,fe}takeFromEndWhile(K){let re=this.lastIdx;for(;re>=0&&K(this.items[re]);)re--;const fe=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,fe}}e.ArrayQueue=G}),define(me[72],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const D=this;let S=!1,T;return function(){return S||(S=!0,T=R.apply(D,arguments)),T}}e.once=p}),define(me[73],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(me[74],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function D(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}R.is=D;const S=Object.freeze([]);function T(){return S}R.empty=T;function*C(g){yield g}R.single=C;function y(g){return g||S}R.from=y;function A(g){return!g||g[Symbol.iterator]().next().done===!0}R.isEmpty=A;function i(g){return g[Symbol.iterator]().next().value}R.first=i;function I(g,t){for(const r of g)if(t(r))return!0;return!1}R.some=I;function u(g,t){for(const r of g)if(t(r))return r}R.find=u;function*m(g,t){for(const r of g)t(r)&&(yield r)}R.filter=m;function*c(g,t){let r=0;for(const s of g)yield t(s,r++)}R.map=c;function*v(...g){for(const t of g)for(const r of t)yield r}R.concat=v;function*_(g){for(const t of g)for(const r of t)yield r}R.concatNested=_;function b(g,t,r){let s=r;for(const n of g)s=t(s,n);return s}R.reduce=b;function*P(g,t,r=g.length){for(t<0&&(t+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);t<r;t++)yield g[t]}R.slice=P;function l(g,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,g];const s=g[Symbol.iterator]();for(let n=0;n<t;n++){const a=s.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return s}}]}R.consume=l;function d(g,t,r=(s,n)=>s===n){const s=g[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=s.next(),h=n.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!r(a.value,h.value))return!1}}R.equals=d})(p=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function T(t,r=!1){let s=0,n=t.length,a="",h=0,f=16,w=0;function E(z){let M=0,x=0;for(;M<z;){const F=t.charCodeAt(s);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;s++,M++}return M<z&&(x=-1),x}function o(z){s=z,a="",h=0,f=16,w=0}function k(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&A(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&A(t.charCodeAt(s)))for(s++;s<t.length&&A(t.charCodeAt(s));)s++;else return w=3,t.substring(z,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&A(t.charCodeAt(s))){for(s++;s<t.length&&A(t.charCodeAt(s));)s++;M=s}else w=3;return t.substring(z,M)}function L(){let z="",M=s;for(;;){if(s>=n){z+=t.substring(M,s),w=2;break}const x=t.charCodeAt(s);if(x===34){z+=t.substring(M,s),s++;break}if(x===92){if(z+=t.substring(M,s),s++,s>=n){w=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const q=E(4);q>=0?z+=String.fromCharCode(q):w=4;break;default:w=5}M=s;continue}if(x>=0&&x<=31)if(y(x)){z+=t.substring(M,s),w=2;break}else w=6;s++}return z}function N(){if(a="",w=0,h=s,s>=n)return h=n,f=17;let z=t.charCodeAt(s);if(C(z)){do s++,a+=String.fromCharCode(z),z=t.charCodeAt(s);while(C(z));return f=15}if(y(z))return s++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),f=14;switch(z){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,a=L(),f=10;case 47:const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!y(t.charCodeAt(s));)s++;return a=t.substring(M,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const x=n-1;let F=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,F=!0;break}s++}return F||(s++,w=1),a=t.substring(M,s),f=13}return a+=String.fromCharCode(z),s++,f=16;case 45:if(a+=String.fromCharCode(z),s++,s===n||!A(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=k(),f=11;default:for(;s<n&&V(z);)s++,z=t.charCodeAt(s);if(h!==s){switch(a=t.substring(h,s),a){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return a+=String.fromCharCode(z),s++,f=16}}function V(z){if(C(z)||y(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:o,getPosition:()=>s,scan:r?ee:N,getToken:()=>f,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>w}}e.createScanner=T;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const s=[],n=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function w(E,o,k,L){h.value=E,h.offset=o,h.length=k,h.type=L,h.colonOffset=void 0,a=h}try{l(t,{onObjectBegin:(E,o)=>{if(r<=E)throw n;a=void 0,f=r>E,s.push("")},onObjectProperty:(E,o,k)=>{if(r<o||(w(E,o,k,"property"),s[s.length-1]=E,r<=o+k))throw n},onObjectEnd:(E,o)=>{if(r<=E)throw n;a=void 0,s.pop()},onArrayBegin:(E,o)=>{if(r<=E)throw n;a=void 0,s.push(0)},onArrayEnd:(E,o)=>{if(r<=E)throw n;a=void 0,s.pop()},onLiteralValue:(E,o,k)=>{if(r<o||(w(E,o,k,g(E)),r<=o+k))throw n},onSeparator:(E,o,k)=>{if(r<=o)throw n;if(E===":"&&a&&a.type==="property")a.colonOffset=o,f=!1,a=void 0;else if(E===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(f=!0,s[s.length-1]=""),a=void 0}}})}catch(E){if(E!==n)throw E}return{path:s,previousNode:a,isAtPropertyKey:f,matches:E=>{let o=0;for(let k=0;o<E.length&&k<s.length;k++)if(E[o]===s[k]||E[o]==="*")o++;else if(E[o]!=="**")return!1;return o===E.length}}}e.getLocation=I;function u(t,r=[],s=S.DEFAULT){let n=null,a=[];const h=[];function f(E){Array.isArray(a)?a.push(E):n!==null&&(a[n]=E)}return l(t,{onObjectBegin:()=>{const E={};f(E),h.push(a),a=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const E=[];f(E),h.push(a),a=E,n=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:f,onError:(E,o,k)=>{r.push({error:E,offset:o,length:k})}},s),a[0]}e.parse=u;function m(t,r=[],s=S.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function h(E){return n.children.push(E),E}l(t,{onObjectBegin:E=>{n=h({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,o,k)=>{n=h({type:"property",offset:o,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:o,length:k,parent:n})},onObjectEnd:(E,o)=>{n.length=E+o-n.offset,n=n.parent,a(E+o)},onArrayBegin:(E,o)=>{n=h({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,o)=>{n.length=E+o-n.offset,n=n.parent,a(E+o)},onLiteralValue:(E,o,k)=>{h({type:g(E),offset:o,length:k,parent:n,value:E}),a(o+k)},onSeparator:(E,o,k)=>{n.type==="property"&&(E===":"?n.colonOffset=o:E===","&&a(o))},onError:(E,o,k)=>{r.push({error:E,offset:o,length:k})}},s);const w=n.children[0];return w&&delete w.parent,w}e.parseTree=m;function c(t,r){if(!t)return;let s=t;for(let n of r)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===n){s=h.children[1],a=!0;break}if(!a)return}else{const a=n;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=c;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(r[s.children[0].value]=_(n))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=b;function P(t,r,s=!1){if(b(t,r,s)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=r;a++){const h=P(n[a],r,s);if(h)return h}return t}}e.findNodeAtOffset=P;function l(t,r,s=S.DEFAULT){const n=T(t,!1);function a(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(re){return re?fe=>re(fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=a(r.onObjectBegin),w=h(r.onObjectProperty),E=a(r.onObjectEnd),o=a(r.onArrayBegin),k=a(r.onArrayEnd),L=h(r.onLiteralValue),N=h(r.onSeparator),V=a(r.onComment),ee=h(r.onError),z=s&&s.disallowComments,M=s&&s.allowTrailingComma;function x(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:z||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(re){case 12:case 13:z?F(10):V();break;case 16:F(1);break;case 15:case 14:break;default:return re}}}function F(re,fe=[],ye=[]){if(ee(re),fe.length+ye.length>0){let Ie=n.getToken();for(;Ie!==17;){if(fe.indexOf(Ie)!==-1){x();break}else if(ye.indexOf(Ie)!==-1)break;Ie=x()}}}function q(re){const fe=n.getTokenValue();return re?L(fe):w(fe),x(),!0}function U(){switch(n.getToken()){case 11:let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(F(2),re=0)}catch(fe){F(2)}L(re);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return x(),!0}function O(){return n.getToken()!==10?(F(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(N(":"),x(),K()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function G(){f(),x();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||F(4,[],[]),N(","),x(),n.getToken()===2&&M)break}else re&&F(6,[],[]);O()||F(4,[],[2,5]),re=!0}return E(),n.getToken()!==2?F(7,[2],[]):x(),!0}function $(){o(),x();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||F(4,[],[]),N(","),x(),n.getToken()===4&&M)break}else re&&F(6,[],[]);K()||F(4,[],[4,5]),re=!0}return k(),n.getToken()!==4?F(8,[4],[]):x(),!0}function K(){switch(n.getToken()){case 3:return $();case 1:return G();case 10:return q(!0);default:return U()}}return x(),n.getToken()===17?s.allowEmptyContent?!0:(F(4,[],[]),!1):K()?(n.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=l;function d(t,r){let s=T(t),n=[],a,h=0,f;do switch(f=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:h!==f&&n.push(t.substring(h,f)),r!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,r)),h=s.getPosition();break}while(a!==17);return n.join("")}e.stripComments=d;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(me[137],ge([0,1,57]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,A,i){let I,u,m,c,v;if(A){for(c=A.offset,v=c+A.length,m=c;m>0&&!C(y,m-1);)m--;let h=v;for(;h<y.length&&!C(y,h);)h++;u=y.substring(m,h),I=S(u,i)}else u=y,I=0,m=0,c=0,v=y.length;const _=T(i,y);let b=!1,P=0,l;i.insertSpaces?l=D(" ",i.tabSize||4):l="	";const d=(0,p.createScanner)(u,!1);let g=!1;function t(){return _+D(l,I+P)}function r(){let h=d.scan();for(b=!1;h===15||h===14;)b=b||h===14,h=d.scan();return g=h===16||d.getTokenError()!==0,h}const s=[];function n(h,f,w){!g&&f<v&&w>c&&y.substring(f,w)!==h&&s.push({offset:f,length:w-f,content:h})}let a=r();if(a!==17){const h=d.getTokenOffset()+m,f=D(l,I);n(f,m,h)}for(;a!==17;){let h=d.getTokenOffset()+d.getTokenLength()+m,f=r(),w="";for(;!b&&(f===12||f===13);){const o=d.getTokenOffset()+m;n(" ",h,o),h=d.getTokenOffset()+d.getTokenLength()+m,w=f===12?t():"",f=r()}if(f===2)a!==1&&(P--,w=t());else if(f===4)a!==3&&(P--,w=t());else{switch(a){case 3:case 1:P++,w=t();break;case 5:case 12:w=t();break;case 13:b?w=t():w=" ";break;case 6:w=" ";break;case 10:if(f===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?w=" ":f!==5&&f!==17&&(g=!0);break;case 16:g=!0;break}b&&(f===12||f===13)&&(w=t())}const E=d.getTokenOffset()+m;n(w,h,E),a=f}return s}e.format=R;function D(y,A){let i="";for(let I=0;I<A;I++)i+=y;return i}function S(y,A){let i=0,I=0;const u=A.tabSize||4;for(;i<y.length;){const m=y.charAt(i);if(m===" ")I++;else if(m==="	")I+=u;else break;i++}return Math.floor(I/u)}function T(y,A){for(let i=0;i<A.length;i++){const I=A.charAt(i);if(I==="\r")return i+1<A.length&&A.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=T;function C(y,A){return`\r
`.indexOf(y.charAt(A))!==-1}e.isEOL=C}),define(me[138],ge([0,1,57,137]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(A,i,I){return S(A,i,void 0,I)}e.removeProperty=D;function S(A,i,I,u,m){const c=i.slice(),v=[],_=(0,p.parseTree)(A,v);let b,P;for(;c.length>0&&(P=c.pop(),b=(0,p.findNodeAtLocation)(_,c),b===void 0&&I!==void 0);)typeof P=="string"?I={[P]:I}:I=[I];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const l=(0,p.findNodeAtLocation)(b,[P]);if(l!==void 0)if(I===void 0){if(!l.parent)throw new Error("Malformed AST");const d=b.children.indexOf(l.parent);let g,t=l.parent.offset+l.parent.length;if(d>0){const r=b.children[d-1];g=r.offset+r.length}else g=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return T(A,{offset:g,length:t-g,content:""},u)}else return T(A,{offset:l.offset,length:l.length,content:JSON.stringify(I)},u);else{if(I===void 0)return[];const d=`${JSON.stringify(P)}: ${JSON.stringify(I)}`,g=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(g>0){const r=b.children[g-1];t={offset:r.offset+r.length,length:0,content:","+d}}else b.children.length===0?t={offset:b.offset+1,length:0,content:d}:t={offset:b.offset+1,length:0,content:d+","};return T(A,t,u)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(I!==void 0){const l=`${JSON.stringify(I)}`;let d;if(b.children.length===0||P===0)d={offset:b.offset+1,length:0,content:b.children.length===0?l:l+","};else{const g=P===-1||P>b.children.length?b.children.length:P,t=b.children[g-1];d={offset:t.offset+t.length,length:0,content:","+l}}return T(A,d,u)}else{const l=P,d=b.children[l];let g;if(b.children.length===1)g={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===l){const t=b.children[l-1],r=t.offset+t.length,s=b.offset+b.length;g={offset:r,length:s-2-r,content:""}}else g={offset:d.offset,length:b.children[l+1].offset-d.offset,content:""};return T(A,g,u)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},u)}}e.setProperty=S;function T(A,i,I){let u=C(A,i),m=i.offset,c=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,R.isEOL)(u,m-1);)m--;for(;c<u.length&&!(0,R.isEOL)(u,c);)c++}const v=(0,R.format)(u,{offset:m,length:c-m},I);for(let b=v.length-1;b>=0;b--){const P=v[b];u=C(u,P),m=Math.min(m,P.offset),c=Math.max(c,P.offset+P.length),c+=P.content.length-P.length}const _=A.length-(u.length-c)-m;return[{offset:m,length:_,content:u.substring(m,c)}]}e.withFormatting=T;function C(A,i){return A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)}e.applyEdit=C;function y(A,i){let I=i.slice(0).sort((m,c)=>{const v=m.offset-c.offset;return v===0?m.length-c.length:v}),u=A.length;for(let m=I.length-1;m>=0;m--){let c=I[m];if(c.offset+c.length<=u)A=C(A,c);else throw new Error("Overlapping edit");u=c.offset}return A}e.applyEdits=y}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new p(()=>D(this.getValue()))}}e.Lazy=p}),define(me[6],ge([0,1,72,74]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function T(s){S=s}if(e.setDisposableTracker=T,D){const s="__is_disposable_tracked__";T(new class{trackDisposable(n){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[s]||console.log(a)},3e3)}setParent(n,a){if(n&&n!==P.None)try{n[s]=!0}catch{}}markAsDisposed(n){if(n&&n!==P.None)try{n[s]=!0}catch{}}markAsSingleton(n){}})}function C(s){return S?.trackDisposable(s),s}function y(s){S?.markAsDisposed(s)}function A(s,n){S?.setParent(s,n)}function i(s,n){if(!!S)for(const a of s)S.setParent(a,n)}function I(s){return S?.markAsSingleton(s),s}e.markAsSingleton=I;class u extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=u;function m(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=m;function c(s){if(R.Iterable.is(s)){let n=[];for(const a of s)if(a)try{a.dispose()}catch(h){n.push(h)}if(n.length===1)throw n[0];if(n.length>1)throw new u(n);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=c;function v(...s){const n=_(()=>c(s));return i(s,n),n}e.combinedDisposable=v;function _(s){const n=C({dispose:(0,p.once)(()=>{y(n),s()})});return n}e.toDisposable=_;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,C(this),A(this._store,this)}dispose(){y(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=l;class d{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class g{constructor(){this.references=new Map}acquire(n,...a){let h=this.references.get(n);h||(h={counter:0,object:this.createReferencedObject(n,...a)},this.references.set(n,h));const{object:f}=h,w=(0,p.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(n,h.object),this.references.delete(n))});return h.counter++,{object:f,dispose:w}}}e.ReferenceCollection=g;class t{constructor(n){this.referenceCollection=n}async acquire(n,...a){const h=this.referenceCollection.acquire(n,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(f){throw h.dispose(),f}}}e.AsyncReferenceCollection=t;class r{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=r}),define(me[94],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(S){this.element=S,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let S=this._first;for(;S!==p.Undefined;){const T=S.next;S.prev=p.Undefined,S.next=p.Undefined,S=T}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,T){const C=new p(S);if(this._first===p.Undefined)this._first=C,this._last=C;else if(T){const A=this._last;this._last=C,C.prev=A,A.next=C}else{const A=this._first;this._first=C,C.next=A,A.prev=C}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(C))}}shift(){if(this._first!==p.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==p.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==p.Undefined&&S.next!==p.Undefined){const T=S.prev;T.next=S.next,S.next.prev=T}else S.prev===p.Undefined&&S.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):S.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):S.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==p.Undefined;)yield S.element,S=S.next}}e.LinkedList=R}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ce,De){for(var Te=0;Te<De.length;Te++){var ce=De[Te];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Ce,ce.key,ce)}}function e(Ce,De,Te){return De&&J(Ce.prototype,De),Te&&J(Ce,Te),Ce}function p(Ce,De){if(!!Ce){if(typeof Ce=="string")return R(Ce,De);var Te=Object.prototype.toString.call(Ce).slice(8,-1);if(Te==="Object"&&Ce.constructor&&(Te=Ce.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ce);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return R(Ce,De)}}function R(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var Te=0,ce=new Array(De);Te<De;Te++)ce[Te]=Ce[Te];return ce}function D(Ce,De){var Te;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Te=p(Ce))||De&&Ce&&typeof Ce.length=="number"){Te&&(Ce=Te);var ce=0;return function(){return ce>=Ce.length?{done:!0}:{done:!1,value:Ce[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Te=Ce[Symbol.iterator](),Te.next.bind(Te)}function S(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var T=S(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Te(ce){Ce.exports.defaults=ce}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:Te}}),C=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(De){return I[De]};function m(Ce,De){if(De){if(C.test(Ce))return Ce.replace(y,u)}else if(A.test(Ce))return Ce.replace(i,u);return Ce}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ce){return Ce.replace(c,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var _=/(^|[^\[])\^/g;function b(Ce,De){Ce=Ce.source||Ce,De=De||"";var Te={replace:function(ue,pe){return pe=pe.source||pe,pe=pe.replace(_,"$1"),Ce=Ce.replace(ue,pe),Te},getRegex:function(){return new RegExp(Ce,De)}};return Te}var P=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Ce,De,Te){if(Ce){var ce;try{ce=decodeURIComponent(v(Te)).replace(P,"").toLowerCase()}catch(ue){return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}De&&!l.test(Te)&&(Te=n(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var g={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ce,De){g[" "+Ce]||(t.test(Ce)?g[" "+Ce]=Ce+"/":g[" "+Ce]=w(Ce,"/",!0)),Ce=g[" "+Ce];var Te=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Ce.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Ce.replace(s,"$1")+De:Ce+De}var a={exec:function(){}};function h(Ce){for(var De=1,Te,ce;De<arguments.length;De++){Te=arguments[De];for(ce in Te)Object.prototype.hasOwnProperty.call(Te,ce)&&(Ce[ce]=Te[ce])}return Ce}function f(Ce,De){var Te=Ce.replace(/\|/g,function(pe,be,j){for(var we=!1,_e=be;--_e>=0&&j[_e]==="\\";)we=!we;return we?"|":" |"}),ce=Te.split(/ \|/),ue=0;if(ce.length>De)ce.splice(De);else for(;ce.length<De;)ce.push("");for(;ue<ce.length;ue++)ce[ue]=ce[ue].trim().replace(/\\\|/g,"|");return ce}function w(Ce,De,Te){var ce=Ce.length;if(ce===0)return"";for(var ue=0;ue<ce;){var pe=Ce.charAt(ce-ue-1);if(pe===De&&!Te)ue++;else if(pe!==De&&Te)ue++;else break}return Ce.substr(0,ce-ue)}function E(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var Te=Ce.length,ce=0,ue=0;ue<Te;ue++)if(Ce[ue]==="\\")ue++;else if(Ce[ue]===De[0])ce++;else if(Ce[ue]===De[1]&&(ce--,ce<0))return ue;return-1}function o(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ce,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Ce),De>>=1,Ce+=Ce;return Te+Ce}var L={escape:m,unescape:v,edit:b,cleanUrl:d,resolveUrl:n,noopTest:a,merge:h,splitCells:f,rtrim:w,findClosingBracket:E,checkSanitizeDeprecation:o,repeatString:k},N=T.defaults,V=L.rtrim,ee=L.splitCells,z=L.escape,M=L.findClosingBracket;function x(Ce,De,Te){var ce=De.href,ue=De.title?z(De.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Te,href:ce,title:ue,text:pe}:{type:"image",raw:Te,href:ce,title:ue,text:z(pe)}}function F(Ce,De){var Te=Ce.match(/^(\s+)(?:```)/);if(Te===null)return De;var ce=Te[1];return De.split(`
`).map(function(ue){var pe=ue.match(/^\s+/);if(pe===null)return ue;var be=pe[0];return be.length>=ce.length?ue.slice(ce.length):ue}).join(`
`)}var q=function(){function Ce(Te){this.options=Te||N}var De=Ce.prototype;return De.space=function(ce){var ue=this.rules.block.newline.exec(ce);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(ce){var ue=this.rules.block.code.exec(ce);if(ue){var pe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:V(pe,`
`)}}},De.fences=function(ce){var ue=this.rules.block.fences.exec(ce);if(ue){var pe=ue[0],be=F(pe,ue[3]||"");return{type:"code",raw:pe,lang:ue[2]?ue[2].trim():ue[2],text:be}}},De.heading=function(ce){var ue=this.rules.block.heading.exec(ce);if(ue){var pe=ue[2].trim();if(/#$/.test(pe)){var be=V(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:pe}}},De.nptable=function(ce){var ue=this.rules.block.nptable.exec(ce);if(ue){var pe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(pe.header.length===pe.align.length){var be=pe.align.length,j;for(j=0;j<be;j++)/^ *-+: *$/.test(pe.align[j])?pe.align[j]="right":/^ *:-+: *$/.test(pe.align[j])?pe.align[j]="center":/^ *:-+ *$/.test(pe.align[j])?pe.align[j]="left":pe.align[j]=null;for(be=pe.cells.length,j=0;j<be;j++)pe.cells[j]=ee(pe.cells[j],pe.header.length);return pe}}},De.hr=function(ce){var ue=this.rules.block.hr.exec(ce);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(ce){var ue=this.rules.block.blockquote.exec(ce);if(ue){var pe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:pe}}},De.list=function(ce){var ue=this.rules.block.list.exec(ce);if(ue){var pe=ue[0],be=ue[2],j=be.length>1,we={type:"list",raw:pe,ordered:j,start:j?+be.slice(0,-1):"",loose:!1,items:[]},_e=ue[0].match(this.rules.block.item),Ae=!1,Ue,Ge,Ze,Qe,Je,ct,mt,bt,ot=_e.length;Ze=this.rules.block.listItemStart.exec(_e[0]);for(var at=0;at<ot;at++){if(Ue=_e[at],pe=Ue,at!==ot-1){if(Qe=this.rules.block.listItemStart.exec(_e[at+1]),this.options.pedantic?Qe[1].length>Ze[1].length:Qe[1].length>Ze[0].length||Qe[1].length>3){_e.splice(at,2,_e[at]+`
`+_e[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==be[be.length-1]:j===(Qe[2].length===1))&&(Je=_e.slice(at+1).join(`
`),we.raw=we.raw.substring(0,we.raw.length-Je.length),at=ot-1);Ze=Qe}Ge=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(Ge-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),ct=Ae||/\n\n(?!\s*$)/.test(Ue),at!==ot-1&&(Ae=Ue.charAt(Ue.length-1)===`
`,ct||(ct=Ae)),ct&&(we.loose=!0),this.options.gfm&&(mt=/^\[[ xX]\] /.test(Ue),bt=void 0,mt&&(bt=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:pe,task:mt,checked:bt,loose:ct,text:Ue})}return we}},De.html=function(ce){var ue=this.rules.block.html.exec(ce);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):z(ue[0]):ue[0]}},De.def=function(ce){var ue=this.rules.block.def.exec(ce);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var pe=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:pe,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(ce){var ue=this.rules.block.table.exec(ce);if(ue){var pe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ue[0];var be=pe.align.length,j;for(j=0;j<be;j++)/^ *-+: *$/.test(pe.align[j])?pe.align[j]="right":/^ *:-+: *$/.test(pe.align[j])?pe.align[j]="center":/^ *:-+ *$/.test(pe.align[j])?pe.align[j]="left":pe.align[j]=null;for(be=pe.cells.length,j=0;j<be;j++)pe.cells[j]=ee(pe.cells[j].replace(/^ *\| *| *\| *$/g,""),pe.header.length);return pe}}},De.lheading=function(ce){var ue=this.rules.block.lheading.exec(ce);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},De.paragraph=function(ce){var ue=this.rules.block.paragraph.exec(ce);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},De.text=function(ce){var ue=this.rules.block.text.exec(ce);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},De.escape=function(ce){var ue=this.rules.inline.escape.exec(ce);if(ue)return{type:"escape",raw:ue[0],text:z(ue[1])}},De.tag=function(ce,ue,pe){var be=this.rules.inline.tag.exec(ce);if(be)return!ue&&/^<a /i.test(be[0])?ue=!0:ue&&/^<\/a>/i.test(be[0])&&(ue=!1),!pe&&/^<(pre|code|kbd|script)(\s|>)/i.test(be[0])?pe=!0:pe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(be[0])&&(pe=!1),{type:this.options.sanitize?"text":"html",raw:be[0],inLink:ue,inRawBlock:pe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):z(be[0]):be[0]}},De.link=function(ce){var ue=this.rules.inline.link.exec(ce);if(ue){var pe=ue[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=V(pe.slice(0,-1),"\\");if((pe.length-be.length)%2==0)return}else{var j=M(ue[2],"()");if(j>-1){var we=ue[0].indexOf("!")===0?5:4,_e=we+ue[1].length+j;ue[2]=ue[2].substring(0,j),ue[0]=ue[0].substring(0,_e).trim(),ue[3]=""}}var Ae=ue[2],Ue="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ge&&(Ae=Ge[1],Ue=Ge[3])}else Ue=ue[3]?ue[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),x(ue,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},ue[0])}},De.reflink=function(ce,ue){var pe;if((pe=this.rules.inline.reflink.exec(ce))||(pe=this.rules.inline.nolink.exec(ce))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ue[be.toLowerCase()],!be||!be.href){var j=pe[0].charAt(0);return{type:"text",raw:j,text:j}}return x(pe,be,pe[0])}},De.emStrong=function(ce,ue,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(ce);if(!!be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=be[1]||be[2]||"";if(!j||j&&(pe===""||this.rules.inline.punctuation.exec(pe))){var we=be[0].length-1,_e,Ae,Ue=we,Ge=0,Ze=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,ue=ue.slice(-1*ce.length+we);(be=Ze.exec(ue))!=null;)if(_e=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!_e){if(Ae=_e.length,be[3]||be[4]){Ue+=Ae;continue}else if((be[5]||be[6])&&we%3&&!((we+Ae)%3)){Ge+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ue+Ge-Ae<=0&&!ue.slice(Ze.lastIndex).match(Ze)&&(Ae=Math.min(Ae,Ae+Ue+Ge)),Math.min(we,Ae)%2)return{type:"em",raw:ce.slice(0,we+be.index+Ae+1),text:ce.slice(1,we+be.index+Ae)};if(Math.min(we,Ae)%2==0)return{type:"strong",raw:ce.slice(0,we+be.index+Ae+1),text:ce.slice(2,we+be.index+Ae-1)}}}}}},De.codespan=function(ce){var ue=this.rules.inline.code.exec(ce);if(ue){var pe=ue[2].replace(/\n/g," "),be=/[^ ]/.test(pe),j=/^ /.test(pe)&&/ $/.test(pe);return be&&j&&(pe=pe.substring(1,pe.length-1)),pe=z(pe,!0),{type:"codespan",raw:ue[0],text:pe}}},De.br=function(ce){var ue=this.rules.inline.br.exec(ce);if(ue)return{type:"br",raw:ue[0]}},De.del=function(ce){var ue=this.rules.inline.del.exec(ce);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},De.autolink=function(ce,ue){var pe=this.rules.inline.autolink.exec(ce);if(pe){var be,j;return pe[2]==="@"?(be=z(this.options.mangle?ue(pe[1]):pe[1]),j="mailto:"+be):(be=z(pe[1]),j=be),{type:"link",raw:pe[0],text:be,href:j,tokens:[{type:"text",raw:be,text:be}]}}},De.url=function(ce,ue){var pe;if(pe=this.rules.inline.url.exec(ce)){var be,j;if(pe[2]==="@")be=z(this.options.mangle?ue(pe[0]):pe[0]),j="mailto:"+be;else{var we;do we=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(we!==pe[0]);be=z(pe[0]),pe[1]==="www."?j="http://"+be:j=be}return{type:"link",raw:pe[0],text:be,href:j,tokens:[{type:"text",raw:be,text:be}]}}},De.inlineText=function(ce,ue,pe){var be=this.rules.inline.text.exec(ce);if(be){var j;return ue?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):z(be[0]):be[0]:j=z(this.options.smartypants?pe(be[0]):be[0]),{type:"text",raw:be[0],text:j}}},Ce}(),U=L.noopTest,O=L.edit,G=L.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:U,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=O($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=O($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=O(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=O($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=O($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=O($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=O($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=G({},$),$.gfm=G({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=O($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=O($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=G({},$.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:O($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=O(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=O($._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=O(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=O(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=O(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=O(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=O(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=O(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=O(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=O(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=G({},K),K.pedantic=G({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=G({},K.normal,{escape:O(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=O(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=G({},K.gfm,{br:O(K.br).replace("{2,}","*").getRegex(),text:O(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var re={block:$,inline:K},fe=T.defaults,ye=re.block,Ie=re.inline,Le=L.repeatString;function qe(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function We(Ce){var De="",Te,ce,ue=Ce.length;for(Te=0;Te<ue;Te++)ce=Ce.charCodeAt(Te),Math.random()>.5&&(ce="x"+ce.toString(16)),De+="&#"+ce+";";return De}var je=function(){function Ce(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||fe,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ce={block:ye.normal,inline:Ie.normal};this.options.pedantic?(ce.block=ye.pedantic,ce.inline=Ie.pedantic):this.options.gfm&&(ce.block=ye.gfm,this.options.breaks?ce.inline=Ie.breaks:ce.inline=Ie.gfm),this.tokenizer.rules=ce}Ce.lex=function(ce,ue){var pe=new Ce(ue);return pe.lex(ce)},Ce.lexInline=function(ce,ue){var pe=new Ce(ue);return pe.inlineTokens(ce)};var De=Ce.prototype;return De.lex=function(ce){return ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(ce,ue,pe){ue===void 0&&(ue=[]),pe===void 0&&(pe=!0),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var be,j,we,_e;ce;){if(be=this.tokenizer.space(ce)){ce=ce.substring(be.raw.length),be.type&&ue.push(be);continue}if(be=this.tokenizer.code(ce)){ce=ce.substring(be.raw.length),_e=ue[ue.length-1],_e&&_e.type==="paragraph"?(_e.raw+=`
`+be.raw,_e.text+=`
`+be.text):ue.push(be);continue}if(be=this.tokenizer.fences(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.heading(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.nptable(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.hr(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.blockquote(ce)){ce=ce.substring(be.raw.length),be.tokens=this.blockTokens(be.text,[],pe),ue.push(be);continue}if(be=this.tokenizer.list(ce)){for(ce=ce.substring(be.raw.length),we=be.items.length,j=0;j<we;j++)be.items[j].tokens=this.blockTokens(be.items[j].text,[],!1);ue.push(be);continue}if(be=this.tokenizer.html(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(pe&&(be=this.tokenizer.def(ce))){ce=ce.substring(be.raw.length),this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.lheading(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(pe&&(be=this.tokenizer.paragraph(ce))){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.text(ce)){ce=ce.substring(be.raw.length),_e=ue[ue.length-1],_e&&_e.type==="text"?(_e.raw+=`
`+be.raw,_e.text+=`
`+be.text):ue.push(be);continue}if(ce){var Ae="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ue},De.inline=function(ce){var ue,pe,be,j,we,_e,Ae=ce.length;for(ue=0;ue<Ae;ue++)switch(_e=ce[ue],_e.type){case"paragraph":case"text":case"heading":{_e.tokens=[],this.inlineTokens(_e.text,_e.tokens);break}case"table":{for(_e.tokens={header:[],cells:[]},j=_e.header.length,pe=0;pe<j;pe++)_e.tokens.header[pe]=[],this.inlineTokens(_e.header[pe],_e.tokens.header[pe]);for(j=_e.cells.length,pe=0;pe<j;pe++)for(we=_e.cells[pe],_e.tokens.cells[pe]=[],be=0;be<we.length;be++)_e.tokens.cells[pe][be]=[],this.inlineTokens(we[be],_e.tokens.cells[pe][be]);break}case"blockquote":{this.inline(_e.tokens);break}case"list":{for(j=_e.items.length,pe=0;pe<j;pe++)this.inline(_e.items[pe].tokens);break}}return ce},De.inlineTokens=function(ce,ue,pe,be){ue===void 0&&(ue=[]),pe===void 0&&(pe=!1),be===void 0&&(be=!1);var j,we,_e=ce,Ae,Ue,Ge;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)Ze.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;){if(Ue||(Ge=""),Ue=!1,j=this.tokenizer.escape(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.tag(ce,pe,be)){ce=ce.substring(j.raw.length),pe=j.inLink,be=j.inRawBlock;var Qe=ue[ue.length-1];Qe&&j.type==="text"&&Qe.type==="text"?(Qe.raw+=j.raw,Qe.text+=j.text):ue.push(j);continue}if(j=this.tokenizer.link(ce)){ce=ce.substring(j.raw.length),j.type==="link"&&(j.tokens=this.inlineTokens(j.text,[],!0,be)),ue.push(j);continue}if(j=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(j.raw.length);var Je=ue[ue.length-1];j.type==="link"?(j.tokens=this.inlineTokens(j.text,[],!0,be),ue.push(j)):Je&&j.type==="text"&&Je.type==="text"?(Je.raw+=j.raw,Je.text+=j.text):ue.push(j);continue}if(j=this.tokenizer.emStrong(ce,_e,Ge)){ce=ce.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],pe,be),ue.push(j);continue}if(j=this.tokenizer.codespan(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.br(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.del(ce)){ce=ce.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],pe,be),ue.push(j);continue}if(j=this.tokenizer.autolink(ce,We)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(!pe&&(j=this.tokenizer.url(ce,We))){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.inlineText(ce,be,qe)){ce=ce.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(Ge=j.raw.slice(-1)),Ue=!0,we=ue[ue.length-1],we&&we.type==="text"?(we.raw+=j.raw,we.text+=j.text):ue.push(j);continue}if(ce){var ct="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(ct);break}else throw new Error(ct)}}return ue},e(Ce,null,[{key:"rules",get:function(){return{block:ye,inline:Ie}}}]),Ce}(),W=T.defaults,Z=L.cleanUrl,ne=L.escape,le=function(){function Ce(Te){this.options=Te||W}var De=Ce.prototype;return De.code=function(ce,ue,pe){var be=(ue||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(ce,be);j!=null&&j!==ce&&(pe=!0,ce=j)}return ce=ce.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+ne(be,!0)+'">'+(pe?ce:ne(ce,!0))+`</code></pre>
`:"<pre><code>"+(pe?ce:ne(ce,!0))+`</code></pre>
`},De.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},De.html=function(ce){return ce},De.heading=function(ce,ue,pe,be){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+be.slug(pe)+'">'+ce+"</h"+ue+`>
`:"<h"+ue+">"+ce+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ce,ue,pe){var be=ue?"ol":"ul",j=ue&&pe!==1?' start="'+pe+'"':"";return"<"+be+j+`>
`+ce+"</"+be+`>
`},De.listitem=function(ce){return"<li>"+ce+`</li>
`},De.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ce){return"<p>"+ce+`</p>
`},De.table=function(ce,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+ue+`</table>
`},De.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},De.tablecell=function(ce,ue){var pe=ue.header?"th":"td",be=ue.align?"<"+pe+' align="'+ue.align+'">':"<"+pe+">";return be+ce+"</"+pe+`>
`},De.strong=function(ce){return"<strong>"+ce+"</strong>"},De.em=function(ce){return"<em>"+ce+"</em>"},De.codespan=function(ce){return"<code>"+ce+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ce){return"<del>"+ce+"</del>"},De.link=function(ce,ue,pe){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return pe;var be='<a href="'+ne(ce)+'"';return ue&&(be+=' title="'+ue+'"'),be+=">"+pe+"</a>",be},De.image=function(ce,ue,pe){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return pe;var be='<img src="'+ce+'" alt="'+pe+'"';return ue&&(be+=' title="'+ue+'"'),be+=this.options.xhtml?"/>":">",be},De.text=function(ce){return ce},Ce}(),Y=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(ce){return ce},De.em=function(ce){return ce},De.codespan=function(ce){return ce},De.del=function(ce){return ce},De.html=function(ce){return ce},De.text=function(ce){return ce},De.link=function(ce,ue,pe){return""+pe},De.image=function(ce,ue,pe){return""+pe},De.br=function(){return""},Ce}(),ae=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ce,ue){var pe=ce,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[ce];do be++,pe=ce+"-"+be;while(this.seen.hasOwnProperty(pe))}return ue||(this.seen[ce]=be,this.seen[pe]=0),pe},De.slug=function(ce,ue){ue===void 0&&(ue={});var pe=this.serialize(ce);return this.getNextSafeSlug(pe,ue.dryrun)},Ce}(),ve=T.defaults,Me=L.unescape,ze=function(){function Ce(Te){this.options=Te||ve,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ae}Ce.parse=function(ce,ue){var pe=new Ce(ue);return pe.parse(ce)},Ce.parseInline=function(ce,ue){var pe=new Ce(ue);return pe.parseInline(ce)};var De=Ce.prototype;return De.parse=function(ce,ue){ue===void 0&&(ue=!0);var pe="",be,j,we,_e,Ae,Ue,Ge,Ze,Qe,Je,ct,mt,bt,ot,at,Se,Pe,te,Q=ce.length;for(be=0;be<Q;be++)switch(Je=ce[be],Je.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Me(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(Ze="",Ge="",_e=Je.header.length,j=0;j<_e;j++)Ge+=this.renderer.tablecell(this.parseInline(Je.tokens.header[j]),{header:!0,align:Je.align[j]});for(Ze+=this.renderer.tablerow(Ge),Qe="",_e=Je.cells.length,j=0;j<_e;j++){for(Ue=Je.tokens.cells[j],Ge="",Ae=Ue.length,we=0;we<Ae;we++)Ge+=this.renderer.tablecell(this.parseInline(Ue[we]),{header:!1,align:Je.align[we]});Qe+=this.renderer.tablerow(Ge)}pe+=this.renderer.table(Ze,Qe);continue}case"blockquote":{Qe=this.parse(Je.tokens),pe+=this.renderer.blockquote(Qe);continue}case"list":{for(ct=Je.ordered,mt=Je.start,bt=Je.loose,_e=Je.items.length,Qe="",j=0;j<_e;j++)at=Je.items[j],Se=at.checked,Pe=at.task,ot="",at.task&&(te=this.renderer.checkbox(Se),bt?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=te+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=te+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:te}):ot+=te),ot+=this.parse(at.tokens,bt),Qe+=this.renderer.listitem(ot,Pe,Se);pe+=this.renderer.list(Qe,ct,mt);continue}case"html":{pe+=this.renderer.html(Je.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Qe=Je.tokens?this.parseInline(Je.tokens):Je.text;be+1<Q&&ce[be+1].type==="text";)Je=ce[++be],Qe+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);pe+=ue?this.renderer.paragraph(Qe):Qe;continue}default:{var Oe='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}return pe},De.parseInline=function(ce,ue){ue=ue||this.renderer;var pe="",be,j,we=ce.length;for(be=0;be<we;be++)switch(j=ce[be],j.type){case"escape":{pe+=ue.text(j.text);break}case"html":{pe+=ue.html(j.text);break}case"link":{pe+=ue.link(j.href,j.title,this.parseInline(j.tokens,ue));break}case"image":{pe+=ue.image(j.href,j.title,j.text);break}case"strong":{pe+=ue.strong(this.parseInline(j.tokens,ue));break}case"em":{pe+=ue.em(this.parseInline(j.tokens,ue));break}case"codespan":{pe+=ue.codespan(j.text);break}case"br":{pe+=ue.br();break}case"del":{pe+=ue.del(this.parseInline(j.tokens,ue));break}case"text":{pe+=ue.text(j.text);break}default:{var _e='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}return pe},Ce}(),Ee=L.merge,Ye=L.checkSanitizeDeprecation,X=L.escape,se=T.getDefaults,he=T.changeDefaults,xe=T.defaults;function Be(Ce,De,Te){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=Ee({},Be.defaults,De||{}),Ye(De),Te){var ce=De.highlight,ue;try{ue=je.lex(Ce,De)}catch(we){return Te(we)}var pe=function(_e){var Ae;if(!_e)try{Ae=ze.parse(ue,De)}catch(Ue){_e=Ue}return De.highlight=ce,_e?Te(_e):Te(null,Ae)};if(!ce||ce.length<3||(delete De.highlight,!ue.length))return pe();var be=0;Be.walkTokens(ue,function(we){we.type==="code"&&(be++,setTimeout(function(){ce(we.text,we.lang,function(_e,Ae){if(_e)return pe(_e);Ae!=null&&Ae!==we.text&&(we.text=Ae,we.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}try{var j=je.lex(Ce,De);return De.walkTokens&&Be.walkTokens(j,De.walkTokens),ze.parse(j,De)}catch(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+X(we.message+"",!0)+"</pre>";throw we}}Be.options=Be.setOptions=function(Ce){return Ee(Be.defaults,Ce),he(Be.defaults),Be},Be.getDefaults=se,Be.defaults=xe,Be.use=function(Ce){var De=Ee({},Ce);if(Ce.renderer&&function(){var ce=Be.defaults.renderer||new le,ue=function(j){var we=ce[j];ce[j]=function(){for(var _e=arguments.length,Ae=new Array(_e),Ue=0;Ue<_e;Ue++)Ae[Ue]=arguments[Ue];var Ge=Ce.renderer[j].apply(ce,Ae);return Ge===!1&&(Ge=we.apply(ce,Ae)),Ge}};for(var pe in Ce.renderer)ue(pe);De.renderer=ce}(),Ce.tokenizer&&function(){var ce=Be.defaults.tokenizer||new q,ue=function(j){var we=ce[j];ce[j]=function(){for(var _e=arguments.length,Ae=new Array(_e),Ue=0;Ue<_e;Ue++)Ae[Ue]=arguments[Ue];var Ge=Ce.tokenizer[j].apply(ce,Ae);return Ge===!1&&(Ge=we.apply(ce,Ae)),Ge}};for(var pe in Ce.tokenizer)ue(pe);De.tokenizer=ce}(),Ce.walkTokens){var Te=Be.defaults.walkTokens;De.walkTokens=function(ce){Ce.walkTokens(ce),Te&&Te(ce)}}Be.setOptions(De)},Be.walkTokens=function(Ce,De){for(var Te=D(Ce),ce;!(ce=Te()).done;){var ue=ce.value;switch(De(ue),ue.type){case"table":{for(var pe=D(ue.tokens.header),be;!(be=pe()).done;){var j=be.value;Be.walkTokens(j,De)}for(var we=D(ue.tokens.cells),_e;!(_e=we()).done;)for(var Ae=_e.value,Ue=D(Ae),Ge;!(Ge=Ue()).done;){var Ze=Ge.value;Be.walkTokens(Ze,De)}break}case"list":{Be.walkTokens(ue.items,De);break}default:ue.tokens&&Be.walkTokens(ue.tokens,De)}}},Be.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=Ee({},Be.defaults,De||{}),Ye(De);try{var Te=je.lexInline(Ce,De);return De.walkTokens&&Be.walkTokens(Te,De.walkTokens),ze.parseInline(Te,De)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+X(ce.message+"",!0)+"</pre>";throw ce}},Be.Parser=ze,Be.parser=ze.parse,Be.Renderer=le,Be.TextRenderer=Y,Be.Lexer=je,Be.lexer=je.lex,Be.Tokenizer=q,Be.Slugger=ae,Be.parse=Be;var et=Be;return et}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(T,C,y){return Math.min(Math.max(T,C),y)}e.clamp=p;function R(T,C){return(C+T%C)%C}e.rot=R;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class S{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function J(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function T(y){S.push(y,Date.now())}function C(){const y=[];for(let A=0;A<S.length;A+=2)y.push({name:S[A],startTime:S[A+1]});return y}return{mark:T,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))S.push({name:T.name,startTime:Math.round(D+T.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const p="en";let R=!1,D=!1,S=!1,T=!1,C=!1,y=!1,A=!1,i,I=p,u,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const v=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=v&&c?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=c?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)m=navigator.userAgent,R=m.indexOf("Windows")>=0,D=m.indexOf("Macintosh")>=0,A=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=m.indexOf("Linux")>=0,y=!0,i=navigator.language,I=i;else if(typeof c=="object"){R=c.platform==="win32",D=c.platform==="darwin",S=c.platform==="linux",T=S&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,i=p,I=p;const s=c.env.VSCODE_NLS_CONFIG;if(s)try{const n=JSON.parse(s),a=n.availableLanguages["*"];i=n.locale,I=a||p,u=n._translationsConfigFile}catch(n){}C=!0}else console.error("Unable to resolve platform.");var _;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function b(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let P=0;D?P=1:R?P=3:S&&(P=2),e.isWindows=R,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=T,e.isNative=C,e.isWeb=y,e.isIOS=A,e.platform=P,e.userAgent=m,e.language=I;var l;(function(s){function n(){return e.language}s.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function h(){return e.language==="en"}s.isDefault=h})(l=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let w=0,E=a.length;w<E;w++){const o=a[w];if(o.id===f.data.vscodeSetImmediateId){a.splice(w,1),o.callback();return}}});let h=0;return f=>{const w=++h;a.push({id:w,callback:f}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const n=Promise.resolve();return a=>n.then(a)}();var d;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(d=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||A?2:R?1:3;let g=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,g=new Uint16Array(s.buffer)[0]===(2<<8)+1}return g}e.isLittleEndian=r}),define(me[38],ge([0,1,11]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,p.setImmediate)(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(D){return(0,p.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[9],ge([0,1,38]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,S=90,T=122,C=46,y=47,A=92,i=58,I=63;class u extends Error{constructor(d,g,t){let r;typeof g=="string"&&g.indexOf("not ")===0?(r="must not be",g=g.replace(/^not /,"")):r="must be";const s=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${s} ${r} of type ${g}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function m(l,d){if(typeof l!="string")throw new u(d,"string",l)}function c(l){return l===y||l===A}function v(l){return l===y}function _(l){return l>=R&&l<=S||l>=D&&l<=T}function b(l,d,g,t){let r="",s=0,n=-1,a=0,h=0;for(let f=0;f<=l.length;++f){if(f<l.length)h=l.charCodeAt(f);else{if(t(h))break;h=y}if(t(h)){if(!(n===f-1||a===1))if(a===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const w=r.lastIndexOf(g);w===-1?(r="",s=0):(r=r.slice(0,w),s=r.length-1-r.lastIndexOf(g)),n=f,a=0;continue}else if(r.length!==0){r="",s=0,n=f,a=0;continue}}d&&(r+=r.length>0?`${g}..`:"..",s=2)}else r.length>0?r+=`${g}${l.slice(n+1,f)}`:r=l.slice(n+1,f),s=f-n-1;n=f,a=0}else h===C&&a!==-1?++a:a=-1}return r}function P(l,d){if(d===null||typeof d!="object")throw new u("pathObject","Object",d);const g=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return g?g===d.root?`${g}${t}`:`${g}${l}${t}`:t}e.win32={resolve(...l){let d="",g="",t=!1;for(let r=l.length-1;r>=-1;r--){let s;if(r>=0){if(s=l[r],m(s,"path"),s.length===0)continue}else d.length===0?s=p.cwd():(s=p.env[`=${d}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==d.toLowerCase()&&s.charCodeAt(2)===A)&&(s=`${d}\\`));const n=s.length;let a=0,h="",f=!1;const w=s.charCodeAt(0);if(n===1)c(w)&&(a=1,f=!0);else if(c(w))if(f=!0,c(s.charCodeAt(1))){let E=2,o=E;for(;E<n&&!c(s.charCodeAt(E));)E++;if(E<n&&E!==o){const k=s.slice(o,E);for(o=E;E<n&&c(s.charCodeAt(E));)E++;if(E<n&&E!==o){for(o=E;E<n&&!c(s.charCodeAt(E));)E++;(E===n||E!==o)&&(h=`\\\\${k}\\${s.slice(o,E)}`,a=E)}}}else a=1;else _(w)&&s.charCodeAt(1)===i&&(h=s.slice(0,2),a=2,n>2&&c(s.charCodeAt(2))&&(f=!0,a=3));if(h.length>0)if(d.length>0){if(h.toLowerCase()!==d.toLowerCase())continue}else d=h;if(t){if(d.length>0)break}else if(g=`${s.slice(a)}\\${g}`,t=f,f&&d.length>0)break}return g=b(g,!t,"\\",c),t?`${d}\\${g}`:`${d}${g}`||"."},normalize(l){m(l,"path");const d=l.length;if(d===0)return".";let g=0,t,r=!1;const s=l.charCodeAt(0);if(d===1)return v(s)?"\\":l;if(c(s))if(r=!0,c(l.charCodeAt(1))){let a=2,h=a;for(;a<d&&!c(l.charCodeAt(a));)a++;if(a<d&&a!==h){const f=l.slice(h,a);for(h=a;a<d&&c(l.charCodeAt(a));)a++;if(a<d&&a!==h){for(h=a;a<d&&!c(l.charCodeAt(a));)a++;if(a===d)return`\\\\${f}\\${l.slice(h)}\\`;a!==h&&(t=`\\\\${f}\\${l.slice(h,a)}`,g=a)}}}else g=1;else _(s)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),g=2,d>2&&c(l.charCodeAt(2))&&(r=!0,g=3));let n=g<d?b(l.slice(g),!r,"\\",c):"";return n.length===0&&!r&&(n="."),n.length>0&&c(l.charCodeAt(d-1))&&(n+="\\"),t===void 0?r?`\\${n}`:n:r?`${t}\\${n}`:`${t}${n}`},isAbsolute(l){m(l,"path");const d=l.length;if(d===0)return!1;const g=l.charCodeAt(0);return c(g)||d>2&&_(g)&&l.charCodeAt(1)===i&&c(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let d,g;for(let s=0;s<l.length;++s){const n=l[s];m(n,"path"),n.length>0&&(d===void 0?d=g=n:d+=`\\${n}`)}if(d===void 0)return".";let t=!0,r=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++r;const s=g.length;s>1&&c(g.charCodeAt(1))&&(++r,s>2&&(c(g.charCodeAt(2))?++r:t=!1))}if(t){for(;r<d.length&&c(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.win32.normalize(d)},relative(l,d){if(m(l,"from"),m(d,"to"),l===d)return"";const g=e.win32.resolve(l),t=e.win32.resolve(d);if(g===t||(l=g.toLowerCase(),d=t.toLowerCase(),l===d))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===A;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===A;)s--;const n=s-r;let a=0;for(;a<d.length&&d.charCodeAt(a)===A;)a++;let h=d.length;for(;h-1>a&&d.charCodeAt(h-1)===A;)h--;const f=h-a,w=n<f?n:f;let E=-1,o=0;for(;o<w;o++){const L=l.charCodeAt(r+o);if(L!==d.charCodeAt(a+o))break;L===A&&(E=o)}if(o!==w){if(E===-1)return t}else{if(f>w){if(d.charCodeAt(a+o)===A)return t.slice(a+o+1);if(o===2)return t.slice(a+o)}n>w&&(l.charCodeAt(r+o)===A?E=o:o===2&&(E=3)),E===-1&&(E=0)}let k="";for(o=r+E+1;o<=s;++o)(o===s||l.charCodeAt(o)===A)&&(k+=k.length===0?"..":"\\..");return a+=E,k.length>0?`${k}${t.slice(a,h)}`:(t.charCodeAt(a)===A&&++a,t.slice(a,h))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const d=e.win32.resolve(l);if(d.length<=2)return l;if(d.charCodeAt(0)===A){if(d.charCodeAt(1)===A){const g=d.charCodeAt(2);if(g!==I&&g!==C)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(_(d.charCodeAt(0))&&d.charCodeAt(1)===i&&d.charCodeAt(2)===A)return`\\\\?\\${d}`;return l},dirname(l){m(l,"path");const d=l.length;if(d===0)return".";let g=-1,t=0;const r=l.charCodeAt(0);if(d===1)return c(r)?l:".";if(c(r)){if(g=t=1,c(l.charCodeAt(1))){let a=2,h=a;for(;a<d&&!c(l.charCodeAt(a));)a++;if(a<d&&a!==h){for(h=a;a<d&&c(l.charCodeAt(a));)a++;if(a<d&&a!==h){for(h=a;a<d&&!c(l.charCodeAt(a));)a++;if(a===d)return l;a!==h&&(g=t=a+1)}}}}else _(r)&&l.charCodeAt(1)===i&&(g=d>2&&c(l.charCodeAt(2))?3:2,t=g);let s=-1,n=!0;for(let a=d-1;a>=t;--a)if(c(l.charCodeAt(a))){if(!n){s=a;break}}else n=!1;if(s===-1){if(g===-1)return".";s=g}return l.slice(0,s)},basename(l,d){d!==void 0&&m(d,"ext"),m(l,"path");let g=0,t=-1,r=!0,s;if(l.length>=2&&_(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(g=2),d!==void 0&&d.length>0&&d.length<=l.length){if(d===l)return"";let n=d.length-1,a=-1;for(s=l.length-1;s>=g;--s){const h=l.charCodeAt(s);if(c(h)){if(!r){g=s+1;break}}else a===-1&&(r=!1,a=s+1),n>=0&&(h===d.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=a))}return g===t?t=a:t===-1&&(t=l.length),l.slice(g,t)}for(s=l.length-1;s>=g;--s)if(c(l.charCodeAt(s))){if(!r){g=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(g,t)},extname(l){m(l,"path");let d=0,g=-1,t=0,r=-1,s=!0,n=0;l.length>=2&&l.charCodeAt(1)===i&&_(l.charCodeAt(0))&&(d=t=2);for(let a=l.length-1;a>=d;--a){const h=l.charCodeAt(a);if(c(h)){if(!s){t=a+1;break}continue}r===-1&&(s=!1,r=a+1),h===C?g===-1?g=a:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||r===-1||n===0||n===1&&g===r-1&&g===t+1?"":l.slice(g,r)},format:P.bind(null,"\\"),parse(l){m(l,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return d;const g=l.length;let t=0,r=l.charCodeAt(0);if(g===1)return c(r)?(d.root=d.dir=l,d):(d.base=d.name=l,d);if(c(r)){if(t=1,c(l.charCodeAt(1))){let E=2,o=E;for(;E<g&&!c(l.charCodeAt(E));)E++;if(E<g&&E!==o){for(o=E;E<g&&c(l.charCodeAt(E));)E++;if(E<g&&E!==o){for(o=E;E<g&&!c(l.charCodeAt(E));)E++;E===g?t=E:E!==o&&(t=E+1)}}}}else if(_(r)&&l.charCodeAt(1)===i){if(g<=2)return d.root=d.dir=l,d;if(t=2,c(l.charCodeAt(2))){if(g===3)return d.root=d.dir=l,d;t=3}}t>0&&(d.root=l.slice(0,t));let s=-1,n=t,a=-1,h=!0,f=l.length-1,w=0;for(;f>=t;--f){if(r=l.charCodeAt(f),c(r)){if(!h){n=f+1;break}continue}a===-1&&(h=!1,a=f+1),r===C?s===-1?s=f:w!==1&&(w=1):s!==-1&&(w=-1)}return a!==-1&&(s===-1||w===0||w===1&&s===a-1&&s===n+1?d.base=d.name=l.slice(n,a):(d.name=l.slice(n,s),d.base=l.slice(n,a),d.ext=l.slice(s,a))),n>0&&n!==t?d.dir=l.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let d="",g=!1;for(let t=l.length-1;t>=-1&&!g;t--){const r=t>=0?l[t]:p.cwd();m(r,"path"),r.length!==0&&(d=`${r}/${d}`,g=r.charCodeAt(0)===y)}return d=b(d,!g,"/",v),g?`/${d}`:d.length>0?d:"."},normalize(l){if(m(l,"path"),l.length===0)return".";const d=l.charCodeAt(0)===y,g=l.charCodeAt(l.length-1)===y;return l=b(l,!d,"/",v),l.length===0?d?"/":g?"./":".":(g&&(l+="/"),d?`/${l}`:l)},isAbsolute(l){return m(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let d;for(let g=0;g<l.length;++g){const t=l[g];m(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(l,d){if(m(l,"from"),m(d,"to"),l===d||(l=e.posix.resolve(l),d=e.posix.resolve(d),l===d))return"";const g=1,t=l.length,r=t-g,s=1,n=d.length-s,a=r<n?r:n;let h=-1,f=0;for(;f<a;f++){const E=l.charCodeAt(g+f);if(E!==d.charCodeAt(s+f))break;E===y&&(h=f)}if(f===a)if(n>a){if(d.charCodeAt(s+f)===y)return d.slice(s+f+1);if(f===0)return d.slice(s+f)}else r>a&&(l.charCodeAt(g+f)===y?h=f:f===0&&(h=0));let w="";for(f=g+h+1;f<=t;++f)(f===t||l.charCodeAt(f)===y)&&(w+=w.length===0?"..":"/..");return`${w}${d.slice(s+h)}`},toNamespacedPath(l){return l},dirname(l){if(m(l,"path"),l.length===0)return".";const d=l.charCodeAt(0)===y;let g=-1,t=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===y){if(!t){g=r;break}}else t=!1;return g===-1?d?"/":".":d&&g===1?"//":l.slice(0,g)},basename(l,d){d!==void 0&&m(d,"ext"),m(l,"path");let g=0,t=-1,r=!0,s;if(d!==void 0&&d.length>0&&d.length<=l.length){if(d===l)return"";let n=d.length-1,a=-1;for(s=l.length-1;s>=0;--s){const h=l.charCodeAt(s);if(h===y){if(!r){g=s+1;break}}else a===-1&&(r=!1,a=s+1),n>=0&&(h===d.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=a))}return g===t?t=a:t===-1&&(t=l.length),l.slice(g,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===y){if(!r){g=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(g,t)},extname(l){m(l,"path");let d=-1,g=0,t=-1,r=!0,s=0;for(let n=l.length-1;n>=0;--n){const a=l.charCodeAt(n);if(a===y){if(!r){g=n+1;break}continue}t===-1&&(r=!1,t=n+1),a===C?d===-1?d=n:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||t===-1||s===0||s===1&&d===t-1&&d===g+1?"":l.slice(d,t)},format:P.bind(null,"/"),parse(l){m(l,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return d;const g=l.charCodeAt(0)===y;let t;g?(d.root="/",t=1):t=0;let r=-1,s=0,n=-1,a=!0,h=l.length-1,f=0;for(;h>=t;--h){const w=l.charCodeAt(h);if(w===y){if(!a){s=h+1;break}continue}n===-1&&(a=!1,n=h+1),w===C?r===-1?r=h:f!==1&&(f=1):r!==-1&&(f=-1)}if(n!==-1){const w=s===0&&g?1:s;r===-1||f===0||f===1&&r===n-1&&r===s+1?d.base=d.name=l.slice(w,n):(d.name=l.slice(w,r),d.base=l.slice(w,n),d.ext=l.slice(r,n))}return s>0?d.dir=l.slice(0,s-1):g&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...T){const C=T.reduce((i,I)=>(i[I]=!0,i),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!C[i]).forEach(i=>{for(let I=0;I<y.length;I++)if(i.search(y[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(me[44],ge([0,1,11]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(T){this._highResolution=R&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new D(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(me[3],ge([0,1,15,72,6,94,44]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(l){l.None=()=>D.Disposable.None;function d(z){return(M,x=null,F)=>{let q=!1,U;return U=z(O=>{if(!q)return U?U.dispose():q=!0,M.call(x,O)},null,F),q&&U.dispose(),U}}l.once=d;function g(z,M){return h((x,F=null,q)=>z(U=>x.call(F,M(U)),null,q))}l.map=g;function t(z,M){return h((x,F=null,q)=>z(U=>{M(U),x.call(F,U)},null,q))}l.forEach=t;function r(z,M){return h((x,F=null,q)=>z(U=>M(U)&&x.call(F,U),null,q))}l.filter=r;function s(z){return z}l.signal=s;function n(...z){return(M,x=null,F)=>(0,D.combinedDisposable)(...z.map(q=>q(U=>M.call(x,U),null,F)))}l.any=n;function a(z,M,x){let F=x;return g(z,q=>(F=M(F,q),F))}l.reduce=a;function h(z){let M;const x=new u({onFirstListenerAdd(){M=z(x.fire,x)},onLastListenerRemove(){M.dispose()}});return x.event}function f(z,M,x=100,F=!1,q){let U,O,G,$=0;const K=new u({leakWarningThreshold:q,onFirstListenerAdd(){U=z(re=>{$++,O=M(O,re),F&&!G&&(K.fire(O),O=void 0),clearTimeout(G),G=setTimeout(()=>{const fe=O;O=void 0,G=void 0,(!F||$>1)&&K.fire(fe),$=0},x)})},onLastListenerRemove(){U.dispose()}});return K.event}l.debounce=f;function w(z,M=(x,F)=>x===F){let x=!0,F;return r(z,q=>{const U=x||!M(q,F);return x=!1,F=q,U})}l.latch=w;function E(z,M){return[l.filter(z,M),l.filter(z,x=>!M(x))]}l.split=E;function o(z,M=!1,x=[]){let F=x.slice(),q=z(G=>{F?F.push(G):O.fire(G)});const U=()=>{F&&F.forEach(G=>O.fire(G)),F=null},O=new u({onFirstListenerAdd(){q||(q=z(G=>O.fire(G)))},onFirstListenerDidAdd(){F&&(M?setTimeout(U):U())},onLastListenerRemove(){q&&q.dispose(),q=null}});return O.event}l.buffer=o;class k{constructor(M){this.event=M}map(M){return new k(g(this.event,M))}forEach(M){return new k(t(this.event,M))}filter(M){return new k(r(this.event,M))}reduce(M,x){return new k(a(this.event,M,x))}latch(){return new k(w(this.event))}debounce(M,x=100,F=!1,q){return new k(f(this.event,M,x,F,q))}on(M,x,F){return this.event(M,x,F)}once(M,x,F){return d(this.event)(M,x,F)}}function L(z){return new k(z)}l.chain=L;function N(z,M,x=F=>F){const F=(...G)=>O.fire(x(...G)),q=()=>z.on(M,F),U=()=>z.removeListener(M,F),O=new u({onFirstListenerAdd:q,onLastListenerRemove:U});return O.event}l.fromNodeEventEmitter=N;function V(z,M,x=F=>F){const F=(...G)=>O.fire(x(...G)),q=()=>z.addEventListener(M,F),U=()=>z.removeEventListener(M,F),O=new u({onFirstListenerAdd:q,onLastListenerRemove:U});return O.event}l.fromDOMEventEmitter=V;function ee(z){return new Promise(M=>d(z)(M))}l.toPromise=ee})(C=e.Event||(e.Event={}));class y{constructor(d){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${d}_${y._idPool++}`}start(d){this._stopWatch=new T.StopWatch(!0),this._listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this._elapsedOverall+=d,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${d.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let A=-1;function i(l){const d=A;return A=l,{dispose(){A=d}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(d,g=Math.random().toString(18).slice(2,5)){this.customThreshold=d,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(d){let g=A;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||d<g)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let s,n=0;for(const[a,h]of this._stacks)(!s||n<h)&&(s=a,n=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${n}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class u{constructor(d){this._disposed=!1,this._options=d,this._leakageMon=A>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(d,g,t)=>{this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(g?[d,g]:d);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,d,g);const n=this._leakageMon?.check(this._listeners.size),a=(0,D.toDisposable)(()=>{n&&n(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(d){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,d]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,t]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,t):g[0].call(g[1],t)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class m extends u{async fireAsync(d,g,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,d]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),n=[],a={...s,waitUntil:h=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(h=t(h,typeof r=="function"?r:r[0])),n.push(h)}};try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(h){(0,p.onUnexpectedError)(h);continue}Object.freeze(n),await Promise.allSettled(n).then(h=>{for(const f of h)f.status==="rejected"&&(0,p.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=m;class c extends u{constructor(d){super(d);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=d?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._listeners&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=c;class v extends c{constructor(d){super(d);this._delay=d.delay??100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=v;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const g={event:d,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const t=()=>{this.hasListeners&&this.unhook(g);const r=this.events.indexOf(g);this.events.splice(r,1)};return(0,D.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(g=>this.emitter.fire(g))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class b{constructor(){this.buffers=[]}wrapEvent(d){return(g,t,r)=>d(s=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>g.call(t,s)):g.call(t,s)},void 0,r)}bufferEvents(d){const g=[];this.buffers.push(g);const t=d();return this.buffers.pop(),g.forEach(r=>r()),t}}e.EventBufferer=b;class P{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(me[21],ge([0,1,3]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(C,y){const A=setTimeout(C.bind(y),0);return{dispose(){clearTimeout(A)}}});var D;(function(C){function y(A){return A===C.None||A===C.Cancelled||A instanceof S?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}C.isCancellationToken=y,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(me[45],ge([0,1,3]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const u=this._icons.get(I.id);u?I.description?u.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function S(i,I){return new C(i,I)}e.registerCodicon=S;function T(i){return i?i.replace(/\$\((.*?)\)/g,(I,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=T;class C{constructor(I,u,m){this.id=I,this.definition=u,this.description=m,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function y(i,I){const u=["codicon","codicon-"+i];return I&&u.push("codicon-modifier-"+I),u}e.getClassNamesArray=y;var A;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function u(v){if(v instanceof C)return["codicon","codicon-"+v.id];const _=I.exec(v.id);if(!_)return u(C.error);let[,b,P]=_;const l=["codicon","codicon-"+b];return P&&l.push("codicon-modifier-"+P.substr(1)),l}i.asClassNameArray=u;function m(v){return u(v).join(" ")}i.asClassName=m;function c(v){return"."+u(v).join(".")}i.asCSSSelector=c})(A=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[95],ge([0,1,15,6]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(l){const d=l;return d?[d.on,d.pause,d.resume,d.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=D;function S(l){const d=l;return d?D(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=S;function T(l,d){return new C(l,d)}e.newWriteableStream=T;class C{constructor(d,g){this.reducer=d,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(g=>g(d))}emitError(d){this.listeners.error.length===0?(0,p.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(g=>g(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,g){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(d,g){if(this.state.destroyed)return;let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(g);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(l,d){const g=[];let t;for(;(t=l.read())!==null;)g.push(t);return d(g)}e.consumeReadable=y;function A(l,d,g){const t=[];let r;for(;(r=l.read())!==null&&t.length<g;)t.push(r);return r===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return l.read()}}}e.peekReadable=A;function i(l,d){return new Promise((g,t)=>{const r=[];I(l,{onData:s=>{d&&r.push(s)},onError:s=>{d?t(s):g(void 0)},onEnd:()=>{g(d?d(r):void 0)}})})}e.consumeStream=i;function I(l,d){l.on("error",g=>d.onError(g)),l.on("end",()=>d.onEnd()),l.on("data",g=>d.onData(g))}e.listenStream=I;function u(l,d){return new Promise((g,t)=>{const r=new R.DisposableStore,s=[],n=f=>{if(s.push(f),s.length>d)return r.dispose(),l.pause(),g({stream:l,buffer:s,ended:!1})},a=f=>t(f),h=()=>g({stream:l,buffer:s,ended:!0});r.add((0,R.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),r.add((0,R.toDisposable)(()=>l.removeListener("end",h))),l.on("end",h),r.add((0,R.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=u;function m(l,d){const g=T(d);return g.end(l),g}e.toStream=m;function c(){const l=T(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function v(l){let d=!1;return{read:()=>d?null:(d=!0,l)}}e.toReadable=v;function _(l,d,g){const t=T(g);return I(l,{onData:r=>t.write(d.data(r)),onError:r=>t.error(d.error?d.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function b(l,d,g){let t=!1;return{read:()=>{const r=d.read();return t?r:(t=!0,r!==null?g([l,r]):l)}}}e.prefixedReadable=b;function P(l,d,g){let t=!1;const r=T(g);return I(d,{onData:s=>t?r.write(s):(t=!0,r.write(g([l,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(l)),r.end()}}),r}e.prefixedStream=P}),define(me[8],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function D(j,...we){return we.length===0?j:j.replace(R,function(_e,Ae){const Ue=parseInt(Ae,10);return isNaN(Ue)||Ue<0||Ue>=we.length?_e:we[Ue]})}e.format=D;const S=/{([^}]+)}/g;function T(j,we){return j.replace(S,(_e,Ae)=>we[Ae]??_e)}e.format2=T;function C(j){return j.replace(/[<>&]/g,function(we){switch(we){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return we}})}e.escape=C;function y(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function A(j,we){let _e=0;const Ae=we.charCodeAt(0);for(let Ue=j.length-1;Ue>=0;Ue--)j.charCodeAt(Ue)===Ae&&_e++;return _e}e.count=A;function i(j,we,_e="\u2026"){return j.length<=we?j:`${j.substr(0,we)}${_e}`}e.truncate=i;function I(j,we=" "){const _e=u(j,we);return m(_e,we)}e.trim=I;function u(j,we){if(!j||!we)return j;const _e=we.length;if(_e===0||j.length===0)return j;let Ae=0;for(;j.indexOf(we,Ae)===Ae;)Ae=Ae+_e;return j.substring(Ae)}e.ltrim=u;function m(j,we){if(!j||!we)return j;const _e=we.length,Ae=j.length;if(_e===0||Ae===0)return j;let Ue=Ae,Ge=-1;for(;Ge=j.lastIndexOf(we,Ue-1),!(Ge===-1||Ge+_e!==Ue);){if(Ge===0)return"";Ue=Ge}return j.substring(0,Ue)}e.rtrim=m;function c(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function v(j){return j.replace(/\*/g,"")}e.stripWildcards=v;function _(j,we,_e={}){if(!j)throw new Error("Cannot create regex from empty string");we||(j=y(j)),_e.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let Ae="";return _e.global&&(Ae+="g"),_e.matchCase||(Ae+="i"),_e.multiline&&(Ae+="m"),_e.unicode&&(Ae+="u"),new RegExp(j,Ae)}e.createRegExp=_;function b(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function P(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function l(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=l;function d(j){return j.split(/\r\n|\r|\n/)}e.splitLines=d;function g(j){for(let we=0,_e=j.length;we<_e;we++){const Ae=j.charCodeAt(we);if(Ae!==32&&Ae!==9)return we}return-1}e.firstNonWhitespaceIndex=g;function t(j,we=0,_e=j.length){for(let Ae=we;Ae<_e;Ae++){const Ue=j.charCodeAt(Ae);if(Ue!==32&&Ue!==9)return j.substring(we,Ae)}return j.substring(we,_e)}e.getLeadingWhitespace=t;function r(j,we=j.length-1){for(let _e=we;_e>=0;_e--){const Ae=j.charCodeAt(_e);if(Ae!==32&&Ae!==9)return _e}return-1}e.lastNonWhitespaceIndex=r;function s(j,we){return j<we?-1:j>we?1:0}e.compare=s;function n(j,we,_e=0,Ae=j.length,Ue=0,Ge=we.length){for(;_e<Ae&&Ue<Ge;_e++,Ue++){let Je=j.charCodeAt(_e),ct=we.charCodeAt(Ue);if(Je<ct)return-1;if(Je>ct)return 1}const Ze=Ae-_e,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=n;function a(j,we){return h(j,we,0,j.length,0,we.length)}e.compareIgnoreCase=a;function h(j,we,_e=0,Ae=j.length,Ue=0,Ge=we.length){for(;_e<Ae&&Ue<Ge;_e++,Ue++){let Je=j.charCodeAt(_e),ct=we.charCodeAt(Ue);if(Je===ct)continue;const mt=Je-ct;if(!(mt===32&&w(ct))&&!(mt===-32&&w(Je)))return f(Je)&&f(ct)?mt:n(j.toLowerCase(),we.toLowerCase(),_e,Ae,Ue,Ge)}const Ze=Ae-_e,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=h;function f(j){return j>=97&&j<=122}e.isLowerAsciiLetter=f;function w(j){return j>=65&&j<=90}e.isUpperAsciiLetter=w;function E(j){return f(j)||w(j)}function o(j,we){return j.length===we.length&&k(j,we)}e.equalsIgnoreCase=o;function k(j,we,_e=j.length){for(let Ae=0;Ae<_e;Ae++){const Ue=j.charCodeAt(Ae),Ge=we.charCodeAt(Ae);if(Ue!==Ge){if(E(Ue)&&E(Ge)){const Ze=Math.abs(Ue-Ge);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Ue).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function L(j,we){const _e=we.length;return we.length>j.length?!1:k(j,we,_e)}e.startsWithIgnoreCase=L;function N(j,we){let _e,Ae=Math.min(j.length,we.length);for(_e=0;_e<Ae;_e++)if(j.charCodeAt(_e)!==we.charCodeAt(_e))return _e;return Ae}e.commonPrefixLength=N;function V(j,we){let _e,Ae=Math.min(j.length,we.length);const Ue=j.length-1,Ge=we.length-1;for(_e=0;_e<Ae;_e++)if(j.charCodeAt(Ue-_e)!==we.charCodeAt(Ge-_e))return _e;return Ae}e.commonSuffixLength=V;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function z(j){return 56320<=j&&j<=57343}e.isLowSurrogate=z;function M(j,we){return(j-55296<<10)+(we-56320)+65536}e.computeCodePoint=M;function x(j,we,_e){const Ae=j.charCodeAt(_e);if(ee(Ae)&&_e+1<we){const Ue=j.charCodeAt(_e+1);if(z(Ue))return M(Ae,Ue)}return Ae}e.getNextCodePoint=x;function F(j,we){const _e=j.charCodeAt(we-1);if(z(_e)&&we>1){const Ae=j.charCodeAt(we-2);if(ee(Ae))return M(Ae,_e)}return _e}function q(j,we){const _e=Ce.getInstance(),Ae=we,Ue=j.length,Ge=x(j,Ue,we);we+=Ge>=65536?2:1;let Ze=_e.getGraphemeBreakType(Ge);for(;we<Ue;){const Qe=x(j,Ue,we),Je=_e.getGraphemeBreakType(Qe);if(Be(Ze,Je))break;we+=Qe>=65536?2:1,Ze=Je}return we-Ae}e.nextCharLength=q;function U(j,we){const _e=Ce.getInstance(),Ae=we,Ue=F(j,we);we-=Ue>=65536?2:1;let Ge=_e.getGraphemeBreakType(Ue);for(;we>0;){const Ze=F(j,we),Qe=_e.getGraphemeBreakType(Ze);if(Be(Qe,Ge))break;we-=Ze>=65536?2:1,Ge=Qe}return Ae-we}e.prevCharLength=U;function O(j,we){const _e=Ce.getInstance(),Ae=j.length,Ue=we,Ge=x(j,Ae,we),Ze=_e.getGraphemeBreakType(Ge);we+=Ge>=65536?2:1;let Qe=Ze;for(;we<Ae;){const ct=x(j,Ae,we),mt=_e.getGraphemeBreakType(ct);if(Be(Qe,mt))break;we+=ct>=65536?2:1,Qe=mt}const Je=we;for(we=Ue,Qe=Ze;we>0;){const ct=F(j,we),mt=_e.getGraphemeBreakType(ct);if(Be(mt,Qe))break;we-=ct>=65536?2:1,Qe=mt}return[we,Je]}function G(j,we){return we>0&&z(j.charCodeAt(we))?O(j,we-1):O(j,we)}e.getCharContainingOffset=G;function $(j){const we=j.length;let _e=0,Ae=0;for(;Ae<we;){const Ze=x(j,we,Ae);Ae+=Ze>=65536?2:1,Ze<128?_e+=1:Ze<2048?_e+=2:Ze<65536?_e+=3:_e+=4}const Ue=new Uint8Array(_e);Ae=0;let Ge=0;for(;Ae<we;){const Ze=x(j,we,Ae);Ae+=Ze>=65536?2:1,Ze<128?Ue[Ge++]=Ze:Ze<2048?(Ue[Ge++]=192|(Ze&1984)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):Ze<65536?(Ue[Ge++]=224|(Ze&61440)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):(Ue[Ge++]=240|(Ze&1835008)>>>18,Ue[Ge++]=128|(Ze&258048)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0)}return Ue}e.encodeUTF8=$;function K(j){const we=j.byteLength,_e=[];let Ae=0;for(;Ae<we;){const Ue=j[Ae];let Ge;if(Ue>=240&&Ae+3<we?Ge=(j[Ae++]&7)<<18>>>0|(j[Ae++]&63)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=224&&Ae+2<we?Ge=(j[Ae++]&15)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=192&&Ae+1<we?Ge=(j[Ae++]&31)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ge=j[Ae++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)_e.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const Ze=Ge-65536,Qe=55296+((Ze&1047552)>>>10),Je=56320+((Ze&1023)>>>0);_e.push(String.fromCharCode(Qe)),_e.push(String.fromCharCode(Je))}else _e.push(String.fromCharCode(65533))}return _e.join("")}e.decodeUTF8=K;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function fe(j){return re.test(j)}e.containsRTL=fe;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(j){return ye.test(j)}e.containsEmoji=Ie;const Le=/^[\t\n\r\x20-\x7E]*$/;function qe(j){return Le.test(j)}e.isBasicASCII=qe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=We;function je(j){for(let we=0,_e=j.length;we<_e;we++)if(W(j.charCodeAt(we)))return!0;return!1}e.containsFullWidthCharacter=je;function W(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=W;function Z(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=Z;function ne(j,we){if(j.length<we)return j;const _e=/\b/g;let Ae=0;for(;_e.test(j)&&!(j.length-_e.lastIndex<we);)Ae=_e.lastIndex,_e.lastIndex+=1;return j.substring(Ae).replace(/^\s/,"")}e.lcut=ne;const le=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function ve(j){return j&&(j=j.replace(le,""),j=j.replace(Y,""),j=j.replace(ae,"")),j}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function ze(j){return Me(j)?j.substr(1):j}e.stripUTF8BOM=ze;function Ee(j,we){if(!j||!we||j.length<we.length)return!1;const _e=we.length,Ae=j.toLowerCase();let Ue=0,Ge=-1;for(;Ue<_e;){const Ze=Ae.indexOf(we[Ue],Ge+1);if(Ze<0)return!1;Ge=Ze,Ue++}return!0}e.fuzzyContains=Ee;function Ye(j,we=!1){return j?(we&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Ye;function X(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=X;function se(j,we=1){if(we===0)return"";let _e=-1;do _e=j.indexOf(`
`,_e+1),we--;while(we>0&&_e>=0);return _e===-1?j:(j[_e-1]==="\r"&&_e--,j.substr(0,_e))}e.getNLines=se;function he(j){const we=90-65+1;return j=j%(2*we),j<we?String.fromCharCode(97+j):String.fromCharCode(65+j-we)}e.singleLetterHash=he;function xe(j){return Ce.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=xe;function Be(j,we){return j===0?we!==5&&we!==7:j===2&&we===3?!1:j===4||j===2||j===3||we===4||we===2||we===3?!0:!(j===8&&(we===8||we===9||we===11||we===12)||(j===11||j===9)&&(we===9||we===10)||(j===12||j===10)&&we===10||we===5||we===13||we===7||j===1||j===13&&we===14||j===6&&we===6)}e.breakBetweenGraphemeBreakType=Be;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=De()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(we){if(we<32)return we===10?3:we===13?2:4;if(we<127)return 0;const _e=this._data,Ae=_e.length/3;let Ue=1;for(;Ue<=Ae;)if(we<_e[3*Ue])Ue=2*Ue;else if(we>_e[3*Ue+1])Ue=2*Ue+1;else return _e[3*Ue+2];return 0}}Ce._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Te(j,we){if(j===0)return 0;const _e=ce(j,we);if(_e!==void 0)return _e;const Ae=F(we,j);return j-=ue(Ae),j}e.getLeftDeleteOffset=Te;function ce(j,we){let _e=F(we,j);for(j-=ue(_e);pe(_e)||_e===65039||_e===8419;){if(j===0)return;_e=F(we,j),j-=ue(_e)}if(!!Z(_e)){if(j>=0){const Ae=F(we,j);Ae===8205&&(j-=ue(Ae))}return j}}function ue(j){return j>=65536?2:1}function pe(j){return 127995<=j&&j<=127999}var be;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(be||(be={}))}),define(me[23],ge([0,1,8,95]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let C,y;class A{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return D?new A(Buffer.allocUnsafe(f)):new A(new Uint8Array(f))}static wrap(f){return D&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new A(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&D?new A(Buffer.from(f)):S?(C||(C=new TextEncoder),new A(C.encode(f))):new A(p.encodeUTF8(f))}static concat(f,w){if(typeof w=="undefined"){w=0;for(let k=0,L=f.length;k<L;k++)w+=f[k].byteLength}const E=A.alloc(w);let o=0;for(let k=0,L=f.length;k<L;k++){const N=f[k];E.set(N,o),o+=N.byteLength}return E}toString(){return D?this.buffer.toString():T?(y||(y=new TextDecoder),y.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(f,w){return new A(this.buffer.subarray(f,w))}set(f,w){f instanceof A?this.buffer.set(f.buffer,w):this.buffer.set(f,w)}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,w){m(this.buffer,f,w)}readUInt32LE(f){return c(this.buffer,f)}writeUInt32LE(f,w){v(this.buffer,f,w)}readUInt8(f){return _(this.buffer,f)}writeUInt8(f,w){b(this.buffer,f,w)}}e.VSBuffer=A;function i(h,f){return h[f+0]<<0>>>0|h[f+1]<<8>>>0}e.readUInt16LE=i;function I(h,f,w){h[w+0]=f&255,f=f>>>8,h[w+1]=f&255}e.writeUInt16LE=I;function u(h,f){return h[f]*2**24+h[f+1]*2**16+h[f+2]*2**8+h[f+3]}e.readUInt32BE=u;function m(h,f,w){h[w+3]=f,f=f>>>8,h[w+2]=f,f=f>>>8,h[w+1]=f,f=f>>>8,h[w]=f}e.writeUInt32BE=m;function c(h,f){return h[f+0]<<0>>>0|h[f+1]<<8>>>0|h[f+2]<<16>>>0|h[f+3]<<24>>>0}e.readUInt32LE=c;function v(h,f,w){h[w+0]=f&255,f=f>>>8,h[w+1]=f&255,f=f>>>8,h[w+2]=f&255,f=f>>>8,h[w+3]=f&255}e.writeUInt32LE=v;function _(h,f){return h[f]}e.readUInt8=_;function b(h,f,w){h[w]=f}e.writeUInt8=b;function P(h){return R.consumeReadable(h,f=>A.concat(f))}e.readableToBuffer=P;function l(h){return R.toReadable(h)}e.bufferToReadable=l;function d(h){return R.consumeStream(h,f=>A.concat(f))}e.streamToBuffer=d;async function g(h){return h.ended?A.concat(h.buffer):A.concat([...h.buffer,await d(h.stream)])}e.bufferedStreamToBuffer=g;function t(h){return R.toStream(h,f=>A.concat(f))}e.bufferToStream=t;function r(h){return R.transform(h,{data:f=>typeof f=="string"?A.fromString(f):A.wrap(f)},f=>A.concat(f))}e.streamToBufferReadableStream=r;function s(h){return R.newWriteableStream(f=>A.concat(f),h)}e.newWriteableBufferStream=s;function n(h,f){return R.prefixedReadable(h,f,w=>A.concat(w))}e.prefixedBufferReadable=n;function a(h,f){return R.prefixedStream(h,f,w=>A.concat(w))}e.prefixedBufferStream=a}),define(me[58],ge([0,1,8]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return D(b,0)}e.hash=R;function D(b,P){switch(typeof b){case"object":return b===null?S(349,P):Array.isArray(b)?y(b,P):A(b,P);case"string":return C(b,P);case"boolean":return T(b,P);case"number":return S(b,P);case"undefined":return S(937,P);default:return S(617,P)}}e.doHash=D;function S(b,P){return(P<<5)-P+b|0}function T(b,P){return S(b?433:863,P)}function C(b,P){P=S(149417,P);for(let l=0,d=b.length;l<d;l++)P=S(b.charCodeAt(l),P);return P}e.stringHash=C;function y(b,P){return P=S(104579,P),b.reduce((l,d)=>D(d,l),P)}function A(b,P){return P=S(181387,P),Object.keys(b).sort().reduce((l,d)=>(l=C(d,l),D(b[d],l)),P)}class i{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=D(P,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function u(b,P,l=32){const d=l-P,g=~((1<<d)-1);return(b<<P|(g&b)>>>d)>>>0}function m(b,P=0,l=b.byteLength,d=0){for(let g=0;g<l;g++)b[P+g]=d}function c(b,P,l="0"){for(;b.length<P;)b=l+b;return b}function v(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(l=>l.toString(16).padStart(2,"0")).join(""):c((b>>>0).toString(16),P/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const l=P.length;if(l===0)return;const d=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=P.charCodeAt(0),s=0);;){let n=r;if(p.isHighSurrogate(r))if(s+1<l){const a=P.charCodeAt(s+1);p.isLowSurrogate(a)?(s++,n=p.computeCodePoint(r,a)):n=65533}else{t=r;break}else p.isLowSurrogate(r)&&(n=65533);if(g=this._push(d,g,n),s++,s<l)r=P.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(P,l,d){return d<128?P[l++]=d:d<2048?(P[l++]=192|(d&1984)>>>6,P[l++]=128|(d&63)>>>0):d<65536?(P[l++]=224|(d&61440)>>>12,P[l++]=128|(d&4032)>>>6,P[l++]=128|(d&63)>>>0):(P[l++]=240|(d&1835008)>>>18,P[l++]=128|(d&258048)>>>12,P[l++]=128|(d&4032)>>>6,P[l++]=128|(d&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=_._bigBlock32,l=this._buffDV;for(let f=0;f<64;f+=4)P.setUint32(f,l.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)P.setUint32(f,u(P.getUint32(f-12,!1)^P.getUint32(f-32,!1)^P.getUint32(f-56,!1)^P.getUint32(f-64,!1),1),!1);let d=this._h0,g=this._h1,t=this._h2,r=this._h3,s=this._h4,n,a,h;for(let f=0;f<80;f++)f<20?(n=g&t|~g&r,a=1518500249):f<40?(n=g^t^r,a=1859775393):f<60?(n=g&t|g&r|t&r,a=2400959708):(n=g^t^r,a=3395469782),h=u(d,5)+n+s+a+P.getUint32(f*4,!1)&4294967295,s=r,r=t,t=u(g,30),g=d,d=h;this._h0=this._h0+d&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[46],ge([0,1,8]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const S="error",T="warning",C="warn",y="info",A="ignore";function i(u){return u?p.equalsIgnoreCase(S,u)?D.Error:p.equalsIgnoreCase(T,u)||p.equalsIgnoreCase(C,u)?D.Warning:p.equalsIgnoreCase(y,u)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function I(u){switch(u){case D.Error:return S;case D.Warning:return T;case D.Info:return y;default:return A}}D.toString=I}(R||(R={})),e.default=R}),define(me[14],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(f){return Array.isArray(f)}e.isArray=p;function R(f){return typeof f=="string"}e.isString=R;function D(f){return Array.isArray(f)&&f.every(w=>R(w))}e.isStringArray=D;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function T(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=T;function C(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=C;function y(f){return f===!0||f===!1}e.isBoolean=y;function A(f){return typeof f=="undefined"}e.isUndefined=A;function i(f){return!I(f)}e.isDefined=i;function I(f){return A(f)||f===null}e.isUndefinedOrNull=I;function u(f,w){if(!f)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=u;function m(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function c(...f){const w=[];for(let E=0;E<f.length;E++){const o=f[E];if(I(o))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);w.push(o)}return w}e.assertAllDefined=c;const v=Object.prototype.hasOwnProperty;function _(f){if(!S(f))return!1;for(let w in f)if(v.call(f,w))return!1;return!0}e.isEmptyObject=_;function b(f){return typeof f=="function"}e.isFunction=b;function P(...f){return f.length>0&&f.every(b)}e.areFunctions=P;function l(f,w){const E=Math.min(f.length,w.length);for(let o=0;o<E;o++)d(f[o],w[o])}e.validateConstraints=l;function d(f,w){if(R(w)){if(typeof f!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(b(w)){try{if(f instanceof w)return}catch{}if(!I(f)&&f.constructor===w||w.length===1&&w.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function g(f){let w=[],E=Object.getPrototypeOf(f);for(;Object.prototype!==E;)w=w.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return w}e.getAllPropertyNames=g;function t(f){const w=[];for(const E of g(f))typeof f[E]=="function"&&w.push(E);return w}e.getAllMethodNames=t;function r(f,w){const E=k=>function(){const L=Array.prototype.slice.call(arguments,0);return w(k,L)};let o={};for(const k of f)o[k]=E(k);return o}e.createProxyObject=r;function s(f){return f===null?void 0:f}e.withNullAsUndefined=s;function n(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=n;function a(f){return class{constructor(){return new Proxy({},{get(w,E){if(w[E])return w[E];throw new Error(`Not Implemented: ${f}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function h(f,w="Unreachable"){throw new Error(w)}e.assertNever=h}),define(me[29],ge([0,1,11,8,9,14]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function C(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=C;function y(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function A(s,n=D.posix.sep){if(!s)return"";const a=s.length,h=s.charCodeAt(0);if(T(h)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let w=3;const E=w;for(;w<a&&!T(s.charCodeAt(w));w++);if(E!==w&&!T(s.charCodeAt(w+1))){for(w+=1;w<a;w++)if(T(s.charCodeAt(w)))return s.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(b(h)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(T(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=A;function i(s){if(!p.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let a=2;const h=a;for(;a<s.length&&(n=s.charCodeAt(a),n!==92);a++);return!(h===a||(n=s.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,n=p.isWindows){const a=n?I:u;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||n&&m.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function v(s,n,a){const h=s===n;return!a||h?h:!s||!n?!1:(0,R.equalsIgnoreCase)(s,n)}e.isEqual=v;function _(s,n,a,h=D.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let w=n.length;return n.charAt(n.length-1)===h&&w--,s.charAt(w)===h}return n.charAt(n.length-1)!==h&&(n+=h),s.indexOf(n)===0}e.isEqualOrParent=_;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function P(s,n){return p.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(n,s)),s=(0,D.normalize)(s),p.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=P;function l(s){const n=(0,D.normalize)(s);return p.isWindows?s.length>3?!1:d(n)&&(s.length===2||n.charCodeAt(2)===92):n===D.posix.sep}e.isRootOrDriveLetter=l;function d(s){return p.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function g(s){return d(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,n,a){return n.length>s.length?-1:s===n?0:(a&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function r(s){const n=s.split(":");let a,h,f;if(n.forEach(w=>{const E=Number(w);(0,S.isNumber)(E)?h===void 0?h=E:f===void 0&&(f=E):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[25],ge([0,1,14]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?_[b]=R(v[b]):_[b]=v[b]}),_}e.deepClone=R;function D(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const b=_.shift();Object.freeze(b);for(const P in b)if(S.call(b,P)){const l=b[P];typeof l=="object"&&!Object.isFrozen(l)&&_.push(l)}}return v}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function T(v,_){return C(v,_,new Set)}e.cloneAndChange=T;function C(v,_,b){if((0,p.isUndefinedOrNull)(v))return v;const P=_(v);if(typeof P!="undefined")return P;if((0,p.isArray)(v)){const l=[];for(const d of v)l.push(C(d,_,b));return l}if((0,p.isObject)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const l={};for(let d in v)S.call(v,d)&&(l[d]=C(v[d],_,b));return b.delete(v),l}return v}function y(v,_,b=!0){return(0,p.isObject)(v)?((0,p.isObject)(_)&&Object.keys(_).forEach(P=>{P in v?b&&((0,p.isObject)(v[P])&&(0,p.isObject)(_[P])?y(v[P],_[P],b):v[P]=_[P]):v[P]=_[P]}),v):_}e.mixin=y;function A(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let b,P;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(b=0;b<v.length;b++)if(!A(v[b],_[b]))return!1}else{const l=[];for(P in v)l.push(P);l.sort();const d=[];for(P in _)d.push(P);if(d.sort(),!A(l,d))return!1;for(b=0;b<l.length;b++)if(!A(v[l[b]],_[l[b]]))return!1}return!0}e.equals=A;function i(v){const _=new Set;return JSON.stringify(v,(b,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(_.has(P))return"[Circular]";_.add(P)}return P})}e.safeStringify=i;function I(v,_,b){const P=_(v);return typeof P=="undefined"?b:P}e.getOrDefault=I;function u(v,_){const b=Object.create(null);return!v||!_||Object.keys(_).forEach(l=>{const d=v[l],g=_[l];A(d,g)||(b[l]=g)}),b}e.distinct=u;function m(v,_){const b=_.toLowerCase(),P=Object.keys(v).find(l=>l.toLowerCase()===b);return P?v[P]:v[_]}e.getCaseInsensitive=m;function c(v,_){const b=Object.create(null);for(const P of Object.keys(v))_(P,v[P])&&(b[P]=v[P]);return b}e.filter=c}),define(me[96],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function R(S){return S<0?0:S>255?255:S|0}e.toUint8=R;function D(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=D}),define(me[2],ge([0,1,11,9]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,T=/^\/\//;function C(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,n){return!s&&!n?"file":s}function A(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const i="",I="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(n,a,h,f,w,E=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=y(n,E),this.authority=a||i,this.path=A(this.scheme,h||i),this.query=f||i,this.fragment=w||i,C(this,E))}static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return l(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:h,path:f,query:w,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=i),h===void 0?h=this.authority:h===null&&(h=i),f===void 0?f=this.path:f===null&&(f=i),w===void 0?w=this.query:w===null&&(w=i),E===void 0?E=this.fragment:E===null&&(E=i),a===this.scheme&&h===this.authority&&f===this.path&&w===this.query&&E===this.fragment?this:new v(a,h,f,w,E)}static parse(n,a=!1){const h=u.exec(n);return h?new v(h[2]||i,r(h[4]||i),r(h[5]||i),r(h[7]||i),r(h[9]||i),a):new v(i,i,i,i,i)}static file(n){let a=i;if(p.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const h=n.indexOf(I,2);h===-1?(a=n.substring(2),n=I):(a=n.substring(2,h),n=n.substring(h)||I)}return new v("file",a,n,i,i)}static from(n){const a=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return C(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return p.isWindows&&n.scheme==="file"?h=m.file(R.win32.join(l(n,!0),...a)).path:h=R.posix.join(n.path,...a),n.with({path:h})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const a=new v(n);return a._formatted=n.external,a._fsPath=n._sep===c?n.fsPath:null,a}}else return n}}e.URI=m;const c=p.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,n){let a,h=-1;for(let f=0;f<s.length;f++){const w=s.charCodeAt(f);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47)h!==-1&&(a+=encodeURIComponent(s.substring(h,f)),h=-1),a!==void 0&&(a+=s.charAt(f));else{a===void 0&&(a=s.substr(0,f));const E=_[w];E!==void 0?(h!==-1&&(a+=encodeURIComponent(s.substring(h,f)),h=-1),a+=E):h===-1&&(h=f)}}return h!==-1&&(a+=encodeURIComponent(s.substring(h))),a!==void 0?a:s}function P(s){let n;for(let a=0;a<s.length;a++){const h=s.charCodeAt(a);h===35||h===63?(n===void 0&&(n=s.substr(0,a)),n+=_[h]):n!==void 0&&(n+=s[a])}return n!==void 0?n:s}function l(s,n){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,p.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=l;function d(s,n){const a=n?P:b;let h="",{scheme:f,authority:w,path:E,query:o,fragment:k}=s;if(f&&(h+=f,h+=":"),(w||f==="file")&&(h+=I,h+=I),w){let L=w.indexOf("@");if(L!==-1){const N=w.substr(0,L);w=w.substr(L+1),L=N.indexOf(":"),L===-1?h+=a(N,!1):(h+=a(N.substr(0,L),!1),h+=":",h+=a(N.substr(L+1),!1)),h+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?h+=a(w,!1):(h+=a(w.substr(0,L),!1),h+=w.substr(L))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const L=E.charCodeAt(1);L>=65&&L<=90&&(E=`/${String.fromCharCode(L+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const L=E.charCodeAt(0);L>=65&&L<=90&&(E=`${String.fromCharCode(L+32)}:${E.substr(2)}`)}h+=a(E,!0)}return o&&(h+="?",h+=a(o,!1)),k&&(h+="#",h+=n?k:b(k,!1)),h}function g(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,n=>g(n)):s}});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[22],ge([0,1,2,8]),function(J,e,p,R){"use strict";var D,S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,s){let n=t.get(r);return n===void 0&&(n=s,t.set(r,n)),n}e.getOrSet=C;function y(t){const r=[];return t.forEach((s,n)=>{r.push(`${n} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function A(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=A;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class u{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new c(r))}static forPaths(){return new _(new u)}static forStrings(){return new _(new i)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(r,s){const n=this._iter.reset(r);let a;for(this._root||(this._root=new v,this._root.segment=n.value()),a=this._root;;){const f=n.cmp(a.segment);if(f>0)a.left||(a.left=new v,a.left.segment=n.value()),a=a.left;else if(f<0)a.right||(a.right=new v,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new v,a.mid.segment=n.value()),a=a.mid;else break}const h=a.value;return a.value=s,a.key=r,h}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let n=this._root;for(;n;){const a=s.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const n=this._iter.reset(r),a=[];let h=this._root;for(;h;){const f=n.cmp(h.segment);if(f>0)a.push([1,h]),h=h.left;else if(f<0)a.push([-1,h]),h=h.right;else if(n.hasNext())n.next(),a.push([0,h]),h=h.mid;else{for(s?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;a.length>0&&h.isEmpty();){let[w,E]=a.pop();switch(w){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}h=E}break}}}findSubstr(r){const s=this._iter.reset(r);let n=this._root,a;for(;n;){const h=s.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(s.hasNext())s.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(r){const s=this._iter.reset(r);let n=this._root;for(;n;){const a=s.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(r){for(const[s,n]of this)r(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const n=s.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&s.push(n.left),n.mid&&s.push(n.mid),n.right&&s.push(n.right))}}}e.TernarySearchTree=_;class b{constructor(r,s){this[D]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[n,a]of this.map)r(a,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield p.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[p.URI.parse(r[0]),r[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[p.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class l{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const n=this._map.get(r);if(!!n)return s!==0&&this.touch(n,s),n.value}set(r,s,n=0){let a=this._map.get(r);if(a)a.value=s,n!==0&&this.touch(a,n);else{switch(a={key:r,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const n=this._state;let a=this._head;for(;a;){if(s?r.bind(s)(a.value,a.key,this):r(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,s=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.key,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return a}values(){const r=this,s=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.value,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return a}entries(){const r=this,s=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:[n.key,n.value],done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return a}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>r;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,n=r.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const n=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const n=r.next,a=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,n)=>{r.push([n,s])}),r}fromJSON(r){this.clear();for(const[s,n]of r)this.set(s,n)}}e.LinkedMap=l;class d extends l{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class g{constructor(r){T.set(this,void 0),it(this,T,r,"f")}get size(){return He(this,T,"f").size}forEach(r,s){He(this,T,"f").forEach(r,s)}get(r){return He(this,T,"f").get(r)}has(r){return He(this,T,"f").has(r)}entries(){return He(this,T,"f").entries()}keys(){return He(this,T,"f").keys()}values(){return He(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return He(this,T,"f").entries()}}e.ReadonlyMapView=g}),define(me[97],ge([0,1,22,8]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Y){return function(ae,ve){for(let Me=0,ze=Y.length;Me<ze;Me++){const Ee=Y[Me](ae,ve);if(Ee)return Ee}return null}}e.or=D,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Y,ae,ve){if(!ve||ve.length<ae.length)return null;let Me;return Y?Me=R.startsWithIgnoreCase(ve,ae):Me=ve.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function T(Y,ae){const ve=ae.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=T;function C(Y,ae){return y(Y.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=C;function y(Y,ae,ve,Me){if(ve===Y.length)return[];if(Me===ae.length)return null;if(Y[ve]===ae[Me]){let ze=null;return(ze=y(Y,ae,ve+1,Me+1))?b({start:Me,end:Me+1},ze):null}return y(Y,ae,ve,Me+1)}function A(Y){return 97<=Y&&Y<=122}function i(Y){return 65<=Y&&Y<=90}e.isUpper=i;function I(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>m.add(Y.charCodeAt(0)));function c(Y){return u(Y)||m.has(Y)}function v(Y,ae){return Y===ae||c(Y)&&c(ae)}function _(Y){return A(Y)||i(Y)||I(Y)}function b(Y,ae){return ae.length===0?ae=[Y]:Y.end===ae[0].start?ae[0].start=Y.start:ae.unshift(Y),ae}function P(Y,ae){for(let ve=ae;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(i(Me)||I(Me)||ve>0&&!_(Y.charCodeAt(ve-1)))return ve}return Y.length}function l(Y,ae,ve,Me){if(ve===Y.length)return[];if(Me===ae.length)return null;if(Y[ve]!==ae[Me].toLowerCase())return null;{let ze=null,Ee=Me+1;for(ze=l(Y,ae,ve+1,Me+1);!ze&&(Ee=P(ae,Ee))<ae.length;)ze=l(Y,ae,ve+1,Ee),Ee++;return ze===null?null:b({start:Me,end:Me+1},ze)}}function d(Y){let ae=0,ve=0,Me=0,ze=0,Ee=0;for(let xe=0;xe<Y.length;xe++)Ee=Y.charCodeAt(xe),i(Ee)&&ae++,A(Ee)&&ve++,_(Ee)&&Me++,I(Ee)&&ze++;const Ye=ae/Y.length,X=ve/Y.length,se=Me/Y.length,he=ze/Y.length;return{upperPercent:Ye,lowerPercent:X,alphaPercent:se,numericPercent:he}}function g(Y){const{upperPercent:ae,lowerPercent:ve}=Y;return ve===0&&ae>.6}function t(Y){const{upperPercent:ae,lowerPercent:ve,alphaPercent:Me,numericPercent:ze}=Y;return ve>.2&&ae<.8&&Me>.6&&ze<.2}function r(Y){let ae=0,ve=0,Me=0,ze=0;for(let Ee=0;Ee<Y.length;Ee++)Me=Y.charCodeAt(Ee),i(Me)&&ae++,A(Me)&&ve++,u(Me)&&ze++;return(ae===0||ve===0)&&ze===0?Y.length<=30:ae<=5}function s(Y,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(Y)||ae.length>60)return null;const ve=d(ae);if(!t(ve)){if(!g(ve))return null;ae=ae.toLowerCase()}let Me=null,ze=0;for(Y=Y.toLowerCase();ze<ae.length&&(Me=l(Y,ae,0,ze))===null;)ze=P(ae,ze+1);return Me}e.matchesCamelCase=s;function n(Y,ae,ve=!1){if(!ae||ae.length===0)return null;let Me=null,ze=0;for(Y=Y.toLowerCase(),ae=ae.toLowerCase();ze<ae.length&&(Me=a(Y,ae,0,ze,ve))===null;)ze=h(ae,ze+1);return Me}e.matchesWords=n;function a(Y,ae,ve,Me,ze){if(ve===Y.length)return[];if(Me===ae.length)return null;if(v(Y.charCodeAt(ve),ae.charCodeAt(Me))){let Ee=null,Ye=Me+1;if(Ee=a(Y,ae,ve+1,Me+1,ze),!ze)for(;!Ee&&(Ye=h(ae,Ye))<ae.length;)Ee=a(Y,ae,ve+1,Ye,ze),Ye++;return Ee===null?null:b({start:Me,end:Me+1},Ee)}else return null}function h(Y,ae){for(let ve=ae;ve<Y.length;ve++)if(c(Y.charCodeAt(ve))||ve>0&&c(Y.charCodeAt(ve-1)))return ve;return Y.length}const f=D(e.matchesPrefix,s,T),w=D(e.matchesPrefix,s,C),E=new p.LRUCache(1e4);function o(Y,ae,ve=!1){if(typeof Y!="string"||typeof ae!="string")return null;let Me=E.get(Y);Me||(Me=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),E.set(Y,Me));const ze=Me.exec(ae);return ze?[{start:ze.index,end:ze.index+ze[0].length}]:ve?w(Y,ae):f(Y,ae)}e.matchesFuzzy=o;function k(Y,ae){const ve=qe(Y,Y.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return ve?N(ve):null}e.matchesFuzzy2=k;function L(Y,ae,ve,Me,ze,Ee){const Ye=Math.min(13,Y.length);for(;ve<Ye;ve++){const X=qe(Y,ae,ve,Me,ze,Ee,!1);if(X)return X}return[0,Ee]}e.anyScore=L;function N(Y){if(typeof Y=="undefined")return[];const ae=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const ze=Y[Me]+ve,Ee=ae[ae.length-1];Ee&&Ee.end===ze?Ee.end=ze+1:ae.push({start:ze,end:ze+1})}return ae}e.createMatches=N;const V=128;function ee(){const Y=[],ae=[];for(let ve=0;ve<=V;ve++)ae[ve]=0;for(let ve=0;ve<=V;ve++)Y.push(ae.slice(0));return Y}function z(Y){const ae=[];for(let ve=0;ve<=Y;ve++)ae[ve]=0;return ae}const M=z(2*V),x=z(2*V),F=ee(),q=ee(),U=ee(),O=!1;function G(Y,ae,ve,Me,ze){function Ee(X,se,he=" "){for(;X.length<se;)X=he+X;return X}let Ye=` |   |${Me.split("").map(X=>Ee(X,3)).join("|")}
`;for(let X=0;X<=ve;X++)X===0?Ye+=" |":Ye+=`${ae[X-1]}|`,Ye+=Y[X].slice(0,ze+1).map(se=>Ee(se.toString(),3)).join("|")+`
`;return Ye}function $(Y,ae,ve,Me){Y=Y.substr(ae),ve=ve.substr(Me),console.log(G(q,Y,Y.length,ve,ve.length)),console.log(G(U,Y,Y.length,ve,ve.length)),console.log(G(F,Y,Y.length,ve,ve.length))}function K(Y,ae){if(ae<0||ae>=Y.length)return!1;const ve=Y.codePointAt(ae);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ve)}}function re(Y,ae){if(ae<0||ae>=Y.length)return!1;switch(Y.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function fe(Y,ae,ve){return ae[Y]!==ve[Y]}function ye(Y,ae,ve,Me,ze,Ee,Ye=!1){for(;ae<ve&&ze<Ee;)Y[ae]===Me[ze]&&(Ye&&(M[ae]=ze),ae+=1),ze+=1;return ae===ve}e.isPatternInWord=ye;var Ie;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(Y){Y.Default=[-100,0];function ae(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=ae})(Le=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,ae,ve,Me,ze,Ee,Ye){const X=Y.length>V?V:Y.length,se=Me.length>V?V:Me.length;if(ve>=X||Ee>=se||X-ve>se-Ee||!ye(ae,ve,X,ze,Ee,se,!0))return;We(X,se,ve,Ee,ae,ze);let he=1,xe=1,Be=ve,et=Ee;const Ce=[!1];for(he=1,Be=ve;Be<X;he++,Be++){const pe=M[Be],be=x[Be],j=Be+1<X?x[Be+1]:se;for(xe=pe-Ee+1,et=pe;et<j;xe++,et++){let we=Number.MIN_SAFE_INTEGER,_e=!1;et<=be&&(we=je(Y,ae,Be,ve,Me,ze,et,se,Ee,F[he-1][xe-1]===0,Ce));let Ae=0;we!==Number.MAX_SAFE_INTEGER&&(_e=!0,Ae=we+q[he-1][xe-1]);const Ue=et>pe,Ge=Ue?q[he][xe-1]+(F[he][xe-1]>0?-5:0):0,Ze=et>pe+1&&F[he][xe-1]>0,Qe=Ze?q[he][xe-2]+(F[he][xe-2]>0?-5:0):0;if(Ze&&(!Ue||Qe>=Ge)&&(!_e||Qe>=Ae))q[he][xe]=Qe,U[he][xe]=3,F[he][xe]=0;else if(Ue&&(!_e||Ge>=Ae))q[he][xe]=Ge,U[he][xe]=2,F[he][xe]=0;else if(_e)q[he][xe]=Ae,U[he][xe]=1,F[he][xe]=F[he-1][xe-1]+1;else throw new Error("not possible")}}if(O&&$(Y,ve,Me,Ee),!Ce[0]&&!Ye)return;he--,xe--;const De=[q[he][xe],Ee];let Te=0,ce=0;for(;he>=1;){let pe=xe;do{const be=U[he][pe];if(be===3)pe=pe-2;else if(be===2)pe=pe-1;else break}while(pe>=1);Te>1&&ae[ve+he-1]===ze[Ee+xe-1]&&!fe(pe+Ee-1,Me,ze)&&Te+1>F[he][pe]&&(pe=xe),pe===xe?Te++:Te=1,ce||(ce=pe),he--,xe=pe-1,De.push(xe)}se===X&&(De[0]+=2);const ue=ce-X;return De[0]-=ue,De}e.fuzzyScore=qe;function We(Y,ae,ve,Me,ze,Ee){let Ye=Y-1,X=ae-1;for(;Ye>=ve&&X>=Me;)ze[Ye]===Ee[X]&&(x[Ye]=X,Ye--),X--}function je(Y,ae,ve,Me,ze,Ee,Ye,X,se,he,xe){if(ae[ve]!==Ee[Ye])return Number.MIN_SAFE_INTEGER;let Be=1,et=!1;return Ye===ve-Me?Be=Y[ve]===ze[Ye]?7:5:fe(Ye,ze,Ee)&&(Ye===0||!fe(Ye-1,ze,Ee))?(Be=Y[ve]===ze[Ye]?7:5,et=!0):K(Ee,Ye)&&(Ye===0||!K(Ee,Ye-1))?Be=5:(K(Ee,Ye-1)||re(Ee,Ye-1))&&(Be=5,et=!0),Be>1&&ve===Me&&(xe[0]=!0),et||(et=fe(Ye,ze,Ee)||K(Ee,Ye-1)||re(Ee,Ye-1)),ve===Me?Ye>se&&(Be-=et?3:5):he?Be+=et?2:0:Be+=et?0:1,Ye+1===X&&(Be-=et?3:5),Be}function W(Y,ae,ve,Me,ze,Ee,Ye){return ne(Y,ae,ve,Me,ze,Ee,!0,Ye)}e.fuzzyScoreGracefulAggressive=W;function Z(Y,ae,ve,Me,ze,Ee,Ye){return ne(Y,ae,ve,Me,ze,Ee,!1,Ye)}e.fuzzyScoreGraceful=Z;function ne(Y,ae,ve,Me,ze,Ee,Ye,X){let se=qe(Y,ae,ve,Me,ze,Ee,X);if(se&&!Ye)return se;if(Y.length>=3){const he=Math.min(7,Y.length-1);for(let xe=ve+1;xe<he;xe++){const Be=le(Y,xe);if(Be){const et=qe(Be,Be.toLowerCase(),ve,Me,ze,Ee,X);et&&(et[0]-=3,(!se||et[0]>se[0])&&(se=et))}}}return se}function le(Y,ae){if(ae+1>=Y.length)return;const ve=Y[ae],Me=Y[ae+1];if(ve!==Me)return Y.slice(0,ae)+Me+ve+Y.slice(ae+2)}}),define(me[141],ge([0,1,45,97,8]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${S.source}`,"g");function C(v){return v.replace(T,(_,b)=>b?_:`\\${_}`)}e.escapeIcons=C;const y=new RegExp(`\\\\${S.source}`,"g");function A(v){return v.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=A;const i=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function I(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(i,(_,b,P,l)=>P?_:b||l||"")}e.stripIcons=I;function u(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:m(v,_)}e.parseLabelWithIcons=u;function m(v,_){const b=[];let P="";function l(h){if(h){P+=h;for(const f of h)b.push(t)}}let d=-1,g="",t=0,r,s,n=_;const a=v.length;for(l(v.substr(0,_));n<a;)r=v[n],s=v[n+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(d=n,l(g),g=e.iconStartMarker,n++):r===")"&&d!==-1?(t+=n-d+1,d=-1,g=""):d!==-1?/^[a-z0-9\-]$/i.test(r)?g+=r:(l(g),d=-1,g=""):l(r),n++;return l(g),{text:P,iconOffsets:b}}function c(v,_,b=!1){const{text:P,iconOffsets:l}=_;if(!l||l.length===0)return(0,R.matchesFuzzy)(v,P,b);const d=(0,D.ltrim)(P," "),g=P.length-d.length,t=(0,R.matchesFuzzy)(v,d,b);if(t)for(const r of t){const s=l[r.start+g]+g;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=c}),define(me[98],ge([0,1,141,15]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(m="",c=!1){if(this.value=m,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1)}appendText(m,c=0){return this.value+=A(this.supportThemeIcons?(0,p.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,c){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=S;function T(u){return C(u)?!u.value:Array.isArray(u)?u.every(T):!0}e.isEmptyMarkdownString=T;function C(u){return u instanceof S?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function y(u,m){return u===m?!0:!u||!m?!1:u.value===m.value&&u.isTrusted===m.isTrusted&&u.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=y;function A(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function i(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(u){const m=[],c=u.split("|").map(_=>_.trim());u=c[0];const v=c[1];if(v){const _=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),P=_?_[1]:"",l=b?b[1]:"",d=isFinite(parseInt(l)),g=isFinite(parseInt(P));d&&m.push(`width="${l}"`),g&&m.push(`height="${P}"`)}return{href:u,dimensions:m}}e.parseHrefAndDimensions=I}),define(me[59],ge([0,1,23,8,2]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,y)}e.stringify=S;function T(i){let I=JSON.parse(i);return I=A(I),I}e.parse=T;var C;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function y(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function A(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let u=0;u<i.length;++u)i[u]=A(i[u],I+1);else for(const u in i)Object.hasOwnProperty.call(i,u)&&(i[u]=A(i[u],I+1))}return i}e.revive=A}),define(me[10],ge([0,1,2,11]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,A,i){this._hosts[y]=A,this._ports[y]=i}setConnectionToken(y,A){this._connectionTokens[y]=A}rewrite(y){if(this._delegate)return this._delegate(y);const A=y.authority;let i=this._hosts[A];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[A],u=this._connectionTokens[A];let m=`path=${encodeURIComponent(y.path)}`;return typeof u=="string"&&(m+=`&tkn=${encodeURIComponent(u)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new S;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,A,i){const I=this.toUri(y,A);if(I.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let u=!1;return R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&I.scheme===D.file&&(u=!0),I.scheme===D.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(u=!0),u?I.with({scheme:D.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(y,A){const i=this.toUri(y,A);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,A){return p.URI.isUri(y)?y:p.URI.parse(A.toUrl(y))}}e.FileAccess=new T}),define(me[76],ge([0,1,22]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new p.LRUCache(1e4);function D(A){return y(A,"NFC",R)}e.normalizeNFC=D;const S=new p.LRUCache(1e4);function T(A){return y(A,"NFD",S)}e.normalizeNFD=T;const C=/[^\u0000-\u0080]/;function y(A,i,I){if(!A)return A;const u=I.get(A);if(u)return u;let m;return C.test(A)?m=A.normalize(i):m=A,I.set(A,m),m}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(i){return T(i).replace(A,"")}}()}),define(me[24],ge([0,1,29,9,2,8,10,11]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,D.uriToFsPath)(m,!0)}e.originalFSPath=y;class A{constructor(c){this._ignorePathCasing=c}compare(c,v,_=!1){return c===v?0:(0,S.compare)(this.getComparisonKey(c,_),this.getComparisonKey(v,_))}isEqual(c,v,_=!1){return c===v?!0:!c||!v?!1:this.getComparisonKey(c,_)===this.getComparisonKey(v,_)}getComparisonKey(c,v=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,v,_=!1){if(c.scheme===v.scheme){if(c.scheme===T.Schemas.file)return p.isEqualOrParent(y(c),y(v),this._ignorePathCasing(c))&&c.query===v.query&&(_||c.fragment===v.fragment);if((0,e.isEqualAuthority)(c.authority,v.authority))return p.isEqualOrParent(c.path,v.path,this._ignorePathCasing(c),"/")&&c.query===v.query&&(_||c.fragment===v.fragment)}return!1}joinPath(c,...v){return D.URI.joinPath(c,...v)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let v;return c.scheme===T.Schemas.file?v=D.URI.file(R.dirname(y(c))).path:(v=R.posix.dirname(c.path),c.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),v="/")),c.with({path:v})}normalizePath(c){if(!c.path.length)return c;let v;return c.scheme===T.Schemas.file?v=D.URI.file(R.normalize(y(c))).path:v=R.posix.normalize(c.path),c.with({path:v})}relativePath(c,v){if(c.scheme!==v.scheme||!(0,e.isEqualAuthority)(c.authority,v.authority))return;if(c.scheme===T.Schemas.file){const P=R.relative(y(c),y(v));return C.isWindows?p.toSlashes(P):P}let _=c.path||"/",b=v.path||"/";if(this._ignorePathCasing(c)){let P=0;for(const l=Math.min(_.length,b.length);P<l&&!(_.charCodeAt(P)!==b.charCodeAt(P)&&_.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);_=b.substr(0,P)+_.substr(P)}return R.posix.relative(_,b)}resolvePath(c,v){if(c.scheme===T.Schemas.file){const _=D.URI.file(R.resolve(y(c),v));return c.with({authority:_.authority,path:_.path})}return v=p.toPosixPath(v),c.with({path:R.posix.resolve(c.path,v)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,v){return c===v||(0,S.equalsIgnoreCase)(c,v)}hasTrailingPathSeparator(c,v=R.sep){if(c.scheme===T.Schemas.file){const _=y(c);return _.length>p.getRoot(_).length&&_[_.length-1]===v}else{const _=c.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,v=R.sep){return(0,e.hasTrailingPathSeparator)(c,v)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,v=R.sep){let _=!1;if(c.scheme===T.Schemas.file){const b=y(c);_=b!==void 0&&b.length===p.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=c.path;_=b.length===1&&b.charCodeAt(b.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(c,v)?c.with({path:c.path+"/"}):c}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(m=>m.scheme===T.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new A(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,c){const v=[];for(let _=0;_<m.length;_++){const b=c(m[_]);m.some((P,l)=>l===_?!1:(0,e.isEqualOrParent)(b,c(P)))||v.push(m[_])}return v}e.distinctParents=i;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function c(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[d,g]=l.split(":");d&&g&&_.set(d,g)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&_.set(m.META_DATA_MIME,P),_}m.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function u(m,c,v){if(c){let _=m.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),m.with({scheme:v,authority:c,path:_})}return m.with({scheme:v})}e.toLocalResource=u}),define(me[16],ge([0,1,21,15,3,6,24]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(x){return!!x&&typeof x.then=="function"}e.isThenable=C;function y(x){const F=new p.CancellationTokenSource,q=x(F.token),U=new Promise((O,G)=>{const $=F.token.onCancellationRequested(()=>{$.dispose(),F.dispose(),G((0,R.canceled)())});Promise.resolve(q).then(K=>{$.dispose(),F.dispose(),O(K)},K=>{$.dispose(),F.dispose(),G(K)})});return new class{cancel(){F.cancel()}then(O,G){return U.then(O,G)}catch(O){return this.then(void 0,O)}finally(O){return U.finally(O)}}}e.createCancelablePromise=y;function A(x,F,q){return Promise.race([x,new Promise(U=>F.onCancellationRequested(()=>U(q)))])}e.raceCancellation=A;async function i(x){let F=-1;const q=x.map((O,G)=>O.then($=>(F=G,$))),U=await Promise.race(q);return x.forEach((O,G)=>{G!==F&&O.cancel()}),U}e.raceCancellablePromises=i;function I(x,F,q){let U;const O=setTimeout(()=>{U?.(void 0),q?.()},F);return Promise.race([x.finally(()=>clearTimeout(O)),new Promise(G=>U=G)])}e.raceTimeout=I;function u(x){return new Promise((F,q)=>{const U=x();C(U)?U.then(F,q):F(U)})}e.asPromise=u;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(q,q).then(U)})}return new Promise((q,U)=>{this.queuedPromise.then(q,U)})}return this.activePromise=F(),new Promise((q,U)=>{this.activePromise.then(O=>{this.activePromise=null,q(O)},O=>{this.activePromise=null,U(O)})})}}e.Throttler=m;class c{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=c;class v{constructor(){this.promiseMap=new Map}queue(F,q){const O=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(F)===O&&this.promiseMap.delete(F)});return this.promiseMap.set(F,O),O}}e.SequencerByKey=v;class _{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,q=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,O)=>{this.doResolve=U,this.doReject=O}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class b{constructor(F){this.delayer=new _(F),this.throttler=new m}trigger(F,q){return this.delayer.trigger(()=>this.throttler.queue(F),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class P{constructor(){this._isOpen=!1,this._promise=new Promise((F,q)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class l extends P{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function d(x,F){return F?new Promise((q,U)=>{const O=setTimeout(()=>{G.dispose(),q()},x),G=F.onCancellationRequested(()=>{clearTimeout(O),G.dispose(),U((0,R.canceled)())})}):y(q=>d(x,q))}e.timeout=d;function g(x,F=0){const q=setTimeout(x,F);return(0,S.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=g;function t(x){const F=[];let q=0;const U=x.length;function O(){return q<U?x[q++]():null}function G($){$!=null&&F.push($);const K=O();return K?K.then(G):Promise.resolve(F)}return Promise.resolve(null).then(G)}e.sequence=t;function r(x,F=U=>!!U,q=null){let U=0;const O=x.length,G=()=>{if(U>=O)return Promise.resolve(q);const $=x[U++];return Promise.resolve($()).then(re=>F(re)?Promise.resolve(re):G())};return G()}e.first=r;function s(x,F=U=>!!U,q=null){if(x.length===0)return Promise.resolve(q);let U=x.length;const O=()=>{U=-1;for(const G of x)G.cancel?.()};return new Promise((G,$)=>{for(const K of x)K.then(re=>{--U>=0&&F(re)?(O(),G(re)):U===0&&G(q)}).catch(re=>{--U>=0&&(O(),$(re))})})}e.firstParallel=s;class n{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((q,U)=>{this.outstandingPromises.push({factory:F,c:q,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const q=F.factory();q.then(F.c,F.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class h{constructor(){this.queues=new Map}queueFor(F,q=T.extUri){const U=q.getComparisonKey(F);let O=this.queues.get(U);return O||(O=new a,D.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(U)}),this.queues.set(U,O)),O}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=h;class f{constructor(F,q){this._token=-1,typeof F=="function"&&typeof q=="number"&&this.setIfNotSet(F,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},q)}setIfNotSet(F,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},q))}}e.TimeoutTimer=f;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,q){this.cancel(),this._token=setInterval(()=>{F()},q)}}e.IntervalTimer=w;class E{constructor(F,q){this.timeoutToken=-1,this.runner=F,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class o extends E{constructor(F,q){super(F,q);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class k extends S.Disposable{constructor(F,q,U,O){super();this.maxWorkChunkSize=F,this.maxPendingWork=q,this.throttleDelay=U,this.handler=O,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const q=setTimeout(()=>F(x));let U=!1;return{dispose(){U||(U=!0,clearTimeout(q))}}}}else e.runWhenIdle=(x,F)=>{const q=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(q))}}}}();class L{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=L;async function N(x,F,q){let U;for(let O=0;O<q;O++)try{return await x()}catch(G){U=G,await d(F)}throw U}e.retry=N;class V{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,q,U){return this._pending={taskId:F,cancel:()=>U?.(),promise:q},q.then(()=>this.donePending(F),()=>this.donePending(F)),q}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let q,U;const O=new Promise((G,$)=>{q=G,U=$});this._next={run:F,promise:O,promiseResolve:q,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=V;class ee{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,q)=>{this.completeCallback=F,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(q=>{this.completeCallback(F),this.resolved=!0,q()})}error(F){return new Promise(q=>{this.errorCallback(F),this.rejected=!0,q()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=z;var M;(function(x){async function F(q){let U;const O=await Promise.all(q.map(G=>G.then($=>$,$=>{U||(U=$)})));if(typeof U!="undefined")throw U;return O}x.settled=F})(M=e.Promises||(e.Promises={}))}),define(me[99],ge([0,1,9,16]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new R.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),S=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(E,o,k=!1){const L=E||"",N=o||"",V=D.value.collator.compare(L,N);return D.value.collatorIsNumeric&&V===0&&L!==N?L<N?-1:1:V}e.compareFileNames=C;function y(E,o){const k=S.value.collator;return E=E||"",o=o||"",g(k,E,o)}e.compareFileNamesDefault=y;function A(E,o){const k=S.value.collator;return E=E||"",o=o||"",n(E,o)||g(k,E,o)}e.compareFileNamesUpper=A;function i(E,o){const k=S.value.collator;return E=E||"",o=o||"",s(E,o)||g(k,E,o)}e.compareFileNamesLower=i;function I(E,o){return E=E||"",o=o||"",E===o?0:E<o?-1:1}e.compareFileNamesUnicode=I;function u(E,o,k=!1){k||(E=E&&E.toLowerCase(),o=o&&o.toLowerCase());const[L,N]=l(E),[V,ee]=l(o);return L!==V?L<V?-1:1:N===ee?0:N<ee?-1:1}e.noIntlCompareFileNames=u;function m(E,o){const[k,L]=l(E),[N,V]=l(o);let ee=D.value.collator.compare(L,V);if(ee===0){if(D.value.collatorIsNumeric&&L!==V)return L<V?-1:1;if(ee=D.value.collator.compare(k,N),D.value.collatorIsNumeric&&ee===0&&k!==N)return k<N?-1:1}return ee}e.compareFileExtensions=m;function c(E,o){E=E||"",o=o||"";const k=d(E),L=d(o),N=S.value.collator,V=T.value.collator;return g(V,k,L)||g(N,E,o)}e.compareFileExtensionsDefault=c;function v(E,o){E=E||"",o=o||"";const k=d(E),L=d(o),N=S.value.collator,V=T.value.collator;return g(V,k,L)||n(E,o)||g(N,E,o)}e.compareFileExtensionsUpper=v;function _(E,o){E=E||"",o=o||"";const k=d(E),L=d(o),N=S.value.collator,V=T.value.collator;return g(V,k,L)||s(E,o)||g(N,E,o)}e.compareFileExtensionsLower=_;function b(E,o){E=E||"",o=o||"";const k=d(E).toLowerCase(),L=d(o).toLowerCase();return k!==L?k<L?-1:1:E!==o?E<o?-1:1:0}e.compareFileExtensionsUnicode=b;const P=/^(.*?)(\.([^.]*))?$/;function l(E,o=!1){const k=E?P.exec(E):[];let L=[k&&k[1]||"",k&&k[3]||""];return o&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function d(E){const o=E?P.exec(E):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function g(E,o,k){let L=E.compare(o,k);return L!==0?L:o.length!==k.length?o.length<k.length?-1:1:0}function t(E){const o=E.charAt(0);return o.toLocaleUpperCase()!==o}function r(E){const o=E.charAt(0);return o.toLocaleLowerCase()!==o}function s(E,o){return t(E)&&r(o)?-1:r(E)&&t(o)?1:0}function n(E,o){return r(E)&&t(o)?-1:t(E)&&r(o)?1:0}function a(E,o,k=!1){return k||(E=E&&E.toLowerCase(),o=o&&o.toLowerCase()),E===o?0:E<o?-1:1}function h(E,o,k=!1){const L=E.split(p.sep),N=o.split(p.sep),V=L.length-1,ee=N.length-1;let z,M;for(let x=0;;x++){if(z=V===x,M=ee===x,z&&M)return C(L[x],N[x],k);if(z)return-1;if(M)return 1;const F=a(L[x],N[x],k);if(F!==0)return F}}e.comparePaths=h;function f(E,o,k){const L=E.toLowerCase(),N=o.toLowerCase(),V=w(E,o,k);if(V)return V;const ee=L.endsWith(k),z=N.endsWith(k);if(ee!==z)return ee?-1:1;const M=C(L,N);return M!==0?M:L.localeCompare(N)}e.compareAnything=f;function w(E,o,k){const L=E.toLowerCase(),N=o.toLowerCase(),V=L.startsWith(k),ee=N.startsWith(k);if(V!==ee)return V?-1:1;if(V&&ee){if(L.length<N.length)return-1;if(L.length>N.length)return 1}return 0}e.compareByPrefix=w}),define(me[100],ge([0,1,99,97,9,11,8]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,y=[C,[]];function A(z,M,x,F){if(!z||!M)return y;const q=z.length,U=M.length;if(q<U)return y;const O=z.toLowerCase();return!F&&!O.includes(x)?y:i(M,x,U,z,O,q)}e.scoreFuzzy=A;function i(z,M,x,F,q,U){const O=[],G=[];for(let fe=0;fe<x;fe++){const ye=fe*U,Ie=ye-U,Le=fe>0,qe=z[fe],We=M[fe];for(let je=0;je<U;je++){const W=je>0,Z=ye+je,ne=Z-1,le=Ie+je-1,Y=W?O[ne]:0,ae=Le&&W?O[le]:0,ve=Le&&W?G[le]:0;let Me;!ae&&Le?Me=0:Me=I(qe,We,F,q,je,ve),Me&&ae+Me>=Y?(G[Z]=ve+1,O[Z]=ae+Me):(G[Z]=C,O[Z]=Y)}}const $=[];let K=x-1,re=U-1;for(;K>=0&&re>=0;){const fe=K*U+re;G[fe]===C||($.push(re),K--),re--}return[O[x*U-1],$.reverse()]}function I(z,M,x,F,q,U){let O=0;if(!u(M,F[q]))return O;if(O+=1,U>0&&(O+=U*5),z===x[q]&&(O+=1),q===0)O+=8;else{const G=m(x.charCodeAt(q-1));G?O+=G:(0,R.isUpper)(x.charCodeAt(q))&&(O+=2)}return O}function u(z,M){return z===M?!0:z==="/"||z==="\\"?M==="/"||M==="\\":!1}function m(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function v(z,M,x=0,F=0){const q=M;return q.values&&q.values.length>1?_(z,q.values,x,F):b(z,M,x,F)}e.scoreFuzzy2=v;function _(z,M,x,F){let q=0;const U=[];for(const O of M){const[G,$]=b(z,O,x,F);if(typeof G!="number")return c;q+=G,U.push(...$)}return[q,h(U)]}function b(z,M,x,F){const q=(0,R.fuzzyScore)(M.original,M.originalLowercase,x,z,z.toLowerCase(),F,!0);return q?[q[0],(0,R.createMatches)(q)]:c}const P=Object.freeze({score:0}),l=1<<18,d=1<<17,g=1<<16;function t(z,M,x,F,q){if(!z||!M.normalized)return P;const U=F.getItemLabel(z);if(!U)return P;const O=F.getItemDescription(z);let G;O?G=`${U}${O}${M.normalized}${Array.isArray(M.values)?M.values.length:""}${x}`:G=`${U}${M.normalized}${Array.isArray(M.values)?M.values.length:""}${x}`;const $=q[G];if($)return $;const K=r(U,O,F.getItemPath(z),M,x);return q[G]=K,K}e.scoreItemFuzzy=t;function r(z,M,x,F,q){const U=!x||!F.containsPathSeparator;return x&&(S.isLinux?F.pathNormalized===x:(0,T.equalsIgnoreCase)(F.pathNormalized,x))?{score:l,labelMatch:[{start:0,end:z.length}],descriptionMatch:M?[{start:0,end:M.length}]:void 0}:F.values&&F.values.length>1?s(z,M,x,F.values,U,q):n(z,M,x,F,U,q)}function s(z,M,x,F,q,U){let O=0;const G=[],$=[];for(const K of F){const{score:re,labelMatch:fe,descriptionMatch:ye}=n(z,M,x,K,q,U);if(re===C)return P;O+=re,fe&&G.push(...fe),ye&&$.push(...ye)}return{score:O,labelMatch:h(G),descriptionMatch:h($)}}function n(z,M,x,F,q,U){if(q||!M){const[O,G]=A(z,F.normalized,F.normalizedLowercase,U);if(O){const $=(0,R.matchesPrefix)(F.normalized,z);let K;return $?(K=d,K+=Math.round(F.normalized.length/z.length*100)):K=g,{score:K+O,labelMatch:$||a(G)}}}if(M){let O=M;x&&(O=`${M}${D.sep}`);const G=O.length,$=`${O}${z}`,[K,re]=A($,F.normalized,F.normalizedLowercase,U);if(K){const fe=a(re),ye=[],Ie=[];return fe.forEach(Le=>{Le.start<G&&Le.end>G?(ye.push({start:0,end:Le.end-G}),Ie.push({start:Le.start,end:G})):Le.start>=G?ye.push({start:Le.start-G,end:Le.end-G}):Ie.push(Le)}),{score:K,labelMatch:ye,descriptionMatch:Ie}}}return P}function a(z){const M=[];if(!z)return M;let x;for(const F of z)x&&x.end===F?x.end+=1:(x={start:F,end:F+1},M.push(x));return M}function h(z){const M=z.sort((q,U)=>q.start-U.start),x=[];let F;for(const q of M)!F||!f(F,q)?(F=q,x.push(q)):(F.start=Math.min(F.start,q.start),F.end=Math.max(F.end,q.end));return x}function f(z,M){return!(z.end<M.start||M.end<z.start)}function w(z,M,x,F,q,U){const O=t(z,x,F,q,U),G=t(M,x,F,q,U),$=O.score,K=G.score;if(($===l||K===l)&&$!==K)return $===l?-1:1;if($>g||K>g){if($!==K)return $>K?-1:1;if($<d&&K<d){const We=o(O.labelMatch,G.labelMatch);if(We!==0)return We}const Le=q.getItemLabel(z)||"",qe=q.getItemLabel(M)||"";if(Le.length!==qe.length)return Le.length-qe.length}if($!==K)return $>K?-1:1;const re=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,fe=Array.isArray(G.labelMatch)&&G.labelMatch.length>0;if(re&&!fe)return-1;if(fe&&!re)return 1;const ye=E(z,O,q),Ie=E(M,G,q);return ye&&Ie&&ye!==Ie?Ie>ye?-1:1:k(z,M,x,q)}e.compareItemsByFuzzyScore=w;function E(z,M,x){let F=-1,q=-1;if(M.descriptionMatch&&M.descriptionMatch.length?F=M.descriptionMatch[0].start:M.labelMatch&&M.labelMatch.length&&(F=M.labelMatch[0].start),M.labelMatch&&M.labelMatch.length){if(q=M.labelMatch[M.labelMatch.length-1].end,M.descriptionMatch&&M.descriptionMatch.length){const U=x.getItemDescription(z);U&&(q+=U.length)}}else M.descriptionMatch&&M.descriptionMatch.length&&(q=M.descriptionMatch[M.descriptionMatch.length-1].end);return q-F}function o(z,M){if(!z&&!M||(!z||!z.length)&&(!M||!M.length))return 0;if(!M||!M.length)return-1;if(!z||!z.length)return 1;const x=z[0].start,q=z[z.length-1].end-x,U=M[0].start,G=M[M.length-1].end-U;return q===G?0:G<q?1:-1}function k(z,M,x,F){const q=F.getItemLabel(z)||"",U=F.getItemLabel(M)||"",O=F.getItemDescription(z),G=F.getItemDescription(M),$=q.length+(O?O.length:0),K=U.length+(G?G.length:0);if($!==K)return $-K;const re=F.getItemPath(z),fe=F.getItemPath(M);return re&&fe&&re.length!==fe.length?re.length-fe.length:q!==U?(0,p.compareAnything)(q,U,x.normalized):O&&G&&O!==G?(0,p.compareAnything)(O,G,x.normalized):re&&fe&&re!==fe?(0,p.compareAnything)(re,fe,x.normalized):0}const L=" ";function N(z){typeof z!="string"&&(z="");const M=z.toLowerCase(),{pathNormalized:x,normalized:F,normalizedLowercase:q}=V(z),U=x.indexOf(D.sep)>=0;let O;const G=z.split(L);if(G.length>1)for(const $ of G){const{pathNormalized:K,normalized:re,normalizedLowercase:fe}=V($);re&&(O||(O=[]),O.push({original:$,originalLowercase:$.toLowerCase(),pathNormalized:K,normalized:re,normalizedLowercase:fe}))}return{original:z,originalLowercase:M,pathNormalized:x,normalized:F,normalizedLowercase:q,values:O,containsPathSeparator:U}}e.prepareQuery=N;function V(z){let M;S.isWindows?M=z.replace(/\//g,D.sep):M=z.replace(/\\/g,D.sep);const x=(0,T.stripWildcards)(M).replace(/\s/g,"");return{pathNormalized:M,normalized:x,normalizedLowercase:x.toLowerCase()}}function ee(z){return Array.isArray(z)?N(z.map(M=>M.original).join(L)):N(z.original)}e.pieceToQuery=ee}),define(me[30],ge([0,1,8,29,9,22,16]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const y="**",A="/",i="[/\\\\]",I="[^/\\\\]",u=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function c(O,G){if(!O)return[];const $=[];let K=!1,re=!1,fe="";for(const ye of O){switch(ye){case G:if(!K&&!re){$.push(fe),fe="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":re=!0;break;case"]":re=!1;break}fe+=ye}return fe&&$.push(fe),$}e.splitGlobAware=c;function v(O){if(!O)return"";let G="";const $=c(O,A);if($.every(K=>K===y))G=".*";else{let K=!1;$.forEach((re,fe)=>{if(re===y){K||(G+=m(2),K=!0);return}let ye=!1,Ie="",Le=!1,qe="";for(const We of re){if(We!=="}"&&ye){Ie+=We;continue}if(Le&&(We!=="]"||!qe)){let je;We==="-"?je=We:(We==="^"||We==="!")&&!qe?je="^":We===A?je="":je=p.escapeRegExpCharacters(We),qe+=je;continue}switch(We){case"{":ye=!0;continue;case"[":Le=!0;continue;case"}":G+=`(?:${c(Ie,",").map(Z=>v(Z)).join("|")})`,ye=!1,Ie="";break;case"]":G+="["+qe+"]",Le=!1,qe="";break;case"?":G+=I;continue;case"*":G+=m(1);continue;default:G+=p.escapeRegExpCharacters(We)}}fe<$.length-1&&($[fe+1]!==y||fe+2<$.length)&&(G+=i),K=!1})}return G}const _=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function n(O,G){if(!O)return s;let $;typeof O!="string"?$=O.pattern:$=O,$=$.trim();const K=`${$}_${!!G.trimForExclusions}`;let re=t.get(K);if(re)return a(re,O);let fe;if(_.test($)){const ye=$.substr(4);re=function(Ie,Le){return typeof Ie=="string"&&Ie.endsWith(ye)?$:null}}else(fe=b.exec(h($,G)))?re=f(fe[1],$):(G.trimForExclusions?l:P).test($)?re=w($,G):(fe=d.exec(h($,G)))?re=E(fe[1].substr(1),$,!0):(fe=g.exec(h($,G)))?re=E(fe[1],$,!1):re=o($);return t.set(K,re),a(re,O)}function a(O,G){return typeof G=="string"?O:function($,K){return R.isEqualOrParent($,G.base)?O(D.relative(G.base,$),K):null}}function h(O,G){return G.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function f(O,G){const $=`/${O}`,K=`\\${O}`,re=function(ye,Ie){return typeof ye!="string"?null:Ie?Ie===O?G:null:ye===O||ye.endsWith($)||ye.endsWith(K)?G:null},fe=[O];return re.basenames=fe,re.patterns=[G],re.allBasenames=fe,re}function w(O,G){const $=U(O.slice(1,-1).split(",").map(Ie=>n(Ie,G)).filter(Ie=>Ie!==s),O),K=$.length;if(!K)return s;if(K===1)return $[0];const re=function(Ie,Le){for(let qe=0,We=$.length;qe<We;qe++)if($[qe](Ie,Le))return O;return null},fe=$.find(Ie=>!!Ie.allBasenames);fe&&(re.allBasenames=fe.allBasenames);const ye=$.reduce((Ie,Le)=>Le.allPaths?Ie.concat(Le.allPaths):Ie,[]);return ye.length&&(re.allPaths=ye),re}function E(O,G,$){const K=D.sep===D.posix.sep,re=K?O:O.replace(u,D.sep),fe=D.sep+re,ye=D.posix.sep+O,Ie=$?function(Le,qe){return typeof Le=="string"&&(Le===re||Le.endsWith(fe)||!K&&(Le===O||Le.endsWith(ye)))?G:null}:function(Le,qe){return typeof Le=="string"&&(Le===re||!K&&Le===O)?G:null};return Ie.allPaths=[($?"*/":"./")+O],Ie}function o(O){try{const G=new RegExp(`^${v(O)}$`);return function($){return G.lastIndex=0,typeof $=="string"&&G.test($)?O:null}}catch(G){return s}}function k(O,G,$){return!O||typeof G!="string"?!1:L(O)(G,void 0,$)}e.match=k;function L(O,G={}){if(!O)return r;if(typeof O=="string"||z(O)){const $=n(O,G);if($===s)return r;const K=function(re,fe){return!!$(re,fe)};return $.allBasenames&&(K.allBasenames=$.allBasenames),$.allPaths&&(K.allPaths=$.allPaths),K}return F(O,G)}e.parse=L;function N(O){if(!O)return;let G;return $=>(G||(G=(O()||Promise.resolve([])).then(K=>K?ee(K):{})),G.then(K=>!!K[$]))}e.hasSiblingPromiseFn=N;function V(O){if(!O)return;let G;return $=>{if(!G){const K=O();G=K?ee(K):{}}return!!G[$]}}e.hasSiblingFn=V;function ee(O){const G={};for(const $ of O)G[$]=!0;return G}function z(O){const G=O;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function x(O){return O.allPaths||[]}e.getPathTerms=x;function F(O,G){const $=U(Object.getOwnPropertyNames(O).map(Ie=>q(Ie,O[Ie],G)).filter(Ie=>Ie!==s)),K=$.length;if(!K)return s;if(!$.some(Ie=>!!Ie.requiresSiblings)){if(K===1)return $[0];const Ie=function(We,je){for(let W=0,Z=$.length;W<Z;W++){const ne=$[W](We,je);if(ne)return ne}return null},Le=$.find(We=>!!We.allBasenames);Le&&(Ie.allBasenames=Le.allBasenames);const qe=$.reduce((We,je)=>je.allPaths?We.concat(je.allPaths):We,[]);return qe.length&&(Ie.allPaths=qe),Ie}const re=function(Ie,Le,qe){let We;for(let je=0,W=$.length;je<W;je++){const Z=$[je];Z.requiresSiblings&&qe&&(Le||(Le=D.basename(Ie)),We||(We=Le.substr(0,Le.length-D.extname(Ie).length)));const ne=Z(Ie,Le,We,qe);if(ne)return ne}return null},fe=$.find(Ie=>!!Ie.allBasenames);fe&&(re.allBasenames=fe.allBasenames);const ye=$.reduce((Ie,Le)=>Le.allPaths?Ie.concat(Le.allPaths):Ie,[]);return ye.length&&(re.allPaths=ye),re}function q(O,G,$){if(G===!1)return s;const K=n(O,$);if(K===s)return s;if(typeof G=="boolean")return K;if(G){const re=G.when;if(typeof re=="string"){const fe=(ye,Ie,Le,qe)=>{if(!qe||!K(ye,Ie))return null;const We=re.replace("$(basename)",Le),je=qe(We);return(0,T.isThenable)(je)?je.then(W=>W?O:null):je?O:null};return fe.requiresSiblings=!0,fe}}return K}function U(O,G){const $=O.filter(Ie=>!!Ie.basenames);if($.length<2)return O;const K=$.reduce((Ie,Le)=>{const qe=Le.basenames;return qe?Ie.concat(qe):Ie},[]);let re;if(G){re=[];for(let Ie=0,Le=K.length;Ie<Le;Ie++)re.push(G)}else re=$.reduce((Ie,Le)=>{const qe=Le.patterns;return qe?Ie.concat(qe):Ie},[]);const fe=function(Ie,Le){if(typeof Ie!="string")return null;if(!Le){let We;for(We=Ie.length;We>0;We--){const je=Ie.charCodeAt(We-1);if(je===47||je===92)break}Le=Ie.substr(We)}const qe=K.indexOf(Le);return qe!==-1?re[qe]:null};fe.basenames=K,fe.patterns=re,fe.allBasenames=K;const ye=O.filter(Ie=>!Ie.basenames);return ye.push(fe),ye}}),define(me[77],ge([0,1,2,9,8,10,11,24,29]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,a,h){if(typeof n=="string"&&(n=p.URI.file(n)),h){const w=h.getWorkspaceFolder(n);if(w){const E=h.getWorkspace().folders.length>1;let o;if((0,C.isEqual)(w.uri,n)?o="":o=(0,C.relativePath)(w.uri,n),E){const k=w.name?w.name:(0,C.basename)(w.uri);o=o?k+" \u2022 "+o:k}return o}}if(n.scheme!==S.Schemas.file&&n.scheme!==S.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(n.fsPath))return(0,R.normalize)(I(n.fsPath));let f=(0,R.normalize)(n.fsPath);return!T.isWindows&&a?.userHome&&(f=m(f,a.userHome.fsPath)),f}e.getPathLabel=A;function i(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const a=(0,C.basename)(n)||(n.scheme===S.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,y.isRootOrDriveLetter)(a)?I(a):a}e.getBaseLabel=i;function I(n){return(0,y.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let u=Object.create(null);function m(n,a){if(T.isWindows||!n||!a)return n;let h=u.original===a?u.normalized:void 0;return h||(h=`${(0,D.rtrim)(a,R.posix.sep)}${R.posix.sep}`,u={original:a,normalized:h}),(T.isLinux?n.startsWith(h):(0,D.startsWithIgnoreCase)(n,h))&&(n=`~/${n.substr(h.length)}`),n}e.tildify=m;function c(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=c;const v="\u2026",_="\\\\",b="~";function P(n,a=R.sep){const h=new Array(n.length);let f=!1;for(let w=0;w<n.length;w++){let E=n[w];if(E===""){h[w]=`.${a}`;continue}if(!E){h[w]=E;continue}f=!0;let o="";E.indexOf(_)===0?(o=E.substr(0,E.indexOf(_)+_.length),E=E.substr(E.indexOf(_)+_.length)):E.indexOf(a)===0?(o=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(b)===0&&(o=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const k=E.split(a);for(let L=1;f&&L<=k.length;L++)for(let N=k.length-L;f&&N>=0;N--){f=!1;let V=k.slice(N,N+L).join(a);for(let ee=0;!f&&ee<n.length;ee++)if(ee!==w&&n[ee]&&n[ee].indexOf(V)>-1){const z=N+L===k.length,M=N>0&&n[ee].indexOf(a)>-1?a+V:V,x=n[ee].endsWith(M);f=!z||x}if(!f){let ee="";(k[0].endsWith(":")||o!=="")&&(N===1&&(N=0,L++,V=k[0]+a+V),N>0&&(ee=k[0]+a),ee=o+ee),N>0&&(ee=ee+v+a),ee=ee+V,N+L<k.length&&(ee=ee+a+v),h[w]=ee}}f&&(h[w]=E)}return h}e.shorten=P;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function d(n,a=Object.create(null)){const h=[];let f=!1,w="";for(const E of n)if(E==="$"||f&&E==="{")w&&h.push({value:w,type:l.TEXT}),w="",f=!0;else if(E==="}"&&f){const o=a[w];if(typeof o=="string")o.length&&h.push({value:o,type:l.VARIABLE});else if(o){const k=h[h.length-1];(!k||k.type!==l.SEPARATOR)&&h.push({value:o.label,type:l.SEPARATOR})}w="",f=!1}else w+=E;return w&&!f&&h.push({value:w,type:l.TEXT}),h.filter((E,o)=>{if(E.type===l.SEPARATOR){const k=h[o-1],L=h[o+1];return[k,L].every(N=>N&&(N.type===l.VARIABLE||N.type===l.TEXT)&&N.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=d;function g(n,a){return T.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(n,a){return T.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(n){const a=n.indexOf("/")!==-1?R.posix:R.win32,h=a.basename(n),f=a.dirname(n);return h.length?{name:h,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(me[101],ge([0,1,9,8,30,10,24]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let y=[],A=[],i=[];function I(r,s=!1){const n=u(r);y.push(n),n.userConfigured?i.push(n):A.push(n),s&&!n.userConfigured&&y.forEach(a=>{a.mime===n.mime||a.userConfigured||(n.extension&&a.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&a.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&a.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&a.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=I;function u(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(p.posix.sep)>=0:!1}}function m(r){r?(y=y.filter(s=>!s.userConfigured),i=[]):(y=[],A=[],i=[])}e.clearTextMimes=m;function c(r,s){let n;if(r)switch(r.scheme){case S.Schemas.file:n=r.fsPath;break;case S.Schemas.data:n=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:n=r.path}if(!n)return[C.unknown];n=n.toLowerCase();const a=(0,p.basename)(n),h=v(n,a,i);if(h)return[h,C.text];const f=v(n,a,A);if(f)return[f,C.text];if(s){const w=_(s);if(w)return[w,C.text]}return[C.unknown]}e.guessMimeTypes=c;function v(r,s,n){let a=null,h=null,f=null;for(let w=n.length-1;w>=0;w--){const E=n[w];if(s===E.filenameLowercase){a=E;break}if(E.filepattern&&(!h||E.filepattern.length>h.filepattern.length)){const o=E.filepatternOnPath?r:s;(0,D.match)(E.filepatternLowercase,o)&&(h=E)}E.extension&&(!f||E.extension.length>f.extension.length)&&s.endsWith(E.extensionLowercase)&&(f=E)}return a?a.mime:h?h.mime:f?f.mime:null}function _(r){if((0,R.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let s=y.length-1;s>=0;s--){const n=y[s];if(!n.firstline)continue;const a=r.match(n.firstline);if(a&&a.length>0)return n.mime}return null}function b(r){return r?typeof r=="string"?r===C.binary||r===C.text||r===C.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(r){const s=(0,p.extname)(r);return P[s.toLowerCase()]}e.getMediaMime=l;function d(r){for(const s in P)if(P[s]===r)return s}e.getExtensionForMimeType=d;const g=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){const n=g.exec(r);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:s?void 0:r}e.normalizeMimeType=t}),define(me[102],ge([0,1,2]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const u=this._uriTransformer.transformIncoming(I);return u===I?I:R(p.URI.from(u))}transformOutgoing(I){const u=this._uriTransformer.transformOutgoing(I);return u===I?I:R(p.URI.from(u))}transformOutgoingURI(I){const u=this._uriTransformer.transformOutgoing(I);return u===I?I:p.URI.from(u)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,I,u){if(!i||u>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return I.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const c=S(i[m],I,u+1);c!==null&&(i[m]=c)}}return null}function T(i,I){const u=S(i,I,0);return u===null?i:u}e.transformOutgoingURIs=T;function C(i,I,u,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return u?p.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let c in i)if(Object.hasOwnProperty.call(i,c)){const v=C(i[c],I,u,m+1);v!==null&&(i[c]=v)}}return null}function y(i,I){const u=C(i,I,!1,0);return u===null?i:u}e.transformIncomingURIs=y;function A(i,I){const u=C(i,I,!0,0);return u===null?i:u}e.transformAndReviveIncomingURIs=A}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return p.test(y)}e.isUUID=R;const D=new Uint8Array(16),S=[];for(let y=0;y<256;y++)S.push(y.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(y){for(let A=0;A<y.length;A++)y[A]=Math.floor(Math.random()*256);return y};function C(){T(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,A="";return A+=S[D[y++]],A+=S[D[y++]],A+=S[D[y++]],A+=S[D[y++]],A+="-",A+=S[D[y++]],A+=S[D[y++]],A+="-",A+=S[D[y++]],A+=S[D[y++]],A+="-",A+=S[D[y++]],A+=S[D[y++]],A+="-",A+=S[D[y++]],A+=S[D[y++]],A+=S[D[y++]],A+=S[D[y++]],A+=S[D[y++]],A+=S[D[y++]],A}e.generateUuid=C}),define(me[142],ge([0,1,103]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new p.StringDecoder(S),this.remaining=null}write(S){const T=[],C=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(C.length<1)return T;let y=0,A,i=y;for(;i<C.length;)if(A=C.charCodeAt(i),A===13||A===10){if(T.push(C.substring(y,i)),i++,i<C.length){const I=A;A=C.charCodeAt(i),(I===13&&A===10||I===10&&A===13)&&i++}y=i}else i++;return this.remaining=y<C.length?C.substr(y):null,T}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,47,104,289,9,16,11,29,32,76,24,2]),function(J,e,p,R,D,S,T,C,y,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function c(M,x=m.UNLINK){if((0,y.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?_(M):v(M)}async function v(M){try{const x=(0,S.join)((0,R.tmpdir)(),(0,A.generateUuid)());try{await e.Promises.rename(M,x)}catch(F){return _(M)}_(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function _(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function b(M){if((0,y.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(M,{recursive:!0})}e.rimrafSync=b;async function P(M,x){return g(await(x?l(M):(0,D.promisify)(p.readdir)(M)))}async function l(M){try{return await(0,D.promisify)(p.readdir)(M,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const x=[],F=await P(M);for(const q of F){let U=!1,O=!1,G=!1;try{const $=await e.Promises.lstat((0,S.join)(M,q));U=$.isFile(),O=$.isDirectory(),G=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}x.push({name:q,isFile:()=>U,isDirectory:()=>O,isSymbolicLink:()=>G})}return x}function d(M){return g(p.readdirSync(M))}e.readdirSync=d;function g(M){return M.map(x=>typeof x=="string"?C.isMacintosh?(0,i.normalizeNFC)(x):x:(x.name=C.isMacintosh?(0,i.normalizeNFC)(x.name):x.name,x))}async function t(M){const x=await P(M),F=[];for(const q of x)await s.existsDirectory((0,S.join)(M,q))&&F.push(q);return F}function r(M,x=1e3){return new Promise(F=>{let q=!1;const U=setInterval(()=>{q||(q=!0,p.access(M,O=>{q=!1,O&&(clearInterval(U),F(void 0))}))},x)})}e.whenDeleted=r;var s;(function(M){async function x(U){let O;try{if(O=await e.Promises.lstat(U),!O.isSymbolicLink())return{stat:O}}catch(G){}try{return{stat:await e.Promises.stat(U),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(C.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw $}throw G}}M.stat=x;async function F(U){try{const{stat:O,symbolicLink:G}=await M.stat(U);return O.isFile()&&G?.dangling!==!0}catch(O){}return!1}M.existsFile=F;async function q(U){try{const{stat:O,symbolicLink:G}=await M.stat(U);return O.isDirectory()&&G?.dangling!==!0}catch(O){}return!1}M.existsDirectory=q})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new T.ResourceQueue;function a(M,x,F){return n.queueFor(u.URI.file(M),I.extUriBiasedIgnorePathCase).queue(()=>{const q=E(F);return new Promise((U,O)=>f(M,x,q,G=>G?O(G):U()))})}let h=!0;function f(M,x,F,q){if(!h)return p.writeFile(M,x,{mode:F.mode,flag:F.flag},q);p.open(M,F.flag,F.mode,(U,O)=>{if(U)return q(U);p.writeFile(O,x,G=>{if(G)return p.close(O,()=>q(G));p.fdatasync(O,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),h=!1),p.close(O,K=>q(K))))})})}function w(M,x,F){const q=E(F);if(!h)return p.writeFileSync(M,x,{mode:q.mode,flag:q.flag});const U=p.openSync(M,q.flag,q.mode);try{p.writeFileSync(U,x);try{p.fdatasyncSync(U)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),h=!1}}finally{p.closeSync(U)}}e.writeFileSync=w;function E(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function o(M,x){if(M===x)return;async function F(q){try{const U=await e.Promises.lstat(q);if(U.isDirectory()||U.isSymbolicLink())return;await e.Promises.utimes(q,U.atime,new Date)}catch(U){}}try{await e.Promises.rename(M,x),await F(x)}catch(q){if(M.toLowerCase()!==x.toLowerCase()&&q.code==="EXDEV"||M.endsWith("."))await k(M,x,{preserveSymlinks:!1}),await c(M,m.MOVE),await F(x);else throw q}}async function k(M,x,F){return N(M,x,{root:{source:M,target:x},options:F,handledSourcePaths:new Set})}const L=511;async function N(M,x,F){if(F.handledSourcePaths.has(M))return;F.handledSourcePaths.add(M);const{stat:q,symbolicLink:U}=await s.stat(M);if(U){if(F.options.preserveSymlinks)try{return await z(M,x,F)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(U.dangling)return}return q.isDirectory()?V(M,x,q.mode&L,F):ee(M,x,q.mode&L)}async function V(M,x,F,q){await e.Promises.mkdir(x,{recursive:!0,mode:F});const U=await P(M);for(const O of U)await N((0,S.join)(M,O),(0,S.join)(x,O),q)}async function ee(M,x,F){await e.Promises.copyFile(M,x),await e.Promises.chmod(x,F)}async function z(M,x,F){let q=await e.Promises.readlink(M);(0,y.isEqualOrParent)(q,F.root.source,!C.isLinux)&&(q=(0,S.join)(F.root.target,q.substr(F.root.source.length+1))),await e.Promises.symlink(q,x)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(0,D.promisify)(p.read)}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(0,D.promisify)(p.write)}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return c}get move(){return o}get copy(){return k}}}),define(me[105],ge([0,1,47,8,9,28]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const I=(0,D.dirname)(i);if(i===I)return i;const u=((0,D.basename)(i)||i).toLowerCase();try{const c=(0,S.readdirSync)(I).filter(v=>v.toLowerCase()===u);if(c.length===1){const v=T(I);if(v)return(0,D.join)(v,c[0])}else if(c.length>1){const v=c.indexOf(u);if(v>=0){const _=T(I);if(_)return(0,D.join)(_,c[v])}}}catch(m){}return null}e.realcaseSync=T;async function C(i){try{return await S.Promises.realpath(i)}catch(I){const u=A(i);return await S.Promises.access(u,p.constants.R_OK),u}}e.realpath=C;function y(i){try{return p.realpathSync(i)}catch(I){const u=A(i);return p.accessSync(u,p.constants.R_OK),u}}e.realpathSync=y;function A(i){return(0,R.rtrim)((0,D.normalize)(i),D.sep)}});var Ve=this&&this.__decorate||function(J,e,p,R){var D=arguments.length,S=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(J,e,p,R);else for(var C=J.length-1;C>=0;C--)(T=J[C])&&(S=(D<3?T(S):D>3?T(e,p,S):T(e,p))||S);return D>3&&S&&Object.defineProperty(e,p,S),S};define(me[106],ge([0,1,3,6,16,21,15,23,20,14,59,8,56]),function(J,e,p,R,D,S,T,C,y,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function c(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(b||(b={}));class P{constructor(O){this.buffer=O,this.pos=0}read(O){const G=this.buffer.slice(this.pos,this.pos+O);return this.pos+=G.byteLength,G}}class l{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var d;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(d||(d={}));function g(U){const O=C.VSBuffer.alloc(4);return O.writeUInt32BE(U,0),O}function t(U){return U.read(4).readUInt32BE(0)}function r(U){const O=C.VSBuffer.alloc(1);return O.writeUInt8(U,0),O}const s={Undefined:r(d.Undefined),String:r(d.String),Buffer:r(d.Buffer),VSBuffer:r(d.VSBuffer),Array:r(d.Array),Object:r(d.Object)},n=typeof Buffer!="undefined";function a(U,O){if(typeof O=="undefined")U.write(s.Undefined);else if(typeof O=="string"){const G=C.VSBuffer.fromString(O);U.write(s.String),U.write(g(G.byteLength)),U.write(G)}else if(n&&Buffer.isBuffer(O)){const G=C.VSBuffer.wrap(O);U.write(s.Buffer),U.write(g(G.byteLength)),U.write(G)}else if(O instanceof C.VSBuffer)U.write(s.VSBuffer),U.write(g(O.byteLength)),U.write(O);else if(Array.isArray(O)){U.write(s.Array),U.write(g(O.length));for(const G of O)a(U,G)}else{const G=C.VSBuffer.fromString(JSON.stringify(O));U.write(s.Object),U.write(g(G.byteLength)),U.write(G)}}function h(U){switch(U.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return U.read(t(U)).toString();case d.Buffer:return U.read(t(U)).buffer;case d.VSBuffer:return U.read(t(U));case d.Array:{const G=t(U),$=[];for(let K=0;K<G;K++)$.push(h(U));return $}case d.Object:return JSON.parse(U.read(t(U)).toString())}}class f{constructor(O,G,$=null,K=1e3){this.protocol=O,this.ctx=G,this.logger=$,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(O,G){this.channels.set(O,G),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const G=this.send([O.type]);this.logger&&this.logger.logOutgoing(G,0,1,_(O.type));return}case 201:case 202:case 204:case 203:{const G=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(G,O.id,1,_(O.type),O.data);return}}}send(O,G=void 0){const $=new l;return a($,O),a($,G),this.sendBuffer($.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(G){return 0}}onRawMessage(O){const G=new P(O),$=h(G),K=h(G),re=$[0];switch(re){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${c(re)}: ${$[2]}.${$[3]}`,K),this.onPromise({type:re,id:$[1],channelName:$[2],name:$[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${c(re)}: ${$[2]}.${$[3]}`,K),this.onEventListen({type:re,id:$[1],channelName:$[2],name:$[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${c(re)}`),this.disposeActiveRequest({type:re,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${c(re)}`),this.disposeActiveRequest({type:re,id:$[1]})}}onPromise(O){const G=this.channels.get(O.channelName);if(!G){this.collectPendingRequest(O);return}const $=new S.CancellationTokenSource;let K;try{K=G.call(this.ctx,O.name,O.arg,$.token)}catch(ye){K=Promise.reject(ye)}const re=O.id;K.then(ye=>{this.sendResponse({id:re,data:ye,type:201}),this.activeRequests.delete(O.id)},ye=>{ye instanceof Error?this.sendResponse({id:re,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split?ye.stack.split(`
`):ye.stack:void 0},type:202}):this.sendResponse({id:re,data:ye,type:203}),this.activeRequests.delete(O.id)});const fe=(0,R.toDisposable)(()=>$.cancel());this.activeRequests.set(O.id,fe)}onEventListen(O){const G=this.channels.get(O.channelName);if(!G){this.collectPendingRequest(O);return}const $=O.id,re=G.listen(this.ctx,O.name,O.arg)(fe=>this.sendResponse({id:$,data:fe,type:204}));this.activeRequests.set(O.id,re)}disposeActiveRequest(O){const G=this.activeRequests.get(O.id);G&&(G.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let G=this.pendingRequests.get(O.channelName);G||(G=[],this.pendingRequests.set(O.channelName,G));const $=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:O,timeoutTimer:$})}flushPendingRequests(O){const G=this.pendingRequests.get(O);if(G){for(const $ of G)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var w;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(O,G=null){this.protocol=O,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=G}getChannel(O){const G=this;return{call($,K,re){return G.isDisposed?Promise.reject(T.canceled()):G.requestPromise(O,$,K,re)},listen($,K){return G.isDisposed?Promise.reject(T.canceled()):G.requestEvent(O,$,K)}}}requestPromise(O,G,$,K=S.CancellationToken.None){const re=this.lastRequestId++,ye={id:re,type:100,channelName:O,name:G,arg:$};if(K.isCancellationRequested)return Promise.reject(T.canceled());let Ie;return new Promise((qe,We)=>{if(K.isCancellationRequested)return We(T.canceled());const je=()=>{const le=Y=>{switch(Y.type){case 201:this.handlers.delete(re),qe(Y.data);break;case 202:this.handlers.delete(re);const ae=new Error(Y.data.message);ae.stack=Y.data.stack,ae.name=Y.data.name,We(ae);break;case 203:this.handlers.delete(re),We(Y.data);break}};this.handlers.set(re,le),this.sendRequest(ye)};let W=null;this.state===b.Idle?je():(W=(0,D.createCancelablePromise)(le=>this.whenInitialized()),W.then(()=>{W=null,je()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:re,type:101}),We(T.canceled())},ne=K.onCancellationRequested(Z);Ie=(0,R.combinedDisposable)((0,R.toDisposable)(Z),ne),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(O,G,$){const K=this.lastRequestId++,fe={id:K,type:102,channelName:O,name:G,arg:$};let ye=null;const Ie=new p.Emitter({onFirstListenerAdd:()=>{ye=(0,D.createCancelablePromise)(qe=>this.whenInitialized()),ye.then(()=>{ye=null,this.activeRequests.add(Ie),this.sendRequest(fe)})},onLastListenerRemove:()=>{ye?(ye.cancel(),ye=null):(this.activeRequests.delete(Ie),this.sendRequest({id:K,type:103}))}}),Le=qe=>Ie.fire(qe.data);return this.handlers.set(K,Le),Ie.event}sendRequest(O){switch(O.type){case 100:case 102:{const G=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(G,O.id,0,`${c(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const G=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(G,O.id,0,c(O.type));return}}}send(O,G=void 0){const $=new l;return a($,O),a($,G),this.sendBuffer($.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(G){return 0}}onBuffer(O){const G=new P(O),$=h(G),K=h(G),re=$[0];switch(re){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,_(re)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],0,_(re),K),this.onResponse({type:$[0],id:$[1],data:K})}}onResponse(O){if(O.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(O.id);G&&G(O)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([u.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class o{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:G,onDidClientDisconnect:$})=>{p.Event.once(G.onMessage)(re=>{const fe=new P(re),ye=h(fe),Ie=new f(G,ye),Le=new E(G);this.channels.forEach((We,je)=>Ie.registerChannel(je,We));const qe={channelServer:Ie,channelClient:Le,ctx:ye};this._connections.add(qe),this._onDidAddConnection.fire(qe),$(()=>{Ie.dispose(),Le.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const O=[];return this._connections.forEach(G=>O.push(G)),O}getChannel(O,G){const $=this;return{call(K,re,fe){let ye;if((0,A.isFunction)(G)){let Le=(0,y.getRandomElement)($.connections.filter(G));ye=Le?Promise.resolve(Le):p.Event.toPromise(p.Event.filter($.onDidAddConnection,G))}else ye=G.routeCall($,K,re);const Ie=ye.then(Le=>Le.channelClient.getChannel(O));return L(Ie).call(K,re,fe)},listen(K,re){if((0,A.isFunction)(G))return $.getMulticastEvent(O,G,K,re);const fe=G.routeEvent($,K,re).then(ye=>ye.channelClient.getChannel(O));return L(fe).listen(K,re)}}}getMulticastEvent(O,G,$,K){const re=this;let fe=new R.DisposableStore;const ye=new p.Emitter({onFirstListenerAdd:()=>{fe=new R.DisposableStore;const Ie=new p.EventMultiplexer,Le=new Map,qe=je=>{const Z=je.channelClient.getChannel(O).listen($,K),ne=Ie.add(Z);Le.set(je,ne)},We=je=>{const W=Le.get(je);!W||(W.dispose(),Le.delete(je))};re.connections.filter(G).forEach(qe),p.Event.filter(re.onDidAddConnection,G)(qe,void 0,fe),re.onDidRemoveConnection(We,void 0,fe),Ie.event(ye.fire,ye,fe),fe.add(Ie)},onLastListenerRemove:()=>{fe.dispose()}});return ye.event}registerChannel(O,G){this.channels.set(O,G),this._connections.forEach($=>{$.channelServer.registerChannel(O,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class k{constructor(O,G,$=null){const K=new l;a(K,G),O.send(K.buffer),this.channelClient=new E(O,$),this.channelServer=new f(O,G,$)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,G){this.channelServer.registerChannel(O,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function L(U){return{call(O,G,$){return U.then(K=>K.call(O,G,$))},listen(O,G){const $=new p.Relay;return U.then(K=>$.input=K.listen(O,G)),$.event}}}e.getDelayedChannel=L;function N(U){let O=!1;return{call(G,$,K){return O?U.call(G,$,K):(0,D.timeout)(0).then(()=>O=!0).then(()=>U.call(G,$,K))},listen(G,$){if(O)return U.listen(G,$);const K=new p.Relay;return(0,D.timeout)(0).then(()=>O=!0).then(()=>K.input=U.listen(G,$)),K.event}}}e.getNextTickChannel=N;class V{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const G of O.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await p.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=V;var ee;(function(U){function O(K,re){const fe=K,ye=re&&re.disableMarshalling,Ie=new Map;for(const Le in fe)$(Le)&&Ie.set(Le,p.Event.buffer(fe[Le],!0));return new class{listen(Le,qe){const We=Ie.get(qe);if(We)return We;throw new Error(`Event not found: ${qe}`)}call(Le,qe,We){const je=fe[qe];if(typeof je=="function"){if(!ye&&Array.isArray(We))for(let W=0;W<We.length;W++)We[W]=(0,i.revive)(We[W]);return je.apply(fe,We)}throw new Error(`Method not found: ${qe}`)}}}U.fromService=O;function G(K,re){const fe=re&&re.disableMarshalling;return new Proxy({},{get(ye,Ie){if(typeof Ie=="string")return re?.properties?.has(Ie)?re.properties.get(Ie):$(Ie)?K.listen(Ie):async function(...Le){let qe;re&&!(0,A.isUndefinedOrNull)(re.context)?qe=[re.context,...Le]:qe=Le;const We=await K.call(Ie,qe);return fe?We:(0,i.revive)(We)};throw new Error(`Property not found: ${String(Ie)}`)}})}U.toService=G;function $(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let O=U.toString();if(O!=="[object Object]")return O}return U}function x(U){return Array.isArray(U)?U.map(M):M(U)}function F(U,O,G,$,K,re,fe){fe=x(fe);const ye=z[K],Ie=ye[$%ye.length];let Le=[`%c[${U}]%c[${String(O).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String($).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(re)?(Le=Le.concat(fe),Le.push(")")):Le.push(fe),console.log.apply(console,Le)}e.logWithColors=F;class q{constructor(O,G){this._outgoingPrefix=O,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,G,$,K,re){this._totalOutgoing+=O,F(this._outgoingPrefix,this._totalOutgoing,O,G,$,K,re)}logIncoming(O,G,$,K,re){this._totalIncoming+=O,F(this._incomingPrefix,this._totalIncoming,O,G,$,K,re)}}e.IPCLogger=q}),define(me[107],ge([0,1,3,106,6,23,11,38]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function i(){return A||(A=S.VSBuffer.alloc(0)),A}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}let h=S.VSBuffer.alloc(n),f=0,w=0;for(;n>0;){const E=this._chunks[w];if(E.byteLength>n){const o=E.slice(0,n);h.set(o,f),f+=n,a&&(this._chunks[w]=E.slice(n),this._totalLength-=n),n-=n}else h.set(E,f),f+=E.byteLength,a?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,n-=E.byteLength}return h}}e.ChunkStream=I;var u;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var m;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,a,h,f){this.type=n,this.id=a,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(h,f,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const h=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,h}_bufferTake(){const n=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends D.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=b;class P extends R.IPCClient{constructor(n,a,h=null){super(n,a,h);this.protocol=n}static fromSocket(n,a){return new P(new b(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=P;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class d{constructor(n){this.data=n,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,h=this._first;for(;h;)n[a++]=h.data,h=h.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new d(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<t._HISTORY_LENGTH;f++)n-this.lastRuns[f]<=a&&h++;return 1-h/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(n,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new c(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,h=n.length;a<h;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new c(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let h=0,f=a.length;h<f;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new c(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(n){const a=new c(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,96]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(C){let y=(0,p.toUint8)(C);this._defaultValue=y,this._asciiMap=R._createAsciiMap(y),this._map=new Map}static _createAsciiMap(C){let y=new Uint8Array(256);for(let A=0;A<256;A++)y[A]=C;return y}set(C,y){let A=(0,p.toUint8)(y);C>=0&&C<256?this._asciiMap[C]=A:this._map.set(C,A)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=R;var D;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(D||(D={}));class S{constructor(){this._actual=new R(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=S}),define(me[143],ge([0,1,108]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends p.CharacterClassifier{constructor(C){super(0);for(let y=0,A=C.length;y<A;y++)this.set(C.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function S(T){let C={};return y=>(C.hasOwnProperty(y)||(C[y]=T(y)),C[y])}e.getMapForWordSeparators=S(T=>new D(T))}),define(me[48],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(D,S){this.lineNumber=D,this.column=S}with(D=this.lineNumber,S=this.column){return D===this.lineNumber&&S===this.column?this:new p(D,S)}delta(D=0,S=0){return this.with(this.lineNumber+D,this.column+S)}equals(D){return p.equals(this,D)}static equals(D,S){return!D&&!S?!0:!!D&&!!S&&D.lineNumber===S.lineNumber&&D.column===S.column}isBefore(D){return p.isBefore(this,D)}static isBefore(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<S.column}isBeforeOrEqual(D){return p.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<=S.column}static compare(D,S){let T=D.lineNumber|0,C=S.lineNumber|0;if(T===C){let y=D.column|0,A=S.column|0;return y-A}return T-C}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new p(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=p}),define(me[41],ge([0,1,48]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(S,T,C,y){S>C||S===C&&T>y?(this.startLineNumber=C,this.startColumn=y,this.endLineNumber=S,this.endColumn=T):(this.startLineNumber=S,this.startColumn=T,this.endLineNumber=C,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return R.containsPosition(this,S)}static containsPosition(S,T){return!(T.lineNumber<S.startLineNumber||T.lineNumber>S.endLineNumber||T.lineNumber===S.startLineNumber&&T.column<S.startColumn||T.lineNumber===S.endLineNumber&&T.column>S.endColumn)}containsRange(S){return R.containsRange(this,S)}static containsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>S.endColumn)}strictContainsRange(S){return R.strictContainsRange(this,S)}static strictContainsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<=S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>=S.endColumn)}plusRange(S){return R.plusRange(this,S)}static plusRange(S,T){let C,y,A,i;return T.startLineNumber<S.startLineNumber?(C=T.startLineNumber,y=T.startColumn):T.startLineNumber===S.startLineNumber?(C=T.startLineNumber,y=Math.min(T.startColumn,S.startColumn)):(C=S.startLineNumber,y=S.startColumn),T.endLineNumber>S.endLineNumber?(A=T.endLineNumber,i=T.endColumn):T.endLineNumber===S.endLineNumber?(A=T.endLineNumber,i=Math.max(T.endColumn,S.endColumn)):(A=S.endLineNumber,i=S.endColumn),new R(C,y,A,i)}intersectRanges(S){return R.intersectRanges(this,S)}static intersectRanges(S,T){let C=S.startLineNumber,y=S.startColumn,A=S.endLineNumber,i=S.endColumn,I=T.startLineNumber,u=T.startColumn,m=T.endLineNumber,c=T.endColumn;return C<I?(C=I,y=u):C===I&&(y=Math.max(y,u)),A>m?(A=m,i=c):A===m&&(i=Math.min(i,c)),C>A||C===A&&y>i?null:new R(C,y,A,i)}equalsRange(S){return R.equalsRange(this,S)}static equalsRange(S,T){return!!S&&!!T&&S.startLineNumber===T.startLineNumber&&S.startColumn===T.startColumn&&S.endLineNumber===T.endLineNumber&&S.endColumn===T.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(S){return new p.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(S){return new p.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,T){return new R(this.startLineNumber,this.startColumn,S,T)}setStartPosition(S,T){return new R(S,T,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(S){return new R(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,T=S){return new R(S.lineNumber,S.column,T.lineNumber,T.column)}static lift(S){return S?new R(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn)}static areIntersecting(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,T){if(S&&T){const A=S.startLineNumber|0,i=T.startLineNumber|0;if(A===i){const I=S.startColumn|0,u=T.startColumn|0;if(I===u){const m=S.endLineNumber|0,c=T.endLineNumber|0;if(m===c){const v=S.endColumn|0,_=T.endColumn|0;return v-_}return m-c}return I-u}return A-i}return(S?1:0)-(T?1:0)}static compareRangesUsingEnds(S,T){return S.endLineNumber===T.endLineNumber?S.endColumn===T.endColumn?S.startLineNumber===T.startLineNumber?S.startColumn-T.startColumn:S.startLineNumber-T.startLineNumber:S.endColumn-T.endColumn:S.endLineNumber-T.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=R}),define(me[144],ge([0,1,48,41]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class S extends R.Range{constructor(C,y,A,i){super(C,y,A,i);this.selectionStartLineNumber=C,this.selectionStartColumn=y,this.positionLineNumber=A,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return S.selectionsEqual(this,C)}static selectionsEqual(C,y){return C.selectionStartLineNumber===y.selectionStartLineNumber&&C.selectionStartColumn===y.selectionStartColumn&&C.positionLineNumber===y.positionLineNumber&&C.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,y){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,C,y):new S(C,y,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,y){return this.getDirection()===0?new S(C,y,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,C,y)}static fromPositions(C,y=C){return new S(C.lineNumber,C.column,y.lineNumber,y.column)}static liftSelection(C){return new S(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,y){if(C&&!y||!C&&y)return!1;if(!C&&!y)return!0;if(C.length!==y.length)return!1;for(let A=0,i=C.length;A<i;A++)if(!this.selectionsEqual(C[A],y[A]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,y,A,i,I){return I===0?new S(C,y,A,i):new S(A,i,C,y)}}e.Selection=S}),define(me[109],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var S;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace)}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class y{constructor(v,_){this._findMatchBrand=void 0,this.range=v,this.matches=_}}e.FindMatch=y;var A;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class u{constructor(v,_,b,P,l,d){this.identifier=v,this.range=_,this.text=b,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=l,this._isTracked=d}}e.ValidAnnotatedEditOperation=u;class m{constructor(v,_,b){this.reverseEdits=v,this.changes=_,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=m}),define(me[145],ge([0,1,8,143,48,41,109]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class y{constructor(l,d,g,t){this.searchString=l,this.isRegex=d,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=A(this.searchString):l=this.searchString.indexOf(`
`)>=0;let d=null;try{d=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let g=!this.isRegex&&!l;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new i(d,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=y;function A(P){if(!P||P.length===0)return!1;for(let l=0,d=P.length;l<d;l++)if(P.charCodeAt(l)===92){if(l++,l>=d)break;const t=P.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class i{constructor(l,d,g){this.regex=l,this.wordSeparators=d,this.simpleSearch=g}}e.SearchData=i;function I(P,l,d){if(!d)return new T.FindMatch(P,null);let g=[];for(let t=0,r=l.length;t<r;t++)g[t]=l[t];return new T.FindMatch(P,g)}e.createFindMatch=I;class u{constructor(l){let d=[],g=0;for(let t=0,r=l.length;t<r;t++)l.charCodeAt(t)===10&&(d[g++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(l){const d=this._lineFeedsOffsets;let g=0,t=d.length-1;if(t===-1||l<=d[0])return 0;for(;g<t;){const r=g+((t-g)/2>>0);d[r]>=l?t=r-1:d[r+1]>=l?(g=r,t=r):g=r+1}return g+1}}class m{static findMatches(l,d,g,t,r){const s=d.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(l,g,new b(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(l,g,s,t,r):[]}static _getMultilineMatchRange(l,d,g,t,r,s){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),n=d+r+a):n=d+r;let h;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-a;h=n+s.length+o}else h=n+s.length;const f=l.getPositionAt(n),w=l.getPositionAt(h);return new S.Range(f.lineNumber,f.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(l,d,g,t,r){const s=l.getOffsetAt(d.getStartPosition()),n=l.getValueInRange(d,1),a=l.getEOL()===`\r
`?new u(n):null,h=[];let f=0,w;for(g.reset(0);w=g.next(n);)if(h[f++]=I(this._getMultilineMatchRange(l,s,n,a,w.index,w[0]),w,t),f>=r)return h;return h}static _doFindMatchesLineByLine(l,d,g,t,r){const s=[];let n=0;if(d.startLineNumber===d.endLineNumber){const h=l.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return n=this._findMatchesInLine(g,h,d.startLineNumber,d.startColumn-1,n,s,t,r),s}const a=l.getLineContent(d.startLineNumber).substring(d.startColumn-1);n=this._findMatchesInLine(g,a,d.startLineNumber,d.startColumn-1,n,s,t,r);for(let h=d.startLineNumber+1;h<d.endLineNumber&&n<r;h++)n=this._findMatchesInLine(g,l.getLineContent(h),h,0,n,s,t,r);if(n<r){const h=l.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);n=this._findMatchesInLine(g,h,d.endLineNumber,0,n,s,t,r)}return s}static _findMatchesInLine(l,d,g,t,r,s,n,a){const h=l.wordSeparators;if(!n&&l.simpleSearch){const E=l.simpleSearch,o=E.length,k=d.length;let L=-o;for(;(L=d.indexOf(E,L+o))!==-1;)if((!h||_(h,d,k,L,o))&&(s[r++]=new T.FindMatch(new S.Range(g,L+1+t,g,L+1+o+t),null),r>=a))return r;return r}const f=new b(l.wordSeparators,l.regex);let w;f.reset(0);do if(w=f.next(d),w&&(s[r++]=I(new S.Range(g,w.index+1+t,g,w.index+1+w[0].length+t),w,n),r>=a))return r;while(w);return r}static findNextMatch(l,d,g,t){const r=d.parseSearchRequest();if(!r)return null;const s=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(l,g,s,t):this._doFindNextMatchLineByLine(l,g,s,t)}static _doFindNextMatchMultiline(l,d,g,t){const r=new D.Position(d.lineNumber,1),s=l.getOffsetAt(r),n=l.getLineCount(),a=l.getValueInRange(new S.Range(r.lineNumber,r.column,n,l.getLineMaxColumn(n)),1),h=l.getEOL()===`\r
`?new u(a):null;g.reset(d.column-1);let f=g.next(a);return f?I(this._getMultilineMatchRange(l,s,a,h,f.index,f[0]),f,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(l,new D.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(l,d,g,t){const r=l.getLineCount(),s=d.lineNumber,n=l.getLineContent(s),a=this._findFirstMatchInLine(g,n,s,d.column,t);if(a)return a;for(let h=1;h<=r;h++){const f=(s+h-1)%r,w=l.getLineContent(f+1),E=this._findFirstMatchInLine(g,w,f+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(l,d,g,t,r){l.reset(t-1);const s=l.next(d);return s?I(new S.Range(g,s.index+1,g,s.index+1+s[0].length),s,r):null}static findPreviousMatch(l,d,g,t){const r=d.parseSearchRequest();if(!r)return null;const s=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(l,g,s,t):this._doFindPreviousMatchLineByLine(l,g,s,t)}static _doFindPreviousMatchMultiline(l,d,g,t){const r=this._doFindMatchesMultiline(l,new S.Range(1,1,d.lineNumber,d.column),g,t,10*C);if(r.length>0)return r[r.length-1];const s=l.getLineCount();return d.lineNumber!==s||d.column!==l.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(l,new D.Position(s,l.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(l,d,g,t){const r=l.getLineCount(),s=d.lineNumber,n=l.getLineContent(s).substring(0,d.column-1),a=this._findLastMatchInLine(g,n,s,t);if(a)return a;for(let h=1;h<=r;h++){const f=(r+s-h-1)%r,w=l.getLineContent(f+1),E=this._findLastMatchInLine(g,w,f+1,t);if(E)return E}return null}static _findLastMatchInLine(l,d,g,t){let r=null,s;for(l.reset(0);s=l.next(d);)r=I(new S.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=m;function c(P,l,d,g,t){if(g===0)return!0;const r=l.charCodeAt(g-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=l.charCodeAt(g);if(P.get(s)!==0)return!0}return!1}function v(P,l,d,g,t){if(g+t===d)return!0;const r=l.charCodeAt(g+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=l.charCodeAt(g+t-1);if(P.get(s)!==0)return!0}return!1}function _(P,l,d,g,t){return c(P,l,d,g,t)&&v(P,l,d,g,t)}e.isValidMatch=_;class b{constructor(l,d){this._wordSeparators=l,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const d=l.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(g=this._searchRegex.exec(l),!g))return null;const t=g.index,r=g[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){p.getNextCodePoint(l,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,l,d,t,r))return g}while(g);return null}}e.Searcher=b}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(C=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)C.indexOf(A)>=0||(y+="\\"+A);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=p();function R(C){let y=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)y=C;else{let A="g";C.ignoreCase&&(A+="i"),C.multiline&&(A+="m"),C.unicode&&(A+="u"),y=new RegExp(C.source,A)}return y.lastIndex=0,y}e.ensureValidWordDefinition=R;const D={maxLen:1e3,windowSize:15,timeBudget:150};function S(C,y,A,i,I=D){if(A.length>I.maxLen){let _=C-I.maxLen/2;return _<0?_=0:i+=_,A=A.substring(_,C+I.maxLen/2),S(C,y,A,i,I)}const u=Date.now(),m=C-1-i;let c=-1,v=null;for(let _=1;!(Date.now()-u>=I.timeBudget);_++){const b=m-I.windowSize*_;y.lastIndex=Math.max(0,b);const P=T(y,A,m,c);if(!P&&v||(v=P,b<=0))break;c=b}if(v){let _={word:v[0],startColumn:i+1+v.index,endColumn:i+1+v.index+v[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=S;function T(C,y,A,i){let I;for(;I=C.exec(y);){const u=I.index||0;if(u<=A&&C.lastIndex>=A)return I;if(i>0&&u>i)return null}return null}}),define(me[146],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class R{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let y=0,A=C.notIn.length;y<A;y++)switch(C.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=R;class D{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of C)S(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),S(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),S(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),S(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&S(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function S(T,C,y){T.has(C)?T.get(C).push(y):T.set(C,[y])}}),define(me[78],ge([0,1,30,9]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(S,T,C,y){if(Array.isArray(S)){let A=0;for(const i of S){const I=D(i,T,C,y);if(I===10)return I;I>A&&(A=I)}return A}else{if(typeof S=="string")return y?S==="*"?5:S===C?10:0:0;if(S){const{language:A,pattern:i,scheme:I,hasAccessToAllModels:u}=S;if(!y&&!u)return 0;let m=0;if(I)if(I===T.scheme)m=10;else if(I==="*")m=5;else return 0;if(A)if(A===C)m=10;else if(A==="*")m=Math.max(m,5);else return 0;if(i){let c;if(typeof i=="string"?c=i:c={...i,base:(0,R.normalize)(i.base)},c===T.fsPath||(0,p.match)(c,T.fsPath))m=10;else return 0}return m}else return 0}}e.score=D}),define(me[147],ge([0,1,108]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class D{constructor(c,v,_){const b=new Uint8Array(c*v);for(let P=0,l=c*v;P<l;P++)b[P]=_;this._data=b,this.rows=c,this.cols=v}get(c,v){return this._data[c*this.cols+v]}set(c,v,_){this._data[c*this.cols+v]=_}}e.Uint8Matrix=D;class S{constructor(c){let v=0,_=0;for(let P=0,l=c.length;P<l;P++){let[d,g,t]=c[P];g>v&&(v=g),d>_&&(_=d),t>_&&(_=t)}v++,_++;let b=new D(_,v,0);for(let P=0,l=c.length;P<l;P++){let[d,g,t]=c[P];b.set(d,g,t)}this._states=b,this._maxCharCode=v}nextState(c,v){return v<0||v>=this._maxCharCode?0:this._states.get(c,v)}}e.StateMachine=S;let T=null;function C(){return T===null&&(T=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let A=null;function i(){if(A===null){A=new p.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)A.set(m.charCodeAt(v),1);const c=".,;";for(let v=0;v<c.length;v++)A.set(c.charCodeAt(v),2)}return A}class I{static _createLink(c,v,_,b,P){let l=P-1;do{const d=v.charCodeAt(l);if(c.get(d)!==2)break;l--}while(l>b);if(b>0){const d=v.charCodeAt(b-1),g=v.charCodeAt(l);(d===40&&g===41||d===91&&g===93||d===123&&g===125)&&l--}return{range:{startLineNumber:_,startColumn:b+1,endLineNumber:_,endColumn:l+2},url:v.substring(b,l+1)}}static computeLinks(c,v=C()){const _=i();let b=[];for(let P=1,l=c.getLineCount();P<=l;P++){const d=c.getLineContent(P),g=d.length;let t=0,r=0,s=0,n=1,a=!1,h=!1,f=!1,w=!1;for(;t<g;){let E=!1;const o=d.charCodeAt(t);if(n===13){let k;switch(o){case 40:a=!0,k=0;break;case 41:k=a?0:1;break;case 91:f=!0,h=!0,k=0;break;case 93:f=!1,k=h?0:1;break;case 123:w=!0,k=0;break;case 125:k=w?0:1;break;case 39:k=s===34||s===96?0:1;break;case 34:k=s===39||s===96?0:1;break;case 96:k=s===39||s===34?0:1;break;case 42:k=s===42?1:0;break;case 124:k=s===124?1:0;break;case 32:k=f?0:1;break;default:k=_.get(o)}k===1&&(b.push(I._createLink(_,d,P,r,t)),E=!0)}else if(n===12){let k;o===91?(h=!0,k=0):k=_.get(o),k===1?E=!0:n=13}else n=v.nextState(n,o),n===0&&(E=!0);E&&(n=1,a=!1,h=!1,w=!1,r=t+1,s=o),t++}n===13&&b.push(I._createLink(_,d,P,r,g))}return b}}e.LinkComputer=I;function u(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:I.computeLinks(m)}e.computeLinks=u}),define(me[148],ge([0,1,3,6]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,C){return this._map.set(T,C),this.fire([T]),(0,R.toDisposable)(()=>{this._map.get(T)===C&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,C){let y=null,A=!1;return this._promises.set(T,C.then(i=>{this._promises.delete(T),!(A||!i)&&(y=this.register(T,i))})),(0,R.toDisposable)(()=>{A=!0,y&&y.dispose()})}getPromise(T){const C=this.get(T);if(C)return Promise.resolve(C);const y=this._promises.get(T);return y?y.then(A=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(me[111],ge([0,1,23,11]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function S(I){for(let u=0,m=I.length;u<m;u+=4){const c=I[u+0],v=I[u+1],_=I[u+2],b=I[u+3];I[u+0]=b,I[u+1]=_,I[u+2]=v,I[u+3]=c}}function T(I){const u=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||S(u),p.VSBuffer.wrap(u)}function C(I){const u=I.buffer;if(R.isLittleEndian()||S(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const m=new Uint8Array(u.byteLength);return m.set(u),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(I){const u=new Uint32Array(A(I));let m=0;if(u[m++]=I.id,I.type==="full")u[m++]=1,u[m++]=I.data.length,u.set(I.data,m),m+=I.data.length;else{u[m++]=2,u[m++]=I.deltas.length;for(const c of I.deltas)u[m++]=c.start,u[m++]=c.deleteCount,c.data?(u[m++]=c.data.length,u.set(c.data,m),m+=c.data.length):u[m++]=0}return T(u)}e.encodeSemanticTokensDto=y;function A(I){let u=0;if(u+=1+1,I.type==="full")u+=1+I.data.length;else{u+=1,u+=(1+1+1)*I.deltas.length;for(const m of I.deltas)m.data&&(u+=m.data.length)}return u}function i(I){const u=C(I);let m=0;const c=u[m++];if(u[m++]===1){const P=u[m++],l=u.subarray(m,m+P);return m+=P,{id:c,type:"full",data:l}}const _=u[m++];let b=[];for(let P=0;P<_;P++){const l=u[m++],d=u[m++],g=u[m++];let t;g>0&&(t=u.subarray(m,m+g),m+=g),b[P]={start:l,deleteCount:d,data:t}}return{id:c,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(me[112],ge([0,1,96]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(T,C){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=C}}e.PrefixSumIndexOfResult=R;class D{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,C){T=(0,p.toUint32)(T);const y=this.values,A=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(y.length+i),this.values.set(y.subarray(0,T),0),this.values.set(y.subarray(T),T+i),this.values.set(C,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,C){return T=(0,p.toUint32)(T),C=(0,p.toUint32)(C),this.values[T]===C?!1:(this.values[T]=C,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,C){T=(0,p.toUint32)(T),C=(0,p.toUint32)(C);const y=this.values,A=this.prefixSum;if(T>=y.length)return!1;let i=y.length-T;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(y.length-C),this.values.set(y.subarray(0,T),0),this.values.set(y.subarray(T+C),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,p.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),T>=this.values.length&&(T=this.values.length-1);for(let y=C;y<=T;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let C=0,y=this.values.length-1,A=0,i=0,I=0;for(;C<=y;)if(A=C+(y-C)/2|0,i=this.prefixSum[A],I=i-this.values[A],T<I)y=A-1;else if(T>=i)C=A+1;else break;return new R(A,T-I)}}e.PrefixSumComputer=D}),define(me[149],ge([0,1,8,48,112]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(C,y,A,i){this._uri=C,this._lines=y,this._eol=A,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const y=C.changes;for(const A of y)this._acceptDeleteRange(A.range),this._acceptInsertText(new R.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,y=this._lines.length,A=new Uint32Array(y);for(let i=0;i<y;i++)A[i]=this._lines[i].length+C;this._lineStarts=new D.PrefixSumComputer(A)}}_setLineText(C,y){this._lines[C]=y,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,y){if(y.length===0)return;let A=(0,p.splitLines)(y);if(A.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+A[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}A[A.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+A[0]);let i=new Uint32Array(A.length-1);for(let I=1;I<A.length;I++)this._lines.splice(C.lineNumber+I-1,0,A[I]),i[I-1]=A[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}e.MirrorTextModel=S}),define(me[150],ge([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,S=D*24,T=S*7,C=S*30,y=S*365;function A(I,u){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,p.localize)(0,null,A(new Date().getTime()+m*1e3,!1));if(m<30)return(0,p.localize)(1,null);let c;return m<R?(c=m,u?c===1?(0,p.localize)(2,null,c):(0,p.localize)(3,null,c):c===1?(0,p.localize)(4,null,c):(0,p.localize)(5,null,c)):m<D?(c=Math.floor(m/R),u?c===1?(0,p.localize)(6,null,c):(0,p.localize)(7,null,c):c===1?(0,p.localize)(8,null,c):(0,p.localize)(9,null,c)):m<S?(c=Math.floor(m/D),u?c===1?(0,p.localize)(10,null,c):(0,p.localize)(11,null,c):c===1?(0,p.localize)(12,null,c):(0,p.localize)(13,null,c)):m<T?(c=Math.floor(m/S),u?c===1?(0,p.localize)(14,null,c):(0,p.localize)(15,null,c):c===1?(0,p.localize)(16,null,c):(0,p.localize)(17,null,c)):m<C?(c=Math.floor(m/T),u?c===1?(0,p.localize)(18,null,c):(0,p.localize)(19,null,c):c===1?(0,p.localize)(20,null,c):(0,p.localize)(21,null,c)):m<y?(c=Math.floor(m/C),u?c===1?(0,p.localize)(22,null,c):(0,p.localize)(23,null,c):c===1?(0,p.localize)(24,null,c):(0,p.localize)(25,null,c)):(c=Math.floor(m/y),u?c===1?(0,p.localize)(26,null,c):(0,p.localize)(27,null,c):c===1?(0,p.localize)(28,null,c):(0,p.localize)(29,null,c))}e.fromNow=A;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[152],ge([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,152,14,20]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(A,i){return i&&(A.stack||A.stacktrace)?p.localize(0,null,C(A),T(A.stack)||T(A.stacktrace)):C(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function C(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?p.localize(1,null,A.message):A.message||p.localize(2,null)}function y(A=null,i=!1){if(!A)return p.localize(3,null);if(Array.isArray(A)){const I=D.coalesce(A),u=y(I[0],i);return I.length>1?p.localize(4,null,u,I.length):u}if(R.isString(A))return A;if(A.detail){const I=A.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return A.stack?S(A,i):A.message?A.message:p.localize(5,null)}e.toErrorMessage=y}),define(me[153],ge([18,19]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,9,28,39,153,38,14,25,29,11,142,10]),function(J,e,p,R,D,S,T,C,y,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(d,g){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};g&&(t.cwd=g);const r=D.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(s=>{r.once("error",n=>{s({success:!1,error:n})}),r.once("exit",(n,a)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=u.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{D.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(s,n,a)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function v(d=T.env){return d.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(g,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=g,this.args=t,this.shell=r,this.options=s;else{const n=g;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(T.env).forEach(a=>{n[a]=T.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const t=g.lastIndexOf(p.sep);return t!==-1&&(g=g.substring(t+1)),_.WellKnowCommands[g]?g:"other"}start(g){return i.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(T.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,s;const n=new Promise((a,h)=>{r=a,s=h});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=D.exec(a,this.options,(h,f,w)=>{this.childProcess=null;const E=h;E&&E.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:w.toString()}):this.handleExec(r,g,h,f,w)})}else{let a=null;const h=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,r,g,s);const w={terminated:this.terminateRequested};C.isNumber(f)&&(w.cmdCode=f),r(w)};if(this.shell&&i.isWindows){const f=y.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let w=!1,E=!1;const o=[];let k=this.ensureQuotes(this.cmd);o.push(k.value),w=k.quoted,this.args&&this.args.forEach(N=>{k=this.ensureQuotes(N),o.push(k.value),E=E&&k.quoted});const L=["/s","/c"];w?E?L.push('"'+o.join(" ")+'"'):o.length>1?L.push('"'+o[0]+'" '+o.slice(1).join(" ")):L.push('"'+o[0]+'"'):L.push(o.join(" ")),a=D.spawn(v(),L,f)}else this.cmd&&(a=D.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,r,g,s,!0)))}return n})}handleClose(g,t,r,s){}ensureQuotes(g){return _.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,c(g,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!i.isWindows)return g(!1);const t=D.spawn(v(),["/s","/c"]);t.on("error",r=>g(!0)),t.on("exit",r=>g(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class b extends _{constructor(g,t,r,s){super(g,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,t,r,s,n){[s,n].forEach((a,h)=>{const f=new I.LineDecoder;f.write(a).forEach(o=>{t({line:o,source:h===0?0:1})});const E=f.end();E&&t({line:E,source:h===0?0:1})}),g({terminated:this.terminateRequested,error:r})}handleSpawn(g,t,r,s,n){const a=new I.LineDecoder,h=new I.LineDecoder;g.stdout.on("data",f=>{a.write(f).forEach(E=>r({line:E,source:0}))}),g.stderr.on("data",f=>{h.write(f).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(g,t,r,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&r({line:a,source:1})}}e.LineProcess=b;function P(d){let g=[],t=!1;const r=function(s){if(t){g.push(s);return}(!d.send(s,a=>{if(a&&console.error(a),t=!1,g.length>0){const h=g.slice(0);g=[],h.forEach(f=>r(f))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=P;var l;(function(d){async function g(t,r,s){if(p.isAbsolute(t))return t;if(r===void 0&&(r=T.cwd()),p.dirname(t)!=="."||(s===void 0&&C.isString(T.env.PATH)&&(s=T.env.PATH.split(p.delimiter)),s===void 0||s.length===0))return p.join(r,t);async function a(h){return await R.Promises.exists(h)?!(await R.Promises.stat(h)).isDirectory():!1}for(let h of s){let f;if(p.isAbsolute(h)?f=p.join(h,t):f=p.join(r,h,t),await a(f))return f;let w=f+".com";if(await a(w)||(w=f+".exe",await a(w)))return w}return p.join(r,t)}d.findExecutable=g})(l=e.win32||(e.win32={}))}),define(me[154],ge([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=T;class C{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,he){this._values[se]=he}}e.ValidatedEditorOptions=C;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class A{constructor(se,he,xe,Be){this.id=se,this.name=he,this.defaultValue=xe,this.schema=Be}compute(se,he,xe){return xe}}class i{constructor(se,he=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(se){return this.defaultValue}}class I{constructor(se,he,xe,Be){this.id=se,this.name=he,this.defaultValue=xe,this.schema=Be}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,he,xe){return xe}}function u(X,se){return typeof X=="undefined"?se:X==="false"?!1:Boolean(X)}e.boolean=u;class m extends I{constructor(se,he,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=xe),super(se,he,xe,Be)}validate(se){return u(se,this.defaultValue)}}class c extends I{constructor(se,he,xe,Be,et,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=xe,Ce.minimum=Be,Ce.maximum=et),super(se,he,xe,Ce),this.minimum=Be,this.maximum=et}static clampedInt(se,he,xe,Be){if(typeof se=="undefined")return he;let et=parseInt(se,10);return isNaN(et)?he:(et=Math.max(xe,et),et=Math.min(Be,et),et|0)}validate(se){return c.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class v extends I{constructor(se,he,xe,Be,et){typeof et!="undefined"&&(et.type="number",et.default=xe),super(se,he,xe,et),this.validationFn=Be}static clamp(se,he,xe){return se<he?he:se>xe?xe:se}static float(se,he){if(typeof se=="number")return se;if(typeof se=="undefined")return he;const xe=parseFloat(se);return isNaN(xe)?he:xe}validate(se){return this.validationFn(v.float(se,this.defaultValue))}}class _ extends I{static string(se,he){return typeof se!="string"?he:se}constructor(se,he,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=xe),super(se,he,xe,Be)}validate(se){return _.string(se,this.defaultValue)}}function b(X,se,he){return typeof X!="string"||he.indexOf(X)===-1?se:X}e.stringSet=b;class P extends I{constructor(se,he,xe,Be,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=Be,et.default=xe),super(se,he,xe,et),this._allowedValues=Be}validate(se){return b(se,this.defaultValue,this._allowedValues)}}class l extends A{constructor(se,he,xe,Be,et,Ce,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=et,De.default=Be),super(se,he,xe,De),this._allowedValues=et,this._convert=Ce}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function d(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,he,xe){return xe===0?se.accessibilitySupport:xe}}class t extends A{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:p.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{insertSpace:u(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function h(X){switch(X){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class f extends i{constructor(){super(126,[64,31])}compute(se,he,xe){const Be=["monaco-editor"];return he.get(31)&&Be.push(he.get(31)),se.extraEditorClassName&&Be.push(se.extraEditorClassName),he.get(64)==="default"?Be.push("mouse-default"):he.get(64)==="copy"&&Be.push("mouse-copy"),he.get(99)&&Be.push("showUnused"),he.get(124)&&Be.push("showDeprecated"),Be.join(" ")}}class w extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(se,he,xe){return xe&&se.emptySelectionClipboard}}class E extends A{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:se.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:p.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:p.localize(15,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{cursorMoveOnType:u(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:u(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":b(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(he.loop,this.defaultValue.loop)}}}class o extends A{constructor(){super(42,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?o.OFF:se==="true"?o.ON:se:Boolean(se)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class k extends i{constructor(){super(41)}compute(se,he,xe){return se.fontInfo}}class L extends I{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(se){let he=v.float(se,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(he,6,100)}compute(se,he,xe){return se.fontInfo.fontSize}}class N extends A{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(se){return se==="normal"||se==="bold"?se:String(c.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class V extends A{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(26,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(27,null),...he},"editor.gotoLocation.multipleDeclarations":{description:p.localize(28,null),...he},"editor.gotoLocation.multipleImplementations":{description:p.localize(29,null),...he},"editor.gotoLocation.multipleReferences":{description:p.localize(30,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:xe,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:xe,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:xe,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:xe,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:xe,description:p.localize(35,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{multiple:b(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??b(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??b(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??b(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??b(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??b(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends A{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(51,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:se.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:p.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{enabled:u(he.enabled,this.defaultValue.enabled),delay:c.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:u(he.sticky,this.defaultValue.sticky)}}}var z;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class M extends i{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(se,he,xe){return M.computeLayout(he,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const he=se.height/se.lineHeight,xe=se.scrollBeyondLastLine?he-1:0,Be=(se.viewLineCount+xe)/(se.pixelRatio*se.height),et=Math.floor(se.viewLineCount/Be);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:xe,desiredRatio:Be,minimapLineCount:et}}static _computeMinimapLayout(se,he){const xe=se.outerWidth,Be=se.outerHeight,et=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ce=he.stableMinimapLayoutInput,De=Ce&&se.outerHeight===Ce.outerHeight&&se.lineHeight===Ce.lineHeight&&se.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&se.pixelRatio===Ce.pixelRatio&&se.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&se.minimap.enabled===Ce.minimap.enabled&&se.minimap.side===Ce.minimap.side&&se.minimap.size===Ce.minimap.size&&se.minimap.showSlider===Ce.minimap.showSlider&&se.minimap.renderCharacters===Ce.minimap.renderCharacters&&se.minimap.maxColumn===Ce.minimap.maxColumn&&se.minimap.scale===Ce.minimap.scale&&se.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&se.isViewportWrapping===Ce.isViewportWrapping,Te=se.lineHeight,ce=se.typicalHalfwidthCharacterWidth,ue=se.scrollBeyondLastLine,pe=se.minimap.renderCharacters;let be=et>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const j=se.minimap.maxColumn,we=se.minimap.size,_e=se.minimap.side,Ae=se.verticalScrollbarWidth,Ue=se.viewLineCount,Ge=se.remainingWidth,Ze=se.isViewportWrapping,Qe=pe?2:3;let Je=Math.floor(et*Be);const ct=Je/et;let mt=!1,bt=!1,ot=Qe*be,at=be/et,Se=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:ut,desiredRatio:St,minimapLineCount:kt}=M.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:ue,height:Be,lineHeight:Te,pixelRatio:et});if(Ue/kt>1)mt=!0,bt=!0,be=1,ot=1,at=be/et;else{let ft=!1,dt=be+1;if(we==="fit"){const vt=Math.ceil((Ue+ut)*ot);Ze&&De&&Ge<=he.stableFitRemainingWidth?(ft=!0,dt=he.stableFitMaxMinimapScale):ft=vt>Je}if(we==="fill"||ft){mt=!0;const vt=be;ot=Math.min(Te*et,Math.max(1,Math.floor(1/St))),Ze&&De&&Ge<=he.stableFitRemainingWidth&&(dt=he.stableFitMaxMinimapScale),be=Math.min(dt,Math.max(1,Math.floor(ot/Qe))),be>vt&&(Se=Math.min(2,be/vt)),at=be/et/Se,Je=Math.ceil(Math.max(Ke,Ue+ut)*ot),Ze?(he.stableMinimapLayoutInput=se,he.stableFitRemainingWidth=Ge,he.stableFitMaxMinimapScale=be):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Pe=Math.floor(j*at),te=Math.min(Pe,Math.max(0,Math.floor((Ge-Ae-2)*at/(ce+at)))+e.MINIMAP_GUTTER_WIDTH);let Q=Math.floor(et*te);const Oe=Q/et;Q=Math.floor(Q*Se);const Fe=pe?1:2,tt=_e==="left"?0:xe-te-Ae;return{renderMinimap:Fe,minimapLeft:tt,minimapWidth:te,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:be,minimapLineHeight:ot,minimapCanvasInnerWidth:Q,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:ct}}static computeLayout(se,he){const xe=he.outerWidth|0,Be=he.outerHeight|0,et=he.lineHeight|0,Ce=he.lineNumbersDigitCount|0,De=he.typicalHalfwidthCharacterWidth,Te=he.maxDigitWidth,ce=he.pixelRatio,ue=he.viewLineCount,pe=se.get(121),be=pe==="inherit"?se.get(120):pe,j=be==="inherit"?se.get(116):be,we=se.get(119),_e=se.get(2),Ae=he.isDominatedByLongLines,Ue=se.get(47),Ge=se.get(58).renderType!==0,Ze=se.get(59),Qe=se.get(93),Je=se.get(63),ct=se.get(91),mt=ct.verticalScrollbarSize,bt=ct.verticalHasArrows,ot=ct.arrowSize,at=ct.horizontalScrollbarSize,Se=se.get(56),Pe=se.get(35);let te;if(typeof Se=="string"&&/^\d+(\.\d+)?ch$/.test(Se)){const It=parseFloat(Se.substr(0,Se.length-2));te=c.clampedInt(It*De,0,0,1e3)}else te=c.clampedInt(Se,0,0,1e3);Pe&&(te+=16);let Q=0;if(Ge){const It=Math.max(Ce,Ze);Q=Math.round(It*Te)}let Oe=0;Ue&&(Oe=et);let Fe=0,tt=Fe+Oe,Ke=tt+Q,ut=Ke+te;const St=xe-Oe-Q-te;let kt=!1,Dt=!1,ft=-1;_e!==2&&(be==="inherit"&&Ae?(kt=!0,Dt=!0):j==="on"||j==="bounded"?Dt=!0:j==="wordWrapColumn"&&(ft=we));const dt=M._computeMinimapLayout({outerWidth:xe,outerHeight:Be,lineHeight:et,typicalHalfwidthCharacterWidth:De,pixelRatio:ce,scrollBeyondLastLine:Qe,minimap:Je,verticalScrollbarWidth:mt,viewLineCount:ue,remainingWidth:St,isViewportWrapping:Dt},he.memory||new y);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Fe+=dt.minimapWidth,tt+=dt.minimapWidth,Ke+=dt.minimapWidth,ut+=dt.minimapWidth);const vt=St-dt.minimapWidth,Et=Math.max(1,Math.floor((vt-mt-2)/De)),Tt=bt?ot:0;return Dt&&(ft=Math.max(1,Et),j==="bounded"&&(ft=Math.min(ft,we))),{width:xe,height:Be,glyphMarginLeft:Fe,glyphMarginWidth:Oe,lineNumbersLeft:tt,lineNumbersWidth:Q,decorationsLeft:Ke,decorationsWidth:te,contentLeft:ut,contentWidth:vt,minimap:dt,viewportColumn:Et,isWordWrapMinified:kt,isViewportWrapping:Dt,wrappingColumn:ft,verticalScrollbarWidth:mt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:mt,height:Be-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=M;class x extends A{constructor(){const se={enabled:!0};super(55,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:p.localize(39,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:u(se.enabled,this.defaultValue.enabled)}}}class F extends A{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,description:p.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{enabled:u(he.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(he.fontFamily,this.defaultValue.fontFamily)}}}class q extends v{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>v.clamp(se,0,150),{markdownDescription:p.localize(43,null)})}compute(se,he,xe){return se.fontInfo.lineHeight}}class U extends A{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:se.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:p.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{enabled:u(he.enabled,this.defaultValue.enabled),size:b(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(he.side,this.defaultValue.side,["right","left"]),showSlider:b(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(he.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(he.scale,1,1,3),maxColumn:c.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends A{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{top:c.clampedInt(he.top,0,0,1e3),bottom:c.clampedInt(he.bottom,0,0,1e3)}}}class $ extends A{constructor(){const se={enabled:!0,cycle:!1};super(74,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:p.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{enabled:u(he.enabled,this.defaultValue.enabled),cycle:u(he.cycle,this.defaultValue.cycle)}}}class K extends i{constructor(){super(127)}compute(se,he,xe){return se.pixelRatio}}class re extends A{constructor(){const se={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:p.localize(58,null)},comments:{type:"boolean",default:se.comments,description:p.localize(59,null)},other:{type:"boolean",default:se.other,description:p.localize(60,null)}}}],default:se,description:p.localize(61,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const he=se,xe={other:u(he.other,this.defaultValue.other),comments:u(he.comments,this.defaultValue.comments),strings:u(he.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var fe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends A{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(se){let he=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(he=4,xe=se):se==="interval"?he=3:se==="relative"?he=2:se==="on"?he=1:he=0),{renderType:he,renderFn:xe}}}function Ie(X){const se=X.get(86);return se==="editable"?X.get(79):se!=="on"}e.filterValidationDecorations=Ie;class Le extends A{constructor(){const se=[],he={type:"number",description:p.localize(67,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:se,description:p.localize(69,null)})}validate(se){if(Array.isArray(se)){let he=[];for(let xe of se)if(typeof xe=="number")he.push({column:c.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Be=xe;he.push({column:c.clampedInt(Be.column,0,0,1e4),color:Be.color})}return he.sort((xe,Be)=>xe.column-Be.column),he}return this.defaultValue}}function qe(X,se){if(typeof X!="string")return se;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class We extends A{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(70,null),p.localize(71,null),p.localize(72,null)],default:"auto",description:p.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(74,null),p.localize(75,null),p.localize(76,null)],default:"auto",description:p.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:p.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:p.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:p.localize(80,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se,xe=c.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=c.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(he.vertical,this.defaultValue.vertical),horizontal:qe(he.horizontal,this.defaultValue.horizontal),useShadows:u(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:c.clampedInt(he.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:c.clampedInt(he.verticalSliderSize,Be,0,1e3),scrollByPage:u(he.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends A{constructor(){const se={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:p.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[p.localize(82,null),p.localize(83,null),p.localize(84,null)],default:se.mode,description:p.localize(85,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{enabled:u(he.enabled,this.defaultValue.enabled),mode:b(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends A{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(86,null),p.localize(87,null)],default:se.insertMode,description:p.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:p.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:p.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:p.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:p.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:p.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:p.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:p.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[p.localize(96,null),p.localize(97,null),p.localize(98,null)],default:se.previewMode,description:p.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:p.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(131,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const he=se;return{insertMode:b(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(he.showIcons,this.defaultValue.showIcons),showStatusBar:u(he.showStatusBar,this.defaultValue.showStatusBar),preview:u(he.preview,this.defaultValue.preview),previewMode:b(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(he.showMethods,this.defaultValue.showMethods),showFunctions:u(he.showFunctions,this.defaultValue.showFunctions),showConstructors:u(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(he.showDeprecated,this.defaultValue.showDeprecated),showFields:u(he.showFields,this.defaultValue.showFields),showVariables:u(he.showVariables,this.defaultValue.showVariables),showClasses:u(he.showClasses,this.defaultValue.showClasses),showStructs:u(he.showStructs,this.defaultValue.showStructs),showInterfaces:u(he.showInterfaces,this.defaultValue.showInterfaces),showModules:u(he.showModules,this.defaultValue.showModules),showProperties:u(he.showProperties,this.defaultValue.showProperties),showEvents:u(he.showEvents,this.defaultValue.showEvents),showOperators:u(he.showOperators,this.defaultValue.showOperators),showUnits:u(he.showUnits,this.defaultValue.showUnits),showValues:u(he.showValues,this.defaultValue.showValues),showConstants:u(he.showConstants,this.defaultValue.showConstants),showEnums:u(he.showEnums,this.defaultValue.showEnums),showEnumMembers:u(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(he.showKeywords,this.defaultValue.showKeywords),showWords:u(he.showWords,this.defaultValue.showWords),showColors:u(he.showColors,this.defaultValue.showColors),showFiles:u(he.showFiles,this.defaultValue.showFiles),showReferences:u(he.showReferences,this.defaultValue.showReferences),showFolders:u(he.showFolders,this.defaultValue.showFolders),showTypeParameters:u(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(he.showSnippets,this.defaultValue.showSnippets),showUsers:u(he.showUsers,this.defaultValue.showUsers),showIssues:u(he.showIssues,this.defaultValue.showIssues)}}}class Z extends A{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(132,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends i{constructor(){super(128,[79])}compute(se,he,xe){return he.get(79)?!0:se.tabFocusMode}}var le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(le=e.WrappingIndent||(e.WrappingIndent={}));function Y(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ae extends i{constructor(){super(130,[129])}compute(se,he,xe){const Be=he.get(129);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const ve="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Me:R.isLinux?ze:ve,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Ye;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.foldingImportsByDefault=38]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=40]="fontFamily",X[X.fontInfo=41]="fontInfo",X[X.fontLigatures=42]="fontLigatures",X[X.fontSize=43]="fontSize",X[X.fontWeight=44]="fontWeight",X[X.formatOnPaste=45]="formatOnPaste",X[X.formatOnType=46]="formatOnType",X[X.glyphMargin=47]="glyphMargin",X[X.gotoLocation=48]="gotoLocation",X[X.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",X[X.hover=51]="hover",X[X.inDiffEditor=52]="inDiffEditor",X[X.inlineSuggest=53]="inlineSuggest",X[X.letterSpacing=54]="letterSpacing",X[X.lightbulb=55]="lightbulb",X[X.lineDecorationsWidth=56]="lineDecorationsWidth",X[X.lineHeight=57]="lineHeight",X[X.lineNumbers=58]="lineNumbers",X[X.lineNumbersMinChars=59]="lineNumbersMinChars",X[X.linkedEditing=60]="linkedEditing",X[X.links=61]="links",X[X.matchBrackets=62]="matchBrackets",X[X.minimap=63]="minimap",X[X.mouseStyle=64]="mouseStyle",X[X.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=66]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",X[X.multiCursorModifier=68]="multiCursorModifier",X[X.multiCursorPaste=69]="multiCursorPaste",X[X.occurrencesHighlight=70]="occurrencesHighlight",X[X.overviewRulerBorder=71]="overviewRulerBorder",X[X.overviewRulerLanes=72]="overviewRulerLanes",X[X.padding=73]="padding",X[X.parameterHints=74]="parameterHints",X[X.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",X[X.quickSuggestions=77]="quickSuggestions",X[X.quickSuggestionsDelay=78]="quickSuggestionsDelay",X[X.readOnly=79]="readOnly",X[X.renameOnType=80]="renameOnType",X[X.renderControlCharacters=81]="renderControlCharacters",X[X.renderIndentGuides=82]="renderIndentGuides",X[X.renderFinalNewline=83]="renderFinalNewline",X[X.renderLineHighlight=84]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=86]="renderValidationDecorations",X[X.renderWhitespace=87]="renderWhitespace",X[X.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",X[X.roundedSelection=89]="roundedSelection",X[X.rulers=90]="rulers",X[X.scrollbar=91]="scrollbar",X[X.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=93]="scrollBeyondLastLine",X[X.scrollPredominantAxis=94]="scrollPredominantAxis",X[X.selectionClipboard=95]="selectionClipboard",X[X.selectionHighlight=96]="selectionHighlight",X[X.selectOnLineNumbers=97]="selectOnLineNumbers",X[X.showFoldingControls=98]="showFoldingControls",X[X.showUnused=99]="showUnused",X[X.snippetSuggestions=100]="snippetSuggestions",X[X.smartSelect=101]="smartSelect",X[X.smoothScrolling=102]="smoothScrolling",X[X.stickyTabStops=103]="stickyTabStops",X[X.stopRenderingLineAfter=104]="stopRenderingLineAfter",X[X.suggest=105]="suggest",X[X.suggestFontSize=106]="suggestFontSize",X[X.suggestLineHeight=107]="suggestLineHeight",X[X.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",X[X.suggestSelection=109]="suggestSelection",X[X.tabCompletion=110]="tabCompletion",X[X.tabIndex=111]="tabIndex",X[X.unusualLineTerminators=112]="unusualLineTerminators",X[X.useShadowDOM=113]="useShadowDOM",X[X.useTabStops=114]="useTabStops",X[X.wordSeparators=115]="wordSeparators",X[X.wordWrap=116]="wordWrap",X[X.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=119]="wordWrapColumn",X[X.wordWrapOverride1=120]="wordWrapOverride1",X[X.wordWrapOverride2=121]="wordWrapOverride2",X[X.wrappingIndent=122]="wrappingIndent",X[X.wrappingStrategy=123]="wrappingStrategy",X[X.showDeprecated=124]="showDeprecated",X[X.inlayHints=125]="inlayHints",X[X.editorClassName=126]="editorClassName",X[X.pixelRatio=127]="pixelRatio",X[X.tabFocusMode=128]="tabFocusMode",X[X.layoutInfo=129]="layoutInfo",X[X.wrappingInfo=130]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(133,null)})),acceptSuggestionOnEnter:Ee(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(134,null),""],markdownDescription:p.localize(135,null)})),accessibilitySupport:Ee(new g),accessibilityPageSize:Ee(new c(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(136,null)})),ariaLabel:Ee(new _(4,"ariaLabel",p.localize(137,null))),autoClosingBrackets:Ee(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(138,null),p.localize(139,null),""],description:p.localize(140,null)})),autoClosingDelete:Ee(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(141,null),""],description:p.localize(142,null)})),autoClosingOvertype:Ee(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(143,null),""],description:p.localize(144,null)})),autoClosingQuotes:Ee(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(145,null),p.localize(146,null),""],description:p.localize(147,null)})),autoIndent:Ee(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[p.localize(148,null),p.localize(149,null),p.localize(150,null),p.localize(151,null),p.localize(152,null)],description:p.localize(153,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(154,null),p.localize(155,null),p.localize(156,null),""],description:p.localize(157,null)})),stickyTabStops:Ee(new m(103,"stickyTabStops",!1,{description:p.localize(158,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:p.localize(159,null)})),codeLensFontFamily:Ee(new _(13,"codeLensFontFamily","",{description:p.localize(160,null)})),codeLensFontSize:Ee(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(161,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:p.localize(162,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:p.localize(163,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(164,null)})),cursorBlinking:Ee(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:p.localize(165,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(166,null)})),cursorStyle:Ee(new l(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:p.localize(167,null)})),cursorSurroundingLines:Ee(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(168,null)})),cursorSurroundingLinesStyle:Ee(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(169,null),p.localize(170,null)],description:p.localize(171,null)})),cursorWidth:Ee(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(172,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:p.localize(173,null)})),emptySelectionClipboard:Ee(new w),extraEditorClassName:Ee(new _(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new v(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(174,null)})),find:Ee(new E),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:p.localize(175,null)})),foldingStrategy:Ee(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(176,null),p.localize(177,null)],description:p.localize(178,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:p.localize(179,null)})),foldingImportsByDefault:Ee(new m(38,"foldingImportsByDefault",!1,{description:p.localize(180,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(39,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(181,null)})),fontFamily:Ee(new _(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(182,null)})),fontInfo:Ee(new k),fontLigatures2:Ee(new o),fontSize:Ee(new L),fontWeight:Ee(new N),formatOnPaste:Ee(new m(45,"formatOnPaste",!1,{description:p.localize(183,null)})),formatOnType:Ee(new m(46,"formatOnType",!1,{description:p.localize(184,null)})),glyphMargin:Ee(new m(47,"glyphMargin",!0,{description:p.localize(185,null)})),gotoLocation:Ee(new V),hideCursorInOverviewRuler:Ee(new m(49,"hideCursorInOverviewRuler",!1,{description:p.localize(186,null)})),highlightActiveIndentGuide:Ee(new m(50,"highlightActiveIndentGuide",!0,{description:p.localize(187,null)})),hover:Ee(new ee),inDiffEditor:Ee(new m(52,"inDiffEditor",!1)),letterSpacing:Ee(new v(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:p.localize(188,null)})),lightbulb:Ee(new x),lineDecorationsWidth:Ee(new I(56,"lineDecorationsWidth",10)),lineHeight:Ee(new q),lineNumbers:Ee(new ye),lineNumbersMinChars:Ee(new c(59,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(60,"linkedEditing",!1,{description:p.localize(189,null)})),links:Ee(new m(61,"links",!0,{description:p.localize(190,null)})),matchBrackets:Ee(new P(62,"matchBrackets","always",["always","near","never"],{description:p.localize(191,null)})),minimap:Ee(new U),mouseStyle:Ee(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new v(65,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(192,null)})),mouseWheelZoom:Ee(new m(66,"mouseWheelZoom",!1,{markdownDescription:p.localize(193,null)})),multiCursorMergeOverlapping:Ee(new m(67,"multiCursorMergeOverlapping",!0,{description:p.localize(194,null)})),multiCursorModifier:Ee(new l(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[p.localize(195,null),p.localize(196,null)],markdownDescription:p.localize(197,null)})),multiCursorPaste:Ee(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(198,null),p.localize(199,null)],markdownDescription:p.localize(200,null)})),occurrencesHighlight:Ee(new m(70,"occurrencesHighlight",!0,{description:p.localize(201,null)})),overviewRulerBorder:Ee(new m(71,"overviewRulerBorder",!0,{description:p.localize(202,null)})),overviewRulerLanes:Ee(new c(72,"overviewRulerLanes",3,0,3)),padding:Ee(new G),parameterHints:Ee(new $),peekWidgetDefaultFocus:Ee(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(203,null),p.localize(204,null)],description:p.localize(205,null)})),definitionLinkOpensInPeek:Ee(new m(76,"definitionLinkOpensInPeek",!1,{description:p.localize(206,null)})),quickSuggestions:Ee(new re),quickSuggestionsDelay:Ee(new c(78,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(207,null)})),readOnly:Ee(new m(79,"readOnly",!1)),renameOnType:Ee(new m(80,"renameOnType",!1,{description:p.localize(208,null),markdownDeprecationMessage:p.localize(209,null)})),renderControlCharacters:Ee(new m(81,"renderControlCharacters",!1,{description:p.localize(210,null)})),renderIndentGuides:Ee(new m(82,"renderIndentGuides",!0,{description:p.localize(211,null)})),renderFinalNewline:Ee(new m(83,"renderFinalNewline",!0,{description:p.localize(212,null)})),renderLineHighlight:Ee(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(213,null)],description:p.localize(214,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(215,null)})),renderValidationDecorations:Ee(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(216,null),p.localize(217,null),p.localize(218,null),""],description:p.localize(219,null)})),revealHorizontalRightPadding:Ee(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(89,"roundedSelection",!0,{description:p.localize(220,null)})),rulers:Ee(new Le),scrollbar:Ee(new We),scrollBeyondLastColumn:Ee(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(221,null)})),scrollBeyondLastLine:Ee(new m(93,"scrollBeyondLastLine",!0,{description:p.localize(222,null)})),scrollPredominantAxis:Ee(new m(94,"scrollPredominantAxis",!0,{description:p.localize(223,null)})),selectionClipboard:Ee(new m(95,"selectionClipboard",!0,{description:p.localize(224,null),included:R.isLinux})),selectionHighlight:Ee(new m(96,"selectionHighlight",!0,{description:p.localize(225,null)})),selectOnLineNumbers:Ee(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(226,null),p.localize(227,null)],description:p.localize(228,null)})),showUnused:Ee(new m(99,"showUnused",!0,{description:p.localize(229,null)})),showDeprecated:Ee(new m(124,"showDeprecated",!0,{description:p.localize(230,null)})),inlayHints:Ee(new F),snippetSuggestions:Ee(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(231,null),p.localize(232,null),p.localize(233,null),p.localize(234,null)],description:p.localize(235,null)})),smartSelect:Ee(new Z),smoothScrolling:Ee(new m(102,"smoothScrolling",!1,{description:p.localize(236,null)})),stopRenderingLineAfter:Ee(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new W),inlineSuggest:Ee(new je),suggestFontSize:Ee(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(237,null)})),suggestLineHeight:Ee(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(238,null)})),suggestOnTriggerCharacters:Ee(new m(108,"suggestOnTriggerCharacters",!0,{description:p.localize(239,null)})),suggestSelection:Ee(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null)],description:p.localize(243,null)})),tabCompletion:Ee(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(244,null),p.localize(245,null),p.localize(246,null)],description:p.localize(247,null)})),tabIndex:Ee(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),useShadowDOM:Ee(new m(113,"useShadowDOM",!0)),useTabStops:Ee(new m(114,"useTabStops",!0,{description:p.localize(252,null)})),wordSeparators:Ee(new _(115,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:p.localize(253,null)})),wordWrap:Ee(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(254,null),p.localize(255,null),p.localize(256,null),p.localize(257,null)],description:p.localize(258,null)})),wordWrapBreakAfterCharacters:Ee(new _(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new _(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(259,null)})),wordWrapOverride1:Ee(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new l(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[p.localize(260,null),p.localize(261,null),p.localize(262,null),p.localize(263,null)],description:p.localize(264,null)})),wrappingStrategy:Ee(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(265,null),p.localize(266,null)],description:p.localize(267,null)})),editorClassName:Ee(new f),pixelRatio:Ee(new K),tabFocusMode:Ee(new ne),layoutInfo:Ee(new M),wrappingInfo:Ee(new ae)}}),define(me[155],ge([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([18,19]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[160],ge([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([18,19]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[172],ge([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[173],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var p;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var R;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var D;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[179],ge([0,1,157]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||R.test(u)}e.isValidVersionStr=S;function T(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=u.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=T;function C(u){if(!u)return null;let m=u.majorBase,c=u.majorMustEqual,v=u.minorBase,_=u.minorMustEqual,b=u.patchBase,P=u.patchMustEqual;u.hasCaret&&(m===0||(_=!1),P=!1);let l=0;if(u.preRelease){const d=D.exec(u.preRelease);if(d){const[,g,t,r]=d;l=Date.UTC(Number(g),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:c,minorBase:v,minorMustEqual:_,patchBase:b,patchMustEqual:P,isMinimum:u.hasGreaterEquals,notBefore:l}}e.normalizeVersion=C;function y(u,m,c){let v;typeof u=="string"?v=C(T(u)):v=u;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let b;if(typeof c=="string"?b=C(T(c)):b=c,!v||!b)return!1;let P=v.majorBase,l=v.minorBase,d=v.patchBase,g=b.majorBase,t=b.minorBase,r=b.patchBase,s=b.notBefore,n=b.majorMustEqual,a=b.minorMustEqual,h=b.patchMustEqual;return b.isMinimum?P>g?!0:P<g?!1:l>t?!0:l<t||_&&_<s?!1:d>=r:(P===1&&g===0&&(!n||!a||!h)&&(g=1,t=0,r=0,n=!0,a=!1,h=!1),P<g?!1:P>g?!n:l<t?!1:l>t?!a:d<r?!1:d>r?!h:!(_&&_<s))}e.isValidVersion=y;function A(u,m,c,v){return c.isBuiltin||typeof c.main=="undefined"?!0:I(u,m,c.engines.vscode,v)}e.isValidExtensionVersion=A;function i(u,m,c){return u==="*"||I(m,c,u)}e.isEngineValid=i;function I(u,m,c,v=[]){let _=C(T(c));if(!_)return v.push(p.localize(0,null,c)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(p.localize(1,null,c)),!1}else if(!_.majorMustEqual)return v.push(p.localize(2,null,c)),!1;return y(u,m,_)?!0:(v.push(p.localize(3,null,u,c)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,S=[],T=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=p}),define(me[79],ge([0,1,115]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function D(T,C,y){C instanceof p.SyncDescriptor||(C=new p.SyncDescriptor(C,[],y)),R.push([T,C])}e.registerSingleton=D;function S(){return R}e.getSingletonServiceDescriptors=S}),define(me[180],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=p;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let T of this._nodes.values())T.outgoing.size===0&&S.push(T);return S}insertEdge(S,T){const C=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(T);C.outgoing.set(this._hashFn(T),y),y.incoming.set(this._hashFn(S),C)}removeNode(S){const T=this._hashFn(S);this._nodes.delete(T);for(let C of this._nodes.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(S){const T=this._hashFn(S);let C=this._nodes.get(T);return C||(C=new p(S),this._nodes.set(T,C)),C}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[T,C]of this._nodes)S.push(`${T}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,T]of this._nodes){const C=new Set([S]),y=this._findCycle(T,C);if(y)return y}}_findCycle(S,T){for(let[C,y]of S.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const A=this._findCycle(y,T);if(A)return A;T.delete(C)}}}e.Graph=R}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(A){return A[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(C,y,A,i){y[p.DI_TARGET]===y?y[p.DI_DEPENDENCIES].push({id:C,index:A,optional:i}):(y[p.DI_DEPENDENCIES]=[{id:C,index:A,optional:i}],y[p.DI_TARGET]=y)}function D(C){if(p.serviceIds.has(C))return p.serviceIds.get(C);const y=function(A,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,A,I,!1)};return y.toString=()=>C,p.serviceIds.set(C,y),y}e.createDecorator=D;function S(C){return C}e.refineServiceDecorator=S;function T(C){return function(y,A,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(C,y,i,!0)}}e.optional=T}),define(me[181],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,p.createDecorator)("modelService");function R(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[182],ge([0,1,3,58,6,22,75,78,181]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(A):!!u.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(m,c){let v={selector:m,provider:c,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(v){let _=this._entries.indexOf(v);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const c=[];for(let v of this._entries)v._score>0&&c.push(v.provider);return c}ordered(m){const c=[];return this._orderedForEach(m,v=>c.push(v.provider)),c}orderedGroups(m){const c=[];let v,_;return this._orderedForEach(m,b=>{v&&_===b._score?v.push(b.provider):(_=b._score,v=[b.provider],c.push(v))}),c}_orderedForEach(m,c){if(!!m){this._updateScores(m);for(const v of this._entries)v._score>0&&c(v)}}_updateScores(m){let c={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let v of this._entries)if(v._score=(0,C.score)(v.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),A(v.selector)&&v._score>0){for(let _ of this._entries)_._score=0;v._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(m,c){return m._score<c._score?1:m._score>c._score?-1:m._time<c._time?1:m._time>c._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(m,c,v=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=c,this.max=v,this._cache=new S.LRUCache(50,.7)}_key(m){return m.id+(0,R.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const c=this._key(m),v=this._cache.get(c);return this._clamp(v?.value)}update(m,c){const v=this._key(m);let _=this._cache.get(v);return _||(_=new T.MovingAverage,this._cache.set(v,_)),_.update(c),this.get(m)}}e.LanguageFeatureRequestDelays=I}),define(me[80],ge([0,1,2,41,182,148,45]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class y{constructor(k,L){this.language=k,this.id=L}}e.LanguageIdentifier=y;var A;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var i;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let L=this.getForeground(k),N="mtk"+L,V=this.getFontStyle(k);return V&1&&(N+=" mtki"),V&2&&(N+=" mtkb"),V&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(k,L){const N=this.getForeground(k),V=this.getFontStyle(k);let ee=`color: ${L[N]};`;return V&1&&(ee+="font-style: italic;"),V&2&&(ee+="font-weight: bold;"),V&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var c;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(k){const L=o[k];let N=L&&T.iconRegistry.get(L);return N||(console.info("No codicon found for CompletionItemKind "+k),N=T.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(k,L){let N=o[k];return typeof N=="undefined"&&!L&&(N=9),N}}();var v;(function(o){o[o.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&p.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(o){const k=new Map;k.set("file",0),k.set("module",1),k.set("namespace",2),k.set("package",3),k.set("class",4),k.set("method",5),k.set("property",6),k.set("field",7),k.set("constructor",8),k.set("enum",9),k.set("interface",10),k.set("function",11),k.set("variable",12),k.set("constant",13),k.set("string",14),k.set("number",15),k.set("boolean",16),k.set("array",17),k.set("object",18),k.set("key",19),k.set("null",20),k.set("enum-member",21),k.set("struct",22),k.set("event",23),k.set("operator",24),k.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function N(z){return k.get(z)}o.fromString=N;function V(z){return L.get(z)}o.toString=V;function ee(z,M){const x=L.get(z);let F=x&&T.iconRegistry.get("symbol-"+x);return F||(console.info("No codicon found for SymbolKind "+z),F=T.Codicon.symbolProperty),`${M?"inline":"block"} ${F.classNames}`}o.toCssClassName=ee})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(k){this.value=k}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var h;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var w;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var E;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,8,4,11]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=D.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",S.indexOf("Edg/")>=0),T.set("isFirefox",S.indexOf("Firefox")>=0),T.set("isChrome",S.indexOf("Chrome")>=0),T.set("isSafari",S.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var y;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return I.INSTANCE}static true(){return u.INSTANCE}static has(o){return m.create(o)}static equals(o,k){return c.create(o,k)}static notEquals(o,k){return b.create(o,k)}static regex(o,k){return r.create(o,k)}static in(o,k){return v.create(o,k)}static not(o){return P.create(o)}static and(...o){return n.create(o)}static or(...o){return a.create(o)}static greater(o,k){return l.create(o,k)}static less(o,k){return g.create(o,k)}static deserialize(o,k=!1){if(!!o)return this._deserializeOrExpression(o,k)}static _deserializeOrExpression(o,k){let L=o.split("||");return a.create(L.map(N=>this._deserializeAndExpression(N,k)))}static _deserializeAndExpression(o,k){let L=o.split("&&");return n.create(L.map(N=>this._deserializeOne(N,k)))}static _deserializeOne(o,k){if(o=o.trim(),o.indexOf("!=")>=0){let L=o.split("!=");return b.create(L[0].trim(),this._deserializeValue(L[1],k))}if(o.indexOf("==")>=0){let L=o.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],k))}if(o.indexOf("=~")>=0){let L=o.split("=~");return r.create(L[0].trim(),this._deserializeRegexValue(L[1],k))}if(o.indexOf(" in ")>=0){let L=o.split(" in ");return v.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const L=o.split(">=");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const L=o.split(">");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const L=o.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const L=o.split("<");return g.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(o)?P.create(o.substr(1).trim()):m.create(o)}static _deserializeValue(o,k){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let L=/^'([^']*)'$/.exec(o);return L?L[1].trim():o}static _deserializeRegexValue(o,k){if((0,p.isFalsyOrWhitespace)(o)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=o.indexOf("/"),N=o.lastIndexOf("/");if(L===N||L<0){if(k)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let V=o.slice(L+1,N),ee=o[N+1]==="i"?"i":"";try{return new RegExp(V,ee)}catch(z){if(k)throw new Error(`bad regexp-value '${o}', parse error: ${z}`);return console.warn(`bad regexp-value '${o}', parse error: ${z}`),null}}}e.ContextKeyExpr=A;function i(E,o){return E.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class u{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class m{constructor(o){this.key=o,this.type=2}static create(o){const k=T.get(o);return typeof k=="boolean"?k?u.INSTANCE:I.INSTANCE:new m(o)}cmp(o){return o.type!==this.type?this.type-o.type:f(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=m;class c{constructor(o,k){this.key=o,this.value=k,this.type=4}static create(o,k){if(typeof k=="boolean")return k?m.create(o):P.create(o);const L=T.get(o);return typeof L=="boolean"?k===(L?"true":"false")?u.INSTANCE:I.INSTANCE:new c(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class v{constructor(o,k){this.key=o,this.valueKey=k,this.type=10}static create(o,k){return new v(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const k=o.getValue(this.valueKey),L=o.getValue(this.key);return Array.isArray(k)?k.indexOf(L)>=0:typeof L=="string"&&typeof k=="object"&&k!==null?C.call(k,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=v;class _{constructor(o){this._actual=o,this.type=11}static create(o){return new _(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new _(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class b{constructor(o,k){this.key=o,this.value=k,this.type=5}static create(o,k){if(typeof k=="boolean")return k?P.create(o):m.create(o);const L=T.get(o);return typeof L=="boolean"?k===(L?"true":"false")?I.INSTANCE:u.INSTANCE:new b(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class P{constructor(o){this.key=o,this.type=3}static create(o){const k=T.get(o);return typeof k=="boolean"?k?I.INSTANCE:u.INSTANCE:new P(o)}cmp(o){return o.type!==this.type?this.type-o.type:f(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=P;class l{constructor(o,k){this.key=o,this.value=k,this.type=12}static create(o,k){return new l(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class d{constructor(o,k){this.key=o,this.value=k,this.type=13}static create(o,k){return new d(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class g{constructor(o,k){this.key=o,this.value=k,this.type=14}static create(o,k){return new g(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(o,k){this.key=o,this.value=k,this.type=15}static create(o,k){return new t(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,k){this.key=o,this.regexp=k,this.type=7}static create(o,k){return new r(o,k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const k=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return k<L?-1:k>L?1:0}equals(o){if(o.type===this.type){const k=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return this.key===o.key&&k===L}return!1}evaluate(o){let k=o.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class n{constructor(o){this.expr=o,this.type=6}static create(o){return n._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,L=this.expr.length;k<L;k++){const N=i(this.expr[k],o.expr[k]);if(N!==0)return N}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].evaluate(o))return!1;return!0}static _normalizeArr(o){const k=[];let L=!1;for(const N of o)if(!!N){if(N.type===1){L=!0;continue}if(N.type===0)return I.INSTANCE;if(N.type===6){k.push(...N.expr);continue}k.push(N)}if(k.length===0&&L)return u.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(i);k.length>1;){const N=k[k.length-1];if(N.type!==9)break;k.pop();const V=k.pop(),ee=a.create(N.expr.map(z=>n.create([z,V])));ee&&(k.push(ee),k.sort(i))}return k.length===1?k[0]:new n(k)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new n(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let k of this.expr)o.push(k.negate());return a.create(o)}}e.ContextKeyAndExpr=n;class a{constructor(o){this.expr=o,this.type=9}static create(o){const k=a._normalizeArr(o);if(k.length!==0)return k.length===1?k[0]:new a(k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,L=this.expr.length;k<L;k++){const N=i(this.expr[k],o.expr[k]);if(N!==0)return N}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,L=this.expr.length;k<L;k++)if(this.expr[k].evaluate(o))return!0;return!1}static _normalizeArr(o){let k=[],L=!1;if(o){for(let N=0,V=o.length;N<V;N++){const ee=o[N];if(!!ee){if(ee.type===0){L=!0;continue}if(ee.type===1)return[u.INSTANCE];if(ee.type===9){k=k.concat(ee.expr);continue}k.push(ee)}}if(k.length===0&&L)return[I.INSTANCE];k.sort(i)}return k}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new a(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());const k=L=>L.type===9?L.expr:[L];for(;o.length>1;){const L=o.shift(),N=o.shift(),V=[];for(const ee of k(L))for(const z of k(N))V.push(A.and(ee,z));o.unshift(A.or(...V))}return o[0]}}e.ContextKeyOrExpr=a;class h extends m{constructor(o,k,L){super(o);this._defaultValue=k,typeof L=="object"?h._info.push({...L,key:o}):L!==!0&&h._info.push({key:o,description:L,type:k!=null?typeof k:void 0})}static all(){return h._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return A.not(this.key)}isEqualTo(o){return A.equals(this.key,o)}notEqualsTo(o){return A.notEquals(this.key,o)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(E,o){return E<o?-1:E>o?1:0}function w(E,o,k,L){return E<k?-1:E>k?1:o<L?-1:o>L?1:0}}),define(me[183],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(me[184],ge([0,1,156,4,10]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=S;var T;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var C;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var y;(function(I){I.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var A;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(A=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(u,m){super(u);this.code=m,this.name=m}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=D;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,u){if(typeof I=="undefined"||I===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof I=="string"||typeof u=="string"){let m=typeof I=="string"?I:I.value,c=typeof u=="string"?u:u.value;return p.equalsIgnoreCase(m,c)}return I._lower===u._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function y(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function A(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[185],ge([0,1,8,26]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(c,v){return c.uuid&&v.uuid?c.uuid===v.uuid:c.id===v.id?!0:(0,p.compareIgnoreCase)(c.id,v.id)===0}e.areSameExtensions=D;class S{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof S?D(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=S;function T(c,v){return`${c}.${v}`}e.getExtensionId=T;function C(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(c,v){return C(T(c,v))}e.getGalleryExtensionId=y;function A(c,v){const _=[],b=P=>{for(const l of _)if(l.some(d=>D(v(d),v(P))))return l;return null};for(const P of c){const l=b(P);l?l.push(P):_.push([P])}return _}e.groupByExtension=A;function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function u(c){const v=new Set;for(const _ of c)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=u;function m(c,v){const _=[],b=v.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&_.every(l=>!D(l.identifier,{id:P}))){const l=c.filter(d=>D(d.identifier,{id:P}));l.length===1&&(_.push(l[0]),b.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=m}),define(me[186],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(me[187],ge([0,1,39,9,113,158,28,11,186,10,140]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=S.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends u{openTerminal(d,g){return this.spawnTerminal(p,d,D.getWindowsShell(),g)}spawnTerminal(d,g,t,r){const s=g.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=R.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return d.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(n==="wt"||n==="wt.exe")&&a.push("-d ."),new Promise((h,f)=>{const w=_(process),E=d.spawn(t,a,{cwd:r,env:w});E.on("error",f),E.on("exit",()=>h())})}runInTerminal(d,g,t,r,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,h)=>{const f=`"${g} - ${I}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",f,"/wait",n,"/c",w],o=Object.assign({},_(process),r);Object.keys(o).filter(N=>o[N]===null).forEach(N=>delete o[N]);const k={cwd:g,env:o,windowsVerbatimArguments:!0};p.spawn(m.CMD,E,k).on("error",N=>{h(b(N))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class c extends u{openTerminal(d,g){return this.spawnTerminal(p,d,g)}runInTerminal(d,g,t,r,s){const n=s.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((a,h)=>{if(n===y.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const f=n===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,J).fsPath,"-t",d||I,"-w",g];for(let L of t)E.push("-a"),E.push(L);if(r){const L=Object.assign({},_(process),r);for(let N in L){const V=L[N];V===null?(E.push("-u"),E.push(N)):(E.push("-e"),E.push(`${N}=${V}`))}}let o="";const k=p.spawn(c.OSASCRIPT,E);k.on("error",L=>{h(b(L))}),k.stderr.on("data",L=>{o+=L.toString()}),k.on("exit",L=>{if(L===0)a(void 0);else if(o){const N=o.split(`
`,1);h(new Error(N[0]))}else h(new Error(S.localize(1,null,f,L)))})}else h(new Error(S.localize(2,null,n)))})}spawnTerminal(d,g,t){const r=g.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const a=["-a",r];t&&a.push(t);const h=_(process),f=d.spawn("/usr/bin/open",a,{cwd:t,env:h});f.on("error",n),f.on("exit",()=>s())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(d,g){return this.spawnTerminal(p,d,g)}runInTerminal(d,g,t,r,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,h)=>{let f=[];n.then(w=>{w.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const E=`${P(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;f.push(`''${E}''`);const o=Object.assign({},_(process),r);Object.keys(o).filter(V=>o[V]===null).forEach(V=>delete o[V]);const k={cwd:g,env:o};let L="";const N=p.spawn(w,f,k);N.on("error",V=>{h(b(V))}),N.stderr.on("data",V=>{L+=V.toString()}),N.on("exit",V=>{if(V===0)a(void 0);else if(L){const ee=L.split(`
`,1);h(new Error(ee[0]))}else h(new Error(S.localize(4,null,w,V)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{C.isLinux?await T.Promises.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,g,t){const r=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{r.then(a=>{const h=_(process),f=d.spawn(a,[],{cwd:t,env:h});f.on("error",n),f.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=S.localize(3,null);function _(l){const d=l.env;return(0,i.sanitizeProcessEnvironment)(d),d}function b(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(S.localize(5,null,l.path)):l}function P(l){let d="";for(let g of l)g.indexOf(" ")>=0?d+='"'+g+'"':d+=g,d+=" ";return d}}),define(me[42],ge([0,1,159,9,2,4,8,14,22]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(M){return M.create===!0}e.isFileOpenForWriteOptions=A;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var u;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=m;function c(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=c;function v(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=_;var b;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(x,F){super(x);this.code=F}}e.FileSystemProviderError=P;function l(M,x){const F=new P(M.toString(),x);return g(F,x),F}e.createFileSystemProviderError=l;function d(M){return M||l((0,p.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=d;function g(M,x){return M.name=x?`${x} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function t(M){if(!M)return b.Unknown;if(M instanceof P)return M.code;const x=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof w)return M.fileOperationResult;switch(t(M)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(x,F,q){this.resource=x,this.operation=F,this.target=q}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var a;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(x,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of x)switch(q.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>F)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>F)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>F)),this.deleted.set(q.resource,q);break}}contains(x,...F){return this.doContains(x,{includeChildren:!1},...F)}affects(x,...F){return this.doContains(x,{includeChildren:!0},...F)}doContains(x,F,...q){if(!x)return!1;const U=q.length>0;return!!((!U||q.includes(1))&&(this.added?.get(x)||F.includeChildren&&this.added?.findSuperstr(x))||(!U||q.includes(0))&&(this.updated?.get(x)||F.includeChildren&&this.updated?.findSuperstr(x))||(!U||q.includes(2))&&(this.deleted?.findSubstr(x)||F.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function f(M,x,F){return!M||!x||M===x||x.length>M.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),F?(0,T.startsWithIgnoreCase)(M,x):M.indexOf(x)===0)}e.isParent=f;class w extends Error{constructor(x,F,q){super(x);this.fileOperationResult=F,this.options=q}}e.FileOperationError=w;class E extends w{constructor(x,F,q){super(x,2,q);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var o;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=L;async function N(M,x){if(!x.canHandleResource(D.URI.from({scheme:M.scheme})))return new Promise(F=>{const q=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===M.scheme&&U.added&&(q.dispose(),F())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(x){return(0,C.isNumber)(x)||(x=0),x<V.KB?(0,p.localize)(1,null,x.toFixed(0)):x<V.MB?(0,p.localize)(2,null,(x/V.KB).toFixed(2)):x<V.GB?(0,p.localize)(3,null,(x/V.MB).toFixed(2)):x<V.TB?(0,p.localize)(4,null,(x/V.GB).toFixed(2)):(0,p.localize)(5,null,(x/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var ee;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(ee=e.Arch||(e.Arch={}));function z(M){return{maxFileSize:M===0?300*V.MB:16*V.GB,maxHeapSize:M===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=z}),define(me[81],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[S,T]of D)this.set(S,T)}set(D,S){const T=this._entries.get(D);return this._entries.set(D,S),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(me[188],ge([0,1,15,180,115,4,81,16]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class A extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class i{constructor(c=new T.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=c,this._strict=v,this._parent=_,this._services.set(S.IInstantiationService,this)}createChild(c){return new i(c,this._strict,this)}invokeFunction(c,...v){let _=u.traceInvocation(c),b=!1;try{return c({get:(l,d)=>{if(b)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(l,_);if(!g&&d!==S.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return g}},...v)}finally{b=!0,_.stop()}}createInstance(c,...v){let _,b;return c instanceof D.SyncDescriptor?(_=u.traceCreation(c.ctor),b=this._createInstance(c.ctor,c.staticArguments.concat(v),_)):(_=u.traceCreation(c),b=this._createInstance(c,v,_)),_.stop(),b}_createInstance(c,v=[],_){let b=S._util.getServiceDependencies(c).sort((d,g)=>d.index-g.index),P=[];for(const d of b){let g=this._getOrCreateServiceInstance(d.id,_);if(!g&&this._strict&&!d.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${d.id}.`);P.push(g)}let l=b.length>0?b[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${v.length} static arguments`);let d=l-v.length;d>0?v=v.concat(new Array(d)):v=v.slice(0,l)}return new c(...[...v,...P])}_setServiceInstance(c,v){if(this._services.get(c)instanceof D.SyncDescriptor)this._services.set(c,v);else if(this._parent)this._parent._setServiceInstance(c,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let v=this._services.get(c);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):v}_getOrCreateServiceInstance(c,v){let _=this._getServiceInstanceOrDescriptor(c);return _ instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,_,v.branch(c,!0)):(v.branch(c,!1),_)}_safeCreateAndCacheServiceInstance(c,v,_){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,v,_)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,v,_){const b=new R.Graph(d=>d.id.toString());let P=0;const l=[{id:c,desc:v,_trace:_}];for(;l.length;){const d=l.pop();if(b.lookupOrInsertNode(d),P++>1e3)throw new A(b);for(let g of S._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${c} depends on ${g.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:g.id,desc:t,_trace:d._trace.branch(g.id,!0)};b.insertEdge(d,r),l.push(r)}}}for(;;){const d=b.roots();if(d.length===0){if(!b.isEmpty())throw new A(b);break}for(const{data:g}of d){if(this._getServiceInstanceOrDescriptor(g.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,r)}b.removeNode(g)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,v,_=[],b,P){if(this._services.get(c)instanceof D.SyncDescriptor)return this._createServiceInstance(v,_,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,v,_,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(c,v=[],_,b){if(_){const P=new C.IdleValue(()=>this._createInstance(c,v,b));return new Proxy(Object.create(null),{get(l,d){if(d in l)return l[d];let g=P.value,t=g[d];return typeof t!="function"||(t=t.bind(g),l[d]=t),t},set(l,d,g){return P.value[d]=g,!0}})}else return this._createInstance(c,v,b)}}e.InstantiationService=i;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class u{constructor(c,v){this.type=c,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return y?new u(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(c){return y?new u(0,c.name):u._None}branch(c,v){let _=new u(2,c.toString());return this._dep.push([c,v,_]),_}stop(){let c=Date.now()-this._start;u._totals+=c;let v=!1;function _(P,l){let d=[],g=new Array(P+1).join("	");for(const[t,r,s]of l._dep)if(r&&s){v=!0,d.push(`${g}CREATES -> ${t}`);let n=_(P+1,s);n&&d.push(n)}else d.push(`${g}uses -> ${t}`);return d.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(c>2||v)&&console.log(b.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(me[12],ge([0,1,4,6,11,3,60]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function C(){return new Date().toISOString()}var y;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class A extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class i extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}r+=(s>0?" ":"")+n}return r}}e.AbstractMessageLogger=i;class I extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class u extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=u;class m extends A{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,T.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class c extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class v extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class _ extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function P(g){if(g.verbose)return y.Trace;if(typeof g.logLevel=="string"){const t=l(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function l(g){switch(g){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=l;function d(g){switch(g){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=d}),define(me[116],ge([0,1,12,42]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(y,A,i,I){try{const u=await new Promise((m,c)=>{J(["spdlog"],m,c)});return u.setFlushOn(p.LogLevel.Trace),u.createAsyncRotatingLogger(y,A,i,I)}catch(u){console.error(u)}return null}function S(y,A,i,I){const u=J.__$__nodeRequire("spdlog");return u.setFlushOn(p.LogLevel.Trace),u.createRotatingLogger(y,A,i,I)}e.createRotatingLogger=S;function T(y,A,i){switch(A){case p.LogLevel.Trace:y.trace(i);break;case p.LogLevel.Debug:y.debug(i);break;case p.LogLevel.Info:y.info(i);break;case p.LogLevel.Warning:y.warn(i);break;case p.LogLevel.Error:y.error(i);break;case p.LogLevel.Critical:y.critical(i);break;default:throw new Error("Invalid log level")}}class C extends p.AbstractMessageLogger{constructor(A,i,I,u){super();this.name=A,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const A=this.rotating?6:1,i=30/A*R.ByteSize.MB;return D(this.name,this.filepath,i,A).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:u,message:m}of this.buffer)T(this._logger,u,m);this.buffer=[]}})}log(A,i){this._logger?T(this._logger,A,i):this.getLevel()<=A&&this.buffer.push({level:A,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[117],ge([0,1,4,160,46]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function A(c,v){return v-c}y.compare=A;const i=Object.create(null);i[y.Error]=(0,R.localize)(0,null),i[y.Warning]=(0,R.localize)(1,null),i[y.Info]=(0,R.localize)(2,null);function I(c){return i[c]||""}y.toString=I;function u(c){switch(c){case D.default.Error:return y.Error;case D.default.Warning:return y.Warning;case D.default.Info:return y.Info;case D.default.Ignore:return y.Hint}}y.fromSeverity=u;function m(c){switch(c){case y.Error:return D.default.Error;case y.Warning:return D.default.Warning;case y.Info:return D.default.Info;case y.Hint:return D.default.Ignore}}y.toSeverity=m}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(y){const A="";function i(u){return I(u,!0)}y.makeKey=i;function I(u,m){let c=[A];return u.source?c.push(u.source.replace("\xA6","\\\xA6")):c.push(A),u.code?typeof u.code=="string"?c.push(u.code.replace("\xA6","\\\xA6")):c.push(u.code.value.replace("\xA6","\\\xA6")):c.push(A),u.severity!==void 0&&u.severity!==null?c.push(T.toString(u.severity)):c.push(A),u.message&&m?c.push(u.message.replace("\xA6","\\\xA6")):c.push(A),u.startLineNumber!==void 0&&u.startLineNumber!==null?c.push(u.startLineNumber.toString()):c.push(A),u.startColumn!==void 0&&u.startColumn!==null?c.push(u.startColumn.toString()):c.push(A),u.endLineNumber!==void 0&&u.endLineNumber!==null?c.push(u.endLineNumber.toString()):c.push(A),u.endColumn!==void 0&&u.endColumn!==null?c.push(u.endColumn.toString()):c.push(A),c.push(A),c.join("\xA6")}y.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(me[189],ge([0,1,46,4,3]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,R.createDecorator)("notificationService");var S;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class y{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=y}),define(me[190],ge([0,1,6,8,2,4]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function T(C,y){return D.URI.isUri(C)?(0,R.equalsIgnoreCase)(C.scheme,y):(0,R.startsWithIgnoreCase)(C,y+":")}e.matchesScheme=T}),define(me[191],ge([0,1,10,11,38,24]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const C=R.globals.vscode.context.configuration();if(C)T=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,S.dirname)(p.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,S.joinPath)(C,"product.json").fsPath);const y=J.__$__nodeRequire((0,S.joinPath)(C,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:y.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.59.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var $e=this&&this.__param||function(J,e){return function(p,R){e(p,R,J)}};define(me[118],ge([0,1,4,21,6,16]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,p.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let y=class extends D.Disposable{constructor(I,u){super();this.deferred=new S.DeferredPromise,u.withProgress(I,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=Ve([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class A extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const u=++this.currentOperationId,m=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:m.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,p.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,14,54]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,C){R.ok(p.isString(T)),R.ok(p.isObject(C)),R.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,C)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(me[119],ge([0,1,34,3]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,A){this.schemasById[D(y)]=A,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new S;p.Registry.add(e.Extensions.JSONContribution,T)}),define(me[82],ge([0,1,155,3,34,14,119]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=D.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,l=!0){this.registerConfigurations([P],l)}registerConfigurations(P,l=!0){const d=[];P.forEach(g=>{d.push(...this.validateAndRegisterProperties(g,l,g.extensionInfo)),this.configurationContributors.push(g),this.registerJSONConfiguration(g)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(P){const l=[],d=g=>{if(g.properties)for(const t in g.properties)l.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,g.properties[t]);g.allOf&&g.allOf.forEach(t=>d(t))};for(const g of P){d(g);const t=this.configurationContributors.indexOf(g);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(P){const l=[],d=[];for(const g of P)for(const t in g)if(l.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...g[t]};const r={type:"object",default:this.defaultValues[t],description:p.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};d.push(u(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=g[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(P){const l=[];for(const d of P)for(const g in d)if(l.push(g),delete this.defaultValues[g],e.OVERRIDE_PROPERTY_PATTERN.test(g))delete this.configurationProperties[g],delete this.defaultLanguageConfigurationOverridesNode.properties[g];else{const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const l of P)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,l=!0,d,g=3){g=S.isUndefinedOrNull(P.scope)?g:P.scope;let t=[],r=P.properties;if(r)for(let n in r){if(l&&v(n)){delete r[n];continue}const a=r[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=S.isUndefinedOrNull(a.scope)?g:a.scope,a.restricted=S.isUndefinedOrNull(a.restricted)?!!d?.restrictedConfigurations?.includes(n):a.restricted),r[n].hasOwnProperty("included")&&!r[n].included){this.excludedConfigurationProperties[n]=r[n],delete r[n];continue}else this.configurationProperties[n]=r[n];!r[n].deprecationMessage&&r[n].markdownDeprecationMessage&&(r[n].deprecationMessage=r[n].markdownDeprecationMessage),t.push(n)}let s=P.allOf;if(s)for(let n of s)t.push(...this.validateAndRegisterProperties(n,l,d,g));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const l=d=>{let g=d.properties;if(g)for(const r in g)this.updateSchema(r,g[r]);let t=d.allOf;t&&t.forEach(l)};l(P)}updateSchema(P,l){switch(e.allSettings.properties[P]=l,l.scope){case 1:e.applicationSettings.properties[P]=l;break;case 2:e.machineSettings.properties[P]=l;break;case 6:e.machineOverridableSettings.properties[P]=l;break;case 3:e.windowSettings.properties[P]=l;break;case 4:e.resourceSettings.properties[P]=l;break;case 5:e.resourceSettings.properties[P]=l,this.resourceLanguageSettingsSchema.properties[P]=l;break}}removeFromSchema(P,l){switch(delete e.allSettings.properties[P],l.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const l=`[${P}]`,d={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,d),e.allSettings.properties[l]=d,e.applicationSettings.properties[l]=d,e.machineSettings.properties[l]=d,e.machineOverridableSettings.properties[l]=d,e.windowSettings.properties[l]=d,e.resourceSettings.properties[l]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,l){let d=this.defaultValues[P];S.isUndefined(d)&&(d=l.default),S.isUndefined(d)&&(d=m(l.type)),l.default=d}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function u(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=u;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const c=new i;D.Registry.add(e.Extensions.Configuration,c);function v(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?p.localize(5,null,b):c.getConfigurationProperties()[b]!==void 0?p.localize(6,null,b):null:p.localize(4,null)}e.validateProperty=v;function _(){const b=[],P=c.getConfigurationProperties();for(const l of Object.keys(P))b.push([l,P[l].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=_}),define(me[120],ge([0,1,25,14,2,34,4,82]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=y;var A;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,s){const n=s?r?s.keys.filter(k=>r.keys.indexOf(k)===-1):[...s.keys]:[],a=r?s?r.keys.filter(k=>s.keys.indexOf(k)===-1):[...r.keys]:[],h=[];if(s&&r){for(const k of r.keys)if(s.keys.indexOf(k)!==-1){const L=b(r.contents,k),N=b(s.contents,k);p.equals(L,N)||h.push(k)}}const f=[],w=k=>{const L={};for(const N of k)for(const V of N.identifiers)L[g(V)]=N;return L},E=s?w(s.overrides):{},o=r?w(r.overrides):{};if(Object.keys(E).length)for(const k of n){const L=E[k];L&&f.push([(0,C.overrideIdentifierFromKey)(k),L.keys])}if(Object.keys(o).length)for(const k of a){const L=o[k];L&&f.push([(0,C.overrideIdentifierFromKey)(k),L.keys])}if(Object.keys(E).length&&Object.keys(o).length)for(const k of h){const L=o[k],N=E[k];if(L&&N){const V=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});f.push([(0,C.overrideIdentifierFromKey)(k),[...V.added,...V.removed,...V.updated]])}}return{added:n,removed:a,updated:h,overrides:f}}e.compare=I;function u(r,s){const n=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const f in r[a])h[f]=r[a][f];n.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:m(h,s)})}return n}e.toOverrides=u;function m(r,s){const n=Object.create(null);for(let a in r)c(n,a,r[a],s);return n}e.toValuesTree=m;function c(r,s,n,a){const h=s.split("."),f=h.pop();let w=r;for(let E=0;E<h.length;E++){let o=h[E],k=w[o];switch(typeof k){case"undefined":k=w[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${h.slice(0,E+1).join(".")} is ${JSON.stringify(k)}`);return}w=k}if(typeof w=="object"&&w!==null)try{w[f]=n}catch(E){a(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(w)}`)}else a(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=c;function v(r,s){const n=s.split(".");_(r,n)}e.removeFromValueTree=v;function _(r,s){const n=s.shift();if(s.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const a=r[n];typeof a=="object"&&!Array.isArray(a)&&(_(a,s),Object.keys(a).length===0&&delete r[n])}}function b(r,s,n){function a(w,E){let o=w;for(const k of E){if(typeof o!="object"||o===null)return;o=o[k]}return o}const h=s.split("."),f=a(r,h);return typeof f=="undefined"?n:f}e.getConfigurationValue=b;function P(r,s,n){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in r?R.isObject(r[a])&&R.isObject(s[a])?P(r[a],s[a],n):n&&(r[a]=s[a]):r[a]=s[a])})}e.merge=P;function l(){const r=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=l;function d(){const r=Object.create(null),s=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let n in s){let a=s[n].default;c(r,n,a,h=>console.error(`Conflict in default settings: ${h}`))}return r}e.getDefaultValues=d;function g(r){return`[${r}]`}e.keyFromOverrideIdentifier=g;function t(r,s,n){const a=r.inspect(s),h=r.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,57,22,20,14,25,2,82,120,34,6,3]),function(J,e,p,R,D,S,T,C,y,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,A.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,A.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[n],h=r[n];h&&(typeof a=="object"&&typeof h=="object"?(a=T.deepClone(a),this.mergeContents(a,h)):a=h),s[n]=a}return new m(s,this.keys,this.overrides)}merge(...t){const r=T.deepClone(this.contents),s=T.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const h of a.overrides){const[f]=s.filter(w=>D.equals(w.identifiers,h.identifiers));f?this.mergeContents(f.contents,h.contents):s.push(T.deepClone(h))}for(const h of a.keys)n.indexOf(h)===-1&&n.push(h)}return new m(r,n,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=T.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,A.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,A.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class c extends m{constructor(){const t=(0,A.getDefaultValues)(),r=(0,A.getConfigurationKeys)(),s=[];for(const n of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,A.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,s)}}e.DefaultConfigurationModel=c;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:n,overrides:a,restricted:h}=this.doParseRaw(t,r);this._configurationModel=new m(s,n,a),this._restrictedConfigurations=h||[]}doParseContent(t){let r={},s=null,n=[],a=[],h=[];function f(E){Array.isArray(n)?n.push(E):s!==null&&(n[s]=E)}let w={onObjectBegin:()=>{let E={};f(E),a.push(n),n=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let E=[];f(E),a.push(n),n=E,s=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:f,onError:(E,o,k)=>{h.push({error:E,offset:o,length:k})}};if(t)try{p.visit(t,w),r=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const s=i.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,r);t=n.raw;const a=(0,A.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),h=Object.keys(t),f=(0,A.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:h,overrides:f,restricted:n.restricted}}filter(t,r,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},h=[];for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const w=this.filter(t[f],r,!1,n);a[f]=w.raw,h.push(...w.restricted)}else{const w=r[f],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&h.push(f),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&w?.restricted||(a[f]=t[f]))}return{raw:a,restricted:h}}}e.ConfigurationModelParser=v;class _ extends I.Disposable{constructor(t,r,s,n){super();this.userSettingsResource=t,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new u.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(u.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class b{constructor(t,r,s=new m,n=new m,a=new R.ResourceMap,h=new m,f=new R.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=f,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new m,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(t):n.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const n=this.getConsolidateConfigurationModel(r,s),a=this.getFolderConfigurationModelForResource(r.resource,s),h=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,f=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,N=r.overrideIdentifier?h.override(r.overrideIdentifier).getValue(t):h.getValue(t),V=n.getValue(t),ee=D.distinct(D.flatten(n.overrides.map(z=>z.identifiers))).filter(z=>n.getOverrideValue(t,z)!==void 0);return{defaultValue:f,userValue:w,userLocalValue:E,userRemoteValue:o,workspaceValue:k,workspaceFolderValue:L,memoryValue:N,value:V,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:a?.freeze().getValue(t),override:r.overrideIdentifier?a?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:h.getValue(t),override:r.overrideIdentifier?h.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(n=>y.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,y.overrideIdentifierFromKey)(n),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=t.getKeysForOverrideIdentifier(a),w=[...f.filter(E=>h.indexOf(E)===-1),...h.filter(E=>f.indexOf(E)===-1),...h.filter(E=>!T.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:n,overrides:a}=(0,A.compare)(this.localUserConfiguration,t),h=[...r,...s,...n];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:n,overrides:a}=(0,A.compare)(this.remoteUserConfiguration,t);let h=[...r,...s,...n];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:n,overrides:a}=(0,A.compare)(this.workspaceConfiguration,t);let h=[...r,...s,...n];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:n,updated:a,removed:h,overrides:f}=(0,A.compare)(s,r);let w=[...n,...a,...h];return(w.length||!s)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:f}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:a,overrides:h}=(0,A.compare)(r,void 0);return{keys:[...s,...n,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const n=r.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(r=s.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:n,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((h,f)=>(h.set(C.URI.revive(f[0]),this.parseConfigurationModel(f[1])),h),new R.ResourceMap);return new b(r,s,new m,n,a,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function P(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,r=new Map;for(const n of g)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,h])=>{const f=(0,R.getOrSet)(r,a,new Set);h.forEach(w=>f.add(w))});const s=[];return r.forEach((n,a)=>s.push([a,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=P;class l{constructor(t,r,s,n){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(f=>a.add(f)),t.overrides.forEach(([,f])=>f.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const h=new m;this.affectedKeys.forEach(f=>h.setValue(f,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!T.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,A.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=l;class d extends l{constructor(t,r,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=d}),define(me[121],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(T,C=R.Unknown,y){super(T);this._message=T,this._code=C,this._detail=y,this.isHandled=C===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(T){return T instanceof D&&T._code===R.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof D&&T._code===R.NoResolverFound}static isHandled(T){return T instanceof D&&T.isHandled}}e.RemoteAuthorityResolverError=D}),define(me[83],ge([0,1,10]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(A){return A.scheme===p.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=R;function D(A){if(!A)return;const i=A.indexOf("+");return i<0?A:A.substr(0,i)}e.getRemoteName=D;function S(A){return A.scheme!==p.Schemas.file&&A.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=S;function T(A){if(A.folders.length)return A.folders.every(i=>S(i.uri))?A.folders[0].uri:void 0;if(A.configuration&&S(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function C(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=C;function y(A){return T(A)!==void 0}e.isVirtualWorkspace=y}),define(me[193],ge([0,1,3,11,4,12]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=i;function I(m,c){return c?c!==1&&m<1024:!R.isWindows&&m<1024}e.isPortPrivileged=I;let u=class{constructor(c){this.logService=c,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,v){return this._tunnelProvider=c,c?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async c=>{const v=[],_=Array.from(this._tunnels.values());for(let b of _){const P=Array.from(b.values());for(let l of P){const d=await l.value;d&&v.push(d)}}c(v)})}async dispose(){for(const c of this._tunnels.values()){for(const{value:v}of c.values())await v.then(_=>_?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,v,_,b,P=!1,l=!1,d){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${b}.`),!c)return;v||(v="localhost");const g=this.retainOrCreateTunnel(c,v,_,b,P,l,d);return g?g.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,public:c.public,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const v=this._tunnels.get(c.tunnelRemoteHost);if(v){const _=v.get(c.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,_))}}}}async tryDisposeTunnel(c,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${v}.`);const b=_.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(v),b}}async closeTunnel(c,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${v} `);const _=this._tunnels.get(c);if(_&&_.has(v)){const b=_.get(v);b.refcount=0,await this.tryDisposeTunnel(c,v,b)}}addTunnelToMap(c,v,_){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(c,v){const _=this._tunnels.get(c);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,v){let _=[c];A(c)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):i(c)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const b=_.map(P=>this._tunnels.get(P));for(const P of b){const l=P?.get(v);if(l)return l}}canTunnel(c){return!!y(c)}createWithProvider(c,v,_,b,P,l,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${b}.`);const t={elevationRequired:P?I(b===void 0?_:b):!1},r={remoteAddress:{host:v,port:_},localAddressPort:b,public:l,protocol:d},s=c.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,_,s),s}};u=Ve([$e(0,S.ILogService)],u),e.AbstractTunnelService=u}),define(me[194],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((D,S)=>J(["vsda"],D,S))}async sign(D){try{const S=await this.vsda(),T=new S.signer;if(T)return T.sign(D)}catch(S){}return D}}e.SignService=p}),define(me[195],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,S,T=5){let C;return C=S(y=>{const A=typeof y=="string"?y:y.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(A);return}const I=setTimeout(()=>this.flushBuffer(D),T);i={data:[A],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),C.dispose()}},this._terminalBufferMap.set(D,i)}),C}stopBuffering(D){const S=this._terminalBufferMap.get(D);S&&S.dispose()}flushBuffer(D){const S=this._terminalBufferMap.get(D);S&&(this._terminalBufferMap.delete(D),this._callback(D,S.data.join("")))}}e.TerminalDataBufferer=p}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(me[84],ge([0,1,4,6,34,3,196,45]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var y;(function(_){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}_.isThemeColor=b})(y=e.ThemeColor||(e.ThemeColor={}));function A(_){return{id:_}}e.themeColorFromId=A;var i;(function(_){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}_.isThemeIcon=b;const P=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function l(r){const s=P.exec(r);if(!s)return;let[,n]=s;return{id:n}}_.fromString=l;function d(r,s){let n=r.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),s&&(n=`${n}~${s}`),{id:n}}_.modify=d;function g(r,s){return r.id===s.id&&r.color?.id===s.color?.id}_.isEqual=g;function t(r,s){return{id:r.id,color:s?A(s):void 0}}_.asThemeIcon=t,_.asClassNameArray=C.CSSIcon.asClassNameArray,_.asClassName=C.CSSIcon.asClassName,_.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function I(_){switch(_){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new u;D.Registry.add(e.Extensions.ThemingContribution,m);function c(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=c;class v extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let l=this.theme.getColor(b);return l&&P&&(l=P(l,this.theme)),l?l.toString():null}}e.Themable=v}),define(me[197],ge([0,1,34,84,3,161,119,16,45]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,P,l,d){const g=this.iconsById[b];if(g){if(l&&!g.description){g.description=l,this.iconSchema.properties[b].markdownDescription=`${l} $(${b})`;const s=this.iconReferenceSchema.enum.indexOf(b);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=l),this._onDidChange.fire()}return g}let t={id:b,description:l,defaults:P,deprecationMessage:d};this.iconsById[b]=t;let r={$ref:"#/definitions/icons"};return d&&(r.deprecationMessage=d),l&&(r.markdownDescription=`${l}: $(${b})`),this.iconSchema.properties[b]=r,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const P=this.iconReferenceSchema.enum.indexOf(b);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,P){const l=this.iconFontsById[b];if(l)return l;let d={id:b,definition:P};return this.iconFontsById[b]=d,this._onDidChange.fire(),d}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(g,t)=>g.id.localeCompare(t.id),P=g=>{for(;R.ThemeIcon.isThemeIcon(g.defaults);)g=this.iconsById[g.defaults.id];return`codicon codicon-${g?g.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(g=>this.iconsById[g]);for(const g of d.filter(t=>!!t.description).sort(b))l.push(`|<i class="${P(g)}"></i>|${g.id}|${R.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const g of d.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(b))l.push(`|<i class="${P(g)}"></i>|${g.id}|`);return l.join(`
`)}}const i=new A;p.Registry.add(e.Extensions.IconContribution,i);function I(_,b,P,l){return i.registerIcon(_,b,P,l)}e.registerIcon=I;function u(){return i}e.getIconRegistry=u;function m(){for(const _ of y.iconRegistry.all)i.registerIcon(_.id,_.definition,_.description);y.iconRegistry.onDidRegister(_=>i.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let c=p.Registry.as(T.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,i.getIconSchema());const v=new C.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=I("widget-close",y.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",y.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",y.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=R.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(me[49],ge([0,1,2,24,4,22]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function C(u){const m=u;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=C;function y(u){const m=u;return!!(m&&typeof m=="object"&&p.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class A{constructor(m,c,v,_){this._id=m,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class i{constructor(m,c){this.raw=c,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,R.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(u){return new i({uri:u,index:0,name:(0,R.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=I}),define(me[198],ge([0,1,4,162,49,2,11,9,24,138,57,10,77,29,83]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(M){return(typeof M=="string"?(0,C.extname)(M):(0,y.extname)(M))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function b(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=P;function l(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=l;function d(M){const x=M;return typeof x?.id=="string"&&S.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=d;function g(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(M){const x=M;return typeof x?.id=="string"&&S.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(M){const x=M;if(x?.uri)return{id:x.id,uri:S.URI.revive(x.uri)};const F=M;if(F?.configPath)return{id:F.id,configPath:S.URI.revive(F.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=r;function s(M,x){return y.extUriBiasedIgnorePathCase.isEqualOrParent(M,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(M){return a(M)||h(M)}e.isStoredWorkspaceFolder=n;function a(M){const x=M;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function h(M){const x=M;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=h;function f(M,x,F,q,U=!T.isWindows,O){if(M.scheme!==q.scheme)return{name:F,uri:M.toString(!0)};let G=x?void 0:O.relativePath(q,M);if(G!==void 0)G.length===0?G=".":T.isWindows&&M.scheme===I.Schemas.file&&!U&&(G=G.replace(/\//g,"\\"));else if(M.scheme===I.Schemas.file)G=M.fsPath,T.isWindows&&(G=(0,u.normalizeDriveLetter)(G),U&&(G=(0,m.toSlashes)(G)));else{if(!O.isEqualAuthority(M.authority,q.authority))return{name:F,uri:M.toString(!0)};G=M.path}return{name:F,path:G}}e.getStoredWorkspaceFolder=f;function w(M,x,F){let q=[],U=new Set;const O=F.dirname(x);for(let G of M){let $;if(a(G))G.path&&($=F.resolvePath(O,G.path));else if(h(G))try{$=S.URI.parse(G.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(K){console.warn(K)}if($){let K=F.getComparisonKey($);if(!U.has(K)){U.add(K);const re=G.name||F.basenameOrAuthority($);q.push(new D.WorkspaceFolder({uri:$,name:re,index:q.length},G))}}}return q}e.toWorkspaceFolders=w;function E(M,x,F,q,U){let O=o(x,M);const G=U.dirname(x),$=U.dirname(q),K=[],re=k(O.folders);for(const Le of O.folders){const qe=a(Le)?U.resolvePath(G,Le.path):S.URI.parse(Le.uri);let We;F?We=!1:We=!a(Le)||(0,C.isAbsolute)(Le.path),K.push(f(qe,We,Le.name,$,re,U))}const fe={insertSpaces:!1,tabSize:4,eol:T.isLinux||T.isMacintosh?`
`:`\r
`},ye=A.setProperty(M,["folders"],K,fe);let Ie=A.applyEdits(M,ye);return O.remoteAuthority===(0,c.getRemoteAuthority)(q)&&(Ie=A.applyEdits(Ie,A.removeProperty(Ie,["remoteAuthority"],fe))),Ie}e.rewriteWorkspaceFileForNewLocation=E;function o(M,x){let F=i.parse(x);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(q=>n(q));else throw new Error(`${M} looks like an invalid workspace file.`);return F}function k(M){return T.isWindows?M.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=k;function L(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function N(M){return typeof M.folderUri=="string"}function V(M){return typeof M.fileUri=="string"}function ee(M,x){const F={workspaces:[],files:[]};if(M){const q=function(O,G){for(let $=0;$<O.length;$++)try{G(O[$],$)}catch(K){x.warn(`Error restoring recent entry ${JSON.stringify(O[$])}: ${K.toString()}. Skip entry.`)}},U=M;if(Array.isArray(U.entries))q(U.entries,O=>{const G=O.label,$=O.remoteAuthority;L(O)?F.workspaces.push({label:G,remoteAuthority:$,workspace:{id:O.workspace.id,configPath:S.URI.parse(O.workspace.configPath)}}):N(O)?F.workspaces.push({label:G,remoteAuthority:$,folderUri:S.URI.parse(O.folderUri)}):V(O)&&F.files.push({label:G,remoteAuthority:$,fileUri:S.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&q(O.workspaces3,(G,$)=>{const K=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[$]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?F.workspaces.push({label:K,workspace:{id:G.id,configPath:S.URI.parse(G.configURIPath)}}):typeof G=="string"&&F.workspaces.push({label:K,folderUri:S.URI.parse(G)})}),Array.isArray(O.files2)&&q(O.files2,(G,$)=>{const K=Array.isArray(O.fileLabels)&&O.fileLabels[$]||void 0;typeof G=="string"&&F.files.push({label:K,fileUri:S.URI.parse(G)})})}}return F}e.restoreRecentlyOpened=ee;function z(M){const x={entries:[]};for(const F of M.workspaces)P(F)?x.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):x.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of M.files)x.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return x}e.toStoreData=z}),define(me[85],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const S=this._idPool++;return this._data.set(S,D),this.logDebugInfo(),S}get(D,S){return this._data.has(D)?this._data.get(D)[S]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(me[50],ge([0,1,2,3,4]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class S{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(y=>({name:y.name,group:y.group,resource:p.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=S}),define(me[62],ge([0,1,10,4]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T):this._providerInfo.set(T,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,p.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,2]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class R{constructor(S,T,C){this._extHostNotebooks=T,this._textDocumentsAndEditors=C}$willAddInteractiveDocument(S,T,C,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],modeId:C,uri:S,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(p.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=R}),define(me[200],ge([0,1,16]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(T,C,y){this._deferredPromises=new Map,this._id=T,this._shared=C,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of A.values())i.complete()}catch(i){for(const I of A.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,C){let y=this._value[T];return typeof y=="undefined"&&(y=C),y}update(T,C){this._value[T]=C;let y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const A=new p.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class D extends R{constructor(T,C){super(T.identifier.value,!0,C);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=D}),define(me[201],ge([0,1,3,2,12]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(C,y){this._logService=C,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,y,A){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(C)).acceptModelChanged(y,A)}$acceptDirtyStateChanged(C,y){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(C)).acceptDirty(y)}$acceptModelSaved(C){const y=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(C));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(C,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,y);const A=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(C));A.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};S=Ve([$e(0,D.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(me[13],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,p.createDecorator)("IExtHostRpcService");class R{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[202],ge([0,1,26,3]),function(J,e,p,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(C,y){D.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(C.identifier),it(this,D,y,"f"),He(this,D,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(C){return He(this,D,"f").get(this._id,C)}store(C,y){return He(this,D,"f").store(this._id,C,y)}delete(C){return He(this,D,"f").delete(this._id,C)}}e.ExtensionSecrets=S,D=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,p.createDecorator)("IExtHostTelemetry")}),define(me[86],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var p;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(p=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,D=(P,l)=>{const d={controllerId:l};return R.set(P,d),d};e.createPrivateApiFor=D;const S=P=>R.get(P);e.getPrivateApiFor=S;const T=(P,l,d,g)=>{let t=d;return{enumerable:!0,configurable:!1,get(){return t},set(r){g(t,r)||(t=r,P.listener?.({op:3,key:l,value:r}))}}},C=(P,l)=>P===l,y={range:(P,l)=>P===l?!0:!P||!l?!1:P.isEqual(l),label:C,description:C,busy:C,error:C,canResolveChildren:C},A=Object.keys(y),i=(P,l)=>({range:T(P,"range",void 0,y.range),label:T(P,"label",l,y.label),description:T(P,"description",void 0,y.description),canResolveChildren:T(P,"canResolveChildren",!1,y.canResolveChildren),busy:T(P,"busy",!1,y.busy),error:T(P,"error",void 0,y.error)}),I=(P,l)=>{const d=new Map;for(const g of A)y[g](P[g],l[g])||d.set(g,l[g]);return d};e.diffTestItems=I;class u extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=u;class m extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class c extends Error{constructor(l,d,g){super(`TestItem with ID "${l}" is from controller "${d}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=c;const v=P=>{const l=(0,e.getPrivateApiFor)(P);let d=new Map;return{get size(){return d.size},forEach(g,t){for(const r of d.values())g.call(t,r,this)},replace(g){const t=new Map,r=new Set(d.keys()),s={op:4,ops:[]};for(const n of g){if(!(n instanceof _))throw new m(n.id);const a=(0,e.getPrivateApiFor)(n).controllerId;if(a!==l.controllerId)throw new c(n.id,a,l.controllerId);if(t.has(n.id))throw new u(n.id);t.set(n.id,n),r.delete(n.id),s.ops.push({op:0,item:n})}for(const n of r.keys())s.ops.push({op:1,id:n});l.listener?.(s),d=t},add(g){if(!(g instanceof _))throw new m(g.id);d.set(g.id,g),l.listener?.({op:0,item:g})},delete(g){d.delete(g)&&l.listener?.({op:1,id:g})},get(g){return d.get(g)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class _{constructor(l,d,g,t){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const r=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof b?void 0:r.parent}},children:{value:v(this),enumerable:!0,writable:!1},...i(r,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class b extends _{constructor(l,d){super(l,l,d,void 0)}}e.TestItemRootImpl=b}),define(me[51],ge([0,1,4,3,13]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var S;(function(C){function y(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}C.fromApiTunnel=y;function A(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}C.fromServiceTunnel=A})(S=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,p.createDecorator)("IExtHostTunnelService");let T=class{constructor(y){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,A){return{dispose:()=>{}}}async $providePortAttributes(y,A,i,I,u){return[]}async $forwardPort(y,A){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([$e(0,D.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[7],ge([0,1,20,15,98,22,101,14,2,32,42,121]),function(J,e,p,R,D,S,T,C,y,A,i,I){"use strict";var u,m,c,v,_,b,P,l,d,g,t,r,s,n,a,h,f,w,E,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(H){function B(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(B,H),Object.setPrototypeOf(B.prototype,H.prototype),B}let L=_=class{constructor(B){u.set(this,void 0),it(this,u,B,"f")}static from(...B){let oe=B;return new _(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof He(this,u,"f")=="function"&&(He(this,u,"f").call(this),it(this,u,void 0,"f"))}};u=new WeakMap,L=_=Ve([k],L),e.Disposable=L;let N=b=class{constructor(B,oe){if(B<0)throw(0,R.illegalArgument)("line must be non-negative");if(oe<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=B,this._character=oe}static Min(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let ke=1;ke<B.length;ke++){const Xe=B[ke];Xe.isBefore(oe)&&(oe=Xe)}return oe}static Max(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let ke=1;ke<B.length;ke++){const Xe=B[ke];Xe.isAfter(oe)&&(oe=Xe)}return oe}static isPosition(B){if(!B)return!1;if(B instanceof b)return!0;let{line:oe,character:ke}=B;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,oe=0){if(B===null||oe===null)throw(0,R.illegalArgument)();let ke;return typeof B=="undefined"?ke=0:typeof B=="number"?ke=B:(ke=typeof B.lineDelta=="number"?B.lineDelta:0,oe=typeof B.characterDelta=="number"?B.characterDelta:0),ke===0&&oe===0?this:new b(this.line+ke,this.character+oe)}with(B,oe=this.character){if(B===null||oe===null)throw(0,R.illegalArgument)();let ke;return typeof B=="undefined"?ke=this.line:typeof B=="number"?ke=B:(ke=typeof B.line=="number"?B.line:this.line,oe=typeof B.character=="number"?B.character:this.character),ke===this.line&&oe===this.character?this:new b(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};N=b=Ve([k],N),e.Position=N;let V=P=class{constructor(B,oe,ke,Xe){let nt,rt;if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Xe=="number"?(nt=new N(B,oe),rt=new N(ke,Xe)):B instanceof N&&oe instanceof N&&(nt=B,rt=oe),!nt||!rt)throw new Error("Invalid arguments");nt.isBefore(rt)?(this._start=nt,this._end=rt):(this._start=rt,this._end=nt)}static isRange(B){return B instanceof P?!0:B?N.isPosition(B.start)&&N.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof P?this.contains(B._start)&&this.contains(B._end):B instanceof N?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const oe=N.Max(B.start,this._start),ke=N.Min(B.end,this._end);if(!oe.isAfter(ke))return new P(oe,ke)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const oe=N.Min(B.start,this._start),ke=N.Max(B.end,this.end);return new P(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,oe=this.end){if(B===null||oe===null)throw(0,R.illegalArgument)();let ke;return B?N.isPosition(B)?ke=B:(ke=B.start||this.start,oe=B.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new P(ke,oe)}toJSON(){return[this.start,this.end]}};V=P=Ve([k],V),e.Range=V;let ee=l=class extends V{constructor(B,oe,ke,Xe){let nt,rt;if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Xe=="number"?(nt=new N(B,oe),rt=new N(ke,Xe)):B instanceof N&&oe instanceof N&&(nt=B,rt=oe),!nt||!rt)throw new Error("Invalid arguments");super(nt,rt);this._anchor=nt,this._active=rt}static isSelection(B){return B instanceof l?!0:B?V.isRange(B)&&N.isPosition(B.anchor)&&N.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=l=Ve([k],ee),e.Selection=ee;class z{constructor(B,oe,ke){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,R.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,R.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=z;class M extends Error{constructor(B,oe=I.RemoteAuthorityResolverErrorCode.Unknown,ke){super(B);this._message=B,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(B,oe){return new M(B,I.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(B){return new M(B,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=M;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var F;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=d=class{constructor(B,oe){this._range=B,this._newText=oe}static isTextEdit(B){return B instanceof d?!0:B?V.isRange(B)&&typeof B.newText=="string":!1}static replace(B,oe){return new d(B,oe)}static insert(B,oe){return d.replace(new V(B,B),oe)}static delete(B){return d.replace(B,"")}static setEndOfLine(B){const oe=new d(new V(new N(0,0),new N(0,0)),"");return oe.newEol=B,oe}get range(){return this._range}set range(B){if(B&&!V.isRange(B))throw(0,R.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,R.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,R.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=d=Ve([k],q),e.TextEdit=q;var U;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,oe,ke,Xe){this._edits.push({_type:1,from:B,to:oe,options:ke,metadata:Xe})}createFile(B,oe,ke){this._edits.push({_type:1,from:void 0,to:B,options:oe,metadata:ke})}deleteFile(B,oe,ke){this._edits.push({_type:1,from:B,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(B,oe,ke){this._edits.push({_type:3,metadata:ke,uri:B,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(B,oe,ke,Xe,nt){let rt,lt,yt=[],At;if(Bt.isNotebookRange(oe)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Xe)?(rt=oe.start,lt=oe.end,yt=ke,At=Xe):typeof oe=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Xe)&&(rt=oe,lt=ke,yt=Xe,At=nt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||yt.length>0)&&this._edits.push({_type:5,uri:B,index:rt,count:lt-rt,cells:yt,metadata:At})}replaceNotebookCellMetadata(B,oe,ke,Xe){this._edits.push({_type:3,metadata:Xe,uri:B,edit:{editType:8,index:oe,metadata:ke}})}replace(B,oe,ke,Xe){this._edits.push({_type:2,uri:B,edit:new q(oe,ke),metadata:Xe})}insert(B,oe,ke,Xe){this.replace(B,new V(oe,oe),ke,Xe)}delete(B,oe,ke){this.replace(B,oe,"",ke)}has(B){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===B.toString())}set(B,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:B,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Xe=this._edits[ke];Xe._type===2&&Xe.uri.toString()===B.toString()&&(this._edits[ke]=void 0)}(0,p.coalesceInPlace)(this._edits)}}get(B){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===B.toString()&&oe.push(ke.edit);return oe}entries(){const B=new S.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=B.get(oe.uri);ke||(ke=[oe.uri,[]],B.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([k],O),e.WorkspaceEdit=O;let G=g=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof g?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=g._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,oe=this._tabstop++){if(typeof B=="function"){const ke=new g;ke._tabstop=this._tabstop,B(ke),this._tabstop=ke._tabstop,B=ke.value}else B=g._escape(B);return this.value+="${",this.value+=oe,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,oe=this._tabstop++){const ke=B.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(B,oe){if(typeof oe=="function"){const ke=new g;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};G=g=Ve([k],G),e.SnippetString=G;var $;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let re=t=class{constructor(B,oe){if(this.uri=B,oe)if(oe instanceof V)this.range=oe;else if(oe instanceof N)this.range=new V(oe,oe);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof t?!0:B?V.isRange(B.range)&&y.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};re=t=Ve([k],re),e.Location=re;let fe=class{constructor(B,oe){this.location=B,this.message=oe}static is(B){return B?typeof B.message=="string"&&B.location&&V.isRange(B.location.range)&&y.URI.isUri(B.location.uri):!1}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.location.range.isEqual(oe.location.range)&&B.location.uri.toString()===oe.location.uri.toString()}};fe=Ve([k],fe),e.DiagnosticRelatedInformation=fe;let ye=class{constructor(B,oe,ke=K.Error){if(!V.isRange(B))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=B,this.message=oe,this.severity=ke}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.severity===oe.severity&&B.code===oe.code&&B.severity===oe.severity&&B.source===oe.source&&B.range.isEqual(oe.range)&&(0,p.equals)(B.tags,oe.tags)&&(0,p.equals)(B.relatedInformation,oe.relatedInformation,fe.isEqual)}};ye=Ve([k],ye),e.Diagnostic=ye;let Ie=class{constructor(B,oe){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=oe}};Ie=Ve([k],Ie),e.Hover=Ie;var Le;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor(B,oe=Le.Text){this.range=B,this.kind=oe}toJSON(){return{range:this.range,kind:Le[this.kind]}}};qe=Ve([k],qe),e.DocumentHighlight=qe;var We;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var je;(function(H){H[H.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let W=r=class{constructor(B,oe,ke,Xe,nt){this.name=B,this.kind=oe,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Xe instanceof re?this.location=Xe:ke instanceof V&&(this.location=new re(Xe,ke)),r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};W=r=Ve([k],W),e.SymbolInformation=W;let Z=s=class{constructor(B,oe,ke,Xe,nt){this.name=B,this.detail=oe,this.kind=ke,this.range=Xe,this.selectionRange=nt,this.children=[],s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(s.validate)}};Z=s=Ve([k],Z),e.DocumentSymbol=Z;var ne;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(B,oe){this.title=B,this.kind=oe}};le=Ve([k],le),e.CodeAction=le;let Y=n=class{constructor(B){this.value=B}append(B){return new n(this.value?this.value+n.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+n.sep)}};Y.sep=".",Y=n=Ve([k],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let ae=class{constructor(B,oe){if(this.range=B,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ve([k],ae),e.SelectionRange=ae;class ve{constructor(B,oe,ke,Xe,nt,rt){this.kind=B,this.name=oe,this.detail=ke,this.uri=Xe,this.range=nt,this.selectionRange=rt}}e.CallHierarchyItem=ve;class Me{constructor(B,oe){this.fromRanges=oe,this.from=B}}e.CallHierarchyIncomingCall=Me;class ze{constructor(B,oe){this.fromRanges=oe,this.to=B}}e.CallHierarchyOutgoingCall=ze;var Ee;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Ee=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(B,oe){this.range=B,this.command=oe}get isResolved(){return!!this.command}};Ye=Ve([k],Ye),e.CodeLens=Ye;let X=a=class{constructor(B,oe=!1){m.set(this,void 0),it(this,m,new D.MarkdownString(B,{supportThemeIcons:oe}),"f")}static isMarkdownString(B){return B instanceof a?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return He(this,m,"f").value}set value(B){He(this,m,"f").value=B}get isTrusted(){return He(this,m,"f").isTrusted}set isTrusted(B){He(this,m,"f").isTrusted=B}get supportThemeIcons(){return He(this,m,"f").supportThemeIcons}set supportThemeIcons(B){He(this,m,"f").supportThemeIcons=B}appendText(B){return He(this,m,"f").appendText(B),this}appendMarkdown(B){return He(this,m,"f").appendMarkdown(B),this}appendCodeblock(B,oe){return He(this,m,"f").appendCodeblock(oe??"",B),this}};m=new WeakMap,X=a=Ve([k],X),e.MarkdownString=X;let se=class{constructor(B,oe){this.label=B,this.documentation=oe}};se=Ve([k],se),e.ParameterInformation=se;let he=class{constructor(B,oe){this.label=B,this.documentation=oe,this.parameters=[]}};he=Ve([k],he),e.SignatureInformation=he;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=Ve([k],xe),e.SignatureHelp=xe;var Be;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor(B,oe,ke){this.text=B,this.position=oe,this.kind=ke}};Ce=Ve([k],Ce),e.InlayHint=Ce;var De;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Te;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Te=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(H){H[H.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let ue=class{constructor(B,oe){this.label=B,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ue=Ve([k],ue),e.CompletionItem=ue;let pe=class{constructor(B=[],oe=!1){this.items=B,this.isIncomplete=oe}};pe=Ve([k],pe),e.CompletionList=pe;let be=class{constructor(B,oe,ke){this.text=B,this.range=oe,this.command=ke}};be=Ve([k],be),e.InlineSuggestion=be;let j=class{constructor(B){this.items=B}};j=Ve([k],j),e.InlineSuggestions=j;var we;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(we=e.ViewColumn||(e.ViewColumn={}));var _e;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ue;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Je;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function B(oe){switch(oe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=B}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(B,oe){if(oe&&!y.URI.isUri(oe))throw(0,R.illegalArgument)("target");if(!V.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.target=oe}};ct=Ve([k],ct),e.DocumentLink=ct;let mt=class{constructor(B,oe,ke,Xe){this.red=B,this.green=oe,this.blue=ke,this.alpha=Xe}};mt=Ve([k],mt),e.Color=mt;let bt=class{constructor(B,oe){if(oe&&!(oe instanceof mt))throw(0,R.illegalArgument)("color");if(!V.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.color=oe}};bt=Ve([k],bt),e.ColorInformation=bt;let ot=class{constructor(B){if(!B||typeof B!="string")throw(0,R.illegalArgument)("label");this.label=B}};ot=Ve([k],ot),e.ColorPresentation=ot;var at;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Se;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Se=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Pe{constructor(B,oe,ke){if(this.startIndex=B,this.length=oe,this.tooltip=ke,typeof B!="number"||B<0)throw(0,R.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,R.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Pe;class te{constructor(B){this.options=B,typeof B!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=te;var Q;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Q=e.TaskRevealKind||(e.TaskRevealKind={}));var Oe;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Oe=e.TaskPanelKind||(e.TaskPanelKind={}));let Fe=h=class{constructor(B,oe){if(typeof B!="string"||typeof oe!="string")throw(0,R.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};Fe.Clean=new h("clean","Clean"),Fe.Build=new h("build","Build"),Fe.Rebuild=new h("rebuild","Rebuild"),Fe.Test=new h("test","Test"),Fe=h=Ve([k],Fe),e.TaskGroup=Fe;function tt(H){let B="";for(let oe=0;oe<H.length;oe++)B+=H[oe].replace(/,/g,",,")+",";return B}let Ke=class{constructor(B,oe,ke){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=B,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)B.push(oe);return tt(B)}};Ke=Ve([k],Ke),e.ProcessExecution=Ke;let ut=class{constructor(B,oe,ke){if(this._args=[],Array.isArray(oe)){if(!B)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B,this._args=oe,this._options=ke}else{if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)B.push(typeof oe=="string"?oe:oe.value);return tt(B)}};ut=Ve([k],ut),e.ShellExecution=ut;var St;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=Dt;let ft=f=class{constructor(B,oe,ke,Xe,nt,rt){this.__deprecated=!1,this._definition=this.definition=B;let lt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Xe,lt=nt,this.__deprecated=!0):oe===kt.Global||oe===kt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Xe,this.execution=nt,lt=rt):(this.target=oe,this._name=this.name=ke,this._source=this.source=Xe,this.execution=nt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const oe=this._definition.type;(f.EmptyType===oe||f.ProcessType===oe||f.ShellType===oe||f.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=f=Ve([k],ft),e.Task=ft;var dt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(B,oe=Et.None){this.collapsibleState=oe,y.URI.isUri(B)?this.resourceUri=B:this.label=B}};vt=Ve([k],vt),e.TreeItem=vt;var Et;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(B,oe){this.id=B,this.color=oe}};Tt=Ve([k],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor(B){this.id=B}};It=Ve([k],It),e.ThemeColor=It;var bn;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(B,oe){if(typeof B!="string"&&(!B||!y.URI.isUri(B)&&!y.URI.isUri(B.uri)))throw(0,R.illegalArgument)("base");if(typeof oe!="string")throw(0,R.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=y.URI.file(B),this.base=B):y.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=oe}};Vt=Ve([k],Vt),e.RelativePattern=Vt;let _t=class{constructor(B,oe,ke,Xe){this.enabled=typeof B=="boolean"?B:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};_t=Ve([k],_t),e.Breakpoint=_t;let Xt=class extends _t{constructor(B,oe,ke,Xe,nt){super(oe,ke,Xe,nt);if(B===null)throw(0,R.illegalArgument)("location");this.location=B}};Xt=Ve([k],Xt),e.SourceBreakpoint=Xt;let Yt=class extends _t{constructor(B,oe,ke,Xe,nt){super(oe,ke,Xe,nt);this.functionName=B}};Yt=Ve([k],Yt),e.FunctionBreakpoint=Yt;let gt=class extends _t{constructor(B,oe,ke,Xe,nt,rt,lt){super(Xe,nt,rt,lt);if(!oe)throw(0,R.illegalArgument)("dataId");this.label=B,this.dataId=oe,this.canPersist=ke}};gt=Ve([k],gt),e.DataBreakpoint=gt;let jt=class{constructor(B,oe,ke){this.command=B,this.args=oe||[],this.options=ke}};jt=Ve([k],jt),e.DebugAdapterExecutable=jt;let Wt=class{constructor(B,oe){this.port=B,this.host=oe}};Wt=Ve([k],Wt),e.DebugAdapterServer=Wt;let Jt=class{constructor(B){this.path=B}};Jt=Ve([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(B){this.implementation=B}};Zt=Ve([k],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor(B,oe){this.range=B,this.expression=oe}};Pt=Ve([k],Pt),e.EvaluatableExpression=Pt;var dn;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(B,oe){this.range=B,this.text=oe}};en=Ve([k],en),e.InlineValueText=en;let xt=class{constructor(B,oe,ke=!0){this.range=B,this.variableName=oe,this.caseSensitiveLookup=ke}};xt=Ve([k],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor(B,oe){this.range=B,this.expression=oe}};ht=Ve([k],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor(B,oe){this.frameId=B,this.stoppedLocation=oe}};tn=Ve([k],tn),e.InlineValueContext=tn;var Mt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Ot=w=class extends Error{constructor(B,oe=i.FileSystemProviderErrorCode.Unknown,ke){super(y.URI.isUri(B)?B.toString(!0):B);this.code=ke?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(B){return new w(B,i.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(B){return new w(B,i.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(B){return new w(B,i.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(B){return new w(B,i.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(B){return new w(B,i.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(B){return new w(B,i.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ot=w=Ve([k],Ot),e.FileSystemError=Ot;let qt=class{constructor(B,oe,ke){this.start=B,this.end=oe,this.kind=ke}};qt=Ve([k],qt),e.FoldingRange=qt;var En;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(B,oe=[]){this.tokenTypes=B,this.tokenModifiers=oe}}e.SemanticTokensLegend=fn;function nn(H){return typeof H=="undefined"||(0,C.isStringArray)(H)}class rn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let oe=0,ke=B.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(B.tokenTypes[oe],oe);for(let oe=0,ke=B.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(B.tokenModifiers[oe],oe)}}push(B,oe,ke,Xe,nt){if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Xe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(B,oe,ke,Xe,nt);if(V.isRange(B)&&typeof oe=="string"&&nn(ke))return this._push(B,oe,ke);throw(0,R.illegalArgument)()}_push(B,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Xe=B.start.line,nt=B.start.character,rt=B.end.character-B.start.character,lt=this._tokenTypeStrToInt.get(oe);let yt=0;if(ke)for(const At of ke){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Xe,nt,rt,lt,yt)}_pushEncoded(B,oe,ke,Xe,nt){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Ft=0;Ft<yt;Ft++){let Nt=this._data[5*Ft],cn=this._data[5*Ft+1];Nt===0?(Nt=At,cn+=Rt):Nt+=At,this._data[5*Ft]=Nt,this._data[5*Ft+1]=cn,At=Nt,Rt=cn}}let rt=B,lt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=nt,this._prevLine=B,this._prevChar=oe}static _sortAndDeltaEncode(B){let oe=[];const ke=B.length/5|0;for(let lt=0;lt<ke;lt++)oe[lt]=lt;oe.sort((lt,yt)=>{const At=B[5*lt],Rt=B[5*yt];if(At===Rt){const Ft=B[5*lt+1],Nt=B[5*yt+1];return Ft-Nt}return At-Rt});const Xe=new Uint32Array(B.length);let nt=0,rt=0;for(let lt=0;lt<ke;lt++){const yt=5*oe[lt],At=B[yt+0],Rt=B[yt+1],Ft=B[yt+2],Nt=B[yt+3],cn=B[yt+4],Un=At-nt,qn=Un===0?Rt-rt:Rt,un=5*lt;Xe[un+0]=Un,Xe[un+1]=qn,Xe[un+2]=Ft,Xe[un+3]=Nt,Xe[un+4]=cn,nt=At,rt=Rt}return Xe}build(B){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),B):new Ht(rn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=rn;class Ht{constructor(B,oe){this.resultId=oe,this.data=B}}e.SemanticTokens=Ht;class sn{constructor(B,oe,ke){this.start=B,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=sn;class Sn{constructor(B,oe){this.resultId=oe,this.edits=B}}e.SemanticTokensEdits=Sn;var yn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=Ve([k],Gt),e.QuickInputButtons=Gt;var Dn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(B,oe,ke){this.badge=B,this.tooltip=oe,this.color=ke}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor(B){this.kind=B}};on=Ve([k],on),e.ColorTheme=on;var an;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(B,oe){if(B<0)throw(0,R.illegalArgument)("start must be positive");if(oe<0)throw(0,R.illegalArgument)("end must be positive");B<=oe?(this._start=B,this._end=oe):(this._start=oe,this._end=B)}static isNotebookRange(B){return B instanceof Bt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let oe=this._start,ke=this._end;return B.start!==void 0&&(oe=B.start),B.end!==void 0&&(ke=B.end),oe===this._start&&ke===this._end?this:new Bt(oe,ke)}}e.NotebookRange=Bt;class Lt{constructor(B,oe,ke,Xe,nt,rt,lt){this.kind=B,this.value=oe,this.languageId=ke,this.mime=Xe,this.outputs=nt??[],this.metadata=rt,this.executionSummary=lt,Lt.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(oe=>Lt.isNotebookCellData(oe))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Lt;class Kt{constructor(B){this.cells=B}}e.NotebookData=Kt;class Ne{constructor(B,oe){this.data=B,this.mime=oe;const ke=(0,T.normalizeMimeType)(oe,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+oe);this.mime=ke}static isNotebookCellOutputItem(B){return B instanceof Ne?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const oe={name:B.name,message:B.message,stack:B.stack};return Ne.json(oe,"application/vnd.code.notebook.error")}static stdout(B){return Ne.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Ne.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,oe="application/octet-stream"){return new Ne(B,oe)}static text(B,oe=T.Mimes.text){const ke=He(Ne,c,"f",v).encode(String(B));return new Ne(ke,oe)}static json(B,oe="application/json"){const ke=JSON.stringify(B,void 0,"	");return Ne.text(ke,oe)}}e.NotebookCellOutputItem=Ne,c=Ne,v={value:new TextEncoder};class $t{constructor(B,oe,ke){this.items=$t.ensureUniqueMimeTypes(B,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,A.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput(B){return B instanceof $t?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,C.isArray)(B.items)}static ensureUniqueMimeTypes(B,oe=!1){const ke=new Set,Xe=new Set;for(let nt=0;nt<B.length;nt++){const rt=B[nt],lt=(0,T.normalizeMimeType)(rt.mime);if(!ke.has(lt)){ke.add(lt);continue}Xe.add(nt),oe&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Xe.size===0?B:B.filter((nt,rt)=>!Xe.has(rt))}}e.NotebookCellOutput=$t;var mn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(B,oe){this.text=B,this.alignment=oe}}e.NotebookCellStatusBarItem=gn;var pn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(B,oe=[]){this.uri=B,this.provides=(0,p.asArray)(oe)}}e.NotebookRendererScript=Pn;let ln=class{constructor(B,oe){this.label=B,this.timestamp=oe}};ln=Ve([k],ln),e.TimelineItem=ln;var An;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(B,oe){this.ranges=B,this.wordPattern=oe}}e.LinkedEditingRanges=Rn;class Ln{constructor(B,oe){this._port=B,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var Mn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(B,oe,ke){this.include=B,this.exclude=oe,this.profile=ke}};ie=Ve([k],ie),e.TestRunRequest=ie;let de=E=class{constructor(B){this.message=B}static diff(B,oe,ke){const Xe=new E(B);return Xe.expectedOutput=oe,Xe.actualOutput=ke,Xe}};de=E=Ve([k],de),e.TestMessage=de;let Re=class{constructor(B,oe){this.covered=B,this.total=oe}};Re=Ve([k],Re),e.CoveredCount=Re;let st=o=class{constructor(B,oe,ke,Xe){this.uri=B,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Xe}static fromDetails(B,oe){const ke=new Re(0,0),Xe=new Re(0,0),nt=new Re(0,0);for(const lt of oe)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const yt of lt.branches)Xe.total+=1,Xe.covered+=yt.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const rt=new o(B,ke,Xe.total>0?Xe:void 0,nt.total>0?nt:void 0);return rt.detailedCoverage=oe,rt}};st=o=Ve([k],st),e.FileCoverage=st;let wt=class{constructor(B,oe,ke=[]){this.executionCount=B,this.location=oe,this.branches=ke}};wt=Ve([k],wt),e.StatementCoverage=wt;let Ct=class{constructor(B,oe){this.executionCount=B,this.location=oe}};Ct=Ve([k],Ct),e.BranchCoverage=Ct;let Nn=class{constructor(B,oe){this.executionCount=B,this.location=oe}};Nn=Ve([k],Nn),e.FunctionCoverage=Nn;var Hn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor(B,oe,ke,Xe,nt,rt){this.kind=B,this.name=oe,this.detail=ke,this.uri=Xe,this.range=nt,this.selectionRange=rt}}e.TypeHierarchyItem=jn}),define(me[123],ge([0,1,54,10,8,149,110,7,20]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function i(c,v){v?A.set(c,v):A.delete(c)}e.setWordDefinitionFor=i;function I(c){return A.get(c)}e.getWordDefinitionFor=I;class u extends S.MirrorTextModel{constructor(v,_,b,P,l,d,g,t){super(_,b,P,l);this._proxy=v,this._languageId=d,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){(0,p.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,y.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===R.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,b){return v._getWordRangeAtPosition(_,b)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,p.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,p.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const b=this._eol,P=_.start.line,l=_.end.line,d=[];d.push(this._lines[P].substring(_.start.character));for(let g=P+1;g<l;g++)d.push(this._lines[g]);return d.push(this._lines[l].substring(0,_.end.character)),d.join(b)}_lineAt(v){let _;if(v instanceof C.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),b=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,b))}_validateRange(v){if(!(v instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),b=this._validatePosition(v.end);return _===v.start&&b===v.end?v:new C.Range(_.line,_.character,b.line,b.character)}_validatePosition(v){if(!(v instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:b}=v,P=!1;if(_<0)_=0,b=0,P=!0;else if(_>=this._lines.length)_=this._lines.length-1,b=this._lines[_].length,P=!0;else{const l=this._lines[_].length;b<0?(b=0,P=!0):b>l&&(b=l,P=!0)}return P?new C.Position(_,b):v}_getWordRangeAtPosition(v,_){const b=this._validatePosition(v);if(!_)_=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const P=(0,T.getWordAtText)(b.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[b.line],0);if(P)return new C.Range(b.line,P.startColumn-1,b.line,P.endColumn-1)}}e.ExtHostDocumentData=u;class m{constructor(v,_,b){this._line=v,this._text=_,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[203],ge([0,1,7,3,112,6,78,22,2,32]),function(J,e,p,R,D,S,T,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(u,m,c,v){this._notebook=c,this._selector=v,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(b=>{const P=this._cellUris.get(b.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(b=>_(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const u=[],m=[];for(const c of this._notebook.getCells())c.kind===p.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),u.push(c.document.getText().length+1),m.push(c.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(u){if(!u){let P="";for(const l of this._cells)P+=l.document.getText()+`
`;return P=P.slice(0,-1),P}if(u.isEmpty)return"";const m=this.locationAt(u.start),c=this.locationAt(u.end),v=this._cellUris.get(m.uri),_=this._cellUris.get(c.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new p.Range(m.range.start,c.range.end));const b=[this._cells[v].document.getText(new p.Range(m.range.start,new p.Position(this._cells[v].document.lineCount,0)))];for(let P=v+1;P<_;P++)b.push(this._cells[P].document.getText());return b.push(this._cells[_].document.getText(new p.Range(new p.Position(0,0),c.range.end))),b.join(`
`)}offsetAt(u){const m=this._cellLines.getIndexOf(u.line),c=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(u.with(m.remainder));return c+v}positionAt(u){if(typeof u=="number"){const c=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(v)}const m=this._cellUris.get(u.uri);if(m!==void 0){const c=this._cellLines.getPrefixSum(m-1);return new p.Position(c+u.range.start.line,u.range.start.character)}return new p.Position(0,0)}locationAt(u){p.Range.isRange(u)||(u=new p.Range(u,u));const m=this._cellLines.getIndexOf(u.start.line);let c=m;u.isEmpty||(c=this._cellLines.getIndexOf(u.end.line));const v=new p.Position(m.remainder,u.start.character),_=new p.Position(c.remainder,u.end.character),b=new p.Range(v,_),P=this._cells[m.index];return new p.Location(P.document.uri,P.document.validateRange(b))}contains(u){return this._cellUris.has(u)}validateRange(u){const m=this.validatePosition(u.start),c=this.validatePosition(u.end);return u.with(m,c)}validatePosition(u){const m=this._cellLines.getIndexOf(u.line),c=new p.Position(m.remainder,u.character),v=this._cells[m.index].document.validatePosition(c),_=this._cellLines.getPrefixSum(m.index-1);return new p.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[204],ge([0,1,7,13,3]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(C){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let y=C==="light"?p.ColorThemeKind.Light:C==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([$e(0,R.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(me[63],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,p.createDecorator)("IURITransformerService");class R{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=R}),define(me[205],ge([0,1,23]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let A=this.buffers.indexOf(y);return A<0&&(A=this.buffers.length,this.buffers.push(y)),A}}function D(C,y){if(y.serializeBuffersForPostMessage){const A=new R,i=(m,c)=>{if(c instanceof ArrayBuffer){const v=A.add(c);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(c)){const v=S(c);if(v){const _=A.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(C,i),u=A.buffers.map(m=>{const c=new Uint8Array(m);return p.VSBuffer.wrap(c)});return{message:I,buffers:u}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=D;function S(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(C,y){const A=y.map(u=>{const m=new ArrayBuffer(u.byteLength);return new Uint8Array(m).set(u.buffer),m}),i=y.length?(u,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const c=m,{index:v}=c,_=A[v];if(c.view)switch(c.view.type){case 1:return new Int8Array(_,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(C,i),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(me[206],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var p;(function(R){function D(T){const C={items:new Map};return T.types.forEach((y,A)=>{C.items.set(y,{asString:async()=>T.items[A].asString})}),C}R.toITreeDataTransfer=D;async function S(T){const C={types:[],items:[]},y=Array.from(T.items.entries());for(const A of y)C.types.push(A[0]),C.items.push({asString:await A[1].asString()});return C}R.toTreeDataTransferDTO=S})(p=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[87],ge([0,1,10,2]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(S,T){return S.scheme===p.Schemas.http||S.scheme===p.Schemas.https?S:(T&&T.authority&&T.isRemote&&S.scheme===p.Schemas.file&&(S=R.URI.from({scheme:p.Schemas.vscodeRemote,authority:T.authority,path:S.path})),R.URI.from({scheme:p.Schemas.https,authority:`${S.scheme}+${S.authority}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=D}),define(me[207],ge([0,1,3,6,87]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(C,y,A){this._proxy=C,this._editors=y,this._initData=A,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const i=y.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,y,A,i,I){let u;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===C){u=l;break}if(!u)throw new Error("not a visible editor");const m=this,c=this._handlePool++,v=new p.Emitter,_=new p.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,D.asWebviewUri)(l,m._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(l){this._options=l,m._proxy.$setOptions(c,l)}get options(){return this._options}set html(l){this._html=l,m._proxy.$setHtml(c,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return m._proxy.$postMessage(c,l)}},P=new class{constructor(){this.editor=C,this.line=y,this.height=A,this.webview=b,this.onDidDispose=_.event}dispose(){m._insets.has(c)&&(m._insets.delete(c),m._proxy.$disposeEditorInset(c),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(c,u.id,u.value.document.uri,y+1,A,i||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:C,inset:P,onDidReceiveMessage:v}),P}$onDidDispose(C){const y=this._insets.get(C);y&&y.inset.dispose()}$onDidReceiveMessage(C,y){const A=this._insets.get(C);A&&A.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=S}),define(me[208],ge([0,1,171,14,2,6,4,61,34,20,10]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,p.localize)(0,null),providerDisplayName:(0,p.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,p.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,p.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,p.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,p.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,p.localize)(6,null)),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,p.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,p.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,p.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,p.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,p.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,p.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,p.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,p.localize)(14,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,p.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,p.localize)(16,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,p.localize)(17,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,p.localize)(18,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,p.localize)(19,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,p.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=I;function u(o){if(l(o))return!1;const k=o;return D.URI.isUri(k?.resource)}e.isResourceEditorInput=u;function m(o){if(l(o))return!1;const k=o;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=m;function c(o){if(l(o))return!1;const k=o;return k?k?.resource===void 0||k.resource.scheme===i.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var v;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var _;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var b;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends S.Disposable{}e.AbstractEditorInput=P;function l(o){return o instanceof P}e.isEditorInput=l;function d(o){const k=o;return D.URI.isUri(k?.preferredResource)}function g(o){const k=o;return l(k?.primary)&&l(k?.secondary)}e.isSideBySideEditorInput=g;function t(o){return l(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const k=o;return t(o)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const k=o;return typeof k?.groupId=="number"&&l(k.editor)}e.isEditorIdentifier=s;var n;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(k,L){if(!k)return;const N=g(k)?k.primary:m(k)?k.modified:void 0,V=g(k)?k.secondary:m(k)?k.original:void 0;if(L?.supportSideBySide&&N&&V){if(L?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:L.filterByScheme})};k=L.supportSideBySide===n.PRIMARY?N:V}if(m(k))return;const ee=d(k)?k.preferredResource:k.resource;return!ee||!L||!L.filterByScheme?ee:this.filterUri(ee,L.filterByScheme)}getCanonicalUri(k,L){if(!k)return;const N=g(k)?k.primary:m(k)?k.modified:void 0,V=g(k)?k.secondary:m(k)?k.original:void 0;if(L?.supportSideBySide&&N&&V){if(L?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:L.filterByScheme})};k=L.supportSideBySide===n.PRIMARY?N:V}if(m(k))return;const ee=k.resource;return!ee||!L||!L.filterByScheme?ee:this.filterUri(ee,L.filterByScheme)}filterUri(k,L){if(Array.isArray(L)){if(L.some(N=>k.scheme===N))return k}else if(L===k.scheme)return k}}e.EditorResourceAccessor=new a;var h;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(h=e.CloseDirection||(e.CloseDirection={}));class f{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const L=this.instantiationService=k.get(T.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,L);this.editorSerializerConstructors.clear()}createEditorSerializer(k,L,N){const V=N.createInstance(L);this.editorSerializerInstances.set(k,V)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,L){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,L,this.instantiationService):this.editorSerializerConstructors.set(k,L),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new f);async function w(o,k){if(!o||!o.length)return[];const L=await Promise.all(o.map(async N=>{const V=D.URI.revive(N.fileUri);if(!V||(await k.activateProvider(V.scheme),!k.canHandleResource(V)))return;const ee=typeof N.exists=="boolean"?N.exists:await k.exists(V);if(!ee&&N.openOnlyIfExists)return;const z=ee&&!(0,R.isUndefined)(N.selection)?{selection:N.selection,pinned:!0,override:N.editorOverrideId}:{pinned:!0,override:N.editorOverrideId};let M;return ee?M={resource:V,options:z,forceFile:!0}:M={resource:V,options:z,forceUntitled:!0},M}));return(0,A.coalesce)(L)}e.pathsToEditors=w;var E;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[209],ge([0,1,3,61,172,4,6,22,34,20,55,25,45,197]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",u.Codicon.window,(0,D.localize)(0,null));var c;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var v;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function b(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=b;class P extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new p.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new p.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(h,f,w){const E=this.get(h.id);if(E)return E;const o=h;return o.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,C.getOrSet)(this.viewContainers,f,[]).push(o),w?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:f}),o}deregisterViewContainer(h){for(const f of this.viewContainers.keys()){const w=this.viewContainers.get(f),E=w?.indexOf(h);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:f});return}}}get(h){return this.all.filter(f=>f.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(w=>w?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===h)}}y.Registry.add(c.ViewContainersRegistry,new P);var l;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function d(a,h){const f=a.group??l.More,w=h.group??l.More;return f!==w?f.localeCompare(w):(a.order??5)-(h.order??5)}class g extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new p.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new p.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new p.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new p.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(h,f){this.registerViews2([{views:h,viewContainer:f}])}registerViews2(h){h.forEach(({views:f,viewContainer:w})=>this.addViews(f,w)),this._onViewsRegistered.fire(h)}deregisterViews(h,f){const w=this.removeViews(h,f);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:f})}moveViews(h,f){for(const w of this._views.keys())if(w!==f){const E=this.removeViews(h,w);E.length&&(this.addViews(E,f),this._onDidChangeContainer.fire({views:E,from:w,to:f}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const f of this._viewContainers){const w=(this._views.get(f)||[]).filter(E=>E.id===h)[0];if(w)return w}return null}getViewContainer(h){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(E=>E.id===h)[0])return f;return null}registerViewWelcomeContent(h,f){return this._viewWelcomeContents.add(h,f),this._onDidChangeViewWelcomeContent.fire(h),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,f),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,f){const w=new Map;for(const[E,o]of f)this._viewWelcomeContents.add(h,o),w.set(E,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,o),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),w}getViewWelcomeContent(h){const f=[];return this._viewWelcomeContents.forEach(h,w=>f.push(w)),f.sort(d)}addViews(h,f){let w=this._views.get(f);w||(w=[],this._views.set(f,w),this._viewContainers.push(f));for(const E of h){if(this.getView(E.id)!==null)throw new Error((0,D.localize)(1,null,E.id));w.push(E)}}removeViews(h,f){const w=this._views.get(f);if(!w)return[];const E=[],o=[];for(const k of w)h.includes(k)?E.push(k):o.push(k);return E.length&&(o.length?this._views.set(f,o):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),E}}y.Registry.add(c.ViewsRegistry,new g),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,D.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var r;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(h,f){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,h),this._hasResolve=!!f,this.resolve=async w=>{if(f&&!this.resolved){const E=await f(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,16,173]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,y,A,i){const I={command:C};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof i=="number"){const u=setTimeout(()=>{clearTimeout(u);const m=this.pendingRequests.get(I.seq);if(m){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,D.localize)(0,null,i,C)};m(c)}},i)}return A&&this.pendingRequests.set(I.seq,A),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,y){return C.type!=="event"||y.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,R.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const y=C,A=this.pendingRequests.get(y.request_seq);A&&(this.pendingRequests.delete(y.request_seq),A(y));break}}}internalSend(C,y){y.type=C,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((y,A)=>C.set(A,y)),await(0,R.timeout)(500),C.forEach((y,A)=>{y({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(me[210],ge([0,1,8,2,9,25,10]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function y(r,s,n){return r.replace(C,function(a,h){return s&&h.length>0&&h[0]!=="_"?a:n&&n.hasOwnProperty(h)?n[h]:a})}e.formatPII=y;function A(r){const s={};for(const n of Object.keys(r))n.startsWith("!")||(s[n]=r[n]);return s}e.filterExceptionsFromTelemetry=A;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,p.equalsIgnoreCase)(s,"extensionhost")||(0,p.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function m(r,s,n){let a,h=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=f.exec(r);){let E=w.index+1,o=E+w[0].length;if(E<=s&&o>=n){a=w[0],h=E;break}}if(a){let E=/\w+/g,o=null;for(;(o=E.exec(a))&&!(o.index+1+h+o[0].length>=n););o&&(a=a.substring(0,E.lastIndex))}return a?{start:h,end:h+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(c))}e.isUri=v;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return R.URI.parse(r.path);if((0,D.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function b(r){if(typeof r.path=="object"){const s=R.URI.revive(r.path);if(s)return s.scheme===T.Schemas.file?s.fsPath:s.toString()}return r.path}function P(r,s){const n=s?_:b,a=(0,S.deepClone)(r);return d(a,(h,f)=>{h&&f&&(f.path=n(f))}),a}e.convertToDAPaths=P;function l(r,s){const n=s?_:b,a=(0,S.deepClone)(r);return d(a,(h,f)=>{!h&&f&&(f.path=n(f))}),a}e.convertToVSCPaths=l;function d(r,s){switch(r.type){case"event":const n=r;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(f=>s(!1,f));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(f=>s(!1,f.source));break;case"loadedSources":h.body.sources.forEach(f=>s(!1,f));break;case"scopes":h.body.scopes.forEach(f=>s(!1,f.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(f=>s(!1,f.source));break;case"setBreakpoints":h.body.breakpoints.forEach(f=>s(!1,f.source));break;default:break}break}}function g(r){return r.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):t(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(me[211],ge([0,1,28,39,174,125,9,8,25,11,184,124]),function(J,e,p,R,D,S,T,C,y,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(P,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,P.on("data",d=>this.handleData(d))}sendMessage(P){if(this.outputStream){const l=JSON.stringify(P);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${u.TWO_CRLF}${l}`,"utf8")}}handleData(P){for(this.rawData=Buffer.concat([this.rawData,P]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+l))}continue}}else{const l=this.rawData.indexOf(u.TWO_CRLF);if(l!==-1){const g=this.rawData.toString("utf8",0,l).split(u.HEADER_LINESEPARATOR);for(const t of g){const r=t.split(u.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(l+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class m extends u{startSession(){return new Promise((P,l)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),P(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",g=>{d?this._onError.fire(g):l(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class c extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",P)}}e.SocketDebugAdapter=c;class v extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return S.createConnection(this.adapterServer.path,P)}}e.NamedPipeDebugAdapter=v;class _ extends u{constructor(P,l,d){super();this.adapterExecutable=P,this.debugType=l,this.outputService=d}async startSession(){const P=this.adapterExecutable.command,l=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(P)if(T.isAbsolute(P)){if(!await p.Promises.exists(P))throw new Error(D.localize(0,null,P))}else P.indexOf("/")<0&&P.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let g=process.env;if(d.env&&Object.keys(d.env).length>0&&(g=y.mixin(y.deepClone(process.env),d.env)),P==="node")if(Array.isArray(l)&&l.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(s.cwd=d.cwd);const n=R.fork(l[0],l.slice(1),s);if(!n.pid)throw new Error(D.localize(2,null,l[0]));this.serverProcess=n}else throw new Error(D.localize(3,null));else{const r={env:g};d.cwd&&(r.cwd=d.cwd),this.serverProcess=R.spawn(P,l,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((P,l)=>{const d=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,r){if(g)return l(g)});d.on("exit",P),d.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(P,l){if(!P)return;const d=Object.create(null);P.runtime&&(P.runtime.indexOf("./")===0?d.runtime=T.join(l,P.runtime):d.runtime=P.runtime),P.runtimeArgs&&(d.runtimeArgs=P.runtimeArgs),P.program&&(T.isAbsolute(P.program)?d.program=P.program:d.program=T.join(l,P.program)),P.args&&(d.args=P.args);const g=P;return g.win&&(d.win=_.extract(g.win,l)),g.winx86&&(d.winx86=_.extract(g.winx86,l)),g.windows&&(d.windows=_.extract(g.windows,l)),g.osx&&(d.osx=_.extract(g.osx,l)),g.linux&&(d.linux=_.extract(g.linux,l)),d}static platformAdapterExecutable(P,l){let d=Object.create(null);l=l.toLowerCase();for(const a of P)if(a.contributes){const h=a.contributes.debuggers;h&&h.length>0&&h.filter(f=>typeof f.type=="string"&&C.equalsIgnoreCase(f.type,l)).forEach(f=>{const w=_.extract(f,a.extensionLocation.fsPath);d=y.mixin(d,w,a.isBuiltin)})}let g;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=d.winx86||d.win||d.windows:A.isWindows?g=d.win||d.windows:A.isMacintosh?g=d.osx:A.isLinux&&(g=d.linux),g=g||d;let t=g.program||d.program;const r=g.args||d.args;let s=g.runtime||d.runtime;const n=g.runtimeArgs||d.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[212],ge([0,1,39,11,29,187]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(u,m){return new Promise((c,v)=>{let _="";const b=p.spawn(u,m);b.pid&&b.stdout.on("data",P=>{_+=P.toString()}),b.on("error",P=>{v(P)}),b.on("close",P=>{c(_)})})}let C;function y(u,m){if(!C)if(R.isWindows)C=new S.WindowsExternalTerminalService;else if(R.isMacintosh)C=new S.MacExternalTerminalService;else if(R.isLinux)C=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=m.getConfiguration("terminal");return C.runInTerminal(u.title,u.cwd,u.args,u.env||{},c.external||{})}e.runInExternalTerminal=y;function A(u){return u?R.isWindows?new Promise(async m=>{(await new Promise((v,_)=>{J(["windows-process-tree"],v,_)})).getProcessTree(u,v=>{m(v.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(u)]).then(m=>{const c=m.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var i;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(i||(i={}));function I(u,m,c,v){u=u.trim().toLowerCase();let _;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?_=1:u.indexOf("cmd.exe")>=0?_=0:u.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let b,P=" ";switch(_){case 1:if(b=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),c){const d=(0,D.getDriveLetter)(c);d&&(P+=`${d}:; `),P+=`cd ${b(c)}; `}if(v)for(let d in v){const g=v[d];g===null?P+=`Remove-Item env:${d}; `:P+=`\${env:${d}}='${g}'; `}if(m.length>0){const d=b(m.shift());P+=d[0]==="'"?`& ${d} `:`${d} `;for(let g of m)P+=`${b(g)} `}break;case 0:if(b=d=>(d=d.replace(/\"/g,'""'),d.indexOf(" ")>=0||d.indexOf('"')>=0||d.length===0?`"${d}"`:d),c){const d=(0,D.getDriveLetter)(c);d&&(P+=`${d}: && `),P+=`cd ${b(c)} && `}if(v){P+='cmd /C "';for(let d in v){let g=v[d];g===null?P+=`set "${d}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),P+=`set "${d}=${g}" && `)}}for(let d of m)P+=`${b(d)} `;v&&(P+='"');break;case 2:b=d=>(d=d.replace(/(["'\\\$])/g,"\\$1"),d.indexOf(" ")>=0||d.indexOf(";")>=0||d.length===0?`"${d}"`:d);const l=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(c&&(P+=`cd ${b(c)} ; `),v){P+="/usr/bin/env";for(let d in v){const g=v[d];g===null?P+=` -u ${l(d)}`:P+=` ${l(`${d}=${g}`)}`}P+=" "}for(let d of m)P+=`${b(d)} `;break}return P}e.prepareCommand=I}),define(me[88],ge([0,1,30,101,10,9,11,61]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(o){o.scheme=D.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function L(M,x){return M.with({scheme:o.scheme,fragment:`ch${x.toString().padStart(7,"0")}${M.scheme!==D.Schemas.file?M.scheme:""}`})}o.generate=L;function N(M){if(M.scheme!==o.scheme)return;const x=k.exec(M.fragment);return x?{handle:Number(x[1]),notebook:M.with({scheme:M.fragment.substr(x[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parse=N;function V(M){if(M.scheme!==D.Schemas.vscodeNotebookCellMetadata)return;const x=k.exec(M.fragment);return x?{handle:Number(x[1]),notebook:M.with({scheme:M.fragment.substr(x[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=V;function ee(M,x,F){return M.with({scheme:F,fragment:`ch${x.toString().padStart(7,"0")}${M.scheme!==D.Schemas.file?M.scheme:""}`})}o.generateCellUri=ee;function z(M,x){if(M.scheme!==x)return;const F=k.exec(M.fragment);return F?{handle:Number(F[1]),notebook:M.with({scheme:M.fragment.substr(F[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parseCellUri=z})(_=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(o){return b.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function l(o){return b.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function d(o){return b.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=d;function g(o,k){return T.isWindows&&(o=o.replace(/\//g,"\\"),k=k.replace(/\//g,"\\")),p.match(o,k)}function t(o,k,L){let N=0;for(let V=0;V<k.length;V++){if(g(k[V],o))return N;N++}for(let V=0;V<L.length;V++){if(g(L[V],o))return N;N++}return N}function r(o,k,L){return o.sort((N,V)=>t(N,k,L)-t(V,k,L))}e.sortMimeTypes=r;function s(o,k,L,N=(V,ee)=>V===ee){const V=[];function ee(x,F,q){if(F===0&&q.length===0)return;const U=V[V.length-1];U&&U.start+U.deleteCount===x?(U.deleteCount+=F,U.toInsert.push(...q)):V.push({start:x,deleteCount:F,toInsert:q})}let z=0,M=0;for(;;){if(z===o.length){ee(z,0,k.slice(M));break}if(M===k.length){ee(z,o.length-z,[]);break}const x=o[z],F=k[M];if(N(x,F)){z+=1,M+=1;continue}L(F)?(ee(z,1,[]),z+=1):(ee(z,0,[F]),M+=1)}return V}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(o){const k=o;return!!((typeof k.include=="string"||p.isRelativePattern(k.include))&&(typeof k.exclude=="string"||p.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=a;function h(o,k,L){if(Array.isArray(o.viewType)&&o.viewType.indexOf(k)>=0||o.viewType===k)return!0;if(o.filenamePattern){let N=a(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,V=a(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(p.match(N,(0,S.basename)(L.fsPath).toLowerCase()))return!(V&&p.match(V,(0,S.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class f{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)k[L]=this.textModel.cells[L].getHashValue();return k}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var w;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(k){return`${E._prefix}${k}`}static parse(k){if(k.startsWith(E._prefix))return k.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(me[213],ge([0,1,176,4,61]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[214],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=p;function R(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=R}),define(me[126],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var p;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(p=e.TestResultState||(e.TestResultState={}));const R=I=>({testId:I.item.extId,controllerId:I.controllerId});e.identifyTest=R;var D;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(I,u)=>{u.expand!==void 0&&(I.expand=u.expand),u.item!==void 0&&(I.item=I.item?Object.assign(I.item,u.item):u.item)};e.applyTestItemUpdate=T;var C;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(u){}update(u){}remove(u,m){}complete(){}}e.IncrementalChangeCollector=A;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(u){const m=this.createChangeCollector();for(const c of u)switch(c[0]){case 0:{const v=c[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const b=this.createItem(v,_);this.items.set(v.item.extId,b),m.add(b)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),m.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=c[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),m.update(_);break}case 2:{const v=this.items.get(c[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[c[1]]];for(;_.length;)for(const b of _.pop()){const P=this.items.get(b);P&&(_.push(P.children),this.items.delete(b),m.remove(P,P!==v),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break}m.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=i}),define(me[89],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var p;(function(S){S.Delimiter="\0"})(p=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class D{constructor(T,C=T.length){if(this.path=T,this.viewEnd=C,T.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,C,y=T.parent){if(T.id===C)return new D([C]);let A=[T.id];for(let i=y;i&&i.id!==C;i=i.parent)A.push(i.id);return A.push(C),new D(A.reverse())}static fromString(T){return new D(T.split("\0"))}static join(T,C){return new D([...T.path,C])}static joinToString(T,C){return T.toString()+"\0"+C}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){let T=this.path[0];yield T;for(let C=1;C<this.viewEnd;C++)T+="\0",T+=this.path[C],yield T}compare(T){for(let C=0;C<T.viewEnd&&C<this.viewEnd;C++)if(T.path[C]!==this.path[C])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=D}),define(me[215],ge([0,1,9,38,14,25,11,77,177]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(I,u,m){this._contributedVariables=new Map,this._context=I,this._labelService=u,m&&(this._envVariablesPromise=m.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(T.isWindows){const u=Object.create(null);return Object.keys(I).forEach(m=>{u[m.toLowerCase()]=I[m]}),u}return I}resolveWithEnvironment(I,u,m){return this.recursiveResolve(this.prepareEnv(I),u?u.uri:void 0,m)}async resolveAsync(I,u){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,u)}async resolveAnyBase(I,u,m,c){const v=S.deepClone(u);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,v,m,c)}async resolveAnyAsync(I,u,m){return this.resolveAnyBase(I,u,m)}async resolveAnyMap(I,u,m){const c=new Map;return{newConfig:await this.resolveAnyBase(I,u,m,c),resolvedVariables:c}}resolveWithInteractionReplace(I,u,m,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,u,m,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,u){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,u)}recursiveResolve(I,u,m,c,v){if(D.isString(m))return this.resolveString(I,u,m,c,v);if(D.isArray(m))return m.map(_=>this.recursiveResolve(I,u,_,c,v));if(D.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(b=>{const P=this.resolveString(I,u,b,c,v);_[P]=this.recursiveResolve(I,u,m[b],c,v)}),_}return m}resolveString(I,u,m,c,v){return m.replace(A.VARIABLE_REGEXP,(b,P)=>{if(P.includes(A.VARIABLE_LHS))return b;let l=this.evaluateSingleVariable(I,b,P,u,c);return v&&v.set(P,l),l!==b&&D.isString(l)&&l.match(A.VARIABLE_REGEXP)&&(l=this.resolveString(I,u,l,c,v)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,u,m,c,v){let _;const b=m.split(":");b.length>1&&(m=b[0],_=b[1]);const P=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,y.localize)(0,null,u))},l=()=>{const g=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,u,p.basename(g)))},d=()=>{if(_){const g=this._context.getFolderUri(_);if(g)return g;throw new Error((0,y.localize)(2,null,u,_))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,u)):new Error((0,y.localize)(4,null,u))};switch(m){case"env":if(_){if(I){const g=I[T.isWindows?_.toLowerCase():_];if(D.isString(g))return g}return""}throw new Error((0,y.localize)(5,null,u));case"config":if(_){const g=this._context.getConfigurationValue(c,_);if(D.isUndefinedOrNull(g))throw new Error((0,y.localize)(6,null,u,_));if(D.isObject(g))throw new Error((0,y.localize)(7,null,u,_));return g}throw new Error((0,y.localize)(8,null,u));case"command":return this.resolveFromMap(u,_,v,"command");case"input":return this.resolveFromMap(u,_,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return c||_?(0,C.normalizeDriveLetter)(this.fsPath(d())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(d()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,y.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,u));case"file":return P();case"fileWorkspaceFolder":return l();case"relativeFile":return c||_?p.relative(this.fsPath(d()),P()):P();case"relativeFileDirname":const r=p.dirname(P());if(c||_){const h=p.relative(this.fsPath(d()),r);return h.length===0?".":h}return r;case"fileDirname":return p.dirname(P());case"fileExtname":return p.extname(P());case"fileBasename":return p.basename(P());case"fileBasenameNoExtension":const s=p.basename(P());return s.slice(0,s.length-p.extname(s).length);case"fileDirnameBasename":return p.basename(p.dirname(P()));case"execPath":const n=this._context.getExecPath();return n||u;case"execInstallFolder":const a=this._context.getAppRoot();return a||u;case"pathSeparator":return p.sep;default:try{const h=_?`${m}:${_}`:m;return this.resolveFromMap(u,h,v,void 0)}catch(h){return u}}}}resolveFromMap(I,u,m,c){if(u&&m){const v=c===void 0?m[u]:m[c+":"+u];if(typeof v=="string")return v;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[127],ge([0,1,4,208]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,p.createDecorator)("editorGroupsService");var D;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var S;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var C;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function A(v){const _=v;return(0,R.isEditorInput)(_?.editor)&&(0,R.isEditorInput)(_?.replacement)}e.isEditorReplacement=A;var i;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=8]="EDITOR_PIN",v[v.EDITOR_STICKY=9]="EDITOR_STICKY",v[v.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=m;function c(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(me[216],ge([0,1,4,127]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,p.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(S){const T=S;return typeof S=="number"||(0,R.isEditorGroup)(T)}e.isPreferredGroup=D}),define(me[17],ge([0,1,20,98,290,59,25,14,2,41,80,178,117,86,88,89,216,7]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(Se){function Pe(Q){const{selectionStartLineNumber:Oe,selectionStartColumn:Fe,positionLineNumber:tt,positionColumn:Ke}=Q,ut=new b.Position(Oe-1,Fe-1),St=new b.Position(tt-1,Ke-1);return new b.Selection(ut,St)}Se.to=Pe;function te(Q){const{anchor:Oe,active:Fe}=Q;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Se.from=te})(P=e.Selection||(e.Selection={}));var l;(function(Se){function Pe(Q){if(!Q)return;const{start:Oe,end:Fe}=Q;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Se.from=Pe;function te(Q){if(!Q)return;const{startLineNumber:Oe,startColumn:Fe,endLineNumber:tt,endColumn:Ke}=Q;return new b.Range(Oe-1,Fe-1,tt-1,Ke-1)}Se.to=te})(l=e.Range||(e.Range={}));var d;(function(Se){function Pe(te){switch(te){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}Se.to=Pe})(d=e.TokenType||(e.TokenType={}));var g;(function(Se){function Pe(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}Se.to=Pe;function te(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Se.from=te})(g=e.Position||(e.Position={}));var t;(function(Se){function Pe(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}Se.to=te})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(Se){function Pe(Q){let Oe;return Q.code&&((0,C.isString)(Q.code)||(0,C.isNumber)(Q.code)?Oe=String(Q.code):Oe={value:String(Q.code.value),target:Q.code.target}),{...l.from(Q.range),message:Q.message,source:Q.source,code:Oe,severity:n.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(s.from),tags:Array.isArray(Q.tags)?(0,p.coalesce)(Q.tags.map(t.from)):void 0}}Se.from=Pe;function te(Q){const Oe=new b.Diagnostic(l.to(Q),Q.message,n.to(Q.severity));return Oe.source=Q.source,Oe.code=(0,C.isString)(Q.code)?Q.code:Q.code?.value,Oe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(s.to),Oe.tags=Q.tags&&(0,p.coalesce)(Q.tags.map(t.to)),Oe}Se.to=te})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(Se){function Pe(Q){return{...l.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Se.from=Pe;function te(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,l.to(Q)),Q.message)}Se.to=te})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Se){function Pe(Q){switch(Q){case b.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Se.from=Pe;function te(Q){switch(Q){case u.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}Se.to=te})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(Se){function Pe(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}Se.from=Pe;function te(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=te})(a=e.ViewColumn||(e.ViewColumn={}));function h(Se){return typeof Se.range!="undefined"}function f(Se){return Se.length===0?!0:!!h(Se[0])}e.isDecorationOptionsArr=f;var w;(function(Se){function Pe(Ke){return Ke.map(Se.from)}Se.fromMany=Pe;function te(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let ut;if(te(Ke)){const{language:ft,value:dt}=Ke;ut={value:"```"+ft+`
`+dt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const St=Object.create(null);ut.uris=St;const kt=ft=>{try{let dt=y.URI.parse(ft,!0);dt=dt.with({query:Oe(dt.query,St)}),St[ft]=dt}catch(dt){}return""},Dt=new D.Renderer;return Dt.link=kt,Dt.image=ft=>kt(R.parseHrefAndDimensions(ft).href),D(ut.value,{renderer:Dt}),ut}Se.from=Q;function Oe(Ke,ut){if(!Ke)return Ke;let St;try{St=(0,S.parse)(Ke)}catch(Dt){}if(!St)return Ke;let kt=!1;return St=(0,T.cloneAndChange)(St,Dt=>{if(y.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=Dt,kt=!0,ft}else return}),kt?JSON.stringify(St):Ke}function Fe(Ke){const ut=new b.MarkdownString(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut}Se.to=Fe;function tt(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Se.from(Ke)}Se.fromStrict=tt})(w=e.MarkdownString||(e.MarkdownString={}));function E(Se){return f(Se)?Se.map(Pe=>({range:l.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?w.fromMany(Pe.hoverMessage):Pe.hoverMessage?w.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Se.map(Pe=>({range:l.from(Pe)}))}e.fromRangeOrRangeWithMessage=E;function o(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?y.URI.file(Se):Se}e.pathOrURIToURI=o;var k;(function(Se){function Pe(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?o(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}Se.from=Pe})(k=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(Se){function Pe(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?o(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?k.from(te.before):void 0,after:te.after?k.from(te.after):void 0}}Se.from=Pe})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(Se){function Pe(te){if(typeof te=="undefined")return te;switch(te){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Pe})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(Se){function Pe(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?N.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?L.from(te.light):void 0,dark:te.dark?L.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?o(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?k.from(te.before):void 0,after:te.after?k.from(te.after):void 0}}Se.from=Pe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(Se){function Pe(Q){return{text:Q.newText,eol:Q.newEol&&he.from(Q.newEol),range:l.from(Q.range)}}Se.from=Pe;function te(Q){const Oe=new b.TextEdit(l.to(Q.range),Q.text);return Oe.newEol=typeof Q.eol=="undefined"?void 0:he.to(Q.eol),Oe}Se.to=te})(ee=e.TextEdit||(e.TextEdit={}));var z;(function(Se){function Pe(Q,Oe,Fe){const tt={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let Ke of Q._allEntries())if(Ke._type===1)tt.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const ut=Oe?.getDocument(Ke.uri);tt.edits.push({_type:2,resource:Ke.uri,edit:ee.from(Ke.edit),modelVersionId:ut?.version,metadata:Ke.metadata})}else Ke._type===3?tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(j.from)}});return tt}Se.from=Pe;function te(Q){const Oe=new b.WorkspaceEdit;for(const Fe of Q.edits)Fe.edit?Oe.replace(y.URI.revive(Fe.resource),l.to(Fe.edit.range),Fe.edit.text):Oe.renameFile(y.URI.revive(Fe.oldUri),y.URI.revive(Fe.newUri),Fe.options);return Oe}Se.to=te})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(Se){const Pe=Object.create(null);Pe[b.SymbolKind.File]=0,Pe[b.SymbolKind.Module]=1,Pe[b.SymbolKind.Namespace]=2,Pe[b.SymbolKind.Package]=3,Pe[b.SymbolKind.Class]=4,Pe[b.SymbolKind.Method]=5,Pe[b.SymbolKind.Property]=6,Pe[b.SymbolKind.Field]=7,Pe[b.SymbolKind.Constructor]=8,Pe[b.SymbolKind.Enum]=9,Pe[b.SymbolKind.Interface]=10,Pe[b.SymbolKind.Function]=11,Pe[b.SymbolKind.Variable]=12,Pe[b.SymbolKind.Constant]=13,Pe[b.SymbolKind.String]=14,Pe[b.SymbolKind.Number]=15,Pe[b.SymbolKind.Boolean]=16,Pe[b.SymbolKind.Array]=17,Pe[b.SymbolKind.Object]=18,Pe[b.SymbolKind.Key]=19,Pe[b.SymbolKind.Null]=20,Pe[b.SymbolKind.EnumMember]=21,Pe[b.SymbolKind.Struct]=22,Pe[b.SymbolKind.Event]=23,Pe[b.SymbolKind.Operator]=24,Pe[b.SymbolKind.TypeParameter]=25;function te(Oe){return typeof Pe[Oe]=="number"?Pe[Oe]:6}Se.from=te;function Q(Oe){for(const Fe in Pe)if(Pe[Fe]===Oe)return Number(Fe);return b.SymbolKind.Property}Se.to=Q})(M=e.SymbolKind||(e.SymbolKind={}));var x;(function(Se){function Pe(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}Se.to=te})(x=e.SymbolTag||(e.SymbolTag={}));var F;(function(Se){function Pe(Q){return{name:Q.name,kind:M.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:$.from(Q.location)}}Se.from=Pe;function te(Q){const Oe=new b.SymbolInformation(Q.name,M.to(Q.kind),Q.containerName,$.to(Q.location));return Oe.tags=Q.tags&&Q.tags.map(x.to),Oe}Se.to=te})(F=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(Se){function Pe(Q){const Oe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:l.from(Q.range),selectionRange:l.from(Q.selectionRange),kind:M.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Oe.children=Q.children.map(Pe)),Oe}Se.from=Pe;function te(Q){const Oe=new b.DocumentSymbol(Q.name,Q.detail,M.to(Q.kind),l.to(Q.range),l.to(Q.selectionRange));return(0,p.isNonEmptyArray)(Q.tags)&&(Oe.tags=Q.tags.map(x.to)),Q.children&&(Oe.children=Q.children.map(te)),Oe}Se.to=te})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(Se){function Pe(Q){const Oe=new b.CallHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),l.to(Q.range),l.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Se.to=Pe;function te(Q,Oe,Fe){if(Oe=Oe??Q._sessionId,Fe=Fe??Q._itemId,Oe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Fe,name:Q.name,detail:Q.detail,kind:M.from(Q.kind),uri:Q.uri,range:l.from(Q.range),selectionRange:l.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}Se.from=te})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var O;(function(Se){function Pe(te){return new b.CallHierarchyIncomingCall(U.to(te.from),te.fromRanges.map(Q=>l.to(Q)))}Se.to=Pe})(O=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(Se){function Pe(te){return new b.CallHierarchyOutgoingCall(U.to(te.to),te.fromRanges.map(Q=>l.to(Q)))}Se.to=Pe})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(Se){function Pe(Q){return{range:Q.range&&l.from(Q.range),uri:Q.uri}}Se.from=Pe;function te(Q){return new b.Location(y.URI.revive(Q.uri),l.to(Q.range))}Se.to=te})($=e.location||(e.location={}));var K;(function(Se){function Pe(Q){const Oe=Q,Fe=Q;return{originSelectionRange:Oe.originSelectionRange?l.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Fe.uri,range:l.from(Oe.targetRange?Oe.targetRange:Fe.range),targetSelectionRange:Oe.targetSelectionRange?l.from(Oe.targetSelectionRange):void 0}}Se.from=Pe;function te(Q){return{targetUri:y.URI.revive(Q.uri),targetRange:l.to(Q.range),targetSelectionRange:Q.targetSelectionRange?l.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?l.to(Q.originSelectionRange):void 0}}Se.to=te})(K=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(Se){function Pe(Q){return{range:l.from(Q.range),contents:w.fromMany(Q.contents)}}Se.from=Pe;function te(Q){return new b.Hover(Q.contents.map(w.to),l.to(Q.range))}Se.to=te})(re=e.Hover||(e.Hover={}));var fe;(function(Se){function Pe(Q){return{range:l.from(Q.range),expression:Q.expression}}Se.from=Pe;function te(Q){return new b.EvaluatableExpression(l.to(Q.range),Q.expression)}Se.to=te})(fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(Se){function Pe(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:l.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:l.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Pe;function te(Q){switch(Q.type){case"text":return{range:l.to(Q.range),text:Q.text};case"variable":return{range:l.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:l.to(Q.range),expression:Q.expression}}}Se.to=te})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(Se){function Pe(Q){return{frameId:Q.frameId,stoppedLocation:l.from(Q.stoppedLocation)}}Se.from=Pe;function te(Q){return new b.InlineValueContext(Q.frameId,l.to(Q.stoppedLocation))}Se.to=te})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(Se){function Pe(Q){return{range:l.from(Q.range),kind:Q.kind}}Se.from=Pe;function te(Q){return new b.DocumentHighlight(l.to(Q.range),Q.kind)}Se.to=te})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(Se){function Pe(te){switch(te){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}Se.to=Pe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(Se){function Pe(te){return{triggerKind:qe.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}Se.to=Pe})(We=e.CompletionContext||(e.CompletionContext={}));var je;(function(Se){function Pe(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}Se.to=te})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Se){const Pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function te(Fe){return Pe.get(Fe)??9}Se.from=te;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Oe(Fe){return Q.get(Fe)??b.CompletionItemKind.Property}Se.to=Oe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(Se){function Pe(te,Q){const Oe=new b.CompletionItem(te.label);return Oe.insertText=te.insertText,Oe.kind=W.to(te.kind),Oe.tags=te.tags?.map(je.to),Oe.detail=te.detail,Oe.documentation=R.isMarkdownString(te.documentation)?w.to(te.documentation):te.documentation,Oe.sortText=te.sortText,Oe.filterText=te.filterText,Oe.preselect=te.preselect,Oe.commitCharacters=te.commitCharacters,A.Range.isIRange(te.range)?Oe.range=l.to(te.range):typeof te.range=="object"&&(Oe.range={inserting:l.to(te.range.insert),replacing:l.to(te.range.replace)}),Oe.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?Oe.insertText=new b.SnippetString(te.insertText):(Oe.insertText=te.insertText,Oe.textEdit=Oe.range instanceof b.Range?new b.TextEdit(Oe.range,Oe.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(Oe.additionalTextEdits=te.additionalTextEdits.map(Fe=>ee.to(Fe))),Oe.command=Q&&te.command?Q.fromInternal(te.command):void 0,Oe}Se.to=Pe})(Z=e.CompletionItem||(e.CompletionItem={}));var ne;(function(Se){function Pe(Q){return{label:Q.label,documentation:Q.documentation?w.fromStrict(Q.documentation):void 0}}Se.from=Pe;function te(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?w.to(Q.documentation):Q.documentation}}Se.to=te})(ne=e.ParameterInformation||(e.ParameterInformation={}));var le;(function(Se){function Pe(Q){return{label:Q.label,documentation:Q.documentation?w.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ne.from):[],activeParameter:Q.activeParameter}}Se.from=Pe;function te(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?w.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ne.to):[],activeParameter:Q.activeParameter}}Se.to=te})(le=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(Se){function Pe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(le.from):[]}}Se.from=Pe;function te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(le.to):[]}}Se.to=te})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(Se){function Pe(Q){return{text:Q.text,position:g.from(Q.position),kind:ve.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}Se.from=Pe;function te(Q){const Oe=new b.InlayHint(Q.text,g.to(Q.position),ve.to(Q.kind));return Oe.whitespaceAfter=Q.whitespaceAfter,Oe.whitespaceBefore=Q.whitespaceBefore,Oe}Se.to=te})(ae=e.InlayHint||(e.InlayHint={}));var ve;(function(Se){function Pe(Q){return Q}Se.from=Pe;function te(Q){return Q}Se.to=te})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(Se){function Pe(Q){return{range:l.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Se.from=Pe;function te(Q){let Oe;if(Q.url)try{Oe=typeof Q.url=="string"?y.URI.parse(Q.url,!0):y.URI.revive(Q.url)}catch(Fe){}return new b.DocumentLink(l.to(Q.range),Oe)}Se.to=te})(Me=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Se){function Pe(Q){const Oe=new b.ColorPresentation(Q.label);return Q.textEdit&&(Oe.textEdit=ee.to(Q.textEdit)),Q.additionalTextEdits&&(Oe.additionalTextEdits=Q.additionalTextEdits.map(Fe=>ee.to(Fe))),Oe}Se.to=Pe;function te(Q){return{label:Q.label,textEdit:Q.textEdit?ee.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Oe=>ee.from(Oe)):void 0}}Se.from=te})(ze=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(Se){function Pe(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}Se.to=Pe;function te(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Se.from=te})(Ee=e.Color||(e.Color={}));var Ye;(function(Se){function Pe(Q){return{range:l.from(Q.range)}}Se.from=Pe;function te(Q){return new b.SelectionRange(l.to(Q.range))}Se.to=te})(Ye=e.SelectionRange||(e.SelectionRange={}));var X;(function(Se){function Pe(te){switch(te){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}Se.to=Pe})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var se;(function(Se){function Pe(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Pe;function te(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}Se.to=te})(se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(Se){function Pe(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}Se.from=Pe;function te(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}Se.to=te})(he=e.EndOfLine||(e.EndOfLine={}));var xe;(function(Se){function Pe(te){if(typeof te=="object")return te.viewId;switch(te){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Pe})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(Se){function Pe(te){const Q={start:te.start+1,end:te.end+1};return te.kind&&(Q.kind=et.from(te.kind)),Q}Se.from=Pe})(Be=e.FoldingRange||(e.FoldingRange={}));var et;(function(Se){function Pe(te){if(te)switch(te){case b.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Se.from=Pe})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ce;(function(Se){function Pe(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?l.from(te.selection):void 0,override:typeof te.override=="boolean"?I.EditorResolution.DISABLED:void 0}}Se.from=Pe})(Ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var De;(function(Se){function Pe(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:te(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}Se.from=Pe;function te(Q){const Oe=Q;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(De=e.GlobPattern||(e.GlobPattern={}));var Te;(function(Se){function Pe(te){if(te){if(Array.isArray(te))return te.map(Pe);if(typeof te=="string")return te;{const Q=te;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:De.from(Q.pattern),exclusive:Q.exclusive}}}else return}Se.from=Pe})(Te=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(Se){function Pe(Q){return{start:Q.start,end:Q.end}}Se.from=Pe;function te(Q){return new b.NotebookRange(Q.start,Q.end)}Se.to=te})(ce=e.NotebookRange||(e.NotebookRange={}));var ue;(function(Se){function Pe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Se.to=Pe;function te(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Se.from=te})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var pe;(function(Se){function Pe(Q){switch(Q){case b.NotebookCellKind.Markup:return c.CellKind.Markup;case b.NotebookCellKind.Code:default:return c.CellKind.Code}}Se.from=Pe;function te(Q){switch(Q){case c.CellKind.Markup:return b.NotebookCellKind.Markup;case c.CellKind.Code:default:return b.NotebookCellKind.Code}}Se.to=te})(pe=e.NotebookCellKind||(e.NotebookCellKind={}));var be;(function(Se){function Pe(Q){const Oe={metadata:Q.metadata??Object.create(null),cells:[]};for(let Fe of Q.cells)b.NotebookCellData.validate(Fe),Oe.cells.push(j.from(Fe));return Oe}Se.from=Pe;function te(Q){const Oe=new b.NotebookData(Q.cells.map(j.to));return(0,C.isEmptyObject)(Q.metadata)||(Oe.metadata=Q.metadata),Oe}Se.to=te})(be=e.NotebookData||(e.NotebookData={}));var j;(function(Se){function Pe(Q){return{cellKind:pe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ue.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(_e.from):[]}}Se.from=Pe;function te(Q){return new b.NotebookCellData(pe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(_e.to):void 0,Q.metadata,Q.internalMetadata?ue.to(Q.internalMetadata):void 0)}Se.to=te})(j=e.NotebookCellData||(e.NotebookCellData={}));var we;(function(Se){function Pe(Q){return{mime:Q.mime,valueBytes:Array.from(Q.data)}}Se.from=Pe;function te(Q){return new b.NotebookCellOutputItem(new Uint8Array(Q.valueBytes),Q.mime)}Se.to=te})(we=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var _e;(function(Se){function Pe(Q){return{outputId:Q.id,items:Q.items.map(we.from),metadata:Q.metadata}}Se.from=Pe;function te(Q){const Oe=Q.items.map(we.to);return new b.NotebookCellOutput(Oe,Q.outputId,Q.metadata)}Se.to=te})(_e=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(Se){function Pe(Fe){if(Fe!=null){if(Fe instanceof b.RelativePattern||typeof Fe=="string")return Fe;if(Oe(Fe))return new b.RelativePattern(Fe.base,Fe.pattern);if(Q(Fe))return{include:De.from(Fe.include)||void 0,exclude:De.from(Fe.exclude)||void 0}}}Se.from=Pe;function te(Fe){return typeof Fe=="string"?Fe:Oe(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}Se.to=te;function Q(Fe){const tt=Fe,Ke=De.from(tt.include);if(!(Ke&&Ke instanceof b.RelativePattern||typeof Ke=="string"))return!1;const ut=De.from(tt.exclude);return!!(ut&&ut instanceof b.RelativePattern||typeof ut=="string")}function Oe(Fe){const tt=Fe;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ue;(function(Se){function Pe(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?k.from(te.top):void 0}}Se.from=Pe})(Ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(Se){function Pe(te,Q,Oe){const Fe=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Fe,Oe),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}Se.from=Pe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(Se){function Pe(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}Se.from=Pe})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(Se){function Pe(Q){return{uri:Q.uri,provides:Q.provides}}Se.from=Pe;function te(Q){return new b.NotebookRendererScript(y.URI.revive(Q.uri),Q.provides)}Se.to=te})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(Se){function Pe(Q){return{message:w.fromStrict(Q.message)||"",severity:b.TestMessageSeverity.Error,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?$.from(Q.location):void 0}}Se.from=Pe;function te(Q){const Oe=new b.TestMessage(typeof Q.message=="string"?Q.message:w.to(Q.message));return Oe.actualOutput=Q.actualOutput,Oe.expectedOutput=Q.expectedOutput,Oe}Se.to=te})(Je=e.TestMessage||(e.TestMessage={}));var ct;(function(Se){function Pe(Fe){return{extId:v.TestId.fromExtHostTestItem(Fe,(0,m.getPrivateApiFor)(Fe).controllerId).toString(),label:Fe.label,uri:Fe.uri,range:l.from(Fe.range)||null,description:Fe.description||null,error:Fe.error&&w.fromStrict(Fe.error)||null}}Se.from=Pe;function te(Fe){return{id:v.TestId.fromString(Fe.extId).localId,label:Fe.label,uri:y.URI.revive(Fe.uri),range:l.to(Fe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Fe.description||void 0}}Se.toPlain=te;function Q(Fe){const tt=v.TestId.fromString(Fe.extId),Ke=new m.TestItemImpl(tt.controllerId,tt.localId,Fe.label,y.URI.revive(Fe.uri));return Ke.range=l.to(Fe.range||void 0),Ke.description=Fe.description||void 0,Ke}function Oe(Fe){let tt;for(const Ke of Fe.tests){const ut=Q(Ke.item);(0,m.getPrivateApiFor)(ut).parent=tt,tt=ut}return tt}Se.toItemFromContext=Oe})(ct=e.TestItem||(e.TestItem={}));var mt;(function(Se){const Pe=(Q,Oe)=>{const Fe={...ct.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Je.to)})),children:Q.children.map(tt=>Oe.get(tt)).filter(C.isDefined).map(tt=>Pe(tt,Oe))};for(const tt of Fe.children)tt.parent=Fe;return Fe};function te(Q){const Oe=[],Fe=new Map;for(const tt of Q.items)Fe.set(tt.item.extId,tt),Q.request.targets.some(Ke=>Ke.controllerId===tt.controllerId&&Ke.testIds.includes(tt.item.extId))&&Oe.push(tt);return{completedAt:Q.completedAt,results:Oe.map(tt=>Pe(tt,Fe))}}Se.to=te})(mt=e.TestResults||(e.TestResults={}));var bt;(function(Se){function Pe(Fe){return{covered:Fe.covered,total:Fe.covered}}function te(Fe){return"line"in Fe?g.from(Fe):l.from(Fe)}function Q(Fe){return"branches"in Fe?{count:Fe.executionCount,location:te(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(tt=>({count:tt.executionCount,location:tt.location&&te(tt.location)})):void 0}:{type:0,count:Fe.executionCount,location:te(Fe.location)}}Se.fromDetailed=Q;function Oe(Fe){return{uri:Fe.uri,statement:Pe(Fe.statementCoverage),branch:Fe.branchCoverage&&Pe(Fe.branchCoverage),function:Fe.functionCoverage&&Pe(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Q)}}Se.fromFile=Oe})(bt=e.TestCoverage||(e.TestCoverage={}));var ot;(function(Se){function Pe(te){switch(te){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}Se.to=Pe})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(Se){function Pe(Q){const Oe=new b.TypeHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),l.to(Q.range),l.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Se.to=Pe;function te(Q,Oe,Fe){if(Oe=Oe??Q._sessionId,Fe=Fe??Q._itemId,Oe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Fe,kind:M.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:l.from(Q.range),selectionRange:l.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}Se.from=te})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[217],ge([0,1,2,15,7,17,94]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(A,i,I,u={timeout:1500,errors:3}){this._logService=A,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(i,I,u)=>{const c={dispose:this._callbacks.push([i,I,A])};return Array.isArray(u)&&u.push(c),c}}async $participateInSave(A,i){const I=p.URI.revive(A);let u=!1;const m=setTimeout(()=>u=!0,this._thresholds.timeout),c=[];try{for(let v of[...this._callbacks]){if(u)break;const _=this._documents.getDocument(I),b=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:S.TextDocumentSaveReason.to(i)});c.push(b)}}finally{clearTimeout(m)}return c}_deliverEventAsyncAndBlameBadListeners([A,i,I],u){const m=this._badListeners.get(A);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,A,i,u).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const v=this._badListeners.get(A);this._badListeners.set(A,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,i,I,u){const m=[],c=Date.now(),{document:v,reason:_}=u,{version:b}=v,P=Object.freeze({document:v,reason:_,waitUntil(l){if(Object.isFrozen(m))throw(0,R.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(l))}});try{i.apply(I,[P])}catch(l){return Promise.reject(l)}return Object.freeze(m),new Promise((l,d)=>{const g=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(g),l(t)}).catch(t=>{clearTimeout(g),d(t)})}).then(l=>{const d={edits:[]};for(const g of l)if(Array.isArray(g)&&g.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:r,range:s}of g)d.edits.push({_type:2,resource:v.uri,edit:{range:s&&S.Range.from(s),text:t,eol:r&&S.EndOfLine.from(r)}});if(d.edits.length!==0)return b===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[218],ge([0,1,3,30,2,17,7]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(i,I,u,m,c){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,u&&(this._config+=1),m&&(this._config+=2),c&&(this._config+=4);const v=(0,R.parse)(I),_=i(b=>{if(!u)for(let P of b.created){const l=D.URI.revive(P);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!m)for(let P of b.changed){const l=D.URI.revive(P);v(l.fsPath)&&this._onDidChange.fire(l)}if(!c)for(let P of b.deleted){const l=D.URI.revive(P);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(i,I,u){this._logService=I,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new p.AsyncEmitter,this._onWillCreateFile=new p.AsyncEmitter,this._onWillDeleteFile=new p.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,u,m){return new C(this._onFileSystemEvent.event,i,I,u,m)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(u=>({oldUri:D.URI.revive(u.source),newUri:D.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(u=>D.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(u=>D.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(u,m,c)=>{const v=function(b){u.call(m,b)};return v.extension=i,I.event(v,void 0,c)}}async $onWillRunFileOperation(i,I,u,m){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(c=>({oldUri:D.URI.revive(c.source),newUri:D.URI.revive(c.target)}))},u,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(c=>D.URI.revive(c.target))},u,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(c=>D.URI.revive(c.target))},u,m)}}async _fireWillEvent(i,I,u,m){const c=new Set,v=[];if(await i.fireAsync(I,m,async(b,P)=>{const l=Date.now(),d=await Promise.resolve(b);d instanceof T.WorkspaceEdit&&(v.push(d),c.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-l>u&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let b of v){let{edits:P}=S.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(P)}return{edit:_,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=y}),define(me[219],ge([0,1,10,25,2,17,7,88]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(u,m,c,v){this.start=u,this.deletedCount=m,this.deletedItems=c,this.items=v}static asApiEvents(u){return u.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(c=>c.apiCell)}))}}class A{constructor(u,m,c){this.notebook=u,this._extHostDocument=m,this._cellData=c,this.handle=c.handle,this.uri=D.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=c.internalMetadata??{},this._metadata=Object.freeze(c.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(c.internalMetadata??{}))}static asModelAddData(u,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return u._mime},set mime(c){u._mime=c},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(S.NotebookCellOutput.to)}setOutputItems(u,m,c){const v=c.map(S.NotebookCellOutputItem.to),_=this._outputs.find(b=>b.id===u);_&&(m||(_.items.length=0),_.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=A;class i{constructor(u,m,c,v,_,b){this._proxy=u,this._textDocumentsAndEditors=m,this._textDocuments=c,this._emitter=v,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===p.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(m){return m=u._validateIndex(m),u._cells[m].apiCell},getCells(m){return(m?u._getCells(m):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,m){this._versionId=u.versionId,this._isDirty=m;for(const c of u.rawEvents)c.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===C.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let m=u.start|0,c=u.end|0;return m<0&&(m=0),c>this._cells.length&&(c=this._cells.length),u.with({start:m,end:c})}_getCells(u){u=this._validateRange(u);const m=[];for(let c=u.start;c<u.end;c++)m.push(this._cells[c]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,m){if(this._disposed)return;const c=[],v=[],_=[];u.reverse().forEach(b=>{const l=b[2].map(t=>{const r=new A(this,this._textDocumentsAndEditors,t);return m||v.push(A.asModelAddData(this.apiNotebook,t)),r}),d=new y(b[0],b[1],[],l),g=this._cells.splice(b[0],b[1],...l);for(const t of g)_.push(t.uri),d.deletedItems.push(t.apiCell);c.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),m||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(c)}))}_moveCell(u,m){const c=this._cells.splice(u,1);this._cells.splice(m,0,...c);const v=[new y(u,1,c.map(_=>_.apiCell),[]),new y(m,0,[],c)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(v)}))}_setCellOutputs(u,m){const c=this._cells[u];c.setOutputs(m),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(u,m,c,v){const _=this._cells[u];_.setOutputItems(m,c,v),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(u,m){const c=this._cells[u];c.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(c.uri,m)}_changeCellMime(u,m){const c=this._cells[u];c.apiCell.mime=m}_changeCellMetadata(u,m){const c=this._cells[u],v=c.apiCell.metadata;c.setMetadata(m);const _=c.apiCell.metadata;(0,R.equals)(v,_)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(u,m){const c=this._cells[u],v=c.internalMetadata;if(c.setInternalMetadata(m),v.runState!==m.runState){const _=m.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:c.apiCell,state:_}))}}getCellFromApiCell(u){return this._cells.find(m=>m.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(m=>m.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[128],ge([0,1,7,17,15]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:A})}replaceCells(y,A,i){this._throwIfFinalized(),!(y===A&&i.length===0)&&this._collectedEdits.push({editType:1,index:y,count:A-y,cells:i.map(R.NotebookCellData.from)})}}class T{constructor(y,A,i,I,u,m){this.id=y,this._proxy=A,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=I,this._viewColumn=m}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(A){if(!Array.isArray(A)||!A.every(p.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");y._selections=A,y._trySetSelections(A)},get visibleRanges(){return y._visibleRanges},revealRange(A,i){y._proxy.$tryRevealRange(y.id,R.NotebookRange.from(A),i??p.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(A){const i=new S(this.document.version);return A(i),y._applyEdit(i.finalize())},setDecorations(A,i){return y.setDecorations(A,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(R.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const A=[];let i=-1;for(let I=0;I<y.cellEdits.length;I++){if(i<0){A.push(y.cellEdits[I]),i++;continue}const m=A[i],c=y.cellEdits[I];if(m.editType===1&&c.editType===1&&m.index===c.index){m.cells.push(...y.cellEdits[I].cells),m.count+=y.cellEdits[I].count;continue}A.push(y.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,A)}setDecorations(y,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return A.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(A),y.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[220],ge([0,1,17,118,165,21,56]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,u,m){const c=this._handles++,{title:v,location:_,cancellable:b}=u,P={label:(0,D.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:p.ProgressLocation.from(_),title:v,source:P,cancellable:b},I),this._withProgress(c,m,!!b)}_withProgress(I,u,m){let c;m&&(c=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),c&&c.dispose()};let _;try{_=u(new A(this._proxy,I),m&&c?c.token:S.CancellationToken.None)}catch(b){throw v(I),b}return _.then(b=>v(I),b=>v(I)),_}$acceptProgressCanceled(I){const u=this._mapHandleToCancellationSource.get(I);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function y(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class A extends R.Progress{constructor(I,u){super(m=>this.throttledReport(m));this._proxy=I,this._handle=u}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([(0,T.throttle)(100,(i,I)=>y(i,I),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(me[129],ge([0,1,54,15,73,17,7]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(u,m,c){const v=C._Keys.nextId();u.$registerTextEditorDecorationType(m.identifier,v,S.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=C,C._Keys=new D.IdGenerator("TextEditorDecorationType");class y{constructor(u,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,m){this._throwIfFinalized();let c=null;if(u instanceof T.Position)c=new T.Range(u,u);else if(u instanceof T.Range)c=u;else throw new Error("Unrecognized location");this._pushEdit(c,m,!1)}insert(u,m){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),m,!0)}delete(u){this._throwIfFinalized();let m=null;if(u instanceof T.Range)m=u;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(u,m,c){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:c})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=y;class A{constructor(u,m,c,v){this._proxy=u,this._id=m,this._accept(c),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(b){_._setTabSize(b)},get insertSpaces(){return _._insertSpaces},set insertSpaces(b){_._setInsertSpaces(b)},get cursorStyle(){return _._cursorStyle},set cursorStyle(b){_._setCursorStyle(b)},get lineNumbers(){return _._lineNumbers},set lineNumbers(b){_._setLineNumbers(b)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const m=Math.floor(u);return m>0?m:null}if(typeof u=="string"){const m=parseInt(u,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(u){const m=this._validateTabSize(u);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const m=this._validateInsertSpaces(u);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(u)})))}assign(u){const m={};let c=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(c=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,c=!0,m.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(c=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,c=!0,m.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,c=!0,m.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,c=!0,m.lineNumbers=S.TextEditorLineNumbersStyle.from(u.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(u){u.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=A;class i{constructor(u,m,c,v,_,b,P,l){this.id=u,this._proxy=m,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new A(this._proxy,this.id,b,c),this._visibleRanges=P,this._viewColumn=l;const d=this;this.value=Object.freeze({get document(){return v.getValue()},set document(g){throw(0,R.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(g){if(!(g instanceof T.Selection))throw(0,R.illegalArgument)("selection");d._selections=[g],d._trySetSelection()},get selections(){return d._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof T.Selection)))throw(0,R.illegalArgument)("selections");d._selections=g,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(g){throw(0,R.readonly)("visibleRanges")},get options(){return d._options.value},set options(g){d._disposed||d._options.assign(g)},get viewColumn(){return d._viewColumn},set viewColumn(g){throw(0,R.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(v.getValue(),t);return g(r),d._applyEdit(r)},insertSnippet(g,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=d._selections.map(n=>S.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:a}=S.Position.from(t);s=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof T.Range)s=[S.Range.from(t)];else{s=[];for(const n of t)if(n instanceof T.Range)s.push(S.Range.from(n));else{const{lineNumber:a,column:h}=S.Position.from(n);s.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return m.$tryInsertSnippet(u,g.value,s,r)},setDecorations(g,t){const r=t.length===0;r&&!d._hasDecorationsForKey.has(g.key)||(r?d._hasDecorationsForKey.delete(g.key):d._hasDecorationsForKey.add(g.key),d._runOnProxy(()=>{if(S.isDecorationOptionsArr(t))return m.$trySetDecorations(u,g.key,S.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const h=t[n];s[4*n]=h.start.line+1,s[4*n+1]=h.start.character+1,s[4*n+2]=h.end.line+1,s[4*n+3]=h.end.character+1}return m.$trySetDecorationsFast(u,g.key,s)}}))},revealRange(g,t){d._runOnProxy(()=>m.$tryRevealRange(u,S.Range.from(g),t||T.TextEditorRevealType.Default))},show(g){m.$tryShowEditor(u,S.ViewColumn.from(g))},hide(){m.$tryHideEditor(u)}})}dispose(){(0,p.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,p.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,p.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,p.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,p.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const m=u.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const c=m.edits.map(_=>_.range);c.sort((_,b)=>_.end.line===b.end.line?_.end.character===b.end.character?_.start.line===b.start.line?_.start.character-b.start.character:_.start.line-b.start.line:_.end.character-b.end.character:_.end.line-b.end.line);for(let _=0,b=c.length-1;_<b;_++){const P=c[_].end;if(c[_+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(_=>({range:S.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?S.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=i}),define(me[221],ge([0,1,168,24,2,3,6,209,16,7,14,20,17,21,206]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(P,l){if((0,i.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let d;return Array.isArray(P.highlights)&&(d=P.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),d=d.length?d:void 0),{label:P.label,highlights:d}}}class _{constructor(l,d,g){this._proxy=l,this.commands=d,this.logService=g,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}d.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(l,d,g){const t=this.createTreeView(l,{treeDataProvider:d},g);return{dispose:()=>t.dispose()}}createTreeView(l,d,g){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=d.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(l,d,g);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(n){s.message=n},get title(){return s.title},set title(n){s.title=n},get description(){return s.description},set description(n){s.description=n},reveal:(n,a)=>s.reveal(n,a),dispose:async()=>{await r,this.treeViews.delete(l),s.dispose()}}}$getChildren(l,d){const g=this.treeViews.get(l);return g?g.getChildren(d):Promise.reject(new Error((0,p.localize)(0,null,l)))}async $onDrop(l,d,g){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,p.localize)(1,null,l)));const r=c.TreeDataTransferConverter.toITreeDataTransfer(d);if(r.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await r.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(a=>t.getExtensionElement(a)).filter(a=>!!a);n.length>0?r.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):r.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,g)}async $hasResolve(l){const d=this.treeViews.get(l);if(!d)throw new Error((0,p.localize)(2,null,l));return d.hasResolve}$resolve(l,d,g){const t=this.treeViews.get(l);if(!t)throw new Error((0,p.localize)(3,null,l));return t.resolveTreeItem(d,g)}$setExpanded(l,d,g){const t=this.treeViews.get(l);if(!t)throw new Error((0,p.localize)(4,null,l));t.setExpanded(d,g)}$setSelection(l,d){const g=this.treeViews.get(l);if(!g)throw new Error((0,p.localize)(5,null,l));g.setSelection(d)}$setVisible(l,d){const g=this.treeViews.get(l);if(!g)throw new Error((0,p.localize)(6,null,l));g.setVisible(d)}createExtHostTreeView(l,d,g){const t=new b(l,d,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(l,t),t}convertArgument(l){const d=this.treeViews.get(l.$treeViewId);return d?d.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=_;class b extends T.Disposable{constructor(l,d,g,t,r,s){super();if(this.viewId=l,this.proxy=g,this.commands=t,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,s.contributes&&s.contributes.views)for(const h in s.contributes.views)for(const f of s.contributes.views[h])f.id===l&&(this._title=f.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let n,a;this._register(S.Event.debounce(this._onDidChangeData.event,(h,f)=>(h||(h={message:!1,elements:[]}),f.element!==!1&&(n||(n=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(f.element)?h.elements.push(...f.element):h.elements.push(f.element)),f.message&&(h.message=!0),h),200,!0)(({message:h,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return n=null,this.refresh(f).then(()=>w())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,i.isUndefinedOrNull)(l))}getChildren(l){const d=l?this.getExtensionElement(l):void 0;if(l&&!d)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);const g=this.getChildrenNodes(l);return(g?Promise.resolve(g):this.fetchChildrenNodes(d)).then(t=>t.map(r=>r.item))}getExtensionElement(l){return this.elements.get(l)}reveal(l,d){d=d||{select:!0,focus:!1};const g=(0,i.isUndefinedOrNull)(d.select)?!0:d.select,t=(0,i.isUndefinedOrNull)(d.focus)?!1:d.focus,r=(0,i.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(s=>this.resolveTreeNode(l,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(a=>a.item)},{select:g,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:t,expand:r})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,d){const g=this.getExtensionElement(l);g&&(d?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(l){(0,I.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,d){const g=this.getExtensionElement(d);if(!!g)return(0,y.asPromise)(()=>this.dndController?.onDrop(l,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,d){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(l);if(g){const t=this.nodes.get(g);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,g,d)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(d=>d?this.resolveUnknownParentChain(d).then(g=>this.resolveTreeNode(d,g[g.length-1]).then(t=>(g.push(t),g))):Promise.resolve([]))}resolveParent(l){const d=this.nodes.get(l);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,d){const g=this.nodes.get(l);return g?Promise.resolve(g):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>this.createHandle(l,t,d,!0)).then(t=>this.getChildren(d?d.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(l){if(l){let d;if(typeof l=="string"){const g=this.getExtensionElement(l);d=g?this.nodes.get(g):void 0}else d=l;return d&&d.children||null}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const d=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=l?this.nodes.get(l):void 0,t=await this.dataProvider.getChildren(l);if(d.token.isCancellationRequested)return[];const r=await Promise.all((0,I.coalesce)(t||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,g):null}));return d.token.isCancellationRequested?[]:(0,I.coalesce)(r)}finally{d.dispose()}}refresh(l){if(l.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(l);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const d=new Set,g=l.map(r=>this.nodes.get(r));for(const r of g)if(r&&!d.has(r.item.handle)){let s=r;for(;s&&s.parent&&g.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&d.add(r.item.handle)}const t=[];return d.forEach(r=>{const s=this.elements.get(r);if(s){const n=this.nodes.get(s);n&&(!n.parent||!d.has(n.parent.item.handle))&&t.push(r)}}),t}refreshHandles(l){const d={};return Promise.all(l.map(g=>this.refreshNode(g).then(t=>{t&&(d[g]=t.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(l){const d=this.getExtensionElement(l);if(d){const g=this.nodes.get(d);if(g)return this.clearChildren(d),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(t=>{if(t){const r=this.createTreeNode(d,t,g.parent);return this.updateNodeCache(d,r,g,g.parent),g.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,d,g){const t=this.createTreeNode(l,d,g);if(d.id&&this.elements.has(t.item.handle))throw new Error((0,p.localize)(7,null,d.id));return this.addNodeToCache(l,t),this.addNodeToParentCache(t,g),t}getTooltip(l){return A.MarkdownString.isMarkdownString(l)?u.MarkdownString.from(l):l}getCommand(l,d){return d?this.commands.toInternal(d,l):void 0}createTreeNode(l,d,g){const t=new T.DisposableStore,r=this.createHandle(l,d,g),s=this.getLightIconPath(d);return{item:{handle:r,parentHandle:g?g.item.handle:void 0,label:v(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(t,d.command),contextValue:d.contextValue,icon:s,iconDark:this.getDarkIconPath(d)||s,themeIcon:this.getThemeIcon(d),collapsibleState:(0,i.isUndefinedOrNull)(d.collapsibleState)?A.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:g,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(l){return l.iconPath instanceof A.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:d,label:g,resourceUri:t},r,s){if(d)return`${b.ID_HANDLE_PREFIX}/${d}`;const n=v(g,this.extension),a=r?r.item.handle:b.LABEL_HANDLE_PREFIX;let h=n?n.label:t?(0,R.basename)(t):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const f=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,w=this.getChildrenNodes(r)||[];let E,o=0;do{if(E=`${a}/${o}:${h}`,s||!this.elements.has(E)||f===E)break;o++}while(o<=w.length);return E}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof A.ThemeIcon))return typeof l.iconPath=="string"||D.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof A.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return D.URI.isUri(l)?l:D.URI.file(l)}addNodeToCache(l,d){this.elements.set(d.item.handle,l),this.nodes.set(l,d)}updateNodeCache(l,d,g,t){this.elements.delete(d.item.handle),this.nodes.delete(l),d.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(l,d);const r=this.getChildrenNodes(t)||[],s=r.filter(n=>n.item.handle===g.item.handle)[0];s&&r.splice(r.indexOf(s),1,d)}addNodeToParentCache(l,d){d?(d.children||(d.children=[]),d.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const d=this.nodes.get(l);if(d){if(d.children)for(const g of d.children){const t=this.elements.get(g.item.handle);t&&this.clear(t)}d.children=void 0}}else this.clearAll()}clear(l){const d=this.nodes.get(l);if(d){if(d.children)for(const g of d.children){const t=this.elements.get(g.item.handle);t&&this.clear(t)}this.nodes.delete(l),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,16,3,6,14,86,17,126,89]),function(J,e,p,R,D,S,T,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends D.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const m=this.diff[this.diff.length-1];if(m&&u[0]===1){if(m[0]===1&&m[1].extId===u[1].extId){(0,y.applyTestItemUpdate)(m[1],u[1]);return}if(m[0]===0&&m[1].item.extId===u[1].extId){(0,y.applyTestItemUpdate)(m[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,m){const c=this.tree.get(u);if(!!c){if((c.expandLevels===void 0||m>c.expandLevels)&&(c.expandLevels=m),c.expand===1){const v=this.resolveChildren(c);return v.isOpen()?this.expandChildren(c,m-1):v.wait().then(()=>this.expandChildren(c,m-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,m-1)):this.expandChildren(c,m-1)}}dispose(){for(const u of this.tree.values())(0,T.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,m){switch(m.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(u.fullId,m.id));break;case 0:this.upsertItem(m.item,u);break;case 4:for(const b of m.ops)this.onTestItemEvent(u,b);break;case 3:const{key:c,value:v}=m,_=u.fullId.toString();switch(c){case"canResolveChildren":this.updateExpandability(u);break;case"range":this.pushDiff([1,{extId:_,item:{range:C.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:C.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[c]:v??null}}]);break}break;default:(0,S.assertNever)(m)}}upsertItem(u,m){if(!(u instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const c=A.TestId.fromExtHostTestItem(u,this.root.id,m?.actual),v=(0,T.getPrivateApiFor)(u);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(u.id);let _=this.tree.get(c.toString());if(!_){_={fullId:c,actual:u,parent:m?c.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(_.fullId.toString(),_),this.setItemParent(u,m),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:C.TestItem.from(u)}]),this.connectItemAndChildren(u,_,m);return}if(_.actual===u){this.connectItem(u,_,m);return}const b=_.actual.children,P=_.actual,l=(0,T.diffTestItems)(P,u);(0,T.getPrivateApiFor)(P).listener=void 0,_.actual=u,_.expand=0;for(const[d,g]of l)this.onTestItemEvent(_,{op:3,key:d,value:g});this.connectItemAndChildren(u,_,m);for(const d of b)u.children.get(d.id)||this.removeItem(A.TestId.joinToString(c,d.id))}setItemParent(u,m){(0,T.getPrivateApiFor)(u).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(u,m,c){this.setItemParent(u,c);const v=(0,T.getPrivateApiFor)(u);v.parent=c?.actual,v.listener=_=>this.onTestItemEvent(m,_),this.updateExpandability(m)}connectItemAndChildren(u,m,c){this.connectItem(u,m,c);for(const v of u.children)this.upsertItem(v,m)}updateExpandability(u){let m;this._resolveHandler?u.resolveBarrier?m=u.resolveBarrier.isOpen()?3:2:m=u.actual.canResolveChildren?1:0:m=0,m!==u.expand&&(u.expand=m,this.pushDiff([1,{extId:u.fullId.toString(),expand:m}]),m===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,m){if(m<0)return;const c=[];for(const v of u.actual.children){const _=this.expand(A.TestId.joinToString(u.fullId,v.id),m);(0,p.isThenable)(_)&&c.push(_)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const v=new p.Barrier;return v.open(),v}u.expand=2,this.pushExpandStateUpdate(u);const m=u.resolveBarrier=new p.Barrier;let c;try{c=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(v){u.actual.error=v.stack||v.message}return(0,p.isThenable)(c)?c.catch(v=>u.actual.error=v.stack||v.message).then(()=>{m.open(),this.updateExpandability(u)}):(m.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const m=this.tree.get(u);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const c=[m];for(;c.length;){const v=c.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0,this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)c.push(this.tree.get(A.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=i}),define(me[223],ge([0,1,4,183]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,p.refineServiceDecorator)(R.IEnvironmentService)}),define(me[224],ge([0,1,26,3,9]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class T{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${p.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(u=>I.add(p.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>I.has(p.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const u=T._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(u.map(m=>m.identifier)),I.length>0){const m=new Set;I.forEach(c=>m.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!m.has(p.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(u)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,b){this.addNode(_),this.addNode(b),this._arcs.has(_)?this._arcs.get(_).push(b):this._arcs.set(_,[b])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,b){const P=I.getArcs(_);for(let l=0;l<P.length;l++)if(!b.has(P[l]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let _ of i){const b=p.ExtensionIdentifier.toKey(_.identifier);if(u.set(b,_),_.extensionDependencies)for(let P of _.extensionDependencies){const l=p.ExtensionIdentifier.toKey(P);I.addArc(b,l)}}let m=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>m.add(_));let c=I.getNodes().filter(_=>!m.has(_)),v;do{v=!1;for(let _=0;_<c.length;_++){const b=c[_];I.hasOnlyGoodArcs(b,m)&&(c.splice(_,1),_--,m.add(b),v=!0)}}while(v);return c.map(_=>u.get(_))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(p.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=T;var C;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(C||(C={}));function y(A,i){const I=A.isBuiltin?0:A.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==u)return I-u;const m=D.posix.basename(A.extensionLocation.path),c=D.posix.basename(i.extensionLocation.path);return m<c?-1:m>c?1:0}}),define(me[225],ge([0,1,23]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function S(C){const y=p.VSBuffer.alloc(1);switch(C){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=S;function T(C,y){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=T}),define(me[35],ge([0,1,3,2,4,26,185]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class C{constructor(P){this.dependency=P}}e.MissingExtensionDependency=C;var y;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class A{constructor(P,l,d,g){this.codeLoadingTime=P,this.activateCallTime=l,this.activateResolvedTime=d,this.activationReason=g}}e.ActivationTimes=A;class i{constructor(P,l){this.description=P,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function u(b){b.enableProposedApi||m(b)}e.checkProposedApiEnabled=u;function m(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=m;function c(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=c;function v(b,P){return{identifier:new S.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!P,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class _{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,l){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,l,d,g,t){}_onDidActivateExtensionError(P,l){}_onExtensionRuntimeError(P,l){}_onExtensionHostExit(P){}}e.NullExtensionService=_}),define(me[226],ge([0,1,26,35,12]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class T{constructor(c,v,_,b){this.startup=c,this.codeLoadingTime=v,this.activateCallTime=_,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class C{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,v){return c===-1||v===-1?-1:v-c}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class y{constructor(c,v,_,b,P,l){this.activationFailed=c,this.activationFailedError=v,this.activationTimes=_,this.module=b,this.exports=P,this.subscriptions=l}}e.ActivatedExtension=y;class A extends y{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class i extends y{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends y{constructor(c){super(!0,c,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let u=class{constructor(c,v,_,b,P){this._logService=P,this._registry=c,this._resolvedExtensionsSet=new Set,v.forEach(l=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,_.forEach(l=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(l),l)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const v=p.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(v)}getActivatedExtension(c){const v=p.ExtensionIdentifier.toKey(c),_=this._activatedExtensions.get(v);if(!_)throw new Error("Extension `"+c.value+"` is not known or not activated");return _}activateByEvent(c,v){if(this._alreadyActivatedEvents[c])return S;const _=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(_.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,v){const _=this._registry.getExtensionDescription(c);if(!_)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:_.identifier,reason:v}])}_handleActivateRequest(c,v,_){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(c.id))){v[p.ExtensionIdentifier.toKey(c.id)]=c;return}const b=this._registry.getExtensionDescription(c.id);if(!b){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,d,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(c.id),new I(d));return}const P=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let l=!0;for(let d=0,g=P.length;d<g;d++){const t=P[d];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const h=b.displayName||b.identifier.value,f=this._registry.getExtensionDescription(t),w=f&&f.displayName||t,E=new Error(`Cannot activate the '${h}' extension because its dependency '${w}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(b.identifier),new I(E));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){l=!1,v[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){l=!1,v[p.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const n=b.displayName||b.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(b.identifier),new I(a));return}l?v[p.ExtensionIdentifier.toKey(b.identifier)]=c:_.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(P=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(P.id))),c.length===0))return Promise.resolve(void 0);const v=Object.create(null),_=[];for(let P=0,l=c.length;P<l;P++)this._handleActivateRequest(c[P],v,_);for(let P=0,l=_.length;P<l;P++){const d=p.ExtensionIdentifier.toKey(_[P].id);v[d]&&delete v[d]}const b=Object.keys(v).map(P=>v[P]);return _.length===0?Promise.all(b.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(b).then(P=>this._activateExtensions(_))}_activateExtension(c,v){const _=p.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const b=this._activatingExtensions.get(_);if(b)return b;const P=this._host.actualActivateExtension(c,v).then(void 0,l=>{const d=new Error;return l&&l.name&&(d.name=l.name),l&&l.message?d.message=`Activating extension '${c.value}' failed: ${l.message}.`:d.message=`Activating extension '${c.value}' failed: ${l}.`,l&&l.stack&&(d.stack=l.stack),this._host.onExtensionActivationError(c,d,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(_,l),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,P),P}};u=Ve([$e(4,D.ILogService)],u),e.ExtensionsActivator=u}),define(me[227],ge([0,1,12,35,27,10,116]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends p.LogService{constructor(A){if(A.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(R.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};C=Ve([$e(0,D.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[228],ge([0,1,15]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,T)=>{this._actualOk=S,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,p.onUnexpectedError)(S))}then(S,T){return this._ensureActual().then(S,T)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=R}),define(me[130],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(y,A){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=A,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const R=[];function D(C){const y=new p(!0,C);return R[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function S(C){const y=new p(!1,C);return R[y.nid]=y,y}e.createExtHostContextProxyIdentifier=S;function T(C){return R[C].sid}e.getStringIdentifierForProxy=T}),define(me[5],ge([0,1,59,2,130]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(l){l.name="$ident";function d(t,r){return Object.defineProperty(t,l.name,{value:r,enumerable:!0}),t}l.mixin=d;function g(t){return t[l.name]}l.of=g})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(d){return d._id=m._n++,d}}e.IdObject=m,m._n=0;var c;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(l){if(l&&l.edits)for(const d of l.edits)typeof d.resource=="object"?d.resource=R.URI.revive(d.resource):(d.newUri=R.URI.revive(d.newUri),d.oldUri=R.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,p.revive)(d.metadata));return l}e.reviveWorkspaceEditDto=b;var P;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(C){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,y){return this._proxy.$getPassword(C,y)}store(C,y,A){return this._proxy.$setPassword(C,y,A)}delete(C,y){return this._proxy.$deletePassword(C,y)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,12,5,13]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,p.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,A,i){const I=this.getUsageKey(y,A);this._reportedUsages.has(I)||(this._reportedUsages.add(I),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:y}))}getUsageKey(y,A){return`${y}-${A.identifier.value}`}};T=Ve([$e(0,S.IExtHostRpcService),$e(1,R.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(C,y,A){}})}),define(me[229],ge([0,1,3,5,7,26]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,A,i,I={}){const u=S.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(u)||[],c=[...i].sort().join(" ");let v=m.find(_=>_.scopes===c);if(v)return v.result;{const _=this._getSession(y,u,A,i,I);v={scopes:c,result:_},m.push(v),this._inFlightRequests.set(u,m);try{await _}finally{const b=m.findIndex(P=>P.scopes===c);b>-1&&(m.splice(b),this._inFlightRequests.set(u,m))}return _}}async _getSession(y,A,i,I,u={}){await this._proxy.$ensureProvider(i);const m=y.displayName||y.name;return this._proxy.$getSession(i,I,A,m,u)}async removeSession(y,A){const i=this._authenticationProviders.get(y);return i?i.provider.removeSession(A):this._proxy.$removeSession(y,A)}registerAuthenticationProvider(y,A,i,I){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:A,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===y)||this._providers.push({id:y,label:A});const u=i.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(y,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,A,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(y);const m=this._providers.findIndex(c=>c.id===y);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,A){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this._onDidChangeSessions.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(me[230],ge([0,1,5,13,17]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(C,y){this._extHostDocumentsAndEditors=y,this._proxy=C.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const y=D.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};S=Ve([$e(0,R.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(me[231],ge([0,1,5]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(S){const T=S.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(C){return T.$writeText(C)}})}}e.ExtHostClipboard=R}),define(me[52],ge([0,1,14,7,17,25,5,20,12,59,41,48,2,6,4,13]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=r,this.converter=new b(this,s=>{const n=this._apiCommands.get(s);return n?.result===l.Void?n:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,A.revive)(s)}},{processArgument(s){return(0,S.cloneAndChange)(s,function(n){if(i.Range.isIRange(n))return D.Range.to(n);if(I.Position.isIPosition(n))return D.Position.to(n);if(i.Range.isIRange(n.range)&&u.URI.isUri(n.uri))return D.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const n=t.args.map((h,f)=>{if(!h.validate(s[f]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${s[f]}`);return h.convert(s[f])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:n,description:a}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const n=(0,S.cloneAndChange)(r,function(a){if(a instanceof R.Position)return D.Position.from(a);if(a instanceof R.Range)return D.Range.from(a);if(a instanceof R.Location)return D.location.from(a);if(R.NotebookRange.isNotebookRange(a))return D.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,s);return(0,A.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:n,thisArg:a,description:h}=s;if(h)for(let f=0;f<h.args.length;f++)try{(0,p.validateConstraint)(r[f],h.args[f].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[f].name}' - ${h.args[f].description}`)}try{return await n.apply(a,r)}catch(f){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(f,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:n}=s;n&&(t[r]=n)}return Promise.resolve(t)}};_=Ve([$e(0,v.IExtHostRpcService),$e(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class b{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const n=this._lookupApiCommand(t.command);if(n)s.id=n.internalId,s.arguments=n.args.map((a,h)=>a.convert(t.arguments&&t.arguments[h]));else if((0,C.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return s}fromInternal(t){const r=T.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class P{constructor(t,r,s,n){this.name=t,this.description=r,this.validate=s,this.convert=n}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",g=>u.URI.isUri(g),g=>g),P.Position=new P("position","A position in a text document",g=>R.Position.isPosition(g),D.Position.from),P.Range=new P("range","A range in a text document",g=>R.Range.isRange(g),D.Range.from),P.Selection=new P("selection","A selection in a text document",g=>R.Selection.isSelection(g),D.Selection.from),P.Number=new P("number","",g=>typeof g=="number",g=>g),P.String=new P("string","",g=>typeof g=="string",g=>g),P.CallHierarchyItem=new P("item","A call hierarchy item",g=>g instanceof R.CallHierarchyItem,D.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",g=>g instanceof R.TypeHierarchyItem,D.TypeHierarchyItem.from);class l{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=l,l.Void=new l("no result",g=>g);class d{constructor(t,r,s,n,a){this.id=t,this.internalId=r,this.description=s,this.args=n,this.result=a}}e.ApiCommand=d}),define(me[232],ge([0,1,17,7,80,52,20,111]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(p.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,T.isFalsyOrEmpty)(u))return;class c extends R.SymbolInformation{static to(_){const b=new c(_.name,p.SymbolKind.to(_.kind),_.containerName||"",new R.Location(m[0],p.Range.to(_.range)));return b.detail=_.detail,b.range=b.location.range,b.selectionRange=p.Range.to(_.selectionRange),b.children=_.children?_.children.map(c.to):[],b}}return u.map(c.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(p.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(p.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>R.Position.isPosition(m)),u=>u.map(p.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(m=>{let c;for(const v of m.reverse())c=new R.SelectionRange(p.Range.to(v),c);return c}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const m=[];if(Array.isArray(u))for(let c of u)m.push(...c[1].map(p.WorkspaceSymbol.to));return m})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(p.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(p.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(p.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return p.WorkspaceEdit.to(u)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(p.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,C.decodeSemanticTokensDto)(u);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,C.decodeSemanticTokensDto)(u);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,m,c)=>{if(!u)return new R.CompletionList([]);const v=u.suggestions.map(_=>p.CompletionItem.to(_,c));return new R.CompletionList(v,u.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return p.SignatureHelp.to(u)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,m,c)=>i(v=>new R.CodeLens(p.Range.to(v.range),v.command&&c.fromInternal(v.command)))(u))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>R.Range.isRange(u),u=>R.Selection.isSelection(u)?p.Selection.from(u):p.Range.from(u)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,m,c)=>i(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(v.command)}else{const _=new R.CodeAction(v.title,v.kind?new R.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=p.WorkspaceEdit.to(v.edit)),v.command&&(_.command=c.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(u))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new R.ColorInformation(p.Range.to(m.range),p.Color.to(m.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",u=>u instanceof R.Color,p.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:p.Range.from(u.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(p.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(p.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>p.NotebookExclusiveDocumentPattern.to(m))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(p.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[p.ViewColumn.from(u.viewColumn),p.TextEditorOpenOptions.from(u)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[p.ViewColumn.from(u.viewColumn),p.TextEditorOpenOptions.from(u)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[p.ViewColumn.from(u.viewColumn),p.TextEditorOpenOptions.from(u)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(p.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(p.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(p.TypeHierarchyItem.to)))];class A{static register(m){y.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=A;function i(u){return m=>{if(Array.isArray(m))return m.map(u)}}function I(u){if(!Array.isArray(u))return;const m=[];for(const c of u)D.isLocationLink(c)?m.push(p.DefinitionLink.to(c)):m.push(p.location.to(c));return m}}),define(me[233],ge([0,1,16,56,3,6,2,80,26,17,7,5]),function(J,e,p,R,D,S,T,C,y,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(m,c,v){const _=m.getProxy(I.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.commentThreadHandle);return h||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.thread.commentThreadHandle);return h?{thread:h,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;let f=n.commentUniqueId,w=h.getCommentByUniqueId(f);return w||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;let f=n.text,w=n.commentUniqueId,E=h.getCommentByUniqueId(w);return E?(E.body=f,E):n}return n}})}createCommentController(n,a,h){const f=b.handlePool++,w=new l(n,f,a,h);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(n.identifier))||[];return E.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(n.identifier),E),w.value}$createCommentThreadTemplate(n,a,h){const f=this._commentControllers.get(n);!f||f.$createCommentThreadTemplate(a,h)}async $updateCommentThreadTemplate(n,a,h){const f=this._commentControllers.get(n);!f||f.$updateCommentThreadTemplate(a,h)}$deleteCommentThread(n,a){const h=this._commentControllers.get(n);h&&h.$deleteCommentThread(a)}$provideCommentingRanges(n,a,h){const f=this._commentControllers.get(n);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(T.URI.revive(a));return(0,p.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(w,h)).then(E=>E?E.map(o=>A.Range.from(o)):void 0)}$toggleReaction(n,a,h,f,w){const E=this._commentControllers.get(n);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,p.asPromise)(()=>{const o=E.getCommentThread(a);if(o){const k=o.getCommentByUniqueId(f.uniqueIdInThread);if(E!==void 0&&k&&E.reactionHandler)return E.reactionHandler(k,t(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class P{constructor(n,a,h,f,w,E,o){this._commentControllerHandle=a,this._id=h,this._uri=f,this._range=w,this._comments=E,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),_.$createCommentThread(a,this.handle,this._id,this._uri,A.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(a,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(L){k.range=L},get comments(){return k.comments},set comments(L){k.comments=L},get collapsibleState(){return k.collapsibleState},set collapsibleState(L){k.collapsibleState=L},get canReply(){return k.canReply},set canReply(L){k.canReply=L},get contextValue(){return k.contextValue},set contextValue(L){k.contextValue=L},get label(){return k.label},set label(L){k.label=L},dispose:()=>{k.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const n=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),a={};n("range")&&(a.range=A.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue),n("comments")&&(a.comments=this._comments.map(h=>d(this,h,this._commentsMap))),n("collapsibleState")&&(a.collapseState=r(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(let a of this._commentsMap){let h=a[0],f=a[1];if(n===f)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}P._handlePool=0,Ve([(0,R.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(n,a,h,f){this._extension=n,this._handle=a,this._id=h,this._label=f,this._threads=new Map,_.$registerCommentController(this.handle,h,f);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,o,k){return w.createCommentThread(E,o,k).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,h,f){if(typeof n=="string"){const w=new P(this.id,this.handle,n,a,h,f,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new P(this.id,this.handle,void 0,n,a,h,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(n,a){const h=new P(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(a),[],this._extension.identifier);return h.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(n,a){let h=this._threads.get(n);h&&(h.range=A.Range.to(a))}$deleteCommentThread(n){let a=this._threads.get(n);a&&a.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function d(s,n,a){let h=a.get(n);h||(h=++s.commentHandle,a.set(n,h));const f=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:h,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:f,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>g(w)):void 0}}function g(s){return{label:s.label,iconPath:s.iconPath?A.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?T.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=u}),define(me[131],ge([0,1,2,5,7,4,13,12,20,8,9]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(m,c){this._logService=c,this._provider=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,c){const v=wn._handlePool++;this._provider.set(v,{provider:m,extensionId:c}),this._proxy.$registerDecorationProvider(v,c.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(v,null);return}let P=(0,y.asArray)(b);if(P.length<=wn._maxEventSize){this._proxy.$onDidChange(v,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,P.length);const l=P.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),d=(0,y.groupBy)(l,(t,r)=>t.rank-r.rank||(0,A.compare)(t.uri.path,r.uri.path));let g=[];e:for(let t of d){let r;for(let s of t){let n=(0,i.dirname)(s.uri.path);if(r!==n&&(r=n,g.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,g)});return new D.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,c,v){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:b,extensionId:P}=this._provider.get(m);return await Promise.all(c.map(async l=>{try{const{uri:d,id:g}=l,t=await Promise.resolve(b.provideFileDecoration(p.URI.revive(d),v));if(!t)return;try{D.FileDecoration.validate(t),_[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(d){this._logService.error(d)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,T.IExtHostRpcService),$e(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")}),define(me[234],ge([0,1,163,117,2,5,7,17,3,12,22]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,v,_,b,P){this._name=c,this._owner=v,this._maxDiagnosticsPerFile=_,this._proxy=b,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,v){if(!c){this.clear();return}this._checkDisposed();let _=[];if(D.URI.isUri(c)){if(!v){this.delete(c);return}this._data.set(c,v.slice()),_=[c]}else if(Array.isArray(c)){_=[];let P;c=[...c].sort(I._compareIndexedTuplesByUri);for(const l of c){const[d,g]=l;if((!P||d.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=d,_.push(d),this._data.set(d,[])),g){const t=this._data.get(d);t&&t.push(...g)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const b=[];for(let P of _){let l=[];const d=this._data.get(P);if(d)if(d.length>this._maxDiagnosticsPerFile){l=[];const g=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of d)if(r.severity===g[t]&&l.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;l.push({severity:R.MarkerSeverity.Info,message:(0,p.localize)(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=d.map(g=>C.Diagnostic.from(g));b.push([P,l])}this._proxy.$changeMany(this._owner,b)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,v){this._checkDisposed();for(let _ of this._data.keys())c.apply(v,[_,this.get(_),this])}get(c){this._checkDisposed();const v=this._data.get(c);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,v){return c[0].toString()<v[0].toString()?-1:c[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=I;let u=class Qt{constructor(c,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=c.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(c){const v=new i.ResourceMap;for(const _ of c)v.set(_,_);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(c,v){const{_collections:_,_proxy:b,_onDidChangeDiagnostics:P,_logService:l}=this,d=new class{$changeMany(r,s){b.$changeMany(r,s),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,s.length===0?"CLEARING":s)}$clear(r){b.$clear(r),l.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){b.dispose()}};let g;if(!v)v="_generated_diagnostic_collection_name_#"+Qt._idPool++,g=v;else if(!_.has(v))g=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do g=v+Qt._idPool++;while(_.has(g))}return new class extends I{constructor(){super(v,g,Qt._maxDiagnosticsPerFile,d,P);_.set(g,this)}dispose(){super.dispose(),_.delete(g)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const v=new Map,_=[];for(const b of this._collections.values())b.forEach((P,l)=>{let d=v.get(P.toString());typeof d=="undefined"&&(d=_.length,v.set(P.toString(),d),_.push([P,[]])),_[d][1]=_[d][1].concat(...l)});return _}}_getDiagnostics(c){let v=[];for(let _ of this._collections.values())_.has(c)&&(v=v.concat(_.get(c)));return v}$acceptMarkersChange(c){if(!this._mirrorCollection){const v="_generated_mirror",_=new I(v,v,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,_),this._mirrorCollection=_}for(const[v,_]of c)this._mirrorCollection.set(D.URI.revive(v),_.map(C.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Ve([$e(1,A.ILogService)],u),e.ExtHostDiagnostics=u}),define(me[235],ge([0,1,2,5]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(T){this._proxy=T.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(C=>C?C.map(y=>p.URI.revive(y)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(C=>C?p.URI.revive(C):void 0)}}e.ExtHostDialogs=D}),define(me[236],ge([0,1,15,2,7,5,10,21,8]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(I,u,m){this._documentsAndEditors=u,this._logService=m,this._documentContentProviders=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,u){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const m=A._handlePool++;this._documentContentProviders.set(m,u),this._proxy.$registerTextContentProvider(m,I);let c;return typeof u.onDidChange=="function"&&(c=u.onDidChange(v=>{if(v.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(_=>{if(!_&&typeof _!="string")return;const b=this._documentsAndEditors.getDocument(v);if(!b)return;const P=(0,y.splitLines)(_);if(!b.equalLines(P))return this._proxy.$onVirtualDocumentChange(v,_)},p.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,u){const m=this._documentContentProviders.get(I);return m?Promise.resolve(m.provideTextDocumentContent(R.URI.revive(u),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(me[237],ge([0,1,3,6,2,5,123,17,14,25,7]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(m,c){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=c,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const c=this._documentsAndEditors.getDocument(m);if(c)return c}getDocument(m){const c=this.getDocumentData(m);if(!c?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return c.document}ensureDocumentData(m){const c=this._documentsAndEditors.getDocument(m);if(c)return Promise.resolve(c);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(_=>{this._documentLoader.delete(m.toString());const b=D.URI.revive(_);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(b))},_=>(this._documentLoader.delete(m.toString()),Promise.reject(_))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(c=>D.URI.revive(c))}$acceptModelModeChanged(m,c){const v=D.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(c),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(m){const c=D.URI.revive(m),v=this._documentsAndEditors.getDocument(c);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,c){const v=D.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(c),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,c,v){const _=D.URI.revive(m),b=this._documentsAndEditors.getDocument(_);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),b.onEvents(c);let P;c.isUndoing?P=i.TextDocumentChangeReason.Undo:c.isRedoing&&(P=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:b.document,contentChanges:c.changes.map(l=>({range:C.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:P}))}setWordDefinitionFor(m,c){(0,T.setWordDefinitionFor)(m,c)}}e.ExtHostDocuments=I}),define(me[43],ge([0,1,54,3,6,2,4,5,123,13,129,17,12,22,10,74,139]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(d,g){this._extHostRpc=d,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const g=[],t=[],r=[];if(d.removedDocuments)for(const s of d.removedDocuments){const n=S.URI.revive(s),a=this._documents.get(n);a?.unref()&&(this._documents.delete(n),g.push(a.value))}if(d.addedDocuments)for(const s of d.addedDocuments){const n=S.URI.revive(s.uri);let a=this._documents.get(n);if(a&&n.scheme!==c.Schemas.vscodeNotebookCell&&n.scheme!==c.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new b(new y.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(d.removedEditors)for(const s of d.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&r.push(n)}if(d.addedEditors)for(const s of d.addedEditors){const n=S.URI.revive(s.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(n).value,h=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(f=>I.Range.to(f)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,h)}d.newActiveEditor!==void 0&&(p.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,D.dispose)(g),(0,D.dispose)(r),d.removedDocuments&&this._onDidRemoveDocuments.fire(g),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return d?g:g?.value}allEditors(){return[...this._editors.values()]}};P=Ve([$e(0,A.IExtHostRpcService),$e(1,u.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[238],ge([0,1,2,5,6,7,17,147,8,23]),function(J,e,p,R,D,S,T,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const c=this._schemes.indexOf(m);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),c=[];let v,_,b=14,P=14;for(const l of m){let d=v?(0,y.commonPrefixLength)(v,l):0;for(d===0?_=1:_=P;d<l.length;d++)d+1===l.length?(b=P,P=9):P+=1,c.push([_,l.toUpperCase().charCodeAt(d),P]),c.push([_,l.toLowerCase().charCodeAt(d),P]),_=P;v=l,P=b}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new C.StateMachine(c)}}provideDocumentLinks(m){this._initStateMachine();const c=[],v=C.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of v){const b=T.DocumentLink.to(_);b.target&&c.push(b)}return c}}class I{constructor(m,c){this._extHostLanguageFeatures=c,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,c,v,_={},b){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(P,v),this._enableProposedApi.set(P,b??!1);let l=2;_.isCaseSensitive&&(l+=1024),_.isReadonly&&(l+=2048),typeof v.copy=="function"&&(l+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(P,c,l).catch(g=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${c}`),console.error(g)});const d=v.onDidChangeFile(g=>{const t=[];for(const r of g){let{uri:s,type:n}=r;if(s.scheme!==c)continue;let a;switch(n){case S.FileChangeType.Changed:a=0;break;case S.FileChangeType.Created:a=1;break;case S.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:a})}this._proxy.$onFileSystemChange(P,t)});return(0,D.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(m,c){const{type:v,ctime:_,mtime:b,size:P,permissions:l}=m;return c?{type:v,ctime:_,mtime:b,size:P,permissions:l}:{type:v,ctime:_,mtime:b,size:P}}$stat(m,c){return Promise.resolve(this._getFsProvider(m).stat(p.URI.revive(c))).then(v=>I._asIStat(v,this._enableProposedApi.get(m)??!1))}$readdir(m,c){return Promise.resolve(this._getFsProvider(m).readDirectory(p.URI.revive(c)))}$readFile(m,c){return Promise.resolve(this._getFsProvider(m).readFile(p.URI.revive(c))).then(v=>A.VSBuffer.wrap(v))}$writeFile(m,c,v,_){return Promise.resolve(this._getFsProvider(m).writeFile(p.URI.revive(c),v.buffer,_))}$delete(m,c,v){return Promise.resolve(this._getFsProvider(m).delete(p.URI.revive(c),v))}$rename(m,c,v,_){return Promise.resolve(this._getFsProvider(m).rename(p.URI.revive(c),p.URI.revive(v),_))}$copy(m,c,v,_){const b=this._getFsProvider(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(p.URI.revive(c),p.URI.revive(v),_))}$mkdir(m,c){return Promise.resolve(this._getFsProvider(m).createDirectory(p.URI.revive(c)))}$watch(m,c,v,_){const b=this._getFsProvider(m).watch(p.URI.revive(v),_);this._watches.set(c,b)}$unwatch(m,c){const v=this._watches.get(c);v&&(v.dispose(),this._watches.delete(c))}$open(m,c,v){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(p.URI.revive(c),v))}$close(m,c){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(c))}$read(m,c,v,_){const b=this._getFsProvider(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const P=A.VSBuffer.alloc(_);return Promise.resolve(b.read(c,v,P.buffer,0,_)).then(l=>P.slice(0,l))}$write(m,c,v,_){const b=this._getFsProvider(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(c,v,_.buffer,0,_.byteLength))}_getFsProvider(m){const c=this._fsProvider.get(m);if(!c){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return c}}e.ExtHostFileSystem=I}),define(me[91],ge([0,1,5,42,7,23,4,13,62]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ut{constructor(I,u){const m=I.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return m.$stat(c).catch(Ut._handleError)},readDirectory(c){return m.$readdir(c).catch(Ut._handleError)},createDirectory(c){return m.$mkdir(c).catch(Ut._handleError)},async readFile(c){return m.$readFile(c).then(v=>v.buffer).catch(Ut._handleError)},writeFile(c,v){return m.$writeFile(c,S.VSBuffer.wrap(v)).catch(Ut._handleError)},delete(c,v){return m.$delete(c,{recursive:!1,useTrash:!1,...v}).catch(Ut._handleError)},rename(c,v,_){return m.$rename(c,v,{overwrite:!1,..._}).catch(Ut._handleError)},copy(c,v,_){return m.$copy(c,v,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(c){const v=u.getCapabilities(c);if(typeof v=="number")return!(v&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new D.FileSystemError(String(I));if(I.name==="ENOPRO")throw D.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(I.message);default:throw new D.FileSystemError(I.message,I.name)}}};A=Ve([$e(0,C.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(me[239],ge([0,1,6,5]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(T){this._handlePool=0,this._proxy=T.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,T),(0,p.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=D}),define(me[240],ge([0,1,2,25,17,7,5,8,41,20,14,144,6,111,73,85,44,15,3]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentSymbols(ne,Z);if(!(0,A.isFalsyOrEmpty)(le))return le[0]instanceof S.DocumentSymbol?le.map(D.DocumentSymbol.from):l._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((le,Y)=>{let ae=le.location.range.start.compareTo(Y.location.range.start);return ae===0&&(ae=Y.location.range.end.compareTo(le.location.range.end)),ae});const Z=[],ne=[];for(const le of W){const Y={name:le.name||"!!MISSING: name!!",kind:D.SymbolKind.from(le.kind),tags:le.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:D.Range.from(le.location.range),selectionRange:D.Range.from(le.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Y),Z.push(Y);break}const ae=ne[ne.length-1];if(y.Range.containsRange(ae.range,Y.range)&&!y.Range.equalsRange(ae.range,Y.range)){ae.children&&ae.children.push(Y),ne.push(Y);break}ne.pop()}}return Z}}class d{constructor(W,Z,ne){this._documents=W,this._commands=Z,this._provider=ne,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideCodeLenses(ne,Z);if(!le||Z.isCancellationRequested)return;const Y=this._cache.add(le),ae=new u.DisposableStore;this._disposables.set(Y,ae);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:D.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return ve}async resolveCodeLens(W,Z){const ne=W.cacheId&&this._cache.get(...W.cacheId);if(!ne)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?le=ne:le=await this._provider.resolveCodeLens(ne,Z),le||(le=ne),Z.isCancellationRequested)return;const Y=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Y)return W.command=this._commands.toInternal(le.command??d._badCmd,Y),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(je){return Array.isArray(je)?je.map(D.DefinitionLink.from):je?[D.DefinitionLink.from(je)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideDefinition(le,Y,ne);return g(ae)}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideDeclaration(le,Y,ne);return g(ae)}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideImplementation(le,Y,ne);return g(ae)}}class n{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideTypeDefinition(le,Y,ne);return g(ae)}}class a{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideHover(le,Y,ne);if(!(!ae||(0,A.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Y)),ae.range||(ae.range=new S.Range(Y,Y)),D.Hover.from(ae)}}class h{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideEvaluatableExpression(le,Y,ne);if(ae)return D.EvaluatableExpression.from(ae)}}class f{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=await this._provider.provideInlineValues(Y,D.Range.to(Z),D.InlineValueContext.to(ne),le);if(Array.isArray(ae))return ae.map(ve=>D.InlineValue.from(ve))}}class w{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideDocumentHighlights(le,Y,ne);if(Array.isArray(ae))return ae.map(D.DocumentHighlight.from)}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.provideLinkedEditingRanges(le,Y,ne);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,A.coalesce)(ae.ranges.map(D.Range.from)),wordPattern:ae.wordPattern}}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=D.Position.to(Z),ve=await this._provider.provideReferences(Y,ae,ne,le);if(Array.isArray(ve))return ve.map(D.location.from)}}class k{constructor(W,Z,ne,le,Y,ae,ve){this._documents=W,this._commands=Z,this._diagnostics=ne,this._provider=le,this._logService=Y,this._extension=ae,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=I.Selection.isISelection(Z)?D.Selection.to(Z):D.Range.to(Z),ve=[];for(const se of this._diagnostics.getDiagnostics(W))if(ae.intersection(se.range)&&ve.push(se)>k._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:ne.only?new S.CodeActionKind(ne.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ne.trigger)},ze=await this._provider.provideCodeActions(Y,ae,Me,le);if(!(0,A.isNonEmptyArray)(ze)||le.isCancellationRequested)return;const Ee=this._cache.add(ze),Ye=new u.DisposableStore;this._disposables.set(Ee,Ye);const X=[];for(let se=0;se<ze.length;se++){const he=ze[se];!he||(k._isCommand(he)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),X.push({_isSynthetic:!0,title:he.title,command:this._commands.toInternal(he,Ye)})):(Me.only&&(he.kind?Me.only.contains(he.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${he.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),X.push({cacheId:[Ee,se],title:he.title,command:he.command&&this._commands.toInternal(he.command,Ye),diagnostics:he.diagnostics&&he.diagnostics.map(D.Diagnostic.from),edit:he.edit&&D.WorkspaceEdit.from(he.edit),kind:he.kind&&he.kind.value,isPreferred:he.isPreferred,disabled:he.disabled?.reason})))}return{cacheId:Ee,actions:X}}async resolveCodeAction(W,Z){const[ne,le]=W,Y=this._cache.get(ne,le);if(!Y||k._isCommand(Y)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Y,Z)??Y;return ae?.edit?D.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}k._maxCodeActionsPerFile=1e3;class L{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentFormattingEdits(le,Z,ne);if(Array.isArray(Y))return Y.map(D.TextEdit.from)}}class N{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=D.Range.to(Z),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,ae,ne,le);if(Array.isArray(ve))return ve.map(D.TextEdit.from)}}class V{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,ne,le,Y){const ae=this._documents.getDocument(W),ve=D.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(ae,ve,ne,le,Y);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class ee{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const ne=T.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(W,Z);if((0,A.isNonEmptyArray)(le))for(const Y of le){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ae=T.IdObject.mixin(D.WorkspaceSymbol.from(Y));this._symbolCache.set(ae._id,Y),ne.symbols.push(ae)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const ne=this._symbolCache.get(W._id);if(ne){const le=await this._provider.resolveWorkspaceSymbol(ne,Z);return le&&(0,R.mixin)(W,D.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[ne,le]=Z;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(W)}}}class z{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=D.Position.to(Z);try{const ve=await this._provider.provideRenameEdits(Y,ae,ne,le);return ve?D.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=z._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(W,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(W),Y=D.Position.to(Z);try{const ae=await this._provider.prepareRename(le,Y,ne);let ve,Me;if(S.Range.isRange(ae)?(ve=ae,Me=le.getText(ae)):(0,i.isObject)(ae)&&(ve=ae.range,Me=ae.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ve),text:Me}}catch(ae){const ve=z._asMessage(ae);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class M{constructor(W,Z){this.resultId=W,this.tokens=Z}}class x{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,ne){const le=this._documents.getDocument(W),Y=Z!==0?this._previousResults.get(Z):null;let ae=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Y.resultId,ne):await this._provider.provideDocumentSemanticTokens(le,ne);return Y&&this._previousResults.delete(Z),ae?(ae=x._fixProvidedSemanticTokens(ae),this._send(x._convertToEdits(Y,ae),ae)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return x._isSemanticTokens(W)?x._isCorrectSemanticTokens(W)?W:new S.SemanticTokens(new Uint32Array(W.data),W.resultId):x._isSemanticTokensEdits(W)?x._isCorrectSemanticTokensEdits(W)?W:new S.SemanticTokensEdits(W.edits.map(Z=>new S.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!x._isSemanticTokens(Z)||!W||!W.tokens)return Z;const ne=W.tokens,le=ne.length,Y=Z.data,ae=Y.length;let ve=0;const Me=Math.min(le,ae);for(;ve<Me&&ne[ve]===Y[ve];)ve++;if(ve===le&&ve===ae)return new S.SemanticTokensEdits([],Z.resultId);let ze=0;const Ee=Me-ve;for(;ze<Ee&&ne[le-ze-1]===Y[ae-ze-1];)ze++;return new S.SemanticTokensEdits([{start:ve,deleteCount:le-ve-ze,data:Y.subarray(ve,ae-ze)}],Z.resultId)}_send(W,Z){if(x._isSemanticTokens(W)){const ne=this._nextResultId++;return this._previousResults.set(ne,new M(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:ne,type:"full",data:W.data})}if(x._isSemanticTokensEdits(W)){const ne=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(ne,new M(Z.resultId,Z.data)):this._previousResults.set(ne,new M(W.resultId)),(0,m.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(W.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentRangeSemanticTokens(le,D.Range.to(Z),ne);return Y?this._send(Y):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class q{constructor(W,Z,ne,le,Y){this._documents=W,this._commands=Z,this._provider=ne,this._apiDeprecation=le,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=D.Position.to(Z),ve=Y.getWordRangeAtPosition(ae)||new S.Range(ae,ae),Me=ve.with({end:ae}),ze=new _.StopWatch(!0),Ee=await this._provider.provideCompletionItems(Y,ae,le,D.CompletionContext.to(ne));if(!Ee||le.isCancellationRequested)return;const Ye=Array.isArray(Ee)?new S.CompletionList(Ee):Ee,X=q.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),se=new u.DisposableStore;this._disposables.set(X,se);const he=[],xe={x:X,b:he,a:{replace:D.Range.from(ve),insert:D.Range.from(Me)},c:Ye.isIncomplete||void 0,d:ze.elapsed()};for(let Be=0;Be<Ye.items.length;Be++){const et=Ye.items[Be],Ce=this._convertCompletionItem(et,[X,Be],Me,ve);he.push(Ce)}return xe}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...W);if(!ne)return;const le=await this._provider.resolveCompletionItem(ne,Z);if(!!le)return this._convertCompletionItem(le,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,ne,le){const Y=this._disposables.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const ae={x:Z,a:W.label,b:W.kind!==void 0?D.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(D.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(W.command,Y)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=W.textEdit.newText):typeof W.insertText=="string"?ae.h=W.insertText:W.insertText instanceof S.SnippetString&&(ae.h=W.insertText.value,ae.i|=4);let ve;return W.textEdit?ve=W.textEdit.range:W.range&&(ve=W.range),S.Range.isRange(ve)?ae.j=D.Range.from(ve):ve&&(!ne?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(ae.j={insert:D.Range.from(ve.inserting),replace:D.Range.from(ve.replacing)}),ae}}class U{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._commands=ne,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=D.Position.to(Z),ve=await this._provider.provideInlineCompletionItems(Y,ae,ne,le);if(!ve||le.isCancellationRequested)return;const Me=(0,i.isArray)(ve)?{items:ve}:ve,ze=this._cache.add(Me.items);let Ee;return{pid:ze,items:Me.items.map((Ye,X)=>{let se;return Ye.command&&(Ee||(Ee=new u.DisposableStore,this._disposables.set(ze,Ee)),se=this._commands.toInternal(Ye.command,Ee)),{text:Ye.text,range:Ye.range?D.Range.from(Ye.range):void 0,command:se,idx:X}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const ne=this._cache.get(W,Z);ne&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=O.map.get(W);return Z||(Z=new O,O.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=O,O.map=new WeakMap;class G{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=D.Position.to(Z),ve=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(Y,ae,le,ve);if(Me){const ze=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:ze}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const ne=D.SignatureHelp.to(W.activeSignatureHelp),le=this._cache.get(W.activeSignatureHelp.id,0);le?(Z=le,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class ${constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideInlayHints(le,D.Range.to(Z),ne);return Y?{hints:Y.map(D.InlayHint.from)}:void 0}}class K{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentLinks(ne,Z);if(!(!Array.isArray(le)||le.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(K._validateLink).map(D.DocumentLink.from)};{const Y=this._cache.add(le),ae={links:[],id:Y};for(let ve=0;ve<le.length;ve++){if(!K._validateLink(le[ve]))continue;const Me=D.DocumentLink.from(le[ve]);Me.cacheId=[Y,ve],ae.links.push(Me)}return ae}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...W);if(!ne)return;const le=await this._provider.resolveDocumentLink(ne,Z);if(!(!le||!K._validateLink(le)))return D.DocumentLink.from(le)}releaseLinks(W){this._cache.delete(W)}}class re{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentColors(ne,Z);return Array.isArray(le)?le.map(ae=>({color:D.Color.from(ae.color),range:D.Range.from(ae.range)})):[]}async provideColorPresentations(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Range.to(Z.range),ae=D.Color.to(Z.color),ve=await this._provider.provideColorPresentations(ae,{document:le,range:Y},ne);if(!!Array.isArray(ve))return ve.map(D.ColorPresentation.from)}}class fe{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideFoldingRanges(le,Z,ne);if(!!Array.isArray(Y))return Y.map(D.FoldingRange.from)}}class ye{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}async provideSelectionRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=Z.map(D.Position.to),ae=await this._provider.provideSelectionRanges(le,Y,ne);if(!(0,A.isNonEmptyArray)(ae))return[];if(ae.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const ze=[];ve.push(ze);let Ee=Y[Me],Ye=ae[Me];for(;;){if(!Ye.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(D.SelectionRange.from(Ye)),!Ye.parent)break;Ee=Ye.range,Ye=Ye.parent}}return ve}}class Ie{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.prepareCallHierarchy(le,Y,ne);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideCallsTo(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!Y)return Y.map(ae=>({from:this._cacheAndConvertItem(W,ae.from),fromRanges:ae.fromRanges.map(ve=>D.Range.from(ve))}))}async provideCallsFrom(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!Y)return Y.map(ae=>({to:this._cacheAndConvertItem(W,ae.to),fromRanges:ae.fromRanges.map(ve=>D.Range.from(ve))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),le=D.CallHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Le{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const le=this._documents.getDocument(W),Y=D.Position.to(Z),ae=await this._provider.prepareTypeHierarchy(le,Y,ne);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideSupertypes(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(le,ne);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}async provideSubtypes(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(le,ne);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),le=D.TypeHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class qe{constructor(W,Z){this.adapter=W,this.extension=Z}}class We{constructor(W,Z,ne,le,Y,ae,ve){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=Y,this._logService=ae,this._apiDeprecation=ve}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:D.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new S.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return We._handlePool++}_withAdapter(W,Z,ne,le,Y=!1){const ae=this._adapter.get(W);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof Z){let ve;ae.extension&&(ve=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=ne(ae.adapter,ae.extension),ze=ae.extension;return ze&&Promise.resolve(Me).then(()=>this._logService.trace(`[${ze.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ee=>{Y&&Ee instanceof b.CancellationError||(this._logService.error(`[${ze.identifier.value}] provider FAILED`),this._logService.error(Ee))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const ne=this._nextHandle();return this._adapter.set(ne,new qe(W,Z)),ne}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,ne,le){const Y=this._addNewAdapter(new l(this._documents,ne),W),ae=le&&le.label||We._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentSymbols(W,Z,ne){return this._withAdapter(W,l,le=>le.provideDocumentSymbols(p.URI.revive(Z),ne),void 0)}registerCodeLensProvider(W,Z,ne){const le=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new d(this._documents,this._commands.converter,ne),W)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const ve=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));ae=S.Disposable.from(ae,ve)}return ae}$provideCodeLenses(W,Z,ne){return this._withAdapter(W,d,le=>le.provideCodeLenses(p.URI.revive(Z),ne),void 0)}$resolveCodeLens(W,Z,ne){return this._withAdapter(W,d,le=>le.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,d,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,ne){const le=this._addNewAdapter(new t(this._documents,ne),W);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDefinition(W,Z,ne,le){return this._withAdapter(W,t,Y=>Y.provideDefinition(p.URI.revive(Z),ne,le),[])}registerDeclarationProvider(W,Z,ne){const le=this._addNewAdapter(new r(this._documents,ne),W);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDeclaration(W,Z,ne,le){return this._withAdapter(W,r,Y=>Y.provideDeclaration(p.URI.revive(Z),ne,le),[])}registerImplementationProvider(W,Z,ne){const le=this._addNewAdapter(new s(this._documents,ne),W);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideImplementation(W,Z,ne,le){return this._withAdapter(W,s,Y=>Y.provideImplementation(p.URI.revive(Z),ne,le),[])}registerTypeDefinitionProvider(W,Z,ne){const le=this._addNewAdapter(new n(this._documents,ne),W);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideTypeDefinition(W,Z,ne,le){return this._withAdapter(W,n,Y=>Y.provideTypeDefinition(p.URI.revive(Z),ne,le),[])}registerHoverProvider(W,Z,ne,le){const Y=this._addNewAdapter(new a(this._documents,ne),W);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(W,Z,ne,le){return this._withAdapter(W,a,Y=>Y.provideHover(p.URI.revive(Z),ne,le),void 0)}registerEvaluatableExpressionProvider(W,Z,ne,le){const Y=this._addNewAdapter(new h(this._documents,ne),W);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(W,Z,ne,le){return this._withAdapter(W,h,Y=>Y.provideEvaluatableExpression(p.URI.revive(Z),ne,le),void 0)}registerInlineValuesProvider(W,Z,ne,le){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new f(this._documents,ne),W);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Z),Y);let ve=this._createDisposable(ae);if(Y!==void 0){const Me=ne.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(Y));ve=S.Disposable.from(ve,Me)}return ve}$provideInlineValues(W,Z,ne,le,Y){return this._withAdapter(W,f,ae=>ae.provideInlineValues(p.URI.revive(Z),ne,le,Y),void 0)}registerDocumentHighlightProvider(W,Z,ne){const le=this._addNewAdapter(new w(this._documents,ne),W);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentHighlights(W,Z,ne,le){return this._withAdapter(W,w,Y=>Y.provideDocumentHighlights(p.URI.revive(Z),ne,le),void 0)}registerLinkedEditingRangeProvider(W,Z,ne){const le=this._addNewAdapter(new E(this._documents,ne),W);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideLinkedEditingRanges(W,Z,ne,le){return this._withAdapter(W,E,async Y=>{const ae=await Y.provideLinkedEditingRanges(p.URI.revive(Z),ne,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?We._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,ne){const le=this._addNewAdapter(new o(this._documents,ne),W);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideReferences(W,Z,ne,le,Y){return this._withAdapter(W,o,ae=>ae.provideReferences(p.URI.revive(Z),ne,le,Y),void 0)}registerCodeActionProvider(W,Z,ne,le){const Y=new u.DisposableStore,ae=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(Z),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},We._extLabel(W),Boolean(ne.resolveCodeAction)),Y.add(this._createDisposable(ae)),Y}$provideCodeActions(W,Z,ne,le,Y){return this._withAdapter(W,k,ae=>ae.provideCodeActions(p.URI.revive(Z),ne,le,Y),void 0)}$resolveCodeAction(W,Z,ne){return this._withAdapter(W,k,le=>le.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,k,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,ne){const le=this._addNewAdapter(new L(this._documents,ne),W);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentFormattingEdits(W,Z,ne,le){return this._withAdapter(W,L,Y=>Y.provideDocumentFormattingEdits(p.URI.revive(Z),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,ne){const le=this._addNewAdapter(new N(this._documents,ne),W);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(W,Z,ne,le,Y){return this._withAdapter(W,N,ae=>ae.provideDocumentRangeFormattingEdits(p.URI.revive(Z),ne,le,Y),void 0)}registerOnTypeFormattingEditProvider(W,Z,ne,le){const Y=this._addNewAdapter(new V(this._documents,ne),W);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),le,W.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(W,Z,ne,le,Y,ae){return this._withAdapter(W,V,ve=>ve.provideOnTypeFormattingEdits(p.URI.revive(Z),ne,le,Y,ae),void 0)}registerWorkspaceSymbolProvider(W,Z){const ne=this._addNewAdapter(new ee(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(W,Z,ne){return this._withAdapter(W,ee,le=>le.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,ne){return this._withAdapter(W,ee,le=>le.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,ee,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,ne){const le=this._addNewAdapter(new z(this._documents,ne,this._logService),W);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Z),z.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(W,Z,ne,le,Y){return this._withAdapter(W,z,ae=>ae.provideRenameEdits(p.URI.revive(Z),ne,le,Y),void 0)}$resolveRenameLocation(W,Z,ne,le){return this._withAdapter(W,z,Y=>Y.resolveRenameLocation(p.URI.revive(Z),ne,le),void 0)}registerDocumentSemanticTokensProvider(W,Z,ne,le){const Y=this._nextHandle(),ae=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new x(this._documents,ne),W)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le,ae);let ve=this._createDisposable(Y);if(ae){const Me=ne.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(ae));ve=S.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(W,Z,ne,le){return this._withAdapter(W,x,Y=>Y.provideDocumentSemanticTokens(p.URI.revive(Z),ne,le),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,x,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,ne,le){const Y=this._addNewAdapter(new F(this._documents,ne),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(W,Z,ne,le){return this._withAdapter(W,F,Y=>Y.provideDocumentRangeSemanticTokens(p.URI.revive(Z),ne,le),null,!0)}registerCompletionItemProvider(W,Z,ne,le){const Y=this._addNewAdapter(new q(this._documents,this._commands.converter,ne,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),le,q.supportsResolving(ne),`${W.identifier.value}(${le.join("")})`),this._createDisposable(Y)}$provideCompletionItems(W,Z,ne,le,Y){return this._withAdapter(W,q,ae=>ae.provideCompletionItems(p.URI.revive(Z),ne,le,Y),void 0)}$resolveCompletionItem(W,Z,ne){return this._withAdapter(W,q,le=>le.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,q,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,ne){const le=this._addNewAdapter(new U(this._documents,ne,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideInlineCompletions(W,Z,ne,le,Y){return this._withAdapter(W,U,ae=>ae.provideInlineCompletions(p.URI.revive(Z),ne,le,Y),void 0)}$handleInlineCompletionDidShow(W,Z,ne){this._withAdapter(W,U,async le=>{le.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,U,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,ne,le){const Y=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new G(this._documents,ne),W);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Z),Y),this._createDisposable(ae)}$provideSignatureHelp(W,Z,ne,le,Y){return this._withAdapter(W,G,ae=>ae.provideSignatureHelp(p.URI.revive(Z),ne,le,Y),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,G,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,ne){const le=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new $(this._documents,ne),W);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),le);let ae=this._createDisposable(Y);if(le!==void 0){const ve=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=S.Disposable.from(ae,ve)}return ae}$provideInlayHints(W,Z,ne,le){return this._withAdapter(W,$,Y=>Y.provideInlayHints(p.URI.revive(Z),ne,le),void 0)}registerDocumentLinkProvider(W,Z,ne){const le=this._addNewAdapter(new K(this._documents,ne),W);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(W,Z,ne){return this._withAdapter(W,K,le=>le.provideLinks(p.URI.revive(Z),ne),void 0)}$resolveDocumentLink(W,Z,ne){return this._withAdapter(W,K,le=>le.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,K,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(W,Z,ne){const le=this._addNewAdapter(new re(this._documents,ne),W);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentColors(W,Z,ne){return this._withAdapter(W,re,le=>le.provideColors(p.URI.revive(Z),ne),[])}$provideColorPresentations(W,Z,ne,le){return this._withAdapter(W,re,Y=>Y.provideColorPresentations(p.URI.revive(Z),ne,le),void 0)}registerFoldingRangeProvider(W,Z,ne){const le=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new fe(this._documents,ne),W)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const ve=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ae=S.Disposable.from(ae,ve)}return ae}$provideFoldingRanges(W,Z,ne,le){return this._withAdapter(W,fe,Y=>Y.provideFoldingRanges(p.URI.revive(Z),ne,le),void 0)}registerSelectionRangeProvider(W,Z,ne){const le=this._addNewAdapter(new ye(this._documents,ne,this._logService),W);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideSelectionRanges(W,Z,ne,le){return this._withAdapter(W,ye,Y=>Y.provideSelectionRanges(p.URI.revive(Z),ne,le),[])}registerCallHierarchyProvider(W,Z,ne){const le=this._addNewAdapter(new Ie(this._documents,ne),W);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareCallHierarchy(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Promise.resolve(Y.prepareSession(p.URI.revive(Z),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Y.provideCallsTo(Z,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Y.provideCallsFrom(Z,ne,le),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,Ie,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,ne){const le=this._addNewAdapter(new Le(this._documents,ne),W);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareTypeHierarchy(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Promise.resolve(Y.prepareSession(p.URI.revive(Z),ne,le)),void 0)}$provideTypeHierarchySupertypes(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Y.provideSupertypes(Z,ne,le),void 0)}$provideTypeHierarchySubtypes(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Y.provideSubtypes(Z,ne,le),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Le,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,C.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:We._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?We._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?We._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:We._serializeRegExp(W.beforeText),afterText:W.afterText?We._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?We._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(We._serializeOnEnterRule)}setLanguageConfiguration(W,Z,ne){let{wordPattern:le}=ne;if(le&&(0,C.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Z,le):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Y=this._nextHandle(),ae={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?We._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?We._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?We._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,ae),this._createDisposable(Y)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(me[241],ge([0,1,5,17,7,46,16]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(A,i){this._handlePool=0,this._proxy=A.getProxy(p.MainContext.MainThreadLanguages),this._documents=i}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,i){await this._proxy.$changeLanguage(A,i);const I=this._documents.getDocumentData(A);if(!I)throw new Error(`document '${A.toString}' NOT found`);return I.document}async tokenAtPosition(A,i){const I=A.version,u=R.Position.from(i),m=await this._proxy.$tokensAtPosition(A.uri,u),c={type:D.StandardTokenType.Other,range:A.getWordRangeAtPosition(i)??new D.Range(i.line,i.character,i.line,i.character)};if(!m)return c;const v={range:R.Range.to(m.range),type:R.TokenType.to(m.type)};return!v.range.contains(i)||I!==A.version?c:v}createLanguageStatusItem(A){const i=this._handlePool++,I=this._proxy,u={selector:A,text:"",detail:"",severity:D.LanguageStatusSeverity.Information};let m;const c=()=>{m?.dispose(),m=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(i,{selector:u.selector,text:u.text,message:typeof u.detail=="string"?u.detail:R.MarkdownString.from(u.detail),severity:u.severity===D.LanguageStatusSeverity.Error?S.default.Error:u.severity===D.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info})},0)},v={get selector(){return u.selector},set selector(_){u.selector=_,c()},get text(){return u.text},set text(_){u.text=_,c()},get detail(){return u.detail},set detail(_){u.detail=_,c()},get severity(){return u.severity},set severity(_){u.severity=_,c()},dispose(){m?.dispose(),I.$removeLanguageStatus(i)}};return c(),v}}e.ExtHostLanguages=C}),define(me[242],ge([0,1,5,12,35]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(C){return C&&C.title}let T=class{constructor(y,A){this._logService=A,this._proxy=y.getProxy(p.MainContext.MainThreadMessageService)}showMessage(y,A,i,I,u){const m={extension:y};let c;typeof I=="string"||S(I)?c=[I,...u]:(m.modal=I?.modal,m.useCustom=I?.useCustom,m.detail=I?.detail,c=u),m.useCustom&&(0,D.checkProposedApiEnabled)(y);const v=[];for(let _=0;_<c.length;_++){const b=c[_];if(typeof b=="string")v.push({title:b,handle:_,isCloseAffordance:!1});else if(typeof b=="object"){let{title:P,isCloseAffordance:l}=b;v.push({title:P,isCloseAffordance:!!l,handle:_})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(A,i,m,v).then(_=>{if(typeof _=="number")return c[_]})}};T=Ve([$e(1,R.ILogService)],T),e.ExtHostMessageService=T}),define(me[243],ge([0,1,23,3,58,6,22,8,14,2,85,5,17,7,219,128]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(P,l,d,g,t){this._textDocumentsAndEditors=d,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,n=r.cell.handle,h=this._documents.get(s)?.getCell(n);if(h)return h.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const l=this._editors.get(P);if(!l)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(P){for(const[l,d]of this._editors)if(d.apiEditor===P)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,l){const d=this._documents.get(P);if(!d&&!l)throw new Error(`NO notebook document for '${P}'`);return d}_getProviderData(P){const l=this._notebookContentProviders.get(P);if(!l)throw new Error(`NO provider for '${P}'`);return l}registerNotebookContentProvider(P,l,d,g,t){if((0,C.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:P,provider:d});let r;return d.onDidChangeNotebookContentOptions&&(r=d.onDidChangeNotebookContentOptions(()=>{const s=u.NotebookDocumentContentOptions.from(d.options);this._notebookProxy.$updateNotebookProviderOptions(l,s)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},l,u.NotebookDocumentContentOptions.from(g),_._convertNotebookRegistrationData(P,t)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(P,l){if(!l)return;const d=l.filenamePattern.map(g=>u.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(l.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:l.displayName,filenamePattern:d,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,l,d){const g=_._notebookStatusBarItemProviderHandlePool++,t=typeof d.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,d),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,l);let r;return t!==void 0&&(r=d.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),r&&r.dispose()})}async createNotebookDocument(P){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&u.NotebookData.from(P.content)});return A.URI.revive(l)}async openNotebookDocument(P){const l=this._documents.get(P);if(l)return l.apiNotebook;const d=await this._notebookDocumentsProxy.$tryOpenNotebook(P),g=this._documents.get(A.URI.revive(d));return(0,y.assertIsDefined)(g?.apiNotebook)}async showNotebookDocument(P,l){A.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let d;typeof l=="object"?d={position:u.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(u.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:d={preserveFocus:!1};const g=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,d),t=g&&this._editors.get(g)?.apiEditor;if(t)return t;throw g?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,l,d,g){const t=this._notebookStatusBarItemProviders.get(P),r=A.URI.revive(l),s=this._documents.get(r);if(!s||!t)return;const n=s.getCellFromIndex(d);if(!n)return;const a=await t.provideCellStatusBarItems(n.apiCell,g);if(!a)return;const h=new S.DisposableStore,f=this._statusBarCache.add([h]),E=(Array.isArray(a)?a:[a]).map(o=>u.NotebookStatusBarItem.from(o,this._commandsConverter,h));return{cacheId:f,items:E}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,l,d,g,t){if((0,C.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,d),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},l,u.NotebookDocumentContentOptions.from(g),_._convertNotebookRegistrationData(P,t)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,l,d){const g=this._notebookSerializer.get(P);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(l.buffer,d);return u.NotebookData.from(t)}async $notebookToData(P,l,d){const g=this._notebookSerializer.get(P);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(u.NotebookData.to(l),d);return p.VSBuffer.wrap(t)}async $openNotebook(P,l,d,g,t){const{provider:r}=this._getProviderData(P),s=await r.openNotebook(A.URI.revive(l),{backupId:d,untitledDocumentData:g?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(u.NotebookCellData.from)}}async $saveNotebook(P,l,d){const g=this.getNotebookDocument(A.URI.revive(l)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(g.apiNotebook,d),!0}async $saveNotebookAs(P,l,d,g){const t=this.getNotebookDocument(A.URI.revive(l)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(A.URI.revive(d),t.apiNotebook,g),!0}async $backupNotebook(P,l,d){const g=this.getNotebookDocument(A.URI.revive(l)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,D.hash)([g.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(r,s),a=await t.provider.backupNotebook(g.apiNotebook,{destination:n},d);return g.updateBackup(a),a.id}_createExtHostEditor(P,l,d){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const g=new v.ExtHostNotebookEditor(l,this._notebookEditorsProxy,P,d.visibleRanges.map(u.NotebookRange.to),d.selections.map(u.NotebookRange.to),typeof d.viewColumn=="number"?u.ViewColumn.to(d.viewColumn):void 0);this._editors.set(l,g)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const d of P.removedDocuments){const g=A.URI.revive(d),t=this._documents.get(g);t&&(t.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===g.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const d=[];for(const g of P.addedDocuments){const t=A.URI.revive(g.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,s=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){r._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){r._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){r._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){r._onDidChangeCellExecutionState.fire(n)}},t,g);d.push(...g.cells.map(n=>c.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(P.addedEditors)for(const d of P.addedEditors){if(this._editors.has(d.id))return;const g=A.URI.revive(d.documentUri),t=this._documents.get(g);t&&this._createExtHostEditor(t,d.id,d)}const l=[];if(P.removedEditors)for(const d of P.removedEditors){const g=this._editors.get(d);g&&(this._editors.delete(d),this._activeNotebookEditor?.id===g.id&&(this._activeNotebookEditor=void 0),l.push(g))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const d=new Set;this._visibleNotebookEditors.forEach(g=>d.add(g.id));for(const g of this._editors.values()){const t=d.has(g.id);g._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(me[244],ge([0,1,3,73,12,5,13,17]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(I,u){const m=y._Keys.nextId();I.$registerNotebookEditorDecorationType(m,C.NotebookDecorationRenderOptions.from(u)),this.value={key:m,dispose(){I.$removeNotebookEditorDecorationType(m)}}}}y._Keys=new R.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(I,u,m){this._logService=I,this._extHostRpc=u,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new y(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,u);const m=this._notebooksAndEditors.getEditorById(I);u.visibleRanges&&m._acceptVisibleRanges(u.visibleRanges.ranges.map(C.NotebookRange.to)),u.selections&&m._acceptSelections(u.selections.selections.map(C.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const u in I)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(C.ViewColumn.to(I[u]))}};A=Ve([$e(0,D.ILogService),$e(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(me[245],ge([0,1,3,6,5,26,2,17,87,22,16,88,21,20,12,7,35]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,r,s,n){this._initData=r,this._extHostNotebook=s,this._logService=n,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,n,a,h){for(let U of this._kernelData.values())if(U.controller.id===r&&S.ExtensionIdentifier.equals(t.identifier,U.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const f=this._handlePool++,w=this;this._logService.trace(`NotebookController[${f}], CREATED by ${t.identifier.value}, ${r}`);const E=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${t.identifier}'`);let o=!1;const k=new R.DisposableStore,L=new p.Emitter,N=new p.Emitter,V={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:h?h.map(C.NotebookRendererScript.from):[]};let ee=a??E,z;this._proxy.$addKernel(f,V).catch(U=>{console.log(U),o=!0});let M=0;const x=()=>{if(o)return;const U=++M;Promise.resolve().then(()=>{U===M&&this._proxy.$updateKernel(f,V)})},F=new A.ResourceMap,q={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return V.label},set label(U){V.label=U??t.displayName??t.name,x()},get detail(){return V.detail??""},set detail(U){V.detail=U,x()},get description(){return V.description??""},set description(U){V.description=U,x()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(U){V.supportedLanguages=U,x()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(U){V.supportsExecutionOrder=U,x()},get rendererScripts(){return V.preloads?V.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(U){ee=U??E},get interruptHandler(){return z},set interruptHandler(U){z=U,V.supportsInterrupt=Boolean(U),x()},createNotebookCellExecution(U){if(o)throw new Error("notebook controller is DISPOSED");if(!F.has(U.notebook.uri))throw w._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(O=>O.toString())),new Error(`notebook controller is NOT associated to notebook: ${U.notebook.uri.toString()}`);return w._createNotebookCellExecution(U)},dispose:()=>{o||(this._logService.trace(`NotebookController[${f}], DISPOSED`),o=!0,this._kernelData.delete(f),k.dispose(),L.dispose(),N.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(U,O){w._proxy.$updateNotebookPriority(f,U.uri,O)},onDidReceiveMessage:N.event,postMessage(U,O){return(0,_.checkProposedApiEnabled)(t),w._proxy.$postMessage(f,O&&w._extHostNotebook.getIdByEditor(O),U)},asWebviewUri(U){return(0,_.checkProposedApiEnabled)(t),(0,y.asWebviewUri)(U,w._initData.remote)}};return this._kernelData.set(f,{extensionId:t.identifier,controller:q,onDidReceiveMessage:N,onDidChangeSelection:L,associatedNotebooks:F}),q}$acceptNotebookAssociation(t,r,s){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));s?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),s),n.onDidChangeSelection.fire({selected:s,notebook:a.apiNotebook})}}async $executeCells(t,r,s){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r)),h=[];for(let f of s){const w=a.getCell(f);w&&h.push(w.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),h.length),await n.controller.executeHandler.call(n.controller,h,a.apiNotebook,n.controller)}catch(f){this._logService.error(`NotebookController[${t}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(t,r,s){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,a.apiNotebook);else for(let h of s){const f=a.getCell(h);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,s){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(r);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const n=new l(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,n);const a=n.onDidChangeState(()=>{n.state===P.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(s.uri))});return n.asApiObject()}};b=Ve([$e(3,c.ILogService)],b),e.ExtHostNotebookKernels=b;var P;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(P||(P={}));class l extends R.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new u.CancellationTokenSource),this._collector=new d(10,n=>this.applyEdits(n)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=v.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?C.NotebookCellOutput.from(r):C.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const n=this.cellIndexToHandle(r),a=this.validateAndConvertOutputs((0,m.asArray)(t));return this.applyEditSoon({editType:2,handle:n,append:s,outputs:a})}async updateOutputItems(t,r,s){return t=v.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(C.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,n){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:n??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!0)},replaceOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!1)},appendOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!0)},replaceOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!1)}})}}class d{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(me[246],ge([0,1,3,5,128]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(C,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,y,A){const i=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(y)?.fire({editor:i.apiEditor,message:A})}createRendererMessaging(C,y){if(!C.contributes?.notebookRenderer?.some(u=>u.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const A=!!C.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(u,m,c)=>{const v=A?u:_=>{const b={};i.set(b,_.editor),u({editor:b,message:_.message})};return this.getOrCreateEmitterFor(y).event(v,m,c)},postMessage:(u,m)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,m]=[m,u]);const c=A?m:i.get(m),v=c&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(v?.id,y,u)}}}getOrCreateEmitterFor(C){let y=this._rendererMessageEmitters.get(C);return y||(y=new p.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,y),y)}}e.ExtHostNotebookRenderers=S}),define(me[65],ge([0,1,5,3,6,23,4,13]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends D.Disposable{constructor(c,v,_,b,P){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=P,this._id=P.$register(this.name,v,_,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?S.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(v=>this._proxy.$clear(v,c))}show(c,v){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof c=="boolean"?c:v)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class A extends y{constructor(c,v,_){super(c,!1,void 0,v,_)}append(c){super.append(c),this._id.then(v=>this._proxy.$append(v,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class i extends y{constructor(c,v,_){super(c,!0,v,void 0,_)}append(c){throw new Error("Not supported")}}class I{constructor(c,v){this.name=c,this._channel=v}append(c){this._channel.then(v=>v.append(c))}appendLine(c){this._channel.then(v=>v.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,v){this._channel.then(_=>_.show(c,v))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let u=class{constructor(c){this._proxy=c.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c,v){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new A(c,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(c,v){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new i(c,v,this._proxy)}};u=Ve([$e(0,C.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(me[247],ge([0,1,16,21,3,6,5,2,7,15,20,46]),function(J,e,p,R,D,S,T,C,y,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function u(m,c,v){const _=m.getProxy(T.MainContext.MainThreadQuickOpen);class b{constructor(n,a){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=a}showQuickPick(n,a,h,f=R.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(n),E=++this._instances,o=_.$show(E,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},f),k={},L=o.then(()=>k);return Promise.race([L,w]).then(N=>{if(N!==k)return w.then(V=>{const ee=[];for(let z=0;z<V.length;z++){const M=V[z];let x,F,q,U,O;typeof M=="string"?x=M:(x=M.label,F=M.description,q=M.detail,U=M.picked,O=M.alwaysShow),ee.push({label:x,description:F,handle:z,detail:q,picked:U,alwaysShow:O})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{h.onDidSelectItem(V[z])}),_.$setItems(E,ee),o.then(z=>{if(typeof z=="number")return V[z];if(Array.isArray(z))return z.map(M=>V[M])})})}).then(void 0,N=>{if(!(0,A.isPromiseCanceledError)(N))return _.$setError(E,N),Promise.reject(N)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,a=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,_.$input(n,typeof this._validateInput=="function",a).then(void 0,h=>{if(!(0,A.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(n){return this._validateInput?(0,p.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,a=R.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!h)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick(n,a){const h=new t(n,a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(n){const a=new r(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(n,a){const h=this._sessions.get(n);h&&h._fireDidChangeValue(a)}$onDidAccept(n){const a=this._sessions.get(n);a&&a._fireDidAccept()}$onDidChangeActive(n,a){const h=this._sessions.get(n);h instanceof t&&h._fireDidChangeActive(a)}$onDidChangeSelection(n,a){const h=this._sessions.get(n);h instanceof t&&h._fireDidChangeSelection(a)}$onDidTriggerButton(n,a){const h=this._sessions.get(n);h&&h._fireDidTriggerButton(a)}$onDidHide(n){const a=this._sessions.get(n);a&&a._fireDidHide()}}class P{constructor(n,a){this._extensionId=n,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((a,h)=>{const f=a===y.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(f,a)}),this.update({buttons:n.map((a,h)=>({iconPath:l(a.iconPath),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const a=this._handlesToButtons.get(n);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(n){if(!this._disposed){for(const a of Object.keys(n)){const h=n[a];this._pendingUpdate[a]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function l(s){if(s instanceof y.ThemeIcon)return{id:s.id};const n=g(s),a=d(s);return{dark:typeof n=="string"?C.URI.file(n):n,light:typeof a=="string"?C.URI.file(a):a}}function d(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends P{constructor(n,a,h){super(n,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((a,h)=>{this._handlesToItems.set(h,a),this._itemsToHandles.set(a,h)}),this.update({items:n.map((a,h)=>({label:a.label,description:a.description,handle:h,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(n){const a=(0,i.coalesce)(n.map(h=>this._handlesToItems.get(h)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(n){const a=(0,i.coalesce)(n.map(h=>this._handlesToItems.get(h)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends P{constructor(n,a){super(n,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new b(c,v)}e.createExtHostQuickOpen=u}),define(me[248],ge([0,1,2,3,56,6,16,5,20,99,12,26,35,84]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(a){if(a)return typeof a.iconPath=="string"?p.URI.file(a.iconPath):p.URI.isUri(a.iconPath)||m.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function v(a,h){if(!a.iconPath&&!h.iconPath)return 0;if(a.iconPath){if(!h.iconPath)return 1}else return-1;const f=typeof a.iconPath=="string"?a.iconPath:p.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,w=typeof h.iconPath=="string"?h.iconPath:p.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,A.comparePaths)(f,w)}function _(a,h){let f=0;if(a.strikeThrough!==h.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==h.faded)return a.faded?1:-1;if(a.tooltip!==h.tooltip)return(a.tooltip||"").localeCompare(h.tooltip||"");if(f=v(a,h),f!==0)return f;if(a.light&&h.light)f=v(a.light,h.light);else{if(a.light)return 1;if(h.light)return-1}if(f!==0)return f;if(a.dark&&h.dark)f=v(a.dark,h.dark);else{if(a.dark)return 1;if(h.dark)return-1}return f}function b(a,h){if(a.command!==h.command)return a.command<h.command?-1:1;if(a.title!==h.title)return a.title<h.title?-1:1;if(a.tooltip!==h.tooltip){if(a.tooltip!==void 0&&h.tooltip!==void 0)return a.tooltip<h.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(a.arguments===h.arguments)return 0;if(a.arguments)if(h.arguments){if(a.arguments.length!==h.arguments.length)return a.arguments.length-h.arguments.length}else return 1;else return-1;for(let f=0;f<a.arguments.length;f++){const w=a.arguments[f],E=h.arguments[f];if(w!==E)return w<E?-1:1}return 0}function P(a,h){let f=(0,A.comparePaths)(a.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(f!==0)return f;if(a.command&&h.command)f=b(a.command,h.command);else{if(a.command)return 1;if(h.command)return-1}if(f!==0)return f;if(a.decorations&&h.decorations)f=_(a.decorations,h.decorations);else{if(a.decorations)return 1;if(h.decorations)return-1}return f}function l(a,h){for(let f=0;f<a.length;f++)if(a[f]!==h[f])return!1;return!0}function d(a,h){return a.command===h.command&&a.title===h.title&&a.tooltip===h.tooltip&&(a.arguments&&h.arguments?l(a.arguments,h.arguments):a.arguments===h.arguments)}function g(a,h){return(0,y.equals)(a,h,d)}class t{constructor(h,f,w){this._extension=h,this._proxy=f,this._sourceControlHandle=w,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(h){this._proxy.$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(h){if((0,u.checkProposedApiEnabled)(this._extension),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,h))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(h,f){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,h,f)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=t;class r{constructor(h,f,w,E,o){this._proxy=h,this._commands=f,this._sourceControlHandle=w,this._id=E,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,f){const w=this._resourceStatesCommandsMap.get(h);return w?(0,T.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(P),w=(0,y.sortedDiff)(this._resourceSnapshot,h,P).map(k=>{const L=k.toInsert.map(N=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,N);const ee=N.resourceUri;let z;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const re=new S.DisposableStore;z=this._commands.converter.toInternal(N.command,re),this._resourceStatesDisposablesMap.set(V,re)}else this._resourceStatesCommandsMap.set(V,N.command);const M=c(N.decorations),x=N.decorations&&c(N.decorations.light)||M,F=N.decorations&&c(N.decorations.dark)||M,q=[x,F],U=N.decorations&&N.decorations.tooltip||"",O=N.decorations&&!!N.decorations.strikeThrough,G=N.decorations&&!!N.decorations.faded,$=N.contextValue||"";return{rawResource:[V,ee,q,U,O,G,$,z],handle:V}});return{start:k.start,deleteCount:k.deleteCount,toInsert:L}}),E=w.map(({start:k,deleteCount:L,toInsert:N})=>[k,L,N.map(V=>V.rawResource)]),o=w.reverse();for(const{start:k,deleteCount:L,toInsert:N}of o){const V=N.map(z=>z.handle),ee=this._handlesSnapshot.splice(k,L,...V);for(const z of ee)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=h,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(h,f,w,E,o,k){this._proxy=f,this._commands=w,this._id=E,this._label=o,this._rootUri=k,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(h,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,o,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,this._proxy.$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,this._proxy.$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=h;const f=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&g(this._statusBarCommands,h))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=h;const f=(h||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(h,f){const w=new r(this._proxy,this._commands,this.handle,h,f),E=R.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,E),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const h=[],f=[];for(const[w,E]of this.createdResourceGroups){E.dispose();const o=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});R.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),o.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),h.push([w.handle,w.id,w.label,w.features]);const k=w._takeResourceStateSnapshot();k.length>0&&f.push([w.handle,k]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,h,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(f=>{const w=f._takeResourceStateSnapshot();w.length!==0&&h.push([f.handle,w])}),h.length>0&&this._proxy.$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,Ve([(0,D.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let n=class xn{constructor(h,f,w){this._commands=f,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=h.getProxy(C.MainContext.MainThreadSCM),this._telemetry=h.getProxy(C.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const o=this._sourceControls.get(E.sourceControlHandle);if(!o)return E;const k=o.getResourceGroup(E.groupHandle);return k?k.getResourceState(E.handle):E}else if(E&&E.$mid===4){const o=this._sourceControls.get(E.sourceControlHandle);return o?o.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const o=this._sourceControls.get(E.handle);return o||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,f,w,E){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,f,w,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const o=xn._handlePool++,k=new s(h,this._proxy,this._commands,f,w,E);this._sourceControls.set(o,k);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier))||[];return L.push(k),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(h.identifier),L),k}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const f=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier)),w=f&&f[f.length-1];return w&&w.inputBox}$provideOriginalResource(h,f,w){const E=p.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,E.toString());const o=this._sourceControls.get(h);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(E,w)).then(k=>k||null)}$onInputBoxValueChange(h,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const w=this._sourceControls.get(h);return w&&w.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(h,f,w,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,f,w);const o=this._sourceControls.get(h);if(!o)return Promise.resolve(void 0);const k=o.getResourceGroup(f);return k?k.$executeResourceCommand(w,E):Promise.resolve(void 0)}$validateInput(h,f,w){this.logService.trace("ExtHostSCM#$validateInput",h);const E=this._sourceControls.get(h);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>E.inputBox.validateInput(f,w)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([$e(2,i.ILogService)],n),e.ExtHostSCM=n});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[249],ge([0,1,7,5,166,6,17]),function(J,e,p,R,D,S,T){"use strict";var C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(m,c,v,_,b=p.StatusBarAlignment.Left,P){C.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,it(this,C,m,"f"),it(this,y,c,"f"),this._entryId=A.ID_GEN++,this._extension=v,this._id=_,this._alignment=b,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!A.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:He(this,y,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:He(this,y,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let c;this._name?c=this._name:c=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;He(this,C,"f").$setEntry(this._entryId,m,c,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,C=new WeakMap,y=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new p.ThemeColor("statusBarItem.warningForeground")]]);class i{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const c={message:m};return this._messages.unshift(c),this._update(),new p.Disposable(()=>{const v=this._messages.indexOf(c);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(m,c){this._proxy=m.getProxy(R.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new i(this)}createStatusBarEntry(m,c,v,_){return new A(this._proxy,this._commands,m,c,v,_)}setStatusBarMessage(m,c){const v=this._statusMessage.setMessage(m);let _;return typeof c=="number"?_=setTimeout(()=>v.dispose(),c):typeof c!="undefined"&&c.then(()=>v.dispose(),()=>v.dispose()),new p.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=I}),define(me[92],ge([0,1,5,3,4]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(C){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,y){this._proxy.$registerExtensionStorageKeysToSync(C,y)}getValue(C,y,A){return this._proxy.$getValue(C,y).then(i=>i||A)}setValue(C,y,A){return this._proxy.$setValue(C,y,A)}$acceptValue(C,y,A){this._onDidChangeStorage.fire({shared:C,key:y,value:A})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(me[66],ge([0,1,4,27,12,91,2]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,p.createDecorator)("IExtensionStoragePaths");let C=class{constructor(A,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,i=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ve([$e(0,R.IExtHostInitDataService),$e(1,D.ILogService),$e(2,S.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,13,6,7,167,15,214,21,32,195,84,14]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class b{constructor(n,a,h,f){this._proxy=n,this._id=a,this._creationOptions=h,this._name=f,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},sendText(E,o=!0){w._checkDisposed(),w._proxy.$sendText(w._id,E,o)},show(E){w._checkDisposed(),w._proxy.$show(w._id,E)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(n,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,_.withNullAsUndefined)(n.shellPath),shellArgs:(0,_.withNullAsUndefined)(n.shellArgs),cwd:(0,_.withNullAsUndefined)(n.cwd),env:(0,_.withNullAsUndefined)(n.env),icon:(0,_.withNullAsUndefined)(r(n.iconPath)),color:v.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,_.withNullAsUndefined)(n.message),strictEnv:(0,_.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(a?.useShellEnvironment),isSplitTerminal:a?.isSplitTerminal,target:a?.target})}async createExtensionTerminal(n,a,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,isSplitTerminal:n,target:a}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,a){return n===this._cols&&a===this._rows||n===0||a===0?!1:(this._cols=n,this._rows=a,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=b;class P{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,a){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:a})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose&&this._pty.onDidClose((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(a=>this._onProcessOverrideDimensions.fire(a&&{cols:a.columns,rows:a.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(a=>this._onProcessTitleChanged.fire(a)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let l=1,d=class extends C.Disposable{constructor(n,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=a.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[h,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,a){const h=new b(this._proxy,(0,m.generateUuid)(),n,n.name),f=new P(n.pty);return h.createExtensionTerminal(a?.isSplitTerminal,a?.target,r(n.iconPath)).then(w=>{const E=this._setupExtHostProcessListeners(w,f);this._terminalProcessDisposables[w]=E}),this._terminals.push(h),h.value}attachPtyToTerminal(n,a){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const f=new P(a),w=this._setupExtHostProcessListeners(n,f);this._terminalProcessDisposables[n]=w}async $acceptActiveTerminalChanged(n){const a=this._activeTerminal;if(n===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(n);h&&(this._activeTerminal=h,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,a){const h=this._getTerminalById(n);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:a})}async $acceptTerminalDimensions(n,a,h){const f=this._getTerminalById(n);f&&f.setDimensions(a,h)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(n,a,h){this._terminalProcesses.get(n)?.resize(a,h)}async $acceptTerminalTitleChange(n,a){const h=this._getTerminalById(n);h&&(h.name=a)}async $acceptTerminalClosed(n,a){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){const f=this._terminals.splice(h,1)[0];f.setExitCode(a),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(n,a,h,f){if(a){const o=this._getTerminalObjectIndexById(this._terminals,a);if(o!==null){this._terminals[o]._id=n,this._onDidOpenTerminal.fire(this.terminals[o]),this._terminals[o].isOpen=!0;return}}const w={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:S.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},E=new b(this._proxy,n,w,h);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(n,a){const h=this._getTerminalById(n);h&&h._setProcessId(a)}async $startExtensionTerminal(n,a){const h=this._getTerminalById(n);if(!h)return{message:(0,A.localize)(0,null,n)};h.isOpen||await new Promise(w=>{const E=this.onDidOpenTerminal(async o=>{o===h.value&&(E.dispose(),w())})});const f=this._terminalProcesses.get(n);f?f.startSendingEvents(a):this._extensionTerminalAwaitingStart[n]={initialDimensions:a}}_setupExtHostProcessListeners(n,a){const h=new C.DisposableStore;h.add(a.onProcessReady(w=>this._proxy.$sendProcessReady(n,w.pid,w.cwd))),h.add(a.onProcessTitleChanged(w=>this._proxy.$sendProcessTitle(n,w))),this._bufferer.startBuffering(n,a.onProcessData),h.add(a.onProcessExit(w=>this._onProcessExit(n,w))),a.onProcessOverrideDimensions&&h.add(a.onProcessOverrideDimensions(w=>this._proxy.$sendOverrideDimensions(n,w))),this._terminalProcesses.set(n,a);const f=this._extensionTerminalAwaitingStart[n];return f&&a instanceof P&&(a.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),h}$acceptProcessAckDataEvent(n,a){this._terminalProcesses.get(n)?.acknowledgeDataEvent(a)}$acceptProcessInput(n,a){this._terminalProcesses.get(n)?.input(a)}$acceptProcessResize(n,a,h){try{this._terminalProcesses.get(n)?.resize(a,h)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(n,a){this._terminalProcesses.get(n)?.shutdown(a)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(n,a))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(a=>this._proxy.$sendProcessCwd(n,a))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,a,h){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,h),this._proxy.$registerProfileProvider(a,n.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(n,a){const h=new u.CancellationTokenSource().token,f=await this._profileProviders.get(n)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,a);return}this.createTerminalFromOptions(f.options,a)}}async $provideLinks(n,a){const h=this._getTerminalById(n);if(!h)return[];this._terminalLinkCache.delete(n);const f=this._terminalLinkCancellationSource.get(n);f&&f.dispose(!0);const w=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,w);const E=[],o={terminal:h.value,line:a},k=[];for(const V of this._linkProviders)k.push(new Promise(async ee=>{w.token.onCancellationRequested(()=>ee({provider:V,links:[]}));const z=await V.provideTerminalLinks(o,w.token)||[];w.token.isCancellationRequested||ee({provider:V,links:z})}));const L=await Promise.all(k);if(w.token.isCancellationRequested)return[];const N=new Map;for(const V of L)V&&V.links.length>0&&E.push(...V.links.map(ee=>{const z={id:l++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return N.set(z.id,{provider:V.provider,link:ee}),z}));return this._terminalLinkCache.set(n,N),E}$activateLink(n,a){const h=this._terminalLinkCache.get(n)?.get(a);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(n,a){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const h=this._terminalProcessDisposables[n];h&&(h.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,a)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,a){const h=this._getTerminalObjectIndexById(n,a);return h!==null?n[h]:null}_getTerminalObjectIndexById(n,a){let h=null;return n.some((f,w)=>f._id===a?(h=w,!0):!1),h}getEnvironmentVariableCollection(n){let a=this._environmentVariableCollections.get(n.identifier.value);return a||(a=new g,this._setEnvironmentVariableCollection(n.identifier.value,a)),a}_syncEnvironmentVariableCollection(n,a){const h=(0,I.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(n,a.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(n){n.forEach(a=>{const h=a[0],f=new g(a[1]);this._setEnvironmentVariableCollection(h,f)})}$acceptDefaultProfile(n,a){this._defaultProfile=n,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(n,a){this._environmentVariableCollections.set(n,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,a)})}};d=Ve([$e(1,T.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class g{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,a){this._setIfDiffers(n,{value:a,type:y.EnvironmentVariableMutatorType.Replace})}append(n,a){this._setIfDiffers(n,{value:a,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,a){this._setIfDiffers(n,{value:a,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,a){const h=this.map.get(n);(!h||h.value!==a.value||h.type!==a.type)&&(this.map.set(n,a),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,a){this.map.forEach((h,f)=>n.call(a,f,h,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let t=class extends d{constructor(n){super(!1,n)}createTerminal(n,a,h){throw new i.NotSupportedError}createTerminalFromOptions(n,a){throw new i.NotSupportedError}};t=Ve([$e(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[250],ge([0,1,23,21,3,72,58,74,6,25,14,32,5,13,86,17,7,222,126,89]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(L,N){this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(u.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),N.registerArgumentProcessor({processArgument:V=>V?.$mid===13?v.TestItem.toItemFromContext(V):V})}createTestController(L,N){const V=new y.DisposableStore,ee=V.add(new b.SingleUseTestCollection(L)),z=new Map,M=this.proxy,x={items:ee.root.children,get label(){return N},set label(q){N=q,ee.root.label=q,M.$updateControllerLabel(L,N)},get id(){return L},createRunProfile:(q,U,O,G)=>{let $=(0,T.hash)(q);for(;z.has($);)$++;const K=new E(this.proxy,L,$,q,U,O,G);return z.set($,K),K},createTestItem(q,U,O){return new c.TestItemImpl(L,q,U,O)},createTestRun:(q,U,O=!0)=>this.runTracker.createTestRun(L,ee,q,U,O),set resolveHandler(q){ee.resolveHandler=q},get resolveHandler(){return ee.resolveHandler},dispose:()=>{V.dispose()}};x.createRunConfiguration=x.createRunProfile,M.$registerTestController(L,N),V.add((0,y.toDisposable)(()=>M.$unregisterTestController(L)));const F={controller:x,collection:ee,profiles:z};return this.controllers.set(L,F),V.add((0,y.toDisposable)(()=>this.controllers.delete(L))),V.add(ee.onDidGenerateDiff(q=>M.$publishDiff(L,q))),x}createTestObserver(){return this.observer.checkout()}async runTests(L,N=R.CancellationToken.None){const V=s(L);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.controllers.get(V.controllerId);if(!ee)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(z=>z.id)??[ee.collection.root.id],profileGroup:o[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:L.exclude?.map(z=>({testId:z.id,controllerId:V.controllerId}))},N)}$provideFileCoverage(L,N,V){return C.Iterable.find(this.runTracker.trackers,ee=>ee.id===L)?.getCoverage(N)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(L,N,V,ee){return C.Iterable.find(this.runTracker.trackers,z=>z.id===L)?.getCoverage(N)?.resolveFileCoverage(V,ee)??Promise.resolve([])}$configureRunProfile(L,N){this.controllers.get(L)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(L){this.results=Object.freeze(L.map(N=>(0,A.deepFreeze)(v.TestResults.to(N))).concat(this.results).sort((N,V)=>V.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:L,testId:N},V){const ee=this.controllers.get(L)?.collection;ee&&(await ee.expand(N,V<0?Infinity:V),ee.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,N){const V=this.controllers.get(L.controllerId);if(!V)return;const{collection:ee,profiles:z}=V,M=z.get(L.profileId);if(!M)return;const x=L.testIds.map(O=>ee.tree.get(O)).filter(i.isDefined),F=L.excludeExtIds.map(O=>V.collection.tree.get(O)).filter(i.isDefined).filter(O=>x.some(G=>G.fullId.compare(O.fullId)===2));if(!x.length)return;const q=new _.TestRunRequest(x.some(O=>O.actual instanceof c.TestItemRootImpl)?void 0:x.map(O=>O.actual),F.map(O=>O.actual),M),U=this.runTracker.prepareForMainThreadTestRun(q,n.fromInternal(L,V.collection),N);try{await M.runHandler(q,N)}finally{U.isRunning&&!N.isCancellationRequested&&await D.Event.toPromise(U.onEnd),this.runTracker.cancelRunById(L.runId)}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};g=Ve([$e(0,m.IExtHostRpcService)],g),e.ExtHostTesting=g;class t extends y.Disposable{constructor(L,N,V){super();this.dto=L,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new D.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(V)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ee}of this.tasks.values())ee.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const N=this.dto.id,V=this.dto.controllerId,ee=(0,I.generateUuid)(),z=new a(this.proxy,N,ee),M=q=>(U,...O)=>{if(x){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),q(U,...O))};let x=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return z.coverageProvider},set coverageProvider(q){z.coverageProvider=q},enqueued:M(q=>{this.proxy.$updateTestStateInRun(N,ee,l.TestId.fromExtHostTestItem(q,V).toString(),1)}),skipped:M(q=>{this.proxy.$updateTestStateInRun(N,ee,l.TestId.fromExtHostTestItem(q,V).toString(),5)}),started:M(q=>{this.proxy.$updateTestStateInRun(N,ee,l.TestId.fromExtHostTestItem(q,V).toString(),2)}),failed:M((q,U,O)=>{this.proxy.$appendTestMessagesInRun(N,ee,l.TestId.fromExtHostTestItem(q,V).toString(),U instanceof Array?U.map(v.TestMessage.from):[v.TestMessage.from(U)]),this.proxy.$updateTestStateInRun(N,ee,l.TestId.fromExtHostTestItem(q,V).toString(),4,O)}),passed:M((q,U)=>{this.proxy.$updateTestStateInRun(N,ee,l.TestId.fromExtHostTestItem(q,this.dto.controllerId).toString(),3,U)}),appendOutput:q=>{x||this.proxy.$appendOutputToRun(N,ee,p.VSBuffer.fromString(q))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(N,ee),this.tasks.delete(ee),this.isRunning||this.dispose())}};return this.tasks.set(ee,{run:F,coverage:z}),this.proxy.$startedTestRunTask(N,{id:ee,name:L,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof c.TestItemImpl))throw new c.InvalidTestItemError(L.id);if(this.sharedTestIds.has(L.id))return;const N=[];for(;N.unshift(v.TestItem.from(L)),!(this.sharedTestIds.has(L.id)||(this.sharedTestIds.add(L.id),!L.parent));)L=L.parent;const V=this.dto.colllection.root;this.sharedTestIds.has(V.id)||(this.sharedTestIds.add(V.id),N.unshift(v.TestItem.from(V))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class r{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,N,V){return this.getTracker(L,N,V)}cancelRunById(L){for(const N of this.tracked.values())if(N.id===L){N.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,N,V,ee,z){const M=this.tracked.get(V);if(M)return M.createRun(ee);const x=n.fromPublic(L,N,V,z),F=s(V);this.proxy.$startedExtensionTestRun({controllerId:L,profile:F&&{group:o[F.kind],id:F.profileId},exclude:V.exclude?.map(U=>U.id)??[],id:x.id,include:V.include?.map(U=>U.id)??[N.root.id],persist:z});const q=this.getTracker(V,x);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),q.createRun(ee)}getTracker(L,N,V){const ee=new t(N,this.proxy,V);return this.tracked.set(L,ee),ee.onEnd(()=>this.tracked.delete(L)),ee}}e.TestRunCoordinator=r;const s=k=>{if(!!k.profile){if(!(k.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class n{constructor(L,N,V,ee,z,M){this.controllerId=L,this.id=N,this.isPersisted=z,this.colllection=M,this.includePrefix=V.map(x=>x+"\0"),this.excludePrefix=ee.map(x=>x+"\0")}static fromPublic(L,N,V,ee){return new n(L,(0,I.generateUuid)(),V.include?.map(z=>l.TestId.fromExtHostTestItem(z,L).toString())??[L],V.exclude?.map(z=>l.TestId.fromExtHostTestItem(z,L).toString())??[],ee,N)}static fromInternal(L,N){return new n(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,N)}isIncluded(L){const N=l.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const V of this.excludePrefix)if(N===V||N.startsWith(V))return!1;for(const V of this.includePrefix)if(N===V||N.startsWith(V))return!0;return!1}}e.TestRunDto=n;class a{constructor(L,N,V){this.proxy=L,this.runId=N,this.taskId=V}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(L,N){const V=await this.fileCoverage;let ee=V?.[L];return!this._coverageProvider||!V||!ee?[]:(ee.detailedCoverage||(ee=V[L]=await this._coverageProvider.resolveFileCoverage?.(ee,N)??ee),ee.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class h extends P.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,v.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:N,removed:V}=this;return{get added(){return[...L].map(ee=>ee.revived)},get updated(){return[...N].map(ee=>ee.revived)},get removed(){return[...V].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,N){return{...L,revived:v.TestItem.toPlain(L.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=f;class w{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(N=>N.revived)},dispose:(0,S.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new f;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class E{constructor(L,N,V,ee,z,M,x=!1){this.controllerId=N,this.profileId=V,this._label=ee,this.kind=z,this.runHandler=M,this._isDefault=x,d.set(this,void 0),it(this,d,L,"f");const F=o[z];if(typeof F!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);He(this,d,"f").$publishTestRunProfile({profileId:V,controllerId:N,label:ee,group:F,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,He(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,He(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,He(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){He(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,d=new WeakMap;const o={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[251],ge([0,1,3,20,5,129,17,7]),function(J,e,p,R,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(u=>u.value)}async showTextDocument(i,I,u){let m;typeof I=="number"?m={position:T.ViewColumn.from(I),preserveFocus:u}:typeof I=="object"?m={position:T.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?T.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:m={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(i.uri,m),v=c&&this._extHostDocumentsAndEditors.getEditor(c);if(v)return v.value;throw c?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new S.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const u=this._extHostDocumentsAndEditors.getEditor(i);if(!u)throw new Error("unknown text editor");if(I.options&&u._acceptOptions(I.options),I.selections){const m=I.selections.selections.map(T.Selection.to);u._acceptSelections(m)}if(I.visibleRanges){const m=R.coalesce(I.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(m)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...I.options,lineNumbers:T.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const m=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:c,kind:m})}if(I.visibleRanges){const m=R.coalesce(I.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:m})}}$acceptEditorPositionData(i){for(const I in i){const u=this._extHostDocumentsAndEditors.getEditor(I);if(!u)throw new Error("Unknown text editor");const m=T.ViewColumn.to(i[I]);u.value.viewColumn!==m&&(u._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:m}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=y}),define(me[252],ge([0,1,2,4,5,6,7]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class C{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const m=u.uri===void 0?void 0:p.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(y(m))?.get(u.handle)}return u}})}async $getTimeline(i,I,u,m,c){return this._providers.get(i)?.provideTimeline(p.URI.revive(I),u,m,c)}registerTimelineProvider(i,I,u,m){const c=new S.DisposableStore,v=this.convertTimelineItem(I.id,m,c).bind(this);let _;I.onDidChange&&(_=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(P,l,d,g){g?.resetCache&&(c.clear(),b.get(I.id)?.clear());const t=await I.provideTimeline(P,l,d);if(t==null)return;const r=v(P,g);return{...t,source:I.id,items:t.items.map(r)}},dispose(){for(const P of b.values())P.get(I.id)?.clear();_?.dispose(),c.dispose()}})}convertTimelineItem(i,I,u){return(m,c)=>{let v;if(c?.cacheResults){let _=this._itemsBySourceAndUriMap.get(i);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(i,_));const b=y(m);v=_.get(b),v===void 0&&(v=new Map,_.set(b,v))}return _=>{const{iconPath:b,...P}=_,l=`${i}|${_.id??_.timestamp}`;v?.set(l,_);let d,g,t;return _.iconPath&&(b instanceof T.ThemeIcon?t={id:b.id,color:b.color}:p.URI.isUri(b)?(d=b,g=b):{light:d,dark:g}=b),{...P,id:P.id??void 0,handle:l,source:i,command:_.command?I.toInternal(_.command,u):void 0,icon:d,iconDark:g,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function y(A){return A?.toString()}}),define(me[253],ge([0,1,6,10,2,5]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(y){this._openers=new Map,this._proxy=y.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,A,i,I){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const u=I.schemes.find(m=>!T.supportedSchemes.has(m));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,i),this._proxy.$registerUriOpener(A,I.schemes,y,I.label),(0,p.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(y,A,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const u=D.URI.revive(A);return I.canOpenExternalUri(u,i)}async $openUri(y,A,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(D.URI.revive(A.resolvedUri),{sourceUri:D.URI.revive(A.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[254],ge([0,1,5,2,6,15,26]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(A,i){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const I=C.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,A),(0,D.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(A,i){const I=this.handlers.get(A);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(i))}catch(u){(0,S.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(A){return R.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=C,C.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[67],ge([0,1,3,2,179,205,87,5]),function(J,e,p,R,D,S,T,C){"use strict";var y,A,i,I,u,m,c,v,_,b,P,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(f,w,E,o,k,L,N){y.set(this,void 0),A.set(this,void 0),i.set(this,void 0),I.set(this,void 0),u.set(this,void 0),m.set(this,void 0),c.set(this,""),v.set(this,void 0),_.set(this,!1),b.set(this,!1),P.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new p.Emitter),this._onDidDispose=He(this,l,"f").event,it(this,y,f,"f"),it(this,A,w,"f"),it(this,v,E,"f"),it(this,I,o,"f"),it(this,u,k,"f"),it(this,m,L,"f"),it(this,P,g(L),"f"),it(this,i,N,"f")}dispose(){it(this,_,!0,"f"),He(this,l,"f").fire(),He(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return it(this,b,!0,"f"),(0,T.asWebviewUri)(f,He(this,I,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),He(this,c,"f")}set html(f){this.assertNotDisposed(),He(this,c,"f")!==f&&(it(this,c,f,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(it(this,b,!0,"f"),He(this,i,"f").report("Webview vscode-resource: uris",He(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,A,"f").$setHtml(He(this,y,"f"),f))}get options(){return this.assertNotDisposed(),He(this,v,"f")}set options(f){this.assertNotDisposed(),He(this,A,"f").$setOptions(He(this,y,"f"),s(He(this,m,"f"),He(this,u,"f"),f)),it(this,v,f,"f")}async postMessage(f){if(He(this,_,"f"))return!1;const w=(0,S.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:He(this,P,"f")});return He(this,A,"f").$postMessage(He(this,y,"f"),w.message,...w.buffers)}assertNotDisposed(){if(He(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,y=new WeakMap,A=new WeakMap,i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,c=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,l=new WeakMap;function g(h){try{const f=(0,D.normalizeVersion)((0,D.parseVersion)(h.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(f,w,E,o,k){this.initData=w,this.workspace=E,this._logService=o,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=f.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(f,w,...E){const o=this.getWebview(f);if(o){const{message:k}=(0,S.deserializeWebviewMessage)(w,E);o._onMessageEmitter.fire(k)}}$onMissingCsp(f,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,w,E){const o=new d(f,this._webviewProxy,n(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(f,o),o._onDidDispose(()=>{this._webviews.delete(f)}),o}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function r(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=r;function s(h,f,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||a(h,f)}}e.serializeWebviewOptions=s;function n(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(f=>R.URI.from(f))}}e.reviveOptions=n;function a(h,f){return[...(f?.getWorkspaceFolders()||[]).map(w=>w.uri),h.extensionLocation]}}),define(me[255],ge([0,1,21,58,6,10,24,2,17,67,85,5,7]),function(J,e,p,R,D,S,T,C,y,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const n=this.key(t,r.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new m(r,s);return this._documents.set(n,a),a}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var v;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,n){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:n}),new u.Disposable(()=>this._providers.delete(r))}}class b{constructor(t,r,s,n,a){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,n){const a=new D.DisposableStore;return P(s)?(a.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),r,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&a.add(s.onDidChangeCustomDocument(h=>{const f=this.getCustomDocumentEntry(r,h.document.uri);if(l(h)){const w=f.addEdit(h);this._proxy.$onDidEdit(h.document.uri,r,w,h.label)}else this._proxy.$onContentChange(h.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),r,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(a,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,n,a){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${r}'`);const f=C.URI.revive(t),w=await h.provider.openCustomDocument(f,{backupId:s,untitledDocumentData:n?.buffer},a);let E;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(r,w,E),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const n=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,n);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,s,n,a,h){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);const w=y.ViewColumn.to(a),E=this._extHostWebview.createNewWebview(r,n.webviewOptions,f.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,n.title,w,n.panelOptions,E),k=C.URI.revive(t);switch(f.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,k);return f.provider.resolveCustomEditor(L,o,h)}case 0:{const L=this._extHostDocuments.getDocument(k);return f.provider.resolveCustomTextEditor(L,o,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const h=C.URI.revive(r),f=this._extHostDocuments.getDocument(h);await n.provider.moveCustomTextEditor(f,a,p.CancellationToken.None)}async $undo(t,r,s,n){return this.getCustomDocumentEntry(r,t).undo(s,n)}async $redo(t,r,s,n){return this.getCustomDocumentEntry(r,t).redo(s,n)}async $revert(t,r,s){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,r,s){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,r,s,n){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,C.URI.revive(s),n)}async $backup(t,r,s){const n=this.getCustomDocumentEntry(r,t),h=await this.getCustomEditorProvider(r).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(h),h.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,C.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function P(g){return typeof g.resolveCustomTextEditor=="function"}function l(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function d(g){const t=g.scheme===S.Schemas.file||g.scheme===S.Schemas.untitled?g.fsPath:g.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[256],ge([0,1,3,6,2,32,17,67,5,7]),function(J,e,p,R,D,S,T,C,y,A){"use strict";var i,I,u,m,c,v,_,b,P,l,d,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(h,f,w,E,o,k,L){super();i.set(this,void 0),I.set(this,void 0),u.set(this,void 0),m.set(this,void 0),c.set(this,void 0),v.set(this,void 0),_.set(this,void 0),b.set(this,void 0),P.set(this,!0),l.set(this,!0),d.set(this,!1),g.set(this,this._register(new p.Emitter)),this.onDidDispose=He(this,g,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,it(this,i,h,"f"),it(this,I,f,"f"),it(this,u,w,"f"),it(this,c,k,"f"),it(this,b,o,"f"),it(this,v,E,"f"),it(this,m,L,"f")}dispose(){He(this,d,"f")||(it(this,d,!0,"f"),He(this,g,"f").fire(),He(this,I,"f").$disposeWebview(He(this,i,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,u,"f")}get title(){return this.assertNotDisposed(),He(this,v,"f")}set title(h){this.assertNotDisposed(),He(this,v,"f")!==h&&(it(this,v,h,"f"),He(this,I,"f").$setTitle(He(this,i,"f"),h))}get iconPath(){return this.assertNotDisposed(),He(this,_,"f")}set iconPath(h){this.assertNotDisposed(),He(this,_,"f")!==h&&(it(this,_,h,"f"),He(this,I,"f").$setIconPath(He(this,i,"f"),D.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return He(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,b,"f")=="number"&&He(this,b,"f")<0))return He(this,b,"f")}get active(){return this.assertNotDisposed(),He(this,l,"f")}get visible(){return this.assertNotDisposed(),He(this,P,"f")}_updateViewState(h){He(this,d,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(it(this,l,h.active,"f"),it(this,P,h.visible,"f"),it(this,b,h.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(h,f){this.assertNotDisposed(),He(this,I,"f").$reveal(He(this,i,"f"),{viewColumn:h?T.ViewColumn.from(h):void 0,preserveFocus:!!f})}assertNotDisposed(){if(He(this,d,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,c=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,l=new WeakMap,d=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(h,f,w){this.webviews=f,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(h,f,w,E,o={}){const k=typeof E=="object"?E.viewColumn:E,L={viewColumn:T.ViewColumn.from(k),preserveFocus:typeof E=="object"&&!!E.preserveFocus},N=(0,C.shouldSerializeBuffersForPostMessage)(h),V=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(h),V,f,{title:w,panelOptions:n(o),webviewOptions:(0,C.serializeWebviewOptions)(h,this.workspace,o),serializeBuffersForPostMessage:N},L);const ee=this.webviews.createNewWebview(V,o,h);return this.createNewWebviewPanel(V,f,w,k,o,ee)}$onDidChangeWebviewPanelViewStates(h){const f=Object.keys(h);f.sort((w,E)=>{const o=h[w],k=h[E];return o.active?1:k.active?-1:+o.visible-+k.visible});for(const w of f){const E=this.getWebviewPanel(w);if(!E)continue;const o=h[w];E._updateViewState({active:o.active,visible:o.visible,viewColumn:T.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,f,w){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:w,extension:h}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(h)}),new A.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(h,f,w,E){const o=this._serializers.get(f);if(!o)throw new Error(`No serializer found for '${f}'`);const{serializer:k,extension:L}=o,N=this.webviews.createNewWebview(h,w.webviewOptions,L),V=this.createNewWebviewPanel(h,f,w.title,E,w.panelOptions,N);await k.deserializeWebviewPanel(V,w.state)}createNewWebviewPanel(h,f,w,E,o,k){const L=new r(h,this._proxy,f,w,E,o,k);return this._webviewPanels.set(h,L),L}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=s;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[257],ge([0,1,3,6,67,5,7]),function(J,e,p,R,D,S,T){"use strict";var C,y,A,i,I,u,m,c,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(d,g,t,r,s,n){super();C.set(this,void 0),y.set(this,void 0),A.set(this,void 0),i.set(this,void 0),I.set(this,!1),u.set(this,void 0),m.set(this,void 0),c.set(this,void 0),v.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=He(this,v,"f").event,_.set(this,this._register(new p.Emitter)),this.onDidDispose=He(this,_,"f").event,it(this,A,t,"f"),it(this,m,r,"f"),it(this,C,d,"f"),it(this,y,g,"f"),it(this,i,s,"f"),it(this,u,n,"f")}dispose(){He(this,I,"f")||(it(this,I,!0,"f"),He(this,_,"f").fire(),He(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(d){this.assertNotDisposed(),He(this,m,"f")!==d&&(it(this,m,d,"f"),He(this,y,"f").$setWebviewViewTitle(He(this,C,"f"),d))}get description(){return this.assertNotDisposed(),He(this,c,"f")}set description(d){this.assertNotDisposed(),He(this,c,"f")!==d&&(it(this,c,d,"f"),He(this,y,"f").$setWebviewViewDescription(He(this,C,"f"),d))}get visible(){return He(this,u,"f")}get webview(){return He(this,i,"f")}get viewType(){return He(this,A,"f")}_setVisible(d){d===He(this,u,"f")||He(this,I,"f")||(it(this,u,d,"f"),He(this,v,"f").fire())}show(d){this.assertNotDisposed(),He(this,y,"f").$show(He(this,C,"f"),!!d)}assertNotDisposed(){if(He(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,y=new WeakMap,A=new WeakMap,i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,c=new WeakMap,v=new WeakMap,_=new WeakMap;class P{constructor(d,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,g,t,r){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(d),g,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(d,g,t,r,s){const n=this._viewProviders.get(g);if(!n)throw new Error(`No view provider found for '${g}'`);const{provider:a,extension:h}=n,f=this._extHostWebview.createNewWebview(d,{},h),w=new b(d,this._proxy,g,t,f,!0);this._webviewViews.set(d,w),await a.resolveWebviewView(w,{state:r},s)}async $onDidChangeWebviewViewVisibility(d,g){this.getWebviewView(d)._setVisible(g)}async $disposeWebviewView(d){const g=this.getWebviewView(d);this._webviewViews.delete(d),g.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const g=this._webviewViews.get(d);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=P}),define(me[132],ge([0,1,3,5,2,10,8,4,13]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Bn{constructor(I){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,u){let m;if(typeof I=="string"){m=I;try{I=D.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,m,u)}async asExternalUri(I,u){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(I,u);return D.URI.from(m)}};A.InitialState={focused:!0},A=Ve([$e(0,y.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[258],ge([0,1,9,104,32,52,6,5,2,13]),function(J,e,p,R,D,S,T,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(u,m){super();const c=u.getProxy(C.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=y.URI.file((0,p.join)((0,R.tmpdir)(),(0,D.generateUuid)()));return await c.$download(v,_),_})}};i=Ve([$e(0,A.IExtHostRpcService),$e(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[259],ge([0,1,2,9,151,28,65,27,13,6,12,116,42]),function(J,e,p,R,D,S,T,C,y,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(b,P,l){this.name=b,this.file=P,this.appender=l}static async create(b,P){const l=await(0,I.createRotatingLogger)(b,P,30*u.ByteSize.MB,1);return l.clearFormatters(),new m(b,P,l)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class c extends T.AbstractExtHostOutputChannel{constructor(b,P,l,d){super(b,!1,p.URI.file(P.file),l,d);this._appender=P}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,P){this._appender.flush(),super.show(b,P)}clear(){this._appender.flush(),super.clear()}}let v=class extends T.ExtHostOutputService{constructor(b,P,l){super(b);this.logService=P,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(b){if(b){const P=this._channels.get(b);P&&(this._visibleChannelDisposable.value=P.onDidAppend(()=>P.update()))}}createOutputChannel(b,P){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const l=this._doCreateOutChannel(b,P);return l.then(d=>d._id.then(g=>this._channels.set(g,d))),new T.LazyOutputChannel(b,l)}async _doCreateOutChannel(b,P){try{const l=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(l)||await S.Promises.mkdir(l,{recursive:!0});const g=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=p.URI.file((0,R.join)(l,`${g}.log`)),r=await m.create(g,t.fsPath);return new c(b,r,P.identifier.value,this._proxy)}catch(l){return this.logService.error(l),new T.ExtHostPushOutputChannel(b,P.identifier.value,this._proxy)}}};v=Ve([$e(0,y.IExtHostRpcService),$e(1,i.ILogService),$e(2,C.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[260],ge([0,1,47,291,2,66,6,10,16]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(g){const t=await super._getWorkspaceStorageURI(g);if(t.scheme!==C.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let s=0;do{let n;s===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await i(n);const a=R.join(n,"vscode.lock"),h=await c(this._logService,a,!1);if(h)return this._workspaceStorageLock=h,process.on("exit",()=>{h.dispose()}),D.URI.file(n);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function i(d){try{await p.promises.stat(d);return}catch{}try{await p.promises.mkdir(d,{recursive:!0})}catch{}}const I=1e3,u=10*60*1e3;class m extends T.Disposable{constructor(g,t){super();this.logService=g,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(g,t);(!r||r.pid!==process.pid)&&(g.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await p.promises.utimes(t,new Date,new Date)}catch(s){g.error(s),g.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{p.unlinkSync(this.filename)}catch(g){}}async setWillRelease(g){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${g} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+g};await p.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function c(d,g,t){try{const s={pid:process.pid,willReleaseAt:0};await p.promises.writeFile(g,JSON.stringify(s),{flag:"wx"})}catch(s){d.error(s)}const r=await v(d,g);return!r||r.pid!==process.pid?t?(d.info(`Lock '${g}': Could not acquire lock, giving up.`),null):(d.info(`Lock '${g}': Could not acquire lock, checking if the file is stale.`),P(d,g)):(d.info(`Lock '${g}': Lock acquired.`),new m(d,g))}async function v(d,g){let t;try{t=await p.promises.readFile(g)}catch(r){return d.error(r),null}try{return JSON.parse(String(t))}catch(r){return d.error(r),null}}async function _(d,g){let t;try{t=await p.promises.stat(g)}catch(r){return d.error(r),0}return t.mtime.getTime()}function b(d){try{return process.kill(d,0),!0}catch(g){return!1}}async function P(d,g){const t=await v(d,g);if(!t)return d.info(`Lock '${g}': Could not read pid of lock holder.`),l(d,g);if(t.willReleaseAt){let h=t.willReleaseAt-Date.now();if(h<5e3){for(h>0?d.info(`Lock '${g}': The lockfile is scheduled to be released in ${h} ms.`):d.info(`Lock '${g}': The lockfile is scheduled to have been released.`);h>0;){if(await(0,y.timeout)(Math.min(100,h)),await _(d,g)===0)return l(d,g);h=t.willReleaseAt-Date.now()}return l(d,g)}}if(!b(t.pid))return d.info(`Lock '${g}': The pid ${t.pid} appears to be gone.`),l(d,g);const r=await _(d,g),s=Date.now()-r;if(s<=u)return d.info(`Lock '${g}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;d.info(`Lock '${g}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const n=await _(d,g),a=Date.now()-n;return a<=u?(d.info(`Lock '${g}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(d.info(`Lock '${g}': The lock looks stale even after waiting for 2s.`),l(d,g))}async function l(d,g){d.info(`Lock '${g}': Deleting a stale lock.`);try{await p.promises.unlink(g)}catch(t){}return c(d,g,!0)}}),define(me[261],ge([0,1,32,13,33]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends D.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,y,A){return this.createTerminalFromOptions({name:C,shellPath:y,shellArgs:A})}createTerminalFromOptions(C,y){const A=new D.ExtHostTerminal(this._proxy,(0,p.generateUuid)(),C,C.name);return this._terminals.push(A),A.create(C,y),A.value}};S=Ve([$e(0,R.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(me[262],ge([0,1,5,13,6,27,2,39,24,28,7,11,51,3,193,75,12]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(f,w,E){this.remoteAddress=f,this.localAddress=w,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function P(h){const f=h.trim().split(`
`),w=[];return f.forEach(o=>{const k=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);k&&k.length>=3&&w.push({pid:parseInt(k[1],10),socket:parseInt(k[2],10)})}),w.reduce((o,k)=>(o[k.socket]=k,o),{})}e.getSockets=P;function l(...h){const f=[].concat(...h.map(g));return[...new Map(f.filter(w=>w.st==="0A").map(w=>{const E=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:d(E[0]),port:parseInt(E[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=l;function d(h){let f="";if(h.length===8)for(let w=h.length-2;w>=0;w-=2)f+=parseInt(h.substr(w,2),16),w!==0&&(f+=".");else for(let w=h.length-4;w>=0;w-=4)f+=parseInt(h.substr(w,4),16).toString(16),w!==0&&(f+=":");return f}e.parseIpAddress=d;function g(h){const f=h.trim().split(`
`),w=f.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return f.map(o=>o.trim().split(/\s+/).reduce((k,L,N)=>(k[w[N]||N]=L,k),{}))}e.loadConnectionTable=g;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function r(h){const f=h.trim().split(`
`),w=[];return f.forEach(E=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);o&&o.length>=4&&w.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),w}e.getRootProcesses=r;async function s(h,f,w){const E=w.reduce((k,L)=>(k[L.pid]=L,k),{}),o=[];return h.forEach(({socket:k,ip:L,port:N})=>{const V=f[k]?f[k].pid:void 0,ee=V?E[V]?.cmd:void 0;V&&ee&&!t(ee)&&o.push({host:L,port:N,detail:ee,pid:V})}),o}e.findPorts=s;function n(h,f,w){const E=new Map,o=r(f);for(const k of h){const L=w.get(k.port);if(L){E.set(k.port,L);continue}const N=o.find(V=>V.cmd.includes(`${k.port}`));if(N){let V=N,ee;do ee=o.find(z=>z.ppid===V.pid),ee&&(V=ee);while(ee);E.set(k.port,{host:k.ip,port:k.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else E.set(k.port,{host:k.ip,port:k.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=n;let a=class extends D.Disposable{constructor(f,w,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(p.MainContext.MainThreadTunnelService),I.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(w,f.displayName);if(E){const o=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,w){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:f,provider:w}),this._proxy.$registerPortsAttributesProvider(f,E),new i.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(f,w,E,o,k){const L=[];for(const V of f){const ee=this._portAttributesProviders.get(V);if(!ee)return[];L.push(...await Promise.all(w.map(async z=>ee.provider.providePortAttributes(z,E,o,k))))}const N=L.filter(V=>!!V);return N.length>0?N.map(V=>({autoForwardAction:V.autoForwardAction,port:V.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let w=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),k=(await this.findCandidatePorts()).filter(N=>(0,c.isLocalhost)(N.host)||(0,c.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${k.map(N=>N.port).join(", ")}`);const L=new Date().getTime()-o;w.update(L),(!E||JSON.stringify(E)!==JSON.stringify(k))&&(E=k,await this._proxy.$onFoundNewCandidates(E)),await new Promise(N=>setTimeout(()=>N(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(f){return f?(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory&&(this._forwardPortProvider=f.tunnelFactory,this._proxy.$setTunnelProvider(f.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,w){if(this._extensionTunnels.has(f.host)){const E=this._extensionTunnels.get(f.host);E.has(f.port)&&(w&&E.get(f.port).disposeListener.dispose(),await E.get(f.port).tunnel.dispose(),E.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(f,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const o=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const k=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:o,disposeListener:k}),u.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const w=await Promise.all(f.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),E=f.filter((o,k)=>w[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(o=>o.port).join(", ")} to ${E.map(o=>o.port).join(", ")}`),E}async findCandidatePorts(){let f="",w="";try{f=await A.Promises.readFile("/proc/net/tcp","utf8"),w=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const E=l(f,w),o=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,q,U)=>{x(q)})}),k=P(o),L=await A.Promises.readdir("/proc"),N=[];for(let x of L)try{const F=Number(x),q=y.joinPath(T.URI.file("/proc"),x);if((await A.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(F)){const O=await A.Promises.readlink(y.joinPath(q,"cwd").fsPath),G=await A.Promises.readFile(y.joinPath(q,"cmdline").fsPath,"utf8");N.push({pid:F,cwd:O,cmd:G})}}catch(F){}const V=[],ee=E.filter(x=>{const F=k[x.socket];return F||V.push(x),F}),z=s(ee,k,N);let M;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const x=await new Promise(F=>{(0,C.exec)("ps -F -A -l | grep root",(q,U,O)=>{F(U)})});this._foundRootPorts=n(V,x,this._foundRootPorts),M=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${M.join(", ")}`)}return z.then(x=>M?x.concat(M):x)}};a=Ve([$e(0,R.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,_.ILogService)],a),e.ExtHostTunnelService=a}),define(me[263],ge([0,1,16,21,15,3,6,102,228,130,23]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function u(n,a){try{return JSON.stringify(n,a)}catch(h){return"null"}}function m(n,a){return JSON.stringify(n,a)}function c(n){return n?(a,h)=>h&&h.$mid===1?n.transformOutgoing(h):h:null}var v;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},P=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class d extends T.Disposable{constructor(a,h=null,f=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=h,this._uriTransformer=f,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,E=A.ProxyIdentifier.count;w<E;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,C.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:h,sid:f}=a;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,f)),this._proxies[h]}_createProxy(a,h){let f={get:(w,E)=>(typeof E=="string"&&!w[E]&&E.charCodeAt(0)===36&&(w[E]=(...o)=>this._remoteCall(a,E,o)),E===l?h:w[E])};return new Proxy(Object.create(null),f)}set(a,h){return this._locals[a.nid]=h,h}assertRegistered(a){for(let h=0,f=a.length;h<f;h++){const w=a[h];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const h=a.byteLength,f=g.read(a,0),w=f.readUInt8(),E=f.readUInt32();switch(w){case 1:case 2:{let{rpcId:o,method:k,args:L}=t.deserializeRequestJSONArgs(f);this._uriTransformer&&(L=(0,C.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,E,o,k,L,w===2);break}case 3:case 4:{let{rpcId:o,method:k,args:L}=t.deserializeRequestMixedArgs(f);this._uriTransformer&&(L=(0,C.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,E,o,k,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(h,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(h,E);break}case 7:{this._receiveReply(h,E,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(f);this._uriTransformer&&(o=(0,C.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(h,E,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(f);this._receiveReply(h,E,o);break}case 10:{let o=t.deserializeReplyErrError(f);this._uriTransformer&&(o=(0,C.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(h,E,o);break}case 11:{this._receiveReplyErr(h,E,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,h,f,w,E,o){this._logger&&this._logger.logIncoming(a,h,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(f)}.${w}(`,E);const k=String(h);let L,N;if(o){const ee=new R.CancellationTokenSource;E.push(ee.token),L=this._invokeHandler(f,w,E),N=()=>ee.cancel()}else L=this._invokeHandler(f,w,E),N=b;this._cancelInvokedHandlers[k]=N;const V=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(V.byteLength,h,1,"ack"),this._protocol.send(V),L.then(ee=>{delete this._cancelInvokedHandlers[k];const z=t.serializeReplyOK(h,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,h,1,"reply:",ee),this._protocol.send(z)},ee=>{delete this._cancelInvokedHandlers[k];const z=t.serializeReplyErr(h,ee);this._logger&&this._logger.logOutgoing(z.byteLength,h,1,"replyErr:",ee),this._protocol.send(z)})}_receiveCancel(a,h){this._logger&&this._logger.logIncoming(a,h,1,"receiveCancel");const f=String(h);this._cancelInvokedHandlers[f]&&this._cancelInvokedHandlers[f]()}_receiveReply(a,h,f){this._logger&&this._logger.logIncoming(a,h,0,"receiveReply:",f);const w=String(h);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],E.resolveOk(f)}_receiveReplyErr(a,h,f){this._logger&&this._logger.logIncoming(a,h,0,"receiveReplyErr:",f);const w=String(h);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let o;f&&(f.$isError?(o=new Error,o.name=f.name,o.message=f.message,o.stack=f.stack):o=f),E.resolveErr(o)}_invokeHandler(a,h,f){try{return Promise.resolve(this._doInvokeHandler(a,h,f))}catch(w){return Promise.reject(w)}}_doInvokeHandler(a,h,f){const w=this._locals[a];if(!w)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(a));let E=w[h];if(typeof E!="function")throw new Error("Unknown method "+h+" on actor "+(0,A.getStringIdentifierForProxy)(a));return E.apply(w,f)}_remoteCall(a,h,f){if(this._isDisposed)return Promise.reject(D.canceled());let w=null;if(f.length>0&&R.CancellationToken.isCancellationToken(f[f.length-1])&&(w=f.pop()),w&&w.isCancellationRequested)return Promise.reject(D.canceled());const E=t.serializeRequestArguments(f,this._uriReplacer),o=++this._lastMessageId,k=String(o),L=new y.LazyPromise;w&&w.onCancellationRequested(()=>{const V=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(V.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[k]=L,this._onWillSendRequest(o);const N=t.serializeRequest(o,a,h,E,!!w);return this._logger&&this._logger.logOutgoing(N.byteLength,o,0,`request: ${(0,A.getStringIdentifierForProxy)(a)}.${h}(`,f),this._protocol.send(N),L}}e.RPCProtocol=d,I=P,d.UNRESPONSIVE_TIME=3*1e3;class g{constructor(a,h){this._buff=a,this._offset=h}static alloc(a,h,f){let w=new g(i.VSBuffer.alloc(f+1+4),0);return w.writeUInt8(a),w.writeUInt32(h),w}static read(a,h){return new g(a,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const f=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,f}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,f}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,h}static sizeMixedArray(a,h){let f=0;f+=1;for(let w=0,E=a.length;w<E;w++){const o=a[w],k=h[w];switch(f+=1,k){case 1:f+=this.sizeLongString(o);break;case 2:f+=this.sizeVSBuffer(o);break;case 3:break}}return f}writeMixedArray(a,h){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let f=0,w=a.length;f<w;f++){const E=a[f];switch(h[f]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(a);for(let f=0;f<a;f++)switch(this.readUInt8()){case 1:h[f]=this.readLongString();break;case 2:h[f]=this.readVSBuffer();break;case 3:h[f]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(a){for(let h=0,f=a.length;h<f;h++)if(a[h]instanceof i.VSBuffer||typeof a[h]=="undefined")return!0;return!1}static serializeRequestArguments(a,h){if(this._arrayContainsBufferOrUndefined(a)){let f=[],w=[];for(let E=0,o=a.length;E<o;E++){const k=a[E];k instanceof i.VSBuffer?(f[E]=k,w[E]=2):typeof k=="undefined"?(f[E]=i.VSBuffer.alloc(0),w[E]=3):(f[E]=i.VSBuffer.fromString(m(k,h)),w[E]=1)}return{type:"mixed",args:f,argsType:w}}return{type:"simple",args:m(a,h)}}static serializeRequest(a,h,f,w,E){return w.type==="mixed"?this._requestMixedArgs(a,h,f,w.args,w.argsType,E):this._requestJSONArgs(a,h,f,w.args,E)}static _requestJSONArgs(a,h,f,w,E){const o=i.VSBuffer.fromString(f),k=i.VSBuffer.fromString(w);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(o),L+=g.sizeLongString(k);let N=g.alloc(E?2:1,a,L);return N.writeUInt8(h),N.writeShortString(o),N.writeLongString(k),N.buffer}static deserializeRequestJSONArgs(a){const h=a.readUInt8(),f=a.readShortString(),w=a.readLongString();return{rpcId:h,method:f,args:JSON.parse(w)}}static _requestMixedArgs(a,h,f,w,E,o){const k=i.VSBuffer.fromString(f);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(k),L+=g.sizeMixedArray(w,E);let N=g.alloc(o?4:3,a,L);return N.writeUInt8(h),N.writeShortString(k),N.writeMixedArray(w,E),N.buffer}static deserializeRequestMixedArgs(a){const h=a.readUInt8(),f=a.readShortString(),w=a.readMixedArray(),E=new Array(w.length);for(let o=0,k=w.length;o<k;o++){const L=w[o];typeof L=="string"?E[o]=JSON.parse(L):E[o]=L}return{rpcId:h,method:f,args:E}}static serializeAcknowledged(a){return g.alloc(5,a,0).buffer}static serializeCancel(a){return g.alloc(6,a,0).buffer}static serializeReplyOK(a,h,f){return typeof h=="undefined"?this._serializeReplyOKEmpty(a):h instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,h):this._serializeReplyOKJSON(a,u(h,f))}static _serializeReplyOKEmpty(a){return g.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,h){let f=0;f+=g.sizeVSBuffer(h);let w=g.alloc(8,a,f);return w.writeVSBuffer(h),w.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,h){const f=i.VSBuffer.fromString(h);let w=0;w+=g.sizeLongString(f);let E=g.alloc(9,a,w);return E.writeLongString(f),E.buffer}static deserializeReplyOKJSON(a){const h=a.readLongString();return JSON.parse(h)}static serializeReplyErr(a,h){return h?this._serializeReplyErrEror(a,h):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,h){const f=i.VSBuffer.fromString(u(D.transformErrorForSerialization(h),null));let w=0;w+=g.sizeLongString(f);let E=g.alloc(10,a,w);return E.writeLongString(f),E.buffer}static deserializeReplyErrError(a){const h=a.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(a){return g.alloc(11,a,0).buffer}}var r;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(s||(s={}))}),define(me[264],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,p.createDecorator)("remoteAgentService")}),define(me[265],ge([0,1,10,9,11,2,4,83,49,223,264]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let I=class $n{constructor(m,c,v,_){this.localUserHome=m,this.remoteAgentService=c,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,c){if(m.remoteAuthority)return p.Schemas.vscodeRemote;const v=(0,C.getVirtualWorkspaceScheme)(c.getWorkspace());if(v)return v;const _=c.getWorkspace().folders[0];if(_)return _.uri.scheme;const b=c.getWorkspace().configuration;return b?b.scheme:p.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?R.win32:R.posix)}async fileURI(m){let c="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(c=m.substring(2),m="/"):(c=m.substring(2,_),m=m.substring(_)||"/")}return S.URI.from({scheme:p.Schemas.file,authority:c,path:m,query:"",fragment:""})}};I=Ve([$e(1,i.IRemoteAgentService),$e(2,A.IWorkbenchEnvironmentService),$e(3,y.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[68],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(T,C){this.line=T,this.character=C}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,C){return new p(0,0)}with(T){return new p(0,0)}}e.Position=p;class R{constructor(T,C,y,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(T,C),this.end=new p(y,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new R(0,0,0,0)}with(T){return new R(0,0,0,0)}}e.Range=R;var D;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,25,29,8,4,9,15,68]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",u=" characters skipped \u27EB",m=(I.length+u.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var c;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function _(F){return!!F.preview}e.resultIsMatch=_;function b(F){return!!F.resource}e.isFileMatch=b;function P(F){return!!F.message}e.isProgressMessage=P;var l;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=d;class g{constructor(q,U,O){this.ranges=U;const G=Array.isArray(U)?U:[U];if(O&&O.matchLines===1&&t(G)){q=(0,T.getNLines)(q,O.matchLines);let $="",K=0,re=0;const fe=Math.floor(O.charsPerLine/5),ye=[];for(const Ie of G){const Le=Math.max(Ie.startColumn-fe,0),qe=Ie.startColumn+O.charsPerLine;if(Le>re+fe+m){const We=I+(Le-re)+u;$+=We+q.slice(Le,qe),K+=Le-(re+We.length)}else $+=q.slice(re,qe);ye.push(new s(0,Ie.startColumn-K,Ie.endColumn-K)),re=qe}this.preview={text:$,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const $=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:q,matches:(0,p.mapArrayOrNot)(U,K=>new r(K.startLineNumber-$,K.startColumn,K.endLineNumber-$,K.endColumn))}}}}e.TextSearchMatch=g;function t(F){const q=F[0].startLineNumber;for(const U of F)if(U.startLineNumber!==q||U.endLineNumber!==q)return!1;return!0}class r{constructor(q,U,O,G){this.startLineNumber=q,this.startColumn=U,this.endLineNumber=O,this.endColumn=G}}e.SearchRange=r;class s extends r{constructor(q,U,O){super(q,U,q,O)}}e.OneLineRange=s;var n;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,q=!0){const U=F&&F.files&&F.files.exclude,O=q&&F&&F.search&&F.search.exclude;if(!U&&!O)return;if(!U||!O)return U||O;let G=Object.create(null);return G=D.mixin(G,D.deepClone(U)),G=D.mixin(G,D.deepClone(O),!0),G}e.getExcludes=a;function h(F,q){return F.excludePattern&&R.match(F.excludePattern,q)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&R.match(F.includePattern,q)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(U=>{const O=U.folder.fsPath;if(S.isEqualOrParent(q,O)){const G=y.relative(O,q);return!U.includePattern||!!R.match(U.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var f;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(q,U){super(q);this.code=U}}e.SearchError=w;function E(F){const q=F.message;if((0,A.isPromiseCanceledError)(F))return new w(q,f.canceled);try{const U=JSON.parse(q);return new w(U.message,U.code)}catch(U){return new w(q,f.other)}}e.deserializeSearchError=E;function o(F){const q={message:F.message,code:F.code};return new Error(JSON.stringify(q))}e.serializeSearchError=o;function k(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=k;function L(F){return F.type==="success"}e.isSerializedSearchSuccess=L;function N(F){return!!F.path}e.isSerializedFileMatch=N;function V(F,q){const U=F.searchPath?F.searchPath:F.relativePath;return(0,T.fuzzyContains)(U,q)}e.isFilePatternMatch=V;class ee{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function z(F,q){const U={...F||{},...q||{}};return Object.keys(U).filter(O=>{const G=U[O];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=z;class M{constructor(q,U){this._parsedIncludeExpression=null,this._excludeExpression={...q.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let O=q.includePattern;U.includePattern&&(O?O={...O,...U.includePattern}:O=U.includePattern),O&&(this._parsedIncludeExpression=R.parse(O))}includedInQuerySync(q,U,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,U,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,U,O))}includedInQuery(q,U,O){return Promise.resolve(this._parsedExcludeExpression(q,U,O)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(q,U,O)).then(K=>!!K):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=M;function x(F){for(const q in F)if(typeof F[q]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,20,16,21,3,22,10,75,24,8,14,2,169,4,12,189,49,62,27,13,7,31,5]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l,d,g,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(k,L,N){return new A.ExtUri(V=>f(V,N)).isEqual(k,L)}function n(k,L,N){return s(k.uri,L.uri,N)?0:(0,i.compare)(k.uri.toString(),L.uri.toString())}function a(k,L,N){return k.index!==L.index?k.index<L.index?-1:1:s(k.uri,L.uri,N)?(0,i.compare)(k.name,L.name):(0,i.compare)(k.uri.toString(),L.uri.toString())}function h(k,L,N,V){const ee=k.slice(0).sort((M,x)=>N(M,x,V)),z=L.slice(0).sort((M,x)=>N(M,x,V));return(0,p.delta)(ee,z,(M,x)=>N(M,x,V))}function f(k,L){const N=L.getCapabilities(k.scheme);return!(N&&N&1024)}class w extends b.Workspace{constructor(L,N,V,ee,z,M){super(L,V.map(x=>new b.WorkspaceFolder(x)),ee,M);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(M),V.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(L,N,V,ee){if(!L)return{workspace:null,added:[],removed:[]};const{id:z,name:M,folders:x,configuration:F,isUntitled:q}=L,U=[],O=N;N?x.forEach((re,fe)=>{const ye=u.URI.revive(re.uri),Ie=w._findFolder(V||N,ye,ee);Ie?(Ie.name=re.name,Ie.index=re.index,U.push(Ie)):U.push({uri:ye,name:re.name,index:fe})}):U.push(...x.map(({uri:re,name:fe,index:ye})=>({uri:u.URI.revive(re),name:fe,index:ye}))),U.sort((re,fe)=>re.index<fe.index?-1:1);const G=new w(z,M,U,F?u.URI.revive(F):null,!!q,re=>f(re,ee)),{added:$,removed:K}=h(O?O.workspaceFolders:[],G.workspaceFolders,n,ee);return{workspace:G,added:$,removed:K}}static _findFolder(L,N,V){for(let ee=0;ee<L.folders.length;ee++){const z=L.workspaceFolders[ee];if(s(z.uri,N,V))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,N){return N&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let E=class{constructor(L,N,V,ee){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ee,this._extHostFileSystemInfo=V,this._requestIdProvider=new y.Counter,this._barrier=new R.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const z=N.workspace;this._confirmedWorkspace=z?new w(z.id,z.name,[],z.configuration?u.URI.revive(z.configuration):null,!!z.isUntitled,M=>f(M,V)):void 0}$initializeWorkspace(L,N){this._trusted=N,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:C.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,N,V,...ee){const z=[];if(Array.isArray(ee)&&ee.forEach(U=>{u.URI.isUri(U.uri)&&!z.some(O=>s(O.uri,U.uri,this._extHostFileSystemInfo))&&z.push({uri:U.uri,name:U.name||(0,A.basenameOrAuthority)(U.uri)})}),this._unconfirmedWorkspace||[N,V].some(U=>typeof U!="number"||U<0)||V===0&&z.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+V>M.length)return!1;const x=M.slice(0);x.splice(N,V,...z.map(U=>({uri:U.uri,name:U.name||(0,A.basenameOrAuthority)(U.uri),index:void 0})));for(let U=0;U<x.length;U++){const O=x[U];if(x.some((G,$)=>$!==U&&s(O.uri,G.uri,this._extHostFileSystemInfo)))return!1}x.forEach((U,O)=>U.index=O);const{added:F,removed:q}=h(M,x,a,this._extHostFileSystemInfo);if(F.length===0&&q.length===0)return!1;if(this._proxy){const U=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(U,N,V,z).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,U,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(L,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,N)}async getWorkspaceFolder2(L,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,N)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,N){let V,ee="";if(typeof L=="string"?(V=u.URI.file(L),ee=L):typeof L!="undefined"&&(V=L,ee=L.fsPath),!V)return ee;const z=this.getWorkspaceFolder(V,!0);if(!z)return ee;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let M=(0,A.relativePath)(z.uri,V);return N&&z.name&&(M=`${z.name}/${M}`),M}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:N,added:V,removed:ee}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:V,removed:ee}))}findFiles(L,N,V,ee,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ee.value}, entryPoint: findFiles`);let M;if(N===null?M=!1:N&&(typeof N=="string"?M=N:M=N.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:F}=o(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(V),z).then(q=>Array.isArray(q)?q.map(U=>u.URI.revive(U)):[])}async findTextInFiles(L,N,V,ee,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ee.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),x=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:F,folder:q}=o(N.include),U=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,O={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:x,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:F,excludePattern:U},G=!1;if(this._activeSearchCallbacks[M]=$=>{if(G)return;const K=u.URI.revive($.resource);$.results.forEach(re=>{(0,t.resultIsMatch)(re)?V({uri:K,preview:{text:re.preview.text,matches:(0,p.mapArrayOrNot)(re.preview.matches,fe=>new g.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,p.mapArrayOrNot)(re.ranges,fe=>new g.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):V({uri:K,text:re.text,lineNumber:re.lineNumber})})},z.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(q),O,M,z);return delete this._activeSearchCallbacks[M],$||{}}catch($){throw delete this._activeSearchCallbacks[M],$}}$handleTextSearchResult(L,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Ve([$e(0,d.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,P.IExtHostFileSystemInfo),$e(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function o(k){let L,N;return k&&(typeof k=="string"?L=k:(L=k.pattern,N=k.baseFolder||u.URI.file(k.base))),{includePattern:L,folder:N}}}),define(me[37],ge([0,1,25,3,36,5,7,192,82,14,16,4,13,12,2]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(r,s){if(s){const n=s.split(".");let a=r;for(let h=0;a&&h<n.length;h++)a=a[n[h]];return a}}function _(r){return r instanceof c.URI}function b(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function l(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function d(r){if(_(r))return{resource:r};if(b(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(l(r))return{resource:r.uri};if(r===null)return{resource:null}}let g=class{constructor(s,n,a){this._proxy=s.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,n))}};g=Ve([$e(0,u.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,m.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,n,a,h){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=h,this._extHostWorkspace=n,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(s,n,a){const h=d(n)||{},f=this._toReadonlyValue(s?v(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,h,a?.identifier);function w(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(o){return typeof v(f,o)!="undefined"},get:(o,k)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,h,a?.identifier);let L=v(f,o);if(typeof L=="undefined")L=k;else{let N;const V=(ee,z)=>{let M;const x=()=>{N=N||(0,p.deepClone)(f),M=M||v(N,z)};return(0,A.isObject)(ee)?new Proxy(ee,{get:(F,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return x(),()=>M;if(N)return M=M||v(N,z),M[q];const U=F[q];return typeof q=="string"?V(U,`${z}.${q}`):U},set:(F,q,U)=>(x(),M&&(M[q]=U),!0),deleteProperty:(F,q)=>(x(),M&&delete M[q],!0),defineProperty:(F,q,U)=>(x(),M&&Object.defineProperty(M,q,U),!0)}):ee};L=V(L,o)}return L},update:(o,k,L,N)=>{o=s?`${s}.${o}`:o;const V=w(L);return k!==void 0?this._proxy.$updateConfigurationOption(V,o,k,h,N):this._proxy.$removeConfigurationOption(V,o,h,N)},inspect:o=>{o=s?`${s}.${o}`:o;const k=(0,p.deepClone)(this._configuration.inspect(o,h,this._extHostWorkspace.workspace));if(k)return{key:o,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof f=="object"&&(0,p.mixin)(E,f,!1),Object.freeze(E)}_toReadonlyValue(s){const n=a=>(0,A.isObject)(a)?new Proxy(a,{get:(h,f)=>n(h[f]),set:(h,f,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(h,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(h,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(s)}_validateConfigurationAccess(s,n,a){const h=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),f=a?`[${a.value}] `:"";if(h===4){typeof n?.resource=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){n?.resource&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const a=new C.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,f)=>a.affectsConfiguration(h,d(f))})}_toMap(s){return s.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[69],ge([0,1,2,16,3,5,7,36,43,37,21,33,13,27,4,10,11,12,64,213,15]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ee){function z(x){if(x!=null)return x}ee.from=z;function M(x){if(x!=null)return x}ee.to=M})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(ee){function z(x){if(x!=null)return x}ee.from=z;function M(x){if(x!=null)return x}ee.to=M})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ee){function z(x){if(x!=null)return x}ee.from=z;function M(x){if(x!=null)return x}ee.to=M})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(ee){function z(F){if(F){const q=F;return q&&!!q.process}else return!1}ee.is=z;function M(F){if(F==null)return;const q={process:F.process,args:F.args};return F.options&&(q.options=s.from(F.options)),q}ee.from=M;function x(F){if(F!=null)return new T.ProcessExecution(F.process,F.args,F.options)}ee.to=x})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(ee){function z(x){if(x!=null)return x}ee.from=z;function M(x){if(x!=null)return x}ee.to=M})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(ee){function z(F){if(F){const q=F;return q&&(!!q.commandLine||!!q.command)}else return!1}ee.is=z;function M(F){if(F==null)return;const q={};return F.commandLine!==void 0?q.commandLine=F.commandLine:(q.command=F.command,q.args=F.args),F.options&&(q.options=a.from(F.options)),q}ee.from=M;function x(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new T.ShellExecution(F.commandLine,F.options):new T.ShellExecution(F.command,F.args?F.args:[],F.options)}ee.to=x})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var f;(function(ee){function z(F){if(F){let q=F;return q&&q.customExecution==="customExecution"}else return!1}ee.is=z;function M(F){return{customExecution:"customExecution"}}ee.from=M;function x(F,q){return q.get(F)}ee.to=x})(f=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(ee){function z(M,x){let F;return M.scope!==void 0&&typeof M.scope!="number"?F=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===T.TaskScope.Workspace&&x&&x.workspaceFile?F=x.workspaceFile:F=l.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:F}}ee.from=z})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var E;(function(ee){function z(F,q){if(F==null)return[];const U=[];for(let O of F){const G=M(O,q);G&&U.push(G)}return U}ee.fromMany=z;function M(F,q){if(F==null)return;let U;F.execution instanceof T.ProcessExecution?U=n.from(F.execution):F.execution instanceof T.ShellExecution?U=h.from(F.execution):F.execution&&F.execution instanceof T.CustomExecution&&(U=f.from(F.execution));const O=t.from(F.definition);let G;if(F.scope?typeof F.scope=="number"?G=F.scope:G=F.scope.uri:G=T.TaskScope.Workspace,!O||!G)return;const $=F.group?F.group.id:void 0;return{_id:F._id,definition:O,name:F.name,source:{extensionId:q.identifier.value,label:F.source,scope:G},execution:U,isBackground:F.isBackground,group:$,presentationOptions:r.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}ee.from=M;async function x(F,q,U){if(F==null)return;let O;n.is(F.execution)?O=n.to(F.execution):h.is(F.execution)?O=h.to(F.execution):f.is(F.execution)&&(O=f.to(F._id,U));const G=t.to(F.definition);let $;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?$=F.source.scope:$=await q.resolveWorkspaceFolder(p.URI.revive(F.source.scope)):$=T.TaskScope.Workspace),!G||!$)return;const K=new T.Task(G,$,F.name,F.source.label,O,F.problemMatchers);return F.isBackground!==void 0&&(K.isBackground=F.isBackground),F.group!==void 0&&(K.group=T.TaskGroup.from(F.group)),F.presentationOptions&&(K.presentationOptions=r.to(F.presentationOptions)),F._id&&(K._id=F._id),F.detail&&(K.detail=F.detail),K}ee.to=x})(E=e.TaskDTO||(e.TaskDTO={}));var o;(function(ee){function z(x){return x}ee.from=z;function M(x){if(!!x)return Object.assign(Object.create(null),x)}ee.to=M})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(z,M,x){this._id=M,this._task=x,g.set(this,void 0),it(this,g,z,"f")}get task(){return this._task}terminate(){He(this,g,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}g=new WeakMap;var L;(function(ee){function z(M){return{id:M._id,task:void 0}}ee.from=z})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(z,M,x,F,q,U,O,G){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=z.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=F,this._configurationService=q,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,M,x){if(!x)return new T.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:M,provider:x,extension:z}),this._proxy.$registerTaskProvider(F,M),new T.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(z,M){this._proxy.$registerTaskSystem(z,M)}fetchTasks(z){return this._proxy.$fetchTasks(o.from(z)).then(async M=>{const x=[];for(let F of M){const q=await E.to(F,this._workspaceProvider,this._providedCustomExecutions2);q&&x.push(q)}return x})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(M=>z.push(M)),z}terminateTask(z){if(!(z instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,M,x){const F=this._providedCustomExecutions2.get(z.id);if(F){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,F),this._terminalService.attachPtyToTerminal(M,await F.callback(x))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const M=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const M=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:M,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const M=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:z.exitCode})}$provideTasks(z,M){const x=this._handlers.get(z);if(!x)return Promise.reject(new Error("no handler found"));const F=[],q=(0,R.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(U=>this.provideTasksInternal(M,F,x,U));return new Promise(U=>{q.then(O=>{Promise.all(F).then(()=>{U(O)})})})}async $resolveTask(z,M){const x=this._handlers.get(z);if(!x)return Promise.reject(new Error("no handler found"));if(M.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${x.type}].`);const F=await E.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const q=await x.provider.resolveTask(F,i.CancellationToken.None);if(!q)return;this.checkDeprecation(q,x);const U=E.from(q,x.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(U.execution)&&await this.addCustomExecution(U,q,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,M,x){const F=await this._proxy.$createTaskId(z);!x&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,M.execution)}async getTaskExecution(z,M){if(typeof z=="string"){const q=this._taskExecutionPromises.get(z);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let x=this._taskExecutionPromises.get(z.id);if(x)return x;const F=new Promise(async(q,U)=>{const O=M||await E.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);O?q(new k(this,z.id,O)):U("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,F),F.then(q=>(this._taskExecutions.set(z.id,q),q),q=>Promise.reject(q))}checkDeprecation(z,M){z._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let x=this._notProvidedCustomExecutions.values(),F=x.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=x.next()}};N=Ve([$e(0,u.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,b.ILogService),$e(7,P.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let V=class extends N{constructor(z,M,x,F,q,U,O,G){super(z,M,x,F,q,U,O,G);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(z,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const x=E.from(M,z);if(x===void 0)throw new Error("Task is not valid");if(f.is(x.execution))await this.addCustomExecution(x,M,!1);else throw new d.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),M);return this._proxy.$executeTask(x).catch(q=>{throw new Error(q)}),F}provideTasksInternal(z,M,x,F){const q=[];if(F)for(let U of F){this.checkDeprecation(U,x),(!U.definition||!z[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const O=E.from(U,x.extension);O&&f.is(O.execution)?(q.push(O),M.push(this.addCustomExecution(O,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:x.extension}}async resolveTaskInternal(z){if(f.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,M,x){}};V=Ve([$e(0,u.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,b.ILogService),$e(7,P.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,c.createDecorator)("IExtHostTask")}),define(me[266],ge([0,1,20,55,30,77,22,10,9,24,8,14,2,145,175,120,49,127,265,31]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(w,E,o,k){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=o,this.pathService=k}text(w,E,o={}){w=this.getContentPattern(w,o);const k=this.configurationService.getValue(),L=E&&E.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(E?.map(_.toWorkspaceFolder),o),type:2,contentPattern:w,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:k.search.usePCRE2||L||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(w,E){const o=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const k={...w,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(k.isCaseSensitive=!0),this.isMultiline(w)&&(k.isMultiline=!0),k}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(n):n(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const o=this.handleIncludeExclude(E.includePattern,E.expandPatterns),k=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),L=w.length>1,N=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,E,k)):w.map(z=>this.getFolderQueryForRoot(z,E,k,L))).filter(z=>!!z),V={_reason:E._reason,folderQueries:N,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:k.pattern,includePattern:o.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const M=p.coalesce(p.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(q=>q.resource)))).filter(F=>(0,l.pathIncludedInQuery)(V,F.fsPath)),x=this.commonQueryFromFileList(M);return{...V,...x}}const ee=E.extraFileResources&&E.extraFileResources.filter(z=>(0,l.pathIncludedInQuery)(V,z.fsPath));return V.extraFileResources=ee&&ee.length?ee:void 0,V}commonQueryFromFileList(w){const E=[],o=new T.ResourceMap,k={};let L=!1;return w.forEach(N=>{if(N.scheme===C.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(N)){const ee=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:y.dirname(N.fsPath)});let z=o.get(ee);z||(L=!0,z={folder:ee,includePattern:{}},E.push(z),o.set(ee,z));const M=y.relative(ee.fsPath,N.fsPath);(0,I.assertIsDefined)(z.includePattern)[M.replace(/\\/g,"/")]=!0}else N.fsPath&&(L=!0,k[N.fsPath]=!0)}),{folderQueries:E,includePattern:k,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(i.containsUppercaseCharacter(w.pattern,!0))return!0}else if(i.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),k=(Array.isArray(w)?w:r(w)).map(x=>{const F=this.pathService.resolvedUserHome;return F?(0,S.untildify)(x,F.scheme===C.Schemas.file?F.fsPath:F.path):x}),L=R.groupBy(k,x=>E(x)?"searchPaths":"exprSegments"),N=(L.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),V={},ee=this.expandSearchPathPatterns(L.searchPaths||[]);ee&&ee.length&&(V.searchPaths=ee);const z=p.flatten(N),M=t(...z);return M&&(V.pattern=M),V}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,l.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=p.flatten(w.map(k=>{let{pathPortion:L,globPortion:N}=g(k);N&&(N=a(N));const V=this.expandOneSearchPath(L);return p.flatten(V.map(ee=>this.resolveOneSearchPathPattern(ee,N)))})),o=new Map;return E.forEach(k=>{const L=k.searchPath.toString(),N=o.get(L);N?k.pattern&&(N.pattern=N.pattern||{},N.pattern[k.pattern]=!0):o.set(L,{searchPath:k.searchPath,pattern:k.pattern?t(k.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==C.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:u.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=n(w),w.startsWith("../")||w===".."){const k=y.posix.resolve(E.path,w);return[{searchPath:E.with({path:k})}]}const o=a(w);return[{searchPath:E,pattern:o}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(L=>{const N=E.match(new RegExp(`^${i.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return N?{match:N,folder:L}:null}).filter(I.isDefined);if(k.length)return k.map(L=>{const N=L.match[1];return{searchPath:L.folder.uri,pattern:N&&a(N)}});{const L=w.match(/\.[\/\\](.+)[\/\\]?/),N=L?L[1]:w,V=c.localize(0,null,N);throw new Error(V)}}}}resolveOneSearchPathPattern(w,E){const o=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,k=[{searchPath:w.searchPath,pattern:o}];return o&&!o.endsWith("**")&&k.push({searchPath:w.searchPath,pattern:o+"/**"}),k}getFolderQueryForSearchPath(w,E,o){const k=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),E,o,!1);return k?{...k,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,o,k){let L;const N=u.URI.isUri(w)?w:w.uri;if(o.searchPaths){const x=o.searchPaths.filter(F=>(0,A.isEqual)(F.searchPath,N))[0];if(x&&!x.pattern)return null;x&&(L=x.pattern)}const V=this.configurationService.getValue({resource:N}),z={...this.getExcludesForFolder(V,E)||{},...L||{}},M=u.URI.isUri(w)?(0,A.basename)(w):w.name;return{folder:N,folderName:k?M:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!V.search.followSymlinks}}};d=Ve([$e(0,v.IConfigurationService),$e(1,_.IWorkspaceContextService),$e(2,b.IEditorGroupsService),$e(3,P.IPathService)],d),e.QueryBuilder=d;function g(f){const w=f.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,o=f.substr(0,E).match(/[/|\\][^/\\]*$/);if(o){let k=f.substr(0,o.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:f.substr((o.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function r(f){return D.splitGlobAware(f,",").map(w=>w.trim()).filter(w=>!!w.length)}function s(f){return[`**/${f}/**`,`**/${f}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(f){return f.replace(/\\/g,"/")}function a(f){return n(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(f,w){f=p.distinct(f,k=>k.toString());const E=[],o=w.getWorkspace();return f&&f.forEach(k=>{let L;if(w.getWorkbenchState()===2)L=(0,A.relativePath)(o.folders[0].uri,k),L&&L!=="."&&(L="./"+L);else{const N=w.getWorkspaceFolder(k);if(N){const V=N.name;if(o.folders.filter(z=>z.name===V).length===1){const z=(0,A.relativePath)(N.uri,k);z===""?L=`./${N.name}`:L=`./${N.name}/${z}`}else L=k.fsPath}}L&&E.push(L)}),E}e.resolveResourcesForSearchIncludes=h}),define(me[267],ge([0,1,24,2,21,15,4,266,31,49]),function(J,e,p,R,D,S,T,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(v,_){const b=_.activationEvents;if(!b)return Promise.resolve(void 0);const P=[],l=[];for(const n of b)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?l.push(a):P.push(a)}if(P.length===0&&l.length===0)return Promise.resolve(void 0);let d;const g=new Promise((n,a)=>{d=n}),t=n=>d({activationEvent:n}),r=Promise.all(P.map(n=>u(v,n,t))).then(()=>{}),s=m(v,_.identifier,l,t);return Promise.all([r,s]).then(()=>{d(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function u(v,_,b){for(const P of v.folders)if(await v.exists(p.joinPath(R.URI.revive(P),_))){b(`workspaceContains:${_}`);return}}async function m(v,_,b,P){if(b.length===0)return Promise.resolve(void 0);const l=new D.CancellationTokenSource,d=v.checkExists(v.folders,b,l.token),g=setTimeout(async()=>{l.cancel(),P(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await d}catch(r){S.isPromiseCanceledError(r)||S.onUnexpectedError(r)}l.dispose(),clearTimeout(g),t&&P(`workspaceContains:${b.join(",")}`)}function c(v,_,b,P){const l=v.get(T.IInstantiationService),d=v.get(y.ISearchService),t=l.createInstance(C.QueryBuilder).file(_.map(r=>(0,A.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:b,exists:!0});return d.fileSearch(t,P).then(r=>!!r.limitHit,r=>S.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var it=this&&this.__classPrivateFieldSet||function(J,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,p):D?D.value=p:e.set(J,p),p},He=this&&this.__classPrivateFieldGet||function(J,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(J):R?R.value:e.get(J)};define(me[40],ge([0,1,164,9,70,24,16,6,22,2,12,5,37,226,92,36,35,224,15,26,23,200,7,121,4,27,66,13,81,51,33,3,267,90,202]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l,d,g,t,r,s,n,a,h,f,w,E,o,k,L,N){"use strict";var V,ee,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let M=class Wn extends C.Disposable{constructor(U,O,G,$,K,re,fe,ye,Ie,Le){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=G,this._initData=fe,this._extHostWorkspace=$,this._extHostConfiguration=K,this._logService=re,this._extHostTunnelService=Ie,this._extHostTerminalService=Le,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=U.createChild(new f.ServiceCollection([c.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(We=>qe.add(l.ExtensionIdentifier.toKey(We))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,je,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,P.transformErrorForSerialization(je),W)},actualActivateExtension:async(We,je)=>{if(qe.has(l.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,je),new m.HostExtension;const W=this._registry.getExtensionDescription(We);return this._activateExtension(W,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){P.onUnexpectedError(U)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let U=[];try{U=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(O){}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,O){return this._activator.activateByEvent(U,O)}_activateById(U,O){return this._activator.activateById(U,O)}activateByIdWithErrors(U,O){return this._activateById(U,O).then(()=>{const G=this._activator.getActivatedExtension(U);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const U=y.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then($=>U.set(A.URI.file($).fsPath,G))});this._extensionPathIndex=Promise.all(O).then(()=>U)}return this._extensionPathIndex}_deactivate(U){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return O;const G=this._activator.getActivatedExtension(U);if(!G)return O;try{typeof G.module.deactivate=="function"&&(O=Promise.resolve(G.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,C.dispose)(G.subscriptions)}catch($){this._logService.error($)}return O}async _activateExtension(U,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,O).then(G=>{const $=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,O),this._logExtensionActivationTimes(U,O,"success",$),G},G=>{throw this._logExtensionActivationTimes(U,O,"failure"),G})}_logExtensionActivationTimes(U,O,G,$){const K=x(U,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...$||{},outcome:G})}_doActivateExtension(U,O){const G=x(U,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const $=this._getEntryPoint(U);if(!$)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const K=new m.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,S.joinPath)(U.extensionLocation,$),K),this._loadExtensionContext(U)]).then(re=>(D.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),Wn._callActivate(this._logService,U.identifier,re[0],re[1],K))).then(re=>(D.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),re))}_loadExtensionContext(U){const O=new g.ExtensionGlobalMemento(U,this._storage),G=new g.ExtensionMemento(U.identifier.value,!1,this._storage),$=new N.ExtensionSecrets(U,this._secretState),K=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([O.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let ye;return Object.freeze({globalState:O,workspaceState:G,secrets:$,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ie){return R.join(U.extensionLocation.fsPath,Ie)},get storagePath(){return fe._storagePath.workspaceValue(U)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(U).fsPath},get logPath(){return R.join(fe._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return A.URI.joinPath(fe._initData.logsLocation,U.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(U)},get globalStorageUri(){return fe._storagePath.globalValue(U)},get extensionMode(){return K},get extension(){return ye===void 0&&(ye=new F(fe,U.identifier,U,re)),ye},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(U),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,O,G,$,K){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,O,G,$,K).then(re=>new m.ActivatedExtension(!1,null,K.build(),G,re,$.subscriptions))}static _callActivateOptional(U,O,G,$,K){if(typeof G.activate=="function")try{K.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${O.value}`);const re=typeof global=="object"?global:self,fe=G.activate.apply(re,[$]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(fe).then(ye=>(K.activateResolveStop(),ye))}catch(re){return Promise.reject(re)}else return Promise.resolve(G)}_activateOneStartupFinished(U,O){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:O}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const O of U.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(U,O)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(O),$=Promise.all([U,G]).then(()=>{});return Promise.race([$,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(U,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,O){if(this.isActivated(O.identifier))return;const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:U.map(re=>re.uri),forceUsingSearch:G,exists:re=>this._hostUtils.exists(re.fsPath),checkExists:(re,fe,ye)=>this._mainThreadWorkspaceProxy.$checkExists(re,fe,ye)},K=await(0,k.checkActivateWorkspaceContainsExtension)($,O);if(!!K)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:K.activationEvent}).then(void 0,re=>this._logService.error(re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:O}=this._initData.environment;if(!U||!O)throw new Error(p.localize(0,null));const G=await this._loadCommonJSModule(null,O,new m.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(p.localize(1,null,O.toString()));return new Promise(($,K)=>{const re=(Ie,Le)=>{Ie?K(Ie):$(typeof Le=="number"&&Le>0?1:0)},fe=(0,S.originalFSPath)(O),ye=G.run(fe,re);ye&&ye.then&&ye.then(()=>{$(0)}).catch(Ie=>{K(Ie.toString())})})}async $extensionTestsExit(U){this._logService.info(`extension host terminating: test runner requested exit with code ${U}`),this._logService.info(`exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(U,O){return this._resolvers[U]=O,(0,C.toDisposable)(()=>{delete this._resolvers[U]})}async _activateAndGetResolver(U){const O=U.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const G=U.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this._resolvers[G]}}async $resolveAuthority(U,O){const{authorityPrefix:G,resolver:$}=await this._activateAndGetResolver(U);if(!$)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${G}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),D.mark(`code/extHost/willResolveAuthority/${G}`);const K=await $.resolve(U,{resolveAttempt:O});D.mark(`code/extHost/didResolveAuthorityOK/${G}`);const re={authority:U,host:K.host,port:K.port,connectionToken:K.connectionToken},fe={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:re,options:fe,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(D.mark(`code/extHost/didResolveAuthorityError/${G}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(U,O){const{authorityPrefix:G,resolver:$}=await this._activateAndGetResolver(U);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${G}`);const K=A.URI.revive(O);if(typeof $.getCanonicalURI=="undefined")return K;const re=await(0,T.asPromise)(()=>$.getCanonicalURI(K));return re||K}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,O){return O===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(U,!1))}async $activate(U,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,O),!0):!1}async $deltaExtensions(U,O){U.forEach($=>$.extensionLocation=A.URI.revive($.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(O.map(async $=>{const K=this._registry.getExtensionDescription($);if(!K)return;const re=await this._hostUtils.realpath(K.extensionLocation.fsPath);G.delete(A.URI.file(re).fsPath)})),await Promise.all(U.map(async $=>{const K=await this._hostUtils.realpath($.extensionLocation.fsPath);G.set(A.URI.file(K).fsPath,$)})),this._registry.deltaExtensions(U,O),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let O=d.VSBuffer.alloc(U),G=Math.random()%256;for(let $=0;$<U;$++)O.writeUInt8(G,$);return O}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};M=Ve([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,h.IExtHostRpcService),$e(3,v.IExtHostWorkspace),$e(4,u.IExtHostConfiguration),$e(5,i.ILogService),$e(6,n.IExtHostInitDataService),$e(7,a.IExtensionStoragePaths),$e(8,w.IExtHostTunnelService),$e(9,E.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function x(q,U){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class F{constructor(U,O,G,$){V.set(this,void 0),ee.set(this,void 0),z.set(this,void 0),it(this,V,U,"f"),it(this,ee,O,"f"),it(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=R.normalize((0,S.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=$}get isActive(){return He(this,V,"f").isActivated(He(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,V,"f").getExtensionExports(He(this,z,"f"))}activate(){return He(this,V,"f").activateByIdWithErrors(He(this,z,"f"),{startup:!1,extensionId:He(this,ee,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,V=new WeakMap,ee=new WeakMap,z=new WeakMap}),define(me[53],ge([0,1,9,2,3,16,5,7,124,36,40,43,215,37,210,13,4,14,38,50]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let d=class{constructor(f,w,E,o,k,L){this._workspaceService=w,this._extensionService=E,this._editorsService=o,this._configurationService=k,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=f.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(V=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,w){const E=f;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let o=`debug:${encodeURIComponent(E.path||"")}`,k="?";return w&&(o+=`${k}session=${encodeURIComponent(w.id)}`,k="&"),o+=`${k}ref=${E.sourceReference}`,R.URI.parse(o)}else{if(E.path)return R.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const w=[];for(const E of f.getAllExtensionDescriptions())if(E.contributes){const o=E.contributes.debuggers;if(o&&o.length>0)for(const k of o)(0,c.isDebuggerMainContribution)(k)&&w.push(k.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(w=>f.push(w)),f}addBreakpoints(f){this.startBreakpoints();const w=f.filter(k=>{const L=k.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,k),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],o=new Map;for(const k of w)if(k instanceof C.SourceBreakpoint){let L=o.get(k.location.uri.toString());L||(L={type:"sourceMulti",uri:k.location.uri,lines:[]},o.set(k.location.uri.toString(),L),E.push(L)),L.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof C.FunctionBreakpoint&&E.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(f){this.startBreakpoints();const w=f.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(L=>L instanceof C.SourceBreakpoint).map(L=>L.id),o=w.filter(L=>L instanceof C.FunctionBreakpoint).map(L=>L.id),k=w.filter(L=>L instanceof C.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(E,o,k)}startDebugging(f,w,E){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,w,E){if(!w)return new C.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:o,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,o),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(f,w,E){if(!E)return new C.Disposable(()=>{});if(!this.definesDebugType(f,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:o,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,o),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(f,w){if(!w)return new C.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:E,factory:w}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==w)})}async $runInTerminal(f,w){return Promise.resolve(void 0)}async $substituteVariables(f,w){if(!this._variableResolver){const[k,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,L)}let E;const o=await this.getFolder(f);return o&&(E={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(f,w){if(f.type==="implementation")return new n(f.implementation)}createSignService(){}async $startDASession(f,w){const E=this,o=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const L=this.convertToDto(k),N=this.createDebugAdapter(L,o);if(!N)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const V=N;return this._debugAdapters.set(f,V),this.getDebugAdapterTrackers(o).then(ee=>(ee&&this._debugAdaptersTrackers.set(f,ee),V.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const M=z,x={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(M.arguments.value);x.body={signature:F},V.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,V.sendResponse(x)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(z),z=(0,c.convertToVSCPaths)(z,!0),E._debugServiceProxy.$acceptDAMessage(f,z)}),V.onError(z=>{ee&&ee.onError&&ee.onError(z),this._debugServiceProxy.$acceptDAError(f,z.name,z.message,z.stack)}),V.onExit(z=>{ee&&ee.onExit&&ee.onExit((0,b.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,b.withNullAsUndefined)(z),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),V.startSession()))})}$sendDAMessage(f,w){w=(0,c.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(f);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const o=this._debugAdapters.get(f);o&&o.sendMessage(w)}$stopDASession(f){const w=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(f);return this._debugAdapters.delete(f),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const w=[],E=[],o=[];if(f.added)for(const k of f.added){const L=k.id;if(L&&!this._breakpoints.has(L)){let N;if(k.type==="function")N=new C.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")N=new C.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const V=R.URI.revive(k.uri);N=new C.SourceBreakpoint(new C.Location(V,new C.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}N._id=L,this._breakpoints.set(L,N),w.push(N)}}if(f.removed)for(const k of f.removed){const L=this._breakpoints.get(k);L&&(this._breakpoints.delete(k),E.push(L))}if(f.changed){for(const k of f.changed)if(k.id){const L=this._breakpoints.get(k.id);if(L){if(L instanceof C.FunctionBreakpoint&&k.type==="function"){const N=L;N.enabled=k.enabled,N.condition=k.condition,N.hitCondition=k.hitCondition,N.logMessage=k.logMessage,N.functionName=k.functionName}else if(L instanceof C.SourceBreakpoint&&k.type==="source"){const N=L;N.enabled=k.enabled,N.condition=k.condition,N.hitCondition=k.hitCondition,N.logMessage=k.logMessage,N.location=new C.Location(R.URI.revive(k.uri),new C.Position(k.line,k.character))}o.push(L)}}}this.fireBreakpointChanges(w,E,o)}$provideDebugConfigurations(f,w,E){return(0,S.asPromise)(async()=>{const o=this.getConfigProviderByHandle(f);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(w);return o.provideDebugConfigurations(k,E)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(f,w,E,o){return(0,S.asPromise)(async()=>{const k=this.getConfigProviderByHandle(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(w);return k.resolveDebugConfiguration(L,E,o)})}$resolveDebugConfigurationWithSubstitutedVariables(f,w,E,o){return(0,S.asPromise)(async()=>{const k=this.getConfigProviderByHandle(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(w);return k.resolveDebugConfigurationWithSubstitutedVariables(L,E,o)})}async $provideDebugAdapter(f,w){const E=this.getAdapterDescriptorFactoryByHandle(f);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(w);return this.getAdapterDescriptor(E,o).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(f){const w=await this.getSession(f);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(f){const w=await this.getSession(f);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,w){const E=await this.getSession(f);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(f,w){const o={session:await this.getSession(f),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(f){if(f instanceof C.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof C.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const w=this._adapterFactories.filter(E=>E.type===f);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(f){const w=this._adapterFactories.filter(E=>E.handle===f);if(w.length>0)return w[0].factory}getConfigProviderByHandle(f){const w=this._configProviders.filter(E=>E.handle===f);if(w.length>0)return w[0].provider}definesDebugType(f,w){if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0){for(const o of E)if(o.label&&o.type&&o.type===w)return!0}}return!1}getDebugAdapterTrackers(f){const E=f.configuration.type,o=this._trackerFactories.filter(k=>k.type===E||k.type==="*").map(k=>(0,S.asPromise)(()=>k.factory.createDebugAdapterTracker(f)).then(L=>L,L=>null));return Promise.race([Promise.all(o).then(k=>{const L=k.filter(N=>!!N);if(L.length>0)return new s(L)}),new Promise((k,L)=>{const N=setTimeout(()=>{clearTimeout(N),L(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(f,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new C.DebugAdapterServer(E));if(f){const k=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>f.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,k))).then(L=>{if(L)return L})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,o))}daExecutableFromPackage(f,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,w,E){(f.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:w,changed:E}))}async getSession(f){if(f)if(typeof f=="string"){const w=this._debugSessions.get(f);if(w)return w}else{let w=this._debugSessions.get(f.id);if(!w){const E=await this.getFolder(f.folderUri),o=f.parent?this._debugSessions.get(f.parent):void 0;w=new g(this._debugServiceProxy,f.id,f.type,f.name,E,f.configuration,o),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(f){if(f){const w=R.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};d=Ve([$e(0,v.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,l.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class g{constructor(f,w,E,o,k,L,N){this._debugServiceProxy=f,this._id=w,this._type=E,this._name=o,this._workspaceFolder=k,this._configuration=L,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,w)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=g;class t{constructor(f){this.value=Object.freeze({append(w){f.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends u.AbstractVariableResolverService{constructor(f,w,E,o,k){function L(){if(w){const N=w.activeEditor();if(N)return N.document.uri;const V=o.tabs.filter(ee=>ee.isActive);if(V.length>0)return V[0].resource}}super({getFolderUri:N=>{const V=f.filter(ee=>ee.name===N);if(V&&V.length>0)return V[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(N,V)=>E.getConfiguration(void 0,N).get(V),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=L();if(N)return p.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const N=L();if(N){const V=k.getWorkspaceFolder(N);if(V)return p.normalize(V.uri.fsPath)}}},getSelectedText:()=>{if(w){const N=w.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(w){const N=w.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class s{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(w=>w.onError?w.onError(f):void 0)}onExit(f,w){this.trackers.forEach(E=>E.onExit?E.onExit(f,w):void 0)}}class n extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(f,w,E,o,k,L){super(f,w,E,o,k,L)}createVariableResolver(f,w,E){return new r(f,w,E,this._editorTabs)}};a=Ve([$e(0,v.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,l.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(me[268],ge([0,1,70,2,5,37,35,26,13,27,4,40,38,12]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(l,d,g,t,r,s,n){this._apiFactory=l,this._extensionRegistry=d,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,d,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,d,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let d of l.nodeModuleName)this._factories.set(d,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(d=>l.alternativeModuleName(d))}};c=Ve([$e(2,i.IInstantiationService),$e(3,S.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,A.IExtHostInitDataService),$e(6,m.ILogService)],c),e.RequireInterceptor=c;class v{constructor(l,d,g,t,r){this._apiFactory=l,this._extensionPaths=d,this._extensionRegistry=g,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,d){const g=this._extensionPaths.findSubstr(d.fsPath);if(g){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(l,d){this.nodeModuleName="keytar";const{environment:g}=d,t=l.getProxy(D.MainContext.MainThreadKeytar);if(g.appRoot){let r=g.appRoot.fsPath;u.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,n)=>t.$setPassword(r,s,n),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(l,d){return this._impl}alternativeModuleName(l){const d=l.length;if(d<=7||!this.alternativeNames)return;const g=d-7;if((l.charAt(g)==="/"||l.charAt(g)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};_=Ve([$e(0,y.IExtHostRpcService),$e(1,A.IExtHostInitDataService)],_);let b=class{constructor(l,d,g){this._extensionPaths=l,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(D.MainContext.MainThreadTelemetry);const t=g.getProxy(D.MainContext.MainThreadWindow);this._impl=(r,s)=>{const n=R.URI.parse(r);return s?this.callOriginal(r,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,r,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,r,{}):this.callOriginal(r,s)}}load(l,d,g){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(l),this._impl}callOriginal(l,d){return this.sendNoForwardTelemetry(),this._original(l,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([$e(2,y.IExtHostRpcService)],b)}),define(me[269],ge([0,1,170,11,7,211,36,40,43,37,33,13,53,194,16,212,50]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends u.ExtHostDebugServiceBase{constructor(d,g,t,r,s,n,a){super(d,g,t,r,s,a);this._terminalService=n,this._integratedTerminalInstances=new P}createDebugAdapter(d,g){switch(d.type){case"server":return new S.SocketDebugAdapter(d);case"pipeServer":return new S.NamedPipeDebugAdapter(d);case"executable":return new S.ExecutableDebugAdapter(d,g.type)}return super.createDebugAdapter(d,g)}daExecutableFromPackage(d,g){const t=S.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),d.type);if(t)return new D.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(d,g){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=d.title||p.localize(0,null),a=JSON.stringify({shell:r,shellArgs:s});let h=await this._integratedTerminalInstances.checkout(a,n),f,w=!1;if(h)f=d.cwd;else{const L={shellPath:r,shellArgs:s,cwd:d.cwd,name:n,iconPath:new D.ThemeIcon("debug")};w=!0,h=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,a)}h.show(!0);const E=await h.processId;w?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?h.sendText("cls"):r.indexOf("bash")>=0?h.sendText("clear"):R.isWindows?h.sendText("cls"):h.sendText("clear"));const o=(0,v.prepareCommand)(r,d.args,f,d.env);h.sendText(o);const k=this.onDidTerminateDebugSession(L=>{L.id===g&&(this._integratedTerminalInstances.free(h),k.dispose())});return E}else if(d.kind==="external")return(0,v.runInExternalTerminal)(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,g)}createVariableResolver(d,g,t){return new u.ExtHostVariableResolverService(d,g,t,this._editorTabs,this._workspaceService)}};b=Ve([$e(0,I.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,C.IExtHostExtensionService),$e(3,y.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,_.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class P{constructor(){this._terminalInstances=new Map}async checkout(d,g){const r=[...this._terminalInstances.entries()].map(([s,n])=>(0,c.createCancelablePromise)(async a=>{if(s.name!==g||n.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await s.processId))return null;const h=Date.now();return n.lastUsedAt+P.minUseDelay>h||a.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=h,s)}));return await(0,c.firstParallel)(r,s=>!!s)}insert(d,g){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:g})}free(d){const g=this._terminalInstances.get(d);g&&(g.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}P.minUseDelay=1e3}),define(me[270],ge([0,1,9,2,113,36,53,43,37,33,13,27,69,10,12,64,50]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends u.ExtHostTaskBase{constructor(l,d,g,t,r,s,n,a,h){super(l,d,g,t,r,s,n,a);this.workspaceService=g,this.editorTabs=h,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(l,d){const g=d;if(!d.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const t=u.TaskHandleDTO.from(g,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(r,d);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=u.TaskDTO.from(d,l);if(t===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,d,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),d);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(l,d,g,t){const r=[];if(t)for(let s of t){this.checkDeprecation(s,g),(!s.definition||!l[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const n=u.TaskDTO.from(s,g.extension);n&&(r.push(n),u.CustomExecutionDTO.is(n.execution)&&d.push(this.addCustomExecution(n,s,!0)))}return{tasks:r,extension:g.extension}}async resolveTaskInternal(l){return l}async getVariableResolver(l){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(l,this._editorService,d,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(l,d){const g=R.URI.revive(l),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(g),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!r)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(s),a={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}};for(let h of d.variables)t.variables[h]=await n.resolveAsync(a,h);if(d.process!==void 0){let h;if(d.process.path!==void 0){h=d.process.path.split(p.delimiter);for(let f=0;f<h.length;f++)h[f]=await n.resolveAsync(a,h[f])}t.process=await D.win32.findExecutable(await n.resolveAsync(a,d.process.name),d.process.cwd!==void 0?await n.resolveAsync(a,d.process.cwd):void 0,h)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(l,d,g){return D.win32.findExecutable(l,d,g)}};b=Ve([$e(0,i.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,y.IExtHostConfiguration),$e(5,A.IExtHostTerminalService),$e(6,c.ILogService),$e(7,v.IExtHostApiDeprecationService),$e(8,_.IExtHostEditorTabs)],b),e.ExtHostTask=b}),define(me[271],ge([0,1,16,15,70,6,2,5,263,12,79,81,27,188,13,63,40,33]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(d,g,t,r){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(d,null,r),g=P._transform(g,this._rpcProtocol);const s=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...g}),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(v.IURITransformerService,new v.URITransformerService(r)),s.set(_.IHostUtils,t);const n=new m.InstantiationService(s,!0),a=n.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(E=>E.get(A.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=n.invokeFunction(E=>E.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(o,k)=>{let L="",N,V;for(const ee of k)L+=`
	at ${ee.toString()}`,V=ee.getFileName(),!N&&V&&(N=E.findSubstr(V));return h.set(o,N),`${o.name||"Error"}: ${o.message||""}${L}`}});const f=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(E=>{const o=R.transformErrorForSerialization(E),k=h.get(E);k?f.$onExtensionRuntimeError(k.identifier,o):w.$onUnexpectedError(o)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,p.timeout)(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,g){d.extensions.forEach(r=>r.extensionLocation=T.URI.revive(g.transformIncomingURIs(r.extensionLocation))),d.environment.appRoot=T.URI.revive(g.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(r=>T.URI.revive(g.transformIncomingURIs(r)))),d.environment.extensionTestsLocationURI=T.URI.revive(g.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=T.URI.revive(g.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=T.URI.revive(g.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=T.URI.revive(g.transformIncomingURIs(d.logsLocation)),d.logFile=T.URI.revive(g.transformIncomingURIs(d.logFile)),d.workspace=g.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=P}),define(me[272],ge([0,1,9,21,60,30,24,44,31]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(u,m,c){this.config=u,this.provider=m,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&S.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&S.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const m=this.config.folderQueries||[];return new Promise((c,v)=>{const _=b=>{this.resultCount++,u(b)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const P=b.toString(),l=p.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,l)||this.matchFile(_,{base:b,basename:l})}),Promise.all(m.map(b=>this.searchInFolder(b,_))).then(b=>{c({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,D.toErrorMessage)(b)))})})}async searchInFolder(u,m){const c=new R.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),_=this.initDirectoryTree(),b=new y.QueryGlobTester(this.config,u),P=!b.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(c),l=C.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,c.token),g=l.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(r=>{const s=p.posix.relative(u.folder.path,r.path);if(P){const n=p.basename(r.path);this.matchFile(m,{base:u.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(_,u.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,b,m),{providerTime:g,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(u){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),c=(0,y.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:c,includes:m,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},m,c,v){if(c===this.filePattern){const b=p.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:b})}function _(b){const P=p.basename(b),l=p.dirname(b);let d=u[l];d||(d=u[l]=[],_(l)),d.push({base:m,relativePath:b,basename:P})}_(c)}matchDirectoryTree({rootEntries:u,pathToEntries:m},c,v){const _=this,b=this.filePattern;function P(l){const d=S.hasSiblingFn(()=>l.map(g=>g.basename));for(let g=0,t=l.length;g<t;g++){const r=l[g],{relativePath:s,basename:n}=r;if(!c.includedInQuerySync(s,n,b!==n?d:void 0))continue;const a=m[s];if(a)P(a);else{if(s===b)continue;_.matchFile(v,r)}if(_.isLimitHit)break}}P(u)}matchFile(u,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(m))}}class i{constructor(){this.sessions=new Map}fileSearch(u,m,c,v){const _=this.getSessionTokenSource(u.cacheKey),b=new A(u,m,_&&_.token);let P=0;const l=d=>{P+=d.length,c(d.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(b,i.BATCH_SIZE,l,v).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:d.stats}}))}clearCache(u){const m=this.getSessionTokenSource(u);m&&m.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new R.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,m,c,v){v.onCancellationRequested(()=>{u.cancel()});const _=P=>{P&&(b.push(P),m>0&&b.length>=m&&(c(b),b=[]))};let b=[];return u.search(_).then(P=>(b.length&&c(b),P),P=>(b.length&&c(b),Promise.reject(P)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[133],ge([0,1,9,20,21,60,24,30,2,31,10,14]),function(J,e,p,R,D,S,T,C,y,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(l,d,g){this.query=l,this.provider=d,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,d){const g=this.query.folderQueries||[],t=new D.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new c(l);let n=!1;const a=(h,f)=>{if(!n&&!this.isLimitHit){const w=this.resultSize(h);_(h)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const E=this.resultSize(h);this.resultCount+=E,(E>0||!_(h))&&this.collector.add(h,f)}};Promise.all(g.map((h,f)=>this.searchInFolder(h,w=>a(w,f),t.token))).then(h=>{t.dispose(),this.collector.flush();const f=h.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||f,messages:(0,R.flatten)(h.map(w=>w?.message?(0,I.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:"textSearchProvider"}})},h=>{t.dispose();const f=(0,S.toErrorMessage)(h);s(new Error(f))})})}resultSize(l){return _(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,d){const g=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:g.slice(0,d),preview:{matches:t.slice(0,d),text:l.preview.text},uri:l.uri}}async searchInFolder(l,d,g){const t=new A.QueryGlobTester(this.query,l),r=[],s={report:h=>{if(!this.validateProviderResult(h))return;const f=l.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(h.uri))):void 0,w=T.relativePath(l.folder,h.uri);w&&r.push(t.includedInQuery(w,p.basename(w),f).then(E=>{E&&d(h)}))}},n=this.getSearchOptionsForFolder(l),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,s,g);return await Promise.all(r),a}validateProviderResult(l){if(_(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const d=(0,A.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),g=(0,A.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:y.URI.from(l.folder),excludes:g,includes:d,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function m(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class c{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,d=>this.sendItems(d))}add(l,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!T.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=c;function v(P){return _(P)?{preview:{matches:(0,R.mapArrayOrNot)(P.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:P.preview.text},ranges:(0,R.mapArrayOrNot)(P.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function _(P){return!!P.preview}e.extensionResultIsMatch=_;class b{constructor(l,d){this.maxBatchSize=l,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,d){!l||this.addItemToBatch(l,d)}addItems(l,d){!l||this.addItemsToBatch(l,d)}addItemToBatch(l,d){this.batch.push(l),this.batchSize+=d,this.onUpdate()}addItemsToBatch(l,d){this.batch=this.batch.concat(l),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,272,13,63,12,2,133]),function(J,e,p,R,D,S,T,C,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(v,_,b){this.extHostRpc=v,this._uriTransformer=_,this._logService=b,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const b=this._handlePool++;return this._textSearchProvider.set(b,_),this._proxy.$registerTextSearchProvider(b,this._transformScheme(v)),(0,p.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const b=this._handlePool++;return this._fileSearchProvider.set(b,_),this._proxy.$registerFileSearchProvider(b,this._transformScheme(v)),(0,p.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(v,_,b,P){const l=u(b),d=this._fileSearchProvider.get(v);if(d)return this._fileSearchManager.fileSearch(l,d,g=>{this._proxy.$handleFileMatch(v,_,g.map(t=>t.resource))},P);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,b,P){const l=this._textSearchProvider.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const d=u(b);return this.createTextSearchManager(d,l).search(t=>this._proxy.$handleTextMatch(v,_,t),P)}createTextSearchManager(v,_){return new i.TextSearchManager(v,_,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};I=Ve([$e(0,T.IExtHostRpcService),$e(1,C.IURITransformerService),$e(2,y.ILogService)],I),e.ExtHostSearch=I;function u(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(m),extraFileResources:c.extraFileResources&&c.extraFileResources.map(v=>A.URI.revive(v))}}e.reviveQuery=u;function m(c){return{...c,folder:A.URI.revive(c.folder)}}}),define(me[273],ge([0,1,21,15,3,46,2,114,109,146,78,42,5,232,231,52,233,37,234,235,236,217,237,43,40,238,218,240,241,242,65,220,247,248,249,92,33,251,221,17,7,254,67,132,36,35,55,207,239,83,131,69,53,71,12,63,13,27,243,204,51,64,229,252,203,66,91,257,255,256,230,62,250,253,90,50,122,245,68,246,10,190,244,201,199]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l,d,g,t,r,s,n,a,h,f,w,E,o,k,L,N,V,ee,z,M,x,F,q,U,O,G,$,K,re,fe,ye,Ie,Le,qe,We,je,W,Z,ne,le,Y,ae,ve,Me,ze,Ee,Ye,X,se,he,xe,Be,et,Ce,De,Te,ce,ue,pe,be,j,we,_e,Ae,Ue,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Qe){const Je=Qe.get(ne.IExtHostInitDataService),ct=Qe.get(et.IExtHostFileSystemInfo),mt=Qe.get(X.IExtHostConsumerFileSystem),bt=Qe.get(s.IExtHostExtensionService),ot=Qe.get(G.IExtHostWorkspace),at=Qe.get(ue.IExtHostTelemetry),Se=Qe.get(b.IExtHostConfiguration),Pe=Qe.get(W.IURITransformerService),te=Qe.get(Z.IExtHostRpcService),Q=Qe.get(V.IExtHostStorage),Oe=Qe.get(Ye.IExtensionStoragePaths),Fe=Qe.get(je.ILogService),tt=Qe.get(ae.IExtHostTunnelService),Ke=Qe.get(ve.IExtHostApiDeprecationService),ut=Qe.get(O.IExtHostWindow),St=Qe.get(Te.IExtHostSecretState),kt=Qe.get(ce.IExtHostEditorTabs);te.set(u.ExtHostContext.ExtHostFileSystemInfo,ct),te.set(u.ExtHostContext.ExtHostLogService,Fe),te.set(u.ExtHostContext.ExtHostWorkspace,ot),te.set(u.ExtHostContext.ExtHostConfiguration,Se),te.set(u.ExtHostContext.ExtHostExtensionService,bt),te.set(u.ExtHostContext.ExtHostStorage,Q),te.set(u.ExtHostContext.ExtHostTunnelService,tt),te.set(u.ExtHostContext.ExtHostWindow,ut),te.set(u.ExtHostContext.ExtHostSecretState,St),te.set(u.ExtHostContext.ExtHostTelemetry,at),te.set(u.ExtHostContext.ExtHostEditorTabs,kt);const Dt=te.set(u.ExtHostContext.ExtHostDecorations,Qe.get(Ie.IExtHostDecorations)),ft=te.set(u.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(r.IExtHostDocumentsAndEditors)),dt=te.set(u.ExtHostContext.ExtHostCommands,Qe.get(v.IExtHostCommands)),vt=te.set(u.ExtHostContext.ExtHostTerminalService,Qe.get(ee.IExtHostTerminalService)),Et=te.set(u.ExtHostContext.ExtHostDebugService,Qe.get(qe.IExtHostDebugService)),Tt=te.set(u.ExtHostContext.ExtHostSearch,Qe.get(We.IExtHostSearch)),It=te.set(u.ExtHostContext.ExtHostTask,Qe.get(Le.IExtHostTask)),bn=te.set(u.ExtHostContext.ExtHostOutputService,Qe.get(E.IExtHostOutputService)),Vt=te.set(u.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(te)),_t=te.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(te,ft)),Xt=te.set(u.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(te,ft,Fe)),Yt=te.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(Fe,_t,te.getProxy(u.MainContext.MainThreadBulkEdits))),gt=te.set(u.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(te,dt,ft,_t,Oe)),jt=te.set(u.ExtHostContext.ExtHostNotebookDocuments,new Ue.ExtHostNotebookDocuments(Fe,gt)),Wt=te.set(u.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(Fe,te,gt)),Jt=te.set(u.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(te,Je,gt,Fe)),Zt=te.set(u.ExtHostContext.ExtHostNotebookRenderers,new j.ExtHostNotebookRenderers(te,gt)),Pt=te.set(u.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(te,ft)),dn=te.set(u.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(te.getProxy(u.MainContext.MainThreadTreeViews),dt,Fe)),en=te.set(u.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(te.getProxy(u.MainContext.MainThreadEditorInsets),Pt,Je)),xt=te.set(u.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(te,Fe)),ht=te.set(u.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(te,Pe,_t,dt,xt,Fe,Ke)),tn=te.set(u.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(te,ht)),Mt=te.set(u.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(te,Fe,ft)),Ot=te.set(u.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(te,ot,dt)),qt=te.set(u.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(te,dt,Fe)),En=te.set(u.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(te,dt,_t)),hn=te.set(u.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(te.getProxy(u.MainContext.MainThreadProgress))),_n=te.set(u.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(te)),fn=te.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(te)),nn=te.set(u.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(te)),rn=te.set(u.ExtHostContext.ExtHostTimeline,new ze.ExtHostTimeline(te,dt)),Ht=te.set(u.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(te,{remote:Je.remote},ot,Fe,Ke)),sn=te.set(u.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(te,Ht,ot)),Sn=te.set(u.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(te,_t,Oe,Ht,sn)),yn=te.set(u.ExtHostContext.ExtHostWebviewViews,new se.ExtHostWebviewViews(te,Ht)),zt=te.set(u.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(te,dt)),Gt=te.set(u.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(te));te.set(u.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(te,gt,ft));const Dn=(0,K.values)(u.ExtHostContext);te.assertRegistered(Dn);const Cn=new Be.ExtHostBulkEdits(te,ft),on=new c.ExtHostClipboard(te),an=new w.ExtHostMessageService(te,Fe),Bt=new l.ExtHostDialogs(te),Lt=new N.ExtHostStatusBar(te,dt.converter),Kt=new f.ExtHostLanguages(te,_t);return m.ExtHostApiCommands.register(dt),function(Ne,$t,mn){const pt=function(){let ie=!Ne.isUnderDevelopment;function de(Re){ie||(Fe.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")de(st);else{const wt=st;typeof wt.scheme=="undefined"&&de(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,$.throwProposedApiError)(Ne)}return st}}(),kn={getSession(ie,de,Re){return Re?.forceRecreate&&(0,$.checkProposedApiEnabled)(Ne),nn.getSession(Ne,ie,de,Re)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ie,de,Re,st){return nn.registerAuthenticationProvider(ie,de,Re,st)}},In={registerCommand(ie,de,Re){return dt.registerCommand(!0,ie,de,Re)},registerTextEditorCommand(ie,de,Re){return dt.registerCommand(!0,ie,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Fe.warn("Cannot execute "+ie+" because there is no active text editor.");return}return wt.edit(Ct=>{de.apply(Re,[wt,Ct,...st])}).then(Ct=>{Ct||Fe.warn("Edits from command "+ie+" were not applied.")},Ct=>{Fe.warn("An error occurred while running command "+ie,Ct)})})},registerDiffInformationCommand:(ie,de,Re)=>((0,$.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,ie,async(...st)=>{const wt=ft.activeEditor(!0);if(!wt){Fe.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);de.apply(Re,[Ct,...st])})),executeCommand(ie,...de){return dt.executeCommand(ie,...de)},getCommands(ie=!1){return dt.getCommands(ie)}},gn={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){return Je.environment.appRoot?.fsPath??""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return on.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,de){return ut.openUri(ie,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Je.environment.appUriScheme)return Vt.createAppUri(ie);try{return await ut.asExternalUri(ie,{allowTunneling:!!Je.remote.authority})}catch(de){if((0,_e.matchesScheme)(ie,we.Schemas.http)||(0,_e.matchesScheme)(ie,we.Schemas.https))return ie;throw de}},get remoteName(){return(0,ye.getRemoteName)(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Je.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Pn={createTestController(ie,de){return zt.createTestController(ie,de)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Ne),zt.createTestObserver()},runTests(ie){return(0,$.checkProposedApiEnabled)(Ne),zt.runTests(ie)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Ne),zt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Ne),zt.results}},ln={getExtension(ie){const de=$t.getExtensionDescription(ie);if(de)return new s.Extension(bt,Ne.identifier,de,pn)},get all(){return $t.getAllExtensionDescriptions().map(ie=>new s.Extension(bt,Ne.identifier,ie,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(ie){return xt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:ie=>xt.getDiagnostics(ie),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(ie,de){return Kt.changeLanguage(ie.uri,de)},match(ie,de){return(0,i.score)(x.LanguageSelector.from(ie),de.uri,de.languageId,!0)},registerCodeActionsProvider(ie,de,Re){return ht.registerCodeActionProvider(Ne,pt(ie),de,Re)},registerCodeLensProvider(ie,de){return ht.registerCodeLensProvider(Ne,pt(ie),de)},registerDefinitionProvider(ie,de){return ht.registerDefinitionProvider(Ne,pt(ie),de)},registerDeclarationProvider(ie,de){return ht.registerDeclarationProvider(Ne,pt(ie),de)},registerImplementationProvider(ie,de){return ht.registerImplementationProvider(Ne,pt(ie),de)},registerTypeDefinitionProvider(ie,de){return ht.registerTypeDefinitionProvider(Ne,pt(ie),de)},registerHoverProvider(ie,de){return ht.registerHoverProvider(Ne,pt(ie),de,Ne.identifier)},registerEvaluatableExpressionProvider(ie,de){return ht.registerEvaluatableExpressionProvider(Ne,pt(ie),de,Ne.identifier)},registerInlineValuesProvider(ie,de){return ht.registerInlineValuesProvider(Ne,pt(ie),de,Ne.identifier)},registerDocumentHighlightProvider(ie,de){return ht.registerDocumentHighlightProvider(Ne,pt(ie),de)},registerLinkedEditingRangeProvider(ie,de){return ht.registerLinkedEditingRangeProvider(Ne,pt(ie),de)},registerReferenceProvider(ie,de){return ht.registerReferenceProvider(Ne,pt(ie),de)},registerRenameProvider(ie,de){return ht.registerRenameProvider(Ne,pt(ie),de)},registerDocumentSymbolProvider(ie,de,Re){return ht.registerDocumentSymbolProvider(Ne,pt(ie),de,Re)},registerWorkspaceSymbolProvider(ie){return ht.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,de){return ht.registerDocumentFormattingEditProvider(Ne,pt(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return ht.registerDocumentRangeFormattingEditProvider(Ne,pt(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Re,...st){return ht.registerOnTypeFormattingEditProvider(Ne,pt(ie),de,[Re].concat(st))},registerDocumentSemanticTokensProvider(ie,de,Re){return ht.registerDocumentSemanticTokensProvider(Ne,pt(ie),de,Re)},registerDocumentRangeSemanticTokensProvider(ie,de,Re){return ht.registerDocumentRangeSemanticTokensProvider(Ne,pt(ie),de,Re)},registerSignatureHelpProvider(ie,de,Re,...st){return typeof Re=="object"?ht.registerSignatureHelpProvider(Ne,pt(ie),de,Re):ht.registerSignatureHelpProvider(Ne,pt(ie),de,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(ie,de,...Re){return ht.registerCompletionItemProvider(Ne,pt(ie),de,Re)},registerInlineCompletionItemProvider(ie,de){return(0,$.checkProposedApiEnabled)(Ne),ht.registerInlineCompletionsProvider(Ne,pt(ie),de)},registerDocumentLinkProvider(ie,de){return ht.registerDocumentLinkProvider(Ne,pt(ie),de)},registerColorProvider(ie,de){return ht.registerColorProvider(Ne,pt(ie),de)},registerFoldingRangeProvider(ie,de){return ht.registerFoldingRangeProvider(Ne,pt(ie),de)},registerSelectionRangeProvider(ie,de){return ht.registerSelectionRangeProvider(Ne,ie,de)},registerCallHierarchyProvider(ie,de){return ht.registerCallHierarchyProvider(Ne,ie,de)},setLanguageConfiguration:(ie,de)=>ht.setLanguageConfiguration(Ne,ie,de),getTokenInformationAtPosition(ie,de){return(0,$.checkProposedApiEnabled)(Ne),Kt.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return(0,$.checkProposedApiEnabled)(Ne),ht.registerInlayHintsProvider(Ne,ie,de)},registerTypeHierarchyProvider(ie,de){return(0,$.checkProposedApiEnabled)(Ne),ht.registerTypeHierarchyProvider(Ne,ie,de)},createLanguageStatusItem(ie){return(0,$.checkProposedApiEnabled)(Ne),Kt.createLanguageStatusItem(ie)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ie,de,Re){const st=await(T.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(st,de,Re)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,de,Re){return Pt.onDidChangeActiveTextEditor(ie,de,Re)},onDidChangeVisibleTextEditors(ie,de,Re){return Pt.onDidChangeVisibleTextEditors(ie,de,Re)},onDidChangeTextEditorSelection(ie,de,Re){return Pt.onDidChangeTextEditorSelection(ie,de,Re)},onDidChangeTextEditorOptions(ie,de,Re){return Pt.onDidChangeTextEditorOptions(ie,de,Re)},onDidChangeTextEditorVisibleRanges(ie,de,Re){return Pt.onDidChangeTextEditorVisibleRanges(ie,de,Re)},onDidChangeTextEditorViewColumn(ie,de,Re){return Pt.onDidChangeTextEditorViewColumn(ie,de,Re)},onDidCloseTerminal(ie,de,Re){return vt.onDidCloseTerminal(ie,de,Re)},onDidOpenTerminal(ie,de,Re){return vt.onDidOpenTerminal(ie,de,Re)},onDidChangeActiveTerminal(ie,de,Re){return vt.onDidChangeActiveTerminal(ie,de,Re)},onDidChangeTerminalDimensions(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),vt.onDidChangeTerminalDimensions(ie,de,Re)},onDidWriteTerminalData(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),vt.onDidWriteTerminalData(ie,de,Re)},get state(){return ut.state},onDidChangeWindowState(ie,de,Re){return ut.onDidChangeWindowState(ie,de,Re)},showInformationMessage(ie,...de){return an.showMessage(Ne,S.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return an.showMessage(Ne,S.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return an.showMessage(Ne,S.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Re){return Ot.showQuickPick(ie,!!Ne.enableProposedApi,de,Re)},showWorkspaceFolderPick(ie){return Ot.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Ot.showInput(ie,de)},showOpenDialog(ie){return Bt.showOpenDialog(ie)},showSaveDialog(ie){return Bt.showSaveDialog(ie)},createStatusBarItem(ie,de,Re){let st,wt,Ct;return typeof ie=="string"?(st=ie,wt=de,Ct=Re):(wt=ie,Ct=de),Lt.createStatusBarEntry(Ne,st,wt,Ct)},setStatusBarMessage(ie,de){return Lt.setStatusBarMessage(ie,de)},withScmProgress(ie){return Ke.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),hn.withProgress(Ne,{location:F.ProgressLocation.SourceControl},(de,Re)=>ie({report(st){}}))},withProgress(ie,de){return hn.withProgress(Ne,ie,de)},createOutputChannel(ie){return bn.createOutputChannel(ie,Ne)},createWebviewPanel(ie,de,Re,st){return sn.createWebviewPanel(Ne,ie,de,Re,st)},createWebviewTextEditorInset(ie,de,Re,st){return(0,$.checkProposedApiEnabled)(Ne),en.createWebviewEditorInset(ie,de,Re,st,Ne)},createTerminal(ie,de,Re){return typeof ie=="object"?(ie.color&&(0,$.checkProposedApiEnabled)(Ne),"pty"in ie?vt.createExtensionTerminal(ie):vt.createTerminalFromOptions(ie)):vt.createTerminal(ie,de,Re)},registerTerminalLinkProvider(ie){return vt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return vt.registerProfileProvider(Ne,ie,de)},registerTreeDataProvider(ie,de){return dn.registerTreeDataProvider(ie,de,Ne)},createTreeView(ie,de){return dn.createTreeView(ie,de,Ne)},registerWebviewPanelSerializer:(ie,de)=>sn.registerWebviewPanelSerializer(Ne,ie,de),registerCustomEditorProvider:(ie,de,Re={})=>Sn.registerCustomEditorProvider(Ne,ie,de,Re),registerFileDecorationProvider(ie){return Dt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return Vt.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Ot.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Ot.createInputBox(Ne.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Re){return fn.onDidChangeActiveColorTheme(ie,de,Re)},registerWebviewViewProvider(ie,de,Re){return yn.registerWebviewViewProvider(Ne,ie,de,Re?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Ne),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),gt.onDidChangeActiveNotebookEditor(ie,de,Re)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),Wt.onDidChangeNotebookEditorSelection(ie,de,Re)},onDidChangeNotebookEditorVisibleRanges(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),Wt.onDidChangeNotebookEditorVisibleRanges(ie,de,Re)},showNotebookDocument(ie,de){return(0,$.checkProposedApiEnabled)(Ne),gt.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),Gt.registerExternalUriOpener(Ne.identifier,ie,de,Re)},get openEditors(){return(0,$.checkProposedApiEnabled)(Ne),kt.tabs},get onDidChangeOpenEditors(){return(0,$.checkProposedApiEnabled)(Ne),kt.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,$.checkProposedApiEnabled)(Ne),h.InlineCompletionController.get(ie)}},vn={get rootPath(){return Ke.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(ie){throw R.readonly()},getWorkspaceFolder(ie){return ot.getWorkspaceFolder(ie)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(ie){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(ie){throw R.readonly()},updateWorkspaceFolders:(ie,de,...Re)=>ot.updateWorkspaceFolders(Ne,ie,de||0,...Re),onDidChangeWorkspaceFolders:function(ie,de,Re){return ot.onDidChangeWorkspace(ie,de,Re)},asRelativePath:(ie,de)=>ot.getRelativePath(ie,de),findFiles:(ie,de,Re,st)=>ot.findFiles(x.GlobPattern.from(ie),x.GlobPattern.from(de),Re,Ne.identifier,st),findTextInFiles:(ie,de,Re,st)=>{let wt,Ct;return typeof de=="object"?(wt=de,Ct=Re):(wt={},Ct=de,st=Re),ot.findTextInFiles(ie,wt||{},Ct,Ne.identifier,st)},saveAll:ie=>ot.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,de,Re,st)=>Mt.createFileSystemWatcher(x.GlobPattern.from(ie),de,Re,st),get textDocuments(){return _t.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw R.readonly()},openTextDocument(ie){let de;const Re=ie;if(typeof ie=="string")de=Promise.resolve(T.URI.file(ie));else if(T.URI.isUri(ie))de=Promise.resolve(ie);else if(!Re||typeof Re=="object")de=_t.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ie,de,Re)=>_t.onDidAddDocument(ie,de,Re),onDidCloseTextDocument:(ie,de,Re)=>_t.onDidRemoveDocument(ie,de,Re),onDidChangeTextDocument:(ie,de,Re)=>_t.onDidChangeDocument(ie,de,Re),onDidSaveTextDocument:(ie,de,Re)=>_t.onDidSaveDocument(ie,de,Re),onWillSaveTextDocument:(ie,de,Re)=>Yt.getOnWillSaveTextDocumentEvent(Ne)(ie,de,Re),get notebookDocuments(){return gt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Re;if(T.URI.isUri(ie))Re=ie,await gt.openNotebookDocument(ie);else if(typeof ie=="string")Re=T.URI.revive(await gt.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,de,Re,st){return gt.registerNotebookSerializer(Ne,ie,de,Re,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ie,de,Re,st)=>((0,$.checkProposedApiEnabled)(Ne),gt.registerNotebookContentProvider(Ne,ie,de,Re,Ne.enableProposedApi?st:void 0)),onDidChangeConfiguration:(ie,de,Re)=>mn.onDidChangeConfiguration(ie,de,Re),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,mn.getConfiguration(ie,de,Ne)},registerTextDocumentContentProvider(ie,de){return Xt.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(Ke.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ne,ie,de)),registerFileSystemProvider(ie,de,Re){return tn.registerFileSystemProvider(Ne.identifier,ie,de,Re,Ne.enableProposedApi)},get fs(){return mt.value},registerFileSearchProvider:(ie,de)=>((0,$.checkProposedApiEnabled)(Ne),Tt.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,$.checkProposedApiEnabled)(Ne),Tt.registerTextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,$.checkProposedApiEnabled)(Ne),bt.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,$.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,de,Re)=>Mt.onDidCreateFile(ie,de,Re),onDidDeleteFiles:(ie,de,Re)=>Mt.onDidDeleteFile(ie,de,Re),onDidRenameFiles:(ie,de,Re)=>Mt.onDidRenameFile(ie,de,Re),onWillCreateFiles:(ie,de,Re)=>Mt.getOnWillCreateFileEvent(Ne)(ie,de,Re),onWillDeleteFiles:(ie,de,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(ie,de,Re),onWillRenameFiles:(ie,de,Re)=>Mt.getOnWillRenameFileEvent(Ne)(ie,de,Re),openTunnel:ie=>((0,$.checkProposedApiEnabled)(Ne),tt.openTunnel(Ne,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,$.checkProposedApiEnabled)(Ne),tt.getTunnels()},onDidChangeTunnels:(ie,de,Re)=>((0,$.checkProposedApiEnabled)(Ne),tt.onDidChangeTunnels(ie,de,Re)),registerPortAttributesProvider:(ie,de)=>((0,$.checkProposedApiEnabled)(Ne),tt.registerPortsAttributesProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,$.checkProposedApiEnabled)(Ne),rn.registerTimelineProvider(ie,de,Ne.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:ie=>((0,$.checkProposedApiEnabled)(Ne),ot.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Re)=>ot.onDidGrantWorkspaceTrust(ie,de,Re)},Rn={get inputBox(){return Ke.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Ne)},createSourceControl(ie,de,Re){return qt.createSourceControl(Ne,ie,de,Re)}},Ln={createCommentController(ie,de){return En.createCommentController(Ne,ie,de)}},Fn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(ie,de,Re){return Et.onDidStartDebugSession(ie,de,Re)},onDidTerminateDebugSession(ie,de,Re){return Et.onDidTerminateDebugSession(ie,de,Re)},onDidChangeActiveDebugSession(ie,de,Re){return Et.onDidChangeActiveDebugSession(ie,de,Re)},onDidReceiveDebugSessionCustomEvent(ie,de,Re){return Et.onDidReceiveDebugSessionCustomEvent(ie,de,Re)},onDidChangeBreakpoints(ie,de,Re){return Et.onDidChangeBreakpoints(ie,de,Re)},registerDebugConfigurationProvider(ie,de,Re){return Et.registerDebugConfigurationProvider(ie,de,Re||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return Et.registerDebugAdapterDescriptorFactory(Ne,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return Et.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Et.startDebugging(ie,de,{parentSession:Re}):Et.startDebugging(ie,de,Re||{})},stopDebugging(ie){return Et.stopDebugging(ie)},addBreakpoints(ie){return Et.addBreakpoints(ie)},removeBreakpoints(ie){return Et.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return Et.asDebugSourceUri(ie,de)}},Mn={registerTaskProvider:(ie,de)=>It.registerTaskProvider(Ne,ie,de),fetchTasks:ie=>It.fetchTasks(ie),executeTask:ie=>It.executeTask(Ne,ie),get taskExecutions(){return It.taskExecutions},onDidStartTask:(ie,de,Re)=>It.onDidStartTask(ie,de,Re),onDidEndTask:(ie,de,Re)=>It.onDidEndTask(ie,de,Re),onDidStartTaskProcess:(ie,de,Re)=>It.onDidStartTaskProcess(ie,de,Re),onDidEndTaskProcess:(ie,de,Re)=>It.onDidEndTaskProcess(ie,de,Re)},On={createNotebookController(ie,de,Re,st,wt){return Jt.createNotebookController(Ne,ie,de,Re,st,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>gt.registerNotebookCellStatusBarItemProvider(Ne,ie,de),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Ne),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,$.checkProposedApiEnabled)(Ne),Wt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return Zt.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookDocumentMetadata(ie,de,Re)},onDidChangeNotebookCells(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCells(ie,de,Re)},onDidChangeNotebookCellExecutionState(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCellExecutionState(ie,de,Re)},onDidChangeCellOutputs(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),gt.onDidChangeCellOutputs(ie,de,Re)},onDidChangeCellMetadata(ie,de,Re){return(0,$.checkProposedApiEnabled)(Ne),gt.onDidChangeCellMetadata(ie,de,Re)},createConcatTextDocument(ie,de){return(0,$.checkProposedApiEnabled)(Ne),new Ee.ExtHostNotebookConcatDocument(gt,_t,ie,de)}};return{version:Je.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:ln,languages:An,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:A.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:u.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:be.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(me[274],ge([0,1,79,65,36,131,37,52,43,33,69,53,71,92,51,64,132,91,62,90,122,50]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,p.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,p.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,p.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,p.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,p.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,p.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,p.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,p.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,p.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,p.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,p.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,p.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,p.registerSingleton)(c.IExtHostTunnelService,c.ExtHostTunnelService),(0,p.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,p.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,p.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,p.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,p.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(me[93],ge([0,1,20,12,31,68]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function C(I,u,m,c){const v=(0,p.mapArrayOrNot)(m,y),_=new D.TextSearchMatch(u,v,c),b=_.preview.matches;return{ranges:(0,p.mapArrayOrNot)(v,A),uri:I,preview:{text:_.preview.text,matches:(0,p.mapArrayOrNot)(b,A)}}}e.createTextSearchResult=C;function y(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function A(I){return new S.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(u,m){this.prefix=u,this.logService=m}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};i=Ve([$e(1,R.ILogService)],i),e.OutputChannel=i}),define(me[275],ge([0,1,95,23]),function(J,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,T=512,C=512*8,y=512*128;class A{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((a,h)=>{J(["iconv-lite-umd"],a,h)})).getDecoder(m(r));else{const n=new TextDecoder;s={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new A(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function i(t,r){const s=r.minBytesRequiredForDetection??r.guessEncoding?C:T;return new Promise((n,a)=>{const h=(0,p.newWriteableStream)(k=>k.join("")),f=[];let w=0,E;const o=async()=>{try{const k=await g({buffer:R.VSBuffer.concat(f),bytesRead:w},r.guessEncoding);k.encoding=await r.overwriteEncoding(k.encoding),E=await A.create(k.encoding);const L=E.write(R.VSBuffer.concat(f).buffer);h.write(L),f.length=0,w=0,n({stream:h,detected:k})}catch(k){a(k)}};(0,p.listenStream)(t,{onData:async k=>{E?h.write(E.write(k.buffer)):(f.push(k),w+=k.byteLength,w>=s&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:k=>h.error(k),onEnd:async()=>{E||await o(),h.end(E?.end())}})})}e.toDecodeStream=i;async function I(t,r,s){const a=(await new Promise((w,E)=>{J(["iconv-lite-umd"],w,E)})).getEncoder(m(r),s);let h=!1,f=!1;return{read(){if(f)return null;const w=t.read();if(typeof w!="string"){if(f=!0,!h&&s?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=a.end();return E&&E.length>0?(h=!0,R.VSBuffer.wrap(E)):null}return h=!0,R.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=I;async function u(t){return(await new Promise((s,n)=>{J(["iconv-lite-umd"],s,n)})).encodingExists(m(t))}e.encodingExists=u;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function c(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const v=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((f,w)=>{J(["jschardet"],f,w)}),s=t.slice(0,y),n=l(s.buffer),a=r.detect(n);if(!a||!a.encoding)return null;const h=a.encoding.toLowerCase();return 0<=v.indexOf(h)?null:P(a.encoding)}const b={ibm866:"cp866",big5:"cp950"};function P(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[r]||r}function l(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function d(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=d;function g({buffer:t,bytesRead:r},s){let n=c(t,r),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let h=!0,f=!0,w=!1;for(let E=0;E<r&&E<S;E++){const o=E%2==1,k=t.readUInt8(E)===0;if(k&&(w=!0),h&&(o&&!k||!o&&k)&&(h=!1),f&&(o&&k||!o&&!k)&&(f=!1),k&&!h&&!f)break}w&&(h?n=e.UTF16le:f?n=e.UTF16be:a=!0)}return s&&!a&&!n&&t?_(t.slice(0,r)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,275,28,133]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends D.TextSearchManager{constructor(C,y,A=R){super(C,y,{readdir:i=>A.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,p.toCanonicalName)(i)})}}e.NativeTextSearchManager=S}),define(me[276],ge([0,1,277,292,293,2,294]),function(J,e,p,R,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,u,m,c,v,_){const b=_.environment.useHostProxy,P=typeof b=="boolean"?b:!_.remote.isRemote,l=(0,T.createProxyResolver)({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(g,t,...r)=>{switch(g){case T.LogLevel.Trace:c.trace(t,...r);break;case T.LogLevel.Debug:c.debug(t,...r);break;case T.LogLevel.Info:c.info(t,...r);break;case T.LogLevel.Warning:c.warn(t,...r);break;case T.LogLevel.Error:c.error(t,...r);break;case T.LogLevel.Critical:c.critical(t,...r);break;case T.LogLevel.Off:break;default:s(g,t,r);break}function s(n,a,...h){c.error("Unknown log level",n),c.error(a,...h)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:g=>{v.$publicLog2("resolveProxy",g)},useHostProxy:P,env:process.env}),d=y(u,l);return i(m,d)}e.connectProxyResolver=C;function y(I,u){const m={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(v=>{m.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(v=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,(0,T.createHttpPatch)(p,u,{config:"off"},c,!0)),on:Object.assign({},p,(0,T.createHttpPatch)(p,u,{config:"on"},c,!0)),override:Object.assign({},p,(0,T.createHttpPatch)(p,u,{config:"override"},c,!0)),onRequest:Object.assign({},p,(0,T.createHttpPatch)(p,u,m,c,!0)),default:Object.assign(p,(0,T.createHttpPatch)(p,u,m,c,!1))},https:{off:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"off"},c,!0)),on:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"on"},c,!0)),override:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"override"},c,!0)),onRequest:Object.assign({},R,(0,T.createHttpPatch)(R,u,m,c,!0)),default:Object.assign(R,(0,T.createHttpPatch)(R,u,m,c,!1))},tls:Object.assign(D,(0,T.createTlsPatch)(D))}}const A=new Map;function i(I,u){return I.getExtensionPathIndex().then(m=>{const c=J.__$__nodeRequire("module"),v=c._load;c._load=function(b,P,l){if(b==="tls")return u.tls;if(b!=="http"&&b!=="https")return v.apply(this,arguments);const d=u[b],g=m.findSubstr(S.URI.file(P.filename).fsPath);let t=A.get(g);if(t||A.set(g,t={}),!t[b]){let r=d.default;g&&g.enableProposedApi&&(r=d[g.proxySupport]||d.onRequest),t[b]={...r}}return t[b]}})}}),define(me[278],ge([0,1,39,9,76,29,11,8,93,279]),function(J,e,p,R,D,S,T,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,d,g,t){const r=u(l,d,g,t),s=d.folder.fsPath;return{cmd:p.spawn(i,r.args,{cwd:s}),rgDiskPath:i,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=I;function u(l,d,g,t){const r=["--files","--hidden","--case-sensitive"];c([d],g,!1).forEach(n=>{const a=(0,y.anchorGlob)(n);if(r.push("-g",a),T.isMacintosh){const h=(0,D.normalizeNFD)(a);h!==a&&r.push("-g",h)}});const s=m([d],t,void 0,!1);return s.globArgs.forEach(n=>{const a=`!${(0,y.anchorGlob)(n)}`;if(r.push("-g",a),T.isMacintosh){const h=(0,D.normalizeNFD)(a);h!==a&&r.push("-g",h)}}),d.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),d.ignoreSymlinks||r.push("--follow"),l.exists&&r.push("--quiet"),r.push("--no-config"),d.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function m(l,d,g,t=!0){const r=[];let s={};return l.forEach(n=>{const a=Object.assign({},n.excludePattern||{},d||{}),h=v(a,t?n.folder.fsPath:void 0,g);r.push(...h.globArgs),h.siblingClauses&&(s=Object.assign(s,h.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=m;function c(l,d,g=!0){const t=[];return l.forEach(r=>{const s=Object.assign({},d||{},r.includePattern||{}),n=v(s,g?r.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function v(l,d,g){const t=[],r={};return Object.keys(l).forEach(s=>{if(g&&g.has(s)||!s)return;const n=l[s];s=b(d?_(d,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(P(s))):n&&n.when&&(r[s]=n)}),{globArgs:t,siblingClauses:r}}function _(l,d){return R.isAbsolute(d)?d:R.join(l,d)}e.getAbsoluteGlob=_;function b(l){return l=C.rtrim(l,"\\"),C.rtrim(l,"/")}function P(l){return S.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=P}),define(me[280],ge([0,1,39,47,9,103,20,60,30,76,29,11,44,8,14,28,31,278,100]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(s=>s())});class d{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&y.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,P.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&y.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),f=a.folder.fsPath;n.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==f).forEach(w=>{(0,i.isEqualOrParent)(w,f)&&(h[D.relative(f,w)]=!0)}),this.folderExcludePatterns.set(f,new t(h,f))})}cancel(){this.isCanceled=!0}walk(n,a,h,f,w){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);a.forEach(E=>{const o=D.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,o)||this.matchFile(h,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(n,(E,o)=>{this.call(this.cmdTraversal,this,E,h,f,k=>{if(k){const L=(0,C.toErrorMessage)(k);console.error(L),this.errors.push(L),o(k,void 0)}else o(null,void 0)})},(E,o)=>{this.fileWalkSW.stop();const k=E?T.coalesce(E)[0]:null;w(k,this.isLimitHit)})}parallel(n,a,h){const f=new Array(n.length),w=new Array(n.length);let E=!1,o=0;if(n.length===0)return h(null,[]);n.forEach((k,L)=>{a(k,(N,V)=>{if(N?(E=!0,f[L]=null,w[L]=N):(f[L]=V,w[L]=null),++o===n.length)return h(E?w:null,f)})})}call(n,a,...h){try{n.apply(a,h)}catch(f){h[h.length-1](f)}}cmdTraversal(n,a,h,f){const w=n.folder.fsPath,E=I.isMacintosh;let o;const k=()=>o&&o.kill();l.add(k);let L=F=>{l.delete(k),L=()=>{},f(F)},N="";const V=this.initDirectoryTree();let ee;const z=(0,b.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);o=z.cmd,ee=!Object.keys(z.siblingClauses).length;const M=z.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${z.rgDiskPath} ${M}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:x}),this.cmdResultCount=0,this.collectStdout(o,"utf8",h,(F,q,U)=>{if(F){L(F);return}if(this.isLimitHit){L();return}const G=(N+(E?A.normalizeNFC(q||""):q)).split(`
`);if(U){const $=G.length;G[$-1]=G[$-1].trim(),G[$-1]||G.pop()}else N=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,ee){for(const $ of G)if(this.matchFile(a,{base:w,relativePath:$,searchPath:this.getSearchPath(n,$)}),this.isLimitHit){k();break}(U||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,V,w,G,a),U&&(this.matchDirectoryTree(V,w,a),L())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),h=a.getBasenameTerms(),f=a.getPathTerms(),w=["-L","."];if(h.length||f.length){w.push("-not","(","(");for(const E of h)w.push("-name",E),w.push("-o");for(const E of f)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),p.spawn("find",w,{cwd:n.folder.fsPath})}readStdout(n,a,h){let f="";this.collectStdout(n,a,()=>{},(w,E,o)=>{if(w){h(w);return}f+=E,o&&h(null,f)})}collectStdout(n,a,h,f){let w=(k,L,N)=>{(k||N)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),f(k,L,N)},E=!1;n.stdout?(this.forwardData(n.stdout,a,w),n.stdout.once("data",()=>E=!0)):h({message:"stdout is null"});let o;n.stderr?o=this.collectData(n.stderr):h({message:"stderr is null"}),n.on("error",k=>{w(k)}),n.on("close",k=>{let L;!E&&(L=this.decodeData(o,a))&&r(L)?w(new Error(`command failed with error code ${k}: ${this.decodeData(o,a)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(n,a,h){const f=new S.StringDecoder(a);return n.on("data",w=>{h(null,f.write(w))}),f}collectData(n){const a=[];return n.on("data",h=>{a.push(h)}),a}decodeData(n,a){const h=new S.StringDecoder(a);return n.map(f=>h.write(f)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},h,f,w){f.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const E=o=>{const k=D.basename(o),L=D.dirname(o);let N=a[L];N||(N=a[L]=[],E(L)),N.push({base:h,relativePath:o,basename:k,searchPath:this.getSearchPath(n,o)})};f.forEach(E)}matchDirectoryTree({rootEntries:n,pathToEntries:a},h,f){const w=this,E=this.folderExcludePatterns.get(h),o=this.filePattern;function k(L){w.directoriesWalked++;const N=y.hasSiblingFn(()=>L.map(V=>V.basename));for(let V=0,ee=L.length;V<ee;V++){const z=L[V],{relativePath:M,basename:x}=z;if(E.test(M,x,o!==x?N:void 0))continue;const F=a[M];if(F)k(F);else{if(w.filesWalked++,M===o)continue;w.matchFile(f,z)}if(w.isLimitHit)break}}k(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,h,f,w){const E=n.folder,o=y.hasSiblingFn(()=>h);this.parallel(h,(k,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const N=a?[a,k].join(D.sep):k;if(this.folderExcludePatterns.get(n.folder.fsPath).test(N,k,this.config.filePattern!==k?o:void 0))return L(null);const V=[E.fsPath,N].join(D.sep);R.lstat(V,(ee,z)=>{if(ee||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(V,z,(M,x)=>M||this.isCanceled||this.isLimitHit?L(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(V,z,(F,q)=>F||this.isCanceled||this.isLimitHit||(q=q||"",this.walkedPaths[q])?L(null):(this.walkedPaths[q]=!0,v.Promises.readdir(V).then(U=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,N,U,f,O=>L(O||null))},U=>{L(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&c.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(f,{base:E.fsPath,relativePath:N,searchPath:this.getSearchPath(n,N)}),L(null,void 0)))})},k=>{const L=k&&T.coalesce(k);return w(L&&L.length>0?L[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,D.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,h){return a.isSymbolicLink()?R.stat(n,h):h(null,a)}realPathIfNeeded(n,a,h){return a.isSymbolicLink()?R.realpath(n,(f,w)=>f?h(f):h(null,w)):h(null,n)}getSearchPath(n,a){return n.folderName?D.join(n.folderName,a):a}}e.FileWalker=d;class g{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new d(n)}search(n,a,h){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(f,w)=>{h(f,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,h;Object.keys(n).filter(f=>n[f]).forEach(f=>{D.isAbsolute(f)?(a=a||y.getEmptyExpression(),a[f]=n[f]):(h=h||y.getEmptyExpression(),h[f]=n[f])}),this.absoluteParsedExpr=a&&y.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=h&&y.parse(h,{trimForExclusions:!0})}test(n,a,h){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,n),a,h)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...y.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...y.getPathTerms(this.relativeParsedExpr)),n}}function r(s){const n=s.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=r}),define(me[135],ge([0,1,39,295,103,20,55,30,9,8,2,31,68,296,279,93]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,o,k,L){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise((N,V)=>{L.onCancellationRequested(()=>O());const ee=r(E,o),z=o.folder.fsPath,M=ee.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${_} ${M}
 - cwd: ${z}`);let x=p.spawn(_,ee,{cwd:z});x.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),V((0,I.serializeSearchError)(new I.SearchError(fe&&fe.message,I.SearchErrorCode.rgProcessError)))});let F=!1;const q=new d(o.maxResults,z,o.previewOptions);q.on("result",fe=>{F=!0,$="",k.report(fe)});let U=!1;const O=()=>{U=!0,x&&x.kill(),q&&q.cancel()};let G=!1;q.on("hitLimit",()=>{G=!0,O()});let $="";x.stdout.on("data",fe=>{q.handleData(fe),F||($+=fe)});let K=!1;x.stdout.once("data",()=>K=!0);let re="";x.stderr.on("data",fe=>{const ye=fe.toString();this.outputChannel.appendLine(ye),re+=ye}),x.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),U)N({limitHit:G});else{q.flush(),x=null;let fe;re&&!K&&(fe=P(re))?V((0,I.serializeSearchError)(new I.SearchError(fe.message,fe.code))):N({limitHit:G})}})})}}e.RipgrepTextSearchEngine=b;function P(w){const E=w.split(`
`),o=E[0].trim();if(E.some(L=>L.startsWith("regex parse error")))return new I.SearchError(l(E),I.SearchErrorCode.regexParseError);const k=o.match(/grep config error: unknown encoding: (.*)/);if(k)return new I.SearchError(`Unknown encoding: ${k[1]}`,I.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(o,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=P;function l(w){const E=["Regex parse error"],o=w.filter(k=>k.startsWith("PCRE2:"));if(o.length>=1){const k=o[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const L=k.split(":")[1];E.push(":"+L)}}return E.join("")}e.buildRegexParseError=l;class d extends R.EventEmitter{constructor(E,o,k){super();this.maxResults=E,this.rootFolder=o,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,o){return super.on(E,o),this}handleData(E){if(this.isDone)return;const o=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(o)}handleDecodedData(E){let o=E.indexOf(`
`);const k=this.remainder+E;if(o>=0)o+=this.remainder.length;else{this.remainder=k;return}let L=0;for(;o>=0;)this.handleLine(k.substring(L,o).trim()),L=o+1,o=k.indexOf(`
`,L);this.remainder=k.substring(L)}handleLine(E){if(this.isDone||!E)return;let o;try{o=JSON.parse(E)}catch(k){throw new Error(`malformed line from rg: ${E}`)}if(o.type==="match"){const k=g(o.data.path),L=i.URI.file(y.join(this.rootFolder,k)),N=this.createTextSearchMatch(o.data,L);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const k=g(o.data.path),L=i.URI.file(y.join(this.rootFolder,k));this.createTextSearchContext(o.data,L).forEach(V=>this.onResult(V))}}createTextSearchMatch(E,o){const k=E.line_number-1,L=g(E.lines),N=Buffer.from(L);let V=0,ee=0,z=k;E.submatches.length===0&&E.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const M=(0,S.coalesce)(E.submatches.map((x,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const q=g(x.match),U=N.slice(V,x.start).toString().length,O=ee+U,G=t(q),$=z,K=G.numLines+$,re=G.numLines>0?G.lastLineLength:G.lastLineLength+O;return V=x.end,ee=re,z=K,new u.Range($,O,K,re)}));return(0,v.createTextSearchResult)(o,L,M,this.previewOptions)}createTextSearchContext(E,o){const k=g(E.lines),L=E.line_number;return k.replace(/\r?\n$/,"").split(`
`).map((N,V)=>({text:N,uri:o,lineNumber:L+V}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=d;function g(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let o=0,k=-1,L;for(;L=E.exec(w);)o++,k=L.index;const N=k>=0?w.length-k-1:w.length;return{numLines:o,lastLineLength:N}}function r(w,E){const o=["--hidden"];o.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:L}=(0,T.groupBy)(E.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const V=new Set;L.forEach(ee=>{V.add(ee)}),o.push("-g","!*"),V.forEach(ee=>{s(ee).map(v.anchorGlob).forEach(z=>{o.push("-g",z)})})}k&&k.length&&k.forEach(V=>{o.push("-g",V)}),E.excludes.map(v.anchorGlob).forEach(V=>o.push("-g",`!${V}`)),E.maxFileSize&&o.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),E.followSymlinks&&o.push("--follow"),E.encoding&&E.encoding!=="utf8"&&o.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,A.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),w.isRegExp&&(w.pattern=n(w.pattern),o.push("--auto-hybrid-regex"));let N;if(w.isWordMatch){const ee=(0,A.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",ee)}else if(w.isRegExp){let V=h(w.pattern);V=f(V),o.push("--regexp",V)}else N=w.pattern,o.push("--fixed-strings");return o.push("--no-config"),E.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),w.isMultiline&&o.push("--multiline"),E.beforeContext&&o.push("--before-context",E.beforeContext+""),E.afterContext&&o.push("--after-context",E.afterContext+""),o.push("--"),N&&o.push(N),o.push("."),o}function s(w){const E=(0,C.splitGlobAware)(w,"/");return E.map((o,k)=>E.slice(0,k+1).join("/"))}e.spreadGlobComponents=s;function n(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(o);)w=w.replace(o,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=n;const a=w=>w.type==="Assertion"&&w.kind==="lookbehind";function h(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let o="",k=0;const L=(ee,z,M)=>{o+=w.slice(k,ee)+M,k=z},N=[];return new m.RegExpVisitor({onCharacterEnter(ee){if(ee.raw!=="\\n")return;const z=N[0];if(!z)L(ee.start,ee.end,"\\r?\\n");else if(!N.some(a))if(z.type==="CharacterClass")if(z.negate){const M=w.slice(z.start+2,ee.start)+w.slice(ee.end,z.end-1);L(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=w.slice(z.start+1,ee.start)+w.slice(ee.end,z.end-1);L(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&L(ee.start,ee.end,"(?:\\r?\\n)")},onQuantifierEnter(ee){N.unshift(ee)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(ee){N.unshift(ee)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(ee){N.unshift(ee)},onCharacterClassLeave(){N.shift()},onAssertionEnter(ee){a(ee)&&N.push(ee)},onAssertionLeave(ee){N[0]===ee&&N.shift()}}).visit(E),o+=w.slice(k),o}e.fixRegexNewline=h;function f(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(me[281],ge([0,1,21,135,118,10]),function(J,e,p,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,i,I,u){const m=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const c={...i,folder:i.folder.with({scheme:S.Schemas.file})},v=new D.Progress(_=>I.report({..._,uri:_.uri.with({scheme:i.folder.scheme})}));return this.withToken(u,_=>m.provideTextSearchResults(A,c,v,_))}else return this.withToken(u,c=>m.provideTextSearchResults(A,i,I,c))}async withToken(A,i){const I=C(A);this.inProgress.add(I);const u=await i(I.token);return this.inProgress.delete(I),u}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function C(y){const A=new p.CancellationTokenSource;return y.onCancellationRequested(()=>A.cancel()),A}}),define(me[282],ge([0,1,28,135,134]),function(J,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(y){this.query=y}search(y,A,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(m){i({message:m})}},u=new D.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),p);return new Promise((m,c)=>u.search(v=>{A(v.map(T))},y).then(v=>m({limitHit:v.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=S;function T(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((y,A)=>{if(A.ranges){const i=A;return y+(Array.isArray(i.ranges)?i.ranges.length:1)}else return y+1},0)}}}),define(me[283],ge([0,1,47,297,20,16,15,3,100,9,44,2,42,31,280,282]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(p);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const s=l(t),n=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,S.createCancelablePromise)(a=>this.doFileSearchWithEngine(c.Engine,s,h=>n.fire(h),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}textSearch(t){let r;const s=l(t),n=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,S.createCancelablePromise)(a=>this.ripgrepTextSearch(s,h=>n.fire(h),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(c.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,n,a=_.BATCH_SIZE){let h=0;const f=E=>{Array.isArray(E)?(h+=E.length,s(E.map(o=>this.rawMatchToSearchItem(o)))):E.relativePath?(h++,s(this.rawMatchToSearchItem(E))):s(E)};if(r.sortByScore){let E=this.trySortedSearchFromCache(r,f,n);if(!E){const o=r.maxResults?Object.assign({},r,{maxResults:null}):r,k=new t(o);E=this.doSortedSearch(k,r,s,f,n)}return new Promise((o,k)=>{E.then(([L,N])=>{const V=N.map(ee=>this.rawMatchToSearchItem(ee));this.sendProgress(V,s,a),o(L)},k)})}const w=new t(r);return this.doSearch(w,f,a,n).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,n,a){const h=new C.Emitter;let f=(0,S.createCancelablePromise)(E=>{let o=[];const k=L=>{Array.isArray(L)?o=L:(n(L),h.fire(L))};return this.doSearch(t,k,-1,E).then(L=>[L,o])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const E={promise:f,event:h.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=E,f.then(()=>{E.resolved=!0},o=>{delete w.resultsToSearchCache[r.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([E,o])=>{const k=w?w.scorerCache:Object.create(null),L=(typeof r.maxResults!="number"||r.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(r,o,k,a).then(N=>{const V=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:V,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:N.length},messages:E.messages,limitHit:E.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults},N]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new b)}trySortedSearchFromCache(t,r,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",r,s);if(a)return a.then(([h,f,w])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,f,n.scorerCache,s).then(o=>{const k=E.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:f.length,sortingTime:k};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:L},o]})})}sortResults(t,r,s,n){const a=(0,y.prepareQuery)(t.filePattern||""),h=(w,E)=>(0,y.compareItemsByFuzzyScore)(w,E,a,!0,P,s),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return D.topAsync(r,h,f,1e4,n)}sendProgress(t,r,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)r(t.slice(n,n+s));else r(t)}getResultsFromCache(t,r,s,n){const a=i.StopWatch.create(!1),h=r.indexOf(A.sep)>=0;let f;for(const k in t.resultsToSearchCache)if(r.startsWith(k)){if(h&&k.indexOf(A.sep)<0&&k!=="")continue;const L=t.resultsToSearchCache[k];f={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!f)return null;const w=a.elapsed(),E=i.StopWatch.create(!1),o=f.event(s);return n&&n.onCancellationRequested(()=>{o.dispose()}),f.promise.then(([k,L])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const N=[],V=(0,y.prepareQuery)(r).normalizedLowercase;for(const ee of L)!(0,m.isFilePatternMatch)(ee,V)||N.push(ee);return[k,N,{cacheWasResolved:f.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,r,s,n){return new Promise((a,h)=>{let f=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(s?(f.push(w),s>0&&f.length>=s&&(r(f),f=[])):r(w))},w=>{r(w)},(w,E)=>{f.length&&r(f),w?h(w):a(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const P=new class{getItemLabel(g){return(0,A.basename)(g.relativePath)}getItemDescription(g){return(0,A.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(d),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>I.URI.revive(t))}}function d(g){return{...g,folder:I.URI.revive(g.folder)}}}),define(me[284],ge([0,1,6,2,28,12,31,283,281,93,13,63,27,71,10,134]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends m.ExtHostSearch{constructor(P,l,d,g){super(P,d,g);this._pfs=D,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new A.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new y.RipgrepSearchProvider(t)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const P=new A.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new y.RipgrepSearchProvider(P)),this.registerInternalFileSearchProvider(c.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(P,l){const d=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(P)),(0,p.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(P,l,d,g){const t=(0,m.reviveQuery)(d);return P===this._internalFileSearchHandle?this.doInternalFileSearch(P,l,t,g):super.$provideFileSearchResults(P,l,d,g)}doInternalFileSearch(P,l,d,g){const t=r=>{if((0,T.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(P,l,r.map(s=>R.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,t,g)}$clearCache(P){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(P),super.$clearCache(P)}createTextSearchManager(P,l){return new v.NativeTextSearchManager(P,l)}};_=Ve([$e(0,i.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,I.IURITransformerService),$e(3,S.ILogService)],_),e.NativeExtHostSearch=_}),define(me[136],ge([0,1,298,125,299,3,106,9,104,32,6,23,107,15,11]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(f){this.socket=f,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const w=E=>f(I.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(f){const w=E=>{f({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((f,w)=>{if(this.socket.bufferSize===0){f();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),f()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var _;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var b;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(b||(b={}));class P extends i.Disposable{constructor(f,w,E,o){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=o,w?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",k=>{console.error(k),(0,m.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibInflate.on("data",k=>{this._pendingInflateData.push(k)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{console.error(k),(0,m.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibDeflate.on("data",k=>{this._pendingDeflateData.push(k)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new u.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(I.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,w){let E=2;f.byteLength<126?E+=0:f.byteLength<2**16?E+=2:E+=8;const o=I.VSBuffer.alloc(E);if(w?o.writeUInt8(194,0):o.writeUInt8(130,0),f.byteLength<126)o.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){o.writeUInt8(126,1);let k=1;o.writeUInt8(f.byteLength>>>8&255,++k),o.writeUInt8(f.byteLength>>>0&255,++k)}else{o.writeUInt8(127,1);let k=1;o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(f.byteLength>>>24&255,++k),o.writeUInt8(f.byteLength>>>16&255,++k),o.writeUInt8(f.byteLength>>>8&255,++k),o.writeUInt8(f.byteLength>>>0&255,++k)}this._totalOutgoingWireBytes+=o.byteLength+f.byteLength,this.socket.write(I.VSBuffer.concat([o,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),o=(w.readUInt8(0)&128)>>>7,k=w.readUInt8(1),L=(k&128)>>>7,N=k&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),o=(E&128)>>>7;let k=E&127,L=1;k===126?k=w.readUInt8(++L)*2**8+w.readUInt8(++L):k===127&&(k=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let N=0;o&&(N=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=k,this._state.mask=N}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);l(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(I.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function l(h,f){if(f===0)return;let w=h.byteLength>>>2;for(let V=0;V<w;V++){const ee=h.readUInt32BE(V*4);h.writeUInt32BE(ee^f,V*4)}let E=w*4,o=h.byteLength-E;const k=f>>>24&255,L=f>>>16&255,N=f>>>8&255;o>=1&&h.writeUInt8(h.readUInt8(E)^k,E),o>=2&&h.writeUInt8(h.readUInt8(E+1)^L,E+1),o>=3&&h.writeUInt8(h.readUInt8(E+2)^N,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function g(){const h=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):f=(0,C.join)((0,y.tmpdir)(),`vscode-ipc-${h}.sock`),r(f),f}e.createRandomIPCHandle=g;function t(h,f,w){const E=(0,p.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${f}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${f}.sock`):o=(0,C.join)(h,`${w}-${f}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(h){const f=d[c.platform];typeof f=="number"&&h.length>=f&&console.warn(`WARNING: IPC handle "${h}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends T.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const w=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(w,E=>({protocol:new u.Protocol(new v(E)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(h){return new Promise((f,w)=>{const E=(0,R.createServer)();E.on("error",w),E.listen(h,()=>{E.removeListener("error",w),f(new s(E))})})}e.serve=n;function a(h,f){return new Promise((w,E)=>{const o=(0,R.createConnection)(h,()=>{o.removeListener("error",E),w(u.Client.fromSocket(new v(o),f))});o.once("error",E)})}e.connect=a}),define(me[285],ge([0,1,136,277,47,52,2,198,12]),function(J,e,p,R,D,S,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(u,m,c){this._commands=u,this.logService=m,this._ipcHandlePath=c,this._server=R.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,m){const c=[];u.setEncoding("utf8"),u.on("data",v=>c.push(v)),u.on("end",()=>{const v=JSON.parse(c.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),m.end();break}})}open(u,m){let{fileURIs:c,folderURIs:v,forceNewWindow:_,diffMode:b,addMode:P,forceReuseWindow:l,gotoLineMode:d,waitMarkerFilePath:g}=u;const t=[];if(Array.isArray(v))for(const r of v)try{t.push({folderUri:T.URI.parse(r)})}catch(s){}if(Array.isArray(c))for(const r of c)try{(0,C.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:T.URI.parse(r)}):t.push({fileUri:T.URI.parse(r)})}catch(s){}if(t.length){const r=g?T.URI.file(g):void 0,n={forceNewWindow:_,diffMode:b,addMode:P,gotoLineMode:d,forceReuseWindow:l,preferNewWindow:!l&&!r&&!P,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}m.writeHead(200),m.end()}async openExternal(u,m){for(const c of u.uris){const v=T.URI.parse(c),_=v.scheme==="file"?v:c;await this._commands.executeCommand("_remoteCLI.openExternal",_)}m.writeHead(200),m.end()}async manageExtensions(u,m){try{const c=b=>b?.map(P=>/\.vsix$/i.test(P)?T.URI.parse(P):P),v={list:u.list,install:c(u.install),uninstall:c(u.uninstall),force:u.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(_)}catch(c){m.writeHead(500),m.write(String(c),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(u,m){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(c),m.end()}catch(c){m.writeHead(500),m.write(String(c),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let i=class extends A{constructor(u,m){super(u,m,(0,p.createRandomIPCHandle)())}};i=Ve([$e(0,S.IExtHostCommands),$e(1,y.ILogService)],i),e.CLIServer=i}),define(me[286],ge([0,1,70,273,268,5,276,40,258,2,10,7,285,105]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends D.RequireInterceptor{_installInterceptor(){const b=this,P=J.__$__nodeRequire("module"),l=P._load;P._load=function(g,t,r){for(let s of b._alternatives){let n=s(g);if(n){g=n;break}}return b._factories.has(g)?b._factories.get(g).load(g,A.URI.file((0,m.realpathSync)(t.filename)),s=>l.apply(this,[s,t,r])):l.apply(this,arguments)}}}class v extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,b,this._registry).install(),p.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const d=process.send,g=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?d.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,P,l){if(P.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${P}', must be of file-scheme`);let d=null;l.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${P.toString(!0)}`),this._logService.flush();try{b&&p.mark(`code/extHost/willLoadExtensionCode/${b.value}`),d=J.__$__nodeRequire(P.fsPath)}catch(g){return Promise.reject(g)}finally{b&&p.mark(`code/extHost/didLoadExtensionCode/${b.value}`),l.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const P in b){const l=b[P];l===null?delete process.env[P]:process.env[P]=l}}}e.ExtHostExtensionService=v}),define(me[287],ge([0,1,79,259,261,270,269,284,286,227,262,53,40,65,71,69,33,51,12,66,260]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_,b,P,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(u.IExtHostExtensionService,y.ExtHostExtensionService),(0,p.registerSingleton)(P.ILogService,A.ExtHostLogService),(0,p.registerSingleton)(l.IExtensionStoragePaths,d.ExtensionStoragePaths),(0,p.registerSingleton)(I.IExtHostDebugService,T.ExtHostDebugService),(0,p.registerSingleton)(m.IExtHostOutputService,R.ExtHostOutputService2),(0,p.registerSingleton)(c.IExtHostSearch,C.NativeExtHostSearch),(0,p.registerSingleton)(v.IExtHostTask,S.ExtHostTask),(0,p.registerSingleton)(_.IExtHostTerminalService,D.ExtHostTerminalService),(0,p.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[288],ge([0,1,125,300,70,15,107,136,191,225,271,23,102,28,105,16,114,274,287]),function(J,e,p,R,D,S,T,C,y,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=J.__$__nodeRequire("module"),a=n._load;n._load=function(h){if(h==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const P=process.exit.bind(process);function l(n){process.exit=function(a){if(n)P(a);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let d=function(n){P()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,a)=>{let h=null,f=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,o=new v.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),w),k=new v.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),E);process.on("message",(N,V)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=I.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let z;if(N.skipWebSocketFrames)z=new C.NodeSocket(V);else{const M=I.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));z=new C.WebSocketNodeSocket(new C.NodeSocket(V),N.permessageDeflate,M,!1)}h?(o.cancel(),k.cancel(),h.beginAcceptReconnection(z,ee),h.endAcceptReconnection()):(clearTimeout(f),h=new T.PersistentProtocol(z,ee),h.onDidDispose(()=>d("renderer disconnected")),n(h),h.onSocketClose(()=>{o.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(k.isScheduled())return;o.isScheduled()&&k.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,h)=>{const f=p.createConnection(n,()=>{f.removeListener("error",h),a(new T.PersistentProtocol(new C.NodeSocket(f)))});f.once("error",h),f.on("close",()=>{d("renderer closed the socket")})})}}async function t(){const n=await g();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(a=>{(0,A.isMessageOfType)(a,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||n.send(a)}drain(){return n.drain()}}}function r(n){return new Promise(a=>{const h=n.onMessage(f=>{h.dispose();const w=JSON.parse(f.toString()),E=w.commit,o=y.default.commit;E&&o&&E!==o&&P(55);const k=[];process.on("unhandledRejection",(V,ee)=>{k.push(ee),setTimeout(()=>{const z=k.indexOf(ee);z>=0&&ee.catch(M=>{k.splice(z,1),(0,S.isPromiseCanceledError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),(0,S.onUnexpectedError)(V))})},1e3)}),process.on("rejectionHandled",V=>{const ee=k.indexOf(V);ee>=0&&k.splice(ee,1)}),process.on("uncaughtException",function(V){(0,S.onUnexpectedError)(V)});let L=0;setInterval(function(){try{process.kill(w.parentPid,0),L=0}catch(V){V&&V.code==="EPERM"?(L++,L>=3&&d(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):d(`parent process ${w.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let N;try{N=J.__$__nodeRequire("native-watchdog"),N.start(w.parentPid)}catch(V){(0,S.onUnexpectedError)(V)}n.send((0,A.createMessageOfType)(0)),a({protocol:n,initData:w})});n.send((0,A.createMessageOfType)(1))})}async function s(){D.mark("code/extHost/willConnectToRenderer");const n=await t();D.mark("code/extHost/didConnectToRenderer");const a=await r(n);D.mark("code/extHost/didWaitForInitData");const{initData:h}=a;l(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,h.environment.skipWorkspaceStorageLock=(0,_.boolean)(b.skipWorkspaceStorageLock,!1);const f=new class{exit(k){P(k)}exists(k){return m.Promises.exists(k)}realpath(k){return(0,c.realpath)(k)}};let w=null;if(h.remote.authority&&b.uriTransformerPath)try{const k=J.__$__nodeRequire(b.uriTransformerPath)(h.remote.authority);w=new u.URITransformer(k)}catch(o){console.error(o)}const E=new i.ExtensionHostMain(a.protocol,h,f,w);d=o=>E.terminate(o)}e.startExtensionHostProcess=s}),define(me[301],ge([0,1,288]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/04485223ebc6a075f39966bf9b3e261359ac7818/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
