/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(te){for(var e=[],g=0,R=te.length;g<R;g++)e[g]=be[te[g]];return e};define(be[41],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(R,S){if(!R)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=g}),define(be[50],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function R(n){const I=[];for(let l in n)g.call(n,l)&&I.push(n[l]);return I}e.values=R;function S(n,I){for(let l in n)if(g.call(n,l)&&I({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=S;function E(n,I){const l=Object.create(null);for(const d of n){const u=I(d);let f=l[u];f||(f=l[u]=[]),f.push(d)}return l}e.groupBy=E;function k(n){const I=Object.create(null);return n&&n.forEach((l,d)=>{I[d]=l}),I}e.fromMap=k;function y(n,I){const l=[],d=[];for(let u of n)I.has(u)||l.push(u);for(let u of I)n.has(u)||d.push(u);return{removed:l,added:d}}e.diffSets=y;function _(n,I){const l=[],d=[];for(let[u,f]of n)I.has(u)||l.push(f);for(let[u,f]of I)n.has(u)||d.push(f);return{removed:l,added:d}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(I,l){let d=this.map.get(I);d||(d=new Set,this.map.set(I,d)),d.add(l)}delete(I,l){const d=this.map.get(I);!d||(d.delete(l),d.size===0&&this.map.delete(I))}forEach(I,l){const d=this.map.get(I);!d||d.forEach(l)}}e.SetMap=C}),define(be[51],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(k){return(y,_,C)=>{let n=null,I=null;if(typeof C.value=="function"?(n="value",I=C.value):typeof C.get=="function"&&(n="get",I=C.get),!I)throw new Error("not supported");C[n]=k(I,_)}}e.createDecorator=g;function R(k,y,_){let C=null,n=null;if(typeof _.value=="function"?(C="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",n=_.get),!n)throw new Error("not supported");const I=`$memoize$${y}`;_[C]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[I]}}e.memoize=R;function S(k,y,_){return g((C,n)=>{const I=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...d){this[l]||(this[l]=_?_():void 0),clearTimeout(this[I]),y&&(this[l]=y(this[l],...d),d=[this[l]]),this[I]=setTimeout(()=>{C.apply(this,d),this[l]=_?_():void 0},k)}})}e.debounce=S;function E(k,y,_){return g((C,n)=>{const I=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,d=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...f){if(this[l]||(this[l]=_?_():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[l]=y(this[l],...f)),this[u])return;const b=this[d]+k;b<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[d]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0},b-Date.now()))}})}e.throttle=E}),define(be[12],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function S(v){_(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=S;function E(v){_(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=E;function k(v){if(v instanceof Error){let{name:t,message:r}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:s}}return v}e.transformErrorForSerialization=k;const y="Canceled";function _(v){return v instanceof Error&&v.name===y&&v.message===y}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=C;function n(){const v=new Error(y);return v.name=v.message,v}e.canceled=n;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function d(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function f(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=f;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function a(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function h(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=h}),define(be[17],Ee([0,1,12]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(H,oe=0){return H[H.length-(1+oe)]}e.tail=R;function S(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=S;function E(H,oe,de=(Ce,Ne)=>Ce===Ne){if(H===oe)return!0;if(!H||!oe||H.length!==oe.length)return!1;for(let Ce=0,Ne=H.length;Ce<Ne;Ce++)if(!de(H[Ce],oe[Ce]))return!1;return!0}e.equals=E;function k(H,oe,de){let Ce=0,Ne=H.length-1;for(;Ce<=Ne;){const Me=(Ce+Ne)/2|0,$e=de(H[Me],oe);if($e<0)Ce=Me+1;else if($e>0)Ne=Me-1;else return Me}return-(Ce+1)}e.binarySearch=k;function y(H,oe){let de=0,Ce=H.length;if(Ce===0)return 0;for(;de<Ce;){const Ne=Math.floor((de+Ce)/2);oe(H[Ne])?Ce=Ne:de=Ne+1}return de}e.findFirstInSorted=y;function _(H,oe,de){if(H=H|0,H>=oe.length)throw new TypeError("invalid index");let Ce=oe[Math.floor(oe.length*Math.random())],Ne=[],Me=[],$e=[];for(let Xe of oe){const qe=de(Xe,Ce);qe<0?Ne.push(Xe):qe>0?Me.push(Xe):$e.push(Xe)}return H<Ne.length?_(H,Ne,de):H<Ne.length+$e.length?$e[0]:_(H-(Ne.length+$e.length),Me,de)}e.quickSelect=_;function C(H,oe){const de=[];let Ce;for(const Ne of H.slice(0).sort(oe))!Ce||oe(Ce[0],Ne)!==0?(Ce=[Ne],de.push(Ce)):Ce.push(Ne);return de}e.groupBy=C;function n(H,oe,de){const Ce=[];function Ne(Xe,qe,je){if(qe===0&&je.length===0)return;const O=Ce[Ce.length-1];O&&O.start+O.deleteCount===Xe?(O.deleteCount+=qe,O.toInsert.push(...je)):Ce.push({start:Xe,deleteCount:qe,toInsert:je})}let Me=0,$e=0;for(;;){if(Me===H.length){Ne(Me,0,oe.slice($e));break}if($e===oe.length){Ne(Me,H.length-Me,[]);break}const Xe=H[Me],qe=oe[$e],je=de(Xe,qe);je===0?(Me+=1,$e+=1):je<0?(Ne(Me,1,[]),Me+=1):je>0&&(Ne(Me,0,[qe]),$e+=1)}return Ce}e.sortedDiff=n;function I(H,oe,de){const Ce=n(H,oe,de),Ne=[],Me=[];for(const $e of Ce)Ne.push(...H.slice($e.start,$e.start+$e.deleteCount)),Me.push(...$e.toInsert);return{removed:Ne,added:Me}}e.delta=I;function l(H,oe,de){if(de===0)return[];const Ce=H.slice(0,de).sort(oe);return u(H,oe,Ce,de,H.length),Ce}e.top=l;function d(H,oe,de,Ce,Ne){return de===0?Promise.resolve([]):new Promise((Me,$e)=>{(async()=>{const Xe=H.length,qe=H.slice(0,de).sort(oe);for(let je=de,O=Math.min(de+Ce,Xe);je<Xe;je=O,O=Math.min(O+Ce,Xe)){if(je>de&&await new Promise(K=>setTimeout(K)),Ne&&Ne.isCancellationRequested)throw(0,g.canceled)();u(H,oe,qe,je,O)}return qe})().then(Me,$e)})}e.topAsync=d;function u(H,oe,de,Ce,Ne){for(const Me=de.length;Ce<Ne;Ce++){const $e=H[Ce];if(oe($e,de[Me-1])<0){de.pop();const Xe=y(de,qe=>oe($e,qe)<0);de.splice(Xe,0,$e)}}}function f(H){return H.filter(oe=>!!oe)}e.coalesce=f;function b(H){let oe=0;for(let de=0;de<H.length;de++)H[de]&&(H[oe]=H[de],oe+=1);H.length=oe}e.coalesceInPlace=b;function w(H,oe,de){H.splice(de,0,H.splice(oe,1)[0])}e.move=w;function P(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=P;function a(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=a;function h(H,oe){if(!oe)return H.filter((Ce,Ne)=>H.indexOf(Ce)===Ne);const de=Object.create(null);return H.filter(Ce=>{const Ne=oe(Ce);return de[Ne]?!1:(de[Ne]=!0,!0)})}e.distinct=h;function v(H){const oe=new Set;return H.filter(de=>oe.has(de)?!1:(oe.add(de),!0))}e.distinctES6=v;function t(H){const oe=Object.create(null);return de=>{const Ce=H(de);return oe[Ce]?!1:(oe[Ce]=!0,!0)}}e.uniqueFilter=t;function r(H,oe){for(let de=H.length-1;de>=0;de--){const Ce=H[de];if(oe(Ce))return de}return-1}e.lastIndex=r;function s(H,oe){return H.length>0?H[0]:oe}e.firstOrDefault=s;function i(H,oe,de=(Ce,Ne)=>Ce===Ne){let Ce=0;for(let Ne=0,Me=Math.min(H.length,oe.length);Ne<Me&&de(H[Ne],oe[Ne]);Ne++)Ce++;return Ce}e.commonPrefixLength=i;function c(H){return[].concat(...H)}e.flatten=c;function m(H,oe){let de=typeof oe=="number"?H:0;typeof oe=="number"?de=H:(de=0,oe=H);const Ce=[];if(de<=oe)for(let Ne=de;Ne<oe;Ne++)Ce.push(Ne);else for(let Ne=de;Ne>oe;Ne--)Ce.push(Ne);return Ce}e.range=m;function p(H,oe,de){return H.reduce((Ce,Ne)=>(Ce[oe(Ne)]=de?de(Ne):Ne,Ce),Object.create(null))}e.index=p;function D(H,oe){return H.push(oe),()=>T(H,oe)}e.insert=D;function T(H,oe){const de=H.indexOf(oe);if(de>-1)return H.splice(de,1),oe}e.remove=T;function o(H,oe,de){const Ce=H.slice(0,oe),Ne=H.slice(oe);return Ce.concat(de,Ne)}e.arrayInsert=o;function A(H,oe){let de;if(typeof oe=="number"){let Ce=oe;de=()=>{const Ne=Math.sin(Ce++)*179426549;return Ne-Math.floor(Ne)}}else de=Math.random;for(let Ce=H.length-1;Ce>0;Ce-=1){const Ne=Math.floor(de()*(Ce+1)),Me=H[Ce];H[Ce]=H[Ne],H[Ne]=Me}}e.shuffle=A;function F(H,oe){const de=H.indexOf(oe);de>-1&&(H.splice(de,1),H.unshift(oe))}e.pushToStart=F;function U(H,oe){const de=H.indexOf(oe);de>-1&&(H.splice(de,1),H.push(oe))}e.pushToEnd=U;function j(H,oe){return Array.isArray(H)?H.map(oe):oe(H)}e.mapArrayOrNot=j;function ae(H){return Array.isArray(H)?H:[H]}e.asArray=ae;function G(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=G;function B(H,oe){for(const de of H){const Ce=oe(de);if(Ce!==void 0)return Ce}}e.mapFind=B;function $(H,oe,de){const Ce=Z(H,oe),Ne=H.length,Me=de.length;H.length=Ne+Me;for(let $e=Ne-1;$e>=Ce;$e--)H[$e+Me]=H[$e];for(let $e=0;$e<Me;$e++)H[$e+Ce]=de[$e]}e.insertInto=$;function L(H,oe,de,Ce){const Ne=Z(H,oe),Me=H.splice(Ne,de);return $(H,Ne,Ce),Me}e.splice=L;function Z(H,oe){return oe<0?Math.max(oe+H.length,0):Math.min(oe,H.length)}function V(H,oe){let de=Number.MAX_SAFE_INTEGER,Ce=0;return H.forEach((Ne,Me)=>{const $e=oe(Ne);$e<de&&(de=$e,Ce=Me)}),Ce}e.minIndex=V;function Y(H,oe){let de=Number.MIN_SAFE_INTEGER,Ce=0;return H.forEach((Ne,Me)=>{const $e=oe(Ne);$e>de&&(de=$e,Ce=Me)}),Ce}e.maxIndex=Y;class me{constructor(oe){this.items=oe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(oe){let de=this.firstIdx;for(;de<this.items.length&&oe(this.items[de]);)de++;const Ce=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,Ce}takeFromEndWhile(oe){let de=this.lastIdx;for(;de>=0&&oe(this.items[de]);)de--;const Ce=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,Ce}}e.ArrayQueue=me}),define(be[52],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(R){const S=this;let E=!1,k;return function(){return E||(E=!0,k=R.apply(S,arguments)),k}}e.once=g}),define(be[53],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(be[54],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(R){function S(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=S;const E=Object.freeze([]);function k(){return E}R.empty=k;function*y(v){yield v}R.single=y;function _(v){return v||E}R.from=_;function C(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=C;function n(v){return v[Symbol.iterator]().next().value}R.first=n;function I(v,t){for(const r of v)if(t(r))return!0;return!1}R.some=I;function l(v,t){for(const r of v)if(t(r))return r}R.find=l;function*d(v,t){for(const r of v)t(r)&&(yield r)}R.filter=d;function*u(v,t){let r=0;for(const s of v)yield t(s,r++)}R.map=u;function*f(...v){for(const t of v)for(const r of t)yield r}R.concat=f;function*b(v){for(const t of v)for(const r of t)yield r}R.concatNested=b;function w(v,t,r){let s=r;for(const i of v)s=t(s,i);return s}R.reduce=w;function*P(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}R.slice=P;function a(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const s=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=s.next();if(c.done)return[r,R.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}R.consume=a;function h(v,t,r=(s,i)=>s===i){const s=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=s.next(),m=i.next();if(c.done!==m.done)return!1;if(c.done)return!0;if(!r(c.value,m.value))return!1}}R.equals=h})(g=e.Iterable||(e.Iterable={}))}),define(be[111],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let s=0,i=t.length,c="",m=0,p=16,D=0;function T(G){let B=0,$=0;for(;B<G;){const L=t.charCodeAt(s);if(L>=48&&L<=57)$=$*16+L-48;else if(L>=65&&L<=70)$=$*16+L-65+10;else if(L>=97&&L<=102)$=$*16+L-97+10;else break;s++,B++}return B<G&&($=-1),$}function o(G){s=G,c="",m=0,p=16,D=0}function A(){const G=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return D=3,t.substring(G,s);let B=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;B=s}else D=3;return t.substring(G,B)}function F(){let G="",B=s;for(;;){if(s>=i){G+=t.substring(B,s),D=2;break}const $=t.charCodeAt(s);if($===34){G+=t.substring(B,s),s++;break}if($===92){if(G+=t.substring(B,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const Z=T(4);Z>=0?G+=String.fromCharCode(Z):D=4;break;default:D=5}B=s;continue}if($>=0&&$<=31)if(_($)){G+=t.substring(B,s),D=2;break}else D=6;s++}return G}function U(){if(c="",D=0,m=s,s>=i)return m=i,p=17;let G=t.charCodeAt(s);if(y(G)){do s++,c+=String.fromCharCode(G),G=t.charCodeAt(s);while(y(G));return p=15}if(_(G))return s++,c+=String.fromCharCode(G),G===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),p=14;switch(G){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,c=F(),p=10;case 47:const B=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!_(t.charCodeAt(s));)s++;return c=t.substring(B,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const $=i-1;let L=!1;for(;s<$;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,D=1),c=t.substring(B,s),p=13}return c+=String.fromCharCode(G),s++,p=16;case 45:if(c+=String.fromCharCode(G),s++,s===i||!C(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=A(),p=11;default:for(;s<i&&j(G);)s++,G=t.charCodeAt(s);if(m!==s){switch(c=t.substring(m,s),c){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return c+=String.fromCharCode(G),s++,p=16}}function j(G){if(y(G)||_(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let G;do G=U();while(G>=12&&G<=15);return G}return{setPosition:o,getPosition:()=>s,scan:r?ae:U,getToken:()=>p,getTokenValue:()=>c,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>D}}e.createScanner=k;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,r){const s=[],i=new Object;let c;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function D(T,o,A,F){m.value=T,m.offset=o,m.length=A,m.type=F,m.colonOffset=void 0,c=m}try{a(t,{onObjectBegin:(T,o)=>{if(r<=T)throw i;c=void 0,p=r>T,s.push("")},onObjectProperty:(T,o,A)=>{if(r<o||(D(T,o,A,"property"),s[s.length-1]=T,r<=o+A))throw i},onObjectEnd:(T,o)=>{if(r<=T)throw i;c=void 0,s.pop()},onArrayBegin:(T,o)=>{if(r<=T)throw i;c=void 0,s.push(0)},onArrayEnd:(T,o)=>{if(r<=T)throw i;c=void 0,s.pop()},onLiteralValue:(T,o,A)=>{if(r<o||(D(T,o,A,v(T)),r<=o+A))throw i},onSeparator:(T,o,A)=>{if(r<=o)throw i;if(T===":"&&c&&c.type==="property")c.colonOffset=o,p=!1,c=void 0;else if(T===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(p=!0,s[s.length-1]=""),c=void 0}}})}catch(T){if(T!==i)throw T}return{path:s,previousNode:c,isAtPropertyKey:p,matches:T=>{let o=0;for(let A=0;o<T.length&&A<s.length;A++)if(T[o]===s[A]||T[o]==="*")o++;else if(T[o]!=="**")return!1;return o===T.length}}}e.getLocation=I;function l(t,r=[],s=E.DEFAULT){let i=null,c=[];const m=[];function p(T){Array.isArray(c)?c.push(T):i!==null&&(c[i]=T)}return a(t,{onObjectBegin:()=>{const T={};p(T),m.push(c),c=T,i=null},onObjectProperty:T=>{i=T},onObjectEnd:()=>{c=m.pop()},onArrayBegin:()=>{const T=[];p(T),m.push(c),c=T,i=null},onArrayEnd:()=>{c=m.pop()},onLiteralValue:p,onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s),c[0]}e.parse=l;function d(t,r=[],s=E.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(T){i.type==="property"&&(i.length=T-i.offset,i=i.parent)}function m(T){return i.children.push(T),T}a(t,{onObjectBegin:T=>{i=m({type:"object",offset:T,length:-1,parent:i,children:[]})},onObjectProperty:(T,o,A)=>{i=m({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:T,offset:o,length:A,parent:i})},onObjectEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,c(T+o)},onArrayBegin:(T,o)=>{i=m({type:"array",offset:T,length:-1,parent:i,children:[]})},onArrayEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,c(T+o)},onLiteralValue:(T,o,A)=>{m({type:v(T),offset:o,length:A,parent:i,value:T}),c(o+A)},onSeparator:(T,o,A)=>{i.type==="property"&&(T===":"?i.colonOffset=o:T===","&&c(o))},onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=d;function u(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===i){s=m.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=u;function f(t){if(!t.parent||!t.parent.children)return[];const r=f(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=f;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=b(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=w;function P(t,r,s=!1){if(w(t,r,s)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const m=P(i[c],r,s);if(m)return m}return t}}e.findNodeAtOffset=P;function a(t,r,s=E.DEFAULT){const i=k(t,!1);function c(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function m(de){return de?Ce=>de(Ce,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=c(r.onObjectBegin),D=m(r.onObjectProperty),T=c(r.onObjectEnd),o=c(r.onArrayBegin),A=c(r.onArrayEnd),F=m(r.onLiteralValue),U=m(r.onSeparator),j=c(r.onComment),ae=m(r.onError),G=s&&s.disallowComments,B=s&&s.allowTrailingComma;function $(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:G||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(de){case 12:case 13:G?L(10):j();break;case 16:L(1);break;case 15:case 14:break;default:return de}}}function L(de,Ce=[],Ne=[]){if(ae(de),Ce.length+Ne.length>0){let Me=i.getToken();for(;Me!==17;){if(Ce.indexOf(Me)!==-1){$();break}else if(Ne.indexOf(Me)!==-1)break;Me=$()}}}function Z(de){const Ce=i.getTokenValue();return de?F(Ce):D(Ce),$(),!0}function V(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(L(2),de=0)}catch(Ce){L(2)}F(de);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return $(),!0}function Y(){return i.getToken()!==10?(L(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(U(":"),$(),oe()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function me(){p(),$();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||L(4,[],[]),U(","),$(),i.getToken()===2&&B)break}else de&&L(6,[],[]);Y()||L(4,[],[2,5]),de=!0}return T(),i.getToken()!==2?L(7,[2],[]):$(),!0}function H(){o(),$();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||L(4,[],[]),U(","),$(),i.getToken()===4&&B)break}else de&&L(6,[],[]);oe()||L(4,[],[4,5]),de=!0}return A(),i.getToken()!==4?L(8,[4],[]):$(),!0}function oe(){switch(i.getToken()){case 3:return H();case 1:return me();case 10:return Z(!0);default:return V()}}return $(),i.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):oe()?(i.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=a;function h(t,r){let s=k(t),i=[],c,m=0,p;do switch(p=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:m!==p&&i.push(t.substring(m,p)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),m=s.getPosition();break}while(c!==17);return i.join("")}e.stripComments=h;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(be[112],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new g(()=>S(this.getValue()))}}e.Lazy=g}),define(be[6],Ee([0,1,52,54]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let E=null;function k(s){E=s}if(e.setDisposableTracker=k,S){const s="__is_disposable_tracked__";k(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function y(s){return E?.trackDisposable(s),s}function _(s){E?.markAsDisposed(s)}function C(s,i){E?.setParent(s,i)}function n(s,i){if(!!E)for(const c of s)E.setParent(c,i)}function I(s){return E?.markAsSingleton(s),s}e.markAsSingleton=I;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function d(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=d;function u(s){if(R.Iterable.is(s)){let i=[];for(const c of s)if(c)try{c.dispose()}catch(m){i.push(m)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=u;function f(...s){const i=b(()=>u(s));return n(s,i),i}e.combinedDisposable=f;function b(s){const i=y({dispose:(0,g.once)(()=>{_(i),s()})});return i}e.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return C(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new w,y(this),C(this._store,this)}dispose(){_(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&C(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&C(i,null),i}}e.MutableDisposable=a;class h{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class v{constructor(){this.references=new Map}acquire(i,...c){let m=this.references.get(i);m||(m={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,m));const{object:p}=m,D=(0,g.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(i,m.object),this.references.delete(i))});return m.counter++,{object:p,dispose:D}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const m=this.referenceCollection.acquire(i,...c);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(p){throw m.dispose(),p}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(be[80],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(E){this.element=E,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class R{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let E=this._first;for(;E!==g.Undefined;){const k=E.next;E.prev=g.Undefined,E.next=g.Undefined,E=k}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,k){const y=new g(E);if(this._first===g.Undefined)this._first=y,this._last=y;else if(k){const C=this._last;this._last=y,y.prev=C,C.next=y}else{const C=this._first;this._first=y,y.next=C,C.prev=y}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==g.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==g.Undefined&&E.next!==g.Undefined){const k=E.prev;k.next=E.next,E.next.prev=k}else E.prev===g.Undefined&&E.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):E.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):E.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==g.Undefined;)yield E.element,E=E.next}}e.LinkedList=R}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(te=typeof globalThis!="undefined"?globalThis:te||self,te.marked=e())}(this,function(){"use strict";function te(Se,ye){for(var Pe=0;Pe<ye.length;Pe++){var se=ye[Pe];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Se,se.key,se)}}function e(Se,ye,Pe){return ye&&te(Se.prototype,ye),Pe&&te(Se,Pe),Se}function g(Se,ye){if(!!Se){if(typeof Se=="string")return R(Se,ye);var Pe=Object.prototype.toString.call(Se).slice(8,-1);if(Pe==="Object"&&Se.constructor&&(Pe=Se.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Se);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(Se,ye)}}function R(Se,ye){(ye==null||ye>Se.length)&&(ye=Se.length);for(var Pe=0,se=new Array(ye);Pe<ye;Pe++)se[Pe]=Se[Pe];return se}function S(Se,ye){var Pe;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(Pe=g(Se))||ye&&Se&&typeof Se.length=="number"){Pe&&(Se=Pe);var se=0;return function(){return se>=Se.length?{done:!0}:{done:!1,value:Se[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=Se[Symbol.iterator](),Pe.next.bind(Pe)}function E(Se){var ye={exports:{}};return Se(ye,ye.exports),ye.exports}var k=E(function(Se){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(se){Se.exports.defaults=se}Se.exports={defaults:ye(),getDefaults:ye,changeDefaults:Pe}}),y=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(ye){return I[ye]};function d(Se,ye){if(ye){if(y.test(Se))return Se.replace(_,l)}else if(C.test(Se))return Se.replace(n,l);return Se}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(Se){return Se.replace(u,function(ye,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var b=/(^|[^\[])\^/g;function w(Se,ye){Se=Se.source||Se,ye=ye||"";var Pe={replace:function(le,he){return he=he.source||he,he=he.replace(b,"$1"),Se=Se.replace(le,he),Pe},getRegex:function(){return new RegExp(Se,ye)}};return Pe}var P=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Se,ye,Pe){if(Se){var se;try{se=decodeURIComponent(f(Pe)).replace(P,"").toLowerCase()}catch(le){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ye&&!a.test(Pe)&&(Pe=i(ye,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(le){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Se,ye){v[" "+Se]||(t.test(Se)?v[" "+Se]=Se+"/":v[" "+Se]=D(Se,"/",!0)),Se=v[" "+Se];var Pe=Se.indexOf(":")===-1;return ye.substring(0,2)==="//"?Pe?ye:Se.replace(r,"$1")+ye:ye.charAt(0)==="/"?Pe?ye:Se.replace(s,"$1")+ye:Se+ye}var c={exec:function(){}};function m(Se){for(var ye=1,Pe,se;ye<arguments.length;ye++){Pe=arguments[ye];for(se in Pe)Object.prototype.hasOwnProperty.call(Pe,se)&&(Se[se]=Pe[se])}return Se}function p(Se,ye){var Pe=Se.replace(/\|/g,function(he,pe,x){for(var fe=!1,we=pe;--we>=0&&x[we]==="\\";)fe=!fe;return fe?"|":" |"}),se=Pe.split(/ \|/),le=0;if(se.length>ye)se.splice(ye);else for(;se.length<ye;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function D(Se,ye,Pe){var se=Se.length;if(se===0)return"";for(var le=0;le<se;){var he=Se.charAt(se-le-1);if(he===ye&&!Pe)le++;else if(he!==ye&&Pe)le++;else break}return Se.substr(0,se-le)}function T(Se,ye){if(Se.indexOf(ye[1])===-1)return-1;for(var Pe=Se.length,se=0,le=0;le<Pe;le++)if(Se[le]==="\\")le++;else if(Se[le]===ye[0])se++;else if(Se[le]===ye[1]&&(se--,se<0))return le;return-1}function o(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Se,ye){if(ye<1)return"";for(var Pe="";ye>1;)ye&1&&(Pe+=Se),ye>>=1,Se+=Se;return Pe+Se}var F={escape:d,unescape:f,edit:w,cleanUrl:h,resolveUrl:i,noopTest:c,merge:m,splitCells:p,rtrim:D,findClosingBracket:T,checkSanitizeDeprecation:o,repeatString:A},U=k.defaults,j=F.rtrim,ae=F.splitCells,G=F.escape,B=F.findClosingBracket;function $(Se,ye,Pe){var se=ye.href,le=ye.title?G(ye.title):null,he=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:se,title:le,text:he}:{type:"image",raw:Pe,href:se,title:le,text:G(he)}}function L(Se,ye){var Pe=Se.match(/^(\s+)(?:```)/);if(Pe===null)return ye;var se=Pe[1];return ye.split(`
`).map(function(le){var he=le.match(/^\s+/);if(he===null)return le;var pe=he[0];return pe.length>=se.length?le.slice(se.length):le}).join(`
`)}var Z=function(){function Se(Pe){this.options=Pe||U}var ye=Se.prototype;return ye.space=function(se){var le=this.rules.block.newline.exec(se);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},ye.code=function(se){var le=this.rules.block.code.exec(se);if(le){var he=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?he:j(he,`
`)}}},ye.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var he=le[0],pe=L(he,le[3]||"");return{type:"code",raw:he,lang:le[2]?le[2].trim():le[2],text:pe}}},ye.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var he=le[2].trim();if(/#$/.test(he)){var pe=j(he,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(he=pe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:he}}},ye.nptable=function(se){var le=this.rules.block.nptable.exec(se);if(le){var he={type:"table",header:ae(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(he.header.length===he.align.length){var pe=he.align.length,x;for(x=0;x<pe;x++)/^ *-+: *$/.test(he.align[x])?he.align[x]="right":/^ *:-+: *$/.test(he.align[x])?he.align[x]="center":/^ *:-+ *$/.test(he.align[x])?he.align[x]="left":he.align[x]=null;for(pe=he.cells.length,x=0;x<pe;x++)he.cells[x]=ae(he.cells[x],he.header.length);return he}}},ye.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var he=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:he}}},ye.list=function(se){var le=this.rules.block.list.exec(se);if(le){var he=le[0],pe=le[2],x=pe.length>1,fe={type:"list",raw:he,ordered:x,start:x?+pe.slice(0,-1):"",loose:!1,items:[]},we=le[0].match(this.rules.block.item),Ie=!1,Oe,He,Ze,Ke,Je,ut,mt,bt,ot=we.length;Ze=this.rules.block.listItemStart.exec(we[0]);for(var at=0;at<ot;at++){if(Oe=we[at],he=Oe,at!==ot-1){if(Ke=this.rules.block.listItemStart.exec(we[at+1]),this.options.pedantic?Ke[1].length>Ze[1].length:Ke[1].length>Ze[0].length||Ke[1].length>3){we.splice(at,2,we[at]+`
`+we[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==pe[pe.length-1]:x===(Ke[2].length===1))&&(Je=we.slice(at+1).join(`
`),fe.raw=fe.raw.substring(0,fe.raw.length-Je.length),at=ot-1);Ze=Ke}He=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(He-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),ut=Ie||/\n\n(?!\s*$)/.test(Oe),at!==ot-1&&(Ie=Oe.charAt(Oe.length-1)===`
`,ut||(ut=Ie)),ut&&(fe.loose=!0),this.options.gfm&&(mt=/^\[[ xX]\] /.test(Oe),bt=void 0,mt&&(bt=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:he,task:mt,checked:bt,loose:ut,text:Oe})}return fe}},ye.html=function(se){var le=this.rules.block.html.exec(se);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):G(le[0]):le[0]}},ye.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var he=le[1].toLowerCase().replace(/\s+/g," ");return{tag:he,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(se){var le=this.rules.block.table.exec(se);if(le){var he={type:"table",header:ae(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=le[0];var pe=he.align.length,x;for(x=0;x<pe;x++)/^ *-+: *$/.test(he.align[x])?he.align[x]="right":/^ *:-+: *$/.test(he.align[x])?he.align[x]="center":/^ *:-+ *$/.test(he.align[x])?he.align[x]="left":he.align[x]=null;for(pe=he.cells.length,x=0;x<pe;x++)he.cells[x]=ae(he.cells[x].replace(/^ *\| *| *\| *$/g,""),he.header.length);return he}}},ye.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},ye.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},ye.text=function(se){var le=this.rules.block.text.exec(se);if(le)return{type:"text",raw:le[0],text:le[0]}},ye.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:G(le[1])}},ye.tag=function(se,le,he){var pe=this.rules.inline.tag.exec(se);if(pe)return!le&&/^<a /i.test(pe[0])?le=!0:le&&/^<\/a>/i.test(pe[0])&&(le=!1),!he&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?he=!0:he&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(he=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:le,inRawBlock:he,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):G(pe[0]):pe[0]}},ye.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var he=le[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var pe=j(he.slice(0,-1),"\\");if((he.length-pe.length)%2==0)return}else{var x=B(le[2],"()");if(x>-1){var fe=le[0].indexOf("!")===0?5:4,we=fe+le[1].length+x;le[2]=le[2].substring(0,x),le[0]=le[0].substring(0,we).trim(),le[3]=""}}var Ie=le[2],Oe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Oe=He[3])}else Oe=le[3]?le[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(he)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),$(le,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},le[0])}},ye.reflink=function(se,le){var he;if((he=this.rules.inline.reflink.exec(se))||(he=this.rules.inline.nolink.exec(se))){var pe=(he[2]||he[1]).replace(/\s+/g," ");if(pe=le[pe.toLowerCase()],!pe||!pe.href){var x=he[0].charAt(0);return{type:"text",raw:x,text:x}}return $(he,pe,he[0])}},ye.emStrong=function(se,le,he){he===void 0&&(he="");var pe=this.rules.inline.emStrong.lDelim.exec(se);if(!!pe&&!(pe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=pe[1]||pe[2]||"";if(!x||x&&(he===""||this.rules.inline.punctuation.exec(he))){var fe=pe[0].length-1,we,Ie,Oe=fe,He=0,Ze=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,le=le.slice(-1*se.length+fe);(pe=Ze.exec(le))!=null;)if(we=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!we){if(Ie=we.length,pe[3]||pe[4]){Oe+=Ie;continue}else if((pe[5]||pe[6])&&fe%3&&!((fe+Ie)%3)){He+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Oe+He-Ie<=0&&!le.slice(Ze.lastIndex).match(Ze)&&(Ie=Math.min(Ie,Ie+Oe+He)),Math.min(fe,Ie)%2)return{type:"em",raw:se.slice(0,fe+pe.index+Ie+1),text:se.slice(1,fe+pe.index+Ie)};if(Math.min(fe,Ie)%2==0)return{type:"strong",raw:se.slice(0,fe+pe.index+Ie+1),text:se.slice(2,fe+pe.index+Ie-1)}}}}}},ye.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var he=le[2].replace(/\n/g," "),pe=/[^ ]/.test(he),x=/^ /.test(he)&&/ $/.test(he);return pe&&x&&(he=he.substring(1,he.length-1)),he=G(he,!0),{type:"codespan",raw:le[0],text:he}}},ye.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},ye.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2]}},ye.autolink=function(se,le){var he=this.rules.inline.autolink.exec(se);if(he){var pe,x;return he[2]==="@"?(pe=G(this.options.mangle?le(he[1]):he[1]),x="mailto:"+pe):(pe=G(he[1]),x=pe),{type:"link",raw:he[0],text:pe,href:x,tokens:[{type:"text",raw:pe,text:pe}]}}},ye.url=function(se,le){var he;if(he=this.rules.inline.url.exec(se)){var pe,x;if(he[2]==="@")pe=G(this.options.mangle?le(he[0]):he[0]),x="mailto:"+pe;else{var fe;do fe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(fe!==he[0]);pe=G(he[0]),he[1]==="www."?x="http://"+pe:x=pe}return{type:"link",raw:he[0],text:pe,href:x,tokens:[{type:"text",raw:pe,text:pe}]}}},ye.inlineText=function(se,le,he){var pe=this.rules.inline.text.exec(se);if(pe){var x;return le?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):G(pe[0]):pe[0]:x=G(this.options.smartypants?he(pe[0]):pe[0]),{type:"text",raw:pe[0],text:x}}},Se}(),V=F.noopTest,Y=F.edit,me=F.merge,H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:V,table:V,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=Y(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,H.item=Y(H.item,"gm").replace(/bull/g,H.bullet).getRegex(),H.listItemStart=Y(/^( *)(bull)/).replace("bull",H.bullet).getRegex(),H.list=Y(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=Y(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=Y(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.blockquote=Y(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=me({},H),H.gfm=me({},H.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.nptable=Y(H.gfm.nptable).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.gfm.table=Y(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.pedantic=me({},H.normal,{html:Y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:V,paragraph:Y(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:V,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:V,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=Y(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=Y(H._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=Y(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=Y(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=Y(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=Y(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=Y(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=Y(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=Y(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=Y(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=me({},oe),oe.pedantic=me({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Y(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:Y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=me({},oe.normal,{escape:Y(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),oe.gfm.url=Y(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=me({},oe.gfm,{br:Y(oe.br).replace("{2,}","*").getRegex(),text:Y(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:H,inline:oe},Ce=k.defaults,Ne=de.block,Me=de.inline,$e=F.repeatString;function Xe(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Se){var ye="",Pe,se,le=Se.length;for(Pe=0;Pe<le;Pe++)se=Se.charCodeAt(Pe),Math.random()>.5&&(se="x"+se.toString(16)),ye+="&#"+se+";";return ye}var je=function(){function Se(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||Ce,this.options.tokenizer=this.options.tokenizer||new Z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Ne.normal,inline:Me.normal};this.options.pedantic?(se.block=Ne.pedantic,se.inline=Me.pedantic):this.options.gfm&&(se.block=Ne.gfm,this.options.breaks?se.inline=Me.breaks:se.inline=Me.gfm),this.tokenizer.rules=se}Se.lex=function(se,le){var he=new Se(le);return he.lex(se)},Se.lexInline=function(se,le){var he=new Se(le);return he.inlineTokens(se)};var ye=Se.prototype;return ye.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(se,le,he){le===void 0&&(le=[]),he===void 0&&(he=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var pe,x,fe,we;se;){if(pe=this.tokenizer.space(se)){se=se.substring(pe.raw.length),pe.type&&le.push(pe);continue}if(pe=this.tokenizer.code(se)){se=se.substring(pe.raw.length),we=le[le.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):le.push(pe);continue}if(pe=this.tokenizer.fences(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.heading(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.nptable(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.hr(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.blockquote(se)){se=se.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],he),le.push(pe);continue}if(pe=this.tokenizer.list(se)){for(se=se.substring(pe.raw.length),fe=pe.items.length,x=0;x<fe;x++)pe.items[x].tokens=this.blockTokens(pe.items[x].text,[],!1);le.push(pe);continue}if(pe=this.tokenizer.html(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(he&&(pe=this.tokenizer.def(se))){se=se.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.lheading(se)){se=se.substring(pe.raw.length),le.push(pe);continue}if(he&&(pe=this.tokenizer.paragraph(se))){se=se.substring(pe.raw.length),le.push(pe);continue}if(pe=this.tokenizer.text(se)){se=se.substring(pe.raw.length),we=le[le.length-1],we&&we.type==="text"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):le.push(pe);continue}if(se){var Ie="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return le},ye.inline=function(se){var le,he,pe,x,fe,we,Ie=se.length;for(le=0;le<Ie;le++)switch(we=se[le],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},x=we.header.length,he=0;he<x;he++)we.tokens.header[he]=[],this.inlineTokens(we.header[he],we.tokens.header[he]);for(x=we.cells.length,he=0;he<x;he++)for(fe=we.cells[he],we.tokens.cells[he]=[],pe=0;pe<fe.length;pe++)we.tokens.cells[he][pe]=[],this.inlineTokens(fe[pe],we.tokens.cells[he][pe]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(x=we.items.length,he=0;he<x;he++)this.inline(we.items[he].tokens);break}}return se},ye.inlineTokens=function(se,le,he,pe){le===void 0&&(le=[]),he===void 0&&(he=!1),pe===void 0&&(pe=!1);var x,fe,we=se,Ie,Oe,He;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)Ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Ie.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(Oe||(He=""),Oe=!1,x=this.tokenizer.escape(se)){se=se.substring(x.raw.length),le.push(x);continue}if(x=this.tokenizer.tag(se,he,pe)){se=se.substring(x.raw.length),he=x.inLink,pe=x.inRawBlock;var Ke=le[le.length-1];Ke&&x.type==="text"&&Ke.type==="text"?(Ke.raw+=x.raw,Ke.text+=x.text):le.push(x);continue}if(x=this.tokenizer.link(se)){se=se.substring(x.raw.length),x.type==="link"&&(x.tokens=this.inlineTokens(x.text,[],!0,pe)),le.push(x);continue}if(x=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(x.raw.length);var Je=le[le.length-1];x.type==="link"?(x.tokens=this.inlineTokens(x.text,[],!0,pe),le.push(x)):Je&&x.type==="text"&&Je.type==="text"?(Je.raw+=x.raw,Je.text+=x.text):le.push(x);continue}if(x=this.tokenizer.emStrong(se,we,He)){se=se.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],he,pe),le.push(x);continue}if(x=this.tokenizer.codespan(se)){se=se.substring(x.raw.length),le.push(x);continue}if(x=this.tokenizer.br(se)){se=se.substring(x.raw.length),le.push(x);continue}if(x=this.tokenizer.del(se)){se=se.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],he,pe),le.push(x);continue}if(x=this.tokenizer.autolink(se,qe)){se=se.substring(x.raw.length),le.push(x);continue}if(!he&&(x=this.tokenizer.url(se,qe))){se=se.substring(x.raw.length),le.push(x);continue}if(x=this.tokenizer.inlineText(se,pe,Xe)){se=se.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(He=x.raw.slice(-1)),Oe=!0,fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=x.raw,fe.text+=x.text):le.push(x);continue}if(se){var ut="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ut);break}else throw new Error(ut)}}return le},e(Se,null,[{key:"rules",get:function(){return{block:Ne,inline:Me}}}]),Se}(),O=k.defaults,K=F.cleanUrl,X=F.escape,re=function(){function Se(Pe){this.options=Pe||O}var ye=Se.prototype;return ye.code=function(se,le,he){var pe=(le||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(se,pe);x!=null&&x!==se&&(he=!0,se=x)}return se=se.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+X(pe,!0)+'">'+(he?se:X(se,!0))+`</code></pre>
`:"<pre><code>"+(he?se:X(se,!0))+`</code></pre>
`},ye.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ye.html=function(se){return se},ye.heading=function(se,le,he,pe){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+pe.slug(he)+'">'+se+"</h"+le+`>
`:"<h"+le+">"+se+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(se,le,he){var pe=le?"ol":"ul",x=le&&he!==1?' start="'+he+'"':"";return"<"+pe+x+`>
`+se+"</"+pe+`>
`},ye.listitem=function(se){return"<li>"+se+`</li>
`},ye.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(se){return"<p>"+se+`</p>
`},ye.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},ye.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ye.tablecell=function(se,le){var he=le.header?"th":"td",pe=le.align?"<"+he+' align="'+le.align+'">':"<"+he+">";return pe+se+"</"+he+`>
`},ye.strong=function(se){return"<strong>"+se+"</strong>"},ye.em=function(se){return"<em>"+se+"</em>"},ye.codespan=function(se){return"<code>"+se+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(se){return"<del>"+se+"</del>"},ye.link=function(se,le,he){if(se=K(this.options.sanitize,this.options.baseUrl,se),se===null)return he;var pe='<a href="'+X(se)+'"';return le&&(pe+=' title="'+le+'"'),pe+=">"+he+"</a>",pe},ye.image=function(se,le,he){if(se=K(this.options.sanitize,this.options.baseUrl,se),se===null)return he;var pe='<img src="'+se+'" alt="'+he+'"';return le&&(pe+=' title="'+le+'"'),pe+=this.options.xhtml?"/>":">",pe},ye.text=function(se){return se},Se}(),q=function(){function Se(){}var ye=Se.prototype;return ye.strong=function(se){return se},ye.em=function(se){return se},ye.codespan=function(se){return se},ye.del=function(se){return se},ye.html=function(se){return se},ye.text=function(se){return se},ye.link=function(se,le,he){return""+he},ye.image=function(se,le,he){return""+he},ye.br=function(){return""},Se}(),ie=function(){function Se(){this.seen={}}var ye=Se.prototype;return ye.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(se,le){var he=se,pe=0;if(this.seen.hasOwnProperty(he)){pe=this.seen[se];do pe++,he=se+"-"+pe;while(this.seen.hasOwnProperty(he))}return le||(this.seen[se]=pe,this.seen[he]=0),he},ye.slug=function(se,le){le===void 0&&(le={});var he=this.serialize(se);return this.getNextSafeSlug(he,le.dryrun)},Se}(),ge=k.defaults,Re=F.unescape,We=function(){function Se(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ie}Se.parse=function(se,le){var he=new Se(le);return he.parse(se)},Se.parseInline=function(se,le){var he=new Se(le);return he.parseInline(se)};var ye=Se.prototype;return ye.parse=function(se,le){le===void 0&&(le=!0);var he="",pe,x,fe,we,Ie,Oe,He,Ze,Ke,Je,ut,mt,bt,ot,at,_e,ke,Q,W=se.length;for(pe=0;pe<W;pe++)switch(Je=se[pe],Je.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Re(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(Ze="",He="",we=Je.header.length,x=0;x<we;x++)He+=this.renderer.tablecell(this.parseInline(Je.tokens.header[x]),{header:!0,align:Je.align[x]});for(Ze+=this.renderer.tablerow(He),Ke="",we=Je.cells.length,x=0;x<we;x++){for(Oe=Je.tokens.cells[x],He="",Ie=Oe.length,fe=0;fe<Ie;fe++)He+=this.renderer.tablecell(this.parseInline(Oe[fe]),{header:!1,align:Je.align[fe]});Ke+=this.renderer.tablerow(He)}he+=this.renderer.table(Ze,Ke);continue}case"blockquote":{Ke=this.parse(Je.tokens),he+=this.renderer.blockquote(Ke);continue}case"list":{for(ut=Je.ordered,mt=Je.start,bt=Je.loose,we=Je.items.length,Ke="",x=0;x<we;x++)at=Je.items[x],_e=at.checked,ke=at.task,ot="",at.task&&(Q=this.renderer.checkbox(_e),bt?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=Q+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=Q+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:Q}):ot+=Q),ot+=this.parse(at.tokens,bt),Ke+=this.renderer.listitem(ot,ke,_e);he+=this.renderer.list(Ke,ut,mt);continue}case"html":{he+=this.renderer.html(Je.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Ke=Je.tokens?this.parseInline(Je.tokens):Je.text;pe+1<W&&se[pe+1].type==="text";)Je=se[++pe],Ke+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);he+=le?this.renderer.paragraph(Ke):Ke;continue}default:{var Fe='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return he},ye.parseInline=function(se,le){le=le||this.renderer;var he="",pe,x,fe=se.length;for(pe=0;pe<fe;pe++)switch(x=se[pe],x.type){case"escape":{he+=le.text(x.text);break}case"html":{he+=le.html(x.text);break}case"link":{he+=le.link(x.href,x.title,this.parseInline(x.tokens,le));break}case"image":{he+=le.image(x.href,x.title,x.text);break}case"strong":{he+=le.strong(this.parseInline(x.tokens,le));break}case"em":{he+=le.em(this.parseInline(x.tokens,le));break}case"codespan":{he+=le.codespan(x.text);break}case"br":{he+=le.br();break}case"del":{he+=le.del(this.parseInline(x.tokens,le));break}case"text":{he+=le.text(x.text);break}default:{var we='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return he},Se}(),ve=F.merge,Ye=F.checkSanitizeDeprecation,z=F.escape,ee=k.getDefaults,ce=k.changeDefaults,Ue=k.defaults;function xe(Se,ye,Pe){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ye=="function"&&(Pe=ye,ye=null),ye=ve({},xe.defaults,ye||{}),Ye(ye),Pe){var se=ye.highlight,le;try{le=je.lex(Se,ye)}catch(fe){return Pe(fe)}var he=function(we){var Ie;if(!we)try{Ie=We.parse(le,ye)}catch(Oe){we=Oe}return ye.highlight=se,we?Pe(we):Pe(null,Ie)};if(!se||se.length<3||(delete ye.highlight,!le.length))return he();var pe=0;xe.walkTokens(le,function(fe){fe.type==="code"&&(pe++,setTimeout(function(){se(fe.text,fe.lang,function(we,Ie){if(we)return he(we);Ie!=null&&Ie!==fe.text&&(fe.text=Ie,fe.escaped=!0),pe--,pe===0&&he()})},0))}),pe===0&&he();return}try{var x=je.lex(Se,ye);return ye.walkTokens&&xe.walkTokens(x,ye.walkTokens),We.parse(x,ye)}catch(fe){if(fe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+z(fe.message+"",!0)+"</pre>";throw fe}}xe.options=xe.setOptions=function(Se){return ve(xe.defaults,Se),ce(xe.defaults),xe},xe.getDefaults=ee,xe.defaults=Ue,xe.use=function(Se){var ye=ve({},Se);if(Se.renderer&&function(){var se=xe.defaults.renderer||new re,le=function(x){var fe=se[x];se[x]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=Se.renderer[x].apply(se,Ie);return He===!1&&(He=fe.apply(se,Ie)),He}};for(var he in Se.renderer)le(he);ye.renderer=se}(),Se.tokenizer&&function(){var se=xe.defaults.tokenizer||new Z,le=function(x){var fe=se[x];se[x]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=Se.tokenizer[x].apply(se,Ie);return He===!1&&(He=fe.apply(se,Ie)),He}};for(var he in Se.tokenizer)le(he);ye.tokenizer=se}(),Se.walkTokens){var Pe=xe.defaults.walkTokens;ye.walkTokens=function(se){Se.walkTokens(se),Pe&&Pe(se)}}xe.setOptions(ye)},xe.walkTokens=function(Se,ye){for(var Pe=S(Se),se;!(se=Pe()).done;){var le=se.value;switch(ye(le),le.type){case"table":{for(var he=S(le.tokens.header),pe;!(pe=he()).done;){var x=pe.value;xe.walkTokens(x,ye)}for(var fe=S(le.tokens.cells),we;!(we=fe()).done;)for(var Ie=we.value,Oe=S(Ie),He;!(He=Oe()).done;){var Ze=He.value;xe.walkTokens(Ze,ye)}break}case"list":{xe.walkTokens(le.items,ye);break}default:le.tokens&&xe.walkTokens(le.tokens,ye)}}},xe.parseInline=function(Se,ye){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ye=ve({},xe.defaults,ye||{}),Ye(ye);try{var Pe=je.lexInline(Se,ye);return ye.walkTokens&&xe.walkTokens(Pe,ye.walkTokens),We.parseInline(Pe,ye)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+z(se.message+"",!0)+"</pre>";throw se}},xe.Parser=We,xe.parser=We.parse,xe.Renderer=re,xe.TextRenderer=q,xe.Lexer=je,xe.lexer=je.lex,xe.Tokenizer=Z,xe.Slugger=ie,xe.parse=xe;var et=xe;return et}),define(be[81],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(k,y,_){return Math.min(Math.max(k,y),_)}e.clamp=g;function R(k,y){return(y+k%y)%y}e.rot=R;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class E{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function te(S){const E=[];typeof S=="number"&&E.push("code/timeOrigin",S);function k(_){E.push(_,Date.now())}function y(){const _=[];for(let C=0;C<E.length;C+=2)_.push({name:E[C],startTime:E[C+1]});return _}return{mark:k,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))E.push({name:k.name,startTime:Math.round(S+k.startTime)});return E}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function g(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=g(R))}(),define(be[22],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let R=!1,S=!1,E=!1,k=!1,y=!1,_=!1,C=!1,n,I=g,l,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const f=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=f&&u?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=u?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!f)d=navigator.userAgent,R=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,C=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=d.indexOf("Linux")>=0,_=!0,n=navigator.language,I=n;else if(typeof u=="object"){R=u.platform==="win32",S=u.platform==="darwin",E=u.platform==="linux",k=E&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=g,I=g;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),c=i.availableLanguages["*"];n=i.locale,I=c||g,l=i._translationsConfigFile}catch(i){}y=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let P=0;S?P=1:R?P=3:E&&(P=2),e.isWindows=R,e.isMacintosh=S,e.isLinux=E,e.isLinuxSnap=k,e.isNative=y,e.isWeb=_,e.isIOS=C,e.platform=P,e.userAgent=d,e.language=I;var a;(function(s){function i(){return e.language}s.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function m(){return e.language==="en"}s.isDefault=m})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let D=0,T=c.length;D<T;D++){const o=c[D];if(o.id===p.data.vscodeSetImmediateId){c.splice(D,1),o.callback();return}}});let m=0;return p=>{const D=++m;c.push({id:D,callback:p}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var h;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||C?2:R?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(be[42],Ee([0,1,22]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const S=g.globals.vscode.process;R={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(E){return(0,g.setImmediate)(E)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:R={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(S){return(0,g.setImmediate)(S)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[14],Ee([0,1,42]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,S=97,E=90,k=122,y=46,_=47,C=92,n=58,I=63;class l extends Error{constructor(h,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const s=h.indexOf(".")!==-1?"property":"argument";let i=`The "${h}" ${s} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function d(a,h){if(typeof a!="string")throw new l(h,"string",a)}function u(a){return a===_||a===C}function f(a){return a===_}function b(a){return a>=R&&a<=E||a>=S&&a<=k}function w(a,h,v,t){let r="",s=0,i=-1,c=0,m=0;for(let p=0;p<=a.length;++p){if(p<a.length)m=a.charCodeAt(p);else{if(t(m))break;m=_}if(t(m)){if(!(i===p-1||c===1))if(c===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const D=r.lastIndexOf(v);D===-1?(r="",s=0):(r=r.slice(0,D),s=r.length-1-r.lastIndexOf(v)),i=p,c=0;continue}else if(r.length!==0){r="",s=0,i=p,c=0;continue}}h&&(r+=r.length>0?`${v}..`:"..",s=2)}else r.length>0?r+=`${v}${a.slice(i+1,p)}`:r=a.slice(i+1,p),s=p-i-1;i=p,c=0}else m===y&&c!==-1?++c:c=-1}return r}function P(a,h){if(h===null||typeof h!="object")throw new l("pathObject","Object",h);const v=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return v?v===h.root?`${v}${t}`:`${v}${a}${t}`:t}e.win32={resolve(...a){let h="",v="",t=!1;for(let r=a.length-1;r>=-1;r--){let s;if(r>=0){if(s=a[r],d(s,"path"),s.length===0)continue}else h.length===0?s=g.cwd():(s=g.env[`=${h}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${h}\\`));const i=s.length;let c=0,m="",p=!1;const D=s.charCodeAt(0);if(i===1)u(D)&&(c=1,p=!0);else if(u(D))if(p=!0,u(s.charCodeAt(1))){let T=2,o=T;for(;T<i&&!u(s.charCodeAt(T));)T++;if(T<i&&T!==o){const A=s.slice(o,T);for(o=T;T<i&&u(s.charCodeAt(T));)T++;if(T<i&&T!==o){for(o=T;T<i&&!u(s.charCodeAt(T));)T++;(T===i||T!==o)&&(m=`\\\\${A}\\${s.slice(o,T)}`,c=T)}}}else c=1;else b(D)&&s.charCodeAt(1)===n&&(m=s.slice(0,2),c=2,i>2&&u(s.charCodeAt(2))&&(p=!0,c=3));if(m.length>0)if(h.length>0){if(m.toLowerCase()!==h.toLowerCase())continue}else h=m;if(t){if(h.length>0)break}else if(v=`${s.slice(c)}\\${v}`,t=p,p&&h.length>0)break}return v=w(v,!t,"\\",u),t?`${h}\\${v}`:`${h}${v}`||"."},normalize(a){d(a,"path");const h=a.length;if(h===0)return".";let v=0,t,r=!1;const s=a.charCodeAt(0);if(h===1)return f(s)?"\\":a;if(u(s))if(r=!0,u(a.charCodeAt(1))){let c=2,m=c;for(;c<h&&!u(a.charCodeAt(c));)c++;if(c<h&&c!==m){const p=a.slice(m,c);for(m=c;c<h&&u(a.charCodeAt(c));)c++;if(c<h&&c!==m){for(m=c;c<h&&!u(a.charCodeAt(c));)c++;if(c===h)return`\\\\${p}\\${a.slice(m)}\\`;c!==m&&(t=`\\\\${p}\\${a.slice(m,c)}`,v=c)}}}else v=1;else b(s)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),v=2,h>2&&u(a.charCodeAt(2))&&(r=!0,v=3));let i=v<h?w(a.slice(v),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(a.charCodeAt(h-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){d(a,"path");const h=a.length;if(h===0)return!1;const v=a.charCodeAt(0);return u(v)||h>2&&b(v)&&a.charCodeAt(1)===n&&u(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let h,v;for(let s=0;s<a.length;++s){const i=a[s];d(i,"path"),i.length>0&&(h===void 0?h=v=i:h+=`\\${i}`)}if(h===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++r;const s=v.length;s>1&&u(v.charCodeAt(1))&&(++r,s>2&&(u(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<h.length&&u(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(a,h){if(d(a,"from"),d(h,"to"),a===h)return"";const v=e.win32.resolve(a),t=e.win32.resolve(h);if(v===t||(a=v.toLowerCase(),h=t.toLowerCase(),a===h))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===C;)r++;let s=a.length;for(;s-1>r&&a.charCodeAt(s-1)===C;)s--;const i=s-r;let c=0;for(;c<h.length&&h.charCodeAt(c)===C;)c++;let m=h.length;for(;m-1>c&&h.charCodeAt(m-1)===C;)m--;const p=m-c,D=i<p?i:p;let T=-1,o=0;for(;o<D;o++){const F=a.charCodeAt(r+o);if(F!==h.charCodeAt(c+o))break;F===C&&(T=o)}if(o!==D){if(T===-1)return t}else{if(p>D){if(h.charCodeAt(c+o)===C)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}i>D&&(a.charCodeAt(r+o)===C?T=o:o===2&&(T=3)),T===-1&&(T=0)}let A="";for(o=r+T+1;o<=s;++o)(o===s||a.charCodeAt(o)===C)&&(A+=A.length===0?"..":"\\..");return c+=T,A.length>0?`${A}${t.slice(c,m)}`:(t.charCodeAt(c)===C&&++c,t.slice(c,m))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const h=e.win32.resolve(a);if(h.length<=2)return a;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const v=h.charCodeAt(2);if(v!==I&&v!==y)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(b(h.charCodeAt(0))&&h.charCodeAt(1)===n&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return a},dirname(a){d(a,"path");const h=a.length;if(h===0)return".";let v=-1,t=0;const r=a.charCodeAt(0);if(h===1)return u(r)?a:".";if(u(r)){if(v=t=1,u(a.charCodeAt(1))){let c=2,m=c;for(;c<h&&!u(a.charCodeAt(c));)c++;if(c<h&&c!==m){for(m=c;c<h&&u(a.charCodeAt(c));)c++;if(c<h&&c!==m){for(m=c;c<h&&!u(a.charCodeAt(c));)c++;if(c===h)return a;c!==m&&(v=t=c+1)}}}}else b(r)&&a.charCodeAt(1)===n&&(v=h>2&&u(a.charCodeAt(2))?3:2,t=v);let s=-1,i=!0;for(let c=h-1;c>=t;--c)if(u(a.charCodeAt(c))){if(!i){s=c;break}}else i=!1;if(s===-1){if(v===-1)return".";s=v}return a.slice(0,s)},basename(a,h){h!==void 0&&d(h,"ext"),d(a,"path");let v=0,t=-1,r=!0,s;if(a.length>=2&&b(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(v=2),h!==void 0&&h.length>0&&h.length<=a.length){if(h===a)return"";let i=h.length-1,c=-1;for(s=a.length-1;s>=v;--s){const m=a.charCodeAt(s);if(u(m)){if(!r){v=s+1;break}}else c===-1&&(r=!1,c=s+1),i>=0&&(m===h.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=v;--s)if(u(a.charCodeAt(s))){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){d(a,"path");let h=0,v=-1,t=0,r=-1,s=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&b(a.charCodeAt(0))&&(h=t=2);for(let c=a.length-1;c>=h;--c){const m=a.charCodeAt(c);if(u(m)){if(!s){t=c+1;break}continue}r===-1&&(s=!1,r=c+1),m===y?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":a.slice(v,r)},format:P.bind(null,"\\"),parse(a){d(a,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return h;const v=a.length;let t=0,r=a.charCodeAt(0);if(v===1)return u(r)?(h.root=h.dir=a,h):(h.base=h.name=a,h);if(u(r)){if(t=1,u(a.charCodeAt(1))){let T=2,o=T;for(;T<v&&!u(a.charCodeAt(T));)T++;if(T<v&&T!==o){for(o=T;T<v&&u(a.charCodeAt(T));)T++;if(T<v&&T!==o){for(o=T;T<v&&!u(a.charCodeAt(T));)T++;T===v?t=T:T!==o&&(t=T+1)}}}}else if(b(r)&&a.charCodeAt(1)===n){if(v<=2)return h.root=h.dir=a,h;if(t=2,u(a.charCodeAt(2))){if(v===3)return h.root=h.dir=a,h;t=3}}t>0&&(h.root=a.slice(0,t));let s=-1,i=t,c=-1,m=!0,p=a.length-1,D=0;for(;p>=t;--p){if(r=a.charCodeAt(p),u(r)){if(!m){i=p+1;break}continue}c===-1&&(m=!1,c=p+1),r===y?s===-1?s=p:D!==1&&(D=1):s!==-1&&(D=-1)}return c!==-1&&(s===-1||D===0||D===1&&s===c-1&&s===i+1?h.base=h.name=a.slice(i,c):(h.name=a.slice(i,s),h.base=a.slice(i,c),h.ext=a.slice(s,c))),i>0&&i!==t?h.dir=a.slice(0,i-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let h="",v=!1;for(let t=a.length-1;t>=-1&&!v;t--){const r=t>=0?a[t]:g.cwd();d(r,"path"),r.length!==0&&(h=`${r}/${h}`,v=r.charCodeAt(0)===_)}return h=w(h,!v,"/",f),v?`/${h}`:h.length>0?h:"."},normalize(a){if(d(a,"path"),a.length===0)return".";const h=a.charCodeAt(0)===_,v=a.charCodeAt(a.length-1)===_;return a=w(a,!h,"/",f),a.length===0?h?"/":v?"./":".":(v&&(a+="/"),h?`/${a}`:a)},isAbsolute(a){return d(a,"path"),a.length>0&&a.charCodeAt(0)===_},join(...a){if(a.length===0)return".";let h;for(let v=0;v<a.length;++v){const t=a[v];d(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(a,h){if(d(a,"from"),d(h,"to"),a===h||(a=e.posix.resolve(a),h=e.posix.resolve(h),a===h))return"";const v=1,t=a.length,r=t-v,s=1,i=h.length-s,c=r<i?r:i;let m=-1,p=0;for(;p<c;p++){const T=a.charCodeAt(v+p);if(T!==h.charCodeAt(s+p))break;T===_&&(m=p)}if(p===c)if(i>c){if(h.charCodeAt(s+p)===_)return h.slice(s+p+1);if(p===0)return h.slice(s+p)}else r>c&&(a.charCodeAt(v+p)===_?m=p:p===0&&(m=0));let D="";for(p=v+m+1;p<=t;++p)(p===t||a.charCodeAt(p)===_)&&(D+=D.length===0?"..":"/..");return`${D}${h.slice(s+m)}`},toNamespacedPath(a){return a},dirname(a){if(d(a,"path"),a.length===0)return".";const h=a.charCodeAt(0)===_;let v=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===_){if(!t){v=r;break}}else t=!1;return v===-1?h?"/":".":h&&v===1?"//":a.slice(0,v)},basename(a,h){h!==void 0&&d(h,"ext"),d(a,"path");let v=0,t=-1,r=!0,s;if(h!==void 0&&h.length>0&&h.length<=a.length){if(h===a)return"";let i=h.length-1,c=-1;for(s=a.length-1;s>=0;--s){const m=a.charCodeAt(s);if(m===_){if(!r){v=s+1;break}}else c===-1&&(r=!1,c=s+1),i>=0&&(m===h.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===_){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){d(a,"path");let h=-1,v=0,t=-1,r=!0,s=0;for(let i=a.length-1;i>=0;--i){const c=a.charCodeAt(i);if(c===_){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),c===y?h===-1?h=i:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===v+1?"":a.slice(h,t)},format:P.bind(null,"/"),parse(a){d(a,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return h;const v=a.charCodeAt(0)===_;let t;v?(h.root="/",t=1):t=0;let r=-1,s=0,i=-1,c=!0,m=a.length-1,p=0;for(;m>=t;--m){const D=a.charCodeAt(m);if(D===_){if(!c){s=m+1;break}continue}i===-1&&(c=!1,i=m+1),D===y?r===-1?r=m:p!==1&&(p=1):r!==-1&&(p=-1)}if(i!==-1){const D=s===0&&v?1:s;r===-1||p===0||p===1&&r===i-1&&r===s+1?h.base=h.name=a.slice(D,i):(h.name=a.slice(D,r),h.base=a.slice(D,i),h.ext=a.slice(r,i))}return s>0?h.dir=a.slice(0,s-1):v&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],Ee([0,1,22]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=g.globals.performance&&typeof g.globals.performance.now=="function";class S{constructor(k){this._highResolution=R&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new S(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=S}),define(be[3],Ee([0,1,12,52,6,80,55]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(a){a.None=()=>S.Disposable.None;function h(G){return(B,$=null,L)=>{let Z=!1,V;return V=G(Y=>{if(!Z)return V?V.dispose():Z=!0,B.call($,Y)},null,L),Z&&V.dispose(),V}}a.once=h;function v(G,B){return m(($,L=null,Z)=>G(V=>$.call(L,B(V)),null,Z))}a.map=v;function t(G,B){return m(($,L=null,Z)=>G(V=>{B(V),$.call(L,V)},null,Z))}a.forEach=t;function r(G,B){return m(($,L=null,Z)=>G(V=>B(V)&&$.call(L,V),null,Z))}a.filter=r;function s(G){return G}a.signal=s;function i(...G){return(B,$=null,L)=>(0,S.combinedDisposable)(...G.map(Z=>Z(V=>B.call($,V),null,L)))}a.any=i;function c(G,B,$){let L=$;return v(G,Z=>(L=B(L,Z),L))}a.reduce=c;function m(G){let B;const $=new l({onFirstListenerAdd(){B=G($.fire,$)},onLastListenerRemove(){B.dispose()}});return $.event}function p(G,B,$=100,L=!1,Z){let V,Y,me,H=0;const oe=new l({leakWarningThreshold:Z,onFirstListenerAdd(){V=G(de=>{H++,Y=B(Y,de),L&&!me&&(oe.fire(Y),Y=void 0),clearTimeout(me),me=setTimeout(()=>{const Ce=Y;Y=void 0,me=void 0,(!L||H>1)&&oe.fire(Ce),H=0},$)})},onLastListenerRemove(){V.dispose()}});return oe.event}a.debounce=p;function D(G,B=($,L)=>$===L){let $=!0,L;return r(G,Z=>{const V=$||!B(Z,L);return $=!1,L=Z,V})}a.latch=D;function T(G,B){return[a.filter(G,B),a.filter(G,$=>!B($))]}a.split=T;function o(G,B=!1,$=[]){let L=$.slice(),Z=G(me=>{L?L.push(me):Y.fire(me)});const V=()=>{L&&L.forEach(me=>Y.fire(me)),L=null},Y=new l({onFirstListenerAdd(){Z||(Z=G(me=>Y.fire(me)))},onFirstListenerDidAdd(){L&&(B?setTimeout(V):V())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return Y.event}a.buffer=o;class A{constructor(B){this.event=B}map(B){return new A(v(this.event,B))}forEach(B){return new A(t(this.event,B))}filter(B){return new A(r(this.event,B))}reduce(B,$){return new A(c(this.event,B,$))}latch(){return new A(D(this.event))}debounce(B,$=100,L=!1,Z){return new A(p(this.event,B,$,L,Z))}on(B,$,L){return this.event(B,$,L)}once(B,$,L){return h(this.event)(B,$,L)}}function F(G){return new A(G)}a.chain=F;function U(G,B,$=L=>L){const L=(...me)=>Y.fire($(...me)),Z=()=>G.on(B,L),V=()=>G.removeListener(B,L),Y=new l({onFirstListenerAdd:Z,onLastListenerRemove:V});return Y.event}a.fromNodeEventEmitter=U;function j(G,B,$=L=>L){const L=(...me)=>Y.fire($(...me)),Z=()=>G.addEventListener(B,L),V=()=>G.removeEventListener(B,L),Y=new l({onFirstListenerAdd:Z,onLastListenerRemove:V});return Y.event}a.fromDOMEventEmitter=j;function ae(G){return new Promise(B=>h(G)(B))}a.toPromise=ae})(y=e.Event||(e.Event={}));class _{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${_._idPool++}`}start(h){this._stopWatch=new k.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function n(a){const h=C;return C=a,{dispose(){C=h}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(h,v=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let v=C;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||h<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let s,i=0;for(const[c,m]of this._stacks)(!s||i<m)&&(s=c,i=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class l{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(h,v,t)=>{this._listeners||(this._listeners=new E.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(v?[h,v]:h);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,S.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof S.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class d extends l{async fireAsync(h,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,h]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],c={...s,waitUntil:m=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(m=t(m,typeof r=="function"?r:r[0])),i.push(m)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(m){(0,g.onUnexpectedError)(m);continue}Object.freeze(i),await Promise.allSettled(i).then(m=>{for(const p of m)p.status==="rejected"&&(0,g.onUnexpectedError)(p.reason)})}}}}e.AsyncEmitter=d;class u extends l{constructor(h){super(h);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=u;class f extends u{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=f;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const v={event:h,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,S.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(v=>this.emitter.fire(v))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class w{constructor(){this.buffers=[]}wrapEvent(h){return(v,t,r)=>h(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,s)):v.call(t,s)},void 0,r)}bufferEvents(h){const v=[];this.buffers.push(v);const t=h();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=w;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=S.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(be[20],Ee([0,1,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(y,_){const C=setTimeout(y.bind(_),0);return{dispose(){clearTimeout(C)}}});var S;(function(y){function _(C){return C===y.None||C===y.Cancelled||C instanceof E?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}y.isCancellationToken=_,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(S=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=S.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=k}),define(be[35],Ee([0,1,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new R;e.iconRegistry=S;function E(n,I){return new y(n,I)}e.registerCodicon=E;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=k;class y{constructor(I,l,d){this.id=I,this.definition=l,this.description=d,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function _(n,I){const l=["codicon","codicon-"+n];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=_;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(f){if(f instanceof y)return["codicon","codicon-"+f.id];const b=I.exec(f.id);if(!b)return l(y.error);let[,w,P]=b;const a=["codicon","codicon-"+w];return P&&a.push("codicon-modifier-"+P.substr(1)),a}n.asClassNameArray=l;function d(f){return l(f).join(" ")}n.asClassName=d;function u(f){return"."+l(f).join(".")}n.asCSSSelector=u})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(be[113],Ee([0,1,12,6]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=S;function E(a){const h=a;return h?S(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=E;function k(a,h){return new y(a,h)}e.newWriteableStream=k;class y{constructor(h,v){this.reducer=h,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(v=>v(h))}emitError(h){this.listeners.error.length===0?(0,g.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(v=>v(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,v){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(h,v){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(a,h){const v=[];let t;for(;(t=a.read())!==null;)v.push(t);return h(v)}e.consumeReadable=_;function C(a,h,v){const t=[];let r;for(;(r=a.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=C;function n(a,h){return new Promise((v,t)=>{const r=[];I(a,{onData:s=>{h&&r.push(s)},onError:s=>{h?t(s):v(void 0)},onEnd:()=>{v(h?h(r):void 0)}})})}e.consumeStream=n;function I(a,h){a.on("error",v=>h.onError(v)),a.on("end",()=>h.onEnd()),a.on("data",v=>h.onData(v))}e.listenStream=I;function l(a,h){return new Promise((v,t)=>{const r=new R.DisposableStore,s=[],i=p=>{if(s.push(p),s.length>h)return r.dispose(),a.pause(),v({stream:a,buffer:s,ended:!1})},c=p=>t(p),m=()=>v({stream:a,buffer:s,ended:!0});r.add((0,R.toDisposable)(()=>a.removeListener("error",c))),a.on("error",c),r.add((0,R.toDisposable)(()=>a.removeListener("end",m))),a.on("end",m),r.add((0,R.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=l;function d(a,h){const v=k(h);return v.end(a),v}e.toStream=d;function u(){const a=k(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=u;function f(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}e.toReadable=f;function b(a,h,v){const t=k(v);return I(a,{onData:r=>t.write(h.data(r)),onError:r=>t.error(h.error?h.error(r):r),onEnd:()=>t.end()}),t}e.transform=b;function w(a,h,v){let t=!1;return{read:()=>{const r=h.read();return t?r:(t=!0,r!==null?v([a,r]):a)}}}e.prefixedReadable=w;function P(a,h,v){let t=!1;const r=k(v);return I(h,{onData:s=>t?r.write(s):(t=!0,r.write(v([a,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(a)),r.end()}}),r}e.prefixedStream=P}),define(be[8],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=g;const R=/{(\d+)}/g;function S(x,...fe){return fe.length===0?x:x.replace(R,function(we,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=fe.length?we:fe[Oe]})}e.format=S;const E=/{([^}]+)}/g;function k(x,fe){return x.replace(E,(we,Ie)=>fe[Ie]??we)}e.format2=k;function y(x){return x.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.escape=y;function _(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function C(x,fe){let we=0;const Ie=fe.charCodeAt(0);for(let Oe=x.length-1;Oe>=0;Oe--)x.charCodeAt(Oe)===Ie&&we++;return we}e.count=C;function n(x,fe,we="\u2026"){return x.length<=fe?x:`${x.substr(0,fe)}${we}`}e.truncate=n;function I(x,fe=" "){const we=l(x,fe);return d(we,fe)}e.trim=I;function l(x,fe){if(!x||!fe)return x;const we=fe.length;if(we===0||x.length===0)return x;let Ie=0;for(;x.indexOf(fe,Ie)===Ie;)Ie=Ie+we;return x.substring(Ie)}e.ltrim=l;function d(x,fe){if(!x||!fe)return x;const we=fe.length,Ie=x.length;if(we===0||Ie===0)return x;let Oe=Ie,He=-1;for(;He=x.lastIndexOf(fe,Oe-1),!(He===-1||He+we!==Oe);){if(He===0)return"";Oe=He}return x.substring(0,Oe)}e.rtrim=d;function u(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function f(x){return x.replace(/\*/g,"")}e.stripWildcards=f;function b(x,fe,we={}){if(!x)throw new Error("Cannot create regex from empty string");fe||(x=_(x)),we.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ie="";return we.global&&(Ie+="g"),we.matchCase||(Ie+="i"),we.multiline&&(Ie+="m"),we.unicode&&(Ie+="u"),new RegExp(x,Ie)}e.createRegExp=b;function w(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function P(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function a(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=a;function h(x){return x.split(/\r\n|\r|\n/)}e.splitLines=h;function v(x){for(let fe=0,we=x.length;fe<we;fe++){const Ie=x.charCodeAt(fe);if(Ie!==32&&Ie!==9)return fe}return-1}e.firstNonWhitespaceIndex=v;function t(x,fe=0,we=x.length){for(let Ie=fe;Ie<we;Ie++){const Oe=x.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return x.substring(fe,Ie)}return x.substring(fe,we)}e.getLeadingWhitespace=t;function r(x,fe=x.length-1){for(let we=fe;we>=0;we--){const Ie=x.charCodeAt(we);if(Ie!==32&&Ie!==9)return we}return-1}e.lastNonWhitespaceIndex=r;function s(x,fe){return x<fe?-1:x>fe?1:0}e.compare=s;function i(x,fe,we=0,Ie=x.length,Oe=0,He=fe.length){for(;we<Ie&&Oe<He;we++,Oe++){let Je=x.charCodeAt(we),ut=fe.charCodeAt(Oe);if(Je<ut)return-1;if(Je>ut)return 1}const Ze=Ie-we,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstring=i;function c(x,fe){return m(x,fe,0,x.length,0,fe.length)}e.compareIgnoreCase=c;function m(x,fe,we=0,Ie=x.length,Oe=0,He=fe.length){for(;we<Ie&&Oe<He;we++,Oe++){let Je=x.charCodeAt(we),ut=fe.charCodeAt(Oe);if(Je===ut)continue;const mt=Je-ut;if(!(mt===32&&D(ut))&&!(mt===-32&&D(Je)))return p(Je)&&p(ut)?mt:i(x.toLowerCase(),fe.toLowerCase(),we,Ie,Oe,He)}const Ze=Ie-we,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstringIgnoreCase=m;function p(x){return x>=97&&x<=122}e.isLowerAsciiLetter=p;function D(x){return x>=65&&x<=90}e.isUpperAsciiLetter=D;function T(x){return p(x)||D(x)}function o(x,fe){return x.length===fe.length&&A(x,fe)}e.equalsIgnoreCase=o;function A(x,fe,we=x.length){for(let Ie=0;Ie<we;Ie++){const Oe=x.charCodeAt(Ie),He=fe.charCodeAt(Ie);if(Oe!==He){if(T(Oe)&&T(He)){const Ze=Math.abs(Oe-He);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function F(x,fe){const we=fe.length;return fe.length>x.length?!1:A(x,fe,we)}e.startsWithIgnoreCase=F;function U(x,fe){let we,Ie=Math.min(x.length,fe.length);for(we=0;we<Ie;we++)if(x.charCodeAt(we)!==fe.charCodeAt(we))return we;return Ie}e.commonPrefixLength=U;function j(x,fe){let we,Ie=Math.min(x.length,fe.length);const Oe=x.length-1,He=fe.length-1;for(we=0;we<Ie;we++)if(x.charCodeAt(Oe-we)!==fe.charCodeAt(He-we))return we;return Ie}e.commonSuffixLength=j;function ae(x){return 55296<=x&&x<=56319}e.isHighSurrogate=ae;function G(x){return 56320<=x&&x<=57343}e.isLowSurrogate=G;function B(x,fe){return(x-55296<<10)+(fe-56320)+65536}e.computeCodePoint=B;function $(x,fe,we){const Ie=x.charCodeAt(we);if(ae(Ie)&&we+1<fe){const Oe=x.charCodeAt(we+1);if(G(Oe))return B(Ie,Oe)}return Ie}e.getNextCodePoint=$;function L(x,fe){const we=x.charCodeAt(fe-1);if(G(we)&&fe>1){const Ie=x.charCodeAt(fe-2);if(ae(Ie))return B(Ie,we)}return we}function Z(x,fe){const we=Se.getInstance(),Ie=fe,Oe=x.length,He=$(x,Oe,fe);fe+=He>=65536?2:1;let Ze=we.getGraphemeBreakType(He);for(;fe<Oe;){const Ke=$(x,Oe,fe),Je=we.getGraphemeBreakType(Ke);if(xe(Ze,Je))break;fe+=Ke>=65536?2:1,Ze=Je}return fe-Ie}e.nextCharLength=Z;function V(x,fe){const we=Se.getInstance(),Ie=fe,Oe=L(x,fe);fe-=Oe>=65536?2:1;let He=we.getGraphemeBreakType(Oe);for(;fe>0;){const Ze=L(x,fe),Ke=we.getGraphemeBreakType(Ze);if(xe(Ke,He))break;fe-=Ze>=65536?2:1,He=Ke}return Ie-fe}e.prevCharLength=V;function Y(x,fe){const we=Se.getInstance(),Ie=x.length,Oe=fe,He=$(x,Ie,fe),Ze=we.getGraphemeBreakType(He);fe+=He>=65536?2:1;let Ke=Ze;for(;fe<Ie;){const ut=$(x,Ie,fe),mt=we.getGraphemeBreakType(ut);if(xe(Ke,mt))break;fe+=ut>=65536?2:1,Ke=mt}const Je=fe;for(fe=Oe,Ke=Ze;fe>0;){const ut=L(x,fe),mt=we.getGraphemeBreakType(ut);if(xe(mt,Ke))break;fe-=ut>=65536?2:1,Ke=mt}return[fe,Je]}function me(x,fe){return fe>0&&G(x.charCodeAt(fe))?Y(x,fe-1):Y(x,fe)}e.getCharContainingOffset=me;function H(x){const fe=x.length;let we=0,Ie=0;for(;Ie<fe;){const Ze=$(x,fe,Ie);Ie+=Ze>=65536?2:1,Ze<128?we+=1:Ze<2048?we+=2:Ze<65536?we+=3:we+=4}const Oe=new Uint8Array(we);Ie=0;let He=0;for(;Ie<fe;){const Ze=$(x,fe,Ie);Ie+=Ze>=65536?2:1,Ze<128?Oe[He++]=Ze:Ze<2048?(Oe[He++]=192|(Ze&1984)>>>6,Oe[He++]=128|(Ze&63)>>>0):Ze<65536?(Oe[He++]=224|(Ze&61440)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0):(Oe[He++]=240|(Ze&1835008)>>>18,Oe[He++]=128|(Ze&258048)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0)}return Oe}e.encodeUTF8=H;function oe(x){const fe=x.byteLength,we=[];let Ie=0;for(;Ie<fe;){const Oe=x[Ie];let He;if(Oe>=240&&Ie+3<fe?He=(x[Ie++]&7)<<18>>>0|(x[Ie++]&63)<<12>>>0|(x[Ie++]&63)<<6>>>0|(x[Ie++]&63)<<0>>>0:Oe>=224&&Ie+2<fe?He=(x[Ie++]&15)<<12>>>0|(x[Ie++]&63)<<6>>>0|(x[Ie++]&63)<<0>>>0:Oe>=192&&Ie+1<fe?He=(x[Ie++]&31)<<6>>>0|(x[Ie++]&63)<<0>>>0:He=x[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const Ze=He-65536,Ke=55296+((Ze&1047552)>>>10),Je=56320+((Ze&1023)>>>0);we.push(String.fromCharCode(Ke)),we.push(String.fromCharCode(Je))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=oe;const de=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Ce(x){return de.test(x)}e.containsRTL=Ce;const Ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Me(x){return Ne.test(x)}e.containsEmoji=Me;const $e=/^[\t\n\r\x20-\x7E]*$/;function Xe(x){return $e.test(x)}e.isBasicASCII=Xe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function qe(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=qe;function je(x){for(let fe=0,we=x.length;fe<we;fe++)if(O(x.charCodeAt(fe)))return!0;return!1}e.containsFullWidthCharacter=je;function O(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=O;function K(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=K;function X(x,fe){if(x.length<fe)return x;const we=/\b/g;let Ie=0;for(;we.test(x)&&!(x.length-we.lastIndex<fe);)Ie=we.lastIndex,we.lastIndex+=1;return x.substring(Ie).replace(/^\s/,"")}e.lcut=X;const re=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ge(x){return x&&(x=x.replace(re,""),x=x.replace(q,""),x=x.replace(ie,"")),x}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function We(x){return Re(x)?x.substr(1):x}e.stripUTF8BOM=We;function ve(x,fe){if(!x||!fe||x.length<fe.length)return!1;const we=fe.length,Ie=x.toLowerCase();let Oe=0,He=-1;for(;Oe<we;){const Ze=Ie.indexOf(fe[Oe],He+1);if(Ze<0)return!1;He=Ze,Oe++}return!0}e.fuzzyContains=ve;function Ye(x,fe=!1){return x?(fe&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Ye;function z(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=z;function ee(x,fe=1){if(fe===0)return"";let we=-1;do we=x.indexOf(`
`,we+1),fe--;while(fe>0&&we>=0);return we===-1?x:(x[we-1]==="\r"&&we--,x.substr(0,we))}e.getNLines=ee;function ce(x){const fe=90-65+1;return x=x%(2*fe),x<fe?String.fromCharCode(97+x):String.fromCharCode(65+x-fe)}e.singleLetterHash=ce;function Ue(x){return Se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=Ue;function xe(x,fe){return x===0?fe!==5&&fe!==7:x===2&&fe===3?!1:x===4||x===2||x===3||fe===4||fe===2||fe===3?!0:!(x===8&&(fe===8||fe===9||fe===11||fe===12)||(x===11||x===9)&&(fe===9||fe===10)||(x===12||x===10)&&fe===10||fe===5||fe===13||fe===7||x===1||x===13&&fe===14||x===6&&fe===6)}e.breakBetweenGraphemeBreakType=xe;var et;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Se{constructor(){this._data=ye()}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const we=this._data,Ie=we.length/3;let Oe=1;for(;Oe<=Ie;)if(fe<we[3*Oe])Oe=2*Oe;else if(fe>we[3*Oe+1])Oe=2*Oe+1;else return we[3*Oe+2];return 0}}Se._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(x,fe){if(x===0)return 0;const we=se(x,fe);if(we!==void 0)return we;const Ie=L(fe,x);return x-=le(Ie),x}e.getLeftDeleteOffset=Pe;function se(x,fe){let we=L(fe,x);for(x-=le(we);he(we)||we===65039||we===8419;){if(x===0)return;we=L(fe,x),x-=le(we)}if(!!K(we)){if(x>=0){const Ie=L(fe,x);Ie===8205&&(x-=le(Ie))}return x}}function le(x){return x>=65536?2:1}function he(x){return 127995<=x&&x<=127999}var pe;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(pe||(pe={}))}),define(be[24],Ee([0,1,8,113]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let y,_;class C{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return S?new C(Buffer.allocUnsafe(p)):new C(new Uint8Array(p))}static wrap(p){return S&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new C(p)}static fromString(p,D){return!(D?.dontUseNodeBuffer||!1)&&S?new C(Buffer.from(p)):E?(y||(y=new TextEncoder),new C(y.encode(p))):new C(g.encodeUTF8(p))}static concat(p,D){if(typeof D=="undefined"){D=0;for(let A=0,F=p.length;A<F;A++)D+=p[A].byteLength}const T=C.alloc(D);let o=0;for(let A=0,F=p.length;A<F;A++){const U=p[A];T.set(U,o),o+=U.byteLength}return T}toString(){return S?this.buffer.toString():k?(_||(_=new TextDecoder),_.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(p,D){return new C(this.buffer.subarray(p,D))}set(p,D){p instanceof C?this.buffer.set(p.buffer,D):this.buffer.set(p,D)}readUInt32BE(p){return l(this.buffer,p)}writeUInt32BE(p,D){d(this.buffer,p,D)}readUInt32LE(p){return u(this.buffer,p)}writeUInt32LE(p,D){f(this.buffer,p,D)}readUInt8(p){return b(this.buffer,p)}writeUInt8(p,D){w(this.buffer,p,D)}}e.VSBuffer=C;function n(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}e.readUInt16LE=n;function I(m,p,D){m[D+0]=p&255,p=p>>>8,m[D+1]=p&255}e.writeUInt16LE=I;function l(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}e.readUInt32BE=l;function d(m,p,D){m[D+3]=p,p=p>>>8,m[D+2]=p,p=p>>>8,m[D+1]=p,p=p>>>8,m[D]=p}e.writeUInt32BE=d;function u(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}e.readUInt32LE=u;function f(m,p,D){m[D+0]=p&255,p=p>>>8,m[D+1]=p&255,p=p>>>8,m[D+2]=p&255,p=p>>>8,m[D+3]=p&255}e.writeUInt32LE=f;function b(m,p){return m[p]}e.readUInt8=b;function w(m,p,D){m[D]=p}e.writeUInt8=w;function P(m){return R.consumeReadable(m,p=>C.concat(p))}e.readableToBuffer=P;function a(m){return R.toReadable(m)}e.bufferToReadable=a;function h(m){return R.consumeStream(m,p=>C.concat(p))}e.streamToBuffer=h;async function v(m){return m.ended?C.concat(m.buffer):C.concat([...m.buffer,await h(m.stream)])}e.bufferedStreamToBuffer=v;function t(m){return R.toStream(m,p=>C.concat(p))}e.bufferToStream=t;function r(m){return R.transform(m,{data:p=>typeof p=="string"?C.fromString(p):C.wrap(p)},p=>C.concat(p))}e.streamToBufferReadableStream=r;function s(m){return R.newWriteableStream(p=>C.concat(p),m)}e.newWriteableBufferStream=s;function i(m,p){return R.prefixedReadable(m,p,D=>C.concat(D))}e.prefixedBufferReadable=i;function c(m,p){return R.prefixedStream(m,p,D=>C.concat(D))}e.prefixedBufferStream=c}),define(be[43],Ee([0,1,8]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return S(w,0)}e.hash=R;function S(w,P){switch(typeof w){case"object":return w===null?E(349,P):Array.isArray(w)?_(w,P):C(w,P);case"string":return y(w,P);case"boolean":return k(w,P);case"number":return E(w,P);case"undefined":return E(937,P);default:return E(617,P)}}e.doHash=S;function E(w,P){return(P<<5)-P+w|0}function k(w,P){return E(w?433:863,P)}function y(w,P){P=E(149417,P);for(let a=0,h=w.length;a<h;a++)P=E(w.charCodeAt(a),P);return P}e.stringHash=y;function _(w,P){return P=E(104579,P),w.reduce((a,h)=>S(h,a),P)}function C(w,P){return P=E(181387,P),Object.keys(w).sort().reduce((a,h)=>(a=y(h,a),S(w[h],a)),P)}class n{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=S(P,this._value),this._value}}e.Hasher=n;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,P,a=32){const h=a-P,v=~((1<<h)-1);return(w<<P|(v&w)>>>h)>>>0}function d(w,P=0,a=w.byteLength,h=0){for(let v=0;v<a;v++)w[P+v]=h}function u(w,P,a="0"){for(;w.length<P;)w=a+w;return w}function f(w,P=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(a=>a.toString(16).padStart(2,"0")).join(""):u((w>>>0).toString(16),P/4)}e.toHexString=f;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const a=P.length;if(a===0)return;const h=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=P.charCodeAt(0),s=0);;){let i=r;if(g.isHighSurrogate(r))if(s+1<a){const c=P.charCodeAt(s+1);g.isLowSurrogate(c)?(s++,i=g.computeCodePoint(r,c)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(v=this._push(h,v,i),s++,s<a)r=P.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(P,a,h){return h<128?P[a++]=h:h<2048?(P[a++]=192|(h&1984)>>>6,P[a++]=128|(h&63)>>>0):h<65536?(P[a++]=224|(h&61440)>>>12,P[a++]=128|(h&4032)>>>6,P[a++]=128|(h&63)>>>0):(P[a++]=240|(h&1835008)>>>18,P[a++]=128|(h&258048)>>>12,P[a++]=128|(h&4032)>>>6,P[a++]=128|(h&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,a=this._buffDV;for(let p=0;p<64;p+=4)P.setUint32(p,a.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)P.setUint32(p,l(P.getUint32(p-12,!1)^P.getUint32(p-32,!1)^P.getUint32(p-56,!1)^P.getUint32(p-64,!1),1),!1);let h=this._h0,v=this._h1,t=this._h2,r=this._h3,s=this._h4,i,c,m;for(let p=0;p<80;p++)p<20?(i=v&t|~v&r,c=1518500249):p<40?(i=v^t^r,c=1859775393):p<60?(i=v&t|v&r|t&r,c=2400959708):(i=v^t^r,c=3395469782),m=l(h,5)+i+s+c+P.getUint32(p*4,!1)&4294967295,s=r,r=t,t=l(v,30),v=h,h=m;this._h0=this._h0+h&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[36],Ee([0,1,8]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(R||(R={})),function(S){const E="error",k="warning",y="warn",_="info",C="ignore";function n(l){return l?g.equalsIgnoreCase(E,l)?S.Error:g.equalsIgnoreCase(k,l)||g.equalsIgnoreCase(y,l)?S.Warning:g.equalsIgnoreCase(_,l)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(l){switch(l){case S.Error:return E;case S.Warning:return k;case S.Info:return _;default:return C}}S.toString=I}(R||(R={})),e.default=R}),define(be[10],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(p){return Array.isArray(p)}e.isArray=g;function R(p){return typeof p=="string"}e.isString=R;function S(p){return Array.isArray(p)&&p.every(D=>R(D))}e.isStringArray=S;function E(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=E;function k(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=k;function y(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=y;function _(p){return p===!0||p===!1}e.isBoolean=_;function C(p){return typeof p=="undefined"}e.isUndefined=C;function n(p){return!I(p)}e.isDefined=n;function I(p){return C(p)||p===null}e.isUndefinedOrNull=I;function l(p,D){if(!p)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=l;function d(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=d;function u(...p){const D=[];for(let T=0;T<p.length;T++){const o=p[T];if(I(o))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);D.push(o)}return D}e.assertAllDefined=u;const f=Object.prototype.hasOwnProperty;function b(p){if(!E(p))return!1;for(let D in p)if(f.call(p,D))return!1;return!0}e.isEmptyObject=b;function w(p){return typeof p=="function"}e.isFunction=w;function P(...p){return p.length>0&&p.every(w)}e.areFunctions=P;function a(p,D){const T=Math.min(p.length,D.length);for(let o=0;o<T;o++)h(p[o],D[o])}e.validateConstraints=a;function h(p,D){if(R(D)){if(typeof p!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(w(D)){try{if(p instanceof D)return}catch{}if(!I(p)&&p.constructor===D||D.length===1&&D.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function v(p){let D=[],T=Object.getPrototypeOf(p);for(;Object.prototype!==T;)D=D.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return D}e.getAllPropertyNames=v;function t(p){const D=[];for(const T of v(p))typeof p[T]=="function"&&D.push(T);return D}e.getAllMethodNames=t;function r(p,D){const T=A=>function(){const F=Array.prototype.slice.call(arguments,0);return D(A,F)};let o={};for(const A of p)o[A]=T(A);return o}e.createProxyObject=r;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function i(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=i;function c(p){return class{constructor(){return new Proxy({},{get(D,T){if(D[T])return D[T];throw new Error(`Not Implemented: ${p}->${String(T)}`)}})}}}e.NotImplementedProxy=c;function m(p,D="Unreachable"){throw new Error(D)}e.assertNever=m}),define(be[44],Ee([0,1,22,8,14,10]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function y(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=y;function _(s){return s.indexOf("/")===-1&&(s=y(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=_;function C(s,i=S.posix.sep){if(!s)return"";const c=s.length,m=s.charCodeAt(0);if(k(m)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let D=3;const T=D;for(;D<c&&!k(s.charCodeAt(D));D++);if(T!==D&&!k(s.charCodeAt(D+1))){for(D+=1;D<c;D++)if(k(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,i)}}return i}else if(w(m)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<c;p++)if(k(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=C;function n(s){if(!g.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let c=2;const m=c;for(;c<s.length&&(i=s.charCodeAt(c),i!==92);c++);return!(m===c||(i=s.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(s,i=g.isWindows){const c=i?I:l;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||i&&d.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=u;function f(s,i,c){const m=s===i;return!c||m?m:!s||!i?!1:(0,R.equalsIgnoreCase)(s,i)}e.isEqual=f;function b(s,i,c,m=S.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let D=i.length;return i.charAt(i.length-1)===m&&D--,s.charAt(D)===m}return i.charAt(i.length-1)!==m&&(i+=m),s.indexOf(i)===0}e.isEqualOrParent=b;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function P(s,i){return g.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(i,s)),s=(0,S.normalize)(s),g.isWindows?(s=(0,R.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,R.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=P;function a(s){const i=(0,S.normalize)(s);return g.isWindows?s.length>3?!1:h(i)&&(s.length===2||i.charCodeAt(2)===92):i===S.posix.sep}e.isRootOrDriveLetter=a;function h(s){return g.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function v(s){return h(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,c){return i.length>s.length?-1:s===i?0:(c&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let c,m,p;if(i.forEach(D=>{const T=Number(D);(0,E.isNumber)(T)?m===void 0?m=T:p===void 0&&(p=T):c=c?[c,D].join(":"):D}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(be[23],Ee([0,1,10]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.keys(f).forEach(w=>{f[w]&&typeof f[w]=="object"?b[w]=R(f[w]):b[w]=f[w]}),b}e.deepClone=R;function S(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const P in w)if(E.call(w,P)){const a=w[P];typeof a=="object"&&!Object.isFrozen(a)&&b.push(a)}}return f}e.deepFreeze=S;const E=Object.prototype.hasOwnProperty;function k(f,b){return y(f,b,new Set)}e.cloneAndChange=k;function y(f,b,w){if((0,g.isUndefinedOrNull)(f))return f;const P=b(f);if(typeof P!="undefined")return P;if((0,g.isArray)(f)){const a=[];for(const h of f)a.push(y(h,b,w));return a}if((0,g.isObject)(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const a={};for(let h in f)E.call(f,h)&&(a[h]=y(f[h],b,w));return w.delete(f),a}return f}function _(f,b,w=!0){return(0,g.isObject)(f)?((0,g.isObject)(b)&&Object.keys(b).forEach(P=>{P in f?w&&((0,g.isObject)(f[P])&&(0,g.isObject)(b[P])?_(f[P],b[P],w):f[P]=b[P]):f[P]=b[P]}),f):b}e.mixin=_;function C(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let w,P;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(w=0;w<f.length;w++)if(!C(f[w],b[w]))return!1}else{const a=[];for(P in f)a.push(P);a.sort();const h=[];for(P in b)h.push(P);if(h.sort(),!C(a,h))return!1;for(w=0;w<a.length;w++)if(!C(f[a[w]],b[a[w]]))return!1}return!0}e.equals=C;function n(f){const b=new Set;return JSON.stringify(f,(w,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=n;function I(f,b,w){const P=b(f);return typeof P=="undefined"?w:P}e.getOrDefault=I;function l(f,b){const w=Object.create(null);return!f||!b||Object.keys(b).forEach(a=>{const h=f[a],v=b[a];C(h,v)||(w[a]=v)}),w}e.distinct=l;function d(f,b){const w=b.toLowerCase(),P=Object.keys(f).find(a=>a.toLowerCase()===w);return P?f[P]:f[b]}e.getCaseInsensitive=d;function u(f,b){const w=Object.create(null);for(const P of Object.keys(f))b(P,f[P])&&(w[P]=f[P]);return w}e.filter=u}),define(be[82],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function R(E){return E<0?0:E>255?255:E|0}e.toUint8=R;function S(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=S}),define(be[2],Ee([0,1,22,14]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,E=/^\//,k=/^\/\//;function y(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!E.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,i){return!s&&!i?"file":s}function C(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(i,c,m,p,D,T=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=_(i,T),this.authority=c||n,this.path=C(this.scheme,m||n),this.query=p||n,this.fragment=D||n,y(this,T))}static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:m,path:p,query:D,fragment:T}=i;return c===void 0?c=this.scheme:c===null&&(c=n),m===void 0?m=this.authority:m===null&&(m=n),p===void 0?p=this.path:p===null&&(p=n),D===void 0?D=this.query:D===null&&(D=n),T===void 0?T=this.fragment:T===null&&(T=n),c===this.scheme&&m===this.authority&&p===this.path&&D===this.query&&T===this.fragment?this:new f(c,m,p,D,T)}static parse(i,c=!1){const m=l.exec(i);return m?new f(m[2]||n,r(m[4]||n),r(m[5]||n),r(m[7]||n),r(m[9]||n),c):new f(n,n,n,n,n)}static file(i){let c=n;if(g.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const m=i.indexOf(I,2);m===-1?(c=i.substring(2),i=I):(c=i.substring(2,m),i=i.substring(m)||I)}return new f("file",c,i,n,n)}static from(i){const c=new f(i.scheme,i.authority,i.path,i.query,i.fragment);return y(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return g.isWindows&&i.scheme==="file"?m=d.file(R.win32.join(a(i,!0),...c)).path:m=R.posix.join(i.path,...c),i.with({path:m})}toString(i=!1){return h(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const c=new f(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=d;const u=g.isWindows?1:void 0;class f extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let c,m=-1;for(let p=0;p<s.length;p++){const D=s.charCodeAt(p);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47)m!==-1&&(c+=encodeURIComponent(s.substring(m,p)),m=-1),c!==void 0&&(c+=s.charAt(p));else{c===void 0&&(c=s.substr(0,p));const T=b[D];T!==void 0?(m!==-1&&(c+=encodeURIComponent(s.substring(m,p)),m=-1),c+=T):m===-1&&(m=p)}}return m!==-1&&(c+=encodeURIComponent(s.substring(m))),c!==void 0?c:s}function P(s){let i;for(let c=0;c<s.length;c++){const m=s.charCodeAt(c);m===35||m===63?(i===void 0&&(i=s.substr(0,c)),i+=b[m]):i!==void 0&&(i+=s[c])}return i!==void 0?i:s}function a(s,i){let c;return s.authority&&s.path.length>1&&s.scheme==="file"?c=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?c=s.path.substr(1):c=s.path[1].toLowerCase()+s.path.substr(2):c=s.path,g.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=a;function h(s,i){const c=i?P:w;let m="",{scheme:p,authority:D,path:T,query:o,fragment:A}=s;if(p&&(m+=p,m+=":"),(D||p==="file")&&(m+=I,m+=I),D){let F=D.indexOf("@");if(F!==-1){const U=D.substr(0,F);D=D.substr(F+1),F=U.indexOf(":"),F===-1?m+=c(U,!1):(m+=c(U.substr(0,F),!1),m+=":",m+=c(U.substr(F+1),!1)),m+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?m+=c(D,!1):(m+=c(D.substr(0,F),!1),m+=D.substr(F))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const F=T.charCodeAt(1);F>=65&&F<=90&&(T=`/${String.fromCharCode(F+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const F=T.charCodeAt(0);F>=65&&F<=90&&(T=`${String.fromCharCode(F+32)}:${T.substr(2)}`)}m+=c(T,!0)}return o&&(m+="?",m+=c(o,!1)),A&&(m+="#",m+=i?A:w(A,!1)),m}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>v(i)):s}});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[21],Ee([0,1,2,8]),function(te,e,g,R){"use strict";var S,E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=y;function _(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=_;function C(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(r){this._iter=r}static forUris(r=()=>!1){return new b(new u(r))}static forPaths(){return new b(new l)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new I)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let c;for(this._root||(this._root=new f,this._root.segment=i.value()),c=this._root;;){const p=i.cmp(c.segment);if(p>0)c.left||(c.left=new f,c.left.segment=i.value()),c=c.left;else if(p<0)c.right||(c.right=new f,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new f,c.mid.segment=i.value()),c=c.mid;else break}const m=c.value;return c.value=s,c.key=r,m}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),c=[];let m=this._root;for(;m;){const p=i.cmp(m.segment);if(p>0)c.push([1,m]),m=m.left;else if(p<0)c.push([-1,m]),m=m.right;else if(i.hasNext())i.next(),c.push([0,m]),m=m.mid;else{for(s?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;c.length>0&&m.isEmpty();){let[D,T]=c.pop();switch(D){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}m=T}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,c;for(;i;){const m=s.cmp(i.segment);if(m>0)i=i.left;else if(m<0)i=i.right;else if(s.hasNext())s.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=b;class w{constructor(r,s){this[S]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,c]of this.map)r(c,g.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield g.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[g.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[g.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class a{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let c=this._map.get(r);if(c)c.value=s,i!==0&&this.touch(c,i);else{switch(c={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let c=this._head;for(;c;){if(s?r.bind(s)(c.value,c.key,this):r(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:i.key,done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return c}values(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:i.value,done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return c}entries(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:[i.key,i.value],done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return c}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,c=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=a;class h extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class v{constructor(r){k.set(this,void 0),it(this,k,r,"f")}get size(){return Be(this,k,"f").size}forEach(r,s){Be(this,k,"f").forEach(r,s)}get(r){return Be(this,k,"f").get(r)}has(r){return Be(this,k,"f").has(r)}entries(){return Be(this,k,"f").entries()}keys(){return Be(this,k,"f").keys()}values(){return Be(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Be(this,k,"f").entries()}}e.ReadonlyMapView=v}),define(be[114],Ee([0,1,21,8]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(ie,ge){for(let Re=0,We=q.length;Re<We;Re++){const ve=q[Re](ie,ge);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(q,ie,ge){if(!ge||ge.length<ie.length)return null;let Re;return q?Re=R.startsWithIgnoreCase(ge,ie):Re=ge.indexOf(ie)===0,Re?ie.length>0?[{start:0,end:ie.length}]:[]:null}function k(q,ie){const ge=ie.toLowerCase().indexOf(q.toLowerCase());return ge===-1?null:[{start:ge,end:ge+q.length}]}e.matchesContiguousSubString=k;function y(q,ie){return _(q.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=y;function _(q,ie,ge,Re){if(ge===q.length)return[];if(Re===ie.length)return null;if(q[ge]===ie[Re]){let We=null;return(We=_(q,ie,ge+1,Re+1))?w({start:Re,end:Re+1},We):null}return _(q,ie,ge,Re+1)}function C(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function I(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>d.add(q.charCodeAt(0)));function u(q){return l(q)||d.has(q)}function f(q,ie){return q===ie||u(q)&&u(ie)}function b(q){return C(q)||n(q)||I(q)}function w(q,ie){return ie.length===0?ie=[q]:q.end===ie[0].start?ie[0].start=q.start:ie.unshift(q),ie}function P(q,ie){for(let ge=ie;ge<q.length;ge++){const Re=q.charCodeAt(ge);if(n(Re)||I(Re)||ge>0&&!b(q.charCodeAt(ge-1)))return ge}return q.length}function a(q,ie,ge,Re){if(ge===q.length)return[];if(Re===ie.length)return null;if(q[ge]!==ie[Re].toLowerCase())return null;{let We=null,ve=Re+1;for(We=a(q,ie,ge+1,Re+1);!We&&(ve=P(ie,ve))<ie.length;)We=a(q,ie,ge+1,ve),ve++;return We===null?null:w({start:Re,end:Re+1},We)}}function h(q){let ie=0,ge=0,Re=0,We=0,ve=0;for(let Ue=0;Ue<q.length;Ue++)ve=q.charCodeAt(Ue),n(ve)&&ie++,C(ve)&&ge++,b(ve)&&Re++,I(ve)&&We++;const Ye=ie/q.length,z=ge/q.length,ee=Re/q.length,ce=We/q.length;return{upperPercent:Ye,lowerPercent:z,alphaPercent:ee,numericPercent:ce}}function v(q){const{upperPercent:ie,lowerPercent:ge}=q;return ge===0&&ie>.6}function t(q){const{upperPercent:ie,lowerPercent:ge,alphaPercent:Re,numericPercent:We}=q;return ge>.2&&ie<.8&&Re>.6&&We<.2}function r(q){let ie=0,ge=0,Re=0,We=0;for(let ve=0;ve<q.length;ve++)Re=q.charCodeAt(ve),n(Re)&&ie++,C(Re)&&ge++,l(Re)&&We++;return(ie===0||ge===0)&&We===0?q.length<=30:ie<=5}function s(q,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!r(q)||ie.length>60)return null;const ge=h(ie);if(!t(ge)){if(!v(ge))return null;ie=ie.toLowerCase()}let Re=null,We=0;for(q=q.toLowerCase();We<ie.length&&(Re=a(q,ie,0,We))===null;)We=P(ie,We+1);return Re}e.matchesCamelCase=s;function i(q,ie,ge=!1){if(!ie||ie.length===0)return null;let Re=null,We=0;for(q=q.toLowerCase(),ie=ie.toLowerCase();We<ie.length&&(Re=c(q,ie,0,We,ge))===null;)We=m(ie,We+1);return Re}e.matchesWords=i;function c(q,ie,ge,Re,We){if(ge===q.length)return[];if(Re===ie.length)return null;if(f(q.charCodeAt(ge),ie.charCodeAt(Re))){let ve=null,Ye=Re+1;if(ve=c(q,ie,ge+1,Re+1,We),!We)for(;!ve&&(Ye=m(ie,Ye))<ie.length;)ve=c(q,ie,ge+1,Ye,We),Ye++;return ve===null?null:w({start:Re,end:Re+1},ve)}else return null}function m(q,ie){for(let ge=ie;ge<q.length;ge++)if(u(q.charCodeAt(ge))||ge>0&&u(q.charCodeAt(ge-1)))return ge;return q.length}const p=S(e.matchesPrefix,s,k),D=S(e.matchesPrefix,s,y),T=new g.LRUCache(1e4);function o(q,ie,ge=!1){if(typeof q!="string"||typeof ie!="string")return null;let Re=T.get(q);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(q),"i"),T.set(q,Re));const We=Re.exec(ie);return We?[{start:We.index,end:We.index+We[0].length}]:ge?D(q,ie):p(q,ie)}e.matchesFuzzy=o;function A(q,ie){const ge=Xe(q,q.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return ge?U(ge):null}e.matchesFuzzy2=A;function F(q,ie,ge,Re,We,ve){const Ye=Math.min(13,q.length);for(;ge<Ye;ge++){const z=Xe(q,ie,ge,Re,We,ve,!1);if(z)return z}return[0,ve]}e.anyScore=F;function U(q){if(typeof q=="undefined")return[];const ie=[],ge=q[1];for(let Re=q.length-1;Re>1;Re--){const We=q[Re]+ge,ve=ie[ie.length-1];ve&&ve.end===We?ve.end=We+1:ie.push({start:We,end:We+1})}return ie}e.createMatches=U;const j=128;function ae(){const q=[],ie=[];for(let ge=0;ge<=j;ge++)ie[ge]=0;for(let ge=0;ge<=j;ge++)q.push(ie.slice(0));return q}function G(q){const ie=[];for(let ge=0;ge<=q;ge++)ie[ge]=0;return ie}const B=G(2*j),$=G(2*j),L=ae(),Z=ae(),V=ae(),Y=!1;function me(q,ie,ge,Re,We){function ve(z,ee,ce=" "){for(;z.length<ee;)z=ce+z;return z}let Ye=` |   |${Re.split("").map(z=>ve(z,3)).join("|")}
`;for(let z=0;z<=ge;z++)z===0?Ye+=" |":Ye+=`${ie[z-1]}|`,Ye+=q[z].slice(0,We+1).map(ee=>ve(ee.toString(),3)).join("|")+`
`;return Ye}function H(q,ie,ge,Re){q=q.substr(ie),ge=ge.substr(Re),console.log(me(Z,q,q.length,ge,ge.length)),console.log(me(V,q,q.length,ge,ge.length)),console.log(me(L,q,q.length,ge,ge.length))}function oe(q,ie){if(ie<0||ie>=q.length)return!1;const ge=q.codePointAt(ie);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ge)}}function de(q,ie){if(ie<0||ie>=q.length)return!1;switch(q.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function Ce(q,ie,ge){return ie[q]!==ge[q]}function Ne(q,ie,ge,Re,We,ve,Ye=!1){for(;ie<ge&&We<ve;)q[ie]===Re[We]&&(Ye&&(B[ie]=We),ie+=1),We+=1;return ie===ge}e.isPatternInWord=Ne;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var $e;(function(q){q.Default=[-100,0];function ie(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}q.isDefault=ie})($e=e.FuzzyScore||(e.FuzzyScore={}));function Xe(q,ie,ge,Re,We,ve,Ye){const z=q.length>j?j:q.length,ee=Re.length>j?j:Re.length;if(ge>=z||ve>=ee||z-ge>ee-ve||!Ne(ie,ge,z,We,ve,ee,!0))return;qe(z,ee,ge,ve,ie,We);let ce=1,Ue=1,xe=ge,et=ve;const Se=[!1];for(ce=1,xe=ge;xe<z;ce++,xe++){const he=B[xe],pe=$[xe],x=xe+1<z?$[xe+1]:ee;for(Ue=he-ve+1,et=he;et<x;Ue++,et++){let fe=Number.MIN_SAFE_INTEGER,we=!1;et<=pe&&(fe=je(q,ie,xe,ge,Re,We,et,ee,ve,L[ce-1][Ue-1]===0,Se));let Ie=0;fe!==Number.MAX_SAFE_INTEGER&&(we=!0,Ie=fe+Z[ce-1][Ue-1]);const Oe=et>he,He=Oe?Z[ce][Ue-1]+(L[ce][Ue-1]>0?-5:0):0,Ze=et>he+1&&L[ce][Ue-1]>0,Ke=Ze?Z[ce][Ue-2]+(L[ce][Ue-2]>0?-5:0):0;if(Ze&&(!Oe||Ke>=He)&&(!we||Ke>=Ie))Z[ce][Ue]=Ke,V[ce][Ue]=3,L[ce][Ue]=0;else if(Oe&&(!we||He>=Ie))Z[ce][Ue]=He,V[ce][Ue]=2,L[ce][Ue]=0;else if(we)Z[ce][Ue]=Ie,V[ce][Ue]=1,L[ce][Ue]=L[ce-1][Ue-1]+1;else throw new Error("not possible")}}if(Y&&H(q,ge,Re,ve),!Se[0]&&!Ye)return;ce--,Ue--;const ye=[Z[ce][Ue],ve];let Pe=0,se=0;for(;ce>=1;){let he=Ue;do{const pe=V[ce][he];if(pe===3)he=he-2;else if(pe===2)he=he-1;else break}while(he>=1);Pe>1&&ie[ge+ce-1]===We[ve+Ue-1]&&!Ce(he+ve-1,Re,We)&&Pe+1>L[ce][he]&&(he=Ue),he===Ue?Pe++:Pe=1,se||(se=he),ce--,Ue=he-1,ye.push(Ue)}ee===z&&(ye[0]+=2);const le=se-z;return ye[0]-=le,ye}e.fuzzyScore=Xe;function qe(q,ie,ge,Re,We,ve){let Ye=q-1,z=ie-1;for(;Ye>=ge&&z>=Re;)We[Ye]===ve[z]&&($[Ye]=z,Ye--),z--}function je(q,ie,ge,Re,We,ve,Ye,z,ee,ce,Ue){if(ie[ge]!==ve[Ye])return Number.MIN_SAFE_INTEGER;let xe=1,et=!1;return Ye===ge-Re?xe=q[ge]===We[Ye]?7:5:Ce(Ye,We,ve)&&(Ye===0||!Ce(Ye-1,We,ve))?(xe=q[ge]===We[Ye]?7:5,et=!0):oe(ve,Ye)&&(Ye===0||!oe(ve,Ye-1))?xe=5:(oe(ve,Ye-1)||de(ve,Ye-1))&&(xe=5,et=!0),xe>1&&ge===Re&&(Ue[0]=!0),et||(et=Ce(Ye,We,ve)||oe(ve,Ye-1)||de(ve,Ye-1)),ge===Re?Ye>ee&&(xe-=et?3:5):ce?xe+=et?2:0:xe+=et?0:1,Ye+1===z&&(xe-=et?3:5),xe}function O(q,ie,ge,Re,We,ve,Ye){return X(q,ie,ge,Re,We,ve,!0,Ye)}e.fuzzyScoreGracefulAggressive=O;function K(q,ie,ge,Re,We,ve,Ye){return X(q,ie,ge,Re,We,ve,!1,Ye)}e.fuzzyScoreGraceful=K;function X(q,ie,ge,Re,We,ve,Ye,z){let ee=Xe(q,ie,ge,Re,We,ve,z);if(ee&&!Ye)return ee;if(q.length>=3){const ce=Math.min(7,q.length-1);for(let Ue=ge+1;Ue<ce;Ue++){const xe=re(q,Ue);if(xe){const et=Xe(xe,xe.toLowerCase(),ge,Re,We,ve,z);et&&(et[0]-=3,(!ee||et[0]>ee[0])&&(ee=et))}}}return ee}function re(q,ie){if(ie+1>=q.length)return;const ge=q[ie],Re=q[ie+1];if(ge!==Re)return q.slice(0,ie)+Re+ge+q.slice(ie+2)}}),define(be[115],Ee([0,1,35,114,8]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function y(f){return f.replace(k,(b,w)=>w?b:`\\${b}`)}e.escapeIcons=y;const _=new RegExp(`\\\\${E.source}`,"g");function C(f){return f.replace(_,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function I(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(n,(b,w,P,a)=>P?b:w||a||"")}e.stripIcons=I;function l(f){const b=f.indexOf(e.iconStartMarker);return b===-1?{text:f}:d(f,b)}e.parseLabelWithIcons=l;function d(f,b){const w=[];let P="";function a(m){if(m){P+=m;for(const p of m)w.push(t)}}let h=-1,v="",t=0,r,s,i=b;const c=f.length;for(a(f.substr(0,b));i<c;)r=f[i],s=f[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=i,a(v),v=e.iconStartMarker,i++):r===")"&&h!==-1?(t+=i-h+1,h=-1,v=""):h!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(a(v),h=-1,v=""):a(r),i++;return a(v),{text:P,iconOffsets:w}}function u(f,b,w=!1){const{text:P,iconOffsets:a}=b;if(!a||a.length===0)return(0,R.matchesFuzzy)(f,P,w);const h=(0,S.ltrim)(P," "),v=P.length-h.length,t=(0,R.matchesFuzzy)(f,h,w);if(t)for(const r of t){const s=a[r.start+v]+v;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=u}),define(be[83],Ee([0,1,115,12]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",u=!1){if(this.value=d,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(d,u=0){return this.value+=C(this.supportThemeIcons?(0,g.escapeIcons)(d):d).replace(/([ \t]+)/g,(f,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,u){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=E;function k(l){return y(l)?!l.value:Array.isArray(l)?l.every(k):!0}e.isEmptyMarkdownString=k;function y(l){return l instanceof E?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function _(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=_;function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(l){const d=[],u=l.split("|").map(b=>b.trim());l=u[0];const f=u[1];if(f){const b=/height=(\d+)/.exec(f),w=/width=(\d+)/.exec(f),P=b?b[1]:"",a=w?w[1]:"",h=isFinite(parseInt(a)),v=isFinite(parseInt(P));h&&d.push(`width="${a}"`),v&&d.push(`height="${P}"`)}return{href:l,dimensions:d}}e.parseHrefAndDimensions=I}),define(be[56],Ee([0,1,24,8,2]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function E(n){return JSON.stringify(n,_)}e.stringify=E;function k(n){let I=JSON.parse(n);return I=C(I),I}e.parse=k;var y;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function _(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function C(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=C(n[l],I+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=C(n[l],I+1))}return n}e.revive=C}),define(be[11],Ee([0,1,2,22]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,n){this._hosts[_]=C,this._ports[_]=n}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[C],l=this._connectionTokens[C];let d=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(d+=`&tkn=${encodeURIComponent(l)}`),g.URI.from({scheme:R.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new E;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,n){const I=this.toUri(_,C);if(I.scheme===S.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let l=!1;return R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&I.scheme===S.file&&(l=!0),I.scheme===S.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,C){const n=this.toUri(_,C);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,C){return g.URI.isUri(_)?_:g.URI.parse(C.toUrl(_))}}e.FileAccess=new k}),define(be[25],Ee([0,1,44,14,2,8,11,22]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(d){return(0,S.uriToFsPath)(d,!0)}e.originalFSPath=_;class C{constructor(u){this._ignorePathCasing=u}compare(u,f,b=!1){return u===f?0:(0,E.compare)(this.getComparisonKey(u,b),this.getComparisonKey(f,b))}isEqual(u,f,b=!1){return u===f?!0:!u||!f?!1:this.getComparisonKey(u,b)===this.getComparisonKey(f,b)}getComparisonKey(u,f=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,f,b=!1){if(u.scheme===f.scheme){if(u.scheme===k.Schemas.file)return g.isEqualOrParent(_(u),_(f),this._ignorePathCasing(u))&&u.query===f.query&&(b||u.fragment===f.fragment);if((0,e.isEqualAuthority)(u.authority,f.authority))return g.isEqualOrParent(u.path,f.path,this._ignorePathCasing(u),"/")&&u.query===f.query&&(b||u.fragment===f.fragment)}return!1}joinPath(u,...f){return S.URI.joinPath(u,...f)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let f;return u.scheme===k.Schemas.file?f=S.URI.file(R.dirname(_(u))).path:(f=R.posix.dirname(u.path),u.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),f="/")),u.with({path:f})}normalizePath(u){if(!u.path.length)return u;let f;return u.scheme===k.Schemas.file?f=S.URI.file(R.normalize(_(u))).path:f=R.posix.normalize(u.path),u.with({path:f})}relativePath(u,f){if(u.scheme!==f.scheme||!(0,e.isEqualAuthority)(u.authority,f.authority))return;if(u.scheme===k.Schemas.file){const P=R.relative(_(u),_(f));return y.isWindows?g.toSlashes(P):P}let b=u.path||"/",w=f.path||"/";if(this._ignorePathCasing(u)){let P=0;for(const a=Math.min(b.length,w.length);P<a&&!(b.charCodeAt(P)!==w.charCodeAt(P)&&b.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);b=w.substr(0,P)+b.substr(P)}return R.posix.relative(b,w)}resolvePath(u,f){if(u.scheme===k.Schemas.file){const b=S.URI.file(R.resolve(_(u),f));return u.with({authority:b.authority,path:b.path})}return f=g.toPosixPath(f),u.with({path:R.posix.resolve(u.path,f)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,f){return u===f||(0,E.equalsIgnoreCase)(u,f)}hasTrailingPathSeparator(u,f=R.sep){if(u.scheme===k.Schemas.file){const b=_(u);return b.length>g.getRoot(b).length&&b[b.length-1]===f}else{const b=u.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,f=R.sep){return(0,e.hasTrailingPathSeparator)(u,f)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,f=R.sep){let b=!1;if(u.scheme===k.Schemas.file){const w=_(u);b=w!==void 0&&w.length===g.getRoot(w).length&&w[w.length-1]===f}else{f="/";const w=u.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(u,f)?u.with({path:u.path+"/"}):u}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(d=>d.scheme===k.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new C(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(d,u){const f=[];for(let b=0;b<d.length;b++){const w=u(d[b]);d.some((P,a)=>a===b?!1:(0,e.isEqualOrParent)(w,u(P)))||f.push(d[b])}return f}e.distinctParents=n;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function u(f){const b=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(a=>{const[h,v]=a.split(":");h&&v&&b.set(h,v)});const P=f.path.substring(0,f.path.indexOf(";"));return P&&b.set(d.META_DATA_MIME,P),b}d.parseMetaData=u})(I=e.DataUri||(e.DataUri={}));function l(d,u,f){if(u){let b=d.path;return b&&b[0]!==R.posix.sep&&(b=R.posix.sep+b),d.with({scheme:f,authority:u,path:b})}return d.with({scheme:f})}e.toLocalResource=l}),define(be[15],Ee([0,1,20,12,3,6,25]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y($){return!!$&&typeof $.then=="function"}e.isThenable=y;function _($){const L=new g.CancellationTokenSource,Z=$(L.token),V=new Promise((Y,me)=>{const H=L.token.onCancellationRequested(()=>{H.dispose(),L.dispose(),me((0,R.canceled)())});Promise.resolve(Z).then(oe=>{H.dispose(),L.dispose(),Y(oe)},oe=>{H.dispose(),L.dispose(),me(oe)})});return new class{cancel(){L.cancel()}then(Y,me){return V.then(Y,me)}catch(Y){return this.then(void 0,Y)}finally(Y){return V.finally(Y)}}}e.createCancelablePromise=_;function C($,L,Z){return Promise.race([$,new Promise(V=>L.onCancellationRequested(()=>V(Z)))])}e.raceCancellation=C;async function n($){let L=-1;const Z=$.map((Y,me)=>Y.then(H=>(L=me,H))),V=await Promise.race(Z);return $.forEach((Y,me)=>{me!==L&&Y.cancel()}),V}e.raceCancellablePromises=n;function I($,L,Z){let V;const Y=setTimeout(()=>{V?.(void 0),Z?.()},L);return Promise.race([$.finally(()=>clearTimeout(Y)),new Promise(me=>V=me)])}e.raceTimeout=I;function l($){return new Promise((L,Z)=>{const V=$();y(V)?V.then(L,Z):L(V)})}e.asPromise=l;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const Z=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(Z,Z).then(V)})}return new Promise((Z,V)=>{this.queuedPromise.then(Z,V)})}return this.activePromise=L(),new Promise((Z,V)=>{this.activePromise.then(Y=>{this.activePromise=null,Z(Y)},Y=>{this.activePromise=null,V(Y)})})}}e.Throttler=d;class u{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=u;class f{constructor(){this.promiseMap=new Map}queue(L,Z){const Y=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.promiseMap.get(L)===Y&&this.promiseMap.delete(L)});return this.promiseMap.set(L,Y),Y}}e.SequencerByKey=f;class b{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,Z=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,Y)=>{this.doResolve=V,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(L){this.delayer=new b(L),this.throttler=new d}trigger(L,Z){return this.delayer.trigger(()=>this.throttler.queue(L),Z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class P{constructor(){this._isOpen=!1,this._promise=new Promise((L,Z)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class a extends P{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function h($,L){return L?new Promise((Z,V)=>{const Y=setTimeout(()=>{me.dispose(),Z()},$),me=L.onCancellationRequested(()=>{clearTimeout(Y),me.dispose(),V((0,R.canceled)())})}):_(Z=>h($,Z))}e.timeout=h;function v($,L=0){const Z=setTimeout($,L);return(0,E.toDisposable)(()=>clearTimeout(Z))}e.disposableTimeout=v;function t($){const L=[];let Z=0;const V=$.length;function Y(){return Z<V?$[Z++]():null}function me(H){H!=null&&L.push(H);const oe=Y();return oe?oe.then(me):Promise.resolve(L)}return Promise.resolve(null).then(me)}e.sequence=t;function r($,L=V=>!!V,Z=null){let V=0;const Y=$.length,me=()=>{if(V>=Y)return Promise.resolve(Z);const H=$[V++];return Promise.resolve(H()).then(de=>L(de)?Promise.resolve(de):me())};return me()}e.first=r;function s($,L=V=>!!V,Z=null){if($.length===0)return Promise.resolve(Z);let V=$.length;const Y=()=>{V=-1;for(const me of $)me.cancel?.()};return new Promise((me,H)=>{for(const oe of $)oe.then(de=>{--V>=0&&L(de)?(Y(),me(de)):V===0&&me(Z)}).catch(de=>{--V>=0&&(Y(),H(de))})})}e.firstParallel=s;class i{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((Z,V)=>{this.outstandingPromises.push({factory:L,c:Z,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const Z=L.factory();Z.then(L.c,L.e),Z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class m{constructor(){this.queues=new Map}queueFor(L,Z=k.extUri){const V=Z.getComparisonKey(L);let Y=this.queues.get(V);return Y||(Y=new c,S.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(V)}),this.queues.set(V,Y)),Y}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=m;class p{constructor(L,Z){this._token=-1,typeof L=="function"&&typeof Z=="number"&&this.setIfNotSet(L,Z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,Z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},Z)}setIfNotSet(L,Z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},Z))}}e.TimeoutTimer=p;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,Z){this.cancel(),this._token=setInterval(()=>{L()},Z)}}e.IntervalTimer=D;class T{constructor(L,Z){this.timeoutToken=-1,this.runner=L,this.timeout=Z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class o extends T{constructor(L,Z){super(L,Z);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class A extends E.Disposable{constructor(L,Z,V,Y){super();this.maxWorkChunkSize=L,this.maxPendingWork=Z,this.throttleDelay=V,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new E.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=A,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const Z=setTimeout(()=>L($));let V=!1;return{dispose(){V||(V=!0,clearTimeout(Z))}}}}else e.runWhenIdle=($,L)=>{const Z=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(Z))}}}}();class F{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(Z){this._error=Z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=F;async function U($,L,Z){let V;for(let Y=0;Y<Z;Y++)try{return await $()}catch(me){V=me,await h(L)}throw V}e.retry=U;class j{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,Z,V){return this._pending={taskId:L,cancel:()=>V?.(),promise:Z},Z.then(()=>this.donePending(L),()=>this.donePending(L)),Z}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let Z,V;const Y=new Promise((me,H)=>{Z=me,V=H});this._next={run:L,promise:Y,promiseResolve:Z,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class ae{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,Z)=>{this.completeCallback=L,this.errorCallback=Z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(Z=>{this.completeCallback(L),this.resolved=!0,Z()})}error(L){return new Promise(Z=>{this.errorCallback(L),this.rejected=!0,Z()})}cancel(){new Promise(L=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=G;var B;(function($){async function L(Z){let V;const Y=await Promise.all(Z.map(me=>me.then(H=>H,H=>{V||(V=H)})));if(typeof V!="undefined")throw V;return Y}$.settled=L})(B=e.Promises||(e.Promises={}))}),define(be[116],Ee([0,1,14,15]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new R.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),E=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(T,o,A=!1){const F=T||"",U=o||"",j=S.value.collator.compare(F,U);return S.value.collatorIsNumeric&&j===0&&F!==U?F<U?-1:1:j}e.compareFileNames=y;function _(T,o){const A=E.value.collator;return T=T||"",o=o||"",v(A,T,o)}e.compareFileNamesDefault=_;function C(T,o){const A=E.value.collator;return T=T||"",o=o||"",i(T,o)||v(A,T,o)}e.compareFileNamesUpper=C;function n(T,o){const A=E.value.collator;return T=T||"",o=o||"",s(T,o)||v(A,T,o)}e.compareFileNamesLower=n;function I(T,o){return T=T||"",o=o||"",T===o?0:T<o?-1:1}e.compareFileNamesUnicode=I;function l(T,o,A=!1){A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase());const[F,U]=a(T),[j,ae]=a(o);return F!==j?F<j?-1:1:U===ae?0:U<ae?-1:1}e.noIntlCompareFileNames=l;function d(T,o){const[A,F]=a(T),[U,j]=a(o);let ae=S.value.collator.compare(F,j);if(ae===0){if(S.value.collatorIsNumeric&&F!==j)return F<j?-1:1;if(ae=S.value.collator.compare(A,U),S.value.collatorIsNumeric&&ae===0&&A!==U)return A<U?-1:1}return ae}e.compareFileExtensions=d;function u(T,o){T=T||"",o=o||"";const A=h(T),F=h(o),U=E.value.collator,j=k.value.collator;return v(j,A,F)||v(U,T,o)}e.compareFileExtensionsDefault=u;function f(T,o){T=T||"",o=o||"";const A=h(T),F=h(o),U=E.value.collator,j=k.value.collator;return v(j,A,F)||i(T,o)||v(U,T,o)}e.compareFileExtensionsUpper=f;function b(T,o){T=T||"",o=o||"";const A=h(T),F=h(o),U=E.value.collator,j=k.value.collator;return v(j,A,F)||s(T,o)||v(U,T,o)}e.compareFileExtensionsLower=b;function w(T,o){T=T||"",o=o||"";const A=h(T).toLowerCase(),F=h(o).toLowerCase();return A!==F?A<F?-1:1:T!==o?T<o?-1:1:0}e.compareFileExtensionsUnicode=w;const P=/^(.*?)(\.([^.]*))?$/;function a(T,o=!1){const A=T?P.exec(T):[];let F=[A&&A[1]||"",A&&A[3]||""];return o&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function h(T){const o=T?P.exec(T):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(T,o,A){let F=T.compare(o,A);return F!==0?F:o.length!==A.length?o.length<A.length?-1:1:0}function t(T){const o=T.charAt(0);return o.toLocaleUpperCase()!==o}function r(T){const o=T.charAt(0);return o.toLocaleLowerCase()!==o}function s(T,o){return t(T)&&r(o)?-1:r(T)&&t(o)?1:0}function i(T,o){return r(T)&&t(o)?-1:t(T)&&r(o)?1:0}function c(T,o,A=!1){return A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase()),T===o?0:T<o?-1:1}function m(T,o,A=!1){const F=T.split(g.sep),U=o.split(g.sep),j=F.length-1,ae=U.length-1;let G,B;for(let $=0;;$++){if(G=j===$,B=ae===$,G&&B)return y(F[$],U[$],A);if(G)return-1;if(B)return 1;const L=c(F[$],U[$],A);if(L!==0)return L}}e.comparePaths=m;function p(T,o,A){const F=T.toLowerCase(),U=o.toLowerCase(),j=D(T,o,A);if(j)return j;const ae=F.endsWith(A),G=U.endsWith(A);if(ae!==G)return ae?-1:1;const B=y(F,U);return B!==0?B:F.localeCompare(U)}e.compareAnything=p;function D(T,o,A){const F=T.toLowerCase(),U=o.toLowerCase(),j=F.startsWith(A),ae=U.startsWith(A);if(j!==ae)return j?-1:1;if(j&&ae){if(F.length<U.length)return-1;if(F.length>U.length)return 1}return 0}e.compareByPrefix=D}),define(be[27],Ee([0,1,8,44,14,21,15]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const _="**",C="/",n="[/\\\\]",I="[^/\\\\]",l=/\//g;function d(Y){switch(Y){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function u(Y,me){if(!Y)return[];const H=[];let oe=!1,de=!1,Ce="";for(const Ne of Y){switch(Ne){case me:if(!oe&&!de){H.push(Ce),Ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":de=!0;break;case"]":de=!1;break}Ce+=Ne}return Ce&&H.push(Ce),H}e.splitGlobAware=u;function f(Y){if(!Y)return"";let me="";const H=u(Y,C);if(H.every(oe=>oe===_))me=".*";else{let oe=!1;H.forEach((de,Ce)=>{if(de===_){oe||(me+=d(2),oe=!0);return}let Ne=!1,Me="",$e=!1,Xe="";for(const qe of de){if(qe!=="}"&&Ne){Me+=qe;continue}if($e&&(qe!=="]"||!Xe)){let je;qe==="-"?je=qe:(qe==="^"||qe==="!")&&!Xe?je="^":qe===C?je="":je=g.escapeRegExpCharacters(qe),Xe+=je;continue}switch(qe){case"{":Ne=!0;continue;case"[":$e=!0;continue;case"}":me+=`(?:${u(Me,",").map(K=>f(K)).join("|")})`,Ne=!1,Me="";break;case"]":me+="["+Xe+"]",$e=!1,Xe="";break;case"?":me+=I;continue;case"*":me+=d(1);continue;default:me+=g.escapeRegExpCharacters(qe)}}Ce<H.length-1&&(H[Ce+1]!==_||Ce+2<H.length)&&(me+=n),oe=!1})}return me}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new E.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(Y,me){if(!Y)return s;let H;typeof Y!="string"?H=Y.pattern:H=Y,H=H.trim();const oe=`${H}_${!!me.trimForExclusions}`;let de=t.get(oe);if(de)return c(de,Y);let Ce;if(b.test(H)){const Ne=H.substr(4);de=function(Me,$e){return typeof Me=="string"&&Me.endsWith(Ne)?H:null}}else(Ce=w.exec(m(H,me)))?de=p(Ce[1],H):(me.trimForExclusions?a:P).test(H)?de=D(H,me):(Ce=h.exec(m(H,me)))?de=T(Ce[1].substr(1),H,!0):(Ce=v.exec(m(H,me)))?de=T(Ce[1],H,!1):de=o(H);return t.set(oe,de),c(de,Y)}function c(Y,me){return typeof me=="string"?Y:function(H,oe){return R.isEqualOrParent(H,me.base)?Y(S.relative(me.base,H),oe):null}}function m(Y,me){return me.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,me){const H=`/${Y}`,oe=`\\${Y}`,de=function(Ne,Me){return typeof Ne!="string"?null:Me?Me===Y?me:null:Ne===Y||Ne.endsWith(H)||Ne.endsWith(oe)?me:null},Ce=[Y];return de.basenames=Ce,de.patterns=[me],de.allBasenames=Ce,de}function D(Y,me){const H=V(Y.slice(1,-1).split(",").map(Me=>i(Me,me)).filter(Me=>Me!==s),Y),oe=H.length;if(!oe)return s;if(oe===1)return H[0];const de=function(Me,$e){for(let Xe=0,qe=H.length;Xe<qe;Xe++)if(H[Xe](Me,$e))return Y;return null},Ce=H.find(Me=>!!Me.allBasenames);Ce&&(de.allBasenames=Ce.allBasenames);const Ne=H.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Ne.length&&(de.allPaths=Ne),de}function T(Y,me,H){const oe=S.sep===S.posix.sep,de=oe?Y:Y.replace(l,S.sep),Ce=S.sep+de,Ne=S.posix.sep+Y,Me=H?function($e,Xe){return typeof $e=="string"&&($e===de||$e.endsWith(Ce)||!oe&&($e===Y||$e.endsWith(Ne)))?me:null}:function($e,Xe){return typeof $e=="string"&&($e===de||!oe&&$e===Y)?me:null};return Me.allPaths=[(H?"*/":"./")+Y],Me}function o(Y){try{const me=new RegExp(`^${f(Y)}$`);return function(H){return me.lastIndex=0,typeof H=="string"&&me.test(H)?Y:null}}catch(me){return s}}function A(Y,me,H){return!Y||typeof me!="string"?!1:F(Y)(me,void 0,H)}e.match=A;function F(Y,me={}){if(!Y)return r;if(typeof Y=="string"||G(Y)){const H=i(Y,me);if(H===s)return r;const oe=function(de,Ce){return!!H(de,Ce)};return H.allBasenames&&(oe.allBasenames=H.allBasenames),H.allPaths&&(oe.allPaths=H.allPaths),oe}return L(Y,me)}e.parse=F;function U(Y){if(!Y)return;let me;return H=>(me||(me=(Y()||Promise.resolve([])).then(oe=>oe?ae(oe):{})),me.then(oe=>!!oe[H]))}e.hasSiblingPromiseFn=U;function j(Y){if(!Y)return;let me;return H=>{if(!me){const oe=Y();me=oe?ae(oe):{}}return!!me[H]}}e.hasSiblingFn=j;function ae(Y){const me={};for(const H of Y)me[H]=!0;return me}function G(Y){const me=Y;return me&&typeof me.base=="string"&&typeof me.pattern=="string"}e.isRelativePattern=G;function B(Y){return Y.allBasenames||[]}e.getBasenameTerms=B;function $(Y){return Y.allPaths||[]}e.getPathTerms=$;function L(Y,me){const H=V(Object.getOwnPropertyNames(Y).map(Me=>Z(Me,Y[Me],me)).filter(Me=>Me!==s)),oe=H.length;if(!oe)return s;if(!H.some(Me=>!!Me.requiresSiblings)){if(oe===1)return H[0];const Me=function(qe,je){for(let O=0,K=H.length;O<K;O++){const X=H[O](qe,je);if(X)return X}return null},$e=H.find(qe=>!!qe.allBasenames);$e&&(Me.allBasenames=$e.allBasenames);const Xe=H.reduce((qe,je)=>je.allPaths?qe.concat(je.allPaths):qe,[]);return Xe.length&&(Me.allPaths=Xe),Me}const de=function(Me,$e,Xe){let qe;for(let je=0,O=H.length;je<O;je++){const K=H[je];K.requiresSiblings&&Xe&&($e||($e=S.basename(Me)),qe||(qe=$e.substr(0,$e.length-S.extname(Me).length)));const X=K(Me,$e,qe,Xe);if(X)return X}return null},Ce=H.find(Me=>!!Me.allBasenames);Ce&&(de.allBasenames=Ce.allBasenames);const Ne=H.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Ne.length&&(de.allPaths=Ne),de}function Z(Y,me,H){if(me===!1)return s;const oe=i(Y,H);if(oe===s)return s;if(typeof me=="boolean")return oe;if(me){const de=me.when;if(typeof de=="string"){const Ce=(Ne,Me,$e,Xe)=>{if(!Xe||!oe(Ne,Me))return null;const qe=de.replace("$(basename)",$e),je=Xe(qe);return(0,k.isThenable)(je)?je.then(O=>O?Y:null):je?Y:null};return Ce.requiresSiblings=!0,Ce}}return oe}function V(Y,me){const H=Y.filter(Me=>!!Me.basenames);if(H.length<2)return Y;const oe=H.reduce((Me,$e)=>{const Xe=$e.basenames;return Xe?Me.concat(Xe):Me},[]);let de;if(me){de=[];for(let Me=0,$e=oe.length;Me<$e;Me++)de.push(me)}else de=H.reduce((Me,$e)=>{const Xe=$e.patterns;return Xe?Me.concat(Xe):Me},[]);const Ce=function(Me,$e){if(typeof Me!="string")return null;if(!$e){let qe;for(qe=Me.length;qe>0;qe--){const je=Me.charCodeAt(qe-1);if(je===47||je===92)break}$e=Me.substr(qe)}const Xe=oe.indexOf($e);return Xe!==-1?de[Xe]:null};Ce.basenames=oe,Ce.patterns=de,Ce.allBasenames=oe;const Ne=Y.filter(Me=>!Me.basenames);return Ne.push(Ce),Ne}}),define(be[84],Ee([0,1,2,14,8,11,22,25,44]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,c,m){if(typeof i=="string"&&(i=g.URI.file(i)),m){const D=m.getWorkspaceFolder(i);if(D){const T=m.getWorkspace().folders.length>1;let o;if((0,y.isEqual)(D.uri,i)?o="":o=(0,y.relativePath)(D.uri,i),T){const A=D.name?D.name:(0,y.basename)(D.uri);o=o?A+" \u2022 "+o:A}return o}}if(i.scheme!==E.Schemas.file&&i.scheme!==E.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(i.fsPath))return(0,R.normalize)(I(i.fsPath));let p=(0,R.normalize)(i.fsPath);return!k.isWindows&&c?.userHome&&(p=d(p,c.userHome.fsPath)),p}e.getPathLabel=C;function n(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const c=(0,y.basename)(i)||(i.scheme===E.Schemas.file?i.fsPath:i.path);return k.isWindows&&(0,_.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=n;function I(i){return(0,_.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let l=Object.create(null);function d(i,c){if(k.isWindows||!i||!c)return i;let m=l.original===c?l.normalized:void 0;return m||(m=`${(0,S.rtrim)(c,R.posix.sep)}${R.posix.sep}`,l={original:c,normalized:m}),(k.isLinux?i.startsWith(m):(0,S.startsWithIgnoreCase)(i,m))&&(i=`~/${i.substr(m.length)}`),i}e.tildify=d;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const f="\u2026",b="\\\\",w="~";function P(i,c=R.sep){const m=new Array(i.length);let p=!1;for(let D=0;D<i.length;D++){let T=i[D];if(T===""){m[D]=`.${c}`;continue}if(!T){m[D]=T;continue}p=!0;let o="";T.indexOf(b)===0?(o=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(c)===0?(o=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(w)===0&&(o=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const A=T.split(c);for(let F=1;p&&F<=A.length;F++)for(let U=A.length-F;p&&U>=0;U--){p=!1;let j=A.slice(U,U+F).join(c);for(let ae=0;!p&&ae<i.length;ae++)if(ae!==D&&i[ae]&&i[ae].indexOf(j)>-1){const G=U+F===A.length,B=U>0&&i[ae].indexOf(c)>-1?c+j:j,$=i[ae].endsWith(B);p=!G||$}if(!p){let ae="";(A[0].endsWith(":")||o!=="")&&(U===1&&(U=0,F++,j=A[0]+c+j),U>0&&(ae=A[0]+c),ae=o+ae),U>0&&(ae=ae+f+c),ae=ae+j,U+F<A.length&&(ae=ae+c+f),m[D]=ae}}p&&(m[D]=T)}return m}e.shorten=P;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function h(i,c=Object.create(null)){const m=[];let p=!1,D="";for(const T of i)if(T==="$"||p&&T==="{")D&&m.push({value:D,type:a.TEXT}),D="",p=!0;else if(T==="}"&&p){const o=c[D];if(typeof o=="string")o.length&&m.push({value:o,type:a.VARIABLE});else if(o){const A=m[m.length-1];(!A||A.type!==a.SEPARATOR)&&m.push({value:o.label,type:a.SEPARATOR})}D="",p=!1}else D+=T;return D&&!p&&m.push({value:D,type:a.TEXT}),m.filter((T,o)=>{if(T.type===a.SEPARATOR){const A=m[o-1],F=m[o+1];return[A,F].every(U=>U&&(U.type===a.VARIABLE||U.type===a.TEXT)&&U.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=h;function v(i,c){return k.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return k.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,m=>m==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const c=i.indexOf("/")!==-1?R.posix:R.win32,m=c.basename(i),p=c.dirname(i);return m.length?{name:m,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(be[85],Ee([0,1,14,8,27,11,25]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let _=[],C=[],n=[];function I(r,s=!1){const i=l(r);_.push(i),i.userConfigured?n.push(i):C.push(i),s&&!i.userConfigured&&_.forEach(c=>{c.mime===i.mime||c.userConfigured||(i.extension&&c.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&c.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&c.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&c.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=I;function l(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(g.posix.sep)>=0:!1}}function d(r){r?(_=_.filter(s=>!s.userConfigured),n=[]):(_=[],C=[],n=[])}e.clearTextMimes=d;function u(r,s){let i;if(r)switch(r.scheme){case E.Schemas.file:i=r.fsPath;break;case E.Schemas.data:i=k.DataUri.parseMetaData(r).get(k.DataUri.META_DATA_LABEL);break;default:i=r.path}if(!i)return[y.unknown];i=i.toLowerCase();const c=(0,g.basename)(i),m=f(i,c,n);if(m)return[m,y.text];const p=f(i,c,C);if(p)return[p,y.text];if(s){const D=b(s);if(D)return[D,y.text]}return[y.unknown]}e.guessMimeTypes=u;function f(r,s,i){let c=null,m=null,p=null;for(let D=i.length-1;D>=0;D--){const T=i[D];if(s===T.filenameLowercase){c=T;break}if(T.filepattern&&(!m||T.filepattern.length>m.filepattern.length)){const o=T.filepatternOnPath?r:s;(0,S.match)(T.filepatternLowercase,o)&&(m=T)}T.extension&&(!p||T.extension.length>p.extension.length)&&s.endsWith(T.extensionLowercase)&&(p=T)}return c?c.mime:m?m.mime:p?p.mime:null}function b(r){if((0,R.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let s=_.length-1;s>=0;s--){const i=_[s];if(!i.firstline)continue;const c=r.match(i.firstline);if(c&&c.length>0)return i.mime}return null}function w(r){return r?typeof r=="string"?r===y.binary||r===y.text||r===y.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(r){const s=(0,g.extname)(r);return P[s.toLowerCase()]}e.getMediaMime=a;function h(r){for(const s in P)if(P[s]===r)return s}e.getExtensionForMimeType=h;const v=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){const i=v.exec(r);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:s?void 0:r}e.normalizeMimeType=t}),define(be[117],Ee([0,1,2]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:R(g.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:R(g.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:g.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function E(n,I,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const u=E(n[d],I,l+1);u!==null&&(n[d]=u)}}return null}function k(n,I){const l=E(n,I,0);return l===null?n:l}e.transformOutgoingURIs=k;function y(n,I,l,d){if(!n||d>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const f=y(n[u],I,l,d+1);f!==null&&(n[u]=f)}}return null}function _(n,I){const l=y(n,I,!1,0);return l===null?n:l}e.transformIncomingURIs=_;function C(n,I){const l=y(n,I,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=C}),define(be[37],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(_){return g.test(_)}e.isUUID=R;const S=new Uint8Array(16),E=[];for(let _=0;_<256;_++)E.push(_.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function y(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let _=0,C="";return C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C}e.generateUuid=y}),define(be[86],Ee([0,1,82]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(y){let _=(0,g.toUint8)(y);this._defaultValue=_,this._asciiMap=R._createAsciiMap(_),this._map=new Map}static _createAsciiMap(y){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=y;return _}set(y,_){let C=(0,g.toUint8)(_);y>=0&&y<256?this._asciiMap[y]=C:this._map.set(y,C)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=R;var S;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(S||(S={}));class E{constructor(){this._actual=new R(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=E}),define(be[118],Ee([0,1,86]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends g.CharacterClassifier{constructor(y){super(0);for(let _=0,C=y.length;_<C;_++)this.set(y.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function E(k){let y={};return _=>(y.hasOwnProperty(_)||(y[_]=k(_)),y[_])}e.getMapForWordSeparators=E(k=>new S(k))}),define(be[38],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(S,E){this.lineNumber=S,this.column=E}with(S=this.lineNumber,E=this.column){return S===this.lineNumber&&E===this.column?this:new g(S,E)}delta(S=0,E=0){return this.with(this.lineNumber+S,this.column+E)}equals(S){return g.equals(this,S)}static equals(S,E){return!S&&!E?!0:!!S&&!!E&&S.lineNumber===E.lineNumber&&S.column===E.column}isBefore(S){return g.isBefore(this,S)}static isBefore(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<E.column}isBeforeOrEqual(S){return g.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<=E.column}static compare(S,E){let k=S.lineNumber|0,y=E.lineNumber|0;if(k===y){let _=S.column|0,C=E.column|0;return _-C}return k-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new g(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=g}),define(be[31],Ee([0,1,38]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(E,k,y,_){E>y||E===y&&k>_?(this.startLineNumber=y,this.startColumn=_,this.endLineNumber=E,this.endColumn=k):(this.startLineNumber=E,this.startColumn=k,this.endLineNumber=y,this.endColumn=_)}isEmpty(){return R.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return R.containsPosition(this,E)}static containsPosition(E,k){return!(k.lineNumber<E.startLineNumber||k.lineNumber>E.endLineNumber||k.lineNumber===E.startLineNumber&&k.column<E.startColumn||k.lineNumber===E.endLineNumber&&k.column>E.endColumn)}containsRange(E){return R.containsRange(this,E)}static containsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>E.endColumn)}strictContainsRange(E){return R.strictContainsRange(this,E)}static strictContainsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<=E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>=E.endColumn)}plusRange(E){return R.plusRange(this,E)}static plusRange(E,k){let y,_,C,n;return k.startLineNumber<E.startLineNumber?(y=k.startLineNumber,_=k.startColumn):k.startLineNumber===E.startLineNumber?(y=k.startLineNumber,_=Math.min(k.startColumn,E.startColumn)):(y=E.startLineNumber,_=E.startColumn),k.endLineNumber>E.endLineNumber?(C=k.endLineNumber,n=k.endColumn):k.endLineNumber===E.endLineNumber?(C=k.endLineNumber,n=Math.max(k.endColumn,E.endColumn)):(C=E.endLineNumber,n=E.endColumn),new R(y,_,C,n)}intersectRanges(E){return R.intersectRanges(this,E)}static intersectRanges(E,k){let y=E.startLineNumber,_=E.startColumn,C=E.endLineNumber,n=E.endColumn,I=k.startLineNumber,l=k.startColumn,d=k.endLineNumber,u=k.endColumn;return y<I?(y=I,_=l):y===I&&(_=Math.max(_,l)),C>d?(C=d,n=u):C===d&&(n=Math.min(n,u)),y>C||y===C&&_>n?null:new R(y,_,C,n)}equalsRange(E){return R.equalsRange(this,E)}static equalsRange(E,k){return!!E&&!!k&&E.startLineNumber===k.startLineNumber&&E.startColumn===k.startColumn&&E.endLineNumber===k.endLineNumber&&E.endColumn===k.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(E){return new g.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(E){return new g.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,k){return new R(this.startLineNumber,this.startColumn,E,k)}setStartPosition(E,k){return new R(E,k,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(E){return new R(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,k=E){return new R(E.lineNumber,E.column,k.lineNumber,k.column)}static lift(E){return E?new R(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<E.startColumn)}static areIntersecting(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<=k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,k){if(E&&k){const C=E.startLineNumber|0,n=k.startLineNumber|0;if(C===n){const I=E.startColumn|0,l=k.startColumn|0;if(I===l){const d=E.endLineNumber|0,u=k.endLineNumber|0;if(d===u){const f=E.endColumn|0,b=k.endColumn|0;return f-b}return d-u}return I-l}return C-n}return(E?1:0)-(k?1:0)}static compareRangesUsingEnds(E,k){return E.endLineNumber===k.endLineNumber?E.endColumn===k.endColumn?E.startLineNumber===k.startLineNumber?E.startColumn-k.startColumn:E.startLineNumber-k.startLineNumber:E.endColumn-k.endColumn:E.endLineNumber-k.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=R}),define(be[119],Ee([0,1,38,31]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class E extends R.Range{constructor(y,_,C,n){super(y,_,C,n);this.selectionStartLineNumber=y,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return E.selectionsEqual(this,y)}static selectionsEqual(y,_){return y.selectionStartLineNumber===_.selectionStartLineNumber&&y.selectionStartColumn===_.selectionStartColumn&&y.positionLineNumber===_.positionLineNumber&&y.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,_){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,y,_):new E(y,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,_){return this.getDirection()===0?new E(y,_,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,y,_)}static fromPositions(y,_=y){return new E(y.lineNumber,y.column,_.lineNumber,_.column)}static liftSelection(y){return new E(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,_){if(y&&!_||!y&&_)return!1;if(!y&&!_)return!0;if(y.length!==_.length)return!1;for(let C=0,n=y.length;C<n;C++)if(!this.selectionsEqual(y[C],_[C]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,_,C,n,I){return I===0?new E(y,_,C,n):new E(C,n,y,_)}}e.Selection=E}),define(be[87],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace)}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class _{constructor(f,b){this._findMatchBrand=void 0,this.range=f,this.matches=b}}e.FindMatch=_;var C;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(f,b,w,P,a,h){this.identifier=f,this.range=b,this.text=w,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=a,this._isTracked=h}}e.ValidAnnotatedEditOperation=l;class d{constructor(f,b,w){this.reverseEdits=f,this.changes=b,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=d}),define(be[120],Ee([0,1,8,118,38,31,87]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class _{constructor(a,h,v,t){this.searchString=a,this.isRegex=h,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=C(this.searchString):a=this.searchString.indexOf(`
`)>=0;let h=null;try{h=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let v=!this.isRegex&&!a;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(h,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=_;function C(P){if(!P||P.length===0)return!1;for(let a=0,h=P.length;a<h;a++)if(P.charCodeAt(a)===92){if(a++,a>=h)break;const t=P.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(a,h,v){this.regex=a,this.wordSeparators=h,this.simpleSearch=v}}e.SearchData=n;function I(P,a,h){if(!h)return new k.FindMatch(P,null);let v=[];for(let t=0,r=a.length;t<r;t++)v[t]=a[t];return new k.FindMatch(P,v)}e.createFindMatch=I;class l{constructor(a){let h=[],v=0;for(let t=0,r=a.length;t<r;t++)a.charCodeAt(t)===10&&(h[v++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(a){const h=this._lineFeedsOffsets;let v=0,t=h.length-1;if(t===-1||a<=h[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);h[r]>=a?t=r-1:h[r+1]>=a?(v=r,t=r):v=r+1}return v+1}}class d{static findMatches(a,h,v,t,r){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(a,v,new w(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(a,v,s,t,r):[]}static _getMultilineMatchRange(a,h,v,t,r,s){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(r),i=h+r+c):i=h+r;let m;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-c;m=i+s.length+o}else m=i+s.length;const p=a.getPositionAt(i),D=a.getPositionAt(m);return new E.Range(p.lineNumber,p.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(a,h,v,t,r){const s=a.getOffsetAt(h.getStartPosition()),i=a.getValueInRange(h,1),c=a.getEOL()===`\r
`?new l(i):null,m=[];let p=0,D;for(v.reset(0);D=v.next(i);)if(m[p++]=I(this._getMultilineMatchRange(a,s,i,c,D.index,D[0]),D,t),p>=r)return m;return m}static _doFindMatchesLineByLine(a,h,v,t,r){const s=[];let i=0;if(h.startLineNumber===h.endLineNumber){const m=a.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return i=this._findMatchesInLine(v,m,h.startLineNumber,h.startColumn-1,i,s,t,r),s}const c=a.getLineContent(h.startLineNumber).substring(h.startColumn-1);i=this._findMatchesInLine(v,c,h.startLineNumber,h.startColumn-1,i,s,t,r);for(let m=h.startLineNumber+1;m<h.endLineNumber&&i<r;m++)i=this._findMatchesInLine(v,a.getLineContent(m),m,0,i,s,t,r);if(i<r){const m=a.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);i=this._findMatchesInLine(v,m,h.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(a,h,v,t,r,s,i,c){const m=a.wordSeparators;if(!i&&a.simpleSearch){const T=a.simpleSearch,o=T.length,A=h.length;let F=-o;for(;(F=h.indexOf(T,F+o))!==-1;)if((!m||b(m,h,A,F,o))&&(s[r++]=new k.FindMatch(new E.Range(v,F+1+t,v,F+1+o+t),null),r>=c))return r;return r}const p=new w(a.wordSeparators,a.regex);let D;p.reset(0);do if(D=p.next(h),D&&(s[r++]=I(new E.Range(v,D.index+1+t,v,D.index+1+D[0].length+t),D,i),r>=c))return r;while(D);return r}static findNextMatch(a,h,v,t){const r=h.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(a,v,s,t):this._doFindNextMatchLineByLine(a,v,s,t)}static _doFindNextMatchMultiline(a,h,v,t){const r=new S.Position(h.lineNumber,1),s=a.getOffsetAt(r),i=a.getLineCount(),c=a.getValueInRange(new E.Range(r.lineNumber,r.column,i,a.getLineMaxColumn(i)),1),m=a.getEOL()===`\r
`?new l(c):null;v.reset(h.column-1);let p=v.next(c);return p?I(this._getMultilineMatchRange(a,s,c,m,p.index,p[0]),p,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(a,new S.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(a,h,v,t){const r=a.getLineCount(),s=h.lineNumber,i=a.getLineContent(s),c=this._findFirstMatchInLine(v,i,s,h.column,t);if(c)return c;for(let m=1;m<=r;m++){const p=(s+m-1)%r,D=a.getLineContent(p+1),T=this._findFirstMatchInLine(v,D,p+1,1,t);if(T)return T}return null}static _findFirstMatchInLine(a,h,v,t,r){a.reset(t-1);const s=a.next(h);return s?I(new E.Range(v,s.index+1,v,s.index+1+s[0].length),s,r):null}static findPreviousMatch(a,h,v,t){const r=h.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(a,v,s,t):this._doFindPreviousMatchLineByLine(a,v,s,t)}static _doFindPreviousMatchMultiline(a,h,v,t){const r=this._doFindMatchesMultiline(a,new E.Range(1,1,h.lineNumber,h.column),v,t,10*y);if(r.length>0)return r[r.length-1];const s=a.getLineCount();return h.lineNumber!==s||h.column!==a.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(a,new S.Position(s,a.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(a,h,v,t){const r=a.getLineCount(),s=h.lineNumber,i=a.getLineContent(s).substring(0,h.column-1),c=this._findLastMatchInLine(v,i,s,t);if(c)return c;for(let m=1;m<=r;m++){const p=(r+s-m-1)%r,D=a.getLineContent(p+1),T=this._findLastMatchInLine(v,D,p+1,t);if(T)return T}return null}static _findLastMatchInLine(a,h,v,t){let r=null,s;for(a.reset(0);s=a.next(h);)r=I(new E.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=d;function u(P,a,h,v,t){if(v===0)return!0;const r=a.charCodeAt(v-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v);if(P.get(s)!==0)return!0}return!1}function f(P,a,h,v,t){if(v+t===h)return!0;const r=a.charCodeAt(v+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v+t-1);if(P.get(s)!==0)return!0}return!1}function b(P,a,h,v,t){return u(P,a,h,v,t)&&f(P,a,h,v,t)}e.isValidMatch=b;class w{constructor(a,h){this._wordSeparators=a,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const h=a.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(v=this._searchRegex.exec(a),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(a,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,a,h,t,r))return v}while(v);return null}}e.Searcher=w}),define(be[88],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)y.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function R(y){let _=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)_=y;else{let C="g";y.ignoreCase&&(C+="i"),y.multiline&&(C+="m"),y.unicode&&(C+="u"),_=new RegExp(y.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=R;const S={maxLen:1e3,windowSize:15,timeBudget:150};function E(y,_,C,n,I=S){if(C.length>I.maxLen){let b=y-I.maxLen/2;return b<0?b=0:n+=b,C=C.substring(b,y+I.maxLen/2),E(y,_,C,n,I)}const l=Date.now(),d=y-1-n;let u=-1,f=null;for(let b=1;!(Date.now()-l>=I.timeBudget);b++){const w=d-I.windowSize*b;_.lastIndex=Math.max(0,w);const P=k(_,C,d,u);if(!P&&f||(f=P,w<=0))break;u=w}if(f){let b={word:f[0],startColumn:n+1+f.index,endColumn:n+1+f.index+f[0].length};return _.lastIndex=0,b}return null}e.getWordAtText=E;function k(y,_,C,n){let I;for(;I=y.exec(_);){const l=I.index||0;if(l<=C&&y.lastIndex>=C)return I;if(n>0&&l>n)return null}return null}}),define(be[121],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class R{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let _=0,C=y.notIn.length;_<C;_++)switch(y.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=R;class S{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of y)E(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),E(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),E(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),E(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&E(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=S;function E(k,y,_){k.has(y)?k.get(y).push(_):k.set(y,[_])}}),define(be[57],Ee([0,1,27,14]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(E,k,y,_){if(Array.isArray(E)){let C=0;for(const n of E){const I=S(n,k,y,_);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof E=="string")return _?E==="*"?5:E===y?10:0:0;if(E){const{language:C,pattern:n,scheme:I,hasAccessToAllModels:l}=E;if(!_&&!l)return 0;let d=0;if(I)if(I===k.scheme)d=10;else if(I==="*")d=5;else return 0;if(C)if(C===y)d=10;else if(C==="*")d=Math.max(d,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,R.normalize)(n.base)},u===k.fsPath||(0,g.match)(u,k.fsPath))d=10;else return 0}return d}else return 0}}e.score=S}),define(be[122],Ee([0,1,86]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class S{constructor(u,f,b){const w=new Uint8Array(u*f);for(let P=0,a=u*f;P<a;P++)w[P]=b;this._data=w,this.rows=u,this.cols=f}get(u,f){return this._data[u*this.cols+f]}set(u,f,b){this._data[u*this.cols+f]=b}}e.Uint8Matrix=S;class E{constructor(u){let f=0,b=0;for(let P=0,a=u.length;P<a;P++){let[h,v,t]=u[P];v>f&&(f=v),h>b&&(b=h),t>b&&(b=t)}f++,b++;let w=new S(b,f,0);for(let P=0,a=u.length;P<a;P++){let[h,v,t]=u[P];w.set(h,v,t)}this._states=w,this._maxCharCode=f}nextState(u,f){return f<0||f>=this._maxCharCode?0:this._states.get(u,f)}}e.StateMachine=E;let k=null;function y(){return k===null&&(k=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var _;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function n(){if(C===null){C=new g.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<d.length;f++)C.set(d.charCodeAt(f),1);const u=".,;";for(let f=0;f<u.length;f++)C.set(u.charCodeAt(f),2)}return C}class I{static _createLink(u,f,b,w,P){let a=P-1;do{const h=f.charCodeAt(a);if(u.get(h)!==2)break;a--}while(a>w);if(w>0){const h=f.charCodeAt(w-1),v=f.charCodeAt(a);(h===40&&v===41||h===91&&v===93||h===123&&v===125)&&a--}return{range:{startLineNumber:b,startColumn:w+1,endLineNumber:b,endColumn:a+2},url:f.substring(w,a+1)}}static computeLinks(u,f=y()){const b=n();let w=[];for(let P=1,a=u.getLineCount();P<=a;P++){const h=u.getLineContent(P),v=h.length;let t=0,r=0,s=0,i=1,c=!1,m=!1,p=!1,D=!1;for(;t<v;){let T=!1;const o=h.charCodeAt(t);if(i===13){let A;switch(o){case 40:c=!0,A=0;break;case 41:A=c?0:1;break;case 91:p=!0,m=!0,A=0;break;case 93:p=!1,A=m?0:1;break;case 123:D=!0,A=0;break;case 125:A=D?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=p?0:1;break;default:A=b.get(o)}A===1&&(w.push(I._createLink(b,h,P,r,t)),T=!0)}else if(i===12){let A;o===91?(m=!0,A=0):A=b.get(o),A===1?T=!0:i=13}else i=f.nextState(i,o),i===0&&(T=!0);T&&(i=1,c=!1,m=!1,D=!1,r=t+1,s=o),t++}i===13&&w.push(I._createLink(b,h,P,r,v))}return w}}e.LinkComputer=I;function l(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}e.computeLinks=l}),define(be[123],Ee([0,1,3,6]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this._map.set(k,y),this.fire([k]),(0,R.toDisposable)(()=>{this._map.get(k)===y&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,y){let _=null,C=!1;return this._promises.set(k,y.then(n=>{this._promises.delete(k),!(C||!n)&&(_=this.register(k,n))})),(0,R.toDisposable)(()=>{C=!0,_&&_.dispose()})}getPromise(k){const y=this.get(k);if(y)return Promise.resolve(y);const _=this._promises.get(k);return _?_.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(be[89],Ee([0,1,24,22]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function E(I){for(let l=0,d=I.length;l<d;l+=4){const u=I[l+0],f=I[l+1],b=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=b,I[l+2]=f,I[l+3]=u}}function k(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||E(l),g.VSBuffer.wrap(l)}function y(I){const l=I.buffer;if(R.isLittleEndian()||E(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const d=new Uint8Array(l.byteLength);return d.set(l),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function _(I){const l=new Uint32Array(C(I));let d=0;if(l[d++]=I.id,I.type==="full")l[d++]=1,l[d++]=I.data.length,l.set(I.data,d),d+=I.data.length;else{l[d++]=2,l[d++]=I.deltas.length;for(const u of I.deltas)l[d++]=u.start,l[d++]=u.deleteCount,u.data?(l[d++]=u.data.length,l.set(u.data,d),d+=u.data.length):l[d++]=0}return k(l)}e.encodeSemanticTokensDto=_;function C(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const d of I.deltas)d.data&&(l+=d.data.length)}return l}function n(I){const l=y(I);let d=0;const u=l[d++];if(l[d++]===1){const P=l[d++],a=l.subarray(d,d+P);return d+=P,{id:u,type:"full",data:a}}const b=l[d++];let w=[];for(let P=0;P<b;P++){const a=l[d++],h=l[d++],v=l[d++];let t;v>0&&(t=l.subarray(d,d+v),d+=v),w[P]={start:a,deleteCount:h,data:t}}return{id:u,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(be[90],Ee([0,1,82]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(k,y){this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=y}}e.PrefixSumIndexOfResult=R;class S{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,y){k=(0,g.toUint32)(k);const _=this.values,C=this.prefixSum,n=y.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k),k+n),this.values.set(y,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,y){return k=(0,g.toUint32)(k),y=(0,g.toUint32)(y),this.values[k]===y?!1:(this.values[k]=y,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,y){k=(0,g.toUint32)(k),y=(0,g.toUint32)(y);const _=this.values,C=this.prefixSum;if(k>=_.length)return!1;let n=_.length-k;return y>=n&&(y=n),y===0?!1:(this.values=new Uint32Array(_.length-y),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k+y),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=(0,g.toUint32)(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),k>=this.values.length&&(k=this.values.length-1);for(let _=y;_<=k;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let y=0,_=this.values.length-1,C=0,n=0,I=0;for(;y<=_;)if(C=y+(_-y)/2|0,n=this.prefixSum[C],I=n-this.values[C],k<I)_=C-1;else if(k>=n)y=C+1;else break;return new R(C,k-I)}}e.PrefixSumComputer=S}),define(be[124],Ee([0,1,8,38,90]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(y,_,C,n){this._uri=y,this._lines=_,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const _=y.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let n=0;n<_;n++)C[n]=this._lines[n].length+y;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(y,_){this._lines[y]=_,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,_){if(_.length===0)return;let C=(0,g.splitLines)(_);if(C.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+C[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}C[C.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(y.lineNumber+I-1,0,C[I]),n[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,n)}}e.MirrorTextModel=E}),define(be[125],Ee([18,19]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(be[58],Ee([0,1,125,10,17]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(C,n){return n&&(C.stack||C.stacktrace)?g.localize(0,null,y(C),k(C.stack)||k(C.stacktrace)):y(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function y(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function _(C=null,n=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const I=S.coalesce(C),l=_(I[0],n);return I.length>1?g.localize(4,null,l,I.length):l}if(R.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return E(I.error,n);if(I.exception)return E(I.exception,n)}return C.stack?E(C,n):C.message?C.message:g.localize(5,null)}e.toErrorMessage=_}),define(be[126],Ee([18,19]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(be[127],Ee([0,1,126,22,88]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=k;class y{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,ce){this._values[ee]=ce}}e.ValidatedEditorOptions=y;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(ee,ce,Ue,xe){this.id=ee,this.name=ce,this.defaultValue=Ue,this.schema=xe}compute(ee,ce,Ue){return Ue}}class n{constructor(ee,ce=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=ce}validate(ee){return this.defaultValue}}class I{constructor(ee,ce,Ue,xe){this.id=ee,this.name=ce,this.defaultValue=Ue,this.schema=xe}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,ce,Ue){return Ue}}function l(z,ee){return typeof z=="undefined"?ee:z==="false"?!1:Boolean(z)}e.boolean=l;class d extends I{constructor(ee,ce,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Ue),super(ee,ce,Ue,xe)}validate(ee){return l(ee,this.defaultValue)}}class u extends I{constructor(ee,ce,Ue,xe,et,Se=void 0){typeof Se!="undefined"&&(Se.type="integer",Se.default=Ue,Se.minimum=xe,Se.maximum=et),super(ee,ce,Ue,Se),this.minimum=xe,this.maximum=et}static clampedInt(ee,ce,Ue,xe){if(typeof ee=="undefined")return ce;let et=parseInt(ee,10);return isNaN(et)?ce:(et=Math.max(Ue,et),et=Math.min(xe,et),et|0)}validate(ee){return u.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class f extends I{constructor(ee,ce,Ue,xe,et){typeof et!="undefined"&&(et.type="number",et.default=Ue),super(ee,ce,Ue,et),this.validationFn=xe}static clamp(ee,ce,Ue){return ee<ce?ce:ee>Ue?Ue:ee}static float(ee,ce){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return ce;const Ue=parseFloat(ee);return isNaN(Ue)?ce:Ue}validate(ee){return this.validationFn(f.float(ee,this.defaultValue))}}class b extends I{static string(ee,ce){return typeof ee!="string"?ce:ee}constructor(ee,ce,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Ue),super(ee,ce,Ue,xe)}validate(ee){return b.string(ee,this.defaultValue)}}function w(z,ee,ce){return typeof z!="string"||ce.indexOf(z)===-1?ee:z}e.stringSet=w;class P extends I{constructor(ee,ce,Ue,xe,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=xe,et.default=Ue),super(ee,ce,Ue,et),this._allowedValues=xe}validate(ee){return w(ee,this.defaultValue,this._allowedValues)}}class a extends C{constructor(ee,ce,Ue,xe,et,Se,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=et,ye.default=xe),super(ee,ce,Ue,ye),this._allowedValues=et,this._convert=Se}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function h(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,ce,Ue){return Ue===0?ee.accessibilitySupport:Ue}}class t extends C{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{insertSpace:l(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(z){switch(z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function m(z){switch(z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class p extends n{constructor(){super(126,[64,31])}compute(ee,ce,Ue){const xe=["monaco-editor"];return ce.get(31)&&xe.push(ce.get(31)),ee.extraEditorClassName&&xe.push(ee.extraEditorClassName),ce.get(64)==="default"?xe.push("mouse-default"):ce.get(64)==="copy"&&xe.push("mouse-copy"),ce.get(99)&&xe.push("showUnused"),ce.get(124)&&xe.push("showDeprecated"),xe.join(" ")}}class D extends d{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ee,ce,Ue){return Ue&&ee.emptySelectionClipboard}}class T extends C{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:g.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:g.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{cursorMoveOnType:l(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":w(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ce.loop,this.defaultValue.loop)}}}class o extends C{constructor(){super(42,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?o.OFF:ee==="true"?o.ON:ee:Boolean(ee)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class A extends n{constructor(){super(41)}compute(ee,ce,Ue){return ee.fontInfo}}class F extends I{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(ee){let ce=f.float(ee,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ce,6,100)}compute(ee,ce,Ue){return ee.fontInfo.fontSize}}class U extends C{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(u.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class j extends C{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(26,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(27,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:g.localize(28,null),...ce},"editor.gotoLocation.multipleImplementations":{description:g.localize(29,null),...ce},"editor.gotoLocation.multipleReferences":{description:g.localize(30,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Ue,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Ue,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Ue,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Ue,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Ue,description:g.localize(35,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{multiple:w(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??w(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??w(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??w(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??w(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??w(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends C{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(51,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:g.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{enabled:l(ce.enabled,this.defaultValue.enabled),delay:u.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:l(ce.sticky,this.defaultValue.sticky)}}}var G;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class B extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(ee,ce,Ue){return B.computeLayout(ce,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const ce=ee.height/ee.lineHeight,Ue=ee.scrollBeyondLastLine?ce-1:0,xe=(ee.viewLineCount+Ue)/(ee.pixelRatio*ee.height),et=Math.floor(ee.viewLineCount/xe);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Ue,desiredRatio:xe,minimapLineCount:et}}static _computeMinimapLayout(ee,ce){const Ue=ee.outerWidth,xe=ee.outerHeight,et=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Se=ce.stableMinimapLayoutInput,ye=Se&&ee.outerHeight===Se.outerHeight&&ee.lineHeight===Se.lineHeight&&ee.typicalHalfwidthCharacterWidth===Se.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Se.pixelRatio&&ee.scrollBeyondLastLine===Se.scrollBeyondLastLine&&ee.minimap.enabled===Se.minimap.enabled&&ee.minimap.side===Se.minimap.side&&ee.minimap.size===Se.minimap.size&&ee.minimap.showSlider===Se.minimap.showSlider&&ee.minimap.renderCharacters===Se.minimap.renderCharacters&&ee.minimap.maxColumn===Se.minimap.maxColumn&&ee.minimap.scale===Se.minimap.scale&&ee.verticalScrollbarWidth===Se.verticalScrollbarWidth&&ee.isViewportWrapping===Se.isViewportWrapping,Pe=ee.lineHeight,se=ee.typicalHalfwidthCharacterWidth,le=ee.scrollBeyondLastLine,he=ee.minimap.renderCharacters;let pe=et>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const x=ee.minimap.maxColumn,fe=ee.minimap.size,we=ee.minimap.side,Ie=ee.verticalScrollbarWidth,Oe=ee.viewLineCount,He=ee.remainingWidth,Ze=ee.isViewportWrapping,Ke=he?2:3;let Je=Math.floor(et*xe);const ut=Je/et;let mt=!1,bt=!1,ot=Ke*pe,at=pe/et,_e=1;if(fe==="fill"||fe==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:ct,desiredRatio:yt,minimapLineCount:kt}=B.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:le,height:xe,lineHeight:Pe,pixelRatio:et});if(Oe/kt>1)mt=!0,bt=!0,pe=1,ot=1,at=pe/et;else{let ft=!1,dt=pe+1;if(fe==="fit"){const vt=Math.ceil((Oe+ct)*ot);Ze&&ye&&He<=ce.stableFitRemainingWidth?(ft=!0,dt=ce.stableFitMaxMinimapScale):ft=vt>Je}if(fe==="fill"||ft){mt=!0;const vt=pe;ot=Math.min(Pe*et,Math.max(1,Math.floor(1/yt))),Ze&&ye&&He<=ce.stableFitRemainingWidth&&(dt=ce.stableFitMaxMinimapScale),pe=Math.min(dt,Math.max(1,Math.floor(ot/Ke))),pe>vt&&(_e=Math.min(2,pe/vt)),at=pe/et/_e,Je=Math.ceil(Math.max(Ge,Oe+ct)*ot),Ze?(ce.stableMinimapLayoutInput=ee,ce.stableFitRemainingWidth=He,ce.stableFitMaxMinimapScale=pe):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const ke=Math.floor(x*at),Q=Math.min(ke,Math.max(0,Math.floor((He-Ie-2)*at/(se+at)))+e.MINIMAP_GUTTER_WIDTH);let W=Math.floor(et*Q);const Fe=W/et;W=Math.floor(W*_e);const Te=he?1:2,tt=we==="left"?0:Ue-Q-Ie;return{renderMinimap:Te,minimapLeft:tt,minimapWidth:Q,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:pe,minimapLineHeight:ot,minimapCanvasInnerWidth:W,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:ut}}static computeLayout(ee,ce){const Ue=ce.outerWidth|0,xe=ce.outerHeight|0,et=ce.lineHeight|0,Se=ce.lineNumbersDigitCount|0,ye=ce.typicalHalfwidthCharacterWidth,Pe=ce.maxDigitWidth,se=ce.pixelRatio,le=ce.viewLineCount,he=ee.get(121),pe=he==="inherit"?ee.get(120):he,x=pe==="inherit"?ee.get(116):pe,fe=ee.get(119),we=ee.get(2),Ie=ce.isDominatedByLongLines,Oe=ee.get(47),He=ee.get(58).renderType!==0,Ze=ee.get(59),Ke=ee.get(93),Je=ee.get(63),ut=ee.get(91),mt=ut.verticalScrollbarSize,bt=ut.verticalHasArrows,ot=ut.arrowSize,at=ut.horizontalScrollbarSize,_e=ee.get(56),ke=ee.get(35);let Q;if(typeof _e=="string"&&/^\d+(\.\d+)?ch$/.test(_e)){const It=parseFloat(_e.substr(0,_e.length-2));Q=u.clampedInt(It*ye,0,0,1e3)}else Q=u.clampedInt(_e,0,0,1e3);ke&&(Q+=16);let W=0;if(He){const It=Math.max(Se,Ze);W=Math.round(It*Pe)}let Fe=0;Oe&&(Fe=et);let Te=0,tt=Te+Fe,Ge=tt+W,ct=Ge+Q;const yt=Ue-Fe-W-Q;let kt=!1,Dt=!1,ft=-1;we!==2&&(pe==="inherit"&&Ie?(kt=!0,Dt=!0):x==="on"||x==="bounded"?Dt=!0:x==="wordWrapColumn"&&(ft=fe));const dt=B._computeMinimapLayout({outerWidth:Ue,outerHeight:xe,lineHeight:et,typicalHalfwidthCharacterWidth:ye,pixelRatio:se,scrollBeyondLastLine:Ke,minimap:Je,verticalScrollbarWidth:mt,viewLineCount:le,remainingWidth:yt,isViewportWrapping:Dt},ce.memory||new _);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Te+=dt.minimapWidth,tt+=dt.minimapWidth,Ge+=dt.minimapWidth,ct+=dt.minimapWidth);const vt=yt-dt.minimapWidth,Et=Math.max(1,Math.floor((vt-mt-2)/ye)),Tt=bt?ot:0;return Dt&&(ft=Math.max(1,Et),x==="bounded"&&(ft=Math.min(ft,fe))),{width:Ue,height:xe,glyphMarginLeft:Te,glyphMarginWidth:Fe,lineNumbersLeft:tt,lineNumbersWidth:W,decorationsLeft:Ge,decorationsWidth:Q,contentLeft:ct,contentWidth:vt,minimap:dt,viewportColumn:Et,isWordWrapMinified:kt,isViewportWrapping:Dt,wrappingColumn:ft,verticalScrollbarWidth:mt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:mt,height:xe-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=B;class $ extends C{constructor(){const ee={enabled:!0};super(55,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:g.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:l(ee.enabled,this.defaultValue.enabled)}}}class L extends C{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:g.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{enabled:l(ce.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class Z extends f{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>f.clamp(ee,0,150),{markdownDescription:g.localize(43,null)})}compute(ee,ce,Ue){return ee.fontInfo.lineHeight}}class V extends C{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:ee.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:g.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{enabled:l(ce.enabled,this.defaultValue.enabled),size:w(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ce.side,this.defaultValue.side,["right","left"]),showSlider:w(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ce.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(ce.scale,1,1,3),maxColumn:u.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends C{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{top:u.clampedInt(ce.top,0,0,1e3),bottom:u.clampedInt(ce.bottom,0,0,1e3)}}}class H extends C{constructor(){const ee={enabled:!0,cycle:!1};super(74,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:g.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{enabled:l(ce.enabled,this.defaultValue.enabled),cycle:l(ce.cycle,this.defaultValue.cycle)}}}class oe extends n{constructor(){super(127)}compute(ee,ce,Ue){return ee.pixelRatio}}class de extends C{constructor(){const ee={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:g.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:g.localize(59,null)},other:{type:"boolean",default:ee.other,description:g.localize(60,null)}}}],default:ee,description:g.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const ce=ee,Ue={other:l(ce.other,this.defaultValue.other),comments:l(ce.comments,this.defaultValue.comments),strings:l(ce.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Ce;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Ce=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends C{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(ee){let ce=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(ce=4,Ue=ee):ee==="interval"?ce=3:ee==="relative"?ce=2:ee==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ue}}}function Me(z){const ee=z.get(86);return ee==="editable"?z.get(79):ee!=="on"}e.filterValidationDecorations=Me;class $e extends C{constructor(){const ee=[],ce={type:"number",description:g.localize(67,null)};super(90,"rulers",ee,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:ee,description:g.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let ce=[];for(let Ue of ee)if(typeof Ue=="number")ce.push({column:u.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const xe=Ue;ce.push({column:u.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ce.sort((Ue,xe)=>Ue.column-xe.column),ce}return this.defaultValue}}function Xe(z,ee){if(typeof z!="string")return ee;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends C{constructor(){const ee={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(70,null),g.localize(71,null),g.localize(72,null)],default:"auto",description:g.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:g.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:g.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:g.localize(80,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee,Ue=u.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=u.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Xe(ce.vertical,this.defaultValue.vertical),horizontal:Xe(ce.horizontal,this.defaultValue.horizontal),useShadows:l(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:u.clampedInt(ce.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:u.clampedInt(ce.verticalSliderSize,xe,0,1e3),scrollByPage:l(ce.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends C{constructor(){const ee={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:g.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)],default:ee.mode,description:g.localize(85,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{enabled:l(ce.enabled,this.defaultValue.enabled),mode:w(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends C{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(86,null),g.localize(87,null)],default:ee.insertMode,description:g.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:g.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:g.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:g.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:g.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:g.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:g.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:g.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(96,null),g.localize(97,null),g.localize(98,null)],default:ee.previewMode,description:g.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:g.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ce=ee;return{insertMode:w(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ce.showIcons,this.defaultValue.showIcons),showStatusBar:l(ce.showStatusBar,this.defaultValue.showStatusBar),preview:l(ce.preview,this.defaultValue.preview),previewMode:w(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ce.showMethods,this.defaultValue.showMethods),showFunctions:l(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ce.showFields,this.defaultValue.showFields),showVariables:l(ce.showVariables,this.defaultValue.showVariables),showClasses:l(ce.showClasses,this.defaultValue.showClasses),showStructs:l(ce.showStructs,this.defaultValue.showStructs),showInterfaces:l(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ce.showModules,this.defaultValue.showModules),showProperties:l(ce.showProperties,this.defaultValue.showProperties),showEvents:l(ce.showEvents,this.defaultValue.showEvents),showOperators:l(ce.showOperators,this.defaultValue.showOperators),showUnits:l(ce.showUnits,this.defaultValue.showUnits),showValues:l(ce.showValues,this.defaultValue.showValues),showConstants:l(ce.showConstants,this.defaultValue.showConstants),showEnums:l(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ce.showKeywords,this.defaultValue.showKeywords),showWords:l(ce.showWords,this.defaultValue.showWords),showColors:l(ce.showColors,this.defaultValue.showColors),showFiles:l(ce.showFiles,this.defaultValue.showFiles),showReferences:l(ce.showReferences,this.defaultValue.showReferences),showFolders:l(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ce.showSnippets,this.defaultValue.showSnippets),showUsers:l(ce.showUsers,this.defaultValue.showUsers),showIssues:l(ce.showIssues,this.defaultValue.showIssues)}}}class K extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(132,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends n{constructor(){super(128,[79])}compute(ee,ce,Ue){return ce.get(79)?!0:ee.tabFocusMode}}var re;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function q(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ie extends n{constructor(){super(130,[129])}compute(ee,ce,Ue){const xe=ce.get(129);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?We:ge,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(z){return e.editorOptionsRegistry[z.id]=z,z}var Ye;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.foldingImportsByDefault=38]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=40]="fontFamily",z[z.fontInfo=41]="fontInfo",z[z.fontLigatures=42]="fontLigatures",z[z.fontSize=43]="fontSize",z[z.fontWeight=44]="fontWeight",z[z.formatOnPaste=45]="formatOnPaste",z[z.formatOnType=46]="formatOnType",z[z.glyphMargin=47]="glyphMargin",z[z.gotoLocation=48]="gotoLocation",z[z.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",z[z.hover=51]="hover",z[z.inDiffEditor=52]="inDiffEditor",z[z.inlineSuggest=53]="inlineSuggest",z[z.letterSpacing=54]="letterSpacing",z[z.lightbulb=55]="lightbulb",z[z.lineDecorationsWidth=56]="lineDecorationsWidth",z[z.lineHeight=57]="lineHeight",z[z.lineNumbers=58]="lineNumbers",z[z.lineNumbersMinChars=59]="lineNumbersMinChars",z[z.linkedEditing=60]="linkedEditing",z[z.links=61]="links",z[z.matchBrackets=62]="matchBrackets",z[z.minimap=63]="minimap",z[z.mouseStyle=64]="mouseStyle",z[z.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=66]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",z[z.multiCursorModifier=68]="multiCursorModifier",z[z.multiCursorPaste=69]="multiCursorPaste",z[z.occurrencesHighlight=70]="occurrencesHighlight",z[z.overviewRulerBorder=71]="overviewRulerBorder",z[z.overviewRulerLanes=72]="overviewRulerLanes",z[z.padding=73]="padding",z[z.parameterHints=74]="parameterHints",z[z.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",z[z.quickSuggestions=77]="quickSuggestions",z[z.quickSuggestionsDelay=78]="quickSuggestionsDelay",z[z.readOnly=79]="readOnly",z[z.renameOnType=80]="renameOnType",z[z.renderControlCharacters=81]="renderControlCharacters",z[z.renderIndentGuides=82]="renderIndentGuides",z[z.renderFinalNewline=83]="renderFinalNewline",z[z.renderLineHighlight=84]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=86]="renderValidationDecorations",z[z.renderWhitespace=87]="renderWhitespace",z[z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",z[z.roundedSelection=89]="roundedSelection",z[z.rulers=90]="rulers",z[z.scrollbar=91]="scrollbar",z[z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=93]="scrollBeyondLastLine",z[z.scrollPredominantAxis=94]="scrollPredominantAxis",z[z.selectionClipboard=95]="selectionClipboard",z[z.selectionHighlight=96]="selectionHighlight",z[z.selectOnLineNumbers=97]="selectOnLineNumbers",z[z.showFoldingControls=98]="showFoldingControls",z[z.showUnused=99]="showUnused",z[z.snippetSuggestions=100]="snippetSuggestions",z[z.smartSelect=101]="smartSelect",z[z.smoothScrolling=102]="smoothScrolling",z[z.stickyTabStops=103]="stickyTabStops",z[z.stopRenderingLineAfter=104]="stopRenderingLineAfter",z[z.suggest=105]="suggest",z[z.suggestFontSize=106]="suggestFontSize",z[z.suggestLineHeight=107]="suggestLineHeight",z[z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",z[z.suggestSelection=109]="suggestSelection",z[z.tabCompletion=110]="tabCompletion",z[z.tabIndex=111]="tabIndex",z[z.unusualLineTerminators=112]="unusualLineTerminators",z[z.useShadowDOM=113]="useShadowDOM",z[z.useTabStops=114]="useTabStops",z[z.wordSeparators=115]="wordSeparators",z[z.wordWrap=116]="wordWrap",z[z.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=119]="wordWrapColumn",z[z.wordWrapOverride1=120]="wordWrapOverride1",z[z.wordWrapOverride2=121]="wordWrapOverride2",z[z.wrappingIndent=122]="wrappingIndent",z[z.wrappingStrategy=123]="wrappingStrategy",z[z.showDeprecated=124]="showDeprecated",z[z.inlayHints=125]="inlayHints",z[z.editorClassName=126]="editorClassName",z[z.pixelRatio=127]="pixelRatio",z[z.tabFocusMode=128]="tabFocusMode",z[z.layoutInfo=129]="layoutInfo",z[z.wrappingInfo=130]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(133,null)})),acceptSuggestionOnEnter:ve(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(134,null),""],markdownDescription:g.localize(135,null)})),accessibilitySupport:ve(new v),accessibilityPageSize:ve(new u(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(136,null)})),ariaLabel:ve(new b(4,"ariaLabel",g.localize(137,null))),autoClosingBrackets:ve(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(138,null),g.localize(139,null),""],description:g.localize(140,null)})),autoClosingDelete:ve(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(141,null),""],description:g.localize(142,null)})),autoClosingOvertype:ve(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(143,null),""],description:g.localize(144,null)})),autoClosingQuotes:ve(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(145,null),g.localize(146,null),""],description:g.localize(147,null)})),autoIndent:ve(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[g.localize(148,null),g.localize(149,null),g.localize(150,null),g.localize(151,null),g.localize(152,null)],description:g.localize(153,null)})),automaticLayout:ve(new d(10,"automaticLayout",!1)),autoSurround:ve(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(154,null),g.localize(155,null),g.localize(156,null),""],description:g.localize(157,null)})),stickyTabStops:ve(new d(103,"stickyTabStops",!1,{description:g.localize(158,null)})),codeLens:ve(new d(12,"codeLens",!0,{description:g.localize(159,null)})),codeLensFontFamily:ve(new b(13,"codeLensFontFamily","",{description:g.localize(160,null)})),codeLensFontSize:ve(new u(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(161,null)})),colorDecorators:ve(new d(15,"colorDecorators",!0,{description:g.localize(162,null)})),columnSelection:ve(new d(16,"columnSelection",!1,{description:g.localize(163,null)})),comments:ve(new t),contextmenu:ve(new d(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new d(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(164,null)})),cursorBlinking:ve(new a(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:g.localize(165,null)})),cursorSmoothCaretAnimation:ve(new d(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(166,null)})),cursorStyle:ve(new a(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:g.localize(167,null)})),cursorSurroundingLines:ve(new u(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(168,null)})),cursorSurroundingLinesStyle:ve(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(169,null),g.localize(170,null)],description:g.localize(171,null)})),cursorWidth:ve(new u(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(172,null)})),disableLayerHinting:ve(new d(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new d(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new d(28,"domReadOnly",!1)),dragAndDrop:ve(new d(29,"dragAndDrop",!0,{description:g.localize(173,null)})),emptySelectionClipboard:ve(new D),extraEditorClassName:ve(new b(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new f(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:g.localize(174,null)})),find:ve(new T),fixedOverflowWidgets:ve(new d(34,"fixedOverflowWidgets",!1)),folding:ve(new d(35,"folding",!0,{description:g.localize(175,null)})),foldingStrategy:ve(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(176,null),g.localize(177,null)],description:g.localize(178,null)})),foldingHighlight:ve(new d(37,"foldingHighlight",!0,{description:g.localize(179,null)})),foldingImportsByDefault:ve(new d(38,"foldingImportsByDefault",!1,{description:g.localize(180,null)})),unfoldOnClickAfterEndOfLine:ve(new d(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(181,null)})),fontFamily:ve(new b(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(182,null)})),fontInfo:ve(new A),fontLigatures2:ve(new o),fontSize:ve(new F),fontWeight:ve(new U),formatOnPaste:ve(new d(45,"formatOnPaste",!1,{description:g.localize(183,null)})),formatOnType:ve(new d(46,"formatOnType",!1,{description:g.localize(184,null)})),glyphMargin:ve(new d(47,"glyphMargin",!0,{description:g.localize(185,null)})),gotoLocation:ve(new j),hideCursorInOverviewRuler:ve(new d(49,"hideCursorInOverviewRuler",!1,{description:g.localize(186,null)})),highlightActiveIndentGuide:ve(new d(50,"highlightActiveIndentGuide",!0,{description:g.localize(187,null)})),hover:ve(new ae),inDiffEditor:ve(new d(52,"inDiffEditor",!1)),letterSpacing:ve(new f(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>f.clamp(z,-5,20),{description:g.localize(188,null)})),lightbulb:ve(new $),lineDecorationsWidth:ve(new I(56,"lineDecorationsWidth",10)),lineHeight:ve(new Z),lineNumbers:ve(new Ne),lineNumbersMinChars:ve(new u(59,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new d(60,"linkedEditing",!1,{description:g.localize(189,null)})),links:ve(new d(61,"links",!0,{description:g.localize(190,null)})),matchBrackets:ve(new P(62,"matchBrackets","always",["always","near","never"],{description:g.localize(191,null)})),minimap:ve(new V),mouseStyle:ve(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new f(65,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:g.localize(192,null)})),mouseWheelZoom:ve(new d(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(193,null)})),multiCursorMergeOverlapping:ve(new d(67,"multiCursorMergeOverlapping",!0,{description:g.localize(194,null)})),multiCursorModifier:ve(new a(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[g.localize(195,null),g.localize(196,null)],markdownDescription:g.localize(197,null)})),multiCursorPaste:ve(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),occurrencesHighlight:ve(new d(70,"occurrencesHighlight",!0,{description:g.localize(201,null)})),overviewRulerBorder:ve(new d(71,"overviewRulerBorder",!0,{description:g.localize(202,null)})),overviewRulerLanes:ve(new u(72,"overviewRulerLanes",3,0,3)),padding:ve(new me),parameterHints:ve(new H),peekWidgetDefaultFocus:ve(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(203,null),g.localize(204,null)],description:g.localize(205,null)})),definitionLinkOpensInPeek:ve(new d(76,"definitionLinkOpensInPeek",!1,{description:g.localize(206,null)})),quickSuggestions:ve(new de),quickSuggestionsDelay:ve(new u(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(207,null)})),readOnly:ve(new d(79,"readOnly",!1)),renameOnType:ve(new d(80,"renameOnType",!1,{description:g.localize(208,null),markdownDeprecationMessage:g.localize(209,null)})),renderControlCharacters:ve(new d(81,"renderControlCharacters",!1,{description:g.localize(210,null)})),renderIndentGuides:ve(new d(82,"renderIndentGuides",!0,{description:g.localize(211,null)})),renderFinalNewline:ve(new d(83,"renderFinalNewline",!0,{description:g.localize(212,null)})),renderLineHighlight:ve(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(213,null)],description:g.localize(214,null)})),renderLineHighlightOnlyWhenFocus:ve(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(215,null)})),renderValidationDecorations:ve(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(216,null),g.localize(217,null),g.localize(218,null),""],description:g.localize(219,null)})),revealHorizontalRightPadding:ve(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new d(89,"roundedSelection",!0,{description:g.localize(220,null)})),rulers:ve(new $e),scrollbar:ve(new qe),scrollBeyondLastColumn:ve(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(221,null)})),scrollBeyondLastLine:ve(new d(93,"scrollBeyondLastLine",!0,{description:g.localize(222,null)})),scrollPredominantAxis:ve(new d(94,"scrollPredominantAxis",!0,{description:g.localize(223,null)})),selectionClipboard:ve(new d(95,"selectionClipboard",!0,{description:g.localize(224,null),included:R.isLinux})),selectionHighlight:ve(new d(96,"selectionHighlight",!0,{description:g.localize(225,null)})),selectOnLineNumbers:ve(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:ve(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(226,null),g.localize(227,null)],description:g.localize(228,null)})),showUnused:ve(new d(99,"showUnused",!0,{description:g.localize(229,null)})),showDeprecated:ve(new d(124,"showDeprecated",!0,{description:g.localize(230,null)})),inlayHints:ve(new L),snippetSuggestions:ve(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(231,null),g.localize(232,null),g.localize(233,null),g.localize(234,null)],description:g.localize(235,null)})),smartSelect:ve(new K),smoothScrolling:ve(new d(102,"smoothScrolling",!1,{description:g.localize(236,null)})),stopRenderingLineAfter:ve(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new O),inlineSuggest:ve(new je),suggestFontSize:ve(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(237,null)})),suggestLineHeight:ve(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(238,null)})),suggestOnTriggerCharacters:ve(new d(108,"suggestOnTriggerCharacters",!0,{description:g.localize(239,null)})),suggestSelection:ve(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null)],description:g.localize(243,null)})),tabCompletion:ve(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabIndex:ve(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),useShadowDOM:ve(new d(113,"useShadowDOM",!0)),useTabStops:ve(new d(114,"useTabStops",!0,{description:g.localize(252,null)})),wordSeparators:ve(new b(115,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:g.localize(253,null)})),wordWrap:ve(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),wordWrapBreakAfterCharacters:ve(new b(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new b(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(259,null)})),wordWrapOverride1:ve(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new a(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wrappingStrategy:ve(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),editorClassName:ve(new p),pixelRatio:ve(new oe),tabFocusMode:ve(new X),layoutInfo:ve(new B),wrappingInfo:ve(new ie)}}),define(be[128],Ee([18,19]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[129],Ee([18,19]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[130],Ee([18,19]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(be[131],Ee([18,19]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(be[132],Ee([18,19]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(be[133],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[134],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[135],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(be[136],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[137],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[138],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[139],Ee([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[140],Ee([18,19]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(be[141],Ee([18,19]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(be[142],Ee([18,19]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[143],Ee([18,19]),function(te,e){return te.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[144],Ee([18,19]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[145],Ee([18,19]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[146],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var R;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var S;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[147],Ee([0,1,129]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function E(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=E;function k(l){if(!E(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=l.match(R);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=k;function y(l){if(!l)return null;let d=l.majorBase,u=l.majorMustEqual,f=l.minorBase,b=l.minorMustEqual,w=l.patchBase,P=l.patchMustEqual;l.hasCaret&&(d===0||(b=!1),P=!1);let a=0;if(l.preRelease){const h=S.exec(l.preRelease);if(h){const[,v,t,r]=h;a=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:d,majorMustEqual:u,minorBase:f,minorMustEqual:b,patchBase:w,patchMustEqual:P,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=y;function _(l,d,u){let f;typeof l=="string"?f=y(k(l)):f=l;let b;d instanceof Date?b=d.getTime():typeof d=="string"&&(b=new Date(d).getTime());let w;if(typeof u=="string"?w=y(k(u)):w=u,!f||!w)return!1;let P=f.majorBase,a=f.minorBase,h=f.patchBase,v=w.majorBase,t=w.minorBase,r=w.patchBase,s=w.notBefore,i=w.majorMustEqual,c=w.minorMustEqual,m=w.patchMustEqual;return w.isMinimum?P>v?!0:P<v?!1:a>t?!0:a<t||b&&b<s?!1:h>=r:(P===1&&v===0&&(!i||!c||!m)&&(v=1,t=0,r=0,i=!0,c=!1,m=!1),P<v?!1:P>v?!i:a<t?!1:a>t?!c:h<r?!1:h>r?!m:!(b&&b<s))}e.isValidVersion=_;function C(l,d,u,f){return u.isBuiltin||typeof u.main=="undefined"?!0:I(l,d,u.engines.vscode,f)}e.isValidExtensionVersion=C;function n(l,d,u){return l==="*"||I(d,u,l)}e.isEngineValid=n;function I(l,d,u,f=[]){let b=y(k(u));if(!b)return f.push(g.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return f.push(g.localize(1,null,u)),!1}else if(!b.majorMustEqual)return f.push(g.localize(2,null,u)),!1;return _(l,d,b)?!0:(f.push(g.localize(3,null,l,u)),!1)}}),define(be[91],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(S,E=[],k=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=g}),define(be[59],Ee([0,1,91]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function S(k,y,_){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],_)),R.push([k,y])}e.registerSingleton=S;function E(){return R}e.getSingletonServiceDescriptors=E}),define(be[148],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=g;class R{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let k of this._nodes.values())k.outgoing.size===0&&E.push(k);return E}insertEdge(E,k){const y=this.lookupOrInsertNode(E),_=this.lookupOrInsertNode(k);y.outgoing.set(this._hashFn(k),_),_.incoming.set(this._hashFn(E),y)}removeNode(E){const k=this._hashFn(E);this._nodes.delete(k);for(let y of this._nodes.values())y.outgoing.delete(k),y.incoming.delete(k)}lookupOrInsertNode(E){const k=this._hashFn(E);let y=this._nodes.get(k);return y||(y=new g(E),this._nodes.set(k,y)),y}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[k,y]of this._nodes)E.push(`${k}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,k]of this._nodes){const y=new Set([E]),_=this._findCycle(k,y);if(_)return _}}_findCycle(E,k){for(let[y,_]of E.outgoing){if(k.has(y))return[...k,y].join(" -> ");k.add(y);const C=this._findCycle(_,k);if(C)return C;k.delete(y)}}}e.Graph=R}),define(be[4],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function R(y,_,C,n){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:y,index:C,optional:n}):(_[g.DI_DEPENDENCIES]=[{id:y,index:C,optional:n}],_[g.DI_TARGET]=_)}function S(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const _=function(C,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(_,C,I,!1)};return _.toString=()=>y,g.serviceIds.set(y,_),_}e.createDecorator=S;function E(y){return y}e.refineServiceDecorator=E;function k(y){return function(_,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(y,_,n,!0)}}e.optional=k}),define(be[149],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function R(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[150],Ee([0,1,3,43,6,21,81,57,149]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(d,u){let f={selector:d,provider:u,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(f){let b=this._entries.indexOf(f);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const u=[];for(let f of this._entries)f._score>0&&u.push(f.provider);return u}ordered(d){const u=[];return this._orderedForEach(d,f=>u.push(f.provider)),u}orderedGroups(d){const u=[];let f,b;return this._orderedForEach(d,w=>{f&&b===w._score?f.push(w.provider):(b=w._score,f=[w.provider],u.push(f))}),u}_orderedForEach(d,u){if(!!d){this._updateScores(d);for(const f of this._entries)f._score>0&&u(f)}}_updateScores(d){let u={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let f of this._entries)if(f._score=(0,y.score)(f.selector,d.uri,d.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(d)),C(f.selector)&&f._score>0){for(let b of this._entries)b._score=0;f._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(d,u){return d._score<u._score?1:d._score>u._score?-1:d._time<u._time?1:d._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(d,u,f=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=u,this.max=f,this._cache=new E.LRUCache(50,.7)}_key(d){return d.id+(0,R.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const u=this._key(d),f=this._cache.get(u);return this._clamp(f?.value)}update(d,u){const f=this._key(d);let b=this._cache.get(f);return b||(b=new k.MovingAverage,this._cache.set(f,b)),b.update(u),this.get(d)}}e.LanguageFeatureRequestDelays=I}),define(be[60],Ee([0,1,2,31,150,123,35]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class _{constructor(A,F){this.language=A,this.id=F}}e.LanguageIdentifier=_;var C;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let F=this.getForeground(A),U="mtk"+F,j=this.getFontStyle(A);return j&1&&(U+=" mtki"),j&2&&(U+=" mtkb"),j&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(A,F){const U=this.getForeground(A),j=this.getFontStyle(A);let ae=`color: ${F[U]};`;return j&1&&(ae+="font-style: italic;"),j&2&&(ae+="font-weight: bold;"),j&4&&(ae+="text-decoration: underline;"),ae}}e.TokenMetadata=d;var u;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(A){const F=o[A];let U=F&&k.iconRegistry.get(F);return U||(console.info("No codicon found for CompletionItemKind "+A),U=k.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(A,F){let U=o[A];return typeof U=="undefined"&&!F&&(U=9),U}}();var f;(function(o){o[o.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&g.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function U(G){return A.get(G)}o.fromString=U;function j(G){return F.get(G)}o.toString=j;function ae(G,B){const $=F.get(G);let L=$&&k.iconRegistry.get("symbol-"+$);return L||(console.info("No codicon found for SymbolKind "+G),L=k.Codicon.symbolProperty),`${B?"inline":"block"} ${L.classNames}`}o.toCssClassName=ae})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(A){this.value=A}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var m;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var D;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var T;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,8,4,22]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=S.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",S.isMacintosh),k.set("isLinux",S.isLinux),k.set("isWindows",S.isWindows),k.set("isWeb",S.isWeb),k.set("isMacNative",S.isMacintosh&&!S.isWeb),k.set("isEdge",E.indexOf("Edg/")>=0),k.set("isFirefox",E.indexOf("Firefox")>=0),k.set("isChrome",E.indexOf("Chrome")>=0),k.set("isSafari",E.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var _;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(o){return d.create(o)}static equals(o,A){return u.create(o,A)}static notEquals(o,A){return w.create(o,A)}static regex(o,A){return r.create(o,A)}static in(o,A){return f.create(o,A)}static not(o){return P.create(o)}static and(...o){return i.create(o)}static or(...o){return c.create(o)}static greater(o,A){return a.create(o,A)}static less(o,A){return v.create(o,A)}static deserialize(o,A=!1){if(!!o)return this._deserializeOrExpression(o,A)}static _deserializeOrExpression(o,A){let F=o.split("||");return c.create(F.map(U=>this._deserializeAndExpression(U,A)))}static _deserializeAndExpression(o,A){let F=o.split("&&");return i.create(F.map(U=>this._deserializeOne(U,A)))}static _deserializeOne(o,A){if(o=o.trim(),o.indexOf("!=")>=0){let F=o.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],A))}if(o.indexOf("==")>=0){let F=o.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],A))}if(o.indexOf("=~")>=0){let F=o.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],A))}if(o.indexOf(" in ")>=0){let F=o.split(" in ");return f.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const F=o.split(">=");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const F=o.split(">");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const F=o.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const F=o.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(o)?P.create(o.substr(1).trim()):d.create(o)}static _deserializeValue(o,A){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let F=/^'([^']*)'$/.exec(o);return F?F[1].trim():o}static _deserializeRegexValue(o,A){if((0,g.isFalsyOrWhitespace)(o)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=o.indexOf("/"),U=o.lastIndexOf("/");if(F===U||F<0){if(A)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let j=o.slice(F+1,U),ae=o[U+1]==="i"?"i":"";try{return new RegExp(j,ae)}catch(G){if(A)throw new Error(`bad regexp-value '${o}', parse error: ${G}`);return console.warn(`bad regexp-value '${o}', parse error: ${G}`),null}}}e.ContextKeyExpr=C;function n(T,o){return T.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class d{constructor(o){this.key=o,this.type=2}static create(o){const A=k.get(o);return typeof A=="boolean"?A?l.INSTANCE:I.INSTANCE:new d(o)}cmp(o){return o.type!==this.type?this.type-o.type:p(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=d;class u{constructor(o,A){this.key=o,this.value=A,this.type=4}static create(o,A){if(typeof A=="boolean")return A?d.create(o):P.create(o);const F=k.get(o);return typeof F=="boolean"?A===(F?"true":"false")?l.INSTANCE:I.INSTANCE:new u(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class f{constructor(o,A){this.key=o,this.valueKey=A,this.type=10}static create(o,A){return new f(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const A=o.getValue(this.valueKey),F=o.getValue(this.key);return Array.isArray(A)?A.indexOf(F)>=0:typeof F=="string"&&typeof A=="object"&&A!==null?y.call(A,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=f;class b{constructor(o){this._actual=o,this.type=11}static create(o){return new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new b(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class w{constructor(o,A){this.key=o,this.value=A,this.type=5}static create(o,A){if(typeof A=="boolean")return A?P.create(o):d.create(o);const F=k.get(o);return typeof F=="boolean"?A===(F?"true":"false")?I.INSTANCE:l.INSTANCE:new w(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class P{constructor(o){this.key=o,this.type=3}static create(o){const A=k.get(o);return typeof A=="boolean"?A?I.INSTANCE:l.INSTANCE:new P(o)}cmp(o){return o.type!==this.type?this.type-o.type:p(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=P;class a{constructor(o,A){this.key=o,this.value=A,this.type=12}static create(o,A){return new a(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class h{constructor(o,A){this.key=o,this.value=A,this.type=13}static create(o,A){return new h(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class v{constructor(o,A){this.key=o,this.value=A,this.type=14}static create(o,A){return new v(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,A){this.key=o,this.value=A,this.type=15}static create(o,A){return new t(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,A){this.key=o,this.regexp=A,this.type=7}static create(o,A){return new r(o,A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const A=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return A<F?-1:A>F?1:0}equals(o){if(o.type===this.type){const A=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return this.key===o.key&&A===F}return!1}evaluate(o){let A=o.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const U=n(this.expr[A],o.expr[A]);if(U!==0)return U}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].evaluate(o))return!1;return!0}static _normalizeArr(o){const A=[];let F=!1;for(const U of o)if(!!U){if(U.type===1){F=!0;continue}if(U.type===0)return I.INSTANCE;if(U.type===6){A.push(...U.expr);continue}A.push(U)}if(A.length===0&&F)return l.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(n);A.length>1;){const U=A[A.length-1];if(U.type!==9)break;A.pop();const j=A.pop(),ae=c.create(U.expr.map(G=>i.create([G,j])));ae&&(A.push(ae),A.sort(n))}return A.length===1?A[0]:new i(A)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new i(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let A of this.expr)o.push(A.negate());return c.create(o)}}e.ContextKeyAndExpr=i;class c{constructor(o){this.expr=o,this.type=9}static create(o){const A=c._normalizeArr(o);if(A.length!==0)return A.length===1?A[0]:new c(A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const U=n(this.expr[A],o.expr[A]);if(U!==0)return U}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,F=this.expr.length;A<F;A++)if(this.expr[A].evaluate(o))return!0;return!1}static _normalizeArr(o){let A=[],F=!1;if(o){for(let U=0,j=o.length;U<j;U++){const ae=o[U];if(!!ae){if(ae.type===0){F=!0;continue}if(ae.type===1)return[l.INSTANCE];if(ae.type===9){A=A.concat(ae.expr);continue}A.push(ae)}}if(A.length===0&&F)return[I.INSTANCE];A.sort(n)}return A}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new c(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let F of this.expr)o.push(F.negate());const A=F=>F.type===9?F.expr:[F];for(;o.length>1;){const F=o.shift(),U=o.shift(),j=[];for(const ae of A(F))for(const G of A(U))j.push(C.and(ae,G));o.unshift(C.or(...j))}return o[0]}}e.ContextKeyOrExpr=c;class m extends d{constructor(o,A,F){super(o);this._defaultValue=A,typeof F=="object"?m._info.push({...F,key:o}):F!==!0&&m._info.push({key:o,description:F,type:A!=null?typeof A:void 0})}static all(){return m._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(o){return C.equals(this.key,o)}notEqualsTo(o){return C.notEquals(this.key,o)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(T,o){return T<o?-1:T>o?1:0}function D(T,o,A,F){return T<A?-1:T>A?1:o<F?-1:o>F?1:0}}),define(be[151],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,8,4]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=S;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class y{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let d=typeof I=="string"?I:I.value,u=typeof l=="string"?l:l.value;return g.equalsIgnoreCase(d,u)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=y;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[152],Ee([0,1,8,26]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(u,f){return u.uuid&&f.uuid?u.uuid===f.uuid:u.id===f.id?!0:(0,g.compareIgnoreCase)(u.id,f.id)===0}e.areSameExtensions=S;class E{constructor(f,b){this.version=b,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof E?S(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=E;function k(u,f){return`${u}.${f}`}e.getExtensionId=k;function y(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function _(u,f){return y(k(u,f))}e.getGalleryExtensionId=_;function C(u,f){const b=[],w=P=>{for(const a of b)if(a.some(h=>S(f(h),f(P))))return a;return null};for(const P of u){const a=w(P);a?a.push(P):b.push([P])}return b}e.groupByExtension=C;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(u){const f=new Set;for(const b of u)b.malicious&&f.add(b.id.id);return f}e.getMaliciousExtensionsSet=l;function d(u,f){const b=[],w=f.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const P=w.shift();if(P&&b.every(a=>!S(a.identifier,{id:P}))){const a=u.filter(h=>S(h.identifier,{id:P}));a.length===1&&(b.push(a[0]),w.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=d}),define(be[61],Ee([0,1,130,14,2,4,8,10,21]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function C(B){return B.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(B){B[B.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=d;function u(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=u;function f(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function b(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=b;var w;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor($,L){super($);this.code=L}}e.FileSystemProviderError=P;function a(B,$){const L=new P(B.toString(),$);return v(L,$),L}e.createFileSystemProviderError=a;function h(B){return B||a((0,g.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=h;function v(B,$){return B.name=$?`${$} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=v;function t(B){if(!B)return w.Unknown;if(B instanceof P)return B.code;const $=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!$)return w.Unknown;switch($[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(B){if(B instanceof D)return B.fileOperationResult;switch(t(B)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor($,L,Z){this.resource=$,this.operation=L,this.target=Z}isOperation($){return this.operation===$}}e.FileOperationEvent=i;var c;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class m{constructor($,L){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const Z of $)switch(Z.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>L)),this.added.set(Z.resource,Z);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>L)),this.updated.set(Z.resource,Z);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>L)),this.deleted.set(Z.resource,Z);break}}contains($,...L){return this.doContains($,{includeChildren:!1},...L)}affects($,...L){return this.doContains($,{includeChildren:!0},...L)}doContains($,L,...Z){if(!$)return!1;const V=Z.length>0;return!!((!V||Z.includes(1))&&(this.added?.get($)||L.includeChildren&&this.added?.findSuperstr($))||(!V||Z.includes(0))&&(this.updated?.get($)||L.includeChildren&&this.updated?.findSuperstr($))||(!V||Z.includes(2))&&(this.deleted?.findSubstr($)||L.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function p(B,$,L){return!B||!$||B===$||$.length>B.length?!1:($.charAt($.length-1)!==R.sep&&($+=R.sep),L?(0,k.startsWithIgnoreCase)(B,$):B.indexOf($)===0)}e.isParent=p;class D extends Error{constructor($,L,Z){super($);this.fileOperationResult=L,this.options=Z}}e.FileOperationError=D;class T extends D{constructor($,L,Z){super($,2,Z);this.stat=L}}e.NotModifiedSinceFileOperationError=T;var o;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=F;async function U(B,$){if(!$.canHandleResource(S.URI.from({scheme:B.scheme})))return new Promise(L=>{const Z=$.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===B.scheme&&V.added&&(Z.dispose(),L())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize($){return(0,y.isNumber)($)||($=0),$<j.KB?(0,g.localize)(1,null,$.toFixed(0)):$<j.MB?(0,g.localize)(2,null,($/j.KB).toFixed(2)):$<j.GB?(0,g.localize)(3,null,($/j.MB).toFixed(2)):$<j.TB?(0,g.localize)(4,null,($/j.GB).toFixed(2)):(0,g.localize)(5,null,($/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var ae;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function G(B){return{maxFileSize:B===0?300*j.MB:16*j.GB,maxHeapSize:B===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=G}),define(be[62],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...S){this._entries=new Map;for(let[E,k]of S)this.set(E,k)}set(S,E){const k=this._entries.get(S);return this._entries.set(S,E),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=g}),define(be[153],Ee([0,1,12,148,91,4,62,15]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new k.ServiceCollection,f=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=f,this._parent=b,this._services.set(E.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...f){let b=l.traceInvocation(u),w=!1;try{return u({get:(a,h)=>{if(w)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(a,b);if(!v&&h!==E.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return v}},...f)}finally{w=!0,b.stop()}}createInstance(u,...f){let b,w;return u instanceof S.SyncDescriptor?(b=l.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(f),b)):(b=l.traceCreation(u),w=this._createInstance(u,f,b)),b.stop(),w}_createInstance(u,f=[],b){let w=E._util.getServiceDependencies(u).sort((h,v)=>h.index-v.index),P=[];for(const h of w){let v=this._getOrCreateServiceInstance(h.id,b);if(!v&&this._strict&&!h.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${h.id}.`);P.push(v)}let a=w.length>0?w[0].index:f.length;if(f.length!==a){console.warn(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${f.length} static arguments`);let h=a-f.length;h>0?f=f.concat(new Array(h)):f=f.slice(0,a)}return new u(...[...f,...P])}_setServiceInstance(u,f){if(this._services.get(u)instanceof S.SyncDescriptor)this._services.set(u,f);else if(this._parent)this._parent._setServiceInstance(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let f=this._services.get(u);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):f}_getOrCreateServiceInstance(u,f){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,f.branch(u,!0)):(f.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,f,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,f,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,f,b){const w=new R.Graph(h=>h.id.toString());let P=0;const a=[{id:u,desc:f,_trace:b}];for(;a.length;){const h=a.pop();if(w.lookupOrInsertNode(h),P++>1e3)throw new C(w);for(let v of E._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:v.id,desc:t,_trace:h._trace.branch(v.id,!0)};w.insertEdge(h,r),a.push(r)}}}for(;;){const h=w.roots();if(h.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:v}of h){if(this._getServiceInstanceOrDescriptor(v.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,f,b=[],w,P){if(this._services.get(u)instanceof S.SyncDescriptor)return this._createServiceInstance(f,b,w,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,f,b,w,P);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(u,f=[],b,w){if(b){const P=new y.IdleValue(()=>this._createInstance(u,f,w));return new Proxy(Object.create(null),{get(a,h){if(h in a)return a[h];let v=P.value,t=v[h];return typeof t!="function"||(t=t.bind(v),a[h]=t),t},set(a,h,v){return P.value[h]=v,!0}})}else return this._createInstance(u,f,w)}}e.InstantiationService=n;var I;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(I||(I={}));class l{constructor(u,f){this.type=u,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return _?new l(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(u){return _?new l(0,u.name):l._None}branch(u,f){let b=new l(2,u.toString());return this._dep.push([u,f,b]),b}stop(){let u=Date.now()-this._start;l._totals+=u;let f=!1;function b(P,a){let h=[],v=new Array(P+1).join("	");for(const[t,r,s]of a._dep)if(r&&s){f=!0,h.push(`${v}CREATES -> ${t}`);let i=b(P+1,s);i&&h.push(i)}else h.push(`${v}uses -> ${t}`);return h.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(u>2||f)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(be[16],Ee([0,1,4,6,22,3,58]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function y(){return new Date().toISOString()}var _;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(_.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(_.Error,this.format(s))}else this.log(_.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...r){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}debug(t,...r){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}info(t,...r){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}warn(t,...r){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...r):console.warn(`[main ${y()}]`,t,...r))}error(t,...r){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}critical(t,...r){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class d extends C{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,k.toErrorMessage)(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class u extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class f extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=f;class b extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?_.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function P(v){if(v.verbose)return _.Trace;if(typeof v.logLevel=="string"){const t=a(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function a(v){switch(v){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=a;function h(v){switch(v){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=h}),define(be[92],Ee([0,1,4,131,36]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var k;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(u,f){return f-u}_.compare=C;const n=Object.create(null);n[_.Error]=(0,R.localize)(0,null),n[_.Warning]=(0,R.localize)(1,null),n[_.Info]=(0,R.localize)(2,null);function I(u){return n[u]||""}_.toString=I;function l(u){switch(u){case S.default.Error:return _.Error;case S.default.Warning:return _.Warning;case S.default.Info:return _.Info;case S.default.Ignore:return _.Hint}}_.fromSeverity=l;function d(u){switch(u){case _.Error:return S.default.Error;case _.Warning:return S.default.Warning;case _.Info:return S.default.Info;case _.Hint:return S.default.Ignore}}_.toSeverity=d}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(_){const C="";function n(l){return I(l,!0)}_.makeKey=n;function I(l,d){let u=[C];return l.source?u.push(l.source.replace("\xA6","\\\xA6")):u.push(C),l.code?typeof l.code=="string"?u.push(l.code.replace("\xA6","\\\xA6")):u.push(l.code.value.replace("\xA6","\\\xA6")):u.push(C),l.severity!==void 0&&l.severity!==null?u.push(k.toString(l.severity)):u.push(C),l.message&&d?u.push(l.message.replace("\xA6","\\\xA6")):u.push(C),l.startLineNumber!==void 0&&l.startLineNumber!==null?u.push(l.startLineNumber.toString()):u.push(C),l.startColumn!==void 0&&l.startColumn!==null?u.push(l.startColumn.toString()):u.push(C),l.endLineNumber!==void 0&&l.endLineNumber!==null?u.push(l.endLineNumber.toString()):u.push(C),l.endColumn!==void 0&&l.endColumn!==null?u.push(l.endColumn.toString()):u.push(C),u.push(C),u.join("\xA6")}_.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(be[154],Ee([0,1,36,4,3]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=(0,R.createDecorator)("notificationService");var E;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new _,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=y;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(be[155],Ee([0,1,6,8,2,4]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,E.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function k(y,_){return S.URI.isUri(y)?(0,R.equalsIgnoreCase)(y.scheme,_):(0,R.startsWithIgnoreCase)(y,_+":")}e.matchesScheme=k});var ze=this&&this.__decorate||function(te,e,g,R){var S=arguments.length,E=S<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,g):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(te,e,g,R);else for(var y=te.length-1;y>=0;y--)(k=te[y])&&(E=(S<3?k(E):S>3?k(e,g,E):k(e,g))||E);return S>3&&E&&Object.defineProperty(e,g,E),E},Ve=this&&this.__param||function(te,e){return function(g,R){e(g,R,te)}};define(be[156],Ee([0,1,4,20,6,15]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,g.createDecorator)("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let _=class extends S.Disposable{constructor(I,l){super();this.deferred=new E.DeferredPromise,l.withProgress(I,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=ze([Ve(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,d=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:d.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,g.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,10,41]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(k,y){R.ok(g.isString(k)),R.ok(g.isObject(y)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,y)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(be[93],Ee([0,1,28,3]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class E{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[S(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new E;g.Registry.add(e.Extensions.JSONContribution,k)}),define(be[63],Ee([0,1,128,3,28,10,93]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=S.Registry.as(k.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,a=!0){this.registerConfigurations([P],a)}registerConfigurations(P,a=!0){const h=[];P.forEach(v=>{h.push(...this.validateAndRegisterProperties(v,a,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(P){const a=[],h=v=>{if(v.properties)for(const t in v.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>h(t))};for(const v of P){h(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(P){const a=[],h=[];for(const v of P)for(const t in v)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(l(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(P){const a=[];for(const h of P)for(const v in h)if(a.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const a of P)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,a=!0,h,v=3){v=E.isUndefinedOrNull(P.scope)?v:P.scope;let t=[],r=P.properties;if(r)for(let i in r){if(a&&f(i)){delete r[i];continue}const c=r[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=E.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=E.isUndefinedOrNull(c.restricted)?!!h?.restrictedConfigurations?.includes(i):c.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=P.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,a,h,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const a=h=>{let v=h.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=h.allOf;t&&t.forEach(a)};a(P)}updateSchema(P,a){switch(e.allSettings.properties[P]=a,a.scope){case 1:e.applicationSettings.properties[P]=a;break;case 2:e.machineSettings.properties[P]=a;break;case 6:e.machineOverridableSettings.properties[P]=a;break;case 3:e.windowSettings.properties[P]=a;break;case 4:e.resourceSettings.properties[P]=a;break;case 5:e.resourceSettings.properties[P]=a,this.resourceLanguageSettingsSchema.properties[P]=a;break}}removeFromSchema(P,a){switch(delete e.allSettings.properties[P],a.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const a=`[${P}]`,h={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,h),e.allSettings.properties[a]=h,e.applicationSettings.properties[a]=h,e.machineSettings.properties[a]=h,e.machineOverridableSettings.properties[a]=h,e.windowSettings.properties[a]=h,e.resourceSettings.properties[a]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,a){let h=this.defaultValues[P];E.isUndefined(h)&&(h=a.default),E.isUndefined(h)&&(h=d(a.type)),a.default=h}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function d(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const u=new n;S.Registry.add(e.Extensions.Configuration,u);function f(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?g.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?g.localize(6,null,w):null:g.localize(4,null)}e.validateProperty=f;function b(){const w=[],P=u.getConfigurationProperties();for(const a of Object.keys(P))w.push([a,P[a].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(be[94],Ee([0,1,23,10,2,28,4,63]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=_;var C;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(r,s){const i=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],c=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],m=[];if(s&&r){for(const A of r.keys)if(s.keys.indexOf(A)!==-1){const F=w(r.contents,A),U=w(s.contents,A);g.equals(F,U)||m.push(A)}}const p=[],D=A=>{const F={};for(const U of A)for(const j of U.identifiers)F[v(j)]=U;return F},T=s?D(s.overrides):{},o=r?D(r.overrides):{};if(Object.keys(T).length)for(const A of i){const F=T[A];F&&p.push([(0,y.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(o).length)for(const A of c){const F=o[A];F&&p.push([(0,y.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(T).length&&Object.keys(o).length)for(const A of m){const F=o[A],U=T[A];if(F&&U){const j=I({contents:F.contents,keys:F.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});p.push([(0,y.overrideIdentifierFromKey)(A),[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:c,updated:m,overrides:p}}e.compare=I;function l(r,s){const i=[];for(const c of Object.keys(r))if(y.OVERRIDE_PROPERTY_PATTERN.test(c)){const m={};for(const p in r[c])m[p]=r[c][p];i.push({identifiers:[(0,y.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(m),contents:d(m,s)})}return i}e.toOverrides=l;function d(r,s){const i=Object.create(null);for(let c in r)u(i,c,r[c],s);return i}e.toValuesTree=d;function u(r,s,i,c){const m=s.split("."),p=m.pop();let D=r;for(let T=0;T<m.length;T++){let o=m[T],A=D[o];switch(typeof A){case"undefined":A=D[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${s} as ${m.slice(0,T+1).join(".")} is ${JSON.stringify(A)}`);return}D=A}if(typeof D=="object"&&D!==null)try{D[p]=i}catch(T){c(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(D)}`)}else c(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=u;function f(r,s){const i=s.split(".");b(r,i)}e.removeFromValueTree=f;function b(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const c=r[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,s),Object.keys(c).length===0&&delete r[i])}}function w(r,s,i){function c(D,T){let o=D;for(const A of T){if(typeof o!="object"||o===null)return;o=o[A]}return o}const m=s.split("."),p=c(r,m);return typeof p=="undefined"?i:p}e.getConfigurationValue=w;function P(r,s,i){Object.keys(s).forEach(c=>{c!=="__proto__"&&(c in r?R.isObject(r[c])&&R.isObject(s[c])?P(r[c],s[c],i):i&&(r[c]=s[c]):r[c]=s[c])})}e.merge=P;function a(){const r=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function h(){const r=Object.create(null),s=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let i in s){let c=s[i].default;u(r,i,c,m=>console.error(`Conflict in default settings: ${m}`))}return r}e.getDefaultValues=h;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,s,i){const c=r.inspect(s),m=r.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:c.defaultValue}e.getMigratedSettingValue=t}),define(be[157],Ee([0,1,111,21,17,10,23,2,63,94,28,6,3]),function(te,e,g,R,S,E,k,y,_,C,n,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,C.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of S.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[i],m=r[i];m&&(typeof c=="object"&&typeof m=="object"?(c=k.deepClone(c),this.mergeContents(c,m)):c=m),s[i]=c}return new d(s,this.keys,this.overrides)}merge(...t){const r=k.deepClone(this.contents),s=k.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const m of c.overrides){const[p]=s.filter(D=>S.equals(D.identifiers,m.identifiers));p?this.mergeContents(p.contents,m.contents):s.push(k.deepClone(m))}for(const m of c.keys)i.indexOf(m)===-1&&i.push(m)}return new d(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&E.isObject(t[s])&&E.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=k.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,C.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class u extends d{constructor(){const t=(0,C.getDefaultValues)(),r=(0,C.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,_.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,C.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,s)}}e.DefaultConfigurationModel=u;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!E.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:c,restricted:m}=this.doParseRaw(t,r);this._configurationModel=new d(s,i,c),this._restrictedConfigurations=m||[]}doParseContent(t){let r={},s=null,i=[],c=[],m=[];function p(T){Array.isArray(i)?i.push(T):s!==null&&(i[s]=T)}let D={onObjectBegin:()=>{let T={};p(T),c.push(i),i=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let T=[];p(T),c.push(i),i=T,s=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:p,onError:(T,o,A)=>{m.push({error:T,offset:o,length:A})}};if(t)try{g.visit(t,D),r=i[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const c=(0,C.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(t),p=(0,C.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:m,overrides:p,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},m=[];for(let p in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const D=this.filter(t[p],r,!1,i);c[p]=D.raw,m.push(...D.restricted)}else{const D=r[p],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(p),(T===void 0||i.scopes===void 0||i.scopes.includes(T))&&(i.skipRestricted&&D?.restricted||(c[p]=t[p]))}return{raw:c,restricted:m}}}e.ConfigurationModelParser=f;class b extends I.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(t,r,s=new d,i=new d,c=new R.ResourceMap,m=new d,p=new R.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=m,this._memoryConfigurationByResource=p,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new d,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),c=this.getFolderConfigurationModelForResource(r.resource,s),m=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,p=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,U=r.overrideIdentifier?m.override(r.overrideIdentifier).getValue(t):m.getValue(t),j=i.getValue(t),ae=S.distinct(S.flatten(i.overrides.map(G=>G.identifiers))).filter(G=>i.getOverrideValue(t,G)!==void 0);return{defaultValue:p,userValue:D,userLocalValue:T,userRemoteValue:o,workspaceValue:A,workspaceFolderValue:F,memoryValue:U,value:j,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:m.getValue(t),override:r.overrideIdentifier?m.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>_.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,_.overrideIdentifierFromKey)(i),m=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=t.getKeysForOverrideIdentifier(c),D=[...p.filter(T=>m.indexOf(T)===-1),...m.filter(T=>p.indexOf(T)===-1),...m.filter(T=>!k.equals(this._defaultConfiguration.override(c).getValue(T),t.override(c).getValue(T)))];return[c,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,C.compare)(this.localUserConfiguration,t),m=[...r,...s,...i];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,C.compare)(this.remoteUserConfiguration,t);let m=[...r,...s,...i];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,C.compare)(this.workspaceConfiguration,t);let m=[...r,...s,...i];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:c,removed:m,overrides:p}=(0,C.compare)(s,r);let D=[...i,...c,...m];return(D.length||!s)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:p}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:c,overrides:m}=(0,C.compare)(r,void 0);return{keys:[...s,...i,...c],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const c=this._memoryConfigurationByResource.get(t);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((m,p)=>(m.set(y.URI.revive(p[0]),this.parseConfigurationModel(p[1])),m),new R.ResourceMap);return new w(r,s,new d,i,c,new d,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function P(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,m])=>{const p=(0,R.getOrSet)(r,c,new Set);m.forEach(D=>p.add(D))});const s=[];return r.forEach((i,c)=>s.push([c,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=P;class a{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(p=>c.add(p)),t.overrides.forEach(([,p])=>p.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const m=new d;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!k.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,C.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=a;class h extends a{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=h}),define(be[95],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var R;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(k,y=R.Unknown,_){super(k);this._message=k,this._code=y,this._detail=_,this.isHandled=y===R.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===R.NoResolverFound}static isHandled(k){return k instanceof S&&k.isHandled}}e.RemoteAuthorityResolverError=S}),define(be[96],Ee([0,1,11]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===g.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function S(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=S;function E(C){return C.scheme!==g.Schemas.file&&C.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=E;function k(C){if(C.folders.length)return C.folders.every(n=>E(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&E(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function y(C){return k(C)?.scheme}e.getVirtualWorkspaceScheme=y;function _(C){return k(C)!==void 0}e.isVirtualWorkspace=_}),define(be[158],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,E,k=5){let y;return y=E(_=>{const C=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(S),k);n={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),y.dispose()}},this._terminalBufferMap.set(S,n)}),y}stopBuffering(S){const E=this._terminalBufferMap.get(S);E&&E.dispose()}flushBuffer(S){const E=this._terminalBufferMap.get(S);E&&(this._terminalBufferMap.delete(S),this._callback(S,E.data.join("")))}}e.TerminalDataBufferer=g}),define(be[159],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(be[64],Ee([0,1,4,6,28,3,159,35]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var _;(function(b){function w(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=w})(_=e.ThemeColor||(e.ThemeColor={}));function C(b){return{id:b}}e.themeColorFromId=C;var n;(function(b){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||_.isThemeColor(r.color))}b.isThemeIcon=w;const P=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const s=P.exec(r);if(!s)return;let[,i]=s;return{id:i}}b.fromString=a;function h(r,s){let i=r.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),s&&(i=`${i}~${s}`),{id:i}}b.modify=h;function v(r,s){return r.id===s.id&&r.color?.id===s.color?.id}b.isEqual=v;function t(r,s){return{id:r.id,color:s?C(s):void 0}}b.asThemeIcon=t,b.asClassNameArray=y.CSSIcon.asClassNameArray,b.asClassName=y.CSSIcon.asClassName,b.asCSSSelector=y.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function I(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new E.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const P=this.themingParticipants.indexOf(w);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new l;S.Registry.add(e.Extensions.ThemingContribution,d);function u(b){return d.onColorThemeChange(b)}e.registerThemingParticipant=u;class f extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,P){let a=this.theme.getColor(w);return a&&P&&(a=P(a,this.theme)),a?a.toString():null}}e.Themable=f}),define(be[160],Ee([0,1,28,64,3,132,93,15,35]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${_.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,P,a,h){const v=this.iconsById[w];if(v){if(a&&!v.description){v.description=a,this.iconSchema.properties[w].markdownDescription=`${a} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=a),this._onDidChange.fire()}return v}let t={id:w,description:a,defaults:P,deprecationMessage:h};this.iconsById[w]=t;let r={$ref:"#/definitions/icons"};return h&&(r.deprecationMessage=h),a&&(r.markdownDescription=`${a}: $(${w})`),this.iconSchema.properties[w]=r,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const P=this.iconReferenceSchema.enum.indexOf(w);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,P){const a=this.iconFontsById[w];if(a)return a;let h={id:w,definition:P};return this.iconFontsById[w]=h,this._onDidChange.fire(),h}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),P=v=>{for(;R.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of h.filter(t=>!!t.description).sort(w))a.push(`|<i class="${P(v)}"></i>|${v.id}|${R.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const v of h.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(w))a.push(`|<i class="${P(v)}"></i>|${v.id}|`);return a.join(`
`)}}const n=new C;g.Registry.add(e.Extensions.IconContribution,n);function I(b,w,P,a){return n.registerIcon(b,w,P,a)}e.registerIcon=I;function l(){return n}e.getIconRegistry=l;function d(){for(const b of _.iconRegistry.all)n.registerIcon(b.id,b.definition,b.description);_.iconRegistry.onDidRegister(b=>n.registerIcon(b.id,b.definition,b.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let u=g.Registry.as(k.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const f=new y.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=I("widget-close",_.Codicon.close,(0,E.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",_.Codicon.arrowUp,(0,E.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",_.Codicon.arrowDown,(0,E.localize)(4,null)),e.syncing=R.ThemeIcon.modify(_.Codicon.sync,"spin")}),define(be[46],Ee([0,1,2,25,4,21]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var k;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function y(l){const d=l;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=y;function _(l){const d=l;return!!(d&&typeof d=="object"&&g.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(d,u,f,b){this._id=d,this._configuration=f,this._ignorePathCasing=b,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(d,u){this.raw=u,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,R.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(l){return new n({uri:l,index:0,name:(0,R.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(be[65],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const E=this._idPool++;return this._data.set(E,S),this.logDebugInfo(),E}get(S,E){return this._data.has(S)?this._data.get(S)[E]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(be[66],Ee([0,1,2,3,4]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(be[47],Ee([0,1,11,4]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,y){y===null?this._providerInfo.delete(k):this._providerInfo.set(k,y)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(be[161],Ee([0,1,2]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class R{constructor(E,k,y){this._extHostNotebooks=k,this._textDocumentsAndEditors=y}$willAddInteractiveDocument(E,k,y,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:y,uri:E,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(_))?.apiNotebook}]})}$willRemoveInteractiveDocument(E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[E]})}}e.ExtHostInteractive=R}),define(be[162],Ee([0,1,15]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(k,y,_){this._deferredPromises=new Map,this._id=k,this._shared=y,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const I of C.values())I.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,y){let _=this._value[k];return typeof _=="undefined"&&(_=y),_}update(k,y){this._value[k]=y;let _=this._deferredPromises.get(k);if(_!==void 0)return _.p;const C=new g.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class S extends R{constructor(k,y){super(k.identifier.value,!0,y);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=S}),define(be[163],Ee([0,1,3,2,16]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let E=class{constructor(y,_){this._logService=y,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,_,C){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(y,_){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y)).acceptDirty(_)}$acceptModelSaved(y){const _=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(y,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,_);const C=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};E=ze([Ve(0,S.ILogService)],E),e.ExtHostNotebookDocuments=E}),define(be[13],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class R{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[164],Ee([0,1,26,3]),function(te,e,g,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(y,_){S.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),it(this,S,_,"f"),Be(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(y){return Be(this,S,"f").get(this._id,y)}store(y,_){return Be(this,S,"f").store(this._id,y,_)}delete(y){return Be(this,S,"f").delete(this._id,y)}}e.ExtensionSecrets=E,S=new WeakMap}),define(be[97],Ee([0,1,4,3]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(be[67],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,S=(P,a)=>{const h={controllerId:a};return R.set(P,h),h};e.createPrivateApiFor=S;const E=P=>R.get(P);e.getPrivateApiFor=E;const k=(P,a,h,v)=>{let t=h;return{enumerable:!0,configurable:!1,get(){return t},set(r){v(t,r)||(t=r,P.listener?.({op:3,key:a,value:r}))}}},y=(P,a)=>P===a,_={range:(P,a)=>P===a?!0:!P||!a?!1:P.isEqual(a),label:y,description:y,busy:y,error:y,canResolveChildren:y},C=Object.keys(_),n=(P,a)=>({range:k(P,"range",void 0,_.range),label:k(P,"label",a,_.label),description:k(P,"description",void 0,_.description),canResolveChildren:k(P,"canResolveChildren",!1,_.canResolveChildren),busy:k(P,"busy",!1,_.busy),error:k(P,"error",void 0,_.error)}),I=(P,a)=>{const h=new Map;for(const v of C)_[v](P[v],a[v])||h.set(v,a[v]);return h};e.diffTestItems=I;class l extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=l;class d extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class u extends Error{constructor(a,h,v){super(`TestItem with ID "${a}" is from controller "${h}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=u;const f=P=>{const a=(0,e.getPrivateApiFor)(P);let h=new Map;return{get size(){return h.size},forEach(v,t){for(const r of h.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(h.keys()),s={op:4,ops:[]};for(const i of v){if(!(i instanceof b))throw new d(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==a.controllerId)throw new u(i.id,c,a.controllerId);if(t.has(i.id))throw new l(i.id);t.set(i.id,i),r.delete(i.id),s.ops.push({op:0,item:i})}for(const i of r.keys())s.ops.push({op:1,id:i});a.listener?.(s),h=t},add(v){if(!(v instanceof b))throw new d(v.id);h.set(v.id,v),a.listener?.({op:0,item:v})},delete(v){h.delete(v)&&a.listener?.({op:1,id:v})},get(v){return h.get(v)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class b{constructor(a,h,v,t){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof w?void 0:r.parent}},children:{value:f(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=b;class w extends b{constructor(a,h){super(a,a,h,void 0)}}e.TestItemRootImpl=w}),define(be[68],Ee([0,1,4,3,13]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(y){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}y.fromApiTunnel=_;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}y.fromServiceTunnel=C})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let k=class{constructor(_){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,n,I,l){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=ze([Ve(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[7],Ee([0,1,17,12,83,21,85,10,2,37,61,95]),function(te,e,g,R,S,E,k,y,_,C,n,I){"use strict";var l,d,u,f,b,w,P,a,h,v,t,r,s,i,c,m,p,D,T,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let F=b=class{constructor(M){l.set(this,void 0),it(this,l,M,"f")}static from(...M){let ne=M;return new b(function(){if(ne){for(const De of ne)De&&typeof De.dispose=="function"&&De.dispose();ne=void 0}})}dispose(){typeof Be(this,l,"f")=="function"&&(Be(this,l,"f").call(this),it(this,l,void 0,"f"))}};l=new WeakMap,F=b=ze([A],F),e.Disposable=F;let U=w=class{constructor(M,ne){if(M<0)throw(0,R.illegalArgument)("line must be non-negative");if(ne<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let De=1;De<M.length;De++){const Qe=M[De];Qe.isBefore(ne)&&(ne=Qe)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let De=1;De<M.length;De++){const Qe=M[De];Qe.isAfter(ne)&&(ne=Qe)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof w)return!0;let{line:ne,character:De}=M;return typeof ne=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,R.illegalArgument)();let De;return typeof M=="undefined"?De=0:typeof M=="number"?De=M:(De=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),De===0&&ne===0?this:new w(this.line+De,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,R.illegalArgument)();let De;return typeof M=="undefined"?De=this.line:typeof M=="number"?De=M:(De=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),De===this.line&&ne===this.character?this:new w(De,ne)}toJSON(){return{line:this.line,character:this.character}}};U=w=ze([A],U),e.Position=U;let j=P=class{constructor(M,ne,De,Qe){let nt,rt;if(typeof M=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Qe=="number"?(nt=new U(M,ne),rt=new U(De,Qe)):M instanceof U&&ne instanceof U&&(nt=M,rt=ne),!nt||!rt)throw new Error("Invalid arguments");nt.isBefore(rt)?(this._start=nt,this._end=rt):(this._start=rt,this._end=nt)}static isRange(M){return M instanceof P?!0:M?U.isPosition(M.start)&&U.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof P?this.contains(M._start)&&this.contains(M._end):M instanceof U?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=U.Max(M.start,this._start),De=U.Min(M.end,this._end);if(!ne.isAfter(De))return new P(ne,De)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=U.Min(M.start,this._start),De=U.Max(M.end,this.end);return new P(ne,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,R.illegalArgument)();let De;return M?U.isPosition(M)?De=M:(De=M.start||this.start,ne=M.end||this.end):De=this.start,De.isEqual(this._start)&&ne.isEqual(this.end)?this:new P(De,ne)}toJSON(){return[this.start,this.end]}};j=P=ze([A],j),e.Range=j;let ae=a=class extends j{constructor(M,ne,De,Qe){let nt,rt;if(typeof M=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Qe=="number"?(nt=new U(M,ne),rt=new U(De,Qe)):M instanceof U&&ne instanceof U&&(nt=M,rt=ne),!nt||!rt)throw new Error("Invalid arguments");super(nt,rt);this._anchor=nt,this._active=rt}static isSelection(M){return M instanceof a?!0:M?j.isRange(M)&&U.isPosition(M.anchor)&&U.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ae=a=ze([A],ae),e.Selection=ae;class G{constructor(M,ne,De){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,R.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,R.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ne),this.connectionToken=De}}e.ResolvedAuthority=G;class B extends Error{constructor(M,ne=I.RemoteAuthorityResolverErrorCode.Unknown,De){super(M);this._message=M,this._code=ne,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(M,ne){return new B(M,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new B(M,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var $;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var L;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=h=class{constructor(M,ne){this._range=M,this._newText=ne}static isTextEdit(M){return M instanceof h?!0:M?j.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new h(M,ne)}static insert(M,ne){return h.replace(new j(M,M),ne)}static delete(M){return h.replace(M,"")}static setEndOfLine(M){const ne=new h(new j(new U(0,0),new U(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!j.isRange(M))throw(0,R.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,R.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,R.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Z=h=ze([A],Z),e.TextEdit=Z;var V;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,De,Qe){this._edits.push({_type:1,from:M,to:ne,options:De,metadata:Qe})}createFile(M,ne,De){this._edits.push({_type:1,from:void 0,to:M,options:ne,metadata:De})}deleteFile(M,ne,De){this._edits.push({_type:1,from:M,to:void 0,options:ne,metadata:De})}replaceNotebookMetadata(M,ne,De){this._edits.push({_type:3,metadata:De,uri:M,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(M,ne,De,Qe,nt){let rt,lt,St=[],At;if(Bt.isNotebookRange(ne)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(Qe)?(rt=ne.start,lt=ne.end,St=De,At=Qe):typeof ne=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(Qe)&&(rt=ne,lt=De,St=Qe,At=nt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||St.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:lt-rt,cells:St,metadata:At})}replaceNotebookCellMetadata(M,ne,De,Qe){this._edits.push({_type:3,metadata:Qe,uri:M,edit:{editType:8,index:ne,metadata:De}})}replace(M,ne,De,Qe){this._edits.push({_type:2,uri:M,edit:new Z(ne,De),metadata:Qe})}insert(M,ne,De,Qe){this.replace(M,new j(ne,ne),De,Qe)}delete(M,ne,De){this.replace(M,ne,"",De)}has(M){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const De of ne)De&&this._edits.push({_type:2,uri:M,edit:De});else{for(let De=0;De<this._edits.length;De++){const Qe=this._edits[De];Qe._type===2&&Qe.uri.toString()===M.toString()&&(this._edits[De]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(let De of this._edits)De._type===2&&De.uri.toString()===M.toString()&&ne.push(De.edit);return ne}entries(){const M=new E.ResourceMap;for(let ne of this._edits)if(ne._type===2){let De=M.get(ne.uri);De||(De=[ne.uri,[]],M.set(ne.uri,De)),De[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=ze([A],Y),e.WorkspaceEdit=Y;let me=v=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=v._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const De=new v;De._tabstop=this._tabstop,M(De),this._tabstop=De._tabstop,M=De.value}else M=v._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const De=M.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const De=new v;De._tabstop=this._tabstop,ne(De),this._tabstop=De._tabstop,ne=De.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};me=v=ze([A],me),e.SnippetString=me;var H;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=t=class{constructor(M,ne){if(this.uri=M,ne)if(ne instanceof j)this.range=ne;else if(ne instanceof U)this.range=new j(ne,ne);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?j.isRange(M.range)&&_.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=t=ze([A],de),e.Location=de;let Ce=class{constructor(M,ne){this.location=M,this.message=ne}static is(M){return M?typeof M.message=="string"&&M.location&&j.isRange(M.location.range)&&_.URI.isUri(M.location.uri):!1}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};Ce=ze([A],Ce),e.DiagnosticRelatedInformation=Ce;let Ne=class{constructor(M,ne,De=oe.Error){if(!j.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=De}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,g.equals)(M.tags,ne.tags)&&(0,g.equals)(M.relatedInformation,ne.relatedInformation,Ce.isEqual)}};Ne=ze([A],Ne),e.Diagnostic=Ne;let Me=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ne}};Me=ze([A],Me),e.Hover=Me;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Xe=class{constructor(M,ne=$e.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Xe=ze([A],Xe),e.DocumentHighlight=Xe;var qe;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let O=r=class{constructor(M,ne,De,Qe,nt){this.name=M,this.kind=ne,this.containerName=nt,typeof De=="string"&&(this.containerName=De),Qe instanceof de?this.location=Qe:De instanceof j&&(this.location=new de(Qe,De)),r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};O=r=ze([A],O),e.SymbolInformation=O;let K=s=class{constructor(M,ne,De,Qe,nt){this.name=M,this.detail=ne,this.kind=De,this.range=Qe,this.selectionRange=nt,this.children=[],s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(s.validate)}};K=s=ze([A],K),e.DocumentSymbol=K;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(M,ne){this.title=M,this.kind=ne}};re=ze([A],re),e.CodeAction=re;let q=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([A],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ie=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ie=ze([A],ie),e.SelectionRange=ie;class ge{constructor(M,ne,De,Qe,nt,rt){this.kind=M,this.name=ne,this.detail=De,this.uri=Qe,this.range=nt,this.selectionRange=rt}}e.CallHierarchyItem=ge;class Re{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=Re;class We{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=We;var ve;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};Ye=ze([A],Ye),e.CodeLens=Ye;let z=c=class{constructor(M,ne=!1){d.set(this,void 0),it(this,d,new S.MarkdownString(M,{supportThemeIcons:ne}),"f")}static isMarkdownString(M){return M instanceof c?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Be(this,d,"f").value}set value(M){Be(this,d,"f").value=M}get isTrusted(){return Be(this,d,"f").isTrusted}set isTrusted(M){Be(this,d,"f").isTrusted=M}get supportThemeIcons(){return Be(this,d,"f").supportThemeIcons}set supportThemeIcons(M){Be(this,d,"f").supportThemeIcons=M}appendText(M){return Be(this,d,"f").appendText(M),this}appendMarkdown(M){return Be(this,d,"f").appendMarkdown(M),this}appendCodeblock(M,ne){return Be(this,d,"f").appendCodeblock(ne??"",M),this}};d=new WeakMap,z=c=ze([A],z),e.MarkdownString=z;let ee=class{constructor(M,ne){this.label=M,this.documentation=ne}};ee=ze([A],ee),e.ParameterInformation=ee;let ce=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};ce=ze([A],ce),e.SignatureInformation=ce;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=ze([A],Ue),e.SignatureHelp=Ue;var xe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Se=class{constructor(M,ne,De){this.text=M,this.position=ne,this.kind=De}};Se=ze([A],Se),e.InlayHint=Se;var ye;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Pe=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(N){N[N.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let le=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};le=ze([A],le),e.CompletionItem=le;let he=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};he=ze([A],he),e.CompletionList=he;let pe=class{constructor(M,ne,De){this.text=M,this.range=ne,this.command=De}};pe=ze([A],pe),e.InlineSuggestion=pe;let x=class{constructor(M){this.items=M}};x=ze([A],x),e.InlineSuggestions=x;var fe;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(fe=e.ViewColumn||(e.ViewColumn={}));var we;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(we=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Oe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var He;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(He=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ke;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Ke=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Je;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(ne){switch(ne){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(M,ne){if(ne&&!_.URI.isUri(ne))throw(0,R.illegalArgument)("target");if(!j.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.target=ne}};ut=ze([A],ut),e.DocumentLink=ut;let mt=class{constructor(M,ne,De,Qe){this.red=M,this.green=ne,this.blue=De,this.alpha=Qe}};mt=ze([A],mt),e.Color=mt;let bt=class{constructor(M,ne){if(ne&&!(ne instanceof mt))throw(0,R.illegalArgument)("color");if(!j.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.color=ne}};bt=ze([A],bt),e.ColorInformation=bt;let ot=class{constructor(M){if(!M||typeof M!="string")throw(0,R.illegalArgument)("label");this.label=M}};ot=ze([A],ot),e.ColorPresentation=ot;var at;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var _e;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(_e=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ke{constructor(M,ne,De){if(this.startIndex=M,this.length=ne,this.tooltip=De,typeof M!="number"||M<0)throw(0,R.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,R.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=ke;class Q{constructor(M){this.options=M,typeof M!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=Q;var W;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(W=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=m=class{constructor(M,ne){if(typeof M!="string"||typeof ne!="string")throw(0,R.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};Te.Clean=new m("clean","Clean"),Te.Build=new m("build","Build"),Te.Rebuild=new m("rebuild","Rebuild"),Te.Test=new m("test","Test"),Te=m=ze([A],Te),e.TaskGroup=Te;function tt(N){let M="";for(let ne=0;ne<N.length;ne++)M+=N[ne].replace(/,/g,",,")+",";return M}let Ge=class{constructor(M,ne,De){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=De):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)M.push(ne);return tt(M)}};Ge=ze([A],Ge),e.ProcessExecution=Ge;let ct=class{constructor(M,ne,De){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M,this._args=ne,this._options=De}else{if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return tt(M)}};ct=ze([A],ct),e.ShellExecution=ct;var yt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Dt;let ft=p=class{constructor(M,ne,De,Qe,nt,rt){this.__deprecated=!1,this._definition=this.definition=M;let lt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=De,this.execution=Qe,lt=nt,this.__deprecated=!0):ne===kt.Global||ne===kt.Workspace?(this.target=ne,this._name=this.name=De,this._source=this.source=Qe,this.execution=nt,lt=rt):(this.target=ne,this._name=this.name=De,this._source=this.source=Qe,this.execution=nt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof ct?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(p.EmptyType===ne||p.ProcessType===ne||p.ShellType===ne||p.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=p=ze([A],ft),e.Task=ft;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(M,ne=Et.None){this.collapsibleState=ne,_.URI.isUri(M)?this.resourceUri=M:this.label=M}};vt=ze([A],vt),e.TreeItem=vt;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(M,ne){this.id=M,this.color=ne}};Tt=ze([A],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor(M){this.id=M}};It=ze([A],It),e.ThemeColor=It;var bn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(M,ne){if(typeof M!="string"&&(!M||!_.URI.isUri(M)&&!_.URI.isUri(M.uri)))throw(0,R.illegalArgument)("base");if(typeof ne!="string")throw(0,R.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=_.URI.file(M),this.base=M):_.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ne}};Vt=ze([A],Vt),e.RelativePattern=Vt;let _t=class{constructor(M,ne,De,Qe){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof De=="string"&&(this.hitCondition=De),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};_t=ze([A],_t),e.Breakpoint=_t;let Yt=class extends _t{constructor(M,ne,De,Qe,nt){super(ne,De,Qe,nt);if(M===null)throw(0,R.illegalArgument)("location");this.location=M}};Yt=ze([A],Yt),e.SourceBreakpoint=Yt;let Jt=class extends _t{constructor(M,ne,De,Qe,nt){super(ne,De,Qe,nt);this.functionName=M}};Jt=ze([A],Jt),e.FunctionBreakpoint=Jt;let gt=class extends _t{constructor(M,ne,De,Qe,nt,rt,lt){super(Qe,nt,rt,lt);if(!ne)throw(0,R.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=De}};gt=ze([A],gt),e.DataBreakpoint=gt;let qt=class{constructor(M,ne,De){this.command=M,this.args=ne||[],this.options=De}};qt=ze([A],qt),e.DebugAdapterExecutable=qt;let Wt=class{constructor(M,ne){this.port=M,this.host=ne}};Wt=ze([A],Wt),e.DebugAdapterServer=Wt;let Xt=class{constructor(M){this.path=M}};Xt=ze([A],Xt),e.DebugAdapterNamedPipeServer=Xt;let Zt=class{constructor(M){this.implementation=M}};Zt=ze([A],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor(M,ne){this.range=M,this.expression=ne}};Pt=ze([A],Pt),e.EvaluatableExpression=Pt;var dn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(M,ne){this.range=M,this.text=ne}};en=ze([A],en),e.InlineValueText=en;let xt=class{constructor(M,ne,De=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=De}};xt=ze([A],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor(M,ne){this.range=M,this.expression=ne}};ht=ze([A],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};tn=ze([A],tn),e.InlineValueContext=tn;var Mt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Nt=D=class extends Error{constructor(M,ne=n.FileSystemProviderErrorCode.Unknown,De){super(_.URI.isUri(M)?M.toString(!0):M);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(M){return new D(M,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(M){return new D(M,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(M){return new D(M,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(M){return new D(M,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Nt=D=ze([A],Nt),e.FileSystemError=Nt;let jt=class{constructor(M,ne,De){this.start=M,this.end=ne,this.kind=De}};jt=ze([A],jt),e.FoldingRange=jt;var En;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=fn;function nn(N){return typeof N=="undefined"||(0,y.isStringArray)(N)}class rn{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,De=M.tokenTypes.length;ne<De;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,De=M.tokenModifiers.length;ne<De;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,De,Qe,nt){if(typeof M=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Qe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(M,ne,De,Qe,nt);if(j.isRange(M)&&typeof ne=="string"&&nn(De))return this._push(M,ne,De);throw(0,R.illegalArgument)()}_push(M,ne,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Qe=M.start.line,nt=M.start.character,rt=M.end.character-M.start.character,lt=this._tokenTypeStrToInt.get(ne);let St=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);St|=1<<Rt>>>0}this._pushEncoded(Qe,nt,rt,lt,St)}_pushEncoded(M,ne,De,Qe,nt){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Rt=0;for(let Lt=0;Lt<St;Lt++){let Ot=this._data[5*Lt],un=this._data[5*Lt+1];Ot===0?(Ot=At,un+=Rt):Ot+=At,this._data[5*Lt]=Ot,this._data[5*Lt+1]=un,At=Ot,Rt=un}}let rt=M,lt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=nt,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){let ne=[];const De=M.length/5|0;for(let lt=0;lt<De;lt++)ne[lt]=lt;ne.sort((lt,St)=>{const At=M[5*lt],Rt=M[5*St];if(At===Rt){const Lt=M[5*lt+1],Ot=M[5*St+1];return Lt-Ot}return At-Rt});const Qe=new Uint32Array(M.length);let nt=0,rt=0;for(let lt=0;lt<De;lt++){const St=5*ne[lt],At=M[St+0],Rt=M[St+1],Lt=M[St+2],Ot=M[St+3],un=M[St+4],Un=At-nt,jn=Un===0?Rt-rt:Rt,cn=5*lt;Qe[cn+0]=Un,Qe[cn+1]=jn,Qe[cn+2]=Lt,Qe[cn+3]=Ot,Qe[cn+4]=un,nt=At,rt=Rt}return Qe}build(M){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),M):new Ht(rn._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=rn;class Ht{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=Ht;class sn{constructor(M,ne,De){this.start=M,this.deleteCount=ne,this.data=De}}e.SemanticTokensEdit=sn;class yn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=yn;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=ze([A],Gt),e.QuickInputButtons=Gt;var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(M,ne,De){this.badge=M,this.tooltip=ne,this.color=De}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor(M){this.kind=M}};on=ze([A],on),e.ColorTheme=on;var an;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,ne){if(M<0)throw(0,R.illegalArgument)("start must be positive");if(ne<0)throw(0,R.illegalArgument)("end must be positive");M<=ne?(this._start=M,this._end=ne):(this._start=ne,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let ne=this._start,De=this._end;return M.start!==void 0&&(ne=M.start),M.end!==void 0&&(De=M.end),ne===this._start&&De===this._end?this:new Bt(ne,De)}}e.NotebookRange=Bt;class Ft{constructor(M,ne,De,Qe,nt,rt,lt){this.kind=M,this.value=ne,this.languageId=De,this.mime=Qe,this.outputs=nt??[],this.metadata=rt,this.executionSummary=lt,Ft.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ne=>Ft.isNotebookCellData(ne))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Ft;class Kt{constructor(M){this.cells=M}}e.NotebookData=Kt;class Le{constructor(M,ne){this.data=M,this.mime=ne;const De=(0,k.normalizeMimeType)(ne,!0);if(!De)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=De}static isNotebookCellOutputItem(M){return M instanceof Le?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ne={name:M.name,message:M.message,stack:M.stack};return Le.json(ne,"application/vnd.code.notebook.error")}static stdout(M){return Le.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Le.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ne="application/octet-stream"){return new Le(M,ne)}static text(M,ne=k.Mimes.text){const De=Be(Le,u,"f",f).encode(String(M));return new Le(De,ne)}static json(M,ne="application/json"){const De=JSON.stringify(M,void 0,"	");return Le.text(De,ne)}}e.NotebookCellOutputItem=Le,u=Le,f={value:new TextEncoder};class $t{constructor(M,ne,De){this.items=$t.ensureUniqueMimeTypes(M,!0),typeof ne=="string"?(this.id=ne,this.metadata=De):(this.id=(0,C.generateUuid)(),this.metadata=ne??De)}static isNotebookCellOutput(M){return M instanceof $t?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,y.isArray)(M.items)}static ensureUniqueMimeTypes(M,ne=!1){const De=new Set,Qe=new Set;for(let nt=0;nt<M.length;nt++){const rt=M[nt],lt=(0,k.normalizeMimeType)(rt.mime);if(!De.has(lt)){De.add(lt);continue}Qe.add(nt),ne&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Qe.size===0?M:M.filter((nt,rt)=>!Qe.has(rt))}}e.NotebookCellOutput=$t;var mn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(M,ne){this.text=M,this.alignment=ne}}e.NotebookCellStatusBarItem=gn;var pn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(M,ne=[]){this.uri=M,this.provides=(0,g.asArray)(ne)}}e.NotebookRendererScript=Pn;let ln=class{constructor(M,ne){this.label=M,this.timestamp=ne}};ln=ze([A],ln),e.TimelineItem=ln;var An;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=Rn;class Fn{constructor(M,ne){this._port=M,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Ln;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var Mn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let J=class{constructor(M,ne,De){this.include=M,this.exclude=ne,this.profile=De}};J=ze([A],J),e.TestRunRequest=J;let ue=T=class{constructor(M){this.message=M}static diff(M,ne,De){const Qe=new T(M);return Qe.expectedOutput=ne,Qe.actualOutput=De,Qe}};ue=T=ze([A],ue),e.TestMessage=ue;let Ae=class{constructor(M,ne){this.covered=M,this.total=ne}};Ae=ze([A],Ae),e.CoveredCount=Ae;let st=o=class{constructor(M,ne,De,Qe){this.uri=M,this.statementCoverage=ne,this.branchCoverage=De,this.functionCoverage=Qe}static fromDetails(M,ne){const De=new Ae(0,0),Qe=new Ae(0,0),nt=new Ae(0,0);for(const lt of ne)if("branches"in lt){De.total+=1,De.covered+=lt.executionCount>0?1:0;for(const St of lt.branches)Qe.total+=1,Qe.covered+=St.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const rt=new o(M,De,Qe.total>0?Qe:void 0,nt.total>0?nt:void 0);return rt.detailedCoverage=ne,rt}};st=o=ze([A],st),e.FileCoverage=st;let wt=class{constructor(M,ne,De=[]){this.executionCount=M,this.location=ne,this.branches=De}};wt=ze([A],wt),e.StatementCoverage=wt;let Ct=class{constructor(M,ne){this.executionCount=M,this.location=ne}};Ct=ze([A],Ct),e.BranchCoverage=Ct;let On=class{constructor(M,ne){this.executionCount=M,this.location=ne}};On=ze([A],On),e.FunctionCoverage=On;var Hn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(M,ne,De,Qe,nt,rt){this.kind=M,this.name=ne,this.detail=De,this.uri=Qe,this.range=nt,this.selectionRange=rt}}e.TypeHierarchyItem=qn}),define(be[98],Ee([0,1,41,11,8,124,88,7,17]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(u,f){f?C.set(u,f):C.delete(u)}e.setWordDefinitionFor=n;function I(u){return C.get(u)}e.getWordDefinitionFor=I;class l extends E.MirrorTextModel{constructor(f,b,w,P,a,h,v,t){super(b,w,P,a);this._proxy=f,this._languageId=h,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,_.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(b){return b?f._getTextInRange(b):f.getText()},get eol(){return f._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(b){return f._lineAt(b)},offsetAt(b){return f._offsetAt(b)},positionAt(b){return f._positionAt(b)},validateRange(b){return f._validateRange(b)},validatePosition(b){return f._validatePosition(b)},getWordRangeAtPosition(b,w){return f._getWordRangeAtPosition(b,w)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,g.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,g.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const b=this._validateRange(f);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const w=this._eol,P=b.start.line,a=b.end.line,h=[];h.push(this._lines[P].substring(b.start.character));for(let v=P+1;v<a;v++)h.push(this._lines[v]);return h.push(this._lines[a].substring(0,b.end.character)),h.join(w)}_lineAt(f){let b;if(f instanceof y.Position?b=f.line:typeof f=="number"&&(b=f),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new d(b,this._lines[b],b===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(f),w=this._lines[b.index].length;return new y.Position(b.index,Math.min(b.remainder,w))}_validateRange(f){if(!(f instanceof y.Range))throw new Error("Invalid argument");const b=this._validatePosition(f.start),w=this._validatePosition(f.end);return b===f.start&&w===f.end?f:new y.Range(b.line,b.character,w.line,w.character)}_validatePosition(f){if(!(f instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:b,character:w}=f,P=!1;if(b<0)b=0,w=0,P=!0;else if(b>=this._lines.length)b=this._lines.length-1,w=this._lines[b].length,P=!0;else{const a=this._lines[b].length;w<0?(w=0,P=!0):w>a&&(w=a,P=!0)}return P?new y.Position(b,w):f}_getWordRangeAtPosition(f,b){const w=this._validatePosition(f);if(!b)b=I(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const P=(0,k.getWordAtText)(w.character+1,(0,k.ensureValidWordDefinition)(b),this._lines[w.line],0);if(P)return new y.Range(w.line,P.startColumn-1,w.line,P.endColumn-1)}}e.ExtHostDocumentData=l;class d{constructor(f,b,w){this._line=f,this._text=b,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(be[165],Ee([0,1,7,3,90,6,57,21,2,37]),function(te,e,g,R,S,E,k,y,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,d,u,f){this._notebook=u,this._selector=f,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(w=>{const P=this._cellUris.get(w.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>b(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const l=[],d=[];for(const u of this._notebook.getCells())u.kind===g.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),l.push(u.document.getText().length+1),d.push(u.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(l){if(!l){let P="";for(const a of this._cells)P+=a.document.getText()+`
`;return P=P.slice(0,-1),P}if(l.isEmpty)return"";const d=this.locationAt(l.start),u=this.locationAt(l.end),f=this._cellUris.get(d.uri),b=this._cellUris.get(u.uri);if(f===void 0||b===void 0)return"";if(f===b)return this._cells[f].document.getText(new g.Range(d.range.start,u.range.end));const w=[this._cells[f].document.getText(new g.Range(d.range.start,new g.Position(this._cells[f].document.lineCount,0)))];for(let P=f+1;P<b;P++)w.push(this._cells[P].document.getText());return w.push(this._cells[b].document.getText(new g.Range(new g.Position(0,0),u.range.end))),w.join(`
`)}offsetAt(l){const d=this._cellLines.getIndexOf(l.line),u=this._cellLengths.getPrefixSum(d.index-1),f=this._cells[d.index].document.offsetAt(l.with(d.remainder));return u+f}positionAt(l){if(typeof l=="number"){const u=this._cellLengths.getIndexOf(l),f=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(f)}const d=this._cellUris.get(l.uri);if(d!==void 0){const u=this._cellLines.getPrefixSum(d-1);return new g.Position(u+l.range.start.line,l.range.start.character)}return new g.Position(0,0)}locationAt(l){g.Range.isRange(l)||(l=new g.Range(l,l));const d=this._cellLines.getIndexOf(l.start.line);let u=d;l.isEmpty||(u=this._cellLines.getIndexOf(l.end.line));const f=new g.Position(d.remainder,l.start.character),b=new g.Position(u.remainder,l.end.character),w=new g.Range(f,b),P=this._cells[d.index];return new g.Location(P.document.uri,P.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const d=this.validatePosition(l.start),u=this.validatePosition(l.end);return l.with(d,u)}validatePosition(l){const d=this._cellLines.getIndexOf(l.line),u=new g.Position(d.remainder,l.character),f=this._cells[d.index].document.validatePosition(u),b=this._cellLines.getPrefixSum(d.index-1);return new g.Position(b+f.line,f.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[166],Ee([0,1,7,13,3]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let _=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=ze([Ve(0,R.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(be[69],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class R{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=R}),define(be[167],Ee([0,1,24]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function S(y,_){if(_.serializeBuffersForPostMessage){const C=new R,n=(d,u)=>{if(u instanceof ArrayBuffer){const f=C.add(u);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(u)){const f=E(u);if(f){const b=C.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:f,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},I=JSON.stringify(y,n),l=C.buffers.map(d=>{const u=new Uint8Array(d);return g.VSBuffer.wrap(u)});return{message:I,buffers:l}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=S;function E(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(y,_){const C=_.map(l=>{const d=new ArrayBuffer(l.byteLength);return new Uint8Array(d).set(l.buffer),d}),n=_.length?(l,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const u=d,{index:f}=u,b=C[f];if(u.view)switch(u.view.type){case 1:return new Int8Array(b,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return d}:void 0;return{message:JSON.parse(y,n),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(be[168],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(R){function S(k){const y={items:new Map};return k.types.forEach((_,C)=>{y.items.set(_,{asString:async()=>k.items[C].asString})}),y}R.toITreeDataTransfer=S;async function E(k){const y={types:[],items:[]},_=Array.from(k.items.entries());for(const C of _)y.types.push(C[0]),y.items.push({asString:await C[1].asString()});return y}R.toTreeDataTransferDTO=E})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[70],Ee([0,1,11,2]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(E,k){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(k&&k.authority&&k.isRemote&&E.scheme===g.Schemas.file&&(E=R.URI.from({scheme:g.Schemas.vscodeRemote,authority:k.authority,path:E.path})),R.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=S}),define(be[169],Ee([0,1,3,6,70]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(y,_,C){this._proxy=y,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,_,C,n,I){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===y){l=a;break}if(!l)throw new Error("not a visible editor");const d=this,u=this._handlePool++,f=new g.Emitter,b=new g.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,S.asWebviewUri)(a,d._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(a){this._options=a,d._proxy.$setOptions(u,a)}get options(){return this._options}set html(a){this._html=a,d._proxy.$setHtml(u,a)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(a){return d._proxy.$postMessage(u,a)}},P=new class{constructor(){this.editor=y,this.line=_,this.height=C,this.webview=w,this.onDidDispose=b.event}dispose(){d._insets.has(u)&&(d._insets.delete(u),d._proxy.$disposeEditorInset(u),b.fire(),b.dispose(),f.dispose())}};return this._proxy.$createEditorInset(u,l.id,l.value.document.uri,_+1,C,n||{},I.identifier,I.extensionLocation),this._insets.set(u,{editor:y,inset:P,onDidReceiveMessage:f}),P}$onDidDispose(y){const _=this._insets.get(y);_&&_.inset.dispose()}$onDidReceiveMessage(y,_){const C=this._insets.get(y);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=E}),define(be[170],Ee([0,1,140,10,2,6,4,45,28,17,11]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=I;function l(o){if(a(o))return!1;const A=o;return S.URI.isUri(A?.resource)}e.isResourceEditorInput=l;function d(o){if(a(o))return!1;const A=o;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=d;function u(o){if(a(o))return!1;const A=o;return A?A?.resource===void 0||A.resource.scheme===n.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var f;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var b;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var w;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends E.Disposable{}e.AbstractEditorInput=P;function a(o){return o instanceof P}e.isEditorInput=a;function h(o){const A=o;return S.URI.isUri(A?.preferredResource)}function v(o){const A=o;return a(A?.primary)&&a(A?.secondary)}e.isSideBySideEditorInput=v;function t(o){return a(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const A=o;return t(o)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const A=o;return typeof A?.groupId=="number"&&a(A.editor)}e.isEditorIdentifier=s;var i;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(A,F){if(!A)return;const U=v(A)?A.primary:d(A)?A.modified:void 0,j=v(A)?A.secondary:d(A)?A.original:void 0;if(F?.supportSideBySide&&U&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:F.filterByScheme})};A=F.supportSideBySide===i.PRIMARY?U:j}if(d(A))return;const ae=h(A)?A.preferredResource:A.resource;return!ae||!F||!F.filterByScheme?ae:this.filterUri(ae,F.filterByScheme)}getCanonicalUri(A,F){if(!A)return;const U=v(A)?A.primary:d(A)?A.modified:void 0,j=v(A)?A.secondary:d(A)?A.original:void 0;if(F?.supportSideBySide&&U&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:F.filterByScheme})};A=F.supportSideBySide===i.PRIMARY?U:j}if(d(A))return;const ae=A.resource;return!ae||!F||!F.filterByScheme?ae:this.filterUri(ae,F.filterByScheme)}filterUri(A,F){if(Array.isArray(F)){if(F.some(U=>A.scheme===U))return A}else if(F===A.scheme)return A}}e.EditorResourceAccessor=new c;var m;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class p{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const F=this.instantiationService=A.get(k.IInstantiationService);for(const[U,j]of this.editorSerializerConstructors)this.createEditorSerializer(U,j,F);this.editorSerializerConstructors.clear()}createEditorSerializer(A,F,U){const j=U.createInstance(F);this.editorSerializerInstances.set(A,j)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,F){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,F,this.instantiationService):this.editorSerializerConstructors.set(A,F),(0,E.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new p);async function D(o,A){if(!o||!o.length)return[];const F=await Promise.all(o.map(async U=>{const j=S.URI.revive(U.fileUri);if(!j||(await A.activateProvider(j.scheme),!A.canHandleResource(j)))return;const ae=typeof U.exists=="boolean"?U.exists:await A.exists(j);if(!ae&&U.openOnlyIfExists)return;const G=ae&&!(0,R.isUndefined)(U.selection)?{selection:U.selection,pinned:!0,override:U.editorOverrideId}:{pinned:!0,override:U.editorOverrideId};let B;return ae?B={resource:j,options:G,forceFile:!0}:B={resource:j,options:G,forceUntitled:!0},B}));return(0,C.coalesce)(F)}e.pathsToEditors=D;var T;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[171],Ee([0,1,3,45,141,4,6,21,28,17,50,23,35,160]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",l.Codicon.window,(0,S.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var f;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function w(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=w;class P extends k.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(m,p,D){const T=this.get(m.id);if(T)return T;const o=m;return o.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,y.getOrSet)(this.viewContainers,p,[]).push(o),D?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:p}),o}deregisterViewContainer(m){for(const p of this.viewContainers.keys()){const D=this.viewContainers.get(p),T=D?.indexOf(m);if(T!==-1){D?.splice(T,1),D.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:m,viewContainerLocation:p});return}}}get(m){return this.all.filter(p=>p.id===m)[0]}getViewContainers(m){return[...this.viewContainers.get(m)||[]]}getViewContainerLocation(m){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(D=>D?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===m)}}_.Registry.add(u.ViewContainersRegistry,new P);var a;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function h(c,m){const p=c.group??a.More,D=m.group??a.More;return p!==D?p.localeCompare(D):(c.order??5)-(m.order??5)}class v extends k.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(m,p){this.registerViews2([{views:m,viewContainer:p}])}registerViews2(m){m.forEach(({views:p,viewContainer:D})=>this.addViews(p,D)),this._onViewsRegistered.fire(m)}deregisterViews(m,p){const D=this.removeViews(m,p);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:p})}moveViews(m,p){for(const D of this._views.keys())if(D!==p){const T=this.removeViews(m,D);T.length&&(this.addViews(T,p),this._onDidChangeContainer.fire({views:T,from:D,to:p}))}}getViews(m){return this._views.get(m)||[]}getView(m){for(const p of this._viewContainers){const D=(this._views.get(p)||[]).filter(T=>T.id===m)[0];if(D)return D}return null}getViewContainer(m){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(T=>T.id===m)[0])return p;return null}registerViewWelcomeContent(m,p){return this._viewWelcomeContents.add(m,p),this._onDidChangeViewWelcomeContent.fire(m),(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(m,p),this._onDidChangeViewWelcomeContent.fire(m)})}registerViewWelcomeContent2(m,p){const D=new Map;for(const[T,o]of p)this._viewWelcomeContents.add(m,o),D.set(T,(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(m,o),this._onDidChangeViewWelcomeContent.fire(m)}));return this._onDidChangeViewWelcomeContent.fire(m),D}getViewWelcomeContent(m){const p=[];return this._viewWelcomeContents.forEach(m,D=>p.push(D)),p.sort(h)}addViews(m,p){let D=this._views.get(p);D||(D=[],this._views.set(p,D),this._viewContainers.push(p));for(const T of m){if(this.getView(T.id)!==null)throw new Error((0,S.localize)(1,null,T.id));D.push(T)}}removeViews(m,p){const D=this._views.get(p);if(!D)return[];const T=[],o=[];for(const A of D)m.includes(A)?T.push(A):o.push(A);return T.length&&(o.length?this._views.set(p,o):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),T}}_.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,E.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,E.createDecorator)("viewDescriptorService");var r;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(m,p){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,m),this._hasResolve=!!p,this.resolve=async D=>{if(p&&!this.resolved){const T=await p(D);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[172],Ee([0,1,3,15,142]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,_,C,n){const I={command:y};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const d=this.pendingRequests.get(I.seq);if(d){this.pendingRequests.delete(I.seq);const u={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:(0,S.localize)(0,null,n,y)};d(u)}},n)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,_){return y.type!=="event"||_.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,R.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const _=y,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(y,_){_.type=y,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((_,C)=>y.set(C,_)),await(0,R.timeout)(500),y.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(be[173],Ee([0,1,8,2,14,23,11]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function _(r,s,i){return r.replace(y,function(c,m){return s&&m.length>0&&m[0]!=="_"?c:i&&i.hasOwnProperty(m)?i[m]:c})}e.formatPII=_;function C(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=C;function n(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(s,"extensionhost")||(0,g.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function d(r,s,i){let c,m=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=p.exec(r);){let T=D.index+1,o=T+D[0].length;if(T<=s&&o>=i){c=D[0],m=T;break}}if(c){let T=/\w+/g,o=null;for(;(o=T.exec(c))&&!(o.index+1+m+o[0].length>=i););o&&(c=c.substring(0,T.lastIndex))}return c?{start:m,end:m+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(r){return!!(r&&r.match(u))}e.isUri=f;function b(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(f(r.path))return R.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const s=R.URI.revive(r.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return r.path}function P(r,s){const i=s?b:w,c=(0,E.deepClone)(r);return h(c,(m,p)=>{m&&p&&(p.path=i(p))}),c}e.convertToDAPaths=P;function a(r,s){const i=s?b:w,c=(0,E.deepClone)(r);return h(c,(m,p)=>{!m&&p&&(p.path=i(p))}),c}e.convertToVSCPaths=a;function h(r,s){switch(r.type){case"event":const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":s(!0,c.arguments.source);break;case"breakpointLocations":s(!0,c.arguments.source);break;case"source":s(!0,c.arguments.source);break;case"gotoTargets":s(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":m.body.sources.forEach(p=>s(!1,p));break;case"scopes":m.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":m.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function v(r){return r.filter(s=>!s.presentation?.hidden).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=v;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(be[71],Ee([0,1,27,85,11,14,22,45]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var b;(function(o){o.scheme=S.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function F(B,$){return B.with({scheme:o.scheme,fragment:`ch${$.toString().padStart(7,"0")}${B.scheme!==S.Schemas.file?B.scheme:""}`})}o.generate=F;function U(B){if(B.scheme!==o.scheme)return;const $=A.exec(B.fragment);return $?{handle:Number($[1]),notebook:B.with({scheme:B.fragment.substr($[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parse=U;function j(B){if(B.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const $=A.exec(B.fragment);return $?{handle:Number($[1]),notebook:B.with({scheme:B.fragment.substr($[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=j;function ae(B,$,L){return B.with({scheme:L,fragment:`ch${$.toString().padStart(7,"0")}${B.scheme!==S.Schemas.file?B.scheme:""}`})}o.generateCellUri=ae;function G(B,$){if(B.scheme!==$)return;const L=A.exec(B.fragment);return L?{handle:Number(L[1]),notebook:B.with({scheme:B.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellUri=G})(b=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(o){return w.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function a(o){return w.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function h(o){return w.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=h;function v(o,A){return k.isWindows&&(o=o.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),g.match(o,A)}function t(o,A,F){let U=0;for(let j=0;j<A.length;j++){if(v(A[j],o))return U;U++}for(let j=0;j<F.length;j++){if(v(F[j],o))return U;U++}return U}function r(o,A,F){return o.sort((U,j)=>t(U,A,F)-t(j,A,F))}e.sortMimeTypes=r;function s(o,A,F,U=(j,ae)=>j===ae){const j=[];function ae($,L,Z){if(L===0&&Z.length===0)return;const V=j[j.length-1];V&&V.start+V.deleteCount===$?(V.deleteCount+=L,V.toInsert.push(...Z)):j.push({start:$,deleteCount:L,toInsert:Z})}let G=0,B=0;for(;;){if(G===o.length){ae(G,0,A.slice(B));break}if(B===A.length){ae(G,o.length-G,[]);break}const $=o[G],L=A[B];if(U($,L)){G+=1,B+=1;continue}F(L)?(ae(G,1,[]),G+=1):(ae(G,0,[L]),B+=1)}return j}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const A=o;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=c;function m(o,A,F){if(Array.isArray(o.viewType)&&o.viewType.indexOf(A)>=0||o.viewType===A)return!0;if(o.filenamePattern){let U=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,j=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(g.match(U,(0,E.basename)(F.fsPath).toLowerCase()))return!(j&&g.match(j,(0,E.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class p{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)A[F]=this.textModel.cells[F].getHashValue();return A}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var D;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(A){return`${T._prefix}${A}`}static parse(A){if(A.startsWith(T._prefix))return A.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[174],Ee([0,1,144,4,45]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[175],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=g;function R(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=R}),define(be[99],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));const R=I=>({testId:I.item.extId,controllerId:I.controllerId});e.identifyTest=R;var S;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(I,l)=>{l.expand!==void 0&&(I.expand=l.expand),l.item!==void 0&&(I.item=I.item?Object.assign(I.item,l.item):l.item)};e.applyTestItemUpdate=k;var y;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var _;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(l){}update(l){}remove(l,d){}complete(){}}e.IncrementalChangeCollector=C;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const d=this.createChangeCollector();for(const u of l)switch(u[0]){case 0:{const f=u[1];if(f.parent){if(this.items.has(f.parent)){const b=this.items.get(f.parent);b.children.add(f.item.extId);const w=this.createItem(f,b);this.items.set(f.item.extId,w),d.add(w)}}else{const b=this.createItem(f);this.roots.add(b),this.items.set(f.item.extId,b),d.add(b)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=u[1],b=this.items.get(f.extId);if(!b)break;f.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,f),d.update(b);break}case 2:{const f=this.items.get(u[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const b=[[u[1]]];for(;b.length;)for(const w of b.pop()){const P=this.items.get(w);P&&(b.push(P.children),this.items.delete(w),d.remove(P,P!==f),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break}d.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=n}),define(be[72],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(E){E.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(E){E[E.IsSame=0]="IsSame",E[E.Disconnected=1]="Disconnected",E[E.IsChild=2]="IsChild",E[E.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class S{constructor(k,y=k.length){if(this.path=k,this.viewEnd=y,k.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,y,_=k.parent){if(k.id===y)return new S([y]);let C=[k.id];for(let n=_;n&&n.id!==y;n=n.parent)C.push(n.id);return C.push(y),new S(C.reverse())}static fromString(k){return new S(k.split("\0"))}static join(k,y){return new S([...k.path,y])}static joinToString(k,y){return k.toString()+"\0"+y}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){let k=this.path[0];yield k;for(let y=1;y<this.viewEnd;y++)k+="\0",k+=this.path[y],yield k}compare(k){for(let y=0;y<k.viewEnd&&y<this.viewEnd;y++)if(k.path[y]!==this.path[y])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=S}),define(be[176],Ee([0,1,14,42,10,23,22,84,145]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,l,d){this._contributedVariables=new Map,this._context=I,this._labelService=l,d&&(this._envVariablesPromise=d.then(u=>this.prepareEnv(u)))}prepareEnv(I){if(k.isWindows){const l=Object.create(null);return Object.keys(I).forEach(d=>{l[d.toLowerCase()]=I[d]}),l}return I}resolveWithEnvironment(I,l,d){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,d)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,d,u){const f=E.deepClone(l);return k.isWindows&&f.windows?Object.keys(f.windows).forEach(b=>f[b]=f.windows[b]):k.isMacintosh&&f.osx?Object.keys(f.osx).forEach(b=>f[b]=f.osx[b]):k.isLinux&&f.linux&&Object.keys(f.linux).forEach(b=>f[b]=f.linux[b]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,f,d,u)}async resolveAnyAsync(I,l,d){return this.resolveAnyBase(I,l,d)}async resolveAnyMap(I,l,d){const u=new Map;return{newConfig:await this.resolveAnyBase(I,l,d,u),resolvedVariables:u}}resolveWithInteractionReplace(I,l,d,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,d,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,d,u,f){if(S.isString(d))return this.resolveString(I,l,d,u,f);if(S.isArray(d))return d.map(b=>this.recursiveResolve(I,l,b,u,f));if(S.isObject(d)){let b=Object.create(null);return Object.keys(d).forEach(w=>{const P=this.resolveString(I,l,w,u,f);b[P]=this.recursiveResolve(I,l,d[w],u,f)}),b}return d}resolveString(I,l,d,u,f){return d.replace(C.VARIABLE_REGEXP,(w,P)=>{if(P.includes(C.VARIABLE_LHS))return w;let a=this.evaluateSingleVariable(I,w,P,l,u);return f&&f.set(P,a),a!==w&&S.isString(a)&&a.match(C.VARIABLE_REGEXP)&&(a=this.resolveString(I,l,a,u,f)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,d,u,f){let b;const w=d.split(":");w.length>1&&(d=w[0],b=w[1]);const P=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,_.localize)(0,null,l))},a=()=>{const v=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,_.localize)(1,null,l,g.basename(v)))},h=()=>{if(b){const v=this._context.getFolderUri(b);if(v)return v;throw new Error((0,_.localize)(2,null,l,b))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(d){case"env":if(b){if(I){const v=I[k.isWindows?b.toLowerCase():b];if(S.isString(v))return v}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(b){const v=this._context.getConfigurationValue(u,b);if(S.isUndefinedOrNull(v))throw new Error((0,_.localize)(6,null,l,b));if(S.isObject(v))throw new Error((0,_.localize)(7,null,l,b));return v}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,f,"command");case"input":return this.resolveFromMap(l,b,f,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return u||b?(0,y.normalizeDriveLetter)(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(h()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,_.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,_.localize)(10,null,l));case"file":return P();case"fileWorkspaceFolder":return a();case"relativeFile":return u||b?g.relative(this.fsPath(h()),P()):P();case"relativeFileDirname":const r=g.dirname(P());if(u||b){const m=g.relative(this.fsPath(h()),r);return m.length===0?".":m}return r;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const s=g.basename(P());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return g.sep;default:try{const m=b?`${d}:${b}`:d;return this.resolveFromMap(l,m,f,void 0)}catch(m){return l}}}}resolveFromMap(I,l,d,u){if(l&&d){const f=u===void 0?d[l]:d[u+":"+l];if(typeof f=="string")return f;throw new Error((0,_.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[100],Ee([0,1,4,170]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var S;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var E;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(E=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function C(f){const b=f;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=C;var n;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",f[f.EDITOR_PIN=8]="EDITOR_PIN",f[f.EDITOR_STICKY=9]="EDITOR_STICKY",f[f.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function d(f){const b=f;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=d;function u(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(be[177],Ee([0,1,4,100]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(E){const k=E;return typeof E=="number"||(0,R.isEditorGroup)(k)}e.isPreferredGroup=S}),define(be[9],Ee([0,1,17,83,233,56,23,10,2,31,60,146,92,67,71,72,177,7]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(_e){function ke(W){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:tt,positionColumn:Ge}=W,ct=new w.Position(Fe-1,Te-1),yt=new w.Position(tt-1,Ge-1);return new w.Selection(ct,yt)}_e.to=ke;function Q(W){const{anchor:Fe,active:Te}=W;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}_e.from=Q})(P=e.Selection||(e.Selection={}));var a;(function(_e){function ke(W){if(!W)return;const{start:Fe,end:Te}=W;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}_e.from=ke;function Q(W){if(!W)return;const{startLineNumber:Fe,startColumn:Te,endLineNumber:tt,endColumn:Ge}=W;return new w.Range(Fe-1,Te-1,tt-1,Ge-1)}_e.to=Q})(a=e.Range||(e.Range={}));var h;(function(_e){function ke(Q){switch(Q){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}_e.to=ke})(h=e.TokenType||(e.TokenType={}));var v;(function(_e){function ke(W){return new w.Position(W.lineNumber-1,W.column-1)}_e.to=ke;function Q(W){return{lineNumber:W.line+1,column:W.character+1}}_e.from=Q})(v=e.Position||(e.Position={}));var t;(function(_e){function ke(W){switch(W){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}_e.from=ke;function Q(W){switch(W){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}_e.to=Q})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ke(W){let Fe;return W.code&&((0,y.isString)(W.code)||(0,y.isNumber)(W.code)?Fe=String(W.code):Fe={value:String(W.code.value),target:W.code.target}),{...a.from(W.range),message:W.message,source:W.source,code:Fe,severity:i.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(s.from),tags:Array.isArray(W.tags)?(0,g.coalesce)(W.tags.map(t.from)):void 0}}_e.from=ke;function Q(W){const Fe=new w.Diagnostic(a.to(W),W.message,i.to(W.severity));return Fe.source=W.source,Fe.code=(0,y.isString)(W.code)?W.code:W.code?.value,Fe.relatedInformation=W.relatedInformation&&W.relatedInformation.map(s.to),Fe.tags=W.tags&&(0,g.coalesce)(W.tags.map(t.to)),Fe}_e.to=Q})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(_e){function ke(W){return{...a.from(W.location.range),message:W.message,resource:W.location.uri}}_e.from=ke;function Q(W){return new w.DiagnosticRelatedInformation(new w.Location(W.resource,a.to(W)),W.message)}_e.to=Q})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ke(W){switch(W){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ke;function Q(W){switch(W){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}_e.to=Q})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(_e){function ke(W){return typeof W=="number"&&W>=w.ViewColumn.One?W-1:W===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}_e.from=ke;function Q(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=Q})(c=e.ViewColumn||(e.ViewColumn={}));function m(_e){return typeof _e.range!="undefined"}function p(_e){return _e.length===0?!0:!!m(_e[0])}e.isDecorationOptionsArr=p;var D;(function(_e){function ke(Ge){return Ge.map(_e.from)}_e.fromMany=ke;function Q(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function W(Ge){let ct;if(Q(Ge)){const{language:ft,value:dt}=Ge;ct={value:"```"+ft+`
`+dt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const kt=ft=>{try{let dt=_.URI.parse(ft,!0);dt=dt.with({query:Fe(dt.query,yt)}),yt[ft]=dt}catch(dt){}return""},Dt=new S.Renderer;return Dt.link=kt,Dt.image=ft=>kt(R.parseHrefAndDimensions(ft).href),S(ct.value,{renderer:Dt}),ct}_e.from=W;function Fe(Ge,ct){if(!Ge)return Ge;let yt;try{yt=(0,E.parse)(Ge)}catch(Dt){}if(!yt)return Ge;let kt=!1;return yt=(0,k.cloneAndChange)(yt,Dt=>{if(_.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=Dt,kt=!0,ft}else return}),kt?JSON.stringify(yt):Ge}function Te(Ge){const ct=new w.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct}_e.to=Te;function tt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:_e.from(Ge)}_e.fromStrict=tt})(D=e.MarkdownString||(e.MarkdownString={}));function T(_e){return p(_e)?_e.map(ke=>({range:a.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?D.fromMany(ke.hoverMessage):ke.hoverMessage?D.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):_e.map(ke=>({range:a.from(ke)}))}e.fromRangeOrRangeWithMessage=T;function o(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?_.URI.file(_e):_e}e.pathOrURIToURI=o;var A;(function(_e){function ke(Q){return typeof Q=="undefined"?Q:{contentText:Q.contentText,contentIconPath:Q.contentIconPath?o(Q.contentIconPath):void 0,border:Q.border,borderColor:Q.borderColor,fontStyle:Q.fontStyle,fontWeight:Q.fontWeight,textDecoration:Q.textDecoration,color:Q.color,backgroundColor:Q.backgroundColor,margin:Q.margin,width:Q.width,height:Q.height}}_e.from=ke})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(_e){function ke(Q){return typeof Q=="undefined"?Q:{backgroundColor:Q.backgroundColor,outline:Q.outline,outlineColor:Q.outlineColor,outlineStyle:Q.outlineStyle,outlineWidth:Q.outlineWidth,border:Q.border,borderColor:Q.borderColor,borderRadius:Q.borderRadius,borderSpacing:Q.borderSpacing,borderStyle:Q.borderStyle,borderWidth:Q.borderWidth,fontStyle:Q.fontStyle,fontWeight:Q.fontWeight,textDecoration:Q.textDecoration,cursor:Q.cursor,color:Q.color,opacity:Q.opacity,letterSpacing:Q.letterSpacing,gutterIconPath:Q.gutterIconPath?o(Q.gutterIconPath):void 0,gutterIconSize:Q.gutterIconSize,overviewRulerColor:Q.overviewRulerColor,before:Q.before?A.from(Q.before):void 0,after:Q.after?A.from(Q.after):void 0}}_e.from=ke})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(_e){function ke(Q){if(typeof Q=="undefined")return Q;switch(Q){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ke})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(_e){function ke(Q){return{isWholeLine:Q.isWholeLine,rangeBehavior:Q.rangeBehavior?U.from(Q.rangeBehavior):void 0,overviewRulerLane:Q.overviewRulerLane,light:Q.light?F.from(Q.light):void 0,dark:Q.dark?F.from(Q.dark):void 0,backgroundColor:Q.backgroundColor,outline:Q.outline,outlineColor:Q.outlineColor,outlineStyle:Q.outlineStyle,outlineWidth:Q.outlineWidth,border:Q.border,borderColor:Q.borderColor,borderRadius:Q.borderRadius,borderSpacing:Q.borderSpacing,borderStyle:Q.borderStyle,borderWidth:Q.borderWidth,fontStyle:Q.fontStyle,fontWeight:Q.fontWeight,textDecoration:Q.textDecoration,cursor:Q.cursor,color:Q.color,opacity:Q.opacity,letterSpacing:Q.letterSpacing,gutterIconPath:Q.gutterIconPath?o(Q.gutterIconPath):void 0,gutterIconSize:Q.gutterIconSize,overviewRulerColor:Q.overviewRulerColor,before:Q.before?A.from(Q.before):void 0,after:Q.after?A.from(Q.after):void 0}}_e.from=ke})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ae;(function(_e){function ke(W){return{text:W.newText,eol:W.newEol&&ce.from(W.newEol),range:a.from(W.range)}}_e.from=ke;function Q(W){const Fe=new w.TextEdit(a.to(W.range),W.text);return Fe.newEol=typeof W.eol=="undefined"?void 0:ce.to(W.eol),Fe}_e.to=Q})(ae=e.TextEdit||(e.TextEdit={}));var G;(function(_e){function ke(W,Fe,Te){const tt={edits:[]};if(W instanceof w.WorkspaceEdit)for(let Ge of W._allEntries())if(Ge._type===1)tt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ct=Fe?.getDocument(Ge.uri);tt.edits.push({_type:2,resource:Ge.uri,edit:ae.from(Ge.edit),modelVersionId:ct?.version,metadata:Ge.metadata})}else Ge._type===3?tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Te?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Te?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(x.from)}});return tt}_e.from=ke;function Q(W){const Fe=new w.WorkspaceEdit;for(const Te of W.edits)Te.edit?Fe.replace(_.URI.revive(Te.resource),a.to(Te.edit.range),Te.edit.text):Fe.renameFile(_.URI.revive(Te.oldUri),_.URI.revive(Te.newUri),Te.options);return Fe}_e.to=Q})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(_e){const ke=Object.create(null);ke[w.SymbolKind.File]=0,ke[w.SymbolKind.Module]=1,ke[w.SymbolKind.Namespace]=2,ke[w.SymbolKind.Package]=3,ke[w.SymbolKind.Class]=4,ke[w.SymbolKind.Method]=5,ke[w.SymbolKind.Property]=6,ke[w.SymbolKind.Field]=7,ke[w.SymbolKind.Constructor]=8,ke[w.SymbolKind.Enum]=9,ke[w.SymbolKind.Interface]=10,ke[w.SymbolKind.Function]=11,ke[w.SymbolKind.Variable]=12,ke[w.SymbolKind.Constant]=13,ke[w.SymbolKind.String]=14,ke[w.SymbolKind.Number]=15,ke[w.SymbolKind.Boolean]=16,ke[w.SymbolKind.Array]=17,ke[w.SymbolKind.Object]=18,ke[w.SymbolKind.Key]=19,ke[w.SymbolKind.Null]=20,ke[w.SymbolKind.EnumMember]=21,ke[w.SymbolKind.Struct]=22,ke[w.SymbolKind.Event]=23,ke[w.SymbolKind.Operator]=24,ke[w.SymbolKind.TypeParameter]=25;function Q(Fe){return typeof ke[Fe]=="number"?ke[Fe]:6}_e.from=Q;function W(Fe){for(const Te in ke)if(ke[Te]===Fe)return Number(Te);return w.SymbolKind.Property}_e.to=W})(B=e.SymbolKind||(e.SymbolKind={}));var $;(function(_e){function ke(W){switch(W){case w.SymbolTag.Deprecated:return 1}}_e.from=ke;function Q(W){switch(W){case 1:return w.SymbolTag.Deprecated}}_e.to=Q})($=e.SymbolTag||(e.SymbolTag={}));var L;(function(_e){function ke(W){return{name:W.name,kind:B.from(W.kind),tags:W.tags&&W.tags.map($.from),containerName:W.containerName,location:H.from(W.location)}}_e.from=ke;function Q(W){const Fe=new w.SymbolInformation(W.name,B.to(W.kind),W.containerName,H.to(W.location));return Fe.tags=W.tags&&W.tags.map($.to),Fe}_e.to=Q})(L=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Z;(function(_e){function ke(W){const Fe={name:W.name||"!!MISSING: name!!",detail:W.detail,range:a.from(W.range),selectionRange:a.from(W.selectionRange),kind:B.from(W.kind),tags:W.tags?.map($.from)??[]};return W.children&&(Fe.children=W.children.map(ke)),Fe}_e.from=ke;function Q(W){const Fe=new w.DocumentSymbol(W.name,W.detail,B.to(W.kind),a.to(W.range),a.to(W.selectionRange));return(0,g.isNonEmptyArray)(W.tags)&&(Fe.tags=W.tags.map($.to)),W.children&&(Fe.children=W.children.map(Q)),Fe}_e.to=Q})(Z=e.DocumentSymbol||(e.DocumentSymbol={}));var V;(function(_e){function ke(W){const Fe=new w.CallHierarchyItem(B.to(W.kind),W.name,W.detail||"",_.URI.revive(W.uri),a.to(W.range),a.to(W.selectionRange));return Fe._sessionId=W._sessionId,Fe._itemId=W._itemId,Fe}_e.to=ke;function Q(W,Fe,Te){if(Fe=Fe??W._sessionId,Te=Te??W._itemId,Fe===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Te,name:W.name,detail:W.detail,kind:B.from(W.kind),uri:W.uri,range:a.from(W.range),selectionRange:a.from(W.selectionRange),tags:W.tags?.map($.from)}}_e.from=Q})(V=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Y;(function(_e){function ke(Q){return new w.CallHierarchyIncomingCall(V.to(Q.from),Q.fromRanges.map(W=>a.to(W)))}_e.to=ke})(Y=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(_e){function ke(Q){return new w.CallHierarchyOutgoingCall(V.to(Q.to),Q.fromRanges.map(W=>a.to(W)))}_e.to=ke})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var H;(function(_e){function ke(W){return{range:W.range&&a.from(W.range),uri:W.uri}}_e.from=ke;function Q(W){return new w.Location(_.URI.revive(W.uri),a.to(W.range))}_e.to=Q})(H=e.location||(e.location={}));var oe;(function(_e){function ke(W){const Fe=W,Te=W;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:a.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}_e.from=ke;function Q(W){return{targetUri:_.URI.revive(W.uri),targetRange:a.to(W.range),targetSelectionRange:W.targetSelectionRange?a.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?a.to(W.originSelectionRange):void 0}}_e.to=Q})(oe=e.DefinitionLink||(e.DefinitionLink={}));var de;(function(_e){function ke(W){return{range:a.from(W.range),contents:D.fromMany(W.contents)}}_e.from=ke;function Q(W){return new w.Hover(W.contents.map(D.to),a.to(W.range))}_e.to=Q})(de=e.Hover||(e.Hover={}));var Ce;(function(_e){function ke(W){return{range:a.from(W.range),expression:W.expression}}_e.from=ke;function Q(W){return new w.EvaluatableExpression(a.to(W.range),W.expression)}_e.to=Q})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(_e){function ke(W){if(W instanceof w.InlineValueText)return{type:"text",range:a.from(W.range),text:W.text};if(W instanceof w.InlineValueVariableLookup)return{type:"variable",range:a.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ke;function Q(W){switch(W.type){case"text":return{range:a.to(W.range),text:W.text};case"variable":return{range:a.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:a.to(W.range),expression:W.expression}}}_e.to=Q})(Ne=e.InlineValue||(e.InlineValue={}));var Me;(function(_e){function ke(W){return{frameId:W.frameId,stoppedLocation:a.from(W.stoppedLocation)}}_e.from=ke;function Q(W){return new w.InlineValueContext(W.frameId,a.to(W.stoppedLocation))}_e.to=Q})(Me=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(_e){function ke(W){return{range:a.from(W.range),kind:W.kind}}_e.from=ke;function Q(W){return new w.DocumentHighlight(a.to(W.range),W.kind)}_e.to=Q})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(_e){function ke(Q){switch(Q){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}_e.to=ke})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(_e){function ke(Q){return{triggerKind:Xe.to(Q.triggerKind),triggerCharacter:Q.triggerCharacter}}_e.to=ke})(qe=e.CompletionContext||(e.CompletionContext={}));var je;(function(_e){function ke(W){switch(W){case w.CompletionItemTag.Deprecated:return 1}}_e.from=ke;function Q(W){switch(W){case 1:return w.CompletionItemTag.Deprecated}}_e.to=Q})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var O;(function(_e){const ke=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function Q(Te){return ke.get(Te)??9}_e.from=Q;const W=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Fe(Te){return W.get(Te)??w.CompletionItemKind.Property}_e.to=Fe})(O=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(_e){function ke(Q,W){const Fe=new w.CompletionItem(Q.label);return Fe.insertText=Q.insertText,Fe.kind=O.to(Q.kind),Fe.tags=Q.tags?.map(je.to),Fe.detail=Q.detail,Fe.documentation=R.isMarkdownString(Q.documentation)?D.to(Q.documentation):Q.documentation,Fe.sortText=Q.sortText,Fe.filterText=Q.filterText,Fe.preselect=Q.preselect,Fe.commitCharacters=Q.commitCharacters,C.Range.isIRange(Q.range)?Fe.range=a.to(Q.range):typeof Q.range=="object"&&(Fe.range={inserting:a.to(Q.range.insert),replacing:a.to(Q.range.replace)}),Fe.keepWhitespace=typeof Q.insertTextRules=="undefined"?!1:Boolean(Q.insertTextRules&1),typeof Q.insertTextRules!="undefined"&&Q.insertTextRules&4?Fe.insertText=new w.SnippetString(Q.insertText):(Fe.insertText=Q.insertText,Fe.textEdit=Fe.range instanceof w.Range?new w.TextEdit(Fe.range,Fe.insertText):void 0),Q.additionalTextEdits&&Q.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Q.additionalTextEdits.map(Te=>ae.to(Te))),Fe.command=W&&Q.command?W.fromInternal(Q.command):void 0,Fe}_e.to=ke})(K=e.CompletionItem||(e.CompletionItem={}));var X;(function(_e){function ke(W){return{label:W.label,documentation:W.documentation?D.fromStrict(W.documentation):void 0}}_e.from=ke;function Q(W){return{label:W.label,documentation:R.isMarkdownString(W.documentation)?D.to(W.documentation):W.documentation}}_e.to=Q})(X=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(_e){function ke(W){return{label:W.label,documentation:W.documentation?D.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(X.from):[],activeParameter:W.activeParameter}}_e.from=ke;function Q(W){return{label:W.label,documentation:R.isMarkdownString(W.documentation)?D.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(X.to):[],activeParameter:W.activeParameter}}_e.to=Q})(re=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function ke(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(re.from):[]}}_e.from=ke;function Q(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(re.to):[]}}_e.to=Q})(q=e.SignatureHelp||(e.SignatureHelp={}));var ie;(function(_e){function ke(W){return{text:W.text,position:v.from(W.position),kind:ge.from(W.kind??w.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}_e.from=ke;function Q(W){const Fe=new w.InlayHint(W.text,v.to(W.position),ge.to(W.kind));return Fe.whitespaceAfter=W.whitespaceAfter,Fe.whitespaceBefore=W.whitespaceBefore,Fe}_e.to=Q})(ie=e.InlayHint||(e.InlayHint={}));var ge;(function(_e){function ke(W){return W}_e.from=ke;function Q(W){return W}_e.to=Q})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(_e){function ke(W){return{range:a.from(W.range),url:W.target,tooltip:W.tooltip}}_e.from=ke;function Q(W){let Fe;if(W.url)try{Fe=typeof W.url=="string"?_.URI.parse(W.url,!0):_.URI.revive(W.url)}catch(Te){}return new w.DocumentLink(a.to(W.range),Fe)}_e.to=Q})(Re=e.DocumentLink||(e.DocumentLink={}));var We;(function(_e){function ke(W){const Fe=new w.ColorPresentation(W.label);return W.textEdit&&(Fe.textEdit=ae.to(W.textEdit)),W.additionalTextEdits&&(Fe.additionalTextEdits=W.additionalTextEdits.map(Te=>ae.to(Te))),Fe}_e.to=ke;function Q(W){return{label:W.label,textEdit:W.textEdit?ae.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(Fe=>ae.from(Fe)):void 0}}_e.from=Q})(We=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function ke(W){return new w.Color(W[0],W[1],W[2],W[3])}_e.to=ke;function Q(W){return[W.red,W.green,W.blue,W.alpha]}_e.from=Q})(ve=e.Color||(e.Color={}));var Ye;(function(_e){function ke(W){return{range:a.from(W.range)}}_e.from=ke;function Q(W){return new w.SelectionRange(a.to(W.range))}_e.to=Q})(Ye=e.SelectionRange||(e.SelectionRange={}));var z;(function(_e){function ke(Q){switch(Q){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}_e.to=ke})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ee;(function(_e){function ke(W){switch(W){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ke;function Q(W){switch(W){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}_e.to=Q})(ee=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(_e){function ke(W){if(W===w.EndOfLine.CRLF)return 1;if(W===w.EndOfLine.LF)return 0}_e.from=ke;function Q(W){if(W===1)return w.EndOfLine.CRLF;if(W===0)return w.EndOfLine.LF}_e.to=Q})(ce=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(_e){function ke(Q){if(typeof Q=="object")return Q.viewId;switch(Q){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ke})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(_e){function ke(Q){const W={start:Q.start+1,end:Q.end+1};return Q.kind&&(W.kind=et.from(Q.kind)),W}_e.from=ke})(xe=e.FoldingRange||(e.FoldingRange={}));var et;(function(_e){function ke(Q){if(Q)switch(Q){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}_e.from=ke})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Se;(function(_e){function ke(Q){if(Q)return{pinned:typeof Q.preview=="boolean"?!Q.preview:void 0,inactive:Q.background,preserveFocus:Q.preserveFocus,selection:typeof Q.selection=="object"?a.from(Q.selection):void 0,override:typeof Q.override=="boolean"?I.EditorResolution.DISABLED:void 0}}_e.from=ke})(Se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ye;(function(_e){function ke(W){return W instanceof w.RelativePattern||typeof W=="string"?W:Q(W)?new w.RelativePattern(W.base,W.pattern):W}_e.from=ke;function Q(W){const Fe=W;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(ye=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(_e){function ke(Q){if(Q){if(Array.isArray(Q))return Q.map(ke);if(typeof Q=="string")return Q;{const W=Q;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:ye.from(W.pattern),exclusive:W.exclusive}}}else return}_e.from=ke})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(_e){function ke(W){return{start:W.start,end:W.end}}_e.from=ke;function Q(W){return new w.NotebookRange(W.start,W.end)}_e.to=Q})(se=e.NotebookRange||(e.NotebookRange={}));var le;(function(_e){function ke(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}_e.to=ke;function Q(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}_e.from=Q})(le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var he;(function(_e){function ke(W){switch(W){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}_e.from=ke;function Q(W){switch(W){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}_e.to=Q})(he=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(_e){function ke(W){const Fe={metadata:W.metadata??Object.create(null),cells:[]};for(let Te of W.cells)w.NotebookCellData.validate(Te),Fe.cells.push(x.from(Te));return Fe}_e.from=ke;function Q(W){const Fe=new w.NotebookData(W.cells.map(x.to));return(0,y.isEmptyObject)(W.metadata)||(Fe.metadata=W.metadata),Fe}_e.to=Q})(pe=e.NotebookData||(e.NotebookData={}));var x;(function(_e){function ke(W){return{cellKind:he.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:le.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(we.from):[]}}_e.from=ke;function Q(W){return new w.NotebookCellData(he.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(we.to):void 0,W.metadata,W.internalMetadata?le.to(W.internalMetadata):void 0)}_e.to=Q})(x=e.NotebookCellData||(e.NotebookCellData={}));var fe;(function(_e){function ke(W){return{mime:W.mime,valueBytes:Array.from(W.data)}}_e.from=ke;function Q(W){return new w.NotebookCellOutputItem(new Uint8Array(W.valueBytes),W.mime)}_e.to=Q})(fe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var we;(function(_e){function ke(W){return{outputId:W.id,items:W.items.map(fe.from),metadata:W.metadata}}_e.from=ke;function Q(W){const Fe=W.items.map(fe.to);return new w.NotebookCellOutput(Fe,W.outputId,W.metadata)}_e.to=Q})(we=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(_e){function ke(Te){if(Te!=null){if(Te instanceof w.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new w.RelativePattern(Te.base,Te.pattern);if(W(Te))return{include:ye.from(Te.include)||void 0,exclude:ye.from(Te.exclude)||void 0}}}_e.from=ke;function Q(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}_e.to=Q;function W(Te){const tt=Te,Ge=ye.from(tt.include);if(!(Ge&&Ge instanceof w.RelativePattern||typeof Ge=="string"))return!1;const ct=ye.from(tt.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function Fe(Te){const tt=Te;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(_e){function ke(Q){return{backgroundColor:Q.backgroundColor,borderColor:Q.borderColor,top:Q.top?A.from(Q.top):void 0}}_e.from=ke})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var He;(function(_e){function ke(Q,W,Fe){const Te=typeof Q.command=="string"?{title:"",command:Q.command}:Q.command;return{alignment:Q.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Te,Fe),text:Q.text,tooltip:Q.tooltip,accessibilityInformation:Q.accessibilityInformation,priority:Q.priority}}_e.from=ke})(He=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(_e){function ke(Q){return{transientOutputs:Q?.transientOutputs??!1,transientCellMetadata:Q?.transientCellMetadata??{},transientDocumentMetadata:Q?.transientDocumentMetadata??{}}}_e.from=ke})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ke;(function(_e){function ke(W){return{uri:W.uri,provides:W.provides}}_e.from=ke;function Q(W){return new w.NotebookRendererScript(_.URI.revive(W.uri),W.provides)}_e.to=Q})(Ke=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(_e){function ke(W){return{message:D.fromStrict(W.message)||"",severity:w.TestMessageSeverity.Error,expectedOutput:W.expectedOutput,actualOutput:W.actualOutput,location:W.location?H.from(W.location):void 0}}_e.from=ke;function Q(W){const Fe=new w.TestMessage(typeof W.message=="string"?W.message:D.to(W.message));return Fe.actualOutput=W.actualOutput,Fe.expectedOutput=W.expectedOutput,Fe}_e.to=Q})(Je=e.TestMessage||(e.TestMessage={}));var ut;(function(_e){function ke(Te){return{extId:f.TestId.fromExtHostTestItem(Te,(0,d.getPrivateApiFor)(Te).controllerId).toString(),label:Te.label,uri:Te.uri,range:a.from(Te.range)||null,description:Te.description||null,error:Te.error&&D.fromStrict(Te.error)||null}}_e.from=ke;function Q(Te){return{id:f.TestId.fromString(Te.extId).localId,label:Te.label,uri:_.URI.revive(Te.uri),range:a.to(Te.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Te.description||void 0}}_e.toPlain=Q;function W(Te){const tt=f.TestId.fromString(Te.extId),Ge=new d.TestItemImpl(tt.controllerId,tt.localId,Te.label,_.URI.revive(Te.uri));return Ge.range=a.to(Te.range||void 0),Ge.description=Te.description||void 0,Ge}function Fe(Te){let tt;for(const Ge of Te.tests){const ct=W(Ge.item);(0,d.getPrivateApiFor)(ct).parent=tt,tt=ct}return tt}_e.toItemFromContext=Fe})(ut=e.TestItem||(e.TestItem={}));var mt;(function(_e){const ke=(W,Fe)=>{const Te={...ut.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Je.to)})),children:W.children.map(tt=>Fe.get(tt)).filter(y.isDefined).map(tt=>ke(tt,Fe))};for(const tt of Te.children)tt.parent=Te;return Te};function Q(W){const Fe=[],Te=new Map;for(const tt of W.items)Te.set(tt.item.extId,tt),W.request.targets.some(Ge=>Ge.controllerId===tt.controllerId&&Ge.testIds.includes(tt.item.extId))&&Fe.push(tt);return{completedAt:W.completedAt,results:Fe.map(tt=>ke(tt,Te))}}_e.to=Q})(mt=e.TestResults||(e.TestResults={}));var bt;(function(_e){function ke(Te){return{covered:Te.covered,total:Te.covered}}function Q(Te){return"line"in Te?v.from(Te):a.from(Te)}function W(Te){return"branches"in Te?{count:Te.executionCount,location:Q(Te.location),type:1,branches:Te.branches.length?Te.branches.map(tt=>({count:tt.executionCount,location:tt.location&&Q(tt.location)})):void 0}:{type:0,count:Te.executionCount,location:Q(Te.location)}}_e.fromDetailed=W;function Fe(Te){return{uri:Te.uri,statement:ke(Te.statementCoverage),branch:Te.branchCoverage&&ke(Te.branchCoverage),function:Te.functionCoverage&&ke(Te.functionCoverage),details:Te.detailedCoverage?.map(W)}}_e.fromFile=Fe})(bt=e.TestCoverage||(e.TestCoverage={}));var ot;(function(_e){function ke(Q){switch(Q){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}_e.to=ke})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(_e){function ke(W){const Fe=new w.TypeHierarchyItem(B.to(W.kind),W.name,W.detail||"",_.URI.revive(W.uri),a.to(W.range),a.to(W.selectionRange));return Fe._sessionId=W._sessionId,Fe._itemId=W._itemId,Fe}_e.to=ke;function Q(W,Fe,Te){if(Fe=Fe??W._sessionId,Te=Te??W._itemId,Fe===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Te,kind:B.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:a.from(W.range),selectionRange:a.from(W.selectionRange),tags:W.tags?.map($.from)}}_e.from=Q})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[178],Ee([0,1,2,12,7,9,80]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(C,n,I,l={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,I,l)=>{const u={dispose:this._callbacks.push([n,I,C])};return Array.isArray(l)&&l.push(u),u}}async $participateInSave(C,n){const I=g.URI.revive(C);let l=!1;const d=setTimeout(()=>l=!0,this._thresholds.timeout),u=[];try{for(let f of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(f,{document:b,reason:E.TextDocumentSaveReason.to(n)});u.push(w)}}finally{clearTimeout(d)}return u}_deliverEventAsyncAndBlameBadListeners([C,n,I],l){const d=this._badListeners.get(C);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,n,l).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const f=this._badListeners.get(C);this._badListeners.set(C,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,I,l){const d=[],u=Date.now(),{document:f,reason:b}=l,{version:w}=f,P=Object.freeze({document:f,reason:b,waitUntil(a){if(Object.isFrozen(d))throw(0,R.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(a))}});try{n.apply(I,[P])}catch(a){return Promise.reject(a)}return Object.freeze(d),new Promise((a,h)=>{const v=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),a(t)}).catch(t=>{clearTimeout(v),h(t)})}).then(a=>{const h={edits:[]};for(const v of a)if(Array.isArray(v)&&v.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:s}of v)h.edits.push({_type:2,resource:f.uri,edit:{range:s&&E.Range.from(s),text:t,eol:r&&E.EndOfLine.from(r)}});if(h.edits.length!==0)return w===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(be[179],Ee([0,1,3,27,2,9,7]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(n,I,l,d,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,l&&(this._config+=1),d&&(this._config+=2),u&&(this._config+=4);const f=(0,R.parse)(I),b=n(w=>{if(!l)for(let P of w.created){const a=S.URI.revive(P);f(a.fsPath)&&this._onDidCreate.fire(a)}if(!d)for(let P of w.changed){const a=S.URI.revive(P);f(a.fsPath)&&this._onDidChange.fire(a)}if(!u)for(let P of w.deleted){const a=S.URI.revive(P);f(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(n,I,l){this._logService=I,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,I,l,d){return new y(this._onFileSystemEvent.event,n,I,l,d)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,I){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(l=>S.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(l=>S.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,I){return(l,d,u)=>{const f=function(w){l.call(d,w)};return f.extension=n,I.event(f,void 0,u)}}async $onWillRunFileOperation(n,I,l,d){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(u=>({oldUri:S.URI.revive(u.source),newUri:S.URI.revive(u.target)}))},l,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(u=>S.URI.revive(u.target))},l,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(u=>S.URI.revive(u.target))},l,d)}}async _fireWillEvent(n,I,l,d){const u=new Set,f=[];if(await n.fireAsync(I,d,async(w,P)=>{const a=Date.now(),h=await Promise.resolve(w);h instanceof k.WorkspaceEdit&&(f.push(h),u.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-a>l&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),d.isCancellationRequested||f.length===0)return;const b={edits:[]};for(let w of f){let{edits:P}=E.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(P)}return{edit:b,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=_}),define(be[180],Ee([0,1,11,23,2,9,7,71]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,d,u,f){this.start=l,this.deletedCount=d,this.deletedItems=u,this.items=f}static asApiEvents(l){return l.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(u=>u.apiCell)}))}}class C{constructor(l,d,u){this.notebook=l,this._extHostDocument=d,this._cellData=u,this.handle=u.handle,this.uri=S.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(E.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(l,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return l._mime},set mime(u){l._mime=u},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(E.NotebookCellOutput.to)}setOutputItems(l,d,u){const f=u.map(E.NotebookCellOutputItem.to),b=this._outputs.find(w=>w.id===l);b&&(d||(b.items.length=0),b.items.push(...f))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(E.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=C;class n{constructor(l,d,u,f,b,w){this._proxy=l,this._textDocumentsAndEditors=d,this._textDocuments=u,this._emitter=f,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===g.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(d){return d=l._validateIndex(d),l._cells[d].apiCell},getCells(d){return(d?l._getCells(d):l._cells).map(f=>f.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,d){this._versionId=l.versionId,this._isDirty=d;for(const u of l.rawEvents)u.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===y.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let d=l.start|0,u=l.end|0;return d<0&&(d=0),u>this._cells.length&&(u=this._cells.length),l.with({start:d,end:u})}_getCells(l){l=this._validateRange(l);const d=[];for(let u=l.start;u<l.end;u++)d.push(this._cells[u]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,d){if(this._disposed)return;const u=[],f=[],b=[];l.reverse().forEach(w=>{const a=w[2].map(t=>{const r=new C(this,this._textDocumentsAndEditors,t);return d||f.push(C.asModelAddData(this.apiNotebook,t)),r}),h=new _(w[0],w[1],[],a),v=this._cells.splice(w[0],w[1],...a);for(const t of v)b.push(t.uri),h.deletedItems.push(t.apiCell);u.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:b}),d||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(u)}))}_moveCell(l,d){const u=this._cells.splice(l,1);this._cells.splice(d,0,...u);const f=[new _(l,1,u.map(b=>b.apiCell),[]),new _(d,0,[],u)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(f)}))}_setCellOutputs(l,d){const u=this._cells[l];u.setOutputs(d),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(l,d,u,f){const b=this._cells[l];b.setOutputItems(d,u,f),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(l,d){const u=this._cells[l];u.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(u.uri,d)}_changeCellMime(l,d){const u=this._cells[l];u.apiCell.mime=d}_changeCellMetadata(l,d){const u=this._cells[l],f=u.apiCell.metadata;u.setMetadata(d);const b=u.apiCell.metadata;(0,R.equals)(f,b)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(l,d){const u=this._cells[l],f=u.internalMetadata;if(u.setInternalMetadata(d),f.runState!==d.runState){const b=d.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(d=>d.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(d=>d.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[101],Ee([0,1,7,9,12]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class E{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,n){this._throwIfFinalized(),!(_===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:n.map(R.NotebookCellData.from)})}}class k{constructor(_,C,n,I,l,d){this.id=_,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=d}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(g.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,n){_._proxy.$tryRevealRange(_.id,R.NotebookRange.from(C),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const n=new E(this.document.version);return C(n),_._applyEdit(n.finalize())},setDecorations(C,n){return _.setDecorations(C,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(R.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let I=0;I<_.cellEdits.length;I++){if(n<0){C.push(_.cellEdits[I]),n++;continue}const d=C[n],u=_.cellEdits[I];if(d.editType===1&&u.editType===1&&d.index===u.index){d.cells.push(..._.cellEdits[I].cells),d.count+=_.cellEdits[I].count;continue}C.push(_.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(be[181],Ee([0,1,9,156,135,20,51]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,d){const u=this._handles++,{title:f,location:b,cancellable:w}=l,P={label:(0,S.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(u,{location:g.ProgressLocation.from(b),title:f,source:P,cancellable:w},I),this._withProgress(u,d,!!w)}_withProgress(I,l,d){let u;d&&(u=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,u));const f=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let b;try{b=l(new C(this._proxy,I),d&&u?u.token:E.CancellationToken.None)}catch(w){throw f(I),w}return b.then(w=>f(I),w=>f(I)),b}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=y;function _(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class C extends R.Progress{constructor(I,l){super(d=>this.throttledReport(d));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}ze([(0,k.throttle)(100,(n,I)=>_(n,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(be[102],Ee([0,1,41,12,53,9,7]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(l,d,u){const f=y._Keys.nextId();l.$registerTextEditorDecorationType(d.identifier,f,E.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:f,dispose(){l.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=y,y._Keys=new S.IdGenerator("TextEditorDecorationType");class _{constructor(l,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,d){this._throwIfFinalized();let u=null;if(l instanceof k.Position)u=new k.Range(l,l);else if(l instanceof k.Range)u=l;else throw new Error("Unrecognized location");this._pushEdit(u,d,!1)}insert(l,d){this._throwIfFinalized(),this._pushEdit(new k.Range(l,l),d,!0)}delete(l){this._throwIfFinalized();let d=null;if(l instanceof k.Range)d=l;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(l,d,u){const f=this._document.validateRange(l);this._collectedEdits.push({range:f,text:d,forceMoveMarkers:u})}setEndOfLine(l){if(this._throwIfFinalized(),l!==k.EndOfLine.LF&&l!==k.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class C{constructor(l,d,u,f){this._proxy=l,this._id=d,this._accept(u),this._logService=f;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(w){b._setTabSize(w)},get insertSpaces(){return b._insertSpaces},set insertSpaces(w){b._setInsertSpaces(w)},get cursorStyle(){return b._cursorStyle},set cursorStyle(w){b._setCursorStyle(w)},get lineNumbers(){return b._lineNumbers},set lineNumbers(w){b._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const d=Math.floor(l);return d>0?d:null}if(typeof l=="string"){const d=parseInt(l,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(l){const d=this._validateTabSize(l);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const d=this._validateInsertSpaces(l);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(l)})))}assign(l){const d={};let u=!1;if(typeof l.tabSize!="undefined"){const f=this._validateTabSize(l.tabSize);f==="auto"?(u=!0,d.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,u=!0,d.tabSize=f)}if(typeof l.insertSpaces!="undefined"){const f=this._validateInsertSpaces(l.insertSpaces);f==="auto"?(u=!0,d.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,u=!0,d.insertSpaces=f)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,u=!0,d.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,u=!0,d.lineNumbers=E.TextEditorLineNumbersStyle.from(l.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(l){l.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=C;class n{constructor(l,d,u,f,b,w,P,a){this.id=l,this._proxy=d,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new C(this._proxy,this.id,w,u),this._visibleRanges=P,this._viewColumn=a;const h=this;this.value=Object.freeze({get document(){return f.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(v){if(!(v instanceof k.Selection))throw(0,R.illegalArgument)("selection");h._selections=[v],h._trySetSelection()},get selections(){return h._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof k.Selection)))throw(0,R.illegalArgument)("selections");h._selections=v,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return h._options.value},set options(v){h._disposed||h._options.assign(v)},get viewColumn(){return h._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new _(f.getValue(),t);return v(r),h._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(i=>E.Range.from(i));else if(t instanceof k.Position){const{lineNumber:i,column:c}=E.Position.from(t);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof k.Range)s=[E.Range.from(t)];else{s=[];for(const i of t)if(i instanceof k.Range)s.push(E.Range.from(i));else{const{lineNumber:c,column:m}=E.Position.from(i);s.push({startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:m})}}return d.$tryInsertSnippet(l,v.value,s,r)},setDecorations(v,t){const r=t.length===0;r&&!h._hasDecorationsForKey.has(v.key)||(r?h._hasDecorationsForKey.delete(v.key):h._hasDecorationsForKey.add(v.key),h._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return d.$trySetDecorations(l,v.key,E.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const m=t[i];s[4*i]=m.start.line+1,s[4*i+1]=m.start.character+1,s[4*i+2]=m.end.line+1,s[4*i+3]=m.end.character+1}return d.$trySetDecorationsFast(l,v.key,s)}}))},revealRange(v,t){h._runOnProxy(()=>d.$tryRevealRange(l,E.Range.from(v),t||k.TextEditorRevealType.Default))},show(v){d.$tryShowEditor(l,E.ViewColumn.from(v))},hide(){d.$tryHideEditor(l)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,g.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,g.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,g.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,g.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const d=l.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const u=d.edits.map(b=>b.range);u.sort((b,w)=>b.end.line===w.end.line?b.end.character===w.end.character?b.start.line===w.start.line?b.start.character-w.start.character:b.start.line-w.start.line:b.end.character-w.end.character:b.end.line-w.end.line);for(let b=0,w=u.length-1;b<w;b++){const P=u[b].end;if(u[b+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=d.edits.map(b=>({range:E.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,f,{setEndOfLine:typeof d.setEndOfLine=="number"?E.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=n}),define(be[182],Ee([0,1,138,25,2,3,6,171,15,7,10,17,9,20,168]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(P,a){if((0,n.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let h;return Array.isArray(P.highlights)&&(h=P.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),h=h.length?h:void 0),{label:P.label,highlights:h}}}class b{constructor(a,h,v){this._proxy=a,this.commands=h,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}h.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,h,v){const t=this.createTreeView(a,{treeDataProvider:h},v);return{dispose:()=>t.dispose()}}createTreeView(a,h,v){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=h.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(a,h,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,c)=>s.reveal(i,c),dispose:async()=>{await r,this.treeViews.delete(a),s.dispose()}}}$getChildren(a,h){const v=this.treeViews.get(a);return v?v.getChildren(h):Promise.reject(new Error((0,g.localize)(0,null,a)))}async $onDrop(a,h,v){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,a)));const r=u.TreeDataTransferConverter.toITreeDataTransfer(h);if(r.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?r.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(a){const h=this.treeViews.get(a);if(!h)throw new Error((0,g.localize)(2,null,a));return h.hasResolve}$resolve(a,h,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(3,null,a));return t.resolveTreeItem(h,v)}$setExpanded(a,h,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(4,null,a));t.setExpanded(h,v)}$setSelection(a,h){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(5,null,a));v.setSelection(h)}$setVisible(a,h){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(6,null,a));v.setVisible(h)}createExtHostTreeView(a,h,v){const t=new w(a,h,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(a,t),t}convertArgument(a){const h=this.treeViews.get(a.$treeViewId);return h?h.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=b;class w extends k.Disposable{constructor(a,h,v,t,r,s){super();if(this.viewId=a,this.proxy=v,this.commands=t,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,s.contributes&&s.contributes.views)for(const m in s.contributes.views)for(const p of s.contributes.views[m])p.id===a&&(this._title=p.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(m=>this._onDidChangeData.fire({message:!1,element:m}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let i,c;this._register(E.Event.debounce(this._onDidChangeData.event,(m,p)=>(m||(m={message:!1,elements:[]}),p.element!==!1&&(i||(i=new Promise(D=>c=D),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(p.element)?m.elements.push(...p.element):m.elements.push(p.element)),p.message&&(m.message=!0),m),200,!0)(({message:m,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=c;return i=null,this.refresh(p).then(()=>D())})),m&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}getChildren(a){const h=a?this.getExtensionElement(a):void 0;if(a&&!h)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(a);return(v?Promise.resolve(v):this.fetchChildrenNodes(h)).then(t=>t.map(r=>r.item))}getExtensionElement(a){return this.elements.get(a)}reveal(a,h){h=h||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(h.select)?!0:h.select,t=(0,n.isUndefinedOrNull)(h.focus)?!1:h.focus,r=(0,n.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(c=>c.item)},{select:v,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,h){const v=this.getExtensionElement(a);v&&(h?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,h){const v=this.getExtensionElement(h);if(!!v)return(0,_.asPromise)(()=>this.dndController?.onDrop(a,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,h){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(a);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,h)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(h=>h?this.resolveUnknownParentChain(h).then(v=>this.resolveTreeNode(h,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(a){const h=this.nodes.get(a);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,h){const v=this.nodes.get(a);return v?Promise.resolve(v):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,h,!0)).then(t=>this.getChildren(h?h.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let h;if(typeof a=="string"){const v=this.getExtensionElement(a);h=v?this.nodes.get(v):void 0}else h=a;return h&&h.children||null}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const h=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(h.token.isCancellationRequested)return[];const r=await Promise.all((0,I.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,v):null}));return h.token.isCancellationRequested?[]:(0,I.coalesce)(r)}finally{h.dispose()}}refresh(a){if(a.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(a);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const h=new Set,v=a.map(r=>this.nodes.get(r));for(const r of v)if(r&&!h.has(r.item.handle)){let s=r;for(;s&&s.parent&&v.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&h.add(r.item.handle)}const t=[];return h.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!h.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(a){const h={};return Promise.all(a.map(v=>this.refreshNode(v).then(t=>{t&&(h[v]=t.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(a){const h=this.getExtensionElement(a);if(h){const v=this.nodes.get(h);if(v)return this.clearChildren(h),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(t=>{if(t){const r=this.createTreeNode(h,t,v.parent);return this.updateNodeCache(h,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,h,v){const t=this.createTreeNode(a,h,v);if(h.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,h.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,v),t}getTooltip(a){return C.MarkdownString.isMarkdownString(a)?l.MarkdownString.from(a):a}getCommand(a,h){return h?this.commands.toInternal(h,a):void 0}createTreeNode(a,h,v){const t=new k.DisposableStore,r=this.createHandle(a,h,v),s=this.getLightIconPath(h);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:f(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(t,h.command),contextValue:h.contextValue,icon:s,iconDark:this.getDarkIconPath(h)||s,themeIcon:this.getThemeIcon(h),collapsibleState:(0,n.isUndefinedOrNull)(h.collapsibleState)?C.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof C.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:h,label:v,resourceUri:t},r,s){if(h)return`${w.ID_HANDLE_PREFIX}/${h}`;const i=f(v,this.extension),c=r?r.item.handle:w.LABEL_HANDLE_PREFIX;let m=i?i.label:t?(0,R.basename)(t):"";m=m.indexOf("/")!==-1?m.replace("/","//"):m;const p=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,D=this.getChildrenNodes(r)||[];let T,o=0;do{if(T=`${c}/${o}:${m}`,s||!this.elements.has(T)||p===T)break;o++}while(o<=D.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon))return typeof a.iconPath=="string"||S.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return S.URI.isUri(a)?a:S.URI.file(a)}addNodeToCache(a,h){this.elements.set(h.item.handle,a),this.nodes.set(a,h)}updateNodeCache(a,h,v,t){this.elements.delete(h.item.handle),this.nodes.delete(a),h.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(a,h);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===v.item.handle)[0];s&&r.splice(r.indexOf(s),1,h)}addNodeToParentCache(a,h){h?(h.children||(h.children=[]),h.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const h=this.nodes.get(a);if(h){if(h.children)for(const v of h.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}h.children=void 0}}else this.clearAll()}clear(a){const h=this.nodes.get(a);if(h){if(h.children)for(const v of h.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(be[183],Ee([0,1,15,3,6,10,67,9,99,72]),function(te,e,g,R,S,E,k,y,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends S.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const d=this.diff[this.diff.length-1];if(d&&l[0]===1){if(d[0]===1&&d[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(d[1],l[1]);return}if(d[0]===0&&d[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(d[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,d){const u=this.tree.get(l);if(!!u){if((u.expandLevels===void 0||d>u.expandLevels)&&(u.expandLevels=d),u.expand===1){const f=this.resolveChildren(u);return f.isOpen()?this.expandChildren(u,d-1):f.wait().then(()=>this.expandChildren(u,d-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,d-1)):this.expandChildren(u,d-1)}}dispose(){for(const l of this.tree.values())(0,k.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,d){switch(d.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(C.TestId.joinToString(l.fullId,d.id));break;case 0:this.upsertItem(d.item,l);break;case 4:for(const w of d.ops)this.onTestItemEvent(l,w);break;case 3:const{key:u,value:f}=d,b=l.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(l);break;case"range":this.pushDiff([1,{extId:b,item:{range:y.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:y.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:f??null}}]);break}break;default:(0,E.assertNever)(d)}}upsertItem(l,d){if(!(l instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const u=C.TestId.fromExtHostTestItem(l,this.root.id,d?.actual),f=(0,k.getPrivateApiFor)(l);f.parent&&f.parent!==d?.actual&&f.parent.children.delete(l.id);let b=this.tree.get(u.toString());if(!b){b={fullId:u,actual:l,parent:d?u.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},this.tree.set(b.fullId.toString(),b),this.setItemParent(l,d),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:y.TestItem.from(l)}]),this.connectItemAndChildren(l,b,d);return}if(b.actual===l){this.connectItem(l,b,d);return}const w=b.actual.children,P=b.actual,a=(0,k.diffTestItems)(P,l);(0,k.getPrivateApiFor)(P).listener=void 0,b.actual=l,b.expand=0;for(const[h,v]of a)this.onTestItemEvent(b,{op:3,key:h,value:v});this.connectItemAndChildren(l,b,d);for(const h of w)l.children.get(h.id)||this.removeItem(C.TestId.joinToString(u,h.id))}setItemParent(l,d){(0,k.getPrivateApiFor)(l).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(l,d,u){this.setItemParent(l,u);const f=(0,k.getPrivateApiFor)(l);f.parent=u?.actual,f.listener=b=>this.onTestItemEvent(d,b),this.updateExpandability(d)}connectItemAndChildren(l,d,u){this.connectItem(l,d,u);for(const f of l.children)this.upsertItem(f,d)}updateExpandability(l){let d;this._resolveHandler?l.resolveBarrier?d=l.resolveBarrier.isOpen()?3:2:d=l.actual.canResolveChildren?1:0:d=0,d!==l.expand&&(l.expand=d,this.pushDiff([1,{extId:l.fullId.toString(),expand:d}]),d===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,d){if(d<0)return;const u=[];for(const f of l.actual.children){const b=this.expand(C.TestId.joinToString(l.fullId,f.id),d);(0,g.isThenable)(b)&&u.push(b)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const f=new g.Barrier;return f.open(),f}l.expand=2,this.pushExpandStateUpdate(l);const d=l.resolveBarrier=new g.Barrier;let u;try{u=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(f){l.actual.error=f.stack||f.message}return(0,g.isThenable)(u)?u.catch(f=>l.actual.error=f.stack||f.message).then(()=>{d.open(),this.updateExpandability(l)}):(d.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const d=this.tree.get(l);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const u=[d];for(;u.length;){const f=u.pop();if(!!f){(0,k.getPrivateApiFor)(f.actual).listener=void 0,this.tree.delete(f.fullId.toString());for(const b of f.actual.children)u.push(this.tree.get(C.TestId.joinToString(f.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(be[184],Ee([0,1,4,151]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(R.IEnvironmentService)}),define(be[185],Ee([0,1,26,3,14]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=E;class k{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(l=>I.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(g.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(d=>d.identifier)),I.length>0){const d=new Set;I.forEach(u=>d.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!d.has(g.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(l)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,w){this.addNode(b),this.addNode(w),this._arcs.has(b)?this._arcs.get(b).push(w):this._arcs.set(b,[w])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,w){const P=I.getArcs(b);for(let a=0;a<P.length;a++)if(!w.has(P[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of n){const w=g.ExtensionIdentifier.toKey(b.identifier);if(l.set(w,b),b.extensionDependencies)for(let P of b.extensionDependencies){const a=g.ExtensionIdentifier.toKey(P);I.addArc(w,a)}}let d=new Set;I.getNodes().filter(b=>I.getArcs(b).length===0).forEach(b=>d.add(b));let u=I.getNodes().filter(b=>!d.has(b)),f;do{f=!1;for(let b=0;b<u.length;b++){const w=u[b];I.hasOnlyGoodArcs(w,d)&&(u.splice(b,1),b--,d.add(w),f=!0)}}while(f);return u.map(b=>l.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=k;var y;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(y||(y={}));function _(C,n){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==l)return I-l;const d=S.posix.basename(C.extensionLocation.path),u=S.posix.basename(n.extensionLocation.path);return d<u?-1:d>u?1:0}}),define(be[186],Ee([0,1,24]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function E(y){const _=g.VSBuffer.alloc(1);switch(y){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=E;function k(y,_){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=k}),define(be[30],Ee([0,1,3,2,4,26,152]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var _;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(P,a,h,v){this.codeLoadingTime=P,this.activateCallTime=a,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=C;class n{constructor(P,a){this.description=P,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||d(w)}e.checkProposedApiEnabled=l;function d(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=d;function u(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=u;function f(w,P){return{identifier:new E.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!P,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=f;class b{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,a){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,a,h,v,t){}_onDidActivateExtensionError(P,a){}_onExtensionRuntimeError(P,a){}_onExtensionHostExit(P){}}e.NullExtensionService=b}),define(be[187],Ee([0,1,26,30,16]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class k{constructor(u,f,b,w){this.startup=u,this.codeLoadingTime=f,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,f){return u===-1||f===-1?-1:f-u}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class _{constructor(u,f,b,w,P,a){this.activationFailed=u,this.activationFailedError=f,this.activationTimes=b,this.module=w,this.exports=P,this.subscriptions=a}}e.ActivatedExtension=_;class C extends _{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends _{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends _{constructor(u){super(!0,u,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(u,f,b,w,P){this._logService=P,this._registry=u,this._resolvedExtensionsSet=new Set,f.forEach(a=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,b.forEach(a=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(a),a)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const f=g.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(f)}getActivatedExtension(u){const f=g.ExtensionIdentifier.toKey(u),b=this._activatedExtensions.get(f);if(!b)throw new Error("Extension `"+u.value+"` is not known or not activated");return b}activateByEvent(u,f){if(this._alreadyActivatedEvents[u])return E;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:f,extensionId:w.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,f){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:b.identifier,reason:f}])}_handleActivateRequest(u,f,b){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(u.id))){f[g.ExtensionIdentifier.toKey(u.id)]=u;return}const w=this._registry.getExtensionDescription(u.id);if(!w){const h=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,h,new R.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(u.id),new I(h));return}const P=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let a=!0;for(let h=0,v=P.length;h<v;h++){const t=P[h];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const m=w.displayName||w.identifier.value,p=this._registry.getExtensionDescription(t),D=p&&p.displayName||t,T=new Error(`Cannot activate the '${m}' extension because its dependency '${D}' failed to activate`);T.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,T,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(T));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){a=!1,f[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){a=!1,f[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:u.reason};continue}const i=w.displayName||w.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,c,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(c));return}a?f[g.ExtensionIdentifier.toKey(w.identifier)]=u:b.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),u.length===0))return Promise.resolve(void 0);const f=Object.create(null),b=[];for(let P=0,a=u.length;P<a;P++)this._handleActivateRequest(u[P],f,b);for(let P=0,a=b.length;P<a;P++){const h=g.ExtensionIdentifier.toKey(b[P].id);f[h]&&delete f[h]}const w=Object.keys(f).map(P=>f[P]);return b.length===0?Promise.all(w.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(w).then(P=>this._activateExtensions(b))}_activateExtension(u,f){const b=g.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const w=this._activatingExtensions.get(b);if(w)return w;const P=this._host.actualActivateExtension(u,f).then(void 0,a=>{const h=new Error;return a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${u.value}' failed: ${a.message}.`:h.message=`Activating extension '${u.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this._host.onExtensionActivationError(u,h,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(b,a),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,P),P}};l=ze([Ve(4,S.ILogService)],l),e.ExtensionsActivator=l}),define(be[188],Ee([0,1,12]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,k)=>{this._actualOk=E,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):(0,g.onUnexpectedError)(E))}then(E,k){return this._ensureActual().then(E,k)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=R}),define(be[103],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,C){this._proxyIdentifierBrand=void 0,this.isMain=_,this.sid=C,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const R=[];function S(y){const _=new g(!0,y);return R[_.nid]=_,_}e.createMainContextProxyIdentifier=S;function E(y){const _=new g(!1,y);return R[_.nid]=_,_}e.createExtHostContextProxyIdentifier=E;function k(y){return R[y].sid}e.getStringIdentifierForProxy=k}),define(be[5],Ee([0,1,56,2,103]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var k;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function h(t,r){return Object.defineProperty(t,a.name,{value:r,enumerable:!0}),t}a.mixin=h;function v(t){return t[a.name]}a.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(h){return h._id=d._n++,h}}e.IdObject=d,d._n=0;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(a){if(a&&a.edits)for(const h of a.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,g.revive)(h.metadata));return a}e.reviveWorkspaceEditDto=w;var P;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[73],Ee([0,1,5,3,4]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(y){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,_){return this._proxy.$getPassword(y,_)}store(y,_,C){return this._proxy.$setPassword(y,_,C)}delete(y,_){return this._proxy.$deletePassword(y,_)}}e.ExtHostSecretState=E,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(be[74],Ee([0,1,4,16,5,13]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(S.MainContext.MainThreadTelemetry)}report(_,C,n){const I=this.getUsageKey(_,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};k=ze([Ve(0,E.IExtHostRpcService),Ve(1,R.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(y,_,C){}})}),define(be[189],Ee([0,1,3,5,7,26]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,C,n,I={}){const l=E.ExtensionIdentifier.toKey(_.identifier),d=this._inFlightRequests.get(l)||[],u=[...n].sort().join(" ");let f=d.find(b=>b.scopes===u);if(f)return f.result;{const b=this._getSession(_,l,C,n,I);f={scopes:u,result:b},d.push(f),this._inFlightRequests.set(l,d);try{await b}finally{const w=d.findIndex(P=>P.scopes===u);w>-1&&(d.splice(w),this._inFlightRequests.set(l,d))}return b}}async _getSession(_,C,n,I,l={}){await this._proxy.$ensureProvider(n);const d=_.displayName||_.name;return this._proxy.$getSession(n,I,C,d,l)}async removeSession(_,C){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,n,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===_)||this._providers.push({id:_,label:C});const l=n.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(_,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,C,I?.supportsMultipleAccounts??!1),new S.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const d=this._providers.findIndex(u=>u.id===_);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(be[190],Ee([0,1,5,13,9]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(y,_){this._extHostDocumentsAndEditors=_,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const _=S.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};E=ze([Ve(0,R.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(be[191],Ee([0,1,5]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(E){const k=E.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(y){return k.$writeText(y)}})}}e.ExtHostClipboard=R}),define(be[75],Ee([0,1,10,7,9,23,5,17,16,56,31,38,2,6,4,13]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return i?.result===a.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,C.revive)(s)}},{processArgument(s){return(0,E.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(I.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((m,p)=>{if(!m.validate(s[p]))throw new Error(`Invalid argument '${m.name}' when running '${t.id}', received: ${s[p]}`);return m.convert(s[p])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:c}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,E.cloneAndChange)(r,function(c){if(c instanceof R.Position)return S.Position.from(c);if(c instanceof R.Range)return S.Range.from(c);if(c instanceof R.Location)return S.location.from(c);if(R.NotebookRange.isNotebookRange(c))return S.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,s);return(0,C.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:c,description:m}=s;if(m)for(let p=0;p<m.args.length;p++)try{(0,g.validateConstraint)(r[p],m.args[p].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${m.args[p].name}' - ${m.args[p].description}`)}try{return await i.apply(c,r)}catch(p){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};b=ze([Ve(0,f.IExtHostRpcService),Ve(1,_.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class w{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((c,m)=>c.convert(t.arguments&&t.arguments[m]));else if((0,y.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,d.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),s.$ident=c,s.id=this.delegatingCommandId,s.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return s}fromInternal(t){const r=k.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class P{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v),P.Position=new P("position","A position in a text document",v=>R.Position.isPosition(v),S.Position.from),P.Range=new P("range","A range in a text document",v=>R.Range.isRange(v),S.Range.from),P.Selection=new P("selection","A selection in a text document",v=>R.Selection.isSelection(v),S.Selection.from),P.Number=new P("number","",v=>typeof v=="number",v=>v),P.String=new P("string","",v=>typeof v=="string",v=>v),P.CallHierarchyItem=new P("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,S.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",v=>v instanceof R.TypeHierarchyItem,S.TypeHierarchyItem.from);class a{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",v=>v);class h{constructor(t,r,s,i,c){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=c}}e.ApiCommand=h}),define(be[192],Ee([0,1,9,7,60,75,17,89]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,d)=>{if((0,k.isFalsyOrEmpty)(l))return;class u extends R.SymbolInformation{static to(b){const w=new u(b.name,g.SymbolKind.to(b.kind),b.containerName||"",new R.Location(d[0],g.Range.to(b.range)));return w.detail=b.detail,w.range=w.location.range,w.selectionRange=g.Range.to(b.selectionRange),w.children=b.children?b.children.map(u.to):[],w}}return l.map(u.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(d=>R.Position.isPosition(d)),l=>l.map(g.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(d=>{let u;for(const f of d.reverse())u=new R.SelectionRange(g.Range.to(f),u);return u}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const d=[];if(Array.isArray(l))for(let u of l)d.push(...u[1].map(g.WorkspaceSymbol.to));return d})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return g.WorkspaceEdit.to(l)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(g.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,y.decodeSemanticTokensDto)(l);if(d.type==="full")return new R.SemanticTokens(d.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,y.decodeSemanticTokensDto)(l);if(d.type==="full")return new R.SemanticTokens(d.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,d,u)=>{if(!l)return new R.CompletionList([]);const f=l.suggestions.map(b=>g.CompletionItem.to(b,u));return new R.CompletionList(f,l.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return g.SignatureHelp.to(l)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,d,u)=>n(f=>new R.CodeLens(g.Range.to(f.range),f.command&&u.fromInternal(f.command)))(l))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?g.Selection.from(l):g.Range.from(l)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,d,u)=>n(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(f.command)}else{const b=new R.CodeAction(f.title,f.kind?new R.CodeActionKind(f.kind):void 0);return f.edit&&(b.edit=g.WorkspaceEdit.to(f.edit)),f.command&&(b.command=u.fromInternal(f.command)),b.isPreferred=f.isPreferred,b}})(l))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(d=>new R.ColorInformation(g.Range.to(d.range),g.Color.to(d.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,g.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:g.Range.from(l.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(g.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(g.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(d=>g.NotebookExclusiveDocumentPattern.to(d))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(g.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to)))];class C{static register(d){_.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=C;function n(l){return d=>{if(Array.isArray(d))return d.map(l)}}function I(l){if(!Array.isArray(l))return;const d=[];for(const u of l)S.isLocationLink(u)?d.push(g.DefinitionLink.to(u)):d.push(g.location.to(u));return d}}),define(be[193],Ee([0,1,15,51,3,6,2,60,26,9,7,5]),function(te,e,g,R,S,E,k,y,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(d,u,f){const b=d.getProxy(I.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const m=c.getCommentThread(i.commentThreadHandle);return m||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const m=c.getCommentThread(i.thread.commentThreadHandle);return m?{thread:m,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const m=c.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let p=i.commentUniqueId,D=m.getCommentByUniqueId(p);return D||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const m=c.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let p=i.text,D=i.commentUniqueId,T=m.getCommentByUniqueId(D);return T?(T.body=p,T):i}return i}})}createCommentController(i,c,m){const p=w.handlePool++,D=new a(i,p,c,m);this._commentControllers.set(D.handle,D);const T=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(i.identifier))||[];return T.push(D),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(i.identifier),T),D.value}$createCommentThreadTemplate(i,c,m){const p=this._commentControllers.get(i);!p||p.$createCommentThreadTemplate(c,m)}async $updateCommentThreadTemplate(i,c,m){const p=this._commentControllers.get(i);!p||p.$updateCommentThreadTemplate(c,m)}$deleteCommentThread(i,c){const m=this._commentControllers.get(i);m&&m.$deleteCommentThread(c)}$provideCommentingRanges(i,c,m){const p=this._commentControllers.get(i);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const D=f.getDocument(k.URI.revive(c));return(0,g.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(D,m)).then(T=>T?T.map(o=>C.Range.from(o)):void 0)}$toggleReaction(i,c,m,p,D){const T=this._commentControllers.get(i);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const o=T.getCommentThread(c);if(o){const A=o.getCommentByUniqueId(p.uniqueIdInThread);if(T!==void 0&&A&&T.reactionHandler)return T.reactionHandler(A,t(D))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class P{constructor(i,c,m,p,D,T,o){this._commentControllerHandle=c,this._id=m,this._uri=p,this._range=D,this._comments=T,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),b.$createCommentThread(c,this.handle,this._id,this._uri,C.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{b.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(F){A.range=F},get comments(){return A.comments},set comments(F){A.comments=F},get collapsibleState(){return A.collapsibleState},set collapsibleState(F){A.collapsibleState=F},get canReply(){return A.canReply},set canReply(F){A.canReply=F},get contextValue(){return A.contextValue},set contextValue(F){A.contextValue=F},get label(){return A.label},set label(F){A.label=F},dispose:()=>{A.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const i=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),c={};i("range")&&(c.range=C.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(m=>h(this,m,this._commentsMap))),i("collapsibleState")&&(c.collapseState=r(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},b.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let m=c[0],p=c[1];if(i===p)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}P._handlePool=0,ze([(0,R.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,c,m,p){this._extension=i,this._handle=c,this._id=m,this._label=p,this._threads=new Map,b.$registerCommentController(this.handle,m,p);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(T){D.options=T},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(T){D.commentingRangeProvider=T},get reactionHandler(){return D.reactionHandler},set reactionHandler(T){D.reactionHandler=T},createCommentThread(T,o,A){return D.createCommentThread(T,o,A).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{b.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,b.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,b.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,m,p){if(typeof i=="string"){const D=new P(this.id,this.handle,i,c,m,p,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new P(this.id,this.handle,void 0,i,c,m,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(i,c){const m=new P(this.id,this.handle,void 0,k.URI.revive(i),C.Range.to(c),[],this._extension.identifier);return m.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(i,c){let m=this._threads.get(i);m&&(m.range=C.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function h(s,i,c){let m=c.get(i);m||(m=++s.commentHandle,c.set(i,m));const p=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:m,body:C.MarkdownString.from(i.body),userName:i.author.name,userIconPath:p,label:i.label,commentReactions:i.reactions?i.reactions.map(D=>v(D)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?C.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?k.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(be[104],Ee([0,1,2,5,7,4,13,16,17,8,14]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(d,u){this._logService=u,this._provider=new Map,this._proxy=d.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,u){const f=wn._handlePool++;this._provider.set(f,{provider:d,extensionId:u}),this._proxy.$registerDecorationProvider(f,u.value);const b=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(f,null);return}let P=(0,_.asArray)(w);if(P.length<=wn._maxEventSize){this._proxy.$onDidChange(f,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,P.length);const a=P.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),h=(0,_.groupBy)(a,(t,r)=>t.rank-r.rank||(0,C.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of h){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,v.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(f,v)});return new S.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(d,u,f){if(!this._provider.has(d))return Object.create(null);const b=Object.create(null),{provider:w,extensionId:P}=this._provider.get(d);return await Promise.all(u.map(async a=>{try{const{uri:h,id:v}=a,t=await Promise.resolve(w.provideFileDecoration(g.URI.revive(h),f));if(!t)return;try{S.FileDecoration.validate(t),b[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(h){this._logService.error(h)}})),b}};I._handlePool=0,I._maxEventSize=250,I=ze([Ve(0,k.IExtHostRpcService),Ve(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,E.createDecorator)("IExtHostDecorations")}),define(be[194],Ee([0,1,133,92,2,5,7,9,3,16,21]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(u,f,b,w,P){this._name=u,this._owner=f,this._maxDiagnosticsPerFile=b,this._proxy=w,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,f){if(!u){this.clear();return}this._checkDisposed();let b=[];if(S.URI.isUri(u)){if(!f){this.delete(u);return}this._data.set(u,f.slice()),b=[u]}else if(Array.isArray(u)){b=[];let P;u=[...u].sort(I._compareIndexedTuplesByUri);for(const a of u){const[h,v]=a;if((!P||h.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=h,b.push(h),this._data.set(h,[])),v){const t=this._data.get(h);t&&t.push(...v)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const w=[];for(let P of b){let a=[];const h=this._data.get(P);if(h)if(h.length>this._maxDiagnosticsPerFile){a=[];const v=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of h)if(r.severity===v[t]&&a.push(y.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;a.push({severity:R.MarkerSeverity.Info,message:(0,g.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=h.map(v=>y.Diagnostic.from(v));w.push([P,a])}this._proxy.$changeMany(this._owner,w)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,f){this._checkDisposed();for(let b of this._data.keys())u.apply(f,[b,this.get(b),this])}get(u){this._checkDisposed();const f=this._data.get(u);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,f){return u[0].toString()<f[0].toString()?-1:u[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class Qt{constructor(u,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=u.getProxy(E.MainContext.MainThreadDiagnostics)}static _mapper(u){const f=new n.ResourceMap;for(const b of u)f.set(b,b);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(u,f){const{_collections:b,_proxy:w,_onDidChangeDiagnostics:P,_logService:a}=this,h=new class{$changeMany(r,s){w.$changeMany(r,s),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,r,s.length===0?"CLEARING":s)}$clear(r){w.$clear(r),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,r)}dispose(){w.dispose()}};let v;if(!f)f="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=f;else if(!b.has(f))v=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do v=f+Qt._idPool++;while(b.has(v))}return new class extends I{constructor(){super(f,v,Qt._maxDiagnosticsPerFile,h,P);b.set(v,this)}dispose(){super.dispose(),b.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const f=new Map,b=[];for(const w of this._collections.values())w.forEach((P,a)=>{let h=f.get(P.toString());typeof h=="undefined"&&(h=b.length,f.set(P.toString(),h),b.push([P,[]])),b[h][1]=b[h][1].concat(...a)});return b}}_getDiagnostics(u){let f=[];for(let b of this._collections.values())b.has(u)&&(f=f.concat(b.get(u)));return f}$acceptMarkersChange(u){if(!this._mirrorCollection){const f="_generated_mirror",b=new I(f,f,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,b),this._mirrorCollection=b}for(const[f,b]of u)this._mirrorCollection.set(S.URI.revive(f),b.map(y.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([Ve(1,C.ILogService)],l),e.ExtHostDiagnostics=l}),define(be[195],Ee([0,1,2,5]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(k){this._proxy=k.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(y=>y?y.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=S}),define(be[196],Ee([0,1,12,2,7,5,11,20,8]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,l,d){this._documentsAndEditors=l,this._logService=d,this._documentContentProviders=new Map,this._proxy=I.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const d=C._handlePool++;this._documentContentProviders.set(d,l),this._proxy.$registerTextContentProvider(d,I);let u;return typeof l.onDidChange=="function"&&(u=l.onDidChange(f=>{if(f.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(d,f).then(b=>{if(!b&&typeof b!="string")return;const w=this._documentsAndEditors.getDocument(f);if(!w)return;const P=(0,_.splitLines)(b);if(!w.equalLines(P))return this._proxy.$onVirtualDocumentChange(f,b)},g.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(I,l){const d=this._documentContentProviders.get(I);return d?Promise.resolve(d.provideTextDocumentContent(R.URI.revive(l),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(be[197],Ee([0,1,3,6,2,5,98,9,10,23,7]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(d,u){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(f=>{for(const b of f)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(f=>{for(const b of f)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const u=this._documentsAndEditors.getDocument(d);if(u)return u}getDocument(d){const u=this.getDocumentData(d);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return u.document}ensureDocumentData(d){const u=this._documentsAndEditors.getDocument(d);if(u)return Promise.resolve(u);let f=this._documentLoader.get(d.toString());return f||(f=this._proxy.$tryOpenDocument(d).then(b=>{this._documentLoader.delete(d.toString());const w=S.URI.revive(b);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(w))},b=>(this._documentLoader.delete(d.toString()),Promise.reject(b))),this._documentLoader.set(d.toString(),f)),f}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(u=>S.URI.revive(u))}$acceptModelModeChanged(d,u){const f=S.URI.revive(d),b=this._documentsAndEditors.getDocument(f);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(u),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(d){const u=S.URI.revive(d),f=this._documentsAndEditors.getDocument(u);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(f.document)}$acceptDirtyStateChanged(d,u){const f=S.URI.revive(d),b=this._documentsAndEditors.getDocument(f);if(!b)throw new Error("unknown document");b._acceptIsDirty(u),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,u,f){const b=S.URI.revive(d),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");w._acceptIsDirty(f),w.onEvents(u);let P;u.isUndoing?P=n.TextDocumentChangeReason.Undo:u.isRedoing&&(P=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:w.document,contentChanges:u.changes.map(a=>({range:y.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:P}))}setWordDefinitionFor(d,u){(0,k.setWordDefinitionFor)(d,u)}}e.ExtHostDocuments=I}),define(be[48],Ee([0,1,41,3,6,2,4,5,98,13,102,9,16,21,11,54,112]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(h,v){this._extHostRpc=h,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const v=[],t=[],r=[];if(h.removedDocuments)for(const s of h.removedDocuments){const i=E.URI.revive(s),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const i=E.URI.revive(s.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new w(new _.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(h.removedEditors)for(const s of h.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(h.addedEditors)for(const s of h.addedEditors){const i=E.URI.revive(s.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(i).value,m=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>c.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(p=>I.Range.to(p)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,m)}h.newActiveEditor!==void 0&&(g.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,S.dispose)(v),(0,S.dispose)(r),h.removedDocuments&&this._onDidRemoveDocuments.fire(v),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return h?v:v?.value}allEditors(){return[...this._editors.values()]}};P=ze([Ve(0,C.IExtHostRpcService),Ve(1,l.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[198],Ee([0,1,2,5,6,7,9,122,8,24]),function(te,e,g,R,S,E,k,y,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const u=this._schemes.indexOf(d);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),u=[];let f,b,w=14,P=14;for(const a of d){let h=f?(0,_.commonPrefixLength)(f,a):0;for(h===0?b=1:b=P;h<a.length;h++)h+1===a.length?(w=P,P=9):P+=1,u.push([b,a.toUpperCase().charCodeAt(h),P]),u.push([b,a.toLowerCase().charCodeAt(h),P]),b=P;f=a,P=w}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new y.StateMachine(u)}}provideDocumentLinks(d){this._initStateMachine();const u=[],f=y.LinkComputer.computeLinks({getLineContent(b){return d.lineAt(b-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const b of f){const w=k.DocumentLink.to(b);w.target&&u.push(w)}return u}}class I{constructor(d,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,u,f,b={},w){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(P,f),this._enableProposedApi.set(P,w??!1);let a=2;b.isCaseSensitive&&(a+=1024),b.isReadonly&&(a+=2048),typeof f.copy=="function"&&(a+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(P,u,a).catch(v=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${u}`),console.error(v)});const h=f.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:s,type:i}=r;if(s.scheme!==u)continue;let c;switch(i){case E.FileChangeType.Changed:c=0;break;case E.FileChangeType.Created:c=1;break;case E.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:c})}this._proxy.$onFileSystemChange(P,t)});return(0,S.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(d,u){const{type:f,ctime:b,mtime:w,size:P,permissions:a}=d;return u?{type:f,ctime:b,mtime:w,size:P,permissions:a}:{type:f,ctime:b,mtime:w,size:P}}$stat(d,u){return Promise.resolve(this._getFsProvider(d).stat(g.URI.revive(u))).then(f=>I._asIStat(f,this._enableProposedApi.get(d)??!1))}$readdir(d,u){return Promise.resolve(this._getFsProvider(d).readDirectory(g.URI.revive(u)))}$readFile(d,u){return Promise.resolve(this._getFsProvider(d).readFile(g.URI.revive(u))).then(f=>C.VSBuffer.wrap(f))}$writeFile(d,u,f,b){return Promise.resolve(this._getFsProvider(d).writeFile(g.URI.revive(u),f.buffer,b))}$delete(d,u,f){return Promise.resolve(this._getFsProvider(d).delete(g.URI.revive(u),f))}$rename(d,u,f,b){return Promise.resolve(this._getFsProvider(d).rename(g.URI.revive(u),g.URI.revive(f),b))}$copy(d,u,f,b){const w=this._getFsProvider(d);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(u),g.URI.revive(f),b))}$mkdir(d,u){return Promise.resolve(this._getFsProvider(d).createDirectory(g.URI.revive(u)))}$watch(d,u,f,b){const w=this._getFsProvider(d).watch(g.URI.revive(f),b);this._watches.set(u,w)}$unwatch(d,u){const f=this._watches.get(u);f&&(f.dispose(),this._watches.delete(u))}$open(d,u,f){const b=this._getFsProvider(d);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(g.URI.revive(u),f))}$close(d,u){const f=this._getFsProvider(d);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(u))}$read(d,u,f,b){const w=this._getFsProvider(d);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const P=C.VSBuffer.alloc(b);return Promise.resolve(w.read(u,f,P.buffer,0,b)).then(a=>P.slice(0,a))}$write(d,u,f,b){const w=this._getFsProvider(d);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(u,f,b.buffer,0,b.byteLength))}_getFsProvider(d){const u=this._fsProvider.get(d);if(!u){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return u}}e.ExtHostFileSystem=I}),define(be[76],Ee([0,1,5,61,7,24,4,13,47]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ut{constructor(I,l){const d=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return d.$stat(u).catch(Ut._handleError)},readDirectory(u){return d.$readdir(u).catch(Ut._handleError)},createDirectory(u){return d.$mkdir(u).catch(Ut._handleError)},async readFile(u){return d.$readFile(u).then(f=>f.buffer).catch(Ut._handleError)},writeFile(u,f){return d.$writeFile(u,E.VSBuffer.wrap(f)).catch(Ut._handleError)},delete(u,f){return d.$delete(u,{recursive:!1,useTrash:!1,...f}).catch(Ut._handleError)},rename(u,f,b){return d.$rename(u,f,{overwrite:!1,...b}).catch(Ut._handleError)},copy(u,f,b){return d.$copy(u,f,{overwrite:!1,...b}).catch(Ut._handleError)},isWritableFileSystem(u){const f=l.getCapabilities(u);if(typeof f=="number")return!(f&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};C=ze([Ve(0,y.IExtHostRpcService),Ve(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(be[199],Ee([0,1,6,5]),function(te,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(k){this._handlePool=0,this._proxy=k.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,k),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=S}),define(be[200],Ee([0,1,2,23,9,7,5,8,31,17,10,119,6,89,53,65,55,12,3]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentSymbols(O,K){const X=this._documents.getDocument(O),re=await this._provider.provideDocumentSymbols(X,K);if(!(0,C.isFalsyOrEmpty)(re))return re[0]instanceof E.DocumentSymbol?re.map(S.DocumentSymbol.from):a._asDocumentSymbolTree(re)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((re,q)=>{let ie=re.location.range.start.compareTo(q.location.range.start);return ie===0&&(ie=q.location.range.end.compareTo(re.location.range.end)),ie});const K=[],X=[];for(const re of O){const q={name:re.name||"!!MISSING: name!!",kind:S.SymbolKind.from(re.kind),tags:re.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:S.Range.from(re.location.range),selectionRange:S.Range.from(re.location.range),children:[]};for(;;){if(X.length===0){X.push(q),K.push(q);break}const ie=X[X.length-1];if(_.Range.containsRange(ie.range,q.range)&&!_.Range.equalsRange(ie.range,q.range)){ie.children&&ie.children.push(q),X.push(q);break}X.pop()}}return K}}class h{constructor(O,K,X){this._documents=O,this._commands=K,this._provider=X,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,K){const X=this._documents.getDocument(O),re=await this._provider.provideCodeLenses(X,K);if(!re||K.isCancellationRequested)return;const q=this._cache.add(re),ie=new l.DisposableStore;this._disposables.set(q,ie);const ge={cacheId:q,lenses:[]};for(let Re=0;Re<re.length;Re++)ge.lenses.push({cacheId:[q,Re],range:S.Range.from(re[Re].range),command:this._commands.toInternal(re[Re].command,ie)});return ge}async resolveCodeLens(O,K){const X=O.cacheId&&this._cache.get(...O.cacheId);if(!X)return;let re;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?re=X:re=await this._provider.resolveCodeLens(X,K),re||(re=X),K.isCancellationRequested)return;const q=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!q)return O.command=this._commands.toInternal(re.command??h._badCmd,q),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(je){return Array.isArray(je)?je.map(S.DefinitionLink.from):je?[S.DefinitionLink.from(je)]:[]}class t{constructor(O,K){this._documents=O,this._provider=K}async provideDefinition(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideDefinition(re,q,X);return v(ie)}}class r{constructor(O,K){this._documents=O,this._provider=K}async provideDeclaration(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideDeclaration(re,q,X);return v(ie)}}class s{constructor(O,K){this._documents=O,this._provider=K}async provideImplementation(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideImplementation(re,q,X);return v(ie)}}class i{constructor(O,K){this._documents=O,this._provider=K}async provideTypeDefinition(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideTypeDefinition(re,q,X);return v(ie)}}class c{constructor(O,K){this._documents=O,this._provider=K}async provideHover(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideHover(re,q,X);if(!(!ie||(0,C.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=re.getWordRangeAtPosition(q)),ie.range||(ie.range=new E.Range(q,q)),S.Hover.from(ie)}}class m{constructor(O,K){this._documents=O,this._provider=K}async provideEvaluatableExpression(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideEvaluatableExpression(re,q,X);if(ie)return S.EvaluatableExpression.from(ie)}}class p{constructor(O,K){this._documents=O,this._provider=K}async provideInlineValues(O,K,X,re){const q=this._documents.getDocument(O),ie=await this._provider.provideInlineValues(q,S.Range.to(K),S.InlineValueContext.to(X),re);if(Array.isArray(ie))return ie.map(ge=>S.InlineValue.from(ge))}}class D{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentHighlights(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideDocumentHighlights(re,q,X);if(Array.isArray(ie))return ie.map(S.DocumentHighlight.from)}}class T{constructor(O,K){this._documents=O,this._provider=K}async provideLinkedEditingRanges(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(re,q,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,C.coalesce)(ie.ranges.map(S.Range.from)),wordPattern:ie.wordPattern}}}class o{constructor(O,K){this._documents=O,this._provider=K}async provideReferences(O,K,X,re){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=await this._provider.provideReferences(q,ie,X,re);if(Array.isArray(ge))return ge.map(S.location.from)}}class A{constructor(O,K,X,re,q,ie,ge){this._documents=O,this._commands=K,this._diagnostics=X,this._provider=re,this._logService=q,this._extension=ie,this._apiDeprecation=ge,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,K,X,re){const q=this._documents.getDocument(O),ie=I.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),ge=[];for(const ee of this._diagnostics.getDiagnostics(O))if(ie.intersection(ee.range)&&ge.push(ee)>A._maxCodeActionsPerFile)break;const Re={diagnostics:ge,only:X.only?new E.CodeActionKind(X.only):void 0,triggerKind:S.CodeActionTriggerKind.to(X.trigger)},We=await this._provider.provideCodeActions(q,ie,Re,re);if(!(0,C.isNonEmptyArray)(We)||re.isCancellationRequested)return;const ve=this._cache.add(We),Ye=new l.DisposableStore;this._disposables.set(ve,Ye);const z=[];for(let ee=0;ee<We.length;ee++){const ce=We[ee];!ce||(A._isCommand(ce)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),z.push({_isSynthetic:!0,title:ce.title,command:this._commands.toInternal(ce,Ye)})):(Re.only&&(ce.kind?Re.only.contains(ce.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),z.push({cacheId:[ve,ee],title:ce.title,command:ce.command&&this._commands.toInternal(ce.command,Ye),diagnostics:ce.diagnostics&&ce.diagnostics.map(S.Diagnostic.from),edit:ce.edit&&S.WorkspaceEdit.from(ce.edit),kind:ce.kind&&ce.kind.value,isPreferred:ce.isPreferred,disabled:ce.disabled?.reason})))}return{cacheId:ve,actions:z}}async resolveCodeAction(O,K){const[X,re]=O,q=this._cache.get(X,re);if(!q||A._isCommand(q)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(q,K)??q;return ie?.edit?S.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class F{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentFormattingEdits(O,K,X){const re=this._documents.getDocument(O),q=await this._provider.provideDocumentFormattingEdits(re,K,X);if(Array.isArray(q))return q.map(S.TextEdit.from)}}class U{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentRangeFormattingEdits(O,K,X,re){const q=this._documents.getDocument(O),ie=S.Range.to(K),ge=await this._provider.provideDocumentRangeFormattingEdits(q,ie,X,re);if(Array.isArray(ge))return ge.map(S.TextEdit.from)}}class j{constructor(O,K){this._documents=O,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,X,re,q){const ie=this._documents.getDocument(O),ge=S.Position.to(K),Re=await this._provider.provideOnTypeFormattingEdits(ie,ge,X,re,q);if(Array.isArray(Re))return Re.map(S.TextEdit.from)}}class ae{constructor(O,K){this._provider=O,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(O,K){const X=k.IdObject.mixin({symbols:[]}),re=await this._provider.provideWorkspaceSymbols(O,K);if((0,C.isNonEmptyArray)(re))for(const q of re){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ie=k.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(ie._id,q),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(O,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return O;const X=this._symbolCache.get(O._id);if(X){const re=await this._provider.resolveWorkspaceSymbol(X,K);return re&&(0,R.mixin)(O,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(O){const K=this._resultCache.get(O);if(K){for(let[X,re]=K;X<=re;X++)this._symbolCache.delete(X);this._resultCache.delete(O)}}}class G{constructor(O,K,X){this._documents=O,this._provider=K,this._logService=X}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,K,X,re){const q=this._documents.getDocument(O),ie=S.Position.to(K);try{const ge=await this._provider.provideRenameEdits(q,ie,X,re);return ge?S.WorkspaceEdit.from(ge):void 0}catch(ge){const Re=G._asMessage(ge);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(ge)}}async resolveRenameLocation(O,K,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(O),q=S.Position.to(K);try{const ie=await this._provider.prepareRename(re,q,X);let ge,Re;if(E.Range.isRange(ie)?(ge=ie,Re=re.getText(ie)):(0,n.isObject)(ie)&&(ge=ie.range,Re=ie.placeholder),!ge||!Re)return;if(ge.start.line>q.line||ge.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ge),text:Re}}catch(ie){const ge=G._asMessage(ie);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class B{constructor(O,K){this.resultId=O,this.tokens=K}}class ${constructor(O,K){this._documents=O,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,K,X){const re=this._documents.getDocument(O),q=K!==0?this._previousResults.get(K):null;let ie=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(re,q.resultId,X):await this._provider.provideDocumentSemanticTokens(re,X);return q&&this._previousResults.delete(K),ie?(ie=$._fixProvidedSemanticTokens(ie),this._send($._convertToEdits(q,ie),ie)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return $._isSemanticTokens(O)?$._isCorrectSemanticTokens(O)?O:new E.SemanticTokens(new Uint32Array(O.data),O.resultId):$._isSemanticTokensEdits(O)?$._isCorrectSemanticTokensEdits(O)?O:new E.SemanticTokensEdits(O.edits.map(K=>new E.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,K){if(!$._isSemanticTokens(K)||!O||!O.tokens)return K;const X=O.tokens,re=X.length,q=K.data,ie=q.length;let ge=0;const Re=Math.min(re,ie);for(;ge<Re&&X[ge]===q[ge];)ge++;if(ge===re&&ge===ie)return new E.SemanticTokensEdits([],K.resultId);let We=0;const ve=Re-ge;for(;We<ve&&X[re-We-1]===q[ie-We-1];)We++;return new E.SemanticTokensEdits([{start:ge,deleteCount:re-ge-We,data:q.subarray(ge,ie-We)}],K.resultId)}_send(O,K){if($._isSemanticTokens(O)){const X=this._nextResultId++;return this._previousResults.set(X,new B(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:O.data})}if($._isSemanticTokensEdits(O)){const X=this._nextResultId++;return $._isSemanticTokens(K)?this._previousResults.set(X,new B(K.resultId,K.data)):this._previousResults.set(X,new B(O.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(O.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class L{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentRangeSemanticTokens(O,K,X){const re=this._documents.getDocument(O),q=await this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(K),X);return q?this._send(q):null}_send(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=L;class Z{constructor(O,K,X,re,q){this._documents=O,this._commands=K,this._provider=X,this._apiDeprecation=re,this._extension=q,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,K,X,re){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=q.getWordRangeAtPosition(ie)||new E.Range(ie,ie),Re=ge.with({end:ie}),We=new b.StopWatch(!0),ve=await this._provider.provideCompletionItems(q,ie,re,S.CompletionContext.to(X));if(!ve||re.isCancellationRequested)return;const Ye=Array.isArray(ve)?new E.CompletionList(ve):ve,z=Z.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),ee=new l.DisposableStore;this._disposables.set(z,ee);const ce=[],Ue={x:z,b:ce,a:{replace:S.Range.from(ge),insert:S.Range.from(Re)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let xe=0;xe<Ye.items.length;xe++){const et=Ye.items[xe],Se=this._convertCompletionItem(et,[z,xe],Re,ge);ce.push(Se)}return Ue}async resolveCompletionItem(O,K){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...O);if(!X)return;const re=await this._provider.resolveCompletionItem(X,K);if(!!re)return this._convertCompletionItem(re,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,K,X,re){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const ie={x:K,a:O.label,b:O.kind!==void 0?S.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(S.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(O.command,q)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=O.textEdit.newText):typeof O.insertText=="string"?ie.h=O.insertText:O.insertText instanceof E.SnippetString&&(ie.h=O.insertText.value,ie.i|=4);let ge;return O.textEdit?ge=O.textEdit.range:O.range&&(ge=O.range),E.Range.isRange(ge)?ie.j=S.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!re?.isEqual(ge.replacing))&&(ie.j={insert:S.Range.from(ge.inserting),replace:S.Range.from(ge.replacing)}),ie}}class V{constructor(O,K,X){this._documents=O,this._provider=K,this._commands=X,this._cache=new f.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(O,K,X,re){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=await this._provider.provideInlineCompletionItems(q,ie,X,re);if(!ge||re.isCancellationRequested)return;const Re=(0,n.isArray)(ge)?{items:ge}:ge,We=this._cache.add(Re.items);let ve;return{pid:We,items:Re.items.map((Ye,z)=>{let ee;return Ye.command&&(ve||(ve=new l.DisposableStore,this._disposables.set(We,ve)),ee=this._commands.toInternal(Ye.command,ve)),{text:Ye.text,range:Ye.range?S.Range.from(Ye.range):void 0,command:ee,idx:z}})}}disposeCompletions(O){this._cache.delete(O);const K=this._disposables.get(O);K&&K.clear(),this._disposables.delete(O)}handleDidShowCompletionItem(O,K){const X=this._cache.get(O,K);X&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(O){let K=Y.map.get(O);return K||(K=new Y,Y.map.set(O,K)),K}fireOnDidShowCompletionItem(O){this._onDidShowCompletionItemEmitter.fire(O)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class me{constructor(O,K){this._documents=O,this._provider=K,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,K,X,re){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=this.reviveContext(X),Re=await this._provider.provideSignatureHelp(q,ie,re,ge);if(Re){const We=this._cache.add([Re]);return{...S.SignatureHelp.from(Re),id:We}}}reviveContext(O){let K;if(O.activeSignatureHelp){const X=S.SignatureHelp.to(O.activeSignatureHelp),re=this._cache.get(O.activeSignatureHelp.id,0);re?(K=re,K.activeSignature=X.activeSignature,K.activeParameter=X.activeParameter):K=X}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this._cache.delete(O)}}class H{constructor(O,K){this._documents=O,this._provider=K}async provideInlayHints(O,K,X){const re=this._documents.getDocument(O),q=await this._provider.provideInlayHints(re,S.Range.to(K),X);return q?{hints:q.map(S.InlayHint.from)}:void 0}}class oe{constructor(O,K){this._documents=O,this._provider=K,this._cache=new f.Cache("DocumentLink")}async provideLinks(O,K){const X=this._documents.getDocument(O),re=await this._provider.provideDocumentLinks(X,K);if(!(!Array.isArray(re)||re.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(oe._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(re),ie={links:[],id:q};for(let ge=0;ge<re.length;ge++){if(!oe._validateLink(re[ge]))continue;const Re=S.DocumentLink.from(re[ge]);Re.cacheId=[q,ge],ie.links.push(Re)}return ie}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...O);if(!X)return;const re=await this._provider.resolveDocumentLink(X,K);if(!(!re||!oe._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks(O){this._cache.delete(O)}}class de{constructor(O,K){this._documents=O,this._provider=K}async provideColors(O,K){const X=this._documents.getDocument(O),re=await this._provider.provideDocumentColors(X,K);return Array.isArray(re)?re.map(ie=>({color:S.Color.from(ie.color),range:S.Range.from(ie.range)})):[]}async provideColorPresentations(O,K,X){const re=this._documents.getDocument(O),q=S.Range.to(K.range),ie=S.Color.to(K.color),ge=await this._provider.provideColorPresentations(ie,{document:re,range:q},X);if(!!Array.isArray(ge))return ge.map(S.ColorPresentation.from)}}class Ce{constructor(O,K){this._documents=O,this._provider=K}async provideFoldingRanges(O,K,X){const re=this._documents.getDocument(O),q=await this._provider.provideFoldingRanges(re,K,X);if(!!Array.isArray(q))return q.map(S.FoldingRange.from)}}class Ne{constructor(O,K,X){this._documents=O,this._provider=K,this._logService=X}async provideSelectionRanges(O,K,X){const re=this._documents.getDocument(O),q=K.map(S.Position.to),ie=await this._provider.provideSelectionRanges(re,q,X);if(!(0,C.isNonEmptyArray)(ie))return[];if(ie.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Re=0;Re<q.length;Re++){const We=[];ge.push(We);let ve=q[Re],Ye=ie[Re];for(;;){if(!Ye.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(We.push(S.SelectionRange.from(Ye)),!Ye.parent)break;ve=Ye.range,Ye=Ye.parent}}return ge}}class Me{constructor(O,K){this._documents=O,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.prepareCallHierarchy(re,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ie)]}async provideCallsTo(O,K,X){const re=this._itemFromCache(O,K);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(re,X);if(!!q)return q.map(ie=>({from:this._cacheAndConvertItem(O,ie.from),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}async provideCallsFrom(O,K,X){const re=this._itemFromCache(O,K);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(re,X);if(!!q)return q.map(ie=>({to:this._cacheAndConvertItem(O,ie.to),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,K){const X=this._cache.get(O),re=S.CallHierarchyItem.from(K,O,X.size.toString(36));return X.set(re._itemId,K),re}_itemFromCache(O,K){return this._cache.get(O)?.get(K)}}class $e{constructor(O,K){this._documents=O,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(O,K,X){const re=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.prepareTypeHierarchy(re,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ie)]}async provideSupertypes(O,K,X){const re=this._itemFromCache(O,K);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(O,ie))}async provideSubtypes(O,K,X){const re=this._itemFromCache(O,K);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(O,ie))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,K){const X=this._cache.get(O),re=S.TypeHierarchyItem.from(K,O,X.size.toString(36));return X.set(re._itemId,K),re}_itemFromCache(O,K){return this._cache.get(O)?.get(K)}}class Xe{constructor(O,K){this.adapter=O,this.extension=K}}class qe{constructor(O,K,X,re,q,ie,ge){this._adapter=new Map,this._uriTransformer=K,this._proxy=O.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=re,this._diagnostics=q,this._logService=ie,this._apiDeprecation=ge}_transformDocumentSelector(O){return(0,C.coalesce)((0,C.asArray)(O).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(O){if(typeof O=="string")return{$serialized:!0,language:O};if(O)return{$serialized:!0,language:O.language,scheme:this._transformScheme(O.scheme),pattern:typeof O.pattern=="undefined"?void 0:S.GlobPattern.from(O.pattern),exclusive:O.exclusive}}_transformScheme(O){return this._uriTransformer&&typeof O=="string"?this._uriTransformer.transformOutgoingScheme(O):O}_createDisposable(O){return new E.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return qe._handlePool++}_withAdapter(O,K,X,re,q=!1){const ie=this._adapter.get(O);if(!ie)return Promise.resolve(re);if(ie.adapter instanceof K){let ge;ie.extension&&(ge=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Re=X(ie.adapter,ie.extension),We=ie.extension;return We&&Promise.resolve(Re).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-ge}ms`),ve=>{q&&ve instanceof w.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(ve))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(O,K){const X=this._nextHandle();return this._adapter.set(X,new Xe(O,K)),X}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,X,re){const q=this._addNewAdapter(new a(this._documents,X),O),ie=re&&re.label||qe._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),ie),this._createDisposable(q)}$provideDocumentSymbols(O,K,X){return this._withAdapter(O,a,re=>re.provideDocumentSymbols(g.URI.revive(K),X),void 0)}registerCodeLensProvider(O,K,X){const re=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Xe(new h(this._documents,this._commands.converter,X),O)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(K),q);let ie=this._createDisposable(re);if(q!==void 0){const ge=X.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));ie=E.Disposable.from(ie,ge)}return ie}$provideCodeLenses(O,K,X){return this._withAdapter(O,h,re=>re.provideCodeLenses(g.URI.revive(K),X),void 0)}$resolveCodeLens(O,K,X){return this._withAdapter(O,h,re=>re.resolveCodeLens(K,X),void 0)}$releaseCodeLenses(O,K){this._withAdapter(O,h,X=>Promise.resolve(X.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(O,K,X){const re=this._addNewAdapter(new t(this._documents,X),O);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDefinition(O,K,X,re){return this._withAdapter(O,t,q=>q.provideDefinition(g.URI.revive(K),X,re),[])}registerDeclarationProvider(O,K,X){const re=this._addNewAdapter(new r(this._documents,X),O);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDeclaration(O,K,X,re){return this._withAdapter(O,r,q=>q.provideDeclaration(g.URI.revive(K),X,re),[])}registerImplementationProvider(O,K,X){const re=this._addNewAdapter(new s(this._documents,X),O);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideImplementation(O,K,X,re){return this._withAdapter(O,s,q=>q.provideImplementation(g.URI.revive(K),X,re),[])}registerTypeDefinitionProvider(O,K,X){const re=this._addNewAdapter(new i(this._documents,X),O);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideTypeDefinition(O,K,X,re){return this._withAdapter(O,i,q=>q.provideTypeDefinition(g.URI.revive(K),X,re),[])}registerHoverProvider(O,K,X,re){const q=this._addNewAdapter(new c(this._documents,X),O);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover(O,K,X,re){return this._withAdapter(O,c,q=>q.provideHover(g.URI.revive(K),X,re),void 0)}registerEvaluatableExpressionProvider(O,K,X,re){const q=this._addNewAdapter(new m(this._documents,X),O);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression(O,K,X,re){return this._withAdapter(O,m,q=>q.provideEvaluatableExpression(g.URI.revive(K),X,re),void 0)}registerInlineValuesProvider(O,K,X,re){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new p(this._documents,X),O);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),q);let ge=this._createDisposable(ie);if(q!==void 0){const Re=X.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));ge=E.Disposable.from(ge,Re)}return ge}$provideInlineValues(O,K,X,re,q){return this._withAdapter(O,p,ie=>ie.provideInlineValues(g.URI.revive(K),X,re,q),void 0)}registerDocumentHighlightProvider(O,K,X){const re=this._addNewAdapter(new D(this._documents,X),O);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDocumentHighlights(O,K,X,re){return this._withAdapter(O,D,q=>q.provideDocumentHighlights(g.URI.revive(K),X,re),void 0)}registerLinkedEditingRangeProvider(O,K,X){const re=this._addNewAdapter(new T(this._documents,X),O);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideLinkedEditingRanges(O,K,X,re){return this._withAdapter(O,T,async q=>{const ie=await q.provideLinkedEditingRanges(g.URI.revive(K),X,re);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?qe._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(O,K,X){const re=this._addNewAdapter(new o(this._documents,X),O);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideReferences(O,K,X,re,q){return this._withAdapter(O,o,ie=>ie.provideReferences(g.URI.revive(K),X,re,q),void 0)}registerCodeActionProvider(O,K,X,re){const q=new l.DisposableStore,ie=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,X,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:re?.providedCodeActionKinds?.map(ge=>ge.value),documentation:re?.documentation?.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,q)}))},qe._extLabel(O),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ie)),q}$provideCodeActions(O,K,X,re,q){return this._withAdapter(O,A,ie=>ie.provideCodeActions(g.URI.revive(K),X,re,q),void 0)}$resolveCodeAction(O,K,X){return this._withAdapter(O,A,re=>re.resolveCodeAction(K,X),void 0)}$releaseCodeActions(O,K){this._withAdapter(O,A,X=>Promise.resolve(X.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(O,K,X){const re=this._addNewAdapter(new F(this._documents,X),O);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(K),O.identifier,O.displayName||O.name),this._createDisposable(re)}$provideDocumentFormattingEdits(O,K,X,re){return this._withAdapter(O,F,q=>q.provideDocumentFormattingEdits(g.URI.revive(K),X,re),void 0)}registerDocumentRangeFormattingEditProvider(O,K,X){const re=this._addNewAdapter(new U(this._documents,X),O);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(K),O.identifier,O.displayName||O.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(O,K,X,re,q){return this._withAdapter(O,U,ie=>ie.provideDocumentRangeFormattingEdits(g.URI.revive(K),X,re,q),void 0)}registerOnTypeFormattingEditProvider(O,K,X,re){const q=this._addNewAdapter(new j(this._documents,X),O);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),re,O.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(O,K,X,re,q,ie){return this._withAdapter(O,j,ge=>ge.provideOnTypeFormattingEdits(g.URI.revive(K),X,re,q,ie),void 0)}registerWorkspaceSymbolProvider(O,K){const X=this._addNewAdapter(new ae(K,this._logService),O);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(O,K,X){return this._withAdapter(O,ae,re=>re.provideWorkspaceSymbols(K,X),{symbols:[]})}$resolveWorkspaceSymbol(O,K,X){return this._withAdapter(O,ae,re=>re.resolveWorkspaceSymbol(K,X),void 0)}$releaseWorkspaceSymbols(O,K){this._withAdapter(O,ae,X=>X.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(O,K,X){const re=this._addNewAdapter(new G(this._documents,X,this._logService),O);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(K),G.supportsResolving(X)),this._createDisposable(re)}$provideRenameEdits(O,K,X,re,q){return this._withAdapter(O,G,ie=>ie.provideRenameEdits(g.URI.revive(K),X,re,q),void 0)}$resolveRenameLocation(O,K,X,re){return this._withAdapter(O,G,q=>q.resolveRenameLocation(g.URI.revive(K),X,re),void 0)}registerDocumentSemanticTokensProvider(O,K,X,re){const q=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Xe(new $(this._documents,X),O)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),re,ie);let ge=this._createDisposable(q);if(ie){const Re=X.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ie));ge=E.Disposable.from(ge,Re)}return ge}$provideDocumentSemanticTokens(O,K,X,re){return this._withAdapter(O,$,q=>q.provideDocumentSemanticTokens(g.URI.revive(K),X,re),null,!0)}$releaseDocumentSemanticTokens(O,K){this._withAdapter(O,$,X=>X.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(O,K,X,re){const q=this._addNewAdapter(new L(this._documents,X),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),re),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(O,K,X,re){return this._withAdapter(O,L,q=>q.provideDocumentRangeSemanticTokens(g.URI.revive(K),X,re),null,!0)}registerCompletionItemProvider(O,K,X,re){const q=this._addNewAdapter(new Z(this._documents,this._commands.converter,X,this._apiDeprecation,O),O);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),re,Z.supportsResolving(X),`${O.identifier.value}(${re.join("")})`),this._createDisposable(q)}$provideCompletionItems(O,K,X,re,q){return this._withAdapter(O,Z,ie=>ie.provideCompletionItems(g.URI.revive(K),X,re,q),void 0)}$resolveCompletionItem(O,K,X){return this._withAdapter(O,Z,re=>re.resolveCompletionItem(K,X),void 0)}$releaseCompletionItems(O,K){this._withAdapter(O,Z,X=>X.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(O,K,X){const re=this._addNewAdapter(new V(this._documents,X,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideInlineCompletions(O,K,X,re,q){return this._withAdapter(O,V,ie=>ie.provideInlineCompletions(g.URI.revive(K),X,re,q),void 0)}$handleInlineCompletionDidShow(O,K,X){this._withAdapter(O,V,async re=>{re.handleDidShowCompletionItem(K,X)},void 0)}$freeInlineCompletionsList(O,K){this._withAdapter(O,V,async X=>{X.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(O,K,X,re){const q=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,ie=this._addNewAdapter(new me(this._documents,X),O);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),q),this._createDisposable(ie)}$provideSignatureHelp(O,K,X,re,q){return this._withAdapter(O,me,ie=>ie.provideSignatureHelp(g.URI.revive(K),X,re,q),void 0)}$releaseSignatureHelp(O,K){this._withAdapter(O,me,X=>X.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(O,K,X){const re=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new H(this._documents,X),O);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),re);let ie=this._createDisposable(q);if(re!==void 0){const ge=X.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(re));ie=E.Disposable.from(ie,ge)}return ie}$provideInlayHints(O,K,X,re){return this._withAdapter(O,H,q=>q.provideInlayHints(g.URI.revive(K),X,re),void 0)}registerDocumentLinkProvider(O,K,X){const re=this._addNewAdapter(new oe(this._documents,X),O);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(K),typeof X.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(O,K,X){return this._withAdapter(O,oe,re=>re.provideLinks(g.URI.revive(K),X),void 0)}$resolveDocumentLink(O,K,X){return this._withAdapter(O,oe,re=>re.resolveLink(K,X),void 0)}$releaseDocumentLinks(O,K){this._withAdapter(O,oe,X=>X.releaseLinks(K),void 0)}registerColorProvider(O,K,X){const re=this._addNewAdapter(new de(this._documents,X),O);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideDocumentColors(O,K,X){return this._withAdapter(O,de,re=>re.provideColors(g.URI.revive(K),X),[])}$provideColorPresentations(O,K,X,re){return this._withAdapter(O,de,q=>q.provideColorPresentations(g.URI.revive(K),X,re),void 0)}registerFoldingRangeProvider(O,K,X){const re=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Xe(new Ce(this._documents,X),O)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(K),q);let ie=this._createDisposable(re);if(q!==void 0){const ge=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ie=E.Disposable.from(ie,ge)}return ie}$provideFoldingRanges(O,K,X,re){return this._withAdapter(O,Ce,q=>q.provideFoldingRanges(g.URI.revive(K),X,re),void 0)}registerSelectionRangeProvider(O,K,X){const re=this._addNewAdapter(new Ne(this._documents,X,this._logService),O);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$provideSelectionRanges(O,K,X,re){return this._withAdapter(O,Ne,q=>q.provideSelectionRanges(g.URI.revive(K),X,re),[])}registerCallHierarchyProvider(O,K,X){const re=this._addNewAdapter(new Me(this._documents,X),O);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$prepareCallHierarchy(O,K,X,re){return this._withAdapter(O,Me,q=>Promise.resolve(q.prepareSession(g.URI.revive(K),X,re)),void 0)}$provideCallHierarchyIncomingCalls(O,K,X,re){return this._withAdapter(O,Me,q=>q.provideCallsTo(K,X,re),void 0)}$provideCallHierarchyOutgoingCalls(O,K,X,re){return this._withAdapter(O,Me,q=>q.provideCallsFrom(K,X,re),void 0)}$releaseCallHierarchy(O,K){this._withAdapter(O,Me,X=>Promise.resolve(X.releaseSession(K)),void 0)}registerTypeHierarchyProvider(O,K,X){const re=this._addNewAdapter(new $e(this._documents,X),O);return this._proxy.$registerTypeHierarchyProvider(re,this._transformDocumentSelector(K)),this._createDisposable(re)}$prepareTypeHierarchy(O,K,X,re){return this._withAdapter(O,$e,q=>Promise.resolve(q.prepareSession(g.URI.revive(K),X,re)),void 0)}$provideTypeHierarchySupertypes(O,K,X,re){return this._withAdapter(O,$e,q=>q.provideSupertypes(K,X,re),void 0)}$provideTypeHierarchySubtypes(O,K,X,re){return this._withAdapter(O,$e,q=>q.provideSubtypes(K,X,re),void 0)}$releaseTypeHierarchy(O,K){this._withAdapter(O,$e,X=>Promise.resolve(X.releaseSession(K)),void 0)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:qe._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?qe._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?qe._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:qe._serializeRegExp(O.beforeText),afterText:O.afterText?qe._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?qe._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(qe._serializeOnEnterRule)}setLanguageConfiguration(O,K,X){let{wordPattern:re}=X;if(re&&(0,y.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(K,re):this._documents.setWordDefinitionFor(K,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?qe._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?qe._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?qe._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,ie),this._createDisposable(q)}$setWordDefinitions(O){for(const K of O)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(be[201],Ee([0,1,5,9,7,36,15]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(C,n){this._handlePool=0,this._proxy=C.getProxy(g.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,n){await this._proxy.$changeLanguage(C,n);const I=this._documents.getDocumentData(C);if(!I)throw new Error(`document '${C.toString}' NOT found`);return I.document}async tokenAtPosition(C,n){const I=C.version,l=R.Position.from(n),d=await this._proxy.$tokensAtPosition(C.uri,l),u={type:S.StandardTokenType.Other,range:C.getWordRangeAtPosition(n)??new S.Range(n.line,n.character,n.line,n.character)};if(!d)return u;const f={range:R.Range.to(d.range),type:R.TokenType.to(d.type)};return!f.range.contains(n)||I!==C.version?u:f}createLanguageStatusItem(C){const n=this._handlePool++,I=this._proxy,l={selector:C,text:"",detail:"",severity:S.LanguageStatusSeverity.Information};let d;const u=()=>{d?.dispose(),d=(0,k.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:l.selector,text:l.text,message:typeof l.detail=="string"?l.detail:R.MarkdownString.from(l.detail),severity:l.severity===S.LanguageStatusSeverity.Error?E.default.Error:l.severity===S.LanguageStatusSeverity.Warning?E.default.Warning:E.default.Info})},0)},f={get selector(){return l.selector},set selector(b){l.selector=b,u()},get text(){return l.text},set text(b){l.text=b,u()},get detail(){return l.detail},set detail(b){l.detail=b,u()},get severity(){return l.severity},set severity(b){l.severity=b,u()},dispose(){d?.dispose(),I.$removeLanguageStatus(n)}};return u(),f}}e.ExtHostLanguages=y}),define(be[202],Ee([0,1,5,16,30]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(y){return y&&y.title}let k=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,C,n,I,l){const d={extension:_};let u;typeof I=="string"||E(I)?u=[I,...l]:(d.modal=I?.modal,d.useCustom=I?.useCustom,d.detail=I?.detail,u=l),d.useCustom&&(0,S.checkProposedApiEnabled)(_);const f=[];for(let b=0;b<u.length;b++){const w=u[b];if(typeof w=="string")f.push({title:w,handle:b,isCloseAffordance:!1});else if(typeof w=="object"){let{title:P,isCloseAffordance:a}=w;f.push({title:P,isCloseAffordance:!!a,handle:b})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,n,d,f).then(b=>{if(typeof b=="number")return u[b]})}};k=ze([Ve(1,R.ILogService)],k),e.ExtHostMessageService=k}),define(be[203],Ee([0,1,24,3,43,6,21,8,10,2,65,5,9,7,180,101]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(P,a,h,v,t){this._textDocumentsAndEditors=h,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,i=r.cell.handle,m=this._documents.get(s)?.getCell(i);if(m)return m.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const a=this._editors.get(P);if(!a)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(P){for(const[a,h]of this._editors)if(h.apiEditor===P)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,a){const h=this._documents.get(P);if(!h&&!a)throw new Error(`NO notebook document for '${P}'`);return h}_getProviderData(P){const a=this._notebookContentProviders.get(P);if(!a)throw new Error(`NO provider for '${P}'`);return a}registerNotebookContentProvider(P,a,h,v,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:P,provider:h});let r;return h.onDidChangeNotebookContentOptions&&(r=h.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(a,s)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(P,t)),new d.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(P,a){if(!a)return;const h=a.filenamePattern.map(v=>l.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(a.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:a.displayName,filenamePattern:h,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,a,h){const v=b._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,a);let r;return t!==void 0&&(r=h.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),r&&r.dispose()})}async createNotebookDocument(P){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&l.NotebookData.from(P.content)});return C.URI.revive(a)}async openNotebookDocument(P){const a=this._documents.get(P);if(a)return a.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(P),v=this._documents.get(C.URI.revive(h));return(0,_.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(P,a){C.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let h;typeof a=="object"?h={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(l.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:h={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,h),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,a,h,v){const t=this._notebookStatusBarItemProviders.get(P),r=C.URI.revive(a),s=this._documents.get(r);if(!s||!t)return;const i=s.getCellFromIndex(h);if(!i)return;const c=await t.provideCellStatusBarItems(i.apiCell,v);if(!c)return;const m=new E.DisposableStore,p=this._statusBarCache.add([m]),T=(Array.isArray(c)?c:[c]).map(o=>l.NotebookStatusBarItem.from(o,this._commandsConverter,m));return{cacheId:p,items:T}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,a,h,v,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,h),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(P,t)),(0,E.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,a,h){const v=this._notebookSerializer.get(P);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(a.buffer,h);return l.NotebookData.from(t)}async $notebookToData(P,a,h){const v=this._notebookSerializer.get(P);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(l.NotebookData.to(a),h);return g.VSBuffer.wrap(t)}async $openNotebook(P,a,h,v,t){const{provider:r}=this._getProviderData(P),s=await r.openNotebook(C.URI.revive(a),{backupId:h,untitledDocumentData:v?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(l.NotebookCellData.from)}}async $saveNotebook(P,a,h){const v=this.getNotebookDocument(C.URI.revive(a)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(v.apiNotebook,h),!0}async $saveNotebookAs(P,a,h,v){const t=this.getNotebookDocument(C.URI.revive(a)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(C.URI.revive(h),t.apiNotebook,v),!0}async $backupNotebook(P,a,h){const v=this.getNotebookDocument(C.URI.revive(a)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,S.hash)([v.uri.toString(),this._backupIdPool++])),i=C.URI.joinPath(r,s),c=await t.provider.backupNotebook(v.apiNotebook,{destination:i},h);return v.updateBackup(c),c.id}_createExtHostEditor(P,a,h){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const v=new f.ExtHostNotebookEditor(a,this._notebookEditorsProxy,P,h.visibleRanges.map(l.NotebookRange.to),h.selections.map(l.NotebookRange.to),typeof h.viewColumn=="number"?l.ViewColumn.to(h.viewColumn):void 0);this._editors.set(a,v)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const h of P.removedDocuments){const v=C.URI.revive(h),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===v.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const h=[];for(const v of P.addedDocuments){const t=C.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,s=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,v);h.push(...v.cells.map(i=>u.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(P.addedEditors)for(const h of P.addedEditors){if(this._editors.has(h.id))return;const v=C.URI.revive(h.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,h.id,h)}const a=[];if(P.removedEditors)for(const h of P.removedEditors){const v=this._editors.get(h);v&&(this._editors.delete(h),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),a.push(v))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const h=new Set;this._visibleNotebookEditors.forEach(v=>h.add(v.id));for(const v of this._editors.values()){const t=h.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(be[204],Ee([0,1,3,53,16,5,13,9]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,l){const d=_._Keys.nextId();I.$registerNotebookEditorDecorationType(d,y.NotebookDecorationRenderOptions.from(l)),this.value={key:d,dispose(){I.$removeNotebookEditorDecorationType(d)}}}}_._Keys=new R.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,l,d){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(E.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const d=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&d._acceptVisibleRanges(l.visibleRanges.ranges.map(y.NotebookRange.to)),l.selections&&d._acceptSelections(l.selections.selections.map(y.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(y.ViewColumn.to(I[l]))}};C=ze([Ve(0,S.ILogService),Ve(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(be[205],Ee([0,1,3,6,5,26,2,9,70,21,15,71,20,17,16,7,30]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,s,i){this._initData=r,this._extHostNotebook=s,this._logService=i,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,i,c,m){for(let V of this._kernelData.values())if(V.controller.id===r&&E.ExtensionIdentifier.equals(t.identifier,V.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const p=this._handlePool++,D=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${r}`);const T=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let o=!1;const A=new R.DisposableStore,F=new g.Emitter,U=new g.Emitter,j={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:m?m.map(y.NotebookRendererScript.from):[]};let ae=c??T,G;this._proxy.$addKernel(p,j).catch(V=>{console.log(V),o=!0});let B=0;const $=()=>{if(o)return;const V=++B;Promise.resolve().then(()=>{V===B&&this._proxy.$updateKernel(p,j)})},L=new C.ResourceMap,Z={get id(){return r},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return j.label},set label(V){j.label=V??t.displayName??t.name,$()},get detail(){return j.detail??""},set detail(V){j.detail=V,$()},get description(){return j.description??""},set description(V){j.description=V,$()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(V){j.supportedLanguages=V,$()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(V){j.supportsExecutionOrder=V,$()},get rendererScripts(){return j.preloads?j.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return ae},set executeHandler(V){ae=V??T},get interruptHandler(){return G},set interruptHandler(V){G=V,j.supportsInterrupt=Boolean(V),$()},createNotebookCellExecution(V){if(o)throw new Error("notebook controller is DISPOSED");if(!L.has(V.notebook.uri))throw D._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(L.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${V.notebook.uri.toString()}`);return D._createNotebookCellExecution(V)},dispose:()=>{o||(this._logService.trace(`NotebookController[${p}], DISPOSED`),o=!0,this._kernelData.delete(p),A.dispose(),F.dispose(),U.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(V,Y){D._proxy.$updateNotebookPriority(p,V.uri,Y)},onDidReceiveMessage:U.event,postMessage(V,Y){return(0,b.checkProposedApiEnabled)(t),D._proxy.$postMessage(p,Y&&D._extHostNotebook.getIdByEditor(Y),V)},asWebviewUri(V){return(0,b.checkProposedApiEnabled)(t),(0,_.asWebviewUri)(V,D._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:Z,onDidReceiveMessage:U,onDidChangeSelection:F,associatedNotebooks:L}),Z}$acceptNotebookAssociation(t,r,s){const i=this._kernelData.get(t);if(i){const c=this._extHostNotebook.getNotebookDocument(k.URI.revive(r));s?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:c.apiNotebook})}}async $executeCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(k.URI.revive(r)),m=[];for(let p of s){const D=c.getCell(p);D&&m.push(D.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),m.length),await i.controller.executeHandler.call(i.controller,m,c.apiNotebook,i.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(k.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(let m of s){const p=c.getCell(m);p&&this._activeExecutions.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new a(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,i);const c=i.onDidChangeState(()=>{i.state===P.Resolved&&(i.dispose(),c.dispose(),this._activeExecutions.delete(s.uri))});return i.asApiObject()}};w=ze([Ve(3,u.ILogService)],w),e.ExtHostNotebookKernels=w;var P;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(P||(P={}));class a extends R.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new h(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?y.NotebookCellOutput.from(r):y.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const i=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,d.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:s,outputs:c})}async updateOutputItems(t,r,s){return t=f.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,i){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:i??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!0)},replaceOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!1)},appendOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!0)},replaceOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!1)}})}}class h{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(be[206],Ee([0,1,3,5,101]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(y,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,_,C){const n=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(_)?.fire({editor:n.apiEditor,message:C})}createRendererMessaging(y,_){if(!y.contributes?.notebookRenderer?.some(l=>l.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const C=!!y.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(l,d,u)=>{const f=C?l:b=>{const w={};n.set(w,b.editor),l({editor:w,message:b.message})};return this.getOrCreateEmitterFor(_).event(f,d,u)},postMessage:(l,d)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,d]=[d,l]);const u=C?d:n.get(d),f=u&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(f?.id,_,l)}}}getOrCreateEmitterFor(y){let _=this._rendererMessageEmitters.get(y);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,_),_)}}e.ExtHostNotebookRenderers=E}),define(be[105],Ee([0,1,5,3,6,24,4,13]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends S.Disposable{constructor(u,f,b,w,P){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=P,this._id=P.$register(this.name,f,b,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?E.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(f=>this._proxy.$clear(f,u))}show(u,f){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof u=="boolean"?u:f)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(u,f,b){super(u,!1,void 0,f,b)}append(u){super.append(u),this._id.then(f=>this._proxy.$append(f,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends _{constructor(u,f,b){super(u,!0,f,void 0,b)}append(u){throw new Error("Not supported")}}class I{constructor(u,f){this.name=u,this._channel=f}append(u){this._channel.then(f=>f.append(u))}appendLine(u){this._channel.then(f=>f.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,f){this._channel.then(b=>b.show(u,f))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(u){this._proxy=u.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new C(u,f.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new n(u,f,this._proxy)}};l=ze([Ve(0,y.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(be[207],Ee([0,1,15,20,3,6,5,2,7,12,17,36]),function(te,e,g,R,S,E,k,y,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(d,u,f){const b=d.getProxy(k.MainContext.MainThreadQuickOpen);class w{constructor(i,c){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=c}showQuickPick(i,c,m,p=R.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(i),T=++this._instances,o=b.$show(T,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},p),A={},F=o.then(()=>A);return Promise.race([F,D]).then(U=>{if(U!==A)return D.then(j=>{const ae=[];for(let G=0;G<j.length;G++){const B=j[G];let $,L,Z,V,Y;typeof B=="string"?$=B:($=B.label,L=B.description,Z=B.detail,V=B.picked,Y=B.alwaysShow),ae.push({label:$,description:L,handle:G,detail:Z,picked:V,alwaysShow:Y})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{m.onDidSelectItem(j[G])}),b.$setItems(T,ae),o.then(G=>{if(typeof G=="number")return j[G];if(Array.isArray(G))return G.map(B=>j[B])})})}).then(void 0,U=>{if(!(0,C.isPromiseCanceledError)(U))return b.$setError(T,U),Promise.reject(U)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,c=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,b.$input(i,typeof this._validateInput=="function",c).then(void 0,m=>{if(!(0,C.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(i){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,c=R.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!m)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(D=>D.uri.toString()===m.uri.toString())}createQuickPick(i,c){const m=new t(i,c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(i){const c=new r(i,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(i,c){const m=this._sessions.get(i);m&&m._fireDidChangeValue(c)}$onDidAccept(i){const c=this._sessions.get(i);c&&c._fireDidAccept()}$onDidChangeActive(i,c){const m=this._sessions.get(i);m instanceof t&&m._fireDidChangeActive(c)}$onDidChangeSelection(i,c){const m=this._sessions.get(i);m instanceof t&&m._fireDidChangeSelection(c)}$onDidTriggerButton(i,c){const m=this._sessions.get(i);m&&m._fireDidTriggerButton(c)}$onDidHide(i){const c=this._sessions.get(i);c&&c._fireDidHide()}}class P{constructor(i,c){this._extensionId=i,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((c,m)=>{const p=c===_.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(p,c)}),this.update({buttons:i.map((c,m)=>({iconPath:a(c.iconPath),tooltip:c.tooltip,handle:c===_.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const c=this._handlesToButtons.get(i);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,E.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(i){if(!this._disposed){for(const c of Object.keys(i)){const m=i[c];this._pendingUpdate[c]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function a(s){if(s instanceof _.ThemeIcon)return{id:s.id};const i=v(s),c=h(s);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof c=="string"?y.URI.file(c):c}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function v(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends P{constructor(i,c,m){super(i,m);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,m)=>{this._handlesToItems.set(m,c),this._itemsToHandles.set(c,m)}),this.update({items:i.map((c,m)=>({label:c.label,description:c.description,handle:m,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(i){const c=(0,n.coalesce)(i.map(m=>this._handlesToItems.get(m)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(i){const c=(0,n.coalesce)(i.map(m=>this._handlesToItems.get(m)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class r extends P{constructor(i,c){super(i,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?I.default.Error:I.default.Ignore})}}return new w(u,f)}e.createExtHostQuickOpen=l}),define(be[208],Ee([0,1,2,3,51,6,15,5,17,116,16,26,30,64]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(c){if(c)return typeof c.iconPath=="string"?g.URI.file(c.iconPath):g.URI.isUri(c.iconPath)||d.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function f(c,m){if(!c.iconPath&&!m.iconPath)return 0;if(c.iconPath){if(!m.iconPath)return 1}else return-1;const p=typeof c.iconPath=="string"?c.iconPath:g.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,D=typeof m.iconPath=="string"?m.iconPath:g.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,C.comparePaths)(p,D)}function b(c,m){let p=0;if(c.strikeThrough!==m.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==m.faded)return c.faded?1:-1;if(c.tooltip!==m.tooltip)return(c.tooltip||"").localeCompare(m.tooltip||"");if(p=f(c,m),p!==0)return p;if(c.light&&m.light)p=f(c.light,m.light);else{if(c.light)return 1;if(m.light)return-1}if(p!==0)return p;if(c.dark&&m.dark)p=f(c.dark,m.dark);else{if(c.dark)return 1;if(m.dark)return-1}return p}function w(c,m){if(c.command!==m.command)return c.command<m.command?-1:1;if(c.title!==m.title)return c.title<m.title?-1:1;if(c.tooltip!==m.tooltip){if(c.tooltip!==void 0&&m.tooltip!==void 0)return c.tooltip<m.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(c.arguments===m.arguments)return 0;if(c.arguments)if(m.arguments){if(c.arguments.length!==m.arguments.length)return c.arguments.length-m.arguments.length}else return 1;else return-1;for(let p=0;p<c.arguments.length;p++){const D=c.arguments[p],T=m.arguments[p];if(D!==T)return D<T?-1:1}return 0}function P(c,m){let p=(0,C.comparePaths)(c.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(p!==0)return p;if(c.command&&m.command)p=w(c.command,m.command);else{if(c.command)return 1;if(m.command)return-1}if(p!==0)return p;if(c.decorations&&m.decorations)p=b(c.decorations,m.decorations);else{if(c.decorations)return 1;if(m.decorations)return-1}return p}function a(c,m){for(let p=0;p<c.length;p++)if(c[p]!==m[p])return!1;return!0}function h(c,m){return c.command===m.command&&c.title===m.title&&c.tooltip===m.tooltip&&(c.arguments&&m.arguments?a(c.arguments,m.arguments):c.arguments===m.arguments)}function v(c,m){return(0,_.equals)(c,m,h)}class t{constructor(m,p,D){this._extension=m,this._proxy=p,this._sourceControlHandle=D,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,l.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,p){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,p)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=t;class r{constructor(m,p,D,T,o){this._proxy=m,this._commands=p,this._sourceControlHandle=D,this._id=T,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,p){const D=this._resourceStatesCommandsMap.get(m);return D?(0,k.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(P),D=(0,_.sortedDiff)(this._resourceSnapshot,m,P).map(A=>{const F=A.toInsert.map(U=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,U);const ae=U.resourceUri;let G;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const de=new E.DisposableStore;G=this._commands.converter.toInternal(U.command,de),this._resourceStatesDisposablesMap.set(j,de)}else this._resourceStatesCommandsMap.set(j,U.command);const B=u(U.decorations),$=U.decorations&&u(U.decorations.light)||B,L=U.decorations&&u(U.decorations.dark)||B,Z=[$,L],V=U.decorations&&U.decorations.tooltip||"",Y=U.decorations&&!!U.decorations.strikeThrough,me=U.decorations&&!!U.decorations.faded,H=U.contextValue||"";return{rawResource:[j,ae,Z,V,Y,me,H,G],handle:j}});return{start:A.start,deleteCount:A.deleteCount,toInsert:F}}),T=D.map(({start:A,deleteCount:F,toInsert:U})=>[A,F,U.map(j=>j.rawResource)]),o=D.reverse();for(const{start:A,deleteCount:F,toInsert:U}of o){const j=U.map(G=>G.handle),ae=this._handlesSnapshot.splice(A,F,...j);for(const G of ae)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),this._resourceStatesDisposablesMap.get(G)?.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=m,T}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(m,p,D,T,o,A){this._proxy=p,this._commands=D,this._id=T,this._label=o,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,T,o,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=m;const p=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&v(this._statusBarCommands,m))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=m;const p=(m||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(m,p){const D=new r(this._proxy,this._commands,this.handle,m,p),T=R.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,T),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const m=[],p=[];for(const[D,T]of this.createdResourceGroups){T.dispose();const o=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});R.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),o.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),m.push([D.handle,D.id,D.label,D.features]);const A=D._takeResourceStateSnapshot();A.length>0&&p.push([D.handle,A]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,m,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(p=>{const D=p._takeResourceStateSnapshot();D.length!==0&&m.push([p.handle,D])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,ze([(0,S.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let i=class xn{constructor(m,p,D){this._commands=p,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=m.getProxy(y.MainContext.MainThreadSCM),this._telemetry=m.getProxy(y.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const o=this._sourceControls.get(T.sourceControlHandle);if(!o)return T;const A=o.getResourceGroup(T.groupHandle);return A?A.getResourceState(T.handle):T}else if(T&&T.$mid===4){const o=this._sourceControls.get(T.sourceControlHandle);return o?o.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const o=this._sourceControls.get(T.handle);return o||T}return T}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,p,D,T){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,p,D,T),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const o=xn._handlePool++,A=new s(m,this._proxy,this._commands,p,D,T);this._sourceControls.set(o,A);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(m.identifier))||[];return F.push(A),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(m.identifier),F),A}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const p=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(m.identifier)),D=p&&p[p.length-1];return D&&D.inputBox}$provideOriginalResource(m,p,D){const T=g.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,T.toString());const o=this._sourceControls.get(m);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(T,D)).then(A=>A||null)}$onInputBoxValueChange(m,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const D=this._sourceControls.get(m);return D&&D.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(m,p,D,T){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,p,D);const o=this._sourceControls.get(m);if(!o)return Promise.resolve(void 0);const A=o.getResourceGroup(p);return A?A.$executeResourceCommand(D,T):Promise.resolve(void 0)}$validateInput(m,p,D){this.logService.trace("ExtHostSCM#$validateInput",m);const T=this._sourceControls.get(m);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>T.inputBox.validateInput(p,D)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};i._handlePool=0,i=ze([Ve(2,n.ILogService)],i),e.ExtHostSCM=i});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[209],Ee([0,1,7,5,136,6,9]),function(te,e,g,R,S,E,k){"use strict";var y,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(d,u,f,b,w=g.StatusBarAlignment.Left,P){y.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,it(this,y,d,"f"),it(this,_,u,"f"),this._entryId=C.ID_GEN++,this._extension=f,this._id=b,this._alignment=w,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!C.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Be(this,_,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Be(this,_,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let u;this._name?u=this._name:u=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let f=this._color;this._backgroundColor&&(f=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,y,"f").$setEntry(this._entryId,d,u,this._text,b,this._command?.internal,f,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,y=new WeakMap,_=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const u={message:d};return this._messages.unshift(u),this._update(),new g.Disposable(()=>{const f=this._messages.indexOf(u);f>=0&&(this._messages.splice(f,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(d,u){this._proxy=d.getProxy(R.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(d,u,f,b){return new C(this._proxy,this._commands,d,u,f,b)}setStatusBarMessage(d,u){const f=this._statusMessage.setMessage(d);let b;return typeof u=="number"?b=setTimeout(()=>f.dispose(),u):typeof u!="undefined"&&u.then(()=>f.dispose(),()=>f.dispose()),new g.Disposable(()=>{f.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=I}),define(be[77],Ee([0,1,5,3,4]),function(te,e,g,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(y){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,_){this._proxy.$registerExtensionStorageKeysToSync(y,_)}getValue(y,_,C){return this._proxy.$getValue(y,_).then(n=>n||C)}setValue(y,_,C){return this._proxy.$setValue(y,_,C)}$acceptValue(y,_,C){this._onDidChangeStorage.fire({shared:y,key:_,value:C})}}e.ExtHostStorage=E,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(be[78],Ee([0,1,4,29,16,76,2]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let y=class{constructor(C,n,I){this._logService=n,this._extHostFileSystem=I,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(C){return k.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,n=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=ze([Ve(0,R.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,E.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(be[39],Ee([0,1,3,5,4,2,13,6,7,137,12,175,20,37,158,64,10]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(i,c,m,p){this._proxy=i,this._id=c,this._creationOptions=m,this._name=p,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const D=this;this.value={get name(){return D._name||""},get processId(){return D._pidPromise},get creationOptions(){return D._creationOptions},get exitStatus(){return D._exitStatus},sendText(T,o=!0){D._checkDisposed(),D._proxy.$sendText(D._id,T,o)},show(T){D._checkDisposed(),D._proxy.$show(D._id,T)},hide(){D._checkDisposed(),D._proxy.$hide(D._id)},dispose(){D._disposed||(D._disposed=!0,D._proxy.$dispose(D._id))},get dimensions(){if(!(D._cols===void 0||D._rows===void 0))return{columns:D._cols,rows:D._rows}}}}async create(i,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,b.withNullAsUndefined)(i.shellPath),shellArgs:(0,b.withNullAsUndefined)(i.shellArgs),cwd:(0,b.withNullAsUndefined)(i.cwd),env:(0,b.withNullAsUndefined)(i.env),icon:(0,b.withNullAsUndefined)(r(i.iconPath)),color:f.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,b.withNullAsUndefined)(i.message),strictEnv:(0,b.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(c?.useShellEnvironment),isSplitTerminal:c?.isSplitTerminal,target:c?.target})}async createExtensionTerminal(i,c,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,isSplitTerminal:i,target:c}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,c){return i===this._cols&&c===this._rows||i===0||c===0?!1:(this._cols=i,this._rows=c,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class P{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,c){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:c})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let a=1,h=class extends y.Disposable{constructor(i,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=c.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[m,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,c){const m=new w(this._proxy,(0,d.generateUuid)(),i,i.name),p=new P(i.pty);return m.createExtensionTerminal(c?.isSplitTerminal,c?.target,r(i.iconPath)).then(D=>{const T=this._setupExtHostProcessListeners(D,p);this._terminalProcessDisposables[D]=T}),this._terminals.push(m),m.value}attachPtyToTerminal(i,c){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const p=new P(c),D=this._setupExtHostProcessListeners(i,p);this._terminalProcessDisposables[i]=D}async $acceptActiveTerminalChanged(i){const c=this._activeTerminal;if(i===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(i);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,c){const m=this._getTerminalById(i);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(i,c,m){const p=this._getTerminalById(i);p&&p.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(i,c,m){this._terminalProcesses.get(i)?.resize(c,m)}async $acceptTerminalTitleChange(i,c){const m=this._getTerminalById(i);m&&(m.name=c)}async $acceptTerminalClosed(i,c){const m=this._getTerminalObjectIndexById(this._terminals,i);if(m!==null){const p=this._terminals.splice(m,1)[0];p.setExitCode(c),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(i,c,m,p){if(c){const o=this._getTerminalObjectIndexById(this._terminals,c);if(o!==null){this._terminals[o]._id=i,this._onDidOpenTerminal.fire(this.terminals[o]),this._terminals[o].isOpen=!0;return}}const D={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:E.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},T=new w(this._proxy,i,D,m);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(i,c){const m=this._getTerminalById(i);m&&m._setProcessId(c)}async $startExtensionTerminal(i,c){const m=this._getTerminalById(i);if(!m)return{message:(0,C.localize)(0,null,i)};m.isOpen||await new Promise(D=>{const T=this.onDidOpenTerminal(async o=>{o===m.value&&(T.dispose(),D())})});const p=this._terminalProcesses.get(i);p?p.startSendingEvents(c):this._extensionTerminalAwaitingStart[i]={initialDimensions:c}}_setupExtHostProcessListeners(i,c){const m=new y.DisposableStore;m.add(c.onProcessReady(D=>this._proxy.$sendProcessReady(i,D.pid,D.cwd))),m.add(c.onProcessTitleChanged(D=>this._proxy.$sendProcessTitle(i,D))),this._bufferer.startBuffering(i,c.onProcessData),m.add(c.onProcessExit(D=>this._onProcessExit(i,D))),c.onProcessOverrideDimensions&&m.add(c.onProcessOverrideDimensions(D=>this._proxy.$sendOverrideDimensions(i,D))),this._terminalProcesses.set(i,c);const p=this._extensionTerminalAwaitingStart[i];return p&&c instanceof P&&(c.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),m}$acceptProcessAckDataEvent(i,c){this._terminalProcesses.get(i)?.acknowledgeDataEvent(c)}$acceptProcessInput(i,c){this._terminalProcesses.get(i)?.input(c)}$acceptProcessResize(i,c,m){try{this._terminalProcesses.get(i)?.resize(c,m)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(i,c){this._terminalProcesses.get(i)?.shutdown(c)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(i,c))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(c=>this._proxy.$sendProcessCwd(i,c))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,i.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(i,c){const m=new l.CancellationTokenSource().token,p=await this._profileProviders.get(i)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,c);return}this.createTerminalFromOptions(p.options,c)}}async $provideLinks(i,c){const m=this._getTerminalById(i);if(!m)return[];this._terminalLinkCache.delete(i);const p=this._terminalLinkCancellationSource.get(i);p&&p.dispose(!0);const D=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,D);const T=[],o={terminal:m.value,line:c},A=[];for(const j of this._linkProviders)A.push(new Promise(async ae=>{D.token.onCancellationRequested(()=>ae({provider:j,links:[]}));const G=await j.provideTerminalLinks(o,D.token)||[];D.token.isCancellationRequested||ae({provider:j,links:G})}));const F=await Promise.all(A);if(D.token.isCancellationRequested)return[];const U=new Map;for(const j of F)j&&j.links.length>0&&T.push(...j.links.map(ae=>{const G={id:a++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return U.set(G.id,{provider:j.provider,link:ae}),G}));return this._terminalLinkCache.set(i,U),T}$activateLink(i,c){const m=this._terminalLinkCache.get(i)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(i,c){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const m=this._terminalProcessDisposables[i];m&&(m.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,c)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,c){const m=this._getTerminalObjectIndexById(i,c);return m!==null?i[m]:null}_getTerminalObjectIndexById(i,c){let m=null;return i.some((p,D)=>p._id===c?(m=D,!0):!1),m}getEnvironmentVariableCollection(i){let c=this._environmentVariableCollections.get(i.identifier.value);return c||(c=new v,this._setEnvironmentVariableCollection(i.identifier.value,c)),c}_syncEnvironmentVariableCollection(i,c){const m=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(i,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(i){i.forEach(c=>{const m=c[0],p=new v(c[1]);this._setEnvironmentVariableCollection(m,p)})}$acceptDefaultProfile(i,c){this._defaultProfile=i,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(i,c){this._environmentVariableCollections.set(i,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,c)})}};h=ze([Ve(1,k.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class v{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,c){this._setIfDiffers(i,{value:c,type:_.EnvironmentVariableMutatorType.Replace})}append(i,c){this._setIfDiffers(i,{value:c,type:_.EnvironmentVariableMutatorType.Append})}prepend(i,c){this._setIfDiffers(i,{value:c,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,c){const m=this.map.get(i);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(i,c),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,c){this.map.forEach((m,p)=>i.call(c,p,m,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends h{constructor(i){super(!1,i)}createTerminal(i,c,m){throw new n.NotSupportedError}createTerminalFromOptions(i,c){throw new n.NotSupportedError}};t=ze([Ve(0,k.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[210],Ee([0,1,24,20,3,52,43,54,6,23,10,37,5,13,67,9,7,183,99,72]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(F,U){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(l.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new r(this.proxy),U.registerArgumentProcessor({processArgument:j=>j?.$mid===13?f.TestItem.toItemFromContext(j):j})}createTestController(F,U){const j=new _.DisposableStore,ae=j.add(new w.SingleUseTestCollection(F)),G=new Map,B=this.proxy,$={items:ae.root.children,get label(){return U},set label(Z){U=Z,ae.root.label=Z,B.$updateControllerLabel(F,U)},get id(){return F},createRunProfile:(Z,V,Y,me)=>{let H=(0,k.hash)(Z);for(;G.has(H);)H++;const oe=new T(this.proxy,F,H,Z,V,Y,me);return G.set(H,oe),oe},createTestItem(Z,V,Y){return new u.TestItemImpl(F,Z,V,Y)},createTestRun:(Z,V,Y=!0)=>this.runTracker.createTestRun(F,ae,Z,V,Y),set resolveHandler(Z){ae.resolveHandler=Z},get resolveHandler(){return ae.resolveHandler},dispose:()=>{j.dispose()}};$.createRunConfiguration=$.createRunProfile,B.$registerTestController(F,U),j.add((0,_.toDisposable)(()=>B.$unregisterTestController(F)));const L={controller:$,collection:ae,profiles:G};return this.controllers.set(F,L),j.add((0,_.toDisposable)(()=>this.controllers.delete(F))),j.add(ae.onDidGenerateDiff(Z=>B.$publishDiff(F,Z))),$}createTestObserver(){return this.observer.checkout()}async runTests(F,U=R.CancellationToken.None){const j=s(F);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ae=this.controllers.get(j.controllerId);if(!ae)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(G=>G.id)??[ae.collection.root.id],profileGroup:o[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:F.exclude?.map(G=>({testId:G.id,controllerId:j.controllerId}))},U)}$provideFileCoverage(F,U,j){return y.Iterable.find(this.runTracker.trackers,ae=>ae.id===F)?.getCoverage(U)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(F,U,j,ae){return y.Iterable.find(this.runTracker.trackers,G=>G.id===F)?.getCoverage(U)?.resolveFileCoverage(j,ae)??Promise.resolve([])}$configureRunProfile(F,U){this.controllers.get(F)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(F){this.results=Object.freeze(F.map(U=>(0,C.deepFreeze)(f.TestResults.to(U))).concat(this.results).sort((U,j)=>j.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:F,testId:U},j){const ae=this.controllers.get(F)?.collection;ae&&(await ae.expand(U,j<0?Infinity:j),ae.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,U){const j=this.controllers.get(F.controllerId);if(!j)return;const{collection:ae,profiles:G}=j,B=G.get(F.profileId);if(!B)return;const $=F.testIds.map(Y=>ae.tree.get(Y)).filter(n.isDefined),L=F.excludeExtIds.map(Y=>j.collection.tree.get(Y)).filter(n.isDefined).filter(Y=>$.some(me=>me.fullId.compare(Y.fullId)===2));if(!$.length)return;const Z=new b.TestRunRequest($.some(Y=>Y.actual instanceof u.TestItemRootImpl)?void 0:$.map(Y=>Y.actual),L.map(Y=>Y.actual),B),V=this.runTracker.prepareForMainThreadTestRun(Z,i.fromInternal(F,j.collection),U);try{await B.runHandler(Z,U)}finally{V.isRunning&&!U.isCancellationRequested&&await S.Event.toPromise(V.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};v=ze([Ve(0,d.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends _.Disposable{constructor(F,U,j){super();this.dto=F,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(j)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ae}of this.tasks.values())ae.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const U=this.dto.id,j=this.dto.controllerId,ae=(0,I.generateUuid)(),G=new c(this.proxy,U,ae),B=Z=>(V,...Y)=>{if($){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),Z(V,...Y))};let $=!1;const L={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return G.coverageProvider},set coverageProvider(Z){G.coverageProvider=Z},enqueued:B(Z=>{this.proxy.$updateTestStateInRun(U,ae,a.TestId.fromExtHostTestItem(Z,j).toString(),1)}),skipped:B(Z=>{this.proxy.$updateTestStateInRun(U,ae,a.TestId.fromExtHostTestItem(Z,j).toString(),5)}),started:B(Z=>{this.proxy.$updateTestStateInRun(U,ae,a.TestId.fromExtHostTestItem(Z,j).toString(),2)}),failed:B((Z,V,Y)=>{this.proxy.$appendTestMessagesInRun(U,ae,a.TestId.fromExtHostTestItem(Z,j).toString(),V instanceof Array?V.map(f.TestMessage.from):[f.TestMessage.from(V)]),this.proxy.$updateTestStateInRun(U,ae,a.TestId.fromExtHostTestItem(Z,j).toString(),4,Y)}),passed:B((Z,V)=>{this.proxy.$updateTestStateInRun(U,ae,a.TestId.fromExtHostTestItem(Z,this.dto.controllerId).toString(),3,V)}),appendOutput:Z=>{$||this.proxy.$appendOutputToRun(U,ae,g.VSBuffer.fromString(Z))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(U,ae),this.tasks.delete(ae),this.isRunning||this.dispose())}};return this.tasks.set(ae,{run:L,coverage:G}),this.proxy.$startedTestRunTask(U,{id:ae,name:F,running:!0}),L}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof u.TestItemImpl))throw new u.InvalidTestItemError(F.id);if(this.sharedTestIds.has(F.id))return;const U=[];for(;U.unshift(f.TestItem.from(F)),!(this.sharedTestIds.has(F.id)||(this.sharedTestIds.add(F.id),!F.parent));)F=F.parent;const j=this.dto.colllection.root;this.sharedTestIds.has(j.id)||(this.sharedTestIds.add(j.id),U.unshift(f.TestItem.from(j))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class r{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,U,j){return this.getTracker(F,U,j)}cancelRunById(F){for(const U of this.tracked.values())if(U.id===F){U.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,U,j,ae,G){const B=this.tracked.get(j);if(B)return B.createRun(ae);const $=i.fromPublic(F,U,j,G),L=s(j);this.proxy.$startedExtensionTestRun({controllerId:F,profile:L&&{group:o[L.kind],id:L.profileId},exclude:j.exclude?.map(V=>V.id)??[],id:$.id,include:j.include?.map(V=>V.id)??[U.root.id],persist:G});const Z=this.getTracker(j,$);return Z.onEnd(()=>this.proxy.$finishedExtensionTestRun($.id)),Z.createRun(ae)}getTracker(F,U,j){const ae=new t(U,this.proxy,j);return this.tracked.set(F,ae),ae.onEnd(()=>this.tracked.delete(F)),ae}}e.TestRunCoordinator=r;const s=A=>{if(!!A.profile){if(!(A.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class i{constructor(F,U,j,ae,G,B){this.controllerId=F,this.id=U,this.isPersisted=G,this.colllection=B,this.includePrefix=j.map($=>$+"\0"),this.excludePrefix=ae.map($=>$+"\0")}static fromPublic(F,U,j,ae){return new i(F,(0,I.generateUuid)(),j.include?.map(G=>a.TestId.fromExtHostTestItem(G,F).toString())??[F],j.exclude?.map(G=>a.TestId.fromExtHostTestItem(G,F).toString())??[],ae,U)}static fromInternal(F,U){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,U)}isIncluded(F){const U=a.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const j of this.excludePrefix)if(U===j||U.startsWith(j))return!1;for(const j of this.includePrefix)if(U===j||U.startsWith(j))return!0;return!1}}e.TestRunDto=i;class c{constructor(F,U,j){this.proxy=F,this.runId=U,this.taskId=j}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(f.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(F,U){const j=await this.fileCoverage;let ae=j?.[F];return!this._coverageProvider||!j||!ae?[]:(ae.detailedCoverage||(ae=j[F]=await this._coverageProvider.resolveFileCoverage?.(ae,U)??ae),ae.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class m extends P.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,f.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:U,removed:j}=this;return{get added(){return[...F].map(ae=>ae.revived)},get updated(){return[...U].map(ae=>ae.revived)},get removed(){return[...j].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,U){return{...F,revived:f.TestItem.toPlain(F.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=p;class D{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(U=>U.revived)},dispose:(0,E.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class T{constructor(F,U,j,ae,G,B,$=!1){this.controllerId=U,this.profileId=j,this._label=ae,this.kind=G,this.runHandler=B,this._isDefault=$,h.set(this,void 0),it(this,h,F,"f");const L=o[G];if(typeof L!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Be(this,h,"f").$publishTestRunProfile({profileId:j,controllerId:U,label:ae,group:L,isDefault:$,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Be(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Be(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Be(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Be(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,h=new WeakMap;const o={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(be[211],Ee([0,1,3,17,5,102,9,7]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(l=>l.value)}async showTextDocument(n,I,l){let d;typeof I=="number"?d={position:k.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?d={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:d={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,d),f=u&&this._extHostDocumentsAndEditors.getEditor(u);if(f)return f.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new E.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const d=I.selections.selections.map(k.Selection.to);l._acceptSelections(d)}if(I.visibleRanges){const d=R.coalesce(I.visibleRanges.map(k.Range.to));l._acceptVisibleRanges(d)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...I.options,lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const d=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),u=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:u,kind:d})}if(I.visibleRanges){const d=R.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:d})}}$acceptEditorPositionData(n){for(const I in n){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const d=k.ViewColumn.to(n[I]);l.value.viewColumn!==d&&(l._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:d}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_}),define(be[212],Ee([0,1,2,4,5,6,7]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class y{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const d=l.uri===void 0?void 0:g.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(d))?.get(l.handle)}return l}})}async $getTimeline(n,I,l,d,u){return this._providers.get(n)?.provideTimeline(g.URI.revive(I),l,d,u)}registerTimelineProvider(n,I,l,d){const u=new E.DisposableStore,f=this.convertTimelineItem(I.id,d,u).bind(this);let b;I.onDidChange&&(b=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:n,onDidChange:void 0,async provideTimeline(P,a,h,v){v?.resetCache&&(u.clear(),w.get(I.id)?.clear());const t=await I.provideTimeline(P,a,h);if(t==null)return;const r=f(P,v);return{...t,source:I.id,items:t.items.map(r)}},dispose(){for(const P of w.values())P.get(I.id)?.clear();b?.dispose(),u.dispose()}})}convertTimelineItem(n,I,l){return(d,u)=>{let f;if(u?.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const w=_(d);f=b.get(w),f===void 0&&(f=new Map,b.set(w,f))}return b=>{const{iconPath:w,...P}=b,a=`${n}|${b.id??b.timestamp}`;f?.set(a,b);let h,v,t;return b.iconPath&&(w instanceof k.ThemeIcon?t={id:w.id,color:w.color}:g.URI.isUri(w)?(h=w,v=w):{light:h,dark:v}=w),{...P,id:P.id??void 0,handle:a,source:n,command:b.command?I.toInternal(b.command,l):void 0,icon:h,iconDark:v,themeIcon:t,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,E.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=y;function _(C){return C?.toString()}}),define(be[213],Ee([0,1,6,11,2,5]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(_){this._openers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,n,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const l=I.schemes.find(d=>!k.supportedSchemes.has(d));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,I.schemes,_,I.label),(0,g.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const l=S.URI.revive(C);return I.canOpenExternalUri(l,n)}async $openUri(_,C,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[214],Ee([0,1,5,2,6,12,26]),function(te,e,g,R,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=y.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,C),(0,S.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,n){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(n))}catch(l){(0,E.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=y,y.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[49],Ee([0,1,3,2,147,167,70,5]),function(te,e,g,R,S,E,k,y){"use strict";var _,C,n,I,l,d,u,f,b,w,P,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(p,D,T,o,A,F,U){_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,void 0),l.set(this,void 0),d.set(this,void 0),u.set(this,""),f.set(this,void 0),b.set(this,!1),w.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=Be(this,a,"f").event,it(this,_,p,"f"),it(this,C,D,"f"),it(this,f,T,"f"),it(this,I,o,"f"),it(this,l,A,"f"),it(this,d,F,"f"),it(this,P,v(F),"f"),it(this,n,U,"f")}dispose(){it(this,b,!0,"f"),Be(this,a,"f").fire(),Be(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return it(this,w,!0,"f"),(0,k.asWebviewUri)(p,Be(this,I,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,u,"f")}set html(p){this.assertNotDisposed(),Be(this,u,"f")!==p&&(it(this,u,p,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(it(this,w,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,C,"f").$setHtml(Be(this,_,"f"),p))}get options(){return this.assertNotDisposed(),Be(this,f,"f")}set options(p){this.assertNotDisposed(),Be(this,C,"f").$setOptions(Be(this,_,"f"),s(Be(this,d,"f"),Be(this,l,"f"),p)),it(this,f,p,"f")}async postMessage(p){if(Be(this,b,"f"))return!1;const D=(0,E.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Be(this,P,"f")});return Be(this,C,"f").$postMessage(Be(this,_,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Be(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,_=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,u=new WeakMap,f=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap;function v(m){try{const p=(0,S.normalizeVersion)((0,S.parseVersion)(m.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(p,D,T,o,A){this.initData=D,this.workspace=T,this._logService=o,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,D,...T){const o=this.getWebview(p);if(o){const{message:A}=(0,E.deserializeWebviewMessage)(D,T);o._onMessageEmitter.fire(A)}}$onMissingCsp(p,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,D,T){const o=new h(p,this._webviewProxy,i(D),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(p,o),o._onDidDispose(()=>{this._webviews.delete(p)}),o}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function r(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=r;function s(m,p,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||c(m,p)}}e.serializeWebviewOptions=s;function i(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(p=>R.URI.from(p))}}e.reviveOptions=i;function c(m,p){return[...(p?.getWorkspaceFolders()||[]).map(D=>D.uri),m.extensionLocation]}}),define(be[215],Ee([0,1,20,43,6,11,25,2,9,49,65,5,7]),function(te,e,g,R,S,E,k,y,_,C,n,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const c=new d(r,s);return this._documents.set(i,c),c}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var f;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(f||(f={}));class b{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,s,i,c){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new b,this._documents=new u,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const c=new S.DisposableStore;return P(s)?(c.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&c.add(s.onDidChangeCustomDocument(m=>{const p=this.getCustomDocumentEntry(r,m.document.uri);if(a(m)){const D=p.addEdit(m);this._proxy.$onDidEdit(m.document.uri,r,D,m.label)}else this._proxy.$onContentChange(m.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,c){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${r}'`);const p=y.URI.revive(t),D=await m.provider.openCustomDocument(p,{backupId:s,untitledDocumentData:i?.buffer},c);let T;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(r,D,T),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=y.URI.revive(t),{document:c}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,c),c.dispose()}async $resolveWebviewEditor(t,r,s,i,c,m){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const D=_.ViewColumn.to(c),T=this._extHostWebview.createNewWebview(r,i.webviewOptions,p.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,D,i.panelOptions,T),A=y.URI.revive(t);switch(p.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,A);return p.provider.resolveCustomEditor(F,o,m)}case 0:{const F=this._extHostDocuments.getDocument(A);return p.provider.resolveCustomTextEditor(F,o,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const m=y.URI.revive(r),p=this._extHostDocuments.getDocument(m);await i.provider.moveCustomTextEditor(p,c,g.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const c=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(c.document,y.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),m=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(m),m.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,y.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function P(v){return typeof v.resolveCustomTextEditor=="function"}function a(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function h(v){const t=v.scheme===E.Schemas.file||v.scheme===E.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[216],Ee([0,1,3,6,2,37,9,49,5,7]),function(te,e,g,R,S,E,k,y,_,C){"use strict";var n,I,l,d,u,f,b,w,P,a,h,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(m,p,D,T,o,A,F){super();n.set(this,void 0),I.set(this,void 0),l.set(this,void 0),d.set(this,void 0),u.set(this,void 0),f.set(this,void 0),b.set(this,void 0),w.set(this,void 0),P.set(this,!0),a.set(this,!0),h.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,v,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,n,m,"f"),it(this,I,p,"f"),it(this,l,D,"f"),it(this,u,A,"f"),it(this,w,o,"f"),it(this,f,T,"f"),it(this,d,F,"f")}dispose(){Be(this,h,"f")||(it(this,h,!0,"f"),Be(this,v,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,n,"f")),Be(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,d,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,f,"f")}set title(m){this.assertNotDisposed(),Be(this,f,"f")!==m&&(it(this,f,m,"f"),Be(this,I,"f").$setTitle(Be(this,n,"f"),m))}get iconPath(){return this.assertNotDisposed(),Be(this,b,"f")}set iconPath(m){this.assertNotDisposed(),Be(this,b,"f")!==m&&(it(this,b,m,"f"),Be(this,I,"f").$setIconPath(Be(this,n,"f"),S.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,a,"f")}get visible(){return this.assertNotDisposed(),Be(this,P,"f")}_updateViewState(m){Be(this,h,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(it(this,a,m.active,"f"),it(this,P,m.visible,"f"),it(this,w,m.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(m,p){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,n,"f"),{viewColumn:m?k.ViewColumn.from(m):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Be(this,h,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,u=new WeakMap,f=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap,h=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(m,p,D){this.webviews=p,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,E.generateUuid)()}createWebviewPanel(m,p,D,T,o={}){const A=typeof T=="object"?T.viewColumn:T,F={viewColumn:k.ViewColumn.from(A),preserveFocus:typeof T=="object"&&!!T.preserveFocus},U=(0,y.shouldSerializeBuffersForPostMessage)(m),j=s.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(m),j,p,{title:D,panelOptions:i(o),webviewOptions:(0,y.serializeWebviewOptions)(m,this.workspace,o),serializeBuffersForPostMessage:U},F);const ae=this.webviews.createNewWebview(j,o,m);return this.createNewWebviewPanel(j,p,D,A,o,ae)}$onDidChangeWebviewPanelViewStates(m){const p=Object.keys(m);p.sort((D,T)=>{const o=m[D],A=m[T];return o.active?1:A.active?-1:+o.visible-+A.visible});for(const D of p){const T=this.getWebviewPanel(D);if(!T)continue;const o=m[D];T._updateViewState({active:o.active,visible:o.visible,viewColumn:k.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,p,D){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:D,extension:m}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(m)}),new C.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(m,p,D,T){const o=this._serializers.get(p);if(!o)throw new Error(`No serializer found for '${p}'`);const{serializer:A,extension:F}=o,U=this.webviews.createNewWebview(m,D.webviewOptions,F),j=this.createNewWebviewPanel(m,p,D.title,T,D.panelOptions,U);await A.deserializeWebviewPanel(j,D.state)}createNewWebviewPanel(m,p,D,T,o,A){const F=new r(m,this._proxy,p,D,T,o,A);return this._webviewPanels.set(m,F),F}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=s;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[217],Ee([0,1,3,6,49,5,7]),function(te,e,g,R,S,E,k){"use strict";var y,_,C,n,I,l,d,u,f,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(h,v,t,r,s,i){super();y.set(this,void 0),_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,!1),l.set(this,void 0),d.set(this,void 0),u.set(this,void 0),f.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Be(this,f,"f").event,b.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,b,"f").event,it(this,C,t,"f"),it(this,d,r,"f"),it(this,y,h,"f"),it(this,_,v,"f"),it(this,n,s,"f"),it(this,l,i,"f")}dispose(){Be(this,I,"f")||(it(this,I,!0,"f"),Be(this,b,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,d,"f")}set title(h){this.assertNotDisposed(),Be(this,d,"f")!==h&&(it(this,d,h,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,y,"f"),h))}get description(){return this.assertNotDisposed(),Be(this,u,"f")}set description(h){this.assertNotDisposed(),Be(this,u,"f")!==h&&(it(this,u,h,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,y,"f"),h))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,C,"f")}_setVisible(h){h===Be(this,l,"f")||Be(this,I,"f")||(it(this,l,h,"f"),Be(this,f,"f").fire())}show(h){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,y,"f"),!!h)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,_=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,u=new WeakMap,f=new WeakMap,b=new WeakMap;class P{constructor(h,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(h),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(h,v,t,r,s){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:m}=i,p=this._extHostWebview.createNewWebview(h,{},m),D=new w(h,this._proxy,v,t,p,!0);this._webviewViews.set(h,D),await c.resolveWebviewView(D,{state:r},s)}async $onDidChangeWebviewViewVisibility(h,v){this.getWebviewView(h)._setVisible(v)}async $disposeWebviewView(h){const v=this.getWebviewView(h);this._webviewViews.delete(h),v.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const v=this._webviewViews.get(h);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=P}),define(be[106],Ee([0,1,3,5,2,11,8,4,13]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Bn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let d;if(typeof I=="string"){d=I;try{I=S.URI.parse(I)}catch(u){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,k.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,d,l)}async asExternalUri(I,l){if((0,k.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(I,l);return S.URI.from(d)}};C.InitialState={focused:!0},C=ze([Ve(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(be[218],Ee([0,1,16,5,29,13]),function(te,e,g,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends g.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(R.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};k=ze([Ve(0,E.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(be[219],Ee([0,1,15,20,12,3,6,117,188,103,24]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,c){try{return JSON.stringify(i,c)}catch(m){return"null"}}function d(i,c){return JSON.stringify(i,c)}function u(i){return i?(c,m)=>m&&m.$mid===1?i.transformOutgoing(m):m:null}var f;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},P=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class h extends k.Disposable{constructor(c,m=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=m,this._uriTransformer=p,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,T=C.ProxyIdentifier.count;D<T;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,y.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:m,sid:p}=c;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,p)),this._proxies[m]}_createProxy(c,m){let p={get:(D,T)=>(typeof T=="string"&&!D[T]&&T.charCodeAt(0)===36&&(D[T]=(...o)=>this._remoteCall(c,T,o)),T===a?m:D[T])};return new Proxy(Object.create(null),p)}set(c,m){return this._locals[c.nid]=m,m}assertRegistered(c){for(let m=0,p=c.length;m<p;m++){const D=c[m];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const m=c.byteLength,p=v.read(c,0),D=p.readUInt8(),T=p.readUInt32();switch(D){case 1:case 2:{let{rpcId:o,method:A,args:F}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(m,T,o,A,F,D===2);break}case 3:case 4:{let{rpcId:o,method:A,args:F}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(m,T,o,A,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(m,T,0,"ack"),this._onDidReceiveAcknowledge(T);break}case 6:{this._receiveCancel(m,T);break}case 7:{this._receiveReply(m,T,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(p);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(m,T,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(p);this._receiveReply(m,T,o);break}case 10:{let o=t.deserializeReplyErrError(p);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(m,T,o);break}case 11:{this._receiveReplyErr(m,T,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,m,p,D,T,o){this._logger&&this._logger.logIncoming(c,m,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(p)}.${D}(`,T);const A=String(m);let F,U;if(o){const ae=new R.CancellationTokenSource;T.push(ae.token),F=this._invokeHandler(p,D,T),U=()=>ae.cancel()}else F=this._invokeHandler(p,D,T),U=w;this._cancelInvokedHandlers[A]=U;const j=t.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(j.byteLength,m,1,"ack"),this._protocol.send(j),F.then(ae=>{delete this._cancelInvokedHandlers[A];const G=t.serializeReplyOK(m,ae,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,m,1,"reply:",ae),this._protocol.send(G)},ae=>{delete this._cancelInvokedHandlers[A];const G=t.serializeReplyErr(m,ae);this._logger&&this._logger.logOutgoing(G.byteLength,m,1,"replyErr:",ae),this._protocol.send(G)})}_receiveCancel(c,m){this._logger&&this._logger.logIncoming(c,m,1,"receiveCancel");const p=String(m);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(c,m,p){this._logger&&this._logger.logIncoming(c,m,0,"receiveReply:",p);const D=String(m);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],T.resolveOk(p)}_receiveReplyErr(c,m,p){this._logger&&this._logger.logIncoming(c,m,0,"receiveReplyErr:",p);const D=String(m);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let o;p&&(p.$isError?(o=new Error,o.name=p.name,o.message=p.message,o.stack=p.stack):o=p),T.resolveErr(o)}_invokeHandler(c,m,p){try{return Promise.resolve(this._doInvokeHandler(c,m,p))}catch(D){return Promise.reject(D)}}_doInvokeHandler(c,m,p){const D=this._locals[c];if(!D)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(c));let T=D[m];if(typeof T!="function")throw new Error("Unknown method "+m+" on actor "+(0,C.getStringIdentifierForProxy)(c));return T.apply(D,p)}_remoteCall(c,m,p){if(this._isDisposed)return Promise.reject(S.canceled());let D=null;if(p.length>0&&R.CancellationToken.isCancellationToken(p[p.length-1])&&(D=p.pop()),D&&D.isCancellationRequested)return Promise.reject(S.canceled());const T=t.serializeRequestArguments(p,this._uriReplacer),o=++this._lastMessageId,A=String(o),F=new _.LazyPromise;D&&D.onCancellationRequested(()=>{const j=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(j.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[A]=F,this._onWillSendRequest(o);const U=t.serializeRequest(o,c,m,T,!!D);return this._logger&&this._logger.logOutgoing(U.byteLength,o,0,`request: ${(0,C.getStringIdentifierForProxy)(c)}.${m}(`,p),this._protocol.send(U),F}}e.RPCProtocol=h,I=P,h.UNRESPONSIVE_TIME=3*1e3;class v{constructor(c,m){this._buff=c,this._offset=m}static alloc(c,m,p){let D=new v(n.VSBuffer.alloc(p+1+4),0);return D.writeUInt8(c),D.writeUInt32(m),D}static read(c,m){return new v(c,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,m}static sizeMixedArray(c,m){let p=0;p+=1;for(let D=0,T=c.length;D<T;D++){const o=c[D],A=m[D];switch(p+=1,A){case 1:p+=this.sizeLongString(o);break;case 2:p+=this.sizeVSBuffer(o);break;case 3:break}}return p}writeMixedArray(c,m){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let p=0,D=c.length;p<D;p++){const T=c[p];switch(m[p]){case 1:this.writeUInt8(1),this.writeLongString(T);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(c);for(let p=0;p<c;p++)switch(this.readUInt8()){case 1:m[p]=this.readLongString();break;case 2:m[p]=this.readVSBuffer();break;case 3:m[p]=void 0;break}return m}}class t{static _arrayContainsBufferOrUndefined(c){for(let m=0,p=c.length;m<p;m++)if(c[m]instanceof n.VSBuffer||typeof c[m]=="undefined")return!0;return!1}static serializeRequestArguments(c,m){if(this._arrayContainsBufferOrUndefined(c)){let p=[],D=[];for(let T=0,o=c.length;T<o;T++){const A=c[T];A instanceof n.VSBuffer?(p[T]=A,D[T]=2):typeof A=="undefined"?(p[T]=n.VSBuffer.alloc(0),D[T]=3):(p[T]=n.VSBuffer.fromString(d(A,m)),D[T]=1)}return{type:"mixed",args:p,argsType:D}}return{type:"simple",args:d(c,m)}}static serializeRequest(c,m,p,D,T){return D.type==="mixed"?this._requestMixedArgs(c,m,p,D.args,D.argsType,T):this._requestJSONArgs(c,m,p,D.args,T)}static _requestJSONArgs(c,m,p,D,T){const o=n.VSBuffer.fromString(p),A=n.VSBuffer.fromString(D);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(o),F+=v.sizeLongString(A);let U=v.alloc(T?2:1,c,F);return U.writeUInt8(m),U.writeShortString(o),U.writeLongString(A),U.buffer}static deserializeRequestJSONArgs(c){const m=c.readUInt8(),p=c.readShortString(),D=c.readLongString();return{rpcId:m,method:p,args:JSON.parse(D)}}static _requestMixedArgs(c,m,p,D,T,o){const A=n.VSBuffer.fromString(p);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(A),F+=v.sizeMixedArray(D,T);let U=v.alloc(o?4:3,c,F);return U.writeUInt8(m),U.writeShortString(A),U.writeMixedArray(D,T),U.buffer}static deserializeRequestMixedArgs(c){const m=c.readUInt8(),p=c.readShortString(),D=c.readMixedArray(),T=new Array(D.length);for(let o=0,A=D.length;o<A;o++){const F=D[o];typeof F=="string"?T[o]=JSON.parse(F):T[o]=F}return{rpcId:m,method:p,args:T}}static serializeAcknowledged(c){return v.alloc(5,c,0).buffer}static serializeCancel(c){return v.alloc(6,c,0).buffer}static serializeReplyOK(c,m,p){return typeof m=="undefined"?this._serializeReplyOKEmpty(c):m instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,m):this._serializeReplyOKJSON(c,l(m,p))}static _serializeReplyOKEmpty(c){return v.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,m){let p=0;p+=v.sizeVSBuffer(m);let D=v.alloc(8,c,p);return D.writeVSBuffer(m),D.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,m){const p=n.VSBuffer.fromString(m);let D=0;D+=v.sizeLongString(p);let T=v.alloc(9,c,D);return T.writeLongString(p),T.buffer}static deserializeReplyOKJSON(c){const m=c.readLongString();return JSON.parse(m)}static serializeReplyErr(c,m){return m?this._serializeReplyErrEror(c,m):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,m){const p=n.VSBuffer.fromString(l(S.transformErrorForSerialization(m),null));let D=0;D+=v.sizeLongString(p);let T=v.alloc(10,c,D);return T.writeLongString(p),T.buffer}static deserializeReplyErrError(c){const m=c.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(c){return v.alloc(11,c,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(be[220],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(E){const k=y=>{self.removeEventListener("message",k);const _=y.data;Object.defineProperties(self,{postMessage:{value(C,n){_.postMessage(C,n)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",k)}.toString();class R extends EventTarget{constructor(E,k,y){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${g})('${k}'))`,C=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(C),I=new MessageChannel,l=n,d={type:"_newWorker",id:l,port:I.port2,url:n,options:y};E(d,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:l};I.port1.postMessage(u),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(u){I.port1.onmessage=u}},onmessageerror:{get(){return I.port1.onmessageerror},set(u){I.port1.onmessageerror=u}}}),I.port1.addEventListener("messageerror",u=>{const f=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(f)}),I.port1.addEventListener("message",u=>{const f=new MessageEvent("message",{data:u.data});this.dispatchEvent(f)}),I.port1.start()}}e.NestedWorker=R}),define(be[221],Ee([0,1,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(be[222],Ee([0,1,11,14,22,2,4,96,46,184,221]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let I=class $n{constructor(d,u,f,b){this.localUserHome=d,this.remoteAgentService=u,this.environmentService=f,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||S.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||d})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,u){if(d.remoteAuthority)return g.Schemas.vscodeRemote;const f=(0,y.getVirtualWorkspaceScheme)(u.getWorkspace());if(f)return f;const b=u.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:g.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?R.win32:R.posix)}async fileURI(d){let u="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const b=d.indexOf("/",2);b===-1?(u=d.substring(2),d="/"):(u=d.substring(2,b),d=d.substring(b)||"/")}return E.URI.from({scheme:g.Schemas.file,authority:u,path:d,query:"",fragment:""})}};I=ze([Ve(1,n.IRemoteAgentService),Ve(2,C.IWorkbenchEnvironmentService),Ve(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(be[107],Ee([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(k,y){this.line=k,this.character=y}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,y){return new g(0,0)}with(k){return new g(0,0)}}e.Position=g;class R{constructor(k,y,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(k,y),this.end=new g(_,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new R(0,0,0,0)}with(k){return new R(0,0,0,0)}}e.Range=R;var S;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[40],Ee([0,1,17,27,23,44,8,4,14,12,107]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",d=(I.length+l.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var u;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function b(L){return!!L.preview}e.resultIsMatch=b;function w(L){return!!L.resource}e.isFileMatch=w;function P(L){return!!L.message}e.isProgressMessage=P;var a;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=h;class v{constructor(Z,V,Y){this.ranges=V;const me=Array.isArray(V)?V:[V];if(Y&&Y.matchLines===1&&t(me)){Z=(0,k.getNLines)(Z,Y.matchLines);let H="",oe=0,de=0;const Ce=Math.floor(Y.charsPerLine/5),Ne=[];for(const Me of me){const $e=Math.max(Me.startColumn-Ce,0),Xe=Me.startColumn+Y.charsPerLine;if($e>de+Ce+d){const qe=I+($e-de)+l;H+=qe+Z.slice($e,Xe),oe+=$e-(de+qe.length)}else H+=Z.slice(de,Xe);Ne.push(new s(0,Me.startColumn-oe,Me.endColumn-oe)),de=Xe}this.preview={text:H,matches:Array.isArray(this.ranges)?Ne:Ne[0]}}else{const H=Array.isArray(V)?V[0].startLineNumber:V.startLineNumber;this.preview={text:Z,matches:(0,g.mapArrayOrNot)(V,oe=>new r(oe.startLineNumber-H,oe.startColumn,oe.endLineNumber-H,oe.endColumn))}}}}e.TextSearchMatch=v;function t(L){const Z=L[0].startLineNumber;for(const V of L)if(V.startLineNumber!==Z||V.endLineNumber!==Z)return!1;return!0}class r{constructor(Z,V,Y,me){this.startLineNumber=Z,this.startColumn=V,this.endLineNumber=Y,this.endColumn=me}}e.SearchRange=r;class s extends r{constructor(Z,V,Y){super(Z,V,Z,Y)}}e.OneLineRange=s;var i;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(L,Z=!0){const V=L&&L.files&&L.files.exclude,Y=Z&&L&&L.search&&L.search.exclude;if(!V&&!Y)return;if(!V||!Y)return V||Y;let me=Object.create(null);return me=S.mixin(me,S.deepClone(V)),me=S.mixin(me,S.deepClone(Y),!0),me}e.getExcludes=c;function m(L,Z){return L.excludePattern&&R.match(L.excludePattern,Z)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&R.match(L.includePattern,Z)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(V=>{const Y=V.folder.fsPath;if(E.isEqualOrParent(Z,Y)){const me=_.relative(Y,Z);return!V.includePattern||!!R.match(V.includePattern,me)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var p;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(Z,V){super(Z);this.code=V}}e.SearchError=D;function T(L){const Z=L.message;if((0,C.isPromiseCanceledError)(L))return new D(Z,p.canceled);try{const V=JSON.parse(Z);return new D(V.message,V.code)}catch(V){return new D(Z,p.other)}}e.deserializeSearchError=T;function o(L){const Z={message:L.message,code:L.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=o;function A(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=A;function F(L){return L.type==="success"}e.isSerializedSearchSuccess=F;function U(L){return!!L.path}e.isSerializedFileMatch=U;function j(L,Z){const V=L.searchPath?L.searchPath:L.relativePath;return(0,k.fuzzyContains)(V,Z)}e.isFilePatternMatch=j;class ae{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ae;function G(L,Z){const V={...L||{},...Z||{}};return Object.keys(V).filter(Y=>{const me=V[Y];return typeof me=="boolean"&&me})}e.resolvePatternsForProvider=G;class B{constructor(Z,V){this._parsedIncludeExpression=null,this._excludeExpression={...Z.excludePattern||{},...V.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let Y=Z.includePattern;V.includePattern&&(Y?Y={...Y,...V.includePattern}:Y=V.includePattern),Y&&(this._parsedIncludeExpression=R.parse(Y))}includedInQuerySync(Z,V,Y){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,V,Y)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Z,V,Y))}includedInQuery(Z,V,Y){return Promise.resolve(this._parsedExcludeExpression(Z,V,Y)).then(H=>!!H).then(H=>H?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(Z,V,Y)).then(oe=>!!oe):Promise.resolve(!0)).then(H=>H)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=B;function $(L){for(const Z in L)if(typeof L[Z]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,17,15,20,3,21,11,81,25,8,10,2,139,4,16,154,46,47,29,13,7,40,5]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a,h,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(A,F,U){return new C.ExtUri(j=>p(j,U)).isEqual(A,F)}function i(A,F,U){return s(A.uri,F.uri,U)?0:(0,n.compare)(A.uri.toString(),F.uri.toString())}function c(A,F,U){return A.index!==F.index?A.index<F.index?-1:1:s(A.uri,F.uri,U)?(0,n.compare)(A.name,F.name):(0,n.compare)(A.uri.toString(),F.uri.toString())}function m(A,F,U,j){const ae=A.slice(0).sort((B,$)=>U(B,$,j)),G=F.slice(0).sort((B,$)=>U(B,$,j));return(0,g.delta)(ae,G,(B,$)=>U(B,$,j))}function p(A,F){const U=F.getCapabilities(A.scheme);return!(U&&U&1024)}class D extends w.Workspace{constructor(F,U,j,ae,G,B){super(F,j.map($=>new w.WorkspaceFolder($)),ae,B);this._name=U,this._isUntitled=G,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(B),j.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(F,U,j,ae){if(!F)return{workspace:null,added:[],removed:[]};const{id:G,name:B,folders:$,configuration:L,isUntitled:Z}=F,V=[],Y=U;U?$.forEach((de,Ce)=>{const Ne=l.URI.revive(de.uri),Me=D._findFolder(j||U,Ne,ae);Me?(Me.name=de.name,Me.index=de.index,V.push(Me)):V.push({uri:Ne,name:de.name,index:Ce})}):V.push(...$.map(({uri:de,name:Ce,index:Ne})=>({uri:l.URI.revive(de),name:Ce,index:Ne}))),V.sort((de,Ce)=>de.index<Ce.index?-1:1);const me=new D(G,B,V,L?l.URI.revive(L):null,!!Z,de=>p(de,ae)),{added:H,removed:oe}=m(Y?Y.workspaceFolders:[],me.workspaceFolders,i,ae);return{workspace:me,added:H,removed:oe}}static _findFolder(F,U,j){for(let ae=0;ae<F.folders.length;ae++){const G=F.workspaceFolders[ae];if(s(G.uri,U,j))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,U){return U&&this._structure.get(F)&&(F=(0,C.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let T=class{constructor(F,U,j,ae){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ae,this._extHostFileSystemInfo=j,this._requestIdProvider=new _.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const G=U.workspace;this._confirmedWorkspace=G?new D(G.id,G.name,[],G.configuration?l.URI.revive(G.configuration):null,!!G.isUntitled,B=>p(B,j)):void 0}$initializeWorkspace(F,U){this._trusted=U,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:y.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,U,j,...ae){const G=[];if(Array.isArray(ae)&&ae.forEach(V=>{l.URI.isUri(V.uri)&&!G.some(Y=>s(Y.uri,V.uri,this._extHostFileSystemInfo))&&G.push({uri:V.uri,name:V.name||(0,C.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[U,j].some(V=>typeof V!="number"||V<0)||j===0&&G.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+j>B.length)return!1;const $=B.slice(0);$.splice(U,j,...G.map(V=>({uri:V.uri,name:V.name||(0,C.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<$.length;V++){const Y=$[V];if($.some((me,H)=>H!==V&&s(Y.uri,me.uri,this._extHostFileSystemInfo)))return!1}$.forEach((V,Y)=>V.index=Y);const{added:L,removed:Z}=m(B,$,c,this._extHostFileSystemInfo);if(L.length===0&&Z.length===0)return!1;if(this._proxy){const V=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(V,U,j,G).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,d.localize)(0,null,V,Y.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(F,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,U)}async getWorkspaceFolder2(F,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,U)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,U){let j,ae="";if(typeof F=="string"?(j=l.URI.file(F),ae=F):typeof F!="undefined"&&(j=F,ae=F.fsPath),!j)return ae;const G=this.getWorkspaceFolder(j,!0);if(!G)return ae;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let B=(0,C.relativePath)(G.uri,j);return U&&G.name&&(B=`${G.name}/${B}`),B}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:U,added:j,removed:ae}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:ae}))}findFiles(F,U,j,ae,G=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ae.value}, entryPoint: findFiles`);let B;if(U===null?B=!1:U&&(typeof U=="string"?B=U:B=U.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:L}=o(F);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)($),(0,I.withUndefinedAsNull)(L),(0,I.withUndefinedAsNull)(B),(0,I.withUndefinedAsNull)(j),G).then(Z=>Array.isArray(Z)?Z.map(V=>l.URI.revive(V)):[])}async findTextInFiles(F,U,j,ae,G=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ae.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),$=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:L,folder:Z}=o(U.include),V=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Y={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:$,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:L,excludePattern:V},me=!1;if(this._activeSearchCallbacks[B]=H=>{if(me)return;const oe=l.URI.revive(H.resource);H.results.forEach(de=>{(0,t.resultIsMatch)(de)?j({uri:oe,preview:{text:de.preview.text,matches:(0,g.mapArrayOrNot)(de.preview.matches,Ce=>new v.Range(Ce.startLineNumber,Ce.startColumn,Ce.endLineNumber,Ce.endColumn))},ranges:(0,g.mapArrayOrNot)(de.ranges,Ce=>new v.Range(Ce.startLineNumber,Ce.startColumn,Ce.endLineNumber,Ce.endColumn))}):j({uri:oe,text:de.text,lineNumber:de.lineNumber})})},G.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(F,(0,I.withUndefinedAsNull)(Z),Y,B,G);return delete this._activeSearchCallbacks[B],H||{}}catch(H){throw delete this._activeSearchCallbacks[B],H}}$handleTextSearchResult(F,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=ze([Ve(0,h.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,P.IExtHostFileSystemInfo),Ve(3,f.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function o(A){let F,U;return A&&(typeof A=="string"?F=A:(F=A.pattern,U=A.baseFolder||l.URI.file(A.base))),{includePattern:F,folder:U}}}),define(be[33],Ee([0,1,23,3,32,5,7,157,63,10,15,4,13,16,2]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(r,s){if(s){const i=s.split(".");let c=r;for(let m=0;c&&m<i.length;m++)c=c[i[m]];return c}}function b(r){return r instanceof u.URI}function w(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function h(r){if(b(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,i,c){this._proxy=s.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};v=ze([Ve(0,l.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,d.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,i,c,m){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=m,this._extHostWorkspace=i,this._configuration=y.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(s,i,c){const m=h(i)||{},p=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,m,c?.identifier);function D(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(o){return typeof f(p,o)!="undefined"},get:(o,A)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,m,c?.identifier);let F=f(p,o);if(typeof F=="undefined")F=A;else{let U;const j=(ae,G)=>{let B;const $=()=>{U=U||(0,g.deepClone)(p),B=B||f(U,G)};return(0,C.isObject)(ae)?new Proxy(ae,{get:(L,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return $(),()=>B;if(U)return B=B||f(U,G),B[Z];const V=L[Z];return typeof Z=="string"?j(V,`${G}.${Z}`):V},set:(L,Z,V)=>($(),B&&(B[Z]=V),!0),deleteProperty:(L,Z)=>($(),B&&delete B[Z],!0),defineProperty:(L,Z,V)=>($(),B&&Object.defineProperty(B,Z,V),!0)}):ae};F=j(F,o)}return F},update:(o,A,F,U)=>{o=s?`${s}.${o}`:o;const j=D(F);return A!==void 0?this._proxy.$updateConfigurationOption(j,o,A,m,U):this._proxy.$removeConfigurationOption(j,o,m,U)},inspect:o=>{o=s?`${s}.${o}`:o;const A=(0,g.deepClone)(this._configuration.inspect(o,m,this._extHostWorkspace.workspace));if(A)return{key:o,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof p=="object"&&(0,g.mixin)(T,p,!1),Object.freeze(T)}_toReadonlyValue(s){const i=c=>(0,C.isObject)(c)?new Proxy(c,{get:(m,p)=>i(m[p]),set:(m,p,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(m,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(m,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}_validateConfigurationAccess(s,i,c){const m=_.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=c?`[${c.value}] `:"";if(m===4){typeof i?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){i?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const c=new y.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,p)=>c.affectsConfiguration(m,h(p))})}_toMap(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[108],Ee([0,1,2,15,3,5,7,32,48,33,20,39,13,29,4,11,22,16,74,174,12]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ae){function G($){if($!=null)return $}ae.from=G;function B($){if($!=null)return $}ae.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(ae){function G($){if($!=null)return $}ae.from=G;function B($){if($!=null)return $}ae.to=B})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ae){function G($){if($!=null)return $}ae.from=G;function B($){if($!=null)return $}ae.to=B})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(ae){function G(L){if(L){const Z=L;return Z&&!!Z.process}else return!1}ae.is=G;function B(L){if(L==null)return;const Z={process:L.process,args:L.args};return L.options&&(Z.options=s.from(L.options)),Z}ae.from=B;function $(L){if(L!=null)return new k.ProcessExecution(L.process,L.args,L.options)}ae.to=$})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(ae){function G($){if($!=null)return $}ae.from=G;function B($){if($!=null)return $}ae.to=B})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(ae){function G(L){if(L){const Z=L;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}ae.is=G;function B(L){if(L==null)return;const Z={};return L.commandLine!==void 0?Z.commandLine=L.commandLine:(Z.command=L.command,Z.args=L.args),L.options&&(Z.options=c.from(L.options)),Z}ae.from=B;function $(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new k.ShellExecution(L.commandLine,L.options):new k.ShellExecution(L.command,L.args?L.args:[],L.options)}ae.to=$})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(ae){function G(L){if(L){let Z=L;return Z&&Z.customExecution==="customExecution"}else return!1}ae.is=G;function B(L){return{customExecution:"customExecution"}}ae.from=B;function $(L,Z){return Z.get(L)}ae.to=$})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(ae){function G(B,$){let L;return B.scope!==void 0&&typeof B.scope!="number"?L=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===k.TaskScope.Workspace&&$&&$.workspaceFile?L=$.workspaceFile:L=a.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:L}}ae.from=G})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(ae){function G(L,Z){if(L==null)return[];const V=[];for(let Y of L){const me=B(Y,Z);me&&V.push(me)}return V}ae.fromMany=G;function B(L,Z){if(L==null)return;let V;L.execution instanceof k.ProcessExecution?V=i.from(L.execution):L.execution instanceof k.ShellExecution?V=m.from(L.execution):L.execution&&L.execution instanceof k.CustomExecution&&(V=p.from(L.execution));const Y=t.from(L.definition);let me;if(L.scope?typeof L.scope=="number"?me=L.scope:me=L.scope.uri:me=k.TaskScope.Workspace,!Y||!me)return;const H=L.group?L.group.id:void 0;return{_id:L._id,definition:Y,name:L.name,source:{extensionId:Z.identifier.value,label:L.source,scope:me},execution:V,isBackground:L.isBackground,group:H,presentationOptions:r.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}ae.from=B;async function $(L,Z,V){if(L==null)return;let Y;i.is(L.execution)?Y=i.to(L.execution):m.is(L.execution)?Y=m.to(L.execution):p.is(L.execution)&&(Y=p.to(L._id,V));const me=t.to(L.definition);let H;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?H=L.source.scope:H=await Z.resolveWorkspaceFolder(g.URI.revive(L.source.scope)):H=k.TaskScope.Workspace),!me||!H)return;const oe=new k.Task(me,H,L.name,L.source.label,Y,L.problemMatchers);return L.isBackground!==void 0&&(oe.isBackground=L.isBackground),L.group!==void 0&&(oe.group=k.TaskGroup.from(L.group)),L.presentationOptions&&(oe.presentationOptions=r.to(L.presentationOptions)),L._id&&(oe._id=L._id),L.detail&&(oe.detail=L.detail),oe}ae.to=$})(T=e.TaskDTO||(e.TaskDTO={}));var o;(function(ae){function G($){return $}ae.from=G;function B($){if(!!$)return Object.assign(Object.create(null),$)}ae.to=B})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(G,B,$){this._id=B,this._task=$,v.set(this,void 0),it(this,v,G,"f")}get task(){return this._task}terminate(){Be(this,v,"f").terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}v=new WeakMap;var F;(function(ae){function G(B){return{id:B._id,task:void 0}}ae.from=G})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let U=class{constructor(G,B,$,L,Z,V,Y,me){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=G.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=L,this._configurationService=Z,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=me,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(G,B,$){if(!$)return new k.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:B,provider:$,extension:G}),this._proxy.$registerTaskProvider(L,B),new k.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(G,B){this._proxy.$registerTaskSystem(G,B)}fetchTasks(G){return this._proxy.$fetchTasks(o.from(G)).then(async B=>{const $=[];for(let L of B){const Z=await T.to(L,this._workspaceProvider,this._providedCustomExecutions2);Z&&$.push(Z)}return $})}get taskExecutions(){const G=[];return this._taskExecutions.forEach(B=>G.push(B)),G}terminateTask(G){if(!(G instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(G._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(G,B,$){const L=this._providedCustomExecutions2.get(G.id);if(L){if(this._activeCustomExecutions2.get(G.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(G.id,L),this._terminalService.attachPtyToTerminal(B,await L.callback($))}this._lastStartedTask=G.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(G)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(G){const B=await this.getTaskExecution(G);this._taskExecutionPromises.delete(G.id),this._taskExecutions.delete(G.id),this.customExecutionComplete(G),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(G){const B=await this.getTaskExecution(G.id);this._onDidTaskProcessStarted.fire({execution:B,processId:G.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(G){const B=await this.getTaskExecution(G.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:G.exitCode})}$provideTasks(G,B){const $=this._handlers.get(G);if(!$)return Promise.reject(new Error("no handler found"));const L=[],Z=(0,R.asPromise)(()=>$.provider.provideTasks(n.CancellationToken.None)).then(V=>this.provideTasksInternal(B,L,$,V));return new Promise(V=>{Z.then(Y=>{Promise.all(L).then(()=>{V(Y)})})})}async $resolveTask(G,B){const $=this._handlers.get(G);if(!$)return Promise.reject(new Error("no handler found"));if(B.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${$.type}].`);const L=await T.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const Z=await $.provider.resolveTask(L,n.CancellationToken.None);if(!Z)return;this.checkDeprecation(Z,$);const V=T.from(Z,$.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(V.execution)&&await this.addCustomExecution(V,Z,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(G,B,$){const L=await this._proxy.$createTaskId(G);!$&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,B.execution)}async getTaskExecution(G,B){if(typeof G=="string"){const Z=this._taskExecutionPromises.get(G);if(!Z)throw new Error("Unexpected: The specified task is missing an execution");return Z}let $=this._taskExecutionPromises.get(G.id);if($)return $;const L=new Promise(async(Z,V)=>{const Y=B||await T.to(G.task,this._workspaceProvider,this._providedCustomExecutions2);Y?Z(new A(this,G.id,Y)):V("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(G.id,L),L.then(Z=>(this._taskExecutions.set(G.id,Z),Z),Z=>Promise.reject(Z))}checkDeprecation(G,B){G._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(G){this._activeCustomExecutions2.get(G.id)&&this._activeCustomExecutions2.delete(G.id),this._notProvidedCustomExecutions.has(G.id)&&this._lastStartedTask!==G.id&&(this._providedCustomExecutions2.delete(G.id),this._notProvidedCustomExecutions.delete(G.id));let $=this._notProvidedCustomExecutions.values(),L=$.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=$.next()}};U=ze([Ve(0,l.IExtHostRpcService),Ve(1,d.IExtHostInitDataService),Ve(2,y.IExtHostWorkspace),Ve(3,_.IExtHostDocumentsAndEditors),Ve(4,C.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,w.ILogService),Ve(7,P.IExtHostApiDeprecationService)],U),e.ExtHostTaskBase=U;let j=class extends U{constructor(G,B,$,L,Z,V,Y,me){super(G,B,$,L,Z,V,Y,me);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(G,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const $=T.from(B,G);if($===void 0)throw new Error("Task is not valid");if(p.is($.execution))await this.addCustomExecution($,B,!1);else throw new h.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution($),B);return this._proxy.$executeTask($).catch(Z=>{throw new Error(Z)}),L}provideTasksInternal(G,B,$,L){const Z=[];if(L)for(let V of L){this.checkDeprecation(V,$),(!V.definition||!G[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=T.from(V,$.extension);Y&&p.is(Y.execution)?(Z.push(Y),B.push(this.addCustomExecution(Y,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:$.extension}}async resolveTaskInternal(G){if(p.is(G.execution))return G;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(G,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,B,$){}};j=ze([Ve(0,l.IExtHostRpcService),Ve(1,d.IExtHostInitDataService),Ve(2,y.IExtHostWorkspace),Ve(3,_.IExtHostDocumentsAndEditors),Ve(4,C.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,w.ILogService),Ve(7,P.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,u.createDecorator)("IExtHostTask")}),define(be[223],Ee([0,1,17,50,27,84,21,11,14,25,8,10,2,120,143,94,46,100,222,40]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(D,T,o,A){this.configurationService=D,this.workspaceContextService=T,this.editorGroupsService=o,this.pathService=A}text(D,T,o={}){D=this.getContentPattern(D,o);const A=this.configurationService.getValue(),F=T&&T.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep);return{...this.commonQuery(T?.map(b.toWorkspaceFolder),o),type:2,contentPattern:D,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:A.search.usePCRE2||F||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(D,T){const o=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const A={...D,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(D,T)&&(A.isCaseSensitive=!0),this.isMultiline(D)&&(A.isMultiline=!0),A}file(D,T={}){return{...this.commonQuery(D,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(D,T){return D?(D=Array.isArray(D)?D.map(i):i(D),T?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],T={}){const o=this.handleIncludeExclude(T.includePattern,T.expandPatterns),A=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),F=D.length>1,U=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,T,A)):D.map(G=>this.getFolderQueryForRoot(G,T,A,F))).filter(G=>!!G),j={_reason:T._reason,folderQueries:U,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:A.pattern,includePattern:o.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const B=g.coalesce(g.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(Z=>Z.resource)))).filter(L=>(0,a.pathIncludedInQuery)(j,L.fsPath)),$=this.commonQueryFromFileList(B);return{...j,...$}}const ae=T.extraFileResources&&T.extraFileResources.filter(G=>(0,a.pathIncludedInQuery)(j,G.fsPath));return j.extraFileResources=ae&&ae.length?ae:void 0,j}commonQueryFromFileList(D){const T=[],o=new k.ResourceMap,A={};let F=!1;return D.forEach(U=>{if(U.scheme===y.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(U)){const ae=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:_.dirname(U.fsPath)});let G=o.get(ae);G||(F=!0,G={folder:ae,includePattern:{}},T.push(G),o.set(ae,G));const B=_.relative(ae.fsPath,U.fsPath);(0,I.assertIsDefined)(G.includePattern)[B.replace(/\\/g,"/")]=!0}else U.fsPath&&(F=!0,A[U.fsPath]=!0)}),{folderQueries:T,includePattern:A,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,T){if(T.isSmartCase){if(D.isRegExp){if(n.containsUppercaseCharacter(D.pattern,!0))return!0}else if(n.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,d.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const T=$=>_.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),A=(Array.isArray(D)?D:r(D)).map($=>{const L=this.pathService.resolvedUserHome;return L?(0,E.untildify)($,L.scheme===y.Schemas.file?L.fsPath:L.path):$}),F=R.groupBy(A,$=>T($)?"searchPaths":"exprSegments"),U=(F.exprSegments||[]).map($=>n.rtrim($,"/")).map($=>n.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),s($))),j={},ae=this.expandSearchPathPatterns(F.searchPaths||[]);ae&&ae.length&&(j.searchPaths=ae);const G=g.flatten(U),B=t(...G);return B&&(j.pattern=B),j}getExcludesForFolder(D,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(D,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const T=g.flatten(D.map(A=>{let{pathPortion:F,globPortion:U}=v(A);U&&(U=c(U));const j=this.expandOneSearchPath(F);return g.flatten(j.map(ae=>this.resolveOneSearchPathPattern(ae,U)))})),o=new Map;return T.forEach(A=>{const F=A.searchPath.toString(),U=o.get(F);U?A.pattern&&(U.pattern=U.pattern||{},U.pattern[A.pattern]=!0):o.set(F,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(D){if(_.isAbsolute(D)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==y.Schemas.file?[{searchPath:T[0].uri.with({path:D})}]:[{searchPath:l.URI.file(_.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=i(D),D.startsWith("../")||D===".."){const A=_.posix.resolve(T.path,D);return[{searchPath:T.with({path:A})}]}const o=c(D);return[{searchPath:T,pattern:o}]}else{if(D==="./"||D===".\\")return[];{const T=D.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(F=>{const U=T.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return U?{match:U,folder:F}:null}).filter(I.isDefined);if(A.length)return A.map(F=>{const U=F.match[1];return{searchPath:F.folder.uri,pattern:U&&c(U)}});{const F=D.match(/\.[\/\\](.+)[\/\\]?/),U=F?F[1]:D,j=u.localize(0,null,U);throw new Error(j)}}}}resolveOneSearchPathPattern(D,T){const o=D.pattern&&T?`${D.pattern}/${T}`:D.pattern||T,A=[{searchPath:D.searchPath,pattern:o}];return o&&!o.endsWith("**")&&A.push({searchPath:D.searchPath,pattern:o+"/**"}),A}getFolderQueryForSearchPath(D,T,o){const A=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(D.searchPath),T,o,!1);return A?{...A,includePattern:D.pattern}:null}getFolderQueryForRoot(D,T,o,A){let F;const U=l.URI.isUri(D)?D:D.uri;if(o.searchPaths){const $=o.searchPaths.filter(L=>(0,C.isEqual)(L.searchPath,U))[0];if($&&!$.pattern)return null;$&&(F=$.pattern)}const j=this.configurationService.getValue({resource:U}),G={...this.getExcludesForFolder(j,T)||{},...F||{}},B=l.URI.isUri(D)?(0,C.basename)(D):D.name;return{folder:U,folderName:A?B:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!j.search.followSymlinks}}};h=ze([Ve(0,f.IConfigurationService),Ve(1,b.IWorkspaceContextService),Ve(2,w.IEditorGroupsService),Ve(3,P.IPathService)],h),e.QueryBuilder=h;function v(p){const D=p.match(/[\*\{\}\(\)\[\]\?]/);if(D){const T=D.index,o=p.substr(0,T).match(/[/|\\][^/\\]*$/);if(o){let A=p.substr(0,o.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:p.substr((o.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((D,T)=>(D[T]=!0,D),Object.create(null)):void 0}function r(p){return S.splitGlobAware(p,",").map(D=>D.trim()).filter(D=>!!D.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function i(p){return p.replace(/\\/g,"/")}function c(p){return i(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(p,D){p=g.distinct(p,A=>A.toString());const T=[],o=D.getWorkspace();return p&&p.forEach(A=>{let F;if(D.getWorkbenchState()===2)F=(0,C.relativePath)(o.folders[0].uri,A),F&&F!=="."&&(F="./"+F);else{const U=D.getWorkspaceFolder(A);if(U){const j=U.name;if(o.folders.filter(G=>G.name===j).length===1){const G=(0,C.relativePath)(U.uri,A);G===""?F=`./${U.name}`:F=`./${U.name}/${G}`}else F=A.fsPath}}F&&T.push(F)}),T}e.resolveResourcesForSearchIncludes=m}),define(be[224],Ee([0,1,25,2,20,12,4,223,40,46]),function(te,e,g,R,S,E,k,y,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(f,b){const w=b.activationEvents;if(!w)return Promise.resolve(void 0);const P=[],a=[];for(const i of w)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||f.forceUsingSearch?a.push(c):P.push(c)}if(P.length===0&&a.length===0)return Promise.resolve(void 0);let h;const v=new Promise((i,c)=>{h=i}),t=i=>h({activationEvent:i}),r=Promise.all(P.map(i=>l(f,i,t))).then(()=>{}),s=d(f,b.identifier,a,t);return Promise.all([r,s]).then(()=>{h(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function l(f,b,w){for(const P of f.folders)if(await f.exists(g.joinPath(R.URI.revive(P),b))){w(`workspaceContains:${b}`);return}}async function d(f,b,w,P){if(w.length===0)return Promise.resolve(void 0);const a=new S.CancellationTokenSource,h=f.checkExists(f.folders,w,a.token),v=setTimeout(async()=>{a.cancel(),P(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await h}catch(r){E.isPromiseCanceledError(r)||E.onUnexpectedError(r)}a.dispose(),clearTimeout(v),t&&P(`workspaceContains:${w.join(",")}`)}function u(f,b,w,P){const a=f.get(k.IInstantiationService),h=f.get(_.ISearchService),t=a.createInstance(y.QueryBuilder).file(b.map(r=>(0,C.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return h.fileSearch(t,P).then(r=>!!r.limitHit,r=>E.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u});var it=this&&this.__classPrivateFieldSet||function(te,e,g,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Be=this&&this.__classPrivateFieldGet||function(te,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(te):R?R.value:e.get(te)};define(be[34],Ee([0,1,134,14,79,25,15,6,21,2,16,5,33,187,77,32,30,185,12,26,24,162,7,95,4,29,78,13,62,68,39,3,224,73,164]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a,h,v,t,r,s,i,c,m,p,D,T,o,A,F,U){"use strict";var j,ae,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let B=class Wn extends y.Disposable{constructor(V,Y,me,H,oe,de,Ce,Ne,Me,$e){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=me,this._initData=Ce,this._extHostWorkspace=H,this._extHostConfiguration=oe,this._logService=de,this._extHostTunnelService=Me,this._extHostTerminalService=$e,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Ne,this._instaService=V.createChild(new p.ServiceCollection([u.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(qe=>Xe.add(a.ExtensionIdentifier.toKey(qe))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,je,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,P.transformErrorForSerialization(je),O)},actualActivateExtension:async(qe,je)=>{if(Xe.has(a.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,je),new d.HostExtension;const O=this._registry.getExtensionDescription(qe);return this._activateExtension(O,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){P.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this._deactivate(oe))}catch(Y){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Y){return this._activator.activateByEvent(V,Y)}_activateById(V,Y){return this._activator.activateById(V,Y)}activateByIdWithErrors(V,Y){return this._activateById(V,Y).then(()=>{const me=this._activator.getActivatedExtension(V);if(me.activationFailed)return Promise.reject(me.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const V=_.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(me=>{if(!!this._getEntryPoint(me))return this._hostUtils.realpath(me.extensionLocation.fsPath).then(H=>V.set(C.URI.file(H).fsPath,me))});this._extensionPathIndex=Promise.all(Y).then(()=>V)}return this._extensionPathIndex}_deactivate(V){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Y;const me=this._activator.getActivatedExtension(V);if(!me)return Y;try{typeof me.module.deactivate=="function"&&(Y=Promise.resolve(me.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,y.dispose)(me.subscriptions)}catch(H){this._logService.error(H)}return Y}async _activateExtension(V,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Y).then(me=>{const H=me.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,Y),this._logExtensionActivationTimes(V,Y,"success",H),me},me=>{throw this._logExtensionActivationTimes(V,Y,"failure"),me})}_logExtensionActivationTimes(V,Y,me,H){const oe=$(V,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...oe,...H||{},outcome:me})}_doActivateExtension(V,Y){const me=$(V,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",me);const H=this._getEntryPoint(V);if(!H)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const oe=new d.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,E.joinPath)(V.extensionLocation,H),oe),this._loadExtensionContext(V)]).then(de=>(S.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Wn._callActivate(this._logService,V.identifier,de[0],de[1],oe))).then(de=>(S.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),de))}_loadExtensionContext(V){const Y=new v.ExtensionGlobalMemento(V,this._storage),me=new v.ExtensionMemento(V.identifier.value,!1,this._storage),H=new U.ExtensionSecrets(V,this._secretState),oe=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Y.whenReady,me.whenReady,this._storagePath.whenReady]).then(()=>{const Ce=this;let Ne;return Object.freeze({globalState:Y,workspaceState:me,secrets:H,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Me){return R.join(V.extensionLocation.fsPath,Me)},get storagePath(){return Ce._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Ce._storagePath.globalValue(V).fsPath},get logPath(){return R.join(Ce._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return C.URI.joinPath(Ce._initData.logsLocation,V.identifier.value)},get storageUri(){return Ce._storagePath.workspaceValue(V)},get globalStorageUri(){return Ce._storagePath.globalValue(V)},get extensionMode(){return oe},get extension(){return Ne===void 0&&(Ne=new L(Ce,V.identifier,V,de)),Ne},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(V),Ce.extensionRuntime},get environmentVariableCollection(){return Ce._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,Y,me,H,oe){return me=me||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Y,me,H,oe).then(de=>new d.ActivatedExtension(!1,null,oe.build(),me,de,H.subscriptions))}static _callActivateOptional(V,Y,me,H,oe){if(typeof me.activate=="function")try{oe.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const de=typeof global=="object"?global:self,Ce=me.activate.apply(de,[H]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(Ce).then(Ne=>(oe.activateResolveStop(),Ne))}catch(de){return Promise.reject(de)}else return Promise.resolve(me)}_activateOneStartupFinished(V,Y){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Y}).then(void 0,me=>{this._logService.error(me)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Y of V.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(V,Y)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,oe=>{this._logService.error(oe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(oe=>this._handleWorkspaceContainsEagerExtensions(oe.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],me=this._handleWorkspaceContainsEagerExtensions(Y),H=Promise.all([V,me]).then(()=>{});return Promise.race([H,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(V,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Y){if(this.isActivated(Y.identifier))return;const me=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:V.map(de=>de.uri),forceUsingSearch:me,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,Ce,Ne)=>this._mainThreadWorkspaceProxy.$checkExists(de,Ce,Ne)},oe=await(0,A.checkActivateWorkspaceContainsExtension)(H,Y);if(!!oe)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:oe.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Y}=this._initData.environment;if(!V||!Y)throw new Error(g.localize(0,null));const me=await this._loadCommonJSModule(null,Y,new d.ExtensionActivationTimesBuilder(!1));if(!me||typeof me.run!="function")throw new Error(g.localize(1,null,Y.toString()));return new Promise((H,oe)=>{const de=(Me,$e)=>{Me?oe(Me):H(typeof $e=="number"&&$e>0?1:0)},Ce=(0,E.originalFSPath)(Y),Ne=me.run(Ce,de);Ne&&Ne.then&&Ne.then(()=>{H(0)}).catch(Me=>{oe(Me.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,Y){return this._resolvers[V]=Y,(0,y.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Y=V.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const me=V.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${me}`,!1),{authorityPrefix:me,resolver:this._resolvers[me]}}async $resolveAuthority(V,Y){const{authorityPrefix:me,resolver:H}=await this._activateAndGetResolver(V);if(!H)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${me}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),S.mark(`code/extHost/willResolveAuthority/${me}`);const oe=await H.resolve(V,{resolveAttempt:Y});S.mark(`code/extHost/didResolveAuthorityOK/${me}`);const de={authority:V,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Ce={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted};return{type:"ok",value:{authority:de,options:Ce,tunnelInformation:{environmentTunnels:oe.environmentTunnels}}}}catch(oe){if(S.mark(`code/extHost/didResolveAuthorityError/${me}`),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(V,Y){const{authorityPrefix:me,resolver:H}=await this._activateAndGetResolver(V);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${me}`);const oe=C.URI.revive(Y);if(typeof H.getCanonicalURI=="undefined")return oe;const de=await(0,k.asPromise)(()=>H.getCanonicalURI(oe));return de||oe}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Y){return Y===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(me=>this._activateByEvent(V,!1))}async $activate(V,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Y),!0):!1}async $deltaExtensions(V,Y){V.forEach(H=>H.extensionLocation=C.URI.revive(H.extensionLocation));const me=await this.getExtensionPathIndex();return await Promise.all(Y.map(async H=>{const oe=this._registry.getExtensionDescription(H);if(!oe)return;const de=await this._hostUtils.realpath(oe.extensionLocation.fsPath);me.delete(C.URI.file(de).fsPath)})),await Promise.all(V.map(async H=>{const oe=await this._hostUtils.realpath(H.extensionLocation.fsPath);me.set(C.URI.file(oe).fsPath,H)})),this._registry.deltaExtensions(V,Y),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Y=h.VSBuffer.alloc(V),me=Math.random()%256;for(let H=0;H<V;H++)Y.writeUInt8(me,H);return Y}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};B=ze([Ve(0,s.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,m.IExtHostRpcService),Ve(3,f.IExtHostWorkspace),Ve(4,l.IExtHostConfiguration),Ve(5,n.ILogService),Ve(6,i.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,D.IExtHostTunnelService),Ve(9,T.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function $(Z,V){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class L{constructor(V,Y,me,H){j.set(this,void 0),ae.set(this,void 0),G.set(this,void 0),it(this,j,V,"f"),it(this,ae,Y,"f"),it(this,G,me.identifier,"f"),this.id=me.identifier.value,this.extensionUri=me.extensionLocation,this.extensionPath=R.normalize((0,E.originalFSPath)(me.extensionLocation)),this.packageJSON=me,this.extensionKind=H}get isActive(){return Be(this,j,"f").isActivated(Be(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,j,"f").getExtensionExports(Be(this,G,"f"))}activate(){return Be(this,j,"f").activateByIdWithErrors(Be(this,G,"f"),{startup:!1,extensionId:Be(this,ae,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,j=new WeakMap,ae=new WeakMap,G=new WeakMap}),define(be[109],Ee([0,1,14,2,3,15,5,7,172,32,34,48,176,33,173,13,4,10,42,66]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let h=class{constructor(p,D,T,o,A,F){this._workspaceService=D,this._extensionService=T,this._editorsService=o,this._configurationService=A,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=p.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(j=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,D){const T=p;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let o=`debug:${encodeURIComponent(T.path||"")}`,A="?";return D&&(o+=`${A}session=${encodeURIComponent(D.id)}`,A="&"),o+=`${A}ref=${T.sourceReference}`,R.URI.parse(o)}else{if(T.path)return R.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const D=[];for(const T of p.getAllExtensionDescriptions())if(T.contributes){const o=T.contributes.debuggers;if(o&&o.length>0)for(const A of o)(0,u.isDebuggerMainContribution)(A)&&D.push(A.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(D=>p.push(D)),p}addBreakpoints(p){this.startBreakpoints();const D=p.filter(A=>{const F=A.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,A),!0)});this.fireBreakpointChanges(D,[],[]);const T=[],o=new Map;for(const A of D)if(A instanceof y.SourceBreakpoint){let F=o.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},o.set(A.location.uri.toString(),F),T.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof y.FunctionBreakpoint&&T.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(p){this.startBreakpoints();const D=p.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],D,[]);const T=D.filter(F=>F instanceof y.SourceBreakpoint).map(F=>F.id),o=D.filter(F=>F instanceof y.FunctionBreakpoint).map(F=>F.id),A=D.filter(F=>F instanceof y.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(T,o,A)}startDebugging(p,D,T){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,D,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,D,T){if(!D)return new y.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:o,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,T,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,o),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(p,D,T){if(!T)return new y.Disposable(()=>{});if(!this.definesDebugType(p,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:o,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,o),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(p,D){if(!D)return new y.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:T,factory:D}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==D)})}async $runInTerminal(p,D){return Promise.resolve(void 0)}async $substituteVariables(p,D){if(!this._variableResolver){const[A,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,F)}let T;const o=await this.getFolder(p);return o&&(T={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,D)}createDebugAdapter(p,D){if(p.type==="implementation")return new i(p.implementation)}createSignService(){}async $startDASession(p,D){const T=this,o=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const F=this.convertToDto(A),U=this.createDebugAdapter(F,o);if(!U)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const j=U;return this._debugAdapters.set(p,j),this.getDebugAdapterTrackers(o).then(ae=>(ae&&this._debugAdaptersTrackers.set(p,ae),j.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const B=G,$={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(B.arguments.value);$.body={signature:L},j.sendResponse($)}else throw new Error("no signer")}catch(L){$.success=!1,$.message=L.message,j.sendResponse($)}}else ae&&ae.onDidSendMessage&&ae.onDidSendMessage(G),G=(0,u.convertToVSCPaths)(G,!0),T._debugServiceProxy.$acceptDAMessage(p,G)}),j.onError(G=>{ae&&ae.onError&&ae.onError(G),this._debugServiceProxy.$acceptDAError(p,G.name,G.message,G.stack)}),j.onExit(G=>{ae&&ae.onExit&&ae.onExit((0,w.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,w.withNullAsUndefined)(G),void 0)}),ae&&ae.onWillStartSession&&ae.onWillStartSession(),j.startSession()))})}$sendDAMessage(p,D){D=(0,u.convertToDAPaths)(D,!1);const T=this._debugAdaptersTrackers.get(p);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(D);const o=this._debugAdapters.get(p);o&&o.sendMessage(D)}$stopDASession(p){const D=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),D&&D.onWillStopSession&&D.onWillStopSession();const T=this._debugAdapters.get(p);return this._debugAdapters.delete(p),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const D=[],T=[],o=[];if(p.added)for(const A of p.added){const F=A.id;if(F&&!this._breakpoints.has(F)){let U;if(A.type==="function")U=new y.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")U=new y.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const j=R.URI.revive(A.uri);U=new y.SourceBreakpoint(new y.Location(j,new y.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}U._id=F,this._breakpoints.set(F,U),D.push(U)}}if(p.removed)for(const A of p.removed){const F=this._breakpoints.get(A);F&&(this._breakpoints.delete(A),T.push(F))}if(p.changed){for(const A of p.changed)if(A.id){const F=this._breakpoints.get(A.id);if(F){if(F instanceof y.FunctionBreakpoint&&A.type==="function"){const U=F;U.enabled=A.enabled,U.condition=A.condition,U.hitCondition=A.hitCondition,U.logMessage=A.logMessage,U.functionName=A.functionName}else if(F instanceof y.SourceBreakpoint&&A.type==="source"){const U=F;U.enabled=A.enabled,U.condition=A.condition,U.hitCondition=A.hitCondition,U.logMessage=A.logMessage,U.location=new y.Location(R.URI.revive(A.uri),new y.Position(A.line,A.character))}o.push(F)}}}this.fireBreakpointChanges(D,T,o)}$provideDebugConfigurations(p,D,T){return(0,E.asPromise)(async()=>{const o=this.getConfigProviderByHandle(p);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(D);return o.provideDebugConfigurations(A,T)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(p,D,T,o){return(0,E.asPromise)(async()=>{const A=this.getConfigProviderByHandle(p);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(D);return A.resolveDebugConfiguration(F,T,o)})}$resolveDebugConfigurationWithSubstitutedVariables(p,D,T,o){return(0,E.asPromise)(async()=>{const A=this.getConfigProviderByHandle(p);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(D);return A.resolveDebugConfigurationWithSubstitutedVariables(F,T,o)})}async $provideDebugAdapter(p,D){const T=this.getAdapterDescriptorFactoryByHandle(p);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(D);return this.getAdapterDescriptor(T,o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(p){const D=await this.getSession(p);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(p){const D=await this.getSession(p);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,D){const T=await this.getSession(p);T&&T._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(p,D){const o={session:await this.getSession(p),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(p){if(p instanceof y.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof y.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const D=this._adapterFactories.filter(T=>T.type===p);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(p){const D=this._adapterFactories.filter(T=>T.handle===p);if(D.length>0)return D[0].factory}getConfigProviderByHandle(p){const D=this._configProviders.filter(T=>T.handle===p);if(D.length>0)return D[0].provider}definesDebugType(p,D){if(p.contributes){const T=p.contributes.debuggers;if(T&&T.length>0){for(const o of T)if(o.label&&o.type&&o.type===D)return!0}}return!1}getDebugAdapterTrackers(p){const T=p.configuration.type,o=this._trackerFactories.filter(A=>A.type===T||A.type==="*").map(A=>(0,E.asPromise)(()=>A.factory.createDebugAdapterTracker(p)).then(F=>F,F=>null));return Promise.race([Promise.all(o).then(A=>{const F=A.filter(U=>!!U);if(F.length>0)return new s(F)}),new Promise((A,F)=>{const U=setTimeout(()=>{clearTimeout(U),F(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(p,D){const T=D.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new y.DebugAdapterServer(T));if(p){const A=await this._extensionService.getExtensionRegistry();return(0,E.asPromise)(()=>p.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,A))).then(F=>{if(F)return F})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,o))}daExecutableFromPackage(p,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,D,T){(p.length>0||D.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:D,changed:T}))}async getSession(p){if(p)if(typeof p=="string"){const D=this._debugSessions.get(p);if(D)return D}else{let D=this._debugSessions.get(p.id);if(!D){const T=await this.getFolder(p.folderUri),o=p.parent?this._debugSessions.get(p.parent):void 0;D=new v(this._debugServiceProxy,p.id,p.type,p.name,T,p.configuration,o),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(p){if(p){const D=R.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};h=ze([Ve(0,f.IExtHostRpcService),Ve(1,C.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,I.IExtHostDocumentsAndEditors),Ve(4,d.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class v{constructor(p,D,T,o,A,F,U){this._debugServiceProxy=p,this._id=D,this._type=T,this._name=o,this._workspaceFolder=A,this._configuration=F,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,D)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=v;class t{constructor(p){this.value=Object.freeze({append(D){p.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(p,D,T,o,A){function F(){if(D){const U=D.activeEditor();if(U)return U.document.uri;const j=o.tabs.filter(ae=>ae.isActive);if(j.length>0)return j[0].resource}}super({getFolderUri:U=>{const j=p.filter(ae=>ae.name===U);if(j&&j.length>0)return j[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(U,j)=>T.getConfiguration(void 0,U).get(j),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=F();if(U)return g.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const U=F();if(U){const j=A.getWorkspaceFolder(U);if(j)return g.normalize(j.uri.fsPath)}}},getSelectedText:()=>{if(D){const U=D.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(D){const U=D.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class s{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(D=>D.onError?D.onError(p):void 0)}onExit(p,D){this.trackers.forEach(T=>T.onExit?T.onExit(p,D):void 0)}}class i extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends h{constructor(p,D,T,o,A,F){super(p,D,T,o,A,F)}createVariableResolver(p,D,T){return new r(p,D,T,this._editorTabs)}};c=ze([Ve(0,f.IExtHostRpcService),Ve(1,C.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,I.IExtHostDocumentsAndEditors),Ve(4,d.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(be[225],Ee([0,1,79,2,5,33,30,26,13,29,4,34,42,16]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(a,h,v,t,r,s,i){this._apiFactory=a,this._extensionRegistry=h,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,h,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,h,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let h of a.nodeModuleName)this._factories.set(h,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(h=>a.alternativeModuleName(h))}};u=ze([Ve(2,n.IInstantiationService),Ve(3,E.IExtHostConfiguration),Ve(4,I.IExtHostExtensionService),Ve(5,C.IExtHostInitDataService),Ve(6,d.ILogService)],u),e.RequireInterceptor=u;class f{constructor(a,h,v,t,r){this._apiFactory=a,this._extensionPaths=h,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,h){const v=this._extensionPaths.findSubstr(h.fsPath);if(v){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(a,h){this.nodeModuleName="keytar";const{environment:v}=h,t=a.getProxy(S.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(a,h){return this._impl}alternativeModuleName(a){const h=a.length;if(h<=7||!this.alternativeNames)return;const v=h-7;if((a.charAt(v)==="/"||a.charAt(v)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};b=ze([Ve(0,_.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],b);let w=class{constructor(a,h,v){this._extensionPaths=a,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(S.MainContext.MainThreadTelemetry);const t=v.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=R.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(a,h,v){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(a),this._impl}callOriginal(a,h){return this.sendNoForwardTelemetry(),this._original(a,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([Ve(2,_.IExtHostRpcService)],w)}),define(be[226],Ee([0,1,15,12,79,6,2,5,219,16,59,62,29,153,13,69,34,39]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(h,v,t,r){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(h,null,r),v=P._transform(v,this._rpcProtocol);const s=new I.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),s.set(f.IURITransformerService,new f.URITransformerService(r)),s.set(b.IHostUtils,t);const i=new d.InstantiationService(s,!0),c=i.invokeFunction(T=>T.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(T=>T.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(T=>T.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(o,A)=>{let F="",U,j;for(const ae of A)F+=`
	at ${ae.toString()}`,j=ae.getFileName(),!U&&j&&(U=T.findSubstr(j));return m.set(o,U),`${o.name||"Error"}: ${o.message||""}${F}`}});const p=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(T=>{const o=R.transformErrorForSerialization(T),A=m.get(T);A?p.$onExtensionRuntimeError(A.identifier,o):D.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,v){h.extensions.forEach(r=>r.extensionLocation=k.URI.revive(v.transformIncomingURIs(r.extensionLocation))),h.environment.appRoot=k.URI.revive(v.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(r=>k.URI.revive(v.transformIncomingURIs(r)))),h.environment.extensionTestsLocationURI=k.URI.revive(v.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=k.URI.revive(v.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=k.URI.revive(v.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=k.URI.revive(v.transformIncomingURIs(h.logsLocation)),h.logFile=k.URI.revive(v.transformIncomingURIs(h.logFile)),h.workspace=v.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=P}),define(be[227],Ee([0,1,14,20,58,27,25,55,40]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(l,d,u){this.config=l,this.provider=d,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&E.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&E.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const d=this.config.folderQueries||[];return new Promise((u,f)=>{const b=w=>{this.resultCount++,l(w)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const P=w.toString(),a=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,a)||this.matchFile(b,{base:w,basename:a})}),Promise.all(d.map(w=>this.searchInFolder(w,b))).then(w=>{u({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{f(new Error((0,S.toErrorMessage)(w)))})})}async searchInFolder(l,d){const u=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),w=new _.QueryGlobTester(this.config,l),P=!w.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(u),a=y.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,u.token),v=a.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(r=>{const s=g.posix.relative(l.folder.path,r.path);if(P){const i=g.basename(r.path);this.matchFile(d,{base:l.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(b,l.folder,s,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,w,d),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(l){const d=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),u=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:u,includes:d,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},d,u,f){if(u===this.filePattern){const w=g.basename(this.filePattern);this.matchFile(f,{base:d,relativePath:this.filePattern,basename:w})}function b(w){const P=g.basename(w),a=g.dirname(w);let h=l[a];h||(h=l[a]=[],b(a)),h.push({base:d,relativePath:w,basename:P})}b(u)}matchDirectoryTree({rootEntries:l,pathToEntries:d},u,f){const b=this,w=this.filePattern;function P(a){const h=E.hasSiblingFn(()=>a.map(v=>v.basename));for(let v=0,t=a.length;v<t;v++){const r=a[v],{relativePath:s,basename:i}=r;if(!u.includedInQuerySync(s,i,w!==i?h:void 0))continue;const c=d[s];if(c)P(c);else{if(s===w)continue;b.matchFile(f,r)}if(b.isLimitHit)break}}P(l)}matchFile(l,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(d))}}class n{constructor(){this.sessions=new Map}fileSearch(l,d,u,f){const b=this.getSessionTokenSource(l.cacheKey),w=new C(l,d,b&&b.token);let P=0;const a=h=>{P+=h.length,u(h.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,n.BATCH_SIZE,a,f).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:h.stats}}))}clearCache(l){const d=this.getSessionTokenSource(l);d&&d.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:k.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,d,u,f){f.onCancellationRequested(()=>{l.cancel()});const b=P=>{P&&(w.push(P),d>0&&w.length>=d&&(u(w),w=[]))};let w=[];return l.search(b).then(P=>(w.length&&u(w),P),P=>(w.length&&u(w),Promise.reject(P)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[228],Ee([0,1,14,17,20,58,25,27,2,40,11,10]),function(te,e,g,R,S,E,k,y,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,h,v){this.query=a,this.provider=h,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,h){const v=this.query.folderQueries||[],t=new S.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new u(a);let i=!1;const c=(m,p)=>{if(!i&&!this.isLimitHit){const D=this.resultSize(m);b(m)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const T=this.resultSize(m);this.resultCount+=T,(T>0||!b(m))&&this.collector.add(m,p)}};Promise.all(v.map((m,p)=>this.searchInFolder(m,D=>c(D,p),t.token))).then(m=>{t.dispose(),this.collector.flush();const p=m.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||p,messages:(0,R.flatten)(m.map(D=>D?.message?(0,I.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:"textSearchProvider"}})},m=>{t.dispose();const p=(0,E.toErrorMessage)(m);s(new Error(p))})})}resultSize(a){return b(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,h){const v=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:v.slice(0,h),preview:{matches:t.slice(0,h),text:a.preview.text},uri:a.uri}}async searchInFolder(a,h,v){const t=new C.QueryGlobTester(this.query,a),r=[],s={report:m=>{if(!this.validateProviderResult(m))return;const p=a.folder.scheme===n.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(m.uri))):void 0,D=k.relativePath(a.folder,m.uri);D&&r.push(t.includedInQuery(D,g.basename(D),p).then(T=>{T&&h(m)}))}},i=this.getSearchOptionsForFolder(a),c=await this.provider.provideTextSearchResults(d(this.query.contentPattern),i,s,v);return await Promise.all(r),c}validateProviderResult(a){if(b(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const h=(0,C.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),v=(0,C.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:_.URI.from(a.folder),excludes:v,includes:h,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function d(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class u{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,h=>this.sendItems(h))}add(a,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!k.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(f(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=u;function f(P){return b(P)?{preview:{matches:(0,R.mapArrayOrNot)(P.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:P.preview.text},ranges:(0,R.mapArrayOrNot)(P.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function b(P){return!!P.preview}e.extensionResultIsMatch=b;class w{constructor(a,h){this.maxBatchSize=a,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,h){!a||this.addItemToBatch(a,h)}addItems(a,h){!a||this.addItemsToBatch(a,h)}addItemToBatch(a,h){this.batch.push(a),this.batchSize+=h,this.onUpdate()}addItemsToBatch(a,h){this.batch=this.batch.concat(a),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(be[110],Ee([0,1,6,5,4,227,13,69,16,2,228]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let I=class{constructor(f,b,w){this.extHostRpc=f,this._uriTransformer=b,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,b){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const w=this._handlePool++;return this._textSearchProvider.set(w,b),this._proxy.$registerTextSearchProvider(w,this._transformScheme(f)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(f,b){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const w=this._handlePool++;return this._fileSearchProvider.set(w,b),this._proxy.$registerFileSearchProvider(w,this._transformScheme(f)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(f,b,w,P){const a=l(w),h=this._fileSearchProvider.get(f);if(h)return this._fileSearchManager.fileSearch(a,h,v=>{this._proxy.$handleFileMatch(f,b,v.map(t=>t.resource))},P);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,b,w,P){const a=this._textSearchProvider.get(f);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const h=l(w);return this.createTextSearchManager(h,a).search(t=>this._proxy.$handleTextMatch(f,b,t),P)}createTextSearchManager(f,b){return new n.TextSearchManager(f,b,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=ze([Ve(0,k.IExtHostRpcService),Ve(1,y.IURITransformerService),Ve(2,_.ILogService)],I),e.ExtHostSearch=I;function l(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(d),extraFileResources:u.extraFileResources&&u.extraFileResources.map(f=>C.URI.revive(f))}}e.reviveQuery=l;function d(u){return{...u,folder:C.URI.revive(u.folder)}}}),define(be[229],Ee([0,1,20,12,3,36,2,127,87,121,57,61,5,192,191,75,193,33,194,195,196,178,197,48,34,198,179,200,201,202,105,181,207,208,209,77,39,211,182,9,7,214,49,106,32,30,50,169,199,96,104,108,109,110,16,69,13,29,203,166,68,74,189,212,165,78,76,217,215,216,190,47,210,213,73,66,97,205,107,206,11,155,204,163,161]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a,h,v,t,r,s,i,c,m,p,D,T,o,A,F,U,j,ae,G,B,$,L,Z,V,Y,me,H,oe,de,Ce,Ne,Me,$e,Xe,qe,je,O,K,X,re,q,ie,ge,Re,We,ve,Ye,z,ee,ce,Ue,xe,et,Se,ye,Pe,se,le,he,pe,x,fe,we,Ie,Oe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Ke){const Je=Ke.get(X.IExtHostInitDataService),ut=Ke.get(et.IExtHostFileSystemInfo),mt=Ke.get(z.IExtHostConsumerFileSystem),bt=Ke.get(s.IExtHostExtensionService),ot=Ke.get(me.IExtHostWorkspace),at=Ke.get(le.IExtHostTelemetry),_e=Ke.get(w.IExtHostConfiguration),ke=Ke.get(O.IURITransformerService),Q=Ke.get(K.IExtHostRpcService),W=Ke.get(j.IExtHostStorage),Fe=Ke.get(Ye.IExtensionStoragePaths),Te=Ke.get(je.ILogService),tt=Ke.get(ie.IExtHostTunnelService),Ge=Ke.get(ge.IExtHostApiDeprecationService),ct=Ke.get(Y.IExtHostWindow),yt=Ke.get(Pe.IExtHostSecretState),kt=Ke.get(se.IExtHostEditorTabs);Q.set(l.ExtHostContext.ExtHostFileSystemInfo,ut),Q.set(l.ExtHostContext.ExtHostLogService,Te),Q.set(l.ExtHostContext.ExtHostWorkspace,ot),Q.set(l.ExtHostContext.ExtHostConfiguration,_e),Q.set(l.ExtHostContext.ExtHostExtensionService,bt),Q.set(l.ExtHostContext.ExtHostStorage,W),Q.set(l.ExtHostContext.ExtHostTunnelService,tt),Q.set(l.ExtHostContext.ExtHostWindow,ct),Q.set(l.ExtHostContext.ExtHostSecretState,yt),Q.set(l.ExtHostContext.ExtHostTelemetry,at),Q.set(l.ExtHostContext.ExtHostEditorTabs,kt);const Dt=Q.set(l.ExtHostContext.ExtHostDecorations,Ke.get(Me.IExtHostDecorations)),ft=Q.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(r.IExtHostDocumentsAndEditors)),dt=Q.set(l.ExtHostContext.ExtHostCommands,Ke.get(f.IExtHostCommands)),vt=Q.set(l.ExtHostContext.ExtHostTerminalService,Ke.get(ae.IExtHostTerminalService)),Et=Q.set(l.ExtHostContext.ExtHostDebugService,Ke.get(Xe.IExtHostDebugService)),Tt=Q.set(l.ExtHostContext.ExtHostSearch,Ke.get(qe.IExtHostSearch)),It=Q.set(l.ExtHostContext.ExtHostTask,Ke.get($e.IExtHostTask)),bn=Q.set(l.ExtHostContext.ExtHostOutputService,Ke.get(T.IExtHostOutputService)),Vt=Q.set(l.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(Q)),_t=Q.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Q,ft)),Yt=Q.set(l.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Q,ft,Te)),Jt=Q.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Te,_t,Q.getProxy(l.MainContext.MainThreadBulkEdits))),gt=Q.set(l.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Q,dt,ft,_t,Fe)),qt=Q.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Te,gt)),Wt=Q.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Te,Q,gt)),Xt=Q.set(l.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(Q,Je,gt,Te)),Zt=Q.set(l.ExtHostContext.ExtHostNotebookRenderers,new x.ExtHostNotebookRenderers(Q,gt)),Pt=Q.set(l.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(Q,ft)),dn=Q.set(l.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Q.getProxy(l.MainContext.MainThreadTreeViews),dt,Te)),en=Q.set(l.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Q.getProxy(l.MainContext.MainThreadEditorInsets),Pt,Je)),xt=Q.set(l.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(Q,Te)),ht=Q.set(l.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(Q,ke,_t,dt,xt,Te,Ge)),tn=Q.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Q,ht)),Mt=Q.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Q,Te,ft)),Nt=Q.set(l.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(Q,ot,dt)),jt=Q.set(l.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Q,dt,Te)),En=Q.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(Q,dt,_t)),hn=Q.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(Q.getProxy(l.MainContext.MainThreadProgress))),_n=Q.set(l.ExtHostContext.ExtHosLabelService,new Ce.ExtHostLabelService(Q)),fn=Q.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Q)),nn=Q.set(l.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Q)),rn=Q.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(Q,dt)),Ht=Q.set(l.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Q,{remote:Je.remote},ot,Te,Ge)),sn=Q.set(l.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(Q,Ht,ot)),yn=Q.set(l.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Q,_t,Fe,Ht,sn)),Sn=Q.set(l.ExtHostContext.ExtHostWebviewViews,new ee.ExtHostWebviewViews(Q,Ht)),zt=Q.set(l.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(Q,dt)),Gt=Q.set(l.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(Q));Q.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(Q,gt,ft));const Dn=(0,oe.values)(l.ExtHostContext);Q.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(Q,ft),on=new u.ExtHostClipboard(Q),an=new D.ExtHostMessageService(Q,Te),Bt=new a.ExtHostDialogs(Q),Ft=new U.ExtHostStatusBar(Q,dt.converter),Kt=new p.ExtHostLanguages(Q,_t);return d.ExtHostApiCommands.register(dt),function(Le,$t,mn){const pt=function(){let J=!Le.isUnderDevelopment;function ue(Ae){J||(Te.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")ue(st);else{const wt=st;typeof wt.scheme=="undefined"&&ue(st),!Le.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,H.throwProposedApiError)(Le)}return st}}(),kn={getSession(J,ue,Ae){return Ae?.forceRecreate&&(0,H.checkProposedApiEnabled)(Le),nn.getSession(Le,J,ue,Ae)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(J,ue,Ae,st){return nn.registerAuthenticationProvider(J,ue,Ae,st)}},In={registerCommand(J,ue,Ae){return dt.registerCommand(!0,J,ue,Ae)},registerTextEditorCommand(J,ue,Ae){return dt.registerCommand(!0,J,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Te.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Ct=>{ue.apply(Ae,[wt,Ct,...st])}).then(Ct=>{Ct||Te.warn("Edits from command "+J+" were not applied.")},Ct=>{Te.warn("An error occurred while running command "+J,Ct)})})},registerDiffInformationCommand:(J,ue,Ae)=>((0,H.checkProposedApiEnabled)(Le),dt.registerCommand(!0,J,async(...st)=>{const wt=ft.activeEditor(!0);if(!wt){Te.warn("Cannot execute "+J+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);ue.apply(Ae,[Ct,...st])})),executeCommand(J,...ue){return dt.executeCommand(J,...ue)},getCommands(J=!1){return dt.getCommands(J)}},gn={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){return Je.environment.appRoot?.fsPath??""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return on.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ue){return ct.openUri(J,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Je.environment.appUriScheme)return Vt.createAppUri(J);try{return await ct.asExternalUri(J,{allowTunneling:!!Je.remote.authority})}catch(ue){if((0,we.matchesScheme)(J,fe.Schemas.http)||(0,we.matchesScheme)(J,fe.Schemas.https))return J;throw ue}},get remoteName(){return(0,Ne.getRemoteName)(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Je.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Pn={createTestController(J,ue){return zt.createTestController(J,ue)},createTestObserver(){return(0,H.checkProposedApiEnabled)(Le),zt.createTestObserver()},runTests(J){return(0,H.checkProposedApiEnabled)(Le),zt.runTests(J)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Le),zt.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Le),zt.results}},ln={getExtension(J){const ue=$t.getExtensionDescription(J);if(ue)return new s.Extension(bt,Le.identifier,ue,pn)},get all(){return $t.getAllExtensionDescriptions().map(J=>new s.Extension(bt,Le.identifier,J,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(J){return xt.createDiagnosticCollection(Le.identifier,J)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:J=>xt.getDiagnostics(J),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(J,ue){return Kt.changeLanguage(J.uri,ue)},match(J,ue){return(0,n.score)($.LanguageSelector.from(J),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(J,ue,Ae){return ht.registerCodeActionProvider(Le,pt(J),ue,Ae)},registerCodeLensProvider(J,ue){return ht.registerCodeLensProvider(Le,pt(J),ue)},registerDefinitionProvider(J,ue){return ht.registerDefinitionProvider(Le,pt(J),ue)},registerDeclarationProvider(J,ue){return ht.registerDeclarationProvider(Le,pt(J),ue)},registerImplementationProvider(J,ue){return ht.registerImplementationProvider(Le,pt(J),ue)},registerTypeDefinitionProvider(J,ue){return ht.registerTypeDefinitionProvider(Le,pt(J),ue)},registerHoverProvider(J,ue){return ht.registerHoverProvider(Le,pt(J),ue,Le.identifier)},registerEvaluatableExpressionProvider(J,ue){return ht.registerEvaluatableExpressionProvider(Le,pt(J),ue,Le.identifier)},registerInlineValuesProvider(J,ue){return ht.registerInlineValuesProvider(Le,pt(J),ue,Le.identifier)},registerDocumentHighlightProvider(J,ue){return ht.registerDocumentHighlightProvider(Le,pt(J),ue)},registerLinkedEditingRangeProvider(J,ue){return ht.registerLinkedEditingRangeProvider(Le,pt(J),ue)},registerReferenceProvider(J,ue){return ht.registerReferenceProvider(Le,pt(J),ue)},registerRenameProvider(J,ue){return ht.registerRenameProvider(Le,pt(J),ue)},registerDocumentSymbolProvider(J,ue,Ae){return ht.registerDocumentSymbolProvider(Le,pt(J),ue,Ae)},registerWorkspaceSymbolProvider(J){return ht.registerWorkspaceSymbolProvider(Le,J)},registerDocumentFormattingEditProvider(J,ue){return ht.registerDocumentFormattingEditProvider(Le,pt(J),ue)},registerDocumentRangeFormattingEditProvider(J,ue){return ht.registerDocumentRangeFormattingEditProvider(Le,pt(J),ue)},registerOnTypeFormattingEditProvider(J,ue,Ae,...st){return ht.registerOnTypeFormattingEditProvider(Le,pt(J),ue,[Ae].concat(st))},registerDocumentSemanticTokensProvider(J,ue,Ae){return ht.registerDocumentSemanticTokensProvider(Le,pt(J),ue,Ae)},registerDocumentRangeSemanticTokensProvider(J,ue,Ae){return ht.registerDocumentRangeSemanticTokensProvider(Le,pt(J),ue,Ae)},registerSignatureHelpProvider(J,ue,Ae,...st){return typeof Ae=="object"?ht.registerSignatureHelpProvider(Le,pt(J),ue,Ae):ht.registerSignatureHelpProvider(Le,pt(J),ue,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(J,ue,...Ae){return ht.registerCompletionItemProvider(Le,pt(J),ue,Ae)},registerInlineCompletionItemProvider(J,ue){return(0,H.checkProposedApiEnabled)(Le),ht.registerInlineCompletionsProvider(Le,pt(J),ue)},registerDocumentLinkProvider(J,ue){return ht.registerDocumentLinkProvider(Le,pt(J),ue)},registerColorProvider(J,ue){return ht.registerColorProvider(Le,pt(J),ue)},registerFoldingRangeProvider(J,ue){return ht.registerFoldingRangeProvider(Le,pt(J),ue)},registerSelectionRangeProvider(J,ue){return ht.registerSelectionRangeProvider(Le,J,ue)},registerCallHierarchyProvider(J,ue){return ht.registerCallHierarchyProvider(Le,J,ue)},setLanguageConfiguration:(J,ue)=>ht.setLanguageConfiguration(Le,J,ue),getTokenInformationAtPosition(J,ue){return(0,H.checkProposedApiEnabled)(Le),Kt.tokenAtPosition(J,ue)},registerInlayHintsProvider(J,ue){return(0,H.checkProposedApiEnabled)(Le),ht.registerInlayHintsProvider(Le,J,ue)},registerTypeHierarchyProvider(J,ue){return(0,H.checkProposedApiEnabled)(Le),ht.registerTypeHierarchyProvider(Le,J,ue)},createLanguageStatusItem(J){return(0,H.checkProposedApiEnabled)(Le),Kt.createLanguageStatusItem(J)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(J,ue,Ae){const st=await(k.URI.isUri(J)?Promise.resolve(vn.openTextDocument(J)):Promise.resolve(J));return Pt.showTextDocument(st,ue,Ae)},createTextEditorDecorationType(J){return Pt.createTextEditorDecorationType(Le,J)},onDidChangeActiveTextEditor(J,ue,Ae){return Pt.onDidChangeActiveTextEditor(J,ue,Ae)},onDidChangeVisibleTextEditors(J,ue,Ae){return Pt.onDidChangeVisibleTextEditors(J,ue,Ae)},onDidChangeTextEditorSelection(J,ue,Ae){return Pt.onDidChangeTextEditorSelection(J,ue,Ae)},onDidChangeTextEditorOptions(J,ue,Ae){return Pt.onDidChangeTextEditorOptions(J,ue,Ae)},onDidChangeTextEditorVisibleRanges(J,ue,Ae){return Pt.onDidChangeTextEditorVisibleRanges(J,ue,Ae)},onDidChangeTextEditorViewColumn(J,ue,Ae){return Pt.onDidChangeTextEditorViewColumn(J,ue,Ae)},onDidCloseTerminal(J,ue,Ae){return vt.onDidCloseTerminal(J,ue,Ae)},onDidOpenTerminal(J,ue,Ae){return vt.onDidOpenTerminal(J,ue,Ae)},onDidChangeActiveTerminal(J,ue,Ae){return vt.onDidChangeActiveTerminal(J,ue,Ae)},onDidChangeTerminalDimensions(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),vt.onDidChangeTerminalDimensions(J,ue,Ae)},onDidWriteTerminalData(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),vt.onDidWriteTerminalData(J,ue,Ae)},get state(){return ct.state},onDidChangeWindowState(J,ue,Ae){return ct.onDidChangeWindowState(J,ue,Ae)},showInformationMessage(J,...ue){return an.showMessage(Le,E.default.Info,J,ue[0],ue.slice(1))},showWarningMessage(J,...ue){return an.showMessage(Le,E.default.Warning,J,ue[0],ue.slice(1))},showErrorMessage(J,...ue){return an.showMessage(Le,E.default.Error,J,ue[0],ue.slice(1))},showQuickPick(J,ue,Ae){return Nt.showQuickPick(J,!!Le.enableProposedApi,ue,Ae)},showWorkspaceFolderPick(J){return Nt.showWorkspaceFolderPick(J)},showInputBox(J,ue){return Nt.showInput(J,ue)},showOpenDialog(J){return Bt.showOpenDialog(J)},showSaveDialog(J){return Bt.showSaveDialog(J)},createStatusBarItem(J,ue,Ae){let st,wt,Ct;return typeof J=="string"?(st=J,wt=ue,Ct=Ae):(wt=J,Ct=ue),Ft.createStatusBarEntry(Le,st,wt,Ct)},setStatusBarMessage(J,ue){return Ft.setStatusBarMessage(J,ue)},withScmProgress(J){return Ge.report("window.withScmProgress",Le,"Use 'withProgress' instead."),hn.withProgress(Le,{location:L.ProgressLocation.SourceControl},(ue,Ae)=>J({report(st){}}))},withProgress(J,ue){return hn.withProgress(Le,J,ue)},createOutputChannel(J){return bn.createOutputChannel(J,Le)},createWebviewPanel(J,ue,Ae,st){return sn.createWebviewPanel(Le,J,ue,Ae,st)},createWebviewTextEditorInset(J,ue,Ae,st){return(0,H.checkProposedApiEnabled)(Le),en.createWebviewEditorInset(J,ue,Ae,st,Le)},createTerminal(J,ue,Ae){return typeof J=="object"?(J.color&&(0,H.checkProposedApiEnabled)(Le),"pty"in J?vt.createExtensionTerminal(J):vt.createTerminalFromOptions(J)):vt.createTerminal(J,ue,Ae)},registerTerminalLinkProvider(J){return vt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ue){return vt.registerProfileProvider(Le,J,ue)},registerTreeDataProvider(J,ue){return dn.registerTreeDataProvider(J,ue,Le)},createTreeView(J,ue){return dn.createTreeView(J,ue,Le)},registerWebviewPanelSerializer:(J,ue)=>sn.registerWebviewPanelSerializer(Le,J,ue),registerCustomEditorProvider:(J,ue,Ae={})=>yn.registerCustomEditorProvider(Le,J,ue,Ae),registerFileDecorationProvider(J){return Dt.registerFileDecorationProvider(J,Le.identifier)},registerUriHandler(J){return Vt.registerUriHandler(Le.identifier,J)},createQuickPick(){return Nt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Nt.createInputBox(Le.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(J,ue,Ae){return fn.onDidChangeActiveColorTheme(J,ue,Ae)},registerWebviewViewProvider(J,ue,Ae){return Sn.registerWebviewViewProvider(Le,J,ue,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Le),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),gt.onDidChangeActiveNotebookEditor(J,ue,Ae)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Le),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Le),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),Wt.onDidChangeNotebookEditorSelection(J,ue,Ae)},onDidChangeNotebookEditorVisibleRanges(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),Wt.onDidChangeNotebookEditorVisibleRanges(J,ue,Ae)},showNotebookDocument(J,ue){return(0,H.checkProposedApiEnabled)(Le),gt.showNotebookDocument(J,ue)},registerExternalUriOpener(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),Gt.registerExternalUriOpener(Le.identifier,J,ue,Ae)},get openEditors(){return(0,H.checkProposedApiEnabled)(Le),kt.tabs},get onDidChangeOpenEditors(){return(0,H.checkProposedApiEnabled)(Le),kt.onDidChangeTabs},getInlineCompletionItemController(J){return(0,H.checkProposedApiEnabled)(Le),m.InlineCompletionController.get(J)}},vn={get rootPath(){return Ge.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(J){throw R.readonly()},getWorkspaceFolder(J){return ot.getWorkspaceFolder(J)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(J){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(J){throw R.readonly()},updateWorkspaceFolders:(J,ue,...Ae)=>ot.updateWorkspaceFolders(Le,J,ue||0,...Ae),onDidChangeWorkspaceFolders:function(J,ue,Ae){return ot.onDidChangeWorkspace(J,ue,Ae)},asRelativePath:(J,ue)=>ot.getRelativePath(J,ue),findFiles:(J,ue,Ae,st)=>ot.findFiles($.GlobPattern.from(J),$.GlobPattern.from(ue),Ae,Le.identifier,st),findTextInFiles:(J,ue,Ae,st)=>{let wt,Ct;return typeof ue=="object"?(wt=ue,Ct=Ae):(wt={},Ct=ue,st=Ae),ot.findTextInFiles(J,wt||{},Ct,Le.identifier,st)},saveAll:J=>ot.saveAll(J),applyEdit(J){return Cn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ue,Ae,st)=>Mt.createFileSystemWatcher($.GlobPattern.from(J),ue,Ae,st),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw R.readonly()},openTextDocument(J){let ue;const Ae=J;if(typeof J=="string")ue=Promise.resolve(k.URI.file(J));else if(k.URI.isUri(J))ue=Promise.resolve(J);else if(!Ae||typeof Ae=="object")ue=_t.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(J,ue,Ae)=>_t.onDidAddDocument(J,ue,Ae),onDidCloseTextDocument:(J,ue,Ae)=>_t.onDidRemoveDocument(J,ue,Ae),onDidChangeTextDocument:(J,ue,Ae)=>_t.onDidChangeDocument(J,ue,Ae),onDidSaveTextDocument:(J,ue,Ae)=>_t.onDidSaveDocument(J,ue,Ae),onWillSaveTextDocument:(J,ue,Ae)=>Jt.getOnWillSaveTextDocumentEvent(Le)(J,ue,Ae),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ue){let Ae;if(k.URI.isUri(J))Ae=J,await gt.openNotebookDocument(J);else if(typeof J=="string")Ae=k.URI.revive(await gt.createNotebookDocument({viewType:J,content:ue}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ue,Ae,st){return gt.registerNotebookSerializer(Le,J,ue,Ae,Le.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,ue,Ae,st)=>((0,H.checkProposedApiEnabled)(Le),gt.registerNotebookContentProvider(Le,J,ue,Ae,Le.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,ue,Ae)=>mn.onDidChangeConfiguration(J,ue,Ae),getConfiguration(J,ue){return ue=arguments.length===1?void 0:ue,mn.getConfiguration(J,ue,Le)},registerTextDocumentContentProvider(J,ue){return Yt.registerTextDocumentContentProvider(J,ue)},registerTaskProvider:(J,ue)=>(Ge.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Le,J,ue)),registerFileSystemProvider(J,ue,Ae){return tn.registerFileSystemProvider(Le.identifier,J,ue,Ae,Le.enableProposedApi)},get fs(){return mt.value},registerFileSearchProvider:(J,ue)=>((0,H.checkProposedApiEnabled)(Le),Tt.registerFileSearchProvider(J,ue)),registerTextSearchProvider:(J,ue)=>((0,H.checkProposedApiEnabled)(Le),Tt.registerTextSearchProvider(J,ue)),registerRemoteAuthorityResolver:(J,ue)=>((0,H.checkProposedApiEnabled)(Le),bt.registerRemoteAuthorityResolver(J,ue)),registerResourceLabelFormatter:J=>((0,H.checkProposedApiEnabled)(Le),_n.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ue,Ae)=>Mt.onDidCreateFile(J,ue,Ae),onDidDeleteFiles:(J,ue,Ae)=>Mt.onDidDeleteFile(J,ue,Ae),onDidRenameFiles:(J,ue,Ae)=>Mt.onDidRenameFile(J,ue,Ae),onWillCreateFiles:(J,ue,Ae)=>Mt.getOnWillCreateFileEvent(Le)(J,ue,Ae),onWillDeleteFiles:(J,ue,Ae)=>Mt.getOnWillDeleteFileEvent(Le)(J,ue,Ae),onWillRenameFiles:(J,ue,Ae)=>Mt.getOnWillRenameFileEvent(Le)(J,ue,Ae),openTunnel:J=>((0,H.checkProposedApiEnabled)(Le),tt.openTunnel(Le,J).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,H.checkProposedApiEnabled)(Le),tt.getTunnels()},onDidChangeTunnels:(J,ue,Ae)=>((0,H.checkProposedApiEnabled)(Le),tt.onDidChangeTunnels(J,ue,Ae)),registerPortAttributesProvider:(J,ue)=>((0,H.checkProposedApiEnabled)(Le),tt.registerPortsAttributesProvider(J,ue)),registerTimelineProvider:(J,ue)=>((0,H.checkProposedApiEnabled)(Le),rn.registerTimelineProvider(J,ue,Le.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:J=>((0,H.checkProposedApiEnabled)(Le),ot.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ue,Ae)=>ot.onDidGrantWorkspaceTrust(J,ue,Ae)},Rn={get inputBox(){return Ge.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Le)},createSourceControl(J,ue,Ae){return jt.createSourceControl(Le,J,ue,Ae)}},Fn={createCommentController(J,ue){return En.createCommentController(Le,J,ue)}},Ln={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(J,ue,Ae){return Et.onDidStartDebugSession(J,ue,Ae)},onDidTerminateDebugSession(J,ue,Ae){return Et.onDidTerminateDebugSession(J,ue,Ae)},onDidChangeActiveDebugSession(J,ue,Ae){return Et.onDidChangeActiveDebugSession(J,ue,Ae)},onDidReceiveDebugSessionCustomEvent(J,ue,Ae){return Et.onDidReceiveDebugSessionCustomEvent(J,ue,Ae)},onDidChangeBreakpoints(J,ue,Ae){return Et.onDidChangeBreakpoints(J,ue,Ae)},registerDebugConfigurationProvider(J,ue,Ae){return Et.registerDebugConfigurationProvider(J,ue,Ae||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ue){return Et.registerDebugAdapterDescriptorFactory(Le,J,ue)},registerDebugAdapterTrackerFactory(J,ue){return Et.registerDebugAdapterTrackerFactory(J,ue)},startDebugging(J,ue,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?Et.startDebugging(J,ue,{parentSession:Ae}):Et.startDebugging(J,ue,Ae||{})},stopDebugging(J){return Et.stopDebugging(J)},addBreakpoints(J){return Et.addBreakpoints(J)},removeBreakpoints(J){return Et.removeBreakpoints(J)},asDebugSourceUri(J,ue){return Et.asDebugSourceUri(J,ue)}},Mn={registerTaskProvider:(J,ue)=>It.registerTaskProvider(Le,J,ue),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Le,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,ue,Ae)=>It.onDidStartTask(J,ue,Ae),onDidEndTask:(J,ue,Ae)=>It.onDidEndTask(J,ue,Ae),onDidStartTaskProcess:(J,ue,Ae)=>It.onDidStartTaskProcess(J,ue,Ae),onDidEndTaskProcess:(J,ue,Ae)=>It.onDidEndTaskProcess(J,ue,Ae)},Nn={createNotebookController(J,ue,Ae,st,wt){return Xt.createNotebookController(Le,J,ue,Ae,st,Le.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ue)=>gt.registerNotebookCellStatusBarItemProvider(Le,J,ue),get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Le),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,H.checkProposedApiEnabled)(Le),Wt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return Zt.createRendererMessaging(Le,J)},onDidChangeNotebookDocumentMetadata(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),qt.onDidChangeNotebookDocumentMetadata(J,ue,Ae)},onDidChangeNotebookCells(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),gt.onDidChangeNotebookCells(J,ue,Ae)},onDidChangeNotebookCellExecutionState(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),gt.onDidChangeNotebookCellExecutionState(J,ue,Ae)},onDidChangeCellOutputs(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),gt.onDidChangeCellOutputs(J,ue,Ae)},onDidChangeCellMetadata(J,ue,Ae){return(0,H.checkProposedApiEnabled)(Le),gt.onDidChangeCellMetadata(J,ue,Ae)},createConcatTextDocument(J,ue){return(0,H.checkProposedApiEnabled)(Le),new ve.ExtHostNotebookConcatDocument(gt,_t,J,ue)}};return{version:Je.version,authentication:kn,commands:In,comments:Fn,debug:Ln,env:gn,extensions:ln,languages:An,notebooks:Nn,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:C.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:l.UIKind,Uri:k.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(be[230],Ee([0,1,59,105,32,104,33,75,48,39,108,109,110,77,68,74,106,76,47,73,97,66]),function(te,e,g,R,S,E,k,y,_,C,n,I,l,d,u,f,b,w,P,a,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService),(0,g.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,g.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,g.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(E.IExtHostDecorations,E.ExtHostDecorations),(0,g.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,g.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,g.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,g.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,g.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,g.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,g.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,g.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(be[231],Ee([0,1,229,34,225,7,15,5,11]),function(te,e,g,R,S,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(u){const f=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...P)=>{P.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const a=P.slice(0,-1).join(","),h=P.pop().toString();return`(function anonymous(${a}) {
${h}
})`}});function b(...w){return f?self.eval(f.createScript("",...w)):new Function(...w)}u.create=b})(C||(C={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(f,b){for(let w of this._alternatives){let P=w(f);if(P){f=P;break}}if(this._factories.has(f))return this._factories.get(f).load(f,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);d(f,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,b,w){b=b.with({path:l(b.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const P=await fetch(_.FileAccess.asBrowserUri(b).toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),P.status!==200)throw new Error(P.statusText);const a=await P.text(),h=`${b.toString(!0)}#vscode-extension`,v=`${a}
//# sourceURL=${h}`;let t;try{t=C.create(I._ttpExtensionScripts?.createScript("module")??"module",I._ttpExtensionScripts?.createScript("exports")??"exports",I._ttpExtensionScripts?.createScript("require")??"require",I._ttpExtensionScripts?.createScript(v)??v)}catch(c){throw console.error(f?`Loading code for extension ${f.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${b.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const r={},s={exports:r},i=c=>{const m=this._fakeModules.getModule(c,b);if(m===void 0)throw new Error(`Cannot load module '${c}'`);return m};try{return w.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),t(s,r,i),s.exports!==r?s.exports:r}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(f){throw new Error("Not supported")}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+f;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function l(u,f){return u.endsWith(f)?u:u+f}function d(u,f){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(a,h){const v=console[a];console[a]=function(){u.$logExtensionHostMessage({type:"__$console",severity:h,arguments:P(arguments)}),f&&v.apply(console,arguments)}}const w=1e5;function P(a){const h=[],v=[];if(a.length)for(let t=0;t<a.length;t++){if(typeof a[t]=="undefined")a[t]="undefined";else if(a[t]instanceof Error){const r=a[t];r.stack?a[t]=r.stack:a[t]=r.toString()}v.push(a[t])}try{const t=JSON.stringify(v,function(r,s){if(s&&typeof s=="object"){if(h.indexOf(s)!==-1)return"[Circular]";h.push(s)}return s});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[232],Ee([0,1,59,16,34,78,231,218]),function(te,e,g,R,S,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(S.IExtHostExtensionService,k.ExtHostExtensionService),(0,g.registerSingleton)(R.ILogService,y.ExtHostLogService),(0,g.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(be[234],Ee([0,1,24,3,186,226,220,14,79,11,2,230,232]),function(te,e,g,R,S,E,k,y,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const I=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const P=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:h=>h}),a=self.Worker;Worker=function(h,v){/^file:/i.test(h.toString())&&(h=C.FileAccess.asBrowserUri(n.URI.parse(h.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${h}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||y.basename(h.toString());const r=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(r);return new a(P?P.createScriptURL(s):s,v)}}else self.Worker=class extends k.NestedWorker{constructor(P,a){super(l,P,{name:y.basename(P.toString()),...a})}};const d=new class{exit(P){I()}async exists(P){return!0}async realpath(P){return P}};class u{constructor(){const a=new MessageChannel,h=new R.Emitter;let v=!1;l(a.port2,[a.port2]),a.port1.onmessage=t=>{const{data:r}=t;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=g.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,S.isMessageOfType)(s,2)){v=!0,b("received terminate message from renderer");return}h.fire(s)},this.protocol={onMessage:h.event,send:t=>{if(!v){const r=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);a.port1.postMessage(r,[r])}}}}}function f(P){return new Promise(a=>{const h=P.onMessage(v=>{h.dispose();const t=JSON.parse(v.toString());P.send((0,S.createMessageOfType)(0)),a({protocol:P,initData:t})});P.send((0,S.createMessageOfType)(1))})}let b=P=>I();function w(){const P=new u;_.mark("code/extHost/willConnectToRenderer"),f(P.protocol).then(a=>{_.mark("code/extHost/didWaitForInitData");const h=new E.ExtensionHostMain(a.protocol,a.initData,d,null);b=v=>h.terminate(v)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/04485223ebc6a075f39966bf9b3e261359ac7818/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
